#include "stdafx.h"

#include <stdio.h>
#include <math.h>
#include "elem.h"

#include "resource.h"
#include "chgnmdlg.h"

GDrag TheDrag;
CElemCollect TheElemCollector;

////////////////////////////////////////////////////////////////////
//  CViecFC
//

IMPLEMENT_ELEM(CViecFC, CObject, 1)
IMPLEMENT_ELEM(CRelationPipe, CViecFC, 3)
IMPLEMENT_ELEM(CMathSymb, CViecFC, 7)
IMPLEMENT_ELEM(CMSUnknown, CMathSymb, 8)
IMPLEMENT_ELEM(CMSIndep, CMathSymb, 9)
IMPLEMENT_ELEM(CMSPhys, CMathSymb, 10)
IMPLEMENT_ELEM(CMSDep, CMSPhys, 11)
IMPLEMENT_ELEM(CMSIndex, CMathSymb, 12)
IMPLEMENT_ELEM(CMSNumber, CMathSymb, 13)
IMPLEMENT_ELEM(CMSReal, CMSNumber, 14)
IMPLEMENT_ELEM(CMSInt, CMSNumber, 15)
IMPLEMENT_ELEM(CMSConst, CMathSymb, 16)
IMPLEMENT_ELEM(CMSOperator, CMathSymb, 17)
IMPLEMENT_ELEM(CMSOPlus, CMSOperator, 18)
IMPLEMENT_ELEM(CMSOMinus, CMSOperator, 19)
IMPLEMENT_ELEM(CMSONeg, CMSOperator, 20)
IMPLEMENT_ELEM(CMSOMult, CMSOperator, 21)
IMPLEMENT_ELEM(CMSODiv, CMSOperator, 22)
IMPLEMENT_ELEM(CMSODiff, CMSOperator, 23)
IMPLEMENT_ELEM(CMSOEqual, CMSOperator, 24)

/////////////
IMPLEMENT_ELEM(CMSOAdrs, CMSOperator, 24)
IMPLEMENT_ELEM(CMSOPoint, CMSOperator, 24)
////////////

IMPLEMENT_ELEM(CSymbInst, CPElem, 25)

IMPLEMENT_ELEM(CGElem, CViecFC, 26)
IMPLEMENT_ELEM(CPElem, CGElem, 27)
IMPLEMENT_ELEM(CSElem, CPElem, 28)
IMPLEMENT_ELEM(CIElem, CPElem, 29)
IMPLEMENT_ELEM(COperatorFolder, CPElem, 30)
IMPLEMENT_ELEM(CMSInteger, CMSNumber, 33)
IMPLEMENT_ELEM(CMSMatrix, CMathSymb, 34)
IMPLEMENT_ELEM(CEquInst, CIElem, 35)
IMPLEMENT_ELEM(CMSOAbs, CMSOperator, 36)

//fujita 990614///
IMPLEMENT_ELEM(CMSArg, CMSIndex, 37)
IMPLEMENT_ELEM(CMSChar,CMathSymb,38)
IMPLEMENT_ELEM(CMSChar_One,CMathSymb,39)
///////////

IMPLEMENT_ELEM_FREE(CElemView, CViecFC)
IMPLEMENT_ELEM_FREE(CElmResSrv, CElemView)

IMPLEMENT_DYNCREATE(CGDoc, CDocument)
IMPLEMENT_DYNCREATE(CGMainDoc, CGDoc)
IMPLEMENT_DYNCREATE(CSuitCase, CObject)
IMPLEMENT_DYNCREATE(CJobDoer, CObject)

int CViecFC::m_id = 0;

PETCHAR CViecFC::GetName()
{
	if(m_petName==NULL) return NULL;
	return *m_petName;
}

PETCHAR CViecFC::GetFont()
{
	if(m_petFont==NULL) return NULL;
	return *m_petFont;
}

CViecFC::CViecFC(CViecFC *parent)
{
	CRuntimeClass *prtc = GetRuntimeClass();
	m_bDragAllow = m_bDrag = 
	m_bFocus = FALSE;
//	m_bSelected = m_bFocus = FALSE;
	m_extent = CRect(0,0,0,0);
	m_org = CPoint(0,0);
	m_parent = parent;
	m_focus = NULL;
	m_bEncap = FALSE;

	TCHAR buf[30];
	sprintf(buf, "Sym%d", m_id++);
	m_petName = GetNewTChar((const char *)buf, NULL);
	m_petFont = GetNewTChar("Times New Roman", NULL);
	m_nDot = 18;
	m_nCharSet = DEFAULT_CHARSET;
	m_nItalic = FALSE;
	m_bFindFirst = FALSE;
}

CViecFC::~CViecFC()
{
	CViecFC *pel;
	while(m_child.GetCount()) {
		pel = (CViecFC *) m_child.RemoveTail();
		delete pel;
	}
	POSITION pos;
	CString key;
	CObject *pObj;
	//--- remove from the table
	pos = s_MathSymbMapTable.GetStartPosition();
	while(pos) {
		s_MathSymbMapTable.GetNextAssoc(pos, key, pObj);
		if(pObj==this)
			s_MathSymbMapTable.RemoveKey(key);
	}
}

size_t CViecFC::GetNameLen()
{
	if(m_petName==NULL) return 0;
	return m_petName->GetLength();
}

size_t CViecFC::GetFontLen()
{
	if(m_petFont==NULL) return 0;
	return m_petFont->GetLength();
}

void CViecFC::Serialize(CArchive& ar)
{
	CString head = CString(GetRuntimeClass()->m_lpszClassName);
	if (ar.IsStoring()) ar << head;
	SerializeBody(ar);
	SerialChild(ar);
}

void CViecFC::SerializeBody(CArchive& ar)
{
	WORD nLen;
	BYTE b;
	CString str;
	if(ar.IsStoring()) {
		ar << m_org;
		ar << m_extent;
		ar << (BYTE) m_bDragAllow;

		nLen = GetNameLen();
		ar << nLen;
		if(nLen>0)
			ar.Write(GetName(), nLen);

		nLen = GetFontLen();
		ar << nLen;
		if(nLen>0)
			ar.Write(GetFont(), nLen);

		ar << (BYTE) m_nDot;
		ar << (BYTE) m_nCharSet;
	} else {
		ar >> m_org;
		ar >> m_extent;
		ar >> b; m_bDragAllow = b;

		m_petName = NULL;
		ar >> nLen;
		if(nLen>0) {
			ar.Read(str.GetBufferSetLength(nLen), nLen);
			m_petName = GetNewTChar(str, m_petName);
		}

		m_petFont = NULL;
		ar >> nLen;
		if(nLen>0) {
			ar.Read(str.GetBufferSetLength(nLen), nLen);
			m_petFont = GetNewTChar(str, m_petFont);
		}

		ar >> b; m_nDot = b;
		ar >> b; m_nCharSet = b;
	}
}

/*
int CViecFC::OnSelect(CPoint &p)
{
	CRect r = m_extent;
	r.OffsetRect(p);
	if(r.PtInRect(p)) {
		m_bSelected = TRUE;
		return TRUE;
	} else {
		return FALSE;
	}
}
*/

int CViecFC::OnCommand(UINT id)
{
	switch(id) {
	case CMD_ADD_DELETE:
		{
			CViecFC *pelm;
			pelm = GetAncestor();
			GetParent()->OnDelete(this);
			//Ondelete()RgAEgBȂȂ琔XeAOƂɃ|C^[Zq
			//AhXZqȂǂꏏɏĂ܂B̃RgAEgɂDeleteɂǂê
			//słB
			//pelm->OnDelete(this);
			delete this;
		}
		return TRUE;
	case CMD_CHANG_NAME:
		{
			static LOGFONT logFont;
			CDC *pdc = GetDC();
			SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
			CFont *pfont = (CFont*) pdc->SelectStockObject(SYSTEM_FONT);
			pfont->GetObject(sizeof(LOGFONT), &logFont);
			ReleaseDC(pdc);
			CChgNmDlg dlg(&logFont);
			dlg.m_text = GetName();
			if(dlg.DoModal()==IDOK) {
				InvalidateRect(CPoint(0,0));
				m_petName = GetNewTChar(dlg.m_text, m_petName);
				m_petFont = GetNewTChar(logFont.lfFaceName, m_petFont);
				m_nDot = logFont.lfHeight<0 ?(BYTE) (-logFont.lfHeight): (BYTE) logFont.lfHeight;
				m_nCharSet = logFont.lfCharSet;
				CalcExt(dirUp);
				GetAncestor()->SendMsg(MSG_CHANG_NAME, this);
			}
			return 1;
		}
	}
	CSuitCase SC;
	SC.m_case = this;
	SC.m_int = id;
	if(SendMsg(MSG_COMMAND_FOR_CHILD, &SC))
		return SC.m_int;
	return FALSE;
}

int CViecFC::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu();
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str);
	pMenu->AppendMenu(MF_SEPARATOR);
	pMenu->AppendMenu(MF_STRING, CMD_CHANG_NAME, "&Change Name");
	pMenu->AppendMenu(MF_STRING, CMD_RECAL_SIZE, "&Recalc Size");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 0;
}

int CViecFC::OnRun()
{
	return 0;
}

int CViecFC::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CViecFC *pP;
	CViecFC *pE;
	POSITION pos;
	CPoint pp;
	CSuitCase SC;

	switch(nChar) {
	case VK_LEFT:
		pP = (CViecFC *) GetParent();
		if(!pP->IsKindOf(RUNTIME_CLASS(CViecFC))) return FALSE;
		pos = pP->m_child.Find(this);
		if(!pos) return FALSE;
		if(pP->m_child.GetPrev(pos)!=this || !pos) return FALSE;
		pE = (CViecFC*) pP->m_child.GetPrev(pos);
		switch(MyGetKeyState()) {
		case SS_NOTHING:
			SetFocus(FALSE);
			InvalidateRect(CPoint(0,0));
			pE->SetFocus(TRUE);
			pE->InvalidateRect(CPoint(0,0));
			((CViecFC *) GetParent())->SetFocusChild(pE);
			return TRUE;
		case SS_SHIFT:
			SC.m_case = this;
			SC.m_case2 = pE;
			GetParent()->SendMsg(MSG_SUBSTITUTE_THE_TWO, &SC);
			return TRUE;
		}
		break;
	case VK_RIGHT:
		pP = (CViecFC *) GetParent();
		if(!pP->IsKindOf(RUNTIME_CLASS(CViecFC))) return FALSE;
		pos = pP->m_child.Find(this);
		if(!pos) return FALSE;
		if(pP->m_child.GetNext(pos)!=this || !pos) return FALSE;
		pE = (CViecFC*) pP->m_child.GetNext(pos);
		switch(MyGetKeyState()) {
		case SS_NOTHING:
			SetFocus(FALSE);
			InvalidateRect(CPoint(0,0));
			pE->SetFocus(TRUE);
			pE->InvalidateRect(CPoint(0,0));
			((CViecFC *) GetParent())->SetFocusChild(pE);
			return TRUE;
		case SS_SHIFT:
			SC.m_case = this;
			SC.m_case2 = pE;
			GetParent()->SendMsg(MSG_SUBSTITUTE_THE_TWO, &SC);
			return TRUE;
		}
		break;
//		while((pP=(CViecFC *) pE->GetParent())) {
//			pP->SetFocus(TRUE);
//			pP->SetFocusChild(pE);
//			pE = pP;
//		}
		return TRUE;
	case VK_ESCAPE:
		pP = (CViecFC *) GetParent();
		if(!pP || !pP->IsKindOf(RUNTIME_CLASS(CViecFC))) return FALSE;
		if(pP->IsKindOf(RUNTIME_CLASS(CElemView))) return FALSE;
		pp = pP->GetOrg();
		SetFocus(FALSE);
		pP->SetFocusChild(NULL);
		pP->InvalidateRect(CPoint(0,0));
		return TRUE;
	case VK_RETURN:
		if(GetCount()==0) return FALSE;
		pE = (CViecFC*) m_child.GetHead();
		pE->SetFocus(TRUE);
		SetFocusChild(pE);
		InvalidateRect(CPoint(0,0));
		return TRUE;
	}
	return 0;
}

int CViecFC::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	return 0;
}

int CViecFC::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	switch(nChar) {
	case '?':
		OnAccess(NULL);
		return TRUE;
	}
	return FALSE;
}

int CViecFC::SetExtent(const CRect& pr)
{
	m_extent = pr;
	return 1;
}

int CViecFC::SetOrg(const CPoint& pp)
{
	m_org = pp;
	return 1;
}

const CRect& CViecFC::GetExtent()
{
	return m_extent;
}

const CPoint& CViecFC::GetOrg()
{
	return m_org;
}

CRect CViecFC::GetRect()
{
	CRect r(m_extent);
	r.OffsetRect(m_org);
	return r;
}

void CViecFC::DrawArrow(CDC *pdc, const CPoint& p1, const CPoint& p2)
{
	double ang;
	CPoint a1,a2;
	ang = atan2((double) (p2.y-p1.y), (double) (p2.x-p1.x));
	a1.x = (int) (10*cos(ang+0.3));
	a1.y = (int) (10*sin(ang+0.3));
	a2.x = (int) (10*cos(ang-0.3));
	a2.y = (int) (10*sin(ang-0.3));
	pdc->MoveTo(p1);
	pdc->LineTo(p2);
	pdc->MoveTo(p2);
	pdc->LineTo(p2.x-a1.x, p2.y-a1.y);
	pdc->MoveTo(p2);
	pdc->LineTo(p2.x-a2.x, p2.y-a2.y);
}

void CViecFC::OnDrawBody(CDC *pdc, const CPoint& p)
{
	CRect r0 = m_extent;
	r0.OffsetRect(p);
	r0.OffsetRect(m_org);
	pdc->Rectangle(&r0);
}

void CViecFC::OnDrawFocus(CDC *pdc, const CPoint& p)
{
	CRect r0 = m_extent;
	r0.OffsetRect(p);	
	r0.OffsetRect(m_org);
	pdc->MoveTo(r0.left,r0.top);
	pdc->LineTo(r0.right, r0.bottom);
	pdc->MoveTo(r0.left, r0.bottom);
	pdc->LineTo(r0.right, r0.top);
}

void CViecFC::OnDrawDrag(CDC *pdc, const CPoint& p)
{
	CRect r0 = m_extent;
	r0.OffsetRect(p);
	r0.OffsetRect(m_org);
	r0.OffsetRect(TheDrag.LastOffset());
	pdc->MoveTo(r0.left+1, r0.top+1);
	pdc->LineTo(r0.right-1, r0.top+1);
	pdc->LineTo(r0.right-1, r0.bottom-1);
	pdc->LineTo(r0.left+1, r0.bottom-1);
	pdc->LineTo(r0.left+1, r0.top+1);
}

int CViecFC::Release()
{
	m_bDrag = FALSE;
	return 1;
}

CSize CViecFC::GetSize()
{ 
	return CSize(m_extent.right - m_extent.left
	            ,m_extent.bottom - m_extent.top);
}

int CViecFC::OnDrop(const CPoint& p)
{
	if(m_bDrag) {
		CPoint p0(0,0);
		InvalidateRect(p0);
		InvalidateRect(p);
		m_org.Offset(p);
		if(m_parent) m_parent->CalcExt();
		m_bDrag = FALSE;
		return 1;
	} else {
		int rt=0;
		if(!m_bEncap) {
			POSITION pos = GetHeadPosition();
			while(pos) {
				CViecFC* pelem = GetNext(pos);
				rt=pelem->OnDrop(p);
			}
		}
		return rt;
	}
}


void CViecFC::SetDragAllow(BOOL drag)
{
	m_bDragAllow = drag;
}

BOOL CViecFC::GetDragAllow()
{
	return m_bDragAllow;
}

CViecFC* CViecFC::GetParent()
{
	return m_parent;
}

CViecFC* CViecFC::GetView()
{
	if(!m_parent) return this;
	CViecFC* parent, *prt = m_parent;
	while(prt) {
		parent = prt;
		if(parent->IsKindOf(RUNTIME_CLASS(CElemView)) ) break;
		prt = prt->GetParent();
	}
	return parent;
}

CViecFC* CViecFC::GetAncestor()
{
	if(!GetParent()) return this;
	CPElem *ep = (CPElem*) this;
	if(IsKindOf(RUNTIME_CLASS(CPElem)) && ep->GetInstBody())
		return ep->GetInstBody()->GetAncestor();
	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
		return this;
	return GetParent()->GetAncestor();
}

void CViecFC::GetRectG(CRect& rect)
{
	rect = m_extent;
	rect.OffsetRect(m_org);
	CViecFC *parent = m_parent;
	while(parent) {
		rect.OffsetRect(parent->GetOrg());
		parent = parent->GetParent();
	}
}

void CViecFC::InvalidateRect(const CPoint& point)
{
	CRect rect;
	GetRectG(rect);
	rect.OffsetRect(point);
	CViecFC* panc;
	if( (panc = GetView())==NULL ) return;
	CElemView *pobj = (CElemView*) panc;
	pobj->LogicToCleint(rect);
	if(pobj->m_pView)
		pobj->m_pView->InvalidateRect(&rect);
}

void CViecFC::InvalidateRectBd(const CPoint& point, const CRect& rb, int wd)
{
	CRect rect;
	GetRectG(rect);
	rect.OffsetRect(point);
	CViecFC* panc;
	if( (panc = GetView())==NULL ) return;
	CElemView *pobj = (CElemView*) panc;
	pobj->LogicToCleint(rect);

	//---- top
	CRect r;
	r.left = rect.left + rb.left - wd;
	r.top = rect.top + rb.top - wd;
	r.right = rect.right + rb.right + wd;
	r.bottom = rect.top + rb.top + wd;
	pobj->m_pView->InvalidateRect(&r);

	//----- bottom
	r.left = rect.left + rb.left - wd;
	r.top = rect.bottom + rb.bottom-wd;
	r.right = rect.right + rb.right + wd;
	r.bottom = rect.bottom + rb.bottom+wd;
	pobj->m_pView->InvalidateRect(&r);

	//----- left
	r.left = rect.left + rb.left - wd;
	r.top = rect.top + rb.top - wd;
	r.right = rect.left + rb.left + wd;
	r.bottom = rect.bottom + rb.bottom + wd;
	pobj->m_pView->InvalidateRect(&r);

	//------ right
	r.left = rect.right + rb.right - wd;
	r.top = rect.top + rb.top - wd;
	r.right = rect.right + rb.right+wd;
	r.bottom = rect.bottom + rb.bottom + wd;
	pobj->m_pView->InvalidateRect(&r);
}

void CViecFC::SetParent(CViecFC *p)
{
	m_parent = p;
}

CViecFC* CElemCollect::GetNewUnknownElem(CArchive& ar, const char * hd)
{
	CViecFC *pelm;
	CRuntimeClass *rtc;
	CString rKey;
	void *pvd;
	CObject *pNewObj;

	CMapStringToPtr &map = TheElemCollector.m_member;
	if(map.Lookup(hd, pvd)) {
		rtc = (CRuntimeClass *) pvd;
		pNewObj = rtc->CreateObject();
		pelm = (CViecFC*) pNewObj;
		return pelm;
	}
	return NULL;
}	

CViecFC* CViecFC::GetUnknownElem(CArchive& ar, const char *head)
{
	CViecFC *pelm;
	pelm = TheElemCollector.GetNewUnknownElem(ar, head);
	if(pelm) pelm->Serialize(ar);
	return pelm;
}

int CViecFC::SetFont(CDC *pdc, int dot, PETCHAR name, BYTE nCharSet, BYTE nItalic, int wd)
{
//	CElemView *pobj = (CElemView *)GetView();
	return CElmResSrv::s_pElmResSrv->SetFont(pdc, dot, name, nCharSet, nItalic, wd);
}

CRect CViecFC::GetTextExtent(CDC *pdc, const char *pch, size_t nSize)
{
	CRect ext;
	CSize sz = pdc->GetTextExtent(pch, nSize);
	ext.left = 0;
	ext.right = sz.cx;
	ext.top = - sz.cy / 2;
	ext.bottom = sz.cy + ext.top;
	return ext;
}

void CViecFC::UnionExtent(CRect& dest, CRect& src)
{
	if(dest.left>src.left) dest.left = src.left;
	if(dest.top>src.top) dest.top = src.top;
	if(dest.right<src.right) dest.right = src.right;
	if(dest.bottom<src.bottom) dest.bottom = src.bottom;
}	

void CViecFC::TextOut(CDC *pdc, int x, int y, const char *pch, size_t len)
{
	CRect nm = GetTextExtent(pdc, pch, len);
	pdc->TextOut(x, y+nm.top, pch, len);
}

void CViecFC::CalcExtPost(dirMode dir, const CRect& extent)
{	
	if(dir==dirUp && m_parent) m_parent->CalcExt(dir);
	if(extent!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = extent;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
}


void CViecFC::SelectStockObject(CDC *pdc, int nIdx)
{
	pdc->SelectStockObject(nIdx);
}

void CViecFC::SetTextColor(CDC *pdc, DWORD col)
{
	pdc->SetTextColor(col);
}

void CViecFC::EtchingRect(CRect& rct, CRect& eth)
{
	rct.left += eth.left;
	rct.top += eth.top;
	rct.right += eth.right;
	rct.bottom += eth.bottom;
}

CViecFC *CViecFC::GetBaseElem(CRuntimeClass *pRtc)
{
	CViecFC *pE = this;
	while(pE && !pE->IsKindOf(pRtc)) {
		if(pE->GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
			if(pE->IsKindOf(RUNTIME_CLASS(CPElem)))
				if(((CPElem*) pE)->GetInstBody())
					pE = ((CPElem*) pE)->GetInstBody();
				else
					pE = NULL;
			else
				pE = NULL;
		else
			pE = pE->GetParent();
	}
	return pE;
}

CViecFC *CViecFC::GetChildElem(CRuntimeClass *pRtc)
{
	CViecFC *pE;
	CSuitCase SC;
	CViecFCList obLst;

	SC.m_runtimeClass = pRtc;
	SC.m_oblist = &obLst;
	SendMsg(MSG_COLLECT_OBJECT, &SC);
	if(obLst.GetCount()==0) return NULL;
	pE = (CViecFC *) obLst.GetHead();
	if(!pE || !pE->IsKindOf(pRtc)) return NULL;
	return pE;
}

CSymbInst *CSymbInst::GetBaseSymbInst(CRuntimeClass *pRtc)
{
	CViecFC *pE = this;
	CSymbInst *pInst;
	while(pE) {
		pInst = (CSymbInst *) pE;
		if(!pInst->IsKindOf(RUNTIME_CLASS(CSymbInst))) return NULL;
		if(pInst->GetSymbBody()->IsKindOf(pRtc)) return pInst;
		if(pE->GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
			if(pE->IsKindOf(RUNTIME_CLASS(CPElem)))
				pE = ((CPElem*) pE)->GetInstBody();
			else
				pE = NULL;
		else
			pE = pE->GetParent();
	}
	return NULL;
}

////////////////////////////////////////////////////////////////////
//////////////////////// CElmResSrv ////////////////////////////////
////////////////////////////////////////////////////////////////////

CElmResSrv *CElmResSrv::s_pElmResSrv = NULL;

CElmResSrv::CElmResSrv()
{
	m_pView=NULL;
	m_bFocus = TRUE;
	m_bResizeFrame = TRUE;

	m_nETextUsed = m_nETextAll = 0;
	m_nETextBytesUsed = m_nETextBytesAll = 0;
	m_pETextFree = m_pETextUsed = NULL;
	InitializeCriticalSection(&m_syncETextUsed);
	m_bNowCollecting = FALSE;
}

CElmResSrv::~CElmResSrv()
{
	while(GetCount())
		delete RemoveTail();
	//--- tHg폜
	CObjFont *pObjFont;
	while(s_Font.GetCount()) {
		pObjFont = (CObjFont*) s_Font.RemoveTail();
		pObjFont->pGdiObj->DeleteObject();
		delete pObjFont;
	}
	//--- y폜
	CObjPen *pObjPen;
	while(s_Pen.GetCount()) {
		pObjPen = (CObjPen*) s_Pen.RemoveTail();
		pObjPen->pGdiObj->DeleteObject();
		delete pObjPen;
	}
	//--- ubV̍폜
	CObjBrush *pObjBrush;
	while(s_Brush.GetCount()) {
		pObjBrush = (CObjBrush*) s_Brush.RemoveTail();
		pObjBrush->pGdiObj->DeleteObject();
		delete pObjBrush;
	}
	//--- Tuj[
	CMenu *pmenu;
	while(m_Menu.GetCount()) {
		pmenu = (CMenu*) m_Menu.RemoveTail();
		pmenu->DestroyMenu();
		delete pmenu;
	}
	DeleteCriticalSection(&m_syncETextUsed);

	CETextBlock *pNext;
	while(m_pETextUsed) {
		pNext = m_pETextUsed->pNext;
		delete m_pETextUsed;
		m_pETextUsed = pNext;
	}
	while(m_pETextFree) {
		pNext = m_pETextFree->pNext;
		delete m_pETextFree;
		m_pETextFree = pNext;
	}

	POSITION pos, ps2, ps3;
	CRuntimeClass *key, *k2, *k3;
	_MemChain *pMC, *pM2;
	int i,j,k;
	pos = m_mapRtcToFree.GetStartPosition();
	ps2 = m_mapRtcToAllNo.GetStartPosition();
	ps3 = m_mapRtcToUsedNo.GetStartPosition();
	while(pos) {
		m_mapRtcToFree.GetNextAssoc(pos, (void*&)key, (void*&)pMC);
		m_mapRtcToAllNo.GetNextAssoc(ps2, (void*&)k2, (void*&) j);
		m_mapRtcToUsedNo.GetNextAssoc(ps3, (void*&)k3, (void*&) k);
		for(i=0; pMC; i++) {
			pM2 = pMC;
			pMC = pMC->pNext;
			CObject::operator delete(pM2);
		}
		i=0;
	}
		
}

void *CElmResSrv::NewElem(CRuntimeClass *pRtc, size_t nSize)
{
	long UsedNo, AllNo;
	void *pv;
	_MemChain *ppv;

	if(!m_mapRtcToAllNo.Lookup(pRtc, pv))
		m_mapRtcToAllNo[pRtc] = 0;
	if(!m_mapRtcToUsedNo.Lookup(pRtc, pv))
		m_mapRtcToUsedNo[pRtc] = 0;
	if(!m_mapRtcToFree.Lookup(pRtc, pv))
		m_mapRtcToFree[pRtc] = NULL;

	UsedNo = (int) m_mapRtcToUsedNo[pRtc] + 1;
	m_mapRtcToUsedNo[pRtc] = (void*) UsedNo;

	ppv = (_MemChain *) m_mapRtcToFree[pRtc];
	if(ppv) {
		pv = ppv->pNext;
		m_mapRtcToFree[pRtc] = pv;
		return ppv;
	}
	AllNo = (int) m_mapRtcToAllNo[pRtc] + 1;
	m_mapRtcToAllNo[pRtc] = (void*) AllNo;
	return CObject::operator new(nSize);
}

void CElmResSrv::DeleteElem(CRuntimeClass *pRtc, void *p)
{
	long UsedNo, AllNo;
	_MemChain *ppv;
	UsedNo = (int) m_mapRtcToUsedNo[pRtc];
	AllNo = (int) m_mapRtcToAllNo[pRtc];
	ppv = (_MemChain *) p;
	ppv->pNext = (_MemChain*) m_mapRtcToFree[pRtc];
	m_mapRtcToFree[pRtc] = ppv;
	m_mapRtcToUsedNo[pRtc] = (void*) (UsedNo-1);
}

#define ETEXT_BLOCK_SIZE 			0x10000
#define ETEXT_GARB_PERCENT_START	30

DWORD WINAPI CollectGarbageThread(LPVOID pv)
{
	CElmResSrv *pSrv = CElmResSrv::s_pElmResSrv;
	if(!pSrv || !pSrv->IsKindOf(RUNTIME_CLASS(CElmResSrv))) return 0;
	return pSrv->CollectGarbage();
}

BOOL CElmResSrv::CollectGarbage()
{
	EnterCriticalSection(&m_syncETextUsed);
	CETextBlock *pNext;
	CETextBlock *pOld = m_pETextUsed;
	m_nETextUsed = m_nETextAll = m_nETextBytesUsed = m_nETextBytesAll = 0;
	m_pETextUsed = NULL;
	CElmResSrv::s_pElmResSrv->SendMsg(MSG_COLLECT_ALL_GARBAGE, NULL);
	while(pOld) {
		pNext = pOld->pNext;
		pOld->pNext = m_pETextFree;
		m_pETextFree = pOld;
		pOld = pNext;
	}
	m_bNowCollecting = FALSE;
	LeaveCriticalSection(&m_syncETextUsed);
	return TRUE;
}

CEText *CElmResSrv::GetNewTChar(PETCHAR pch, CEText *old)
{
//	EnterCriticalSection(&m_syncETextUsed);
//	LeaveCriticalSection(&m_syncETextUsed);
	BYTE *rt;
	CETextBlock *pNext;

	if( m_nETextAll > 0 && m_nETextBytesAll > ETEXT_BLOCK_SIZE && !m_bNowCollecting
	&& ((m_nETextAll - m_nETextUsed) * 100 / m_nETextAll) > ETEXT_GARB_PERCENT_START) {
		DWORD tid;
		m_bNowCollecting = TRUE;
		::CreateThread(NULL, 0, CollectGarbageThread, this, 0, &tid);
	}
	int nLen = pch? strlen(pch) : 0;
	int nSize = 2 + nLen + 1;
	if(m_pETextUsed==NULL || (m_pETextUsed->nCur + nSize) >= m_pETextUsed->nSize ) {
		if(m_pETextFree==NULL) {
			pNext = (CETextBlock *) ::operator new(ETEXT_BLOCK_SIZE);
			pNext->pNext = m_pETextUsed;
			m_pETextUsed = pNext;
			m_pETextUsed->nCur = m_pETextUsed->pData - (BYTE*) m_pETextUsed;
			m_pETextUsed->nSize = ETEXT_BLOCK_SIZE;
		} else {
			pNext = m_pETextFree->pNext;
			m_pETextFree->pNext = m_pETextUsed;
			m_pETextUsed = m_pETextFree;
			m_pETextUsed->nCur = m_pETextUsed->pData - (BYTE*) m_pETextUsed;
			m_pETextFree = pNext;
		}
	}
	rt = (BYTE*) m_pETextUsed + m_pETextUsed->nCur;
	m_pETextUsed->nCur += nSize;
	memcpy(rt + 2, pch, nLen);
	rt[nLen+2] = '\0';
	rt[0] = 0;
	rt[1] = nLen;
	if(old) {
		m_nETextUsed--;
		m_nETextBytesUsed -= old->bLen;
	}
	m_nETextUsed++;
	m_nETextAll++;
	m_nETextBytesUsed += nLen;
	m_nETextBytesAll += nLen;
	return (CEText *) rt;
}

void CElmResSrv::GarbageEText(CEText*& pEText)
{
	BYTE *rt, *pch;
	CETextBlock *pNext;

	int nLen = pEText->bLen;
	int nSize = 2 + nLen + 1;
	pch = (BYTE*) pEText->data;
	if(m_pETextUsed==NULL || (m_pETextUsed->nCur + nSize) >= m_pETextUsed->nSize ) {
		if(m_pETextFree==NULL) {
			pNext = (CETextBlock *) ::operator new(ETEXT_BLOCK_SIZE);
			pNext->pNext = m_pETextUsed;
			m_pETextUsed = pNext;
			m_pETextUsed->nCur = m_pETextUsed->pData - (BYTE*) m_pETextUsed;
			m_pETextUsed->nSize = ETEXT_BLOCK_SIZE;
		} else {
			pNext = m_pETextFree->pNext;
			m_pETextFree->pNext = m_pETextUsed;
			m_pETextUsed = m_pETextFree;
			m_pETextUsed->nCur = m_pETextUsed->pData - (BYTE*) m_pETextUsed;
			m_pETextFree = pNext;
		}
	}
	rt = (BYTE*) m_pETextUsed + m_pETextUsed->nCur;
	m_pETextUsed->nCur += nSize;
	memcpy(rt + 2, pch, nLen);
	rt[nLen+2] = '\0';
	rt[0] = 0;
	rt[1] = nLen;
	m_nETextUsed++;
	m_nETextAll++;
	m_nETextBytesUsed += nLen;
	m_nETextBytesAll += nLen;
	pEText = (CEText *) rt;
}

CEText *CViecFC::GetNewTChar(PETCHAR pch, CEText *old)
{
	if(!CElmResSrv::s_pElmResSrv
	|| !CElmResSrv::s_pElmResSrv->IsKindOf(RUNTIME_CLASS(CElemView)))
		return NULL;
	return CElmResSrv::s_pElmResSrv->GetNewTChar(pch, old);
}

int CViecFC::SetPen(CDC *pdc, int nPenStyle, int nWidth, COLORREF crColor)
{
	return CElmResSrv::s_pElmResSrv->SetPen(pdc, nPenStyle, nWidth, crColor);
}

int CViecFC::SetBrush(CDC *pdc, COLORREF crColor)
{
	return CElmResSrv::s_pElmResSrv->SetBrush(pdc, crColor);
}

void CViecFC::SetOldGdiObject(CDC *pdc)
{
	CElmResSrv::s_pElmResSrv->SetOldGdiObject(pdc);
}

CDC *CViecFC::GetDC()
{
	return CElmResSrv::s_pElmResSrv->GetDC();
}

int CViecFC::ReleaseDC(CDC*pdc)
{
	return CElmResSrv::s_pElmResSrv->ReleaseDC(pdc);
}

void CViecFC::DrawFold3D(CDC *pdc, const CPoint& p, int mode)
{
	CRect rct = m_extent;
	rct.OffsetRect(p);
	rct.OffsetRect(m_org);
	POINT pnt[6];
	COLORREF col;
	COLORREF col1 = RGB(255,255,255);
	COLORREF col2 = RGB(192,192,192);
	COLORREF col3 = RGB(128,128,128);

	if(mode==1) {
		col = col1;
		col1 = col3;
		col3 = col;
	}
	
	pnt[0].x = rct.left+0; pnt[0].y = rct.top+0;
	pnt[1].x = rct.right-0; pnt[1].y = rct.top+0;
	pnt[2].x = rct.right-0; pnt[2].y = rct.bottom-0;
	pnt[3].x = rct.left+0; pnt[3].y = rct.bottom-0;
	SetPen(pdc, PS_SOLID, 1, col2);
	SetBrush(pdc, col2);
	pdc->Polygon(pnt, 4);

	pnt[0].x = rct.left+0; pnt[0].y = rct.top+0;
	pnt[1].x = rct.right-0; pnt[1].y = rct.top+0;
	pnt[2].x = rct.right-3; pnt[2].y = rct.top+3;
	pnt[3].x = rct.left+3; pnt[3].y = rct.top+3;
	pnt[4].x = rct.left+3; pnt[4].y = rct.bottom-3;
	pnt[5].x = rct.left+0; pnt[5].y = rct.bottom-0;
	SetBrush(pdc, col1);
	pdc->Polygon(pnt, 6);

	pnt[0].x = rct.right-0; pnt[0].y = rct.top+0;
	pnt[1].x = rct.right-0; pnt[1].y = rct.bottom-0;
	pnt[2].x = rct.left+0; pnt[2].y = rct.bottom-0;
	pnt[3].x = rct.left+3; pnt[3].y = rct.bottom-3;
	pnt[4].x = rct.right-3; pnt[4].y = rct.bottom-3;
	pnt[5].x = rct.right-3; pnt[5].y = rct.top+3;
	SetBrush(pdc, col3);
	pdc->Polygon(pnt, 6);
}

void CViecFC::CopyBody(CViecFC *pelm)
{
	pelm->m_org = m_org;
	pelm->m_extent = m_extent;
	pelm->m_bDragAllow = m_bDragAllow;

	CViecFC *pCp = (CViecFC *) pelm;
//	CViecFC::CopyBody(pelm);
	pCp->m_petFont = GetNewTChar(GetFont(), pCp->m_petFont);
	pCp->m_nDot = m_nDot;
	pCp->m_nCharSet = m_nCharSet;
}

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////
// CViecFC
//

CViecFC *CViecFC::Copy()
{
	CViecFC *pelm;
	pelm = (CViecFC *) GetRuntimeClass()->CreateObject();
	CopyBody(pelm);
	CopyChild(pelm);
	return pelm;
}

void CViecFC::CopyChild(CViecFC *pelm)
{
	POSITION pos;
	pos = GetHeadPosition();
	while(pos) 
		pelm->AddTail(GetNext(pos)->Copy());
}

void CViecFC::SerialChild(CArchive& ar)
{
	WORD no,i;
	CViecFC *pelm;
	BYTE b;
	if (ar.IsStoring()) {
		no = m_child.GetCount();
		ar << (BYTE) m_bEncap;
		ar << no;
		POSITION pos = GetHeadPosition();
		for(i=0; i<no&&pos; i++) {
			pelm = (CViecFC*) GetNext(pos);
			pelm->Serialize(ar);
		}
	} else {
		CString head;
		ar >> b; m_bEncap = b;
		ar >> no;
		for(i=0;i<no;i++) {
			ar >> head;
			if((pelm = GetUnknownElem(ar, head))) {
				pelm->SetParent(this);
				m_child.AddTail(pelm);
			}
		}
	}
}

#ifdef _DEBUG
void CViecFC::AssertValid() const
{
	CObject::AssertValid();
}

void CViecFC::Dump(CDumpContext& dc) const
{
	CObject::Dump(dc);
}
#endif //_DEBUG

////////////////////////////////////////////////////////////

int CViecFC::OnFocus(CPoint &p)
{
	POSITION pos;
	BOOL f=m_bFocus;
	CPoint p0 = p;
	p0 -= (CSize) m_org;
	CViecFC *pelem;

	if(GetCount()==0) {
		CRect r = m_extent;
		r.OffsetRect(m_org);
		m_bFocus = r.PtInRect(p)? TRUE:FALSE;
		if(f!=m_bFocus) {
			if(m_parent && m_parent->IsKindOf(RUNTIME_CLASS(CElemView)));
			else InvalidateRect(CPoint(0,0));
		}
		return m_bFocus;
	}
	m_focus = NULL;
	if(m_parent && m_parent->IsKindOf(RUNTIME_CLASS(CElemView))) {
		m_bFocus = TRUE;
		pos = GetHeadPosition();
		while(pos) {
			pelem = GetNext(pos);
			if(pelem->OnFocus(p0)) m_focus = pelem;
		}
		return m_bFocus;
	}

	CRect r = m_extent;
	r.OffsetRect(m_org);
	m_bFocus = r.PtInRect(p)? TRUE:FALSE;
	if(m_bFocus) {
		if(!f) InvalidateRect(CPoint(0,0));
		if(!m_bEncap) {
			pos = GetHeadPosition();
			while(pos) {
				pelem = GetNext(pos);
				if(pelem->OnFocus(p0)) m_focus = pelem;
			}
		}
	} else {
		if(f) InvalidateRect(CPoint(0,0));
		if(!m_bEncap) {
			pos = GetHeadPosition();
			while(pos) {
				pelem = GetNext(pos);
				if(pelem->OnFocus(p0)) m_focus = pelem;
			}
		}
	}
	return m_bFocus;
}

int CViecFC::GetCount()
{
	return m_child.GetCount();
}

POSITION CViecFC::GetHeadPosition()
{
	return m_child.GetHeadPosition();
}

CViecFC *CViecFC::GetNext(POSITION &pos)
{
	return (CViecFC*) m_child.GetNext(pos);
}

POSITION CViecFC::AddTail(CViecFC *e)
{
	if(!e) return NULL;
	e->SetParent(this);
	return m_child.AddTail(e);
}

int CViecFC::CalcExt(dirMode dir)
{
	CViecFC *pelem;
	CRect extent = m_extent;
	m_extent = CRect(0,0,0,0);
	POSITION pos = GetHeadPosition();
	if(pos) {
		if(dir==dirDown) {
			POSITION pos0 = pos;
			while(pos0) {
				pelem = GetNext(pos0);
				pelem->CalcExt(dir);
			}
		}
		if(!m_bEncap) {
			CRect r;
			while(pos) {
				pelem = GetNext(pos);
				r = pelem->GetRect();
				if(r.left<m_extent.left)	m_extent.left = r.left;
				if(r.right>m_extent.right)	m_extent.right = r.right;
				if(r.top<m_extent.top)	m_extent.top = r.top;
				if(r.bottom>m_extent.bottom)	m_extent.bottom = r.bottom;
			}
		}
	}
	if(dir==dirUp && m_parent)
		m_parent->CalcExt(dir);
	if(dir!=dirNot && extent!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = extent;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return 0;
}

void CViecFC::OnDraw(CDC *pdc, const CPoint& p)
{
	CPoint p0=p;
	p0.Offset(m_org);
	CRect r0=m_extent;
	r0.OffsetRect(p0);

	if(m_bDrag) OnDrawDrag(pdc, p);
	OnDrawBody(pdc, p);
	OnDrawChild(pdc, p);
	if(m_bFocus && !m_focus) OnDrawFocus(pdc, p);
}

void CViecFC::OnDrawChild(CDC *pdc, const CPoint& p)
{
	CPoint p0 = p;
	p0.Offset(m_org);
	CViecFC *pelem;
	if(!m_bEncap) {
		POSITION pos = GetHeadPosition();
		while(pos) {
			pelem = GetNext(pos);
			if(pelem!=m_focus)
				pelem->OnDraw(pdc, p0);
		}
		pos = GetHeadPosition();
		while(pos) {
			pelem = GetNext(pos);
				if(pelem==m_focus)
				pelem->OnDraw(pdc, p0);
		}
	}
}

int CViecFC::OnDrag(const CPoint& old, const CPoint& last)
{
	if(!m_bFocus) return 0;

	CPoint p0 = old;
	CPoint p1 = last;
	p0.Offset(m_org);
	p1.Offset(m_org);

	if(!m_focus && m_bDragAllow) {
		if(m_bDrag) InvalidateRect(old);
		else m_bDrag = TRUE;
		InvalidateRect(last);
		return 1;
	}

	POSITION pos = GetHeadPosition();
	CViecFC *pelem;
	if(!m_bEncap) {
		while(pos) {
			pelem = GetNext(pos);
			pelem->OnDrag(old, last);
		}
	}
	return 1;
}

CViecFC* CViecFC::GetFocus()
{
	if(!m_bFocus) return NULL;
	if(GetCount()==0) return this;
	if(!m_focus) return this;
	return m_focus->GetFocus();
}


//////////////////////////////////////////////////
////  CElemView
////
//////////////////////////////////////////////////

int CElemView::OnFocus(CPoint &p)
{
	POSITION pos;
	CPoint p0 = p;
	p0 -= (CSize) m_org;
	m_bFocus = TRUE;
	m_focus = NULL;
	pos = GetHeadPosition();
	while(pos) {
		CViecFC* pelem = GetNext(pos);
		if(pelem->OnFocus(p0)) m_focus = pelem;
		else pelem->SetFocus(TRUE);
	}
	return m_bFocus;
}


CElemView::CElemView()
{
	m_pView=NULL;
	m_bFocus = TRUE;
	m_bResizeFrame = TRUE;
}

CElemView::~CElemView()
{
}

void CElemView::Initialize(CScrollView* pvw)
{
	m_pView = pvw;
}

void CElemView::OnDraw(CDC *pdc, const CPoint& p)
{
	pOldPen = pdc->SelectStockObject(BLACK_PEN);
	pOldBrush = pdc->SelectStockObject(WHITE_BRUSH);
	pOldFont = pdc->SelectStockObject(SYSTEM_FONT);
	pdc->SetBkMode(TRANSPARENT);

	OnDrawChild(pdc, p);

	pdc->SelectObject(pOldPen);
	pdc->SelectObject(pOldBrush);
	pdc->SelectObject(pOldFont);
}

void CElemView::SetView(CScrollView* v)
{
	m_pView = v;
}

#ifdef _DEBUG
void CElemView::AssertValid() const
{
	CObject::AssertValid();
}

void CElemView::Dump(CDumpContext& dc) const
{
	CObject::Dump(dc);
}
#endif //_DEBUG

CRect CElemView::GetClientRect()
{
	CRect r(0,0,0,0);
	if(m_pView) {
		m_pView->GetClientRect(&r);
		r.OffsetRect(m_pView->GetScrollPosition());
	}
	return r;
}

void CElemView::LogicToCleint(CRect& rect)
{
	if(m_pView)
	rect.OffsetRect(-m_pView->GetScrollPosition());
}

int CElemView::CalcExt(dirMode dir)
{
	POSITION pos = GetHeadPosition();
	if(!pos) return 0;
	CRect ext = m_extent;
	CPoint org = m_org;

	CViecFC *pelem = GetNext(pos);
	if(dir==dirDown) pelem->CalcExt(dir);
	m_extent = pelem->GetExtent();
	m_org = -m_extent.TopLeft();

	CSize s = GetSize();

	if(m_pView && (org!=m_org || ext!=m_extent)) {
		m_pView->SetScrollSizes(MM_TEXT, s);		   //enable the scroll view

		CFrameWnd *pfrm = m_pView->GetParentFrame();
		if(m_bResizeFrame) {
/*
			WINDOWPLACEMENT wp;
			if(pfrm->GetWindowPlacement(&wp)) {
				wp.rcNormalPosition.right = 
				   wp.rcNormalPosition.left + s.cx + 10;
				wp.rcNormalPosition.bottom =
				   wp.rcNormalPosition.top + s.cy + 40;
				pfrm->SetWindowPlacement(&wp);
			}
*/
			m_pView->ResizeParentToFit();
		}
		m_pView->InvalidateRect(NULL);
	}
	return 0;
}

int CElmResSrv::SetFont(CDC *pdc, int dot, PETCHAR name, BYTE nCharSet, BYTE nItalic, int wd)
{
	CObjFont *pObjFont;
	POSITION pos = s_Font.GetHeadPosition();
	while(pos) {
		pObjFont = (CObjFont*) s_Font.GetNext(pos);
		if(pObjFont->nDot == dot && pObjFont->nWd == wd && pObjFont->sName==name && 
		   pObjFont->nCharSet==nCharSet && pObjFont->nItalic==nItalic) {
			pdc->SelectObject(pObjFont->pGdiObj);
			return 1;
		}
	}
	//--- Create a new font
	pObjFont = new CObjFont();
	if(!pObjFont) return 0;
	pObjFont->pGdiObj = new CFont();
	if(!pObjFont->pGdiObj) return 0;
	pObjFont->nDot = dot;
	pObjFont->nWd = wd;
	pObjFont->sName = name;
	pObjFont->nCharSet = nCharSet;
	pObjFont->nItalic = nItalic;
	pObjFont->pGdiObj->CreateFont( dot/*high*/, wd /*width*/, 0 /* escape */, 0/*orient*/, 
		FW_DONTCARE/*weight*/, nItalic/*italic*/, FALSE/*underline*/, 0/*strike*/,
		nCharSet/*charset*/, OUT_CHARACTER_PRECIS, CLIP_CHARACTER_PRECIS,
		DEFAULT_QUALITY, FF_DECORATIVE, name );
	s_Font.AddTail(pObjFont);
	pdc->SelectObject(pObjFont->pGdiObj);
	return 2;
}

int CElmResSrv::SetPen(CDC *pdc, int nPenStyle, int nWidth, COLORREF crColor)
{
	CObjPen *pObjPen;
	POSITION pos = s_Pen.GetHeadPosition();
	while(pos) {
		pObjPen = (CObjPen*) s_Pen.GetNext(pos);
		if(pObjPen->nPenStyle==nPenStyle && pObjPen->nWidth==nWidth && pObjPen->crColor==crColor) {
			pdc->SelectObject(pObjPen->pGdiObj);
			return 1;
		}
	}
	//--- Create new Pen
	pObjPen = new CObjPen();
	if(!pObjPen) return 0;
	pObjPen->pGdiObj = new CPen();
	if(!pObjPen->pGdiObj) return 0;
	pObjPen->nPenStyle = nPenStyle;
	pObjPen->nWidth = nWidth;
	pObjPen->crColor = crColor;
	pObjPen->pGdiObj->CreatePen(nPenStyle, nWidth, crColor);
	s_Pen.AddTail(pObjPen);
	pdc->SelectObject(pObjPen->pGdiObj);
	return 2;
}

int CElmResSrv::SetBrush(CDC *pdc, COLORREF crColor)
{
	CObjBrush *pObjBrush;
	POSITION pos = s_Brush.GetHeadPosition();
	while(pos) {
		pObjBrush= (CObjBrush *) s_Brush.GetNext(pos);
		if(pObjBrush->crColor==crColor) {
			pdc->SelectObject(pObjBrush->pGdiObj);
			return 1;
		}
	}
	//--- Create new Pen
	pObjBrush = new CObjBrush();
	if(!pObjBrush) return 0;
	pObjBrush->pGdiObj = new CBrush();
	if(!pObjBrush->pGdiObj) return 0;
	pObjBrush->crColor = crColor;
	pObjBrush->pGdiObj->CreateSolidBrush(crColor);
	s_Brush.AddTail(pObjBrush);
	pdc->SelectObject(pObjBrush->pGdiObj);
	return 2;
}

void CElmResSrv::SetOldGdiObject(CDC *pdc)
{
	if(pOldPen) pdc->SelectObject(pOldPen);
	if(pOldBrush) pdc->SelectObject(pOldBrush);
	if(pOldFont) pdc->SelectObject(pOldFont);
	pdc->SetTextColor(RGB(0,0,0));
}

CDC* CElmResSrv::GetDC()
{
	if(!m_pView) return NULL;
	return m_pView->GetDC();
}

int CElmResSrv::ReleaseDC(CDC* pdc)
{
	if(!m_pView) return 0;
	return m_pView->ReleaseDC(pdc);
}

//////////////////////////////////////////////////////////////////////////////
///
///  Drag Global class
///

GDrag::GDrag()
{
	m_start = m_old = m_last = CPoint(0,0);
	m_capture = NULL;
}

GDrag::~GDrag()
{
}

int GDrag::Capture(CWnd *c, CPoint& p)
{
	m_capture = c;
	m_old = m_last = m_start = p;
	m_capture->SetCapture();
	return 1;
}

int GDrag::Drag(CPoint& p)
{
	if(!m_capture) return 0;  // not yet captured
	m_old = m_last;
	m_last  = p;
	return 1;
}

CPoint GDrag::OldOffset()
{
	return m_old - m_start;
}

CPoint GDrag::LastOffset()
{
	return m_last - m_start;
}

int GDrag::Release()
{
	if(!m_capture) return 0;
	m_capture = NULL;
	m_start = m_old = m_last = CPoint(0,0);
	return ::ReleaseCapture();
}


////////////////////////////////////////////////////////////////////////////
// Symbol
//

BOOL CViecFC::SendMsg(int qst, CObject *el)
{
	switch(qst) {
	case MSG_COLLECT_ALL_GARBAGE:
		if(m_petName)
			CElmResSrv::s_pElmResSrv->GarbageEText(m_petName);
		if(m_petFont)
			CElmResSrv::s_pElmResSrv->GarbageEText(m_petFont);
		break;
	case MSG_DO_JOB:
		{
			CJobDoer *wk = (CJobDoer *) el;
			if(!wk->IsKindOf(RUNTIME_CLASS(CJobDoer)))
				return TRUE;
			if(wk->Do(this))
				return TRUE;
		}
		break;
	case MSG_COLLECT_KINDOF_OBJECT:
		{
			CSuitCase *psc = (CSuitCase *) el;
			if(el && IsKindOf(psc->m_runtimeClass)) {
				psc->m_oblist->AddTail(this);
				return TRUE;
			}
		}
		break;
	case MSG_COLLECT_OBJECT:
		{
			CSuitCase *psc = (CSuitCase *) el;
			if(el && psc->m_runtimeClass==GetRuntimeClass()) {
				psc->m_oblist->AddTail(this);
				return TRUE;
			}
		}
		break;
	case MSG_CAN_SKIP_ONCREATED_PROC:
		((CSuitCase *) el)->m_int = FALSE;
		return TRUE;
	case MSG_CAN_THIS_DISAPPEAR:
		return TRUE;
	case MSG_ADD_MENU_FOR_CHILD:
	case MSG_COMMAND_FOR_CHILD:
	case MSG_INCLUDE_CHILD_IN_MATH_TABLE:
		if(GetParent())
			return GetParent()->SendMsg(qst, el);
		((CSuitCase *) el)->m_int = FALSE;
		return TRUE;
	case MSG_SET_FOCUS_OFF:
		if(m_bFocus) {
			InvalidateRect(CPoint(0,0));
			m_bFocus = FALSE;
			if(m_focus)
				m_focus->SendMsg(qst, this);
		}
		return TRUE;
	case MSG_SUBSTITUTE_THE_TWO:
		{
			CSuitCase *pSC = (CSuitCase *) el;
			POSITION pos1, pos2;
			pos1 = m_child.Find(pSC->m_case);
			pos2 = m_child.Find(pSC->m_case2);
			if(!pos1 || !pos2) return FALSE;
			m_child.SetAt(pos2, pSC->m_case);
			m_child.SetAt(pos1, pSC->m_case2);
			CalcExt();
			InvalidateRect(CPoint(0,0));
		}
		return TRUE;
	}
//	BOOL rt = CViecFC::SendMsg(qst, el);
//	if(rt) return rt;
	return SendMsgToChild(qst, el);
}

void CViecFC::SetName(PETCHAR name)
{
	CObject *pObj;

	if(m_petName && s_MathSymbMapTable.Lookup(GetName(), pObj) && pObj==this) {
		s_MathSymbMapTable.RemoveKey(GetName());
		m_petName = GetNewTChar(name, m_petName);
		s_MathSymbMapTable[GetName()] = this;
	} else {
		m_petName = GetNewTChar(name, m_petName);
	}
	if(m_petName==NULL)
		pObj=NULL;
}

void CViecFC::SetName(const char* name, BYTE nDot, BYTE nCharSet)
{
	SetName(name);
	m_nDot = nDot;
	m_nCharSet = nCharSet;
}

int CViecFC::s_nDot = 24;

CViecFC *CViecFC::GetElemByName(const char *name, dirMode dir, CViecFC *pfrm)
{
	CViecFC *psb=NULL, *psb0;
	CString str = name;
	POSITION pos;
	int i;
	
	pos = GetHeadPosition();
	while(pos) {
		psb = (CViecFC*) GetNext(pos);
		if(GetName() && !strcmp(GetName(), "Sym2")) {
			i = 0;
		}
		if(psb!=pfrm && psb->IsKindOf(RUNTIME_CLASS(CIElem))) {
			CIElem *pie = (CIElem*)psb;
			psb = pie->GetBody();
			if(str==psb->GetName()) {
				return psb;
			} else if(psb->GetFindFirst()) {
				if((psb=psb->GetElemByName(name, dirDown, pfrm))) {
					return psb;
				}
			}
		} else {
			if(psb!=pfrm && psb->IsKindOf(RUNTIME_CLASS(CViecFC))) {
				if(str==psb->GetName()) {
					return psb;
				} else if(psb->GetFindFirst()) {
					if((psb=psb->GetElemByName(name, dirDown, pfrm))) {
						return psb;
					}
				}
			}
		}
	}


	if(dir==dirUp) {
		psb0 = (CViecFC*) GetParent();
		if(IsKindOf(RUNTIME_CLASS(CPElem))) {
			CPElem *ppe = (CPElem*) this;
			if((psb=ppe->GetInstBody())) {
				psb = psb->GetElemByName(name, dir, this);
				if(psb) return psb;
			} else {
				if(psb0 && !psb0->IsKindOf(RUNTIME_CLASS(CElemView))) {
					psb = psb0->GetElemByName(name, dir, this);
					if(psb) return psb;
				}
			}
		} else {
			if(psb0 && !psb0->IsKindOf(RUNTIME_CLASS(CElemView))) {
				psb = psb0->GetElemByName(name, dir, this);
				if(psb) return psb;
			}
		}
	}

	if(IsKindOf(RUNTIME_CLASS(CIElem)) && ((CIElem*)this)->GetBody()) {
		psb = ((CIElem*)this)->GetBody()->GetElemByName(name, dirDown);
		if(psb) return psb;
	}

	pos = GetHeadPosition();
	while(pos) {
		psb0 = (CViecFC*) GetNext(pos);
		if(psb0 && psb0!=pfrm && psb0->IsKindOf(RUNTIME_CLASS(CViecFC))
		   && !psb0->GetFindFirst()
		   && (psb=psb0->GetElemByName(name, dirDown, this)))
			return psb;
	}
	return NULL;
}

CRelationPipe::CRelationPipe(PETCHAR nm)
{
	m_petName = GetNewTChar(nm, NULL);
	m_pSymb = NULL;
}

CGElem::CGElem()
{
	m_bCreated = FALSE;
	m_mode=modeClose;
	m_bEncap = TRUE;
	m_pInst = NULL;
	m_nFormat = DT_CENTER | DT_VCENTER;
	m_oldRct = CRect(0,0,0,0);
}

void CGElem::SetMode(mode m)
{
	m_mode=m;
	switch(m) {
		case modeOpen:
			m_bEncap = FALSE;
			break;
		case modeClose:
			m_bEncap = TRUE;
			break;
	}
}

int CGElem::CalcExt(dirMode dir)
{
	CRect extent = m_extent;
	if(dir==dirDown && GetMode()==modeOpen)
		CViecFC::CalcExt(dir);
	else
		CViecFC::CalcExt(dirNot);
	if(m_mode==modeClose) {
		m_extent = CRect(0,0,0,0);
	}
	
	CDC *pdc = GetDC();
	if(pdc) {
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		CSize sz = pdc->GetTextExtent(GetName(), lstrlen(GetName()));

		m_RName.left = - sz.cx/2;
		m_RName.right = sz.cx + m_RName.left;
		m_RName.top = 5;
		m_RName.bottom = sz.cy+5;
		ReleaseDC(pdc);
	}
	
	if(m_extent.left>m_RName.left) m_extent.left = m_RName.left;
	if(m_extent.top>m_RName.top) m_extent.top = m_RName.top;
	if(m_extent.right<m_RName.right) m_extent.right = m_RName.right;
	if(m_extent.bottom<m_RName.bottom) m_extent.bottom = m_RName.bottom;	

	m_extent.left -= 6;
	m_extent.top -= 6;
	m_extent.right += 6;
	m_extent.bottom += 6;

	if(dir==dirUp && m_parent) m_parent->CalcExt(dir);
	if( extent.left <= m_extent.left && extent.right >= m_extent.right &&
	    extent.top <= m_extent.top && extent.bottom >= m_extent.bottom ) {
		CRect ext0 = m_extent;
		m_extent = extent;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	} else {
		InvalidateRect(CPoint(0,0));
	}
	return 1;
}
void CGElem::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF rgb;

	DrawFold3D(pdc, p);

	CPoint p0=p;
	p0.Offset(m_org);
	p0.Offset( m_RName.left, m_RName.top);
	CRect r0=m_extent;
	r0.OffsetRect(p0);
	if(m_mode==modeClose) {
		if(m_bFocus) rgb = pdc->SetTextColor(RGB(0,0,200));
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		pdc->TextOut(p0.x, p0.y, GetName());
		SetOldGdiObject(pdc);
	}
	if(m_bDrag) {
		p0.Offset(TheDrag.LastOffset());
		pdc->TextOut(p0.x, p0.y, GetName());
	}
	if(m_mode!=modeClose) OnDrawChild(pdc, p);
}

CMultiDocTemplate *CViecFC::pElemTemp = NULL;

CElemView *CViecFC::GetNewView(PETCHAR str)
{
	CFrameWnd* pFrame;
	CGDoc* pDocument;
	CMultiDocTemplate* pTemplate;

	CElemView *pView = new CElemView();
	if(pElemTemp==NULL) {
		pElemTemp = new CGTemplate(IDR_ELEM,
				RUNTIME_CLASS(CGDoc),
				RUNTIME_CLASS(CGFrame),
				RUNTIME_CLASS(CGView));
	}
	pTemplate = pElemTemp;
	if(pTemplate==NULL) return NULL;
	pDocument = (CGDoc*) pTemplate->CreateNewDocument();
	if (pDocument == NULL) return NULL;
	ASSERT_VALID(pDocument);
	pDocument->SetTitle(str);
	pDocument->m_bAutoDelete = NULL;
	pFrame = pTemplate->CreateNewFrame(pDocument, NULL);
	pDocument->m_bAutoDelete = TRUE;
	if (pFrame == NULL) { delete pDocument; return NULL; }
	ASSERT_VALID(pFrame);
	pDocument->m_pElemView = pView;
	pTemplate->InitialUpdateFrame(pFrame, pDocument);
	return pView;
}

CIElem * CGElem::GetNewInst()
{
	CIElem *newInst = new CIElem;
	newInst->SetDragAllow(TRUE);
	return newInst;
}

BOOL CElemView::SendMsg(int sig, CObject* sc)
{
	switch(sig) {
	case MSG_RECALC_ALL_VIEW:
		m_extent = CRect(0,0,0,0);
		CalcExt(dirDown);
		InvalidateRect(CPoint(0,0));
		break;
	}
	return CViecFC::SendMsg(sig, sc);
}

BOOL CIElem::SendMsg(int sig, CObject* sc)
{
	CGElem *body = GetBody();
	CElemView *pv = (CElemView *) body->GetView();

	switch(sig) {
	case MSG_ADD_MENU_FOR_CHILD:
	case MSG_COMMAND_FOR_CHILD:
	case MSG_CAN_THIS_DISAPPEAR:
	case MSG_INCLUDE_CHILD_IN_MATH_TABLE:
		if(GetParent())
			return GetParent()->SendMsg(sig, sc);
		((CSuitCase *) sc)->m_int = FALSE;
		return TRUE;
	case MSG_RECALC_ALL_VIEW:
		if(pv && pv->m_pView) {
			CWnd *pWnd = pv->m_pView->GetParentFrame();
			pWnd->BringWindowToTop();
			pv->SendMsg(sig, sc);
		}
	}
	if(body && body->IsKindOf(RUNTIME_CLASS(CGElem)))
		return body->SendMsg(sig, sc);
	else
		return FALSE;
}

BOOL CGElem::ToDblBody()
{
	InvalidateRect(CPoint(0,0));
	SetMode(modeOpen);
	SetDragAllow(FALSE);

	CElemView *pView = GetNewView(GetName());
	if(pView==NULL) return FALSE;
	CIElem *pInst = GetNewInst();
	if(pInst==NULL) return FALSE;

	if(!m_bCreated)
		OnCreated();
	GetAncestor()->SubstChild(this, pInst, dirDown);
	pInst->DblInst(this);
	pInst->CalcExt(dirUp);
	pView->AddTail(this);
	CalcExt(dirDown);
	pView->CalcExt(dirUp);
	InvalidateRect(CPoint(0,0));
	return TRUE;
}

// CHM 1999.02.02 tree report
/////////// report the tree structure of node  /////////////
class CJDTreeReport : public CJobDoer {
public:
	FILE *fp;
	CViecFC *pTop;

	CJDTreeReport(const char *file = NULL);
	virtual ~CJDTreeReport();
	virtual BOOL Do(CObject *);
};

CJDTreeReport::CJDTreeReport(const char *file)
{
	fp = NULL;
	if(file==NULL) return;
	fp = fopen(file, "w");
}

CJDTreeReport::~CJDTreeReport()
{
	if(fp) fclose(fp);
}

BOOL CJDTreeReport::Do(CObject *g)
{
	if(fp==NULL) return TRUE;
	CViecFC *pE = (CViecFC*) g;
	CRuntimeClass *pRC, *pRC2;

	pRC = pE->GetRuntimeClass();
	CViecFC *pCur = (CViecFC*) pE;
	while(pCur!=NULL && pCur!=pTop) {
		CPElem *pPE;
		pPE = (CPElem*) pCur;
		pCur = pPE->GetParent();
		if(pCur!=NULL && 
			pCur->IsKindOf(RUNTIME_CLASS(CElemView)) &&
			pPE->IsKindOf(RUNTIME_CLASS(CPElem))) {
			pCur = pPE->GetInstBody();
		} else {
			fprintf(fp, "  ");
		}
	}

	fprintf(fp, "%s:\"%s\"", pRC->m_lpszClassName, pE->GetName());
	if(pE->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		CSymbInst *pSI;
		pSI = (CSymbInst*) pE;
		fprintf(fp, "  -> \"%s\"", pSI->GetSymbName());
	}

	fprintf(fp, "  {");
	pRC2 = pRC->m_pfnGetBaseClass();
	while( pRC2 && pRC2!=RUNTIME_CLASS(CObject) ) {
		fprintf(fp, "<-%s", pRC2->m_lpszClassName);
		pRC2 = pRC2->m_pfnGetBaseClass();
	}
	fprintf(fp, "}");
	
	fprintf(fp, "\n");
	
	return FALSE;
}
/////////// report the tree structure of node  /////////////

BOOL CGElem::AppendDefaultMenu(CMenu *pMenu)
{
	if(GetCount()>0) {
		if(!GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
			pMenu->AppendMenu(MF_STRING, CMD_SPLIT, "split");
		if(GetInstBody() && GetParent()->IsKindOf(RUNTIME_CLASS(CElemView))) {
			pMenu->AppendMenu(MF_STRING, CMD_GO_BACK, "Go &back");
			pMenu->AppendMenu(MF_STRING, CMD_FOCUS_TO, "&Focus to");
		} else if(!GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
			if(m_mode==modeOpen)
				pMenu->AppendMenu(MF_STRING, CMD_CLOSE, "&close");
			else
				pMenu->AppendMenu(MF_STRING, CMD_OPEN, "&open");
	}
	pMenu->AppendMenu(MF_STRING, CMD_LOAD_OBJECT, "&load object");
	pMenu->AppendMenu(MF_STRING, CMD_SAVE_OBJECT, "&save object");
	pMenu->AppendMenu(MF_STRING, CMD_CHANG_NAME, "Change &Name");
	pMenu->AppendMenu(MF_STRING, CMD_RECAL_SIZE, "&Recalc Size");
	pMenu->AppendMenu(MF_STRING, CMD_CHM_TREE_REPORT, "&Report tree structure"); // CHM 1999.02.02 tree report
//	pMenu->AppendMenu(MF_STRING, CMD_ADD_COMMENT, "&Add Comment");
	if(GetParent()->SendMsg(MSG_CAN_THIS_DISAPPEAR, this))
		pMenu->AppendMenu(MF_STRING, CMD_ADD_DELETE, "&Delete");

	return TRUE;
}

int CGElem::OnCommand(UINT id)
{
	CElemView *pa;
	CFileDialog dlgFile(TRUE, NULL, "*.*", OFN_FILEMUSTEXIST);
	CFileDialog dlgObj(FALSE, NULL, "*.*");
	CArchive *ar;
	CString head;
	CViecFC *pelm;

	switch(id) {
	case CMD_CHM_TREE_REPORT: // CHM 1999.02.02 tree report
		{
			CFileDialog dlgFile(TRUE, NULL, "*.*");
			if(dlgFile.DoModal()!=IDOK) return TRUE;
			CJDTreeReport report(dlgFile.GetPathName());
			report.pTop = this;
			SendMsg(MSG_DO_JOB, &report);
		}
		return TRUE;
		case CMD_SAVE_OBJECT:
			if(dlgObj.DoModal()!=IDOK) break;
			ar = OpenFile(dlgObj.GetPathName(), modeWrite);
			if(ar==NULL) break;
			Serialize(*ar);
			CloseFile();
			return TRUE;
		case CMD_LOAD_OBJECT:
			if(dlgFile.DoModal()!=IDOK) break;
			ar = OpenFile(dlgFile.GetPathName(), modeRead);
			if(ar==NULL) break;
			*ar >> head;
			pelm = GetUnknownElem(*ar, head);
			if(pelm==NULL) return FALSE;
			AddTail(pelm);
			pelm->OnCreated();
			pelm->SetOrg(t_point);
			pelm->CalcExt(dirDown);
			pelm->SendMsg(MSG_RECALC_ALL_VIEW, NULL);
			CalcExt();
			pelm->InvalidateRect(CPoint(0,0));
			CloseFile();
			return TRUE;
		case CMD_LOAD_OBJECT_COM:
			ar = OpenFile("..\\temp\\_com.tmp", modeRead);
			if(ar==NULL) break;
			*ar >> head;
			pelm = GetUnknownElem(*ar, head); //elemW߂H
			if(pelm==NULL) return FALSE;
			if(GetCount()>1) {
				RemoveTail();
			}
			AddTail(pelm);
			pelm->OnCreated();
			pelm->SetOrg(t_point);
			pelm->CalcExt(dirDown);
			pelm->SendMsg(MSG_RECALC_ALL_VIEW, NULL);
			CalcExt();
			pelm->InvalidateRect(CPoint(0,0));
			CloseFile();
			return TRUE;
		case CMD_SPLIT:
			ToDblBody();
			return 1;
		case CMD_OPEN:
			if(GetCount()==0) break;
			InvalidateRect(CPoint(0,0));
			m_oldRct = m_extent;
			SetMode(modeOpen);
			if(!m_bCreated)
				OnCreated();
			InvalidateRect(CPoint(0,0));
			CalcExt(dirUp);
			return 1;
		case CMD_CLOSE:
			if(GetCount()==0) break;
			InvalidateRect(CPoint(0,0));
			m_extent = m_oldRct;
			SetMode(modeClose);
			InvalidateRect(CPoint(0,0));
			CalcExt(dirUp);
			return 1;
		case CMD_GO_BACK:
			m_pInst->PackInst();
			return 1;
		case CMD_FOCUS_TO:
			pa = (CElemView *) m_pInst->GetView();
			if(pa && pa->m_pView) {
				CWnd *pWnd = pa->m_pView->GetParentFrame();
				pWnd->BringWindowToTop();
			}
			return 0;
		case CMD_CHANG_NAME:
			{
				static LOGFONT logFont;
				CDC *pdc = GetDC();
				SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
				CFont *pfont = (CFont*) pdc->SelectStockObject(SYSTEM_FONT);
				pfont->GetObject(sizeof(LOGFONT), &logFont);
				ReleaseDC(pdc);

				CChgNmDlg dlg(&logFont);
				dlg.m_text = GetName();
				dlg.m_nFormat = GetFormat();
				if(dlg.DoModal()==IDOK) {
					InvalidateRect(CPoint(0,0));
					m_petName = GetNewTChar(dlg.m_text, m_petName);
					m_petFont = GetNewTChar(logFont.lfFaceName, m_petFont);
					m_nDot = logFont.lfHeight<0 ?(BYTE) (-logFont.lfHeight): (BYTE) logFont.lfHeight;
					m_nCharSet = logFont.lfCharSet;
					SetFormat(dlg.m_nFormat);
					CalcExt(dirUp);
					GetAncestor()->SendMsg(MSG_CHANG_NAME, this);
				}
				return 1;
			}
		case CMD_RECAL_SIZE:
			InvalidateRect(CPoint(0,0));
			m_extent=CRect(0,0,0,0);
			CalcExt(dirUp);
			return 1;
		case CMD_ADD_COMMENT:
			{
			CPElem *ppe = new CPElem();
			AddTail(ppe);
			CRect r = GetExtent();
			ppe->SetOrg(CPoint(r.right, 0));
			ppe->SetDragAllow(TRUE);
			InvalidateRect(CPoint(0,0));
			SetMode(modeOpen);
			CalcExt(dirDown);
			CalcExt(dirUp);
			InvalidateRect(CPoint(0,0));
			}
			return 1;
	}
	return CViecFC::OnCommand(id);
}

int CGElem::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu();
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	if(GetCount()>0) {
		if(!GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
			pMenu->AppendMenu(MF_STRING, CMD_SPLIT, "split");
		if(GetInstBody() && GetParent()->IsKindOf(RUNTIME_CLASS(CElemView))) {
			pMenu->AppendMenu(MF_STRING, CMD_GO_BACK, "Go &back");
			pMenu->AppendMenu(MF_STRING, CMD_FOCUS_TO, "&Focus to");
		} else if(GetInstBody()!=NULL || !GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
			if(m_mode!=modeOpen) pMenu->AppendMenu(MF_STRING, CMD_OPEN, "&open");
			else pMenu->AppendMenu(MF_STRING, CMD_OPEN, "&close");
	}
	pMenu->AppendMenu(MF_STRING, CMD_CHANG_NAME, "&Change Name");
	pMenu->AppendMenu(MF_STRING, CMD_RECAL_SIZE, "&Recalc Size");
	pMenu->AppendMenu(MF_STRING, CMD_ADD_COMMENT, "&Add Comment");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 0;
}

BOOL CViecFC::SubstChild(CViecFC *pFrom, CViecFC *pTo, dirMode dir)
{
	BOOL rt = FALSE;
	POSITION pos;
	pos = m_child.Find(pFrom, NULL);
	if(pos) {
		if(pFrom==m_focus)
			m_focus = pTo;
		m_child.SetAt(pos, pTo);
		pTo->SetParent(this);
		rt = TRUE;
	}
	if(dir==dirDown) {
		pos = GetHeadPosition();
		while(pos)
			if(GetNext(pos)->SubstChild(pFrom, pTo, dir)) rt = TRUE;
	}
	return rt;
}

BOOL CViecFC::IsInside(CViecFC* pel)
{
	CViecFC *pelem;
	POSITION pos;

	pos = GetHeadPosition();
	while(pos) {
		pelem = GetNext(pos);
		if(pelem==pel) return TRUE;
		if(pelem->IsInside(pel)) return TRUE;
	}
	return FALSE;
}

void CGElem::SetInst(CIElem *pI)
{
	m_pInst = pI;
}

BOOL CIElem::DblInst(CGElem *pPe)
{
	m_pBody = pPe;
	CSize s1 = pPe->m_oldRct.Size();
	CSize s2 = pPe->m_extent.Size();
	if(s1.cx*s1.cy <s2.cx*s2.cy)
		m_extent = pPe->m_oldRct;
	else
		m_extent = pPe->m_extent;
	m_org = pPe->m_org;
	m_petName = GetNewTChar(pPe->GetName(), m_petName);
	m_petFont = GetNewTChar(pPe->GetFont(), m_petFont);
	m_nDot = pPe->m_nDot;
	m_nCharSet = pPe->m_nCharSet;
	pPe->m_org = CPoint(0,0);
	pPe->SetInst(this);
	pPe->SetMode(modeOpen);

	return TRUE;
}

CGElem::~CGElem()
{
}

CSElem::~CSElem()
{
}

CIElem::~CIElem()
{
	if(m_pBody) {
		CElemView *pO = (CElemView*) m_pBody->m_parent;
		CDocument *pd = (CDocument *)pO->m_pView->GetDocument();
		pd->OnCloseDocument();
	}
}

BOOL CIElem::PackInst()
{
	CElemView *pO;
	CMDIChildWnd *pf;

	pO = (CElemView*) m_pBody->m_parent;
	pO->m_child.RemoveTail();
	m_pBody->m_org = m_org;

	CViecFC *panc = GetAncestor();
	panc->SubstChild(this, m_pBody, dirDown);

	m_pBody->SetMode(modeClose);
	m_pBody->m_pInst = NULL;
	m_pBody->SetDragAllow(TRUE);
	m_pBody->SetOldRct(m_pBody->GetExtent());
	m_pBody->SetExtent(GetExtent());
	m_pBody->CalcExt(dirUp);
	m_pBody = NULL;
	delete this;
	pf = (CMDIChildWnd *)pO->m_pView->GetParent();
	pf->DestroyWindow();
	return TRUE;
}

BOOL CViecFC::FocusToView(CViecFC *pel)
{
	CElemView *pa = (CElemView*) pel->GetView();
	if(pa && pa->m_pView) {
		pa->m_pView->GetParentFrame()->BringWindowToTop();
		return TRUE;
	} else {
		return FALSE;
	}
}

BOOL CViecFC::OnCreated(EnumOnCreated bSkp)
{
	POSITION pos = GetHeadPosition();
	while(pos) {
		CViecFC *pel = GetNext(pos);
		pel->OnCreated(bSkp);
	}
	return TRUE;
}


int CIElem::OnCommand(UINT id)
{
	switch(id) {
		case CMD_GO_BACK:
			PackInst();
			break;
		case CMD_FOCUS_TO:
			FocusToView(m_pBody);
			break;
	}
	return id;
}


int CIElem::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu();
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	pMenu->AppendMenu(MF_STRING, CMD_GO_BACK,"Turn back");
	pMenu->AppendMenu(MF_STRING, CMD_FOCUS_TO,"Focus to");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

void CGElem::CopyBody(CViecFC *pelm)
{
	CGElem *pCp = (CGElem *) pelm;
	CViecFC::CopyBody(pelm);
	pCp->m_mode = m_mode;
	pCp->m_petFont = GetNewTChar(GetFont(), pCp->m_petFont);
	pCp->m_nFormat = m_nFormat;
}

void CGElem::SerializeBody(CArchive& ar)
{
	CViecFC::SerializeBody(ar);
	if(ar.IsStoring()) {
		ar << (BYTE) m_mode;
		ar << (WORD) m_nFormat;
		ar << m_oldRct;
	} else {
		BYTE b;
		WORD w;
		ar >> b; m_mode = (mode) b;
		ar >> w; m_nFormat = w;
		ar >> m_oldRct;
	}
}

void CIElem::CopyBody(CViecFC *pelm)
{
	CIElem *pCp = (CIElem *) pelm;
	CPElem::CopyBody(pelm);
	pCp->m_pBody = (CGElem *) ((CViecFC *)m_pBody)->Copy();
}

void CIElem::SerializeBody(CArchive& ar)
{
	CPElem::SerializeBody(ar);
	if(ar.IsStoring()) {
		m_pBody->Serialize(ar);
	} else {
		CString head;
		ar >> head;
		m_pBody = (CGElem *) GetUnknownElem(ar, head);
	}
}

BOOL CIElem::OnCreated(EnumOnCreated bSkp)
{
	m_pBody->m_pInst = this;
	CPElem::OnCreated(bSkp);

	CViecFC *vw = m_pBody->GetParent();
	if(vw && vw->IsKindOf(RUNTIME_CLASS(CElemView)))
		return TRUE;
	CElemView *pView = GetNewView(GetName());
	if(pView==NULL) return FALSE;
	pView->AddTail(m_pBody);
	m_pBody->OnCreated();
	return TRUE;
}

CSElem::CSElem()
{
}

CIElem::CIElem()
{
	m_pBody = NULL;
}

///////////////////////////////////////////////////////////////////
////////////////////////  CRelationPipe ///////////////////////////
////////////////////////  CRelationPipe ///////////////////////////

BOOL CRelationPipe::SendMsg(int sig, CObject* sc)
{
	switch(sig) {
	case MSG_COLLECT_ALL_GARBAGE:
		CElmResSrv::s_pElmResSrv->GarbageEText(m_petName);
		break;
	}
	return TRUE;
}

CRelationPipe::~CRelationPipe()
{
}

///////////////////////////////////////////////////////////////////
///////////////////////////  CPElem ///////////////////////////////
///////////////////////////  CPElem ///////////////////////////////

CPElem::CPElem()
{
	m_bZoneFg = TRUE;
}

CPElem::~CPElem()
{
	while(m_rpInput.GetCount()>0)
		delete m_rpInput.RemoveHead();
	while(m_rpOutput.GetCount()>0)
		delete m_rpOutput.RemoveHead();
}

BOOL CPElem::OnCreated(EnumOnCreated bSkp)
{
	POSITION pos, pos0;
	CRelationPipe *pRp;
	CPElem *pp;
	CViecFC * psb;
	CString str;

	pos = m_rpInput.GetHeadPosition();
	while(pos) {
		pos0 = pos;
		pRp = (CRelationPipe *) m_rpInput.GetNext(pos);
		if(pRp->IsKindOf(RUNTIME_CLASS(CRelationPipe))) {
			if(pRp->m_pSymb && pRp->m_pSymb->IsKindOf(RUNTIME_CLASS(CViecFC))) {
				pRp->m_petName = GetNewTChar(pRp->m_pSymb->GetName(), pRp->m_petName);
			}
			if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)) && GetInstBody())
				pp = GetInstBody();
			else
				pp = (CPElem*) GetParent();
			str = pRp->GetName();
			if(pp && (psb=pp->GetElemByName(str)) ) {
				if(psb->IsKindOf(RUNTIME_CLASS(CGElem)) && psb->GetParent()
				&& psb->GetParent()->IsKindOf(RUNTIME_CLASS(CElemView))
				&& ((CGElem*)psb)->GetInstBody() )
					psb = ((CGElem*)psb)->GetInstBody();
				pRp->m_pSymb = psb;
			}
		}
	}

	pos = m_rpOutput.GetHeadPosition();
	while(pos) {
		pos0 = pos;
		pRp = (CRelationPipe *) m_rpOutput.GetNext(pos);
		if(pRp->IsKindOf(RUNTIME_CLASS(CRelationPipe))) {
			if(pRp->m_pSymb && pRp->m_pSymb->IsKindOf(RUNTIME_CLASS(CViecFC))) {
				pRp->m_petName = GetNewTChar(pRp->m_pSymb->GetName(), pRp->m_petName);
			}
			if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)) && GetInstBody())
				pp = GetInstBody();
			else
				pp = (CPElem*) GetParent();
			str = pRp->GetName();
			if(pp && (psb=pp->GetElemByName(str)) ) {
				if(psb->IsKindOf(RUNTIME_CLASS(CGElem)) && psb->GetParent()
				&& psb->GetParent()->IsKindOf(RUNTIME_CLASS(CElemView))
				&& ((CGElem*)psb)->GetInstBody() )
					psb = ((CGElem*)psb)->GetInstBody();
				pRp->m_pSymb = psb;
			}
		}
	}
	return CGElem::OnCreated(bSkp);
}

void CPElem::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF rgb;

	DrawFold3D(pdc, p);

	CPoint p0=p;
	p0.Offset(m_org);
	p0.Offset( m_RName.left, m_RName.top);
	CRect r0=m_extent;
	r0.OffsetRect(p0);
	if(m_mode==modeClose) {
		CRect r0=m_extent;
		r0.OffsetRect(m_org);
		r0.OffsetRect(p);
		CRect rD(r0.left+4, r0.top+4, r0.right-4, r0.bottom-4);
		SetPen(pdc, PS_SOLID, 2, RGB(100,100,255));
		pdc->MoveTo(r0.left+4, r0.top+4);
		pdc->LineTo(r0.right-4, r0.top+4);
		pdc->LineTo(r0.right-4, r0.bottom-4);
		pdc->LineTo(r0.left+4, r0.bottom-4);
		pdc->LineTo(r0.left+4, r0.top+4);
		if(m_bFocus) rgb = pdc->SetTextColor(RGB(0,0,200));
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		pdc->DrawText(GetName(), lstrlen(GetName()), &rD, GetFormat());
		SetOldGdiObject(pdc);
	}
	if(m_bDrag) {
		CRect r = GetExtent();
		r.OffsetRect(GetOrg());
		r.OffsetRect(p);
		CPoint dp = TheDrag.LastOffset();
		switch(m_zone) {
			case LeftTop:
				r.left += dp.x; r.top += dp.y;
				break;
			case RightTop:
				r.right += dp.x; r.top += dp.y;
				break;
			case RightBottom:
				r.right += dp.x; r.bottom += dp.y;
				break;
			case LeftBottom:
				r.left += dp.x; r.bottom += dp.y;
				break;
			default:
				r.OffsetRect(dp);
		}
		pdc->MoveTo(r.left, r.top);
		pdc->LineTo(r.right-1, r.top);
		pdc->LineTo(r.right-1, r.bottom-1);
		pdc->LineTo(r.left, r.bottom-1);
		pdc->LineTo(r.left, r.top);
	}

	if(m_mode!=modeClose) {
		OnDrawChild(pdc, p);
	}
}

void CPElem::AddInputPoint(CObject *ps)
{
	if(!m_bCreated) OnCreated();
	if(ps->IsKindOf(RUNTIME_CLASS(CViecFC))) {
		CViecFC *psym = (CViecFC*) ps;
		CRelationPipe *pRp = new CRelationPipe;
		pRp->m_petName = GetNewTChar(psym->GetName(), pRp->m_petName);
		pRp->m_pSymb = psym;
		m_rpInput.AddTail(pRp);
	}
}

void CPElem::AddOutputPoint(CObject *ps)
{
	if(!m_bCreated) OnCreated();
	if(ps->IsKindOf(RUNTIME_CLASS(CViecFC))) {
		CViecFC *psym = (CViecFC*) ps;
		CRelationPipe *pRp = new CRelationPipe;
		pRp->m_petName = GetNewTChar(psym->GetName(), pRp->m_petName);
		pRp->m_pSymb = psym;
		m_rpOutput.AddTail(pRp);
	}
}

CRelationPipe *CPElem::FindInputRel(CViecFC *pS)
{
//	if(!m_bCreated) OnCreated();
	CRelationPipe *rp;
	POSITION pos;
	pos = m_rpInput.GetHeadPosition();
	while(pos) {
		rp = (CRelationPipe *) m_rpInput.GetNext(pos);
		if(rp->m_pSymb==pS)
			return rp;
	}
	return NULL;
}

CRelationPipe *CPElem::FindOutputRel(CViecFC *pS)
{
//	if(!m_bCreated) OnCreated();
	CRelationPipe *rp;
	POSITION pos;
	pos = m_rpOutput.GetHeadPosition();
	while(pos) {
		rp = (CRelationPipe *) m_rpOutput.GetNext(pos);
		if(rp->m_pSymb==pS)
			return rp;
	}
	return NULL;
}

BOOL CPElem::SubstChild(CViecFC *pFrom, CViecFC *pTo, dirMode dir)
{
//	if(!m_bCreated) OnCreated();
	BOOL rt =CViecFC::SubstChild(pFrom, pTo, dir);
	CRelationPipe *rp;
	if(IsKindOf(RUNTIME_CLASS(CIElem))) {
		CIElem *pii = (CIElem*) this;
		if(pii->GetBody())
			pii->GetBody()->SubstChild(pFrom, pTo, dir);
	}
	if((rp = FindInputRel((CViecFC *)pFrom)))
		rp->m_pSymb = (CViecFC *) pTo;
	if((rp = FindOutputRel((CViecFC *)pFrom)))
		rp->m_pSymb = (CViecFC *) pTo;
	return TRUE;
}

void CPElem::CopyBody(CViecFC *pelm)
{
	CViecFC *psym;
	CRelationPipe *rp;
	CPElem *pCp = (CPElem *) pelm;
	CGElem::CopyBody(pelm);
	POSITION pos;
	pos = m_rpInput.GetHeadPosition();
	while(pos) {
		psym = (CViecFC *) m_rpInput.GetNext(pos);
		rp = new CRelationPipe(psym->GetName());
		pCp->m_rpInput.AddTail(rp);
	}
	pos = m_rpOutput.GetHeadPosition();
	while(pos) {
		psym = (CViecFC *) m_rpOutput.GetNext(pos);
		rp = new CRelationPipe(psym->GetName());
		pCp->m_rpOutput.AddTail(rp);
	}
}

void CPElem::SerializeBody(CArchive& ar)
{
	POSITION pos;
	PETCHAR ptnm;
	WORD nLen;
	CRelationPipe *rp;
	CGElem::SerializeBody(ar);
	if(ar.IsStoring()) {
		ar << (WORD) m_rpInput.GetCount();
		pos = m_rpInput.GetHeadPosition();
		while(pos) {
			rp = (CRelationPipe *) m_rpInput.GetNext(pos);
			if(rp->m_pSymb)
				ptnm = rp->m_pSymb->GetName();
			else
				ptnm = rp->GetName();
			nLen = ptnm? strlen(ptnm) : 0;
			ar << nLen;
			ar.Write(ptnm, nLen);
		}
		ar << (WORD) m_rpOutput.GetCount();
		pos = m_rpOutput.GetHeadPosition();
		while(pos) {
			rp = (CRelationPipe *) m_rpOutput.GetNext(pos);
			if(rp->m_pSymb)
				ptnm = rp->m_pSymb->GetName();
			else
				ptnm = rp->GetName();
			nLen = ptnm? strlen(ptnm) : 0;
			ar << nLen;
			ar.Write(ptnm, nLen);
		}
	} else {
		WORD no, i;
		CString str;

		ar >> no;
		for(i=0; i<no; i++) {
			ar >> nLen;
			ar.Read(str.GetBufferSetLength(nLen), nLen);
			m_rpInput.AddTail(new CRelationPipe(str));
		}
		ar >> no;
		for(i=0; i<no; i++) {
			ar >> nLen;
			ar.Read(str.GetBufferSetLength(nLen), nLen);
			m_rpOutput.AddTail(new CRelationPipe(str));
		}
	}
}

int CPElem::OnFocus(CPoint &p)
{
	int rt = CGElem::OnFocus(p);
	if(rt && !m_focus) {
		CPoint p0 = p;
		p0.Offset(-m_org);
		CRect &r = m_extent;
		CRect r0;
		
		const int wd = 6;

		m_zone = InSideRect;
		if(!m_bZoneFg)
			return rt;
		r0 = CRect(r.left, r.top, r.left+wd, r.top+wd);
		if( r0.PtInRect(p0) ) m_zone = LeftTop;
		else {
			r0 = CRect(r.right-wd, r.top, r.right, r.top+wd);
			if( r0.PtInRect(p0) ) m_zone = RightTop;
			else {
				r0 = CRect(r.right-wd, r.bottom-wd, r.right, r.bottom);
				if( r0.PtInRect(p0) ) m_zone = RightBottom;
				else {
					r0 = CRect(r.left, r.bottom-wd, r.left+wd, r.bottom);
					if( r0.PtInRect(p0) ) m_zone = LeftBottom;
					else {
						if(r.top<=p0.y && p0.y<=r.top+wd) m_zone = TopSide;
						else {
							if(r.bottom-wd<=p0.y && p0.y<=r.bottom) m_zone = BottomSide;
							else {
								if(r.left<=p0.x && p0.x<=r.left+wd) m_zone = LeftSide;
								else {
									if(r.right-wd<=p0.x && p0.x<=r.right) m_zone = RightSide;
								}
							}
						}
					}
				}
			}
		}
	}
	return rt;
}

int CPElem::OnDrag(const CPoint& old, const CPoint& last)
{
	if(!m_bFocus) return 0;

	CPoint p0 = old;
	CPoint p1 = last;
	p0.Offset(m_org);
	p1.Offset(m_org);

	if(!m_focus && m_bDragAllow) {
		if(m_bDrag) {
			switch(m_zone) {
				case LeftTop:
					InvalidateRectBd(CPoint(0,0), CRect(old.x, old.y, 0,0));
					break;
				case RightTop:
					InvalidateRectBd(CPoint(0,0), CRect(0, old.y, old.x, 0));
					break;
				case RightBottom:
					InvalidateRectBd(CPoint(0,0), CRect(0,0,old.x, old.y));
					break;
				case LeftBottom:
					InvalidateRectBd(CPoint(0,0), CRect(old.x, 0, 0, old.y));
					break;
				case LeftSide:
					InvalidateRectBd(CPoint(0,0), CRect(old.x, 0, 0, 0));
					break;
				case RightSide:
					InvalidateRectBd(CPoint(0,0), CRect(0, 0, old.x, 0));
					break;
				case TopSide:
					InvalidateRectBd(CPoint(0,0), CRect(0, old.y, 0, 0));
					break;
				case BottomSide:
					InvalidateRectBd(CPoint(0,0), CRect(0, 0, 0, old.y));
					break;
				default:
					InvalidateRectBd(old);
			}
		} else m_bDrag = TRUE;
		switch(m_zone) {
			case LeftTop:
				InvalidateRectBd(CPoint(0,0), CRect(last.x, last.y, 0,0));
				break;
			case RightTop:
				InvalidateRectBd(CPoint(0,0), CRect(0, last.y, last.x, 0));
				break;
			case RightBottom:
				InvalidateRectBd(CPoint(0,0), CRect(0,0, last.x, last.y));
				break;
			case LeftBottom:
				InvalidateRectBd(CPoint(0,0), CRect(last.x, 0, 0, last.y));
				break;
			case LeftSide:
				InvalidateRectBd(CPoint(0,0), CRect(last.x, 0, 0, 0));
				break;
			case RightSide:
				InvalidateRectBd(CPoint(0,0), CRect(0, 0, last.x, 0));
				break;
			case TopSide:
				InvalidateRectBd(CPoint(0,0), CRect(0, last.y, 0, 0));
				break;
			case BottomSide:
				InvalidateRectBd(CPoint(0,0), CRect(0, 0, 0, last.y));
				break;
			default:
				InvalidateRectBd(old);
		}
		return 1;
	}

	POSITION pos = GetHeadPosition();
	CViecFC *pelem;
	if(!m_bEncap) {
		while(pos) {
			pelem = GetNext(pos);
			pelem->OnDrag(old, last);
		}
	}
	return 1;
}

int CPElem::OnDrop(const CPoint& p)
{
	if(m_bDrag) {
		InvalidateRect(CPoint(0,0));
		switch(m_zone) {
			case LeftTop:
				m_extent.left += p.x;
				m_extent.top += p.y;
				break;
			case RightTop:
				m_extent.right += p.x;
				m_extent.top += p.y;
				break;
			case RightBottom:
				m_extent.right += p.x;
				m_extent.bottom += p.y;
				break;
			case LeftBottom:
				m_extent.left += p.x;
				m_extent.bottom += p.y;
				break;
			case LeftSide:
				m_extent.left += p.x;
				break;
			case RightSide:
				m_extent.right += p.x;
				break;
			case TopSide:
				m_extent.top += p.y;
				break;
			case BottomSide:
				m_extent.bottom += p.y;
				break;
			default:
				m_org.Offset(p);
		}
		if(m_parent) m_parent->CalcExt(dirUp);
		InvalidateRect(CPoint(0,0));
		m_bDrag = FALSE;
		return 1;
	} else {
		int rt=0;
		if(!m_bEncap) {
			POSITION pos = GetHeadPosition();
			while(pos) {
				CViecFC* pelem = GetNext(pos);
				rt=pelem->OnDrop(p);
			}
		}
		return rt;
	}
}

BOOL CPElem::OnDelete(CViecFC *el)
{
	BOOL rt = FALSE;
	POSITION pos,pos0;
	CRelationPipe *rp;
		
	if(!m_bCreated) OnCreated(); //for access check
	pos = m_rpInput.GetHeadPosition();
	while(pos) {
		pos0 = pos;
		rp = (CRelationPipe *) m_rpInput.GetNext(pos);
		if(rp->m_pSymb==el)
			m_rpInput.RemoveAt(pos0);
	}
	pos = m_rpOutput.GetHeadPosition();
	while(pos) {
		pos0 = pos;
		rp = (CRelationPipe *) m_rpOutput.GetNext(pos);
		if(rp->m_pSymb==el)
			m_rpOutput.RemoveAt(pos0);
	}
	CGElem::OnDelete(el);
	return TRUE;
}

CViecFC * CPElem::GetInputChild(int no)
{
	if(!m_bCreated) OnCreated();
	if(no>(GetInputCount()-1)) return NULL;
	POSITION pos = m_rpInput.FindIndex(no);
	if(pos==NULL) return NULL;
	return ((CRelationPipe *) m_rpInput.GetAt(pos))->m_pSymb;
}

CViecFC * CPElem::GetOutputChild(int no)
{
	if(!m_bCreated) OnCreated();
	if(no>(GetOutputCount()-1)) return NULL;
	POSITION pos = m_rpOutput.FindIndex(no);
	if(pos==NULL) return NULL;
	return ((CRelationPipe *) m_rpOutput.GetAt(pos))->m_pSymb;
}

///////////////////////////  CIElem ///////////////////////////////
///////////////////////////  CIElem ///////////////////////////////

int CIElem::CalcExt(dirMode dir)
{
	if(dir==dirUp) return CPElem::CalcExt(dir);
	if(m_pBody) m_pBody->CalcExt(dir);
	return CPElem::CalcExt(dir);
}

BOOL CViecFC::OnDelete(CViecFC *elm)
{
	CViecFC *pelm;
	BOOL bChanged = FALSE;
	BOOL rt = FALSE;
	POSITION pos0;
	POSITION pos = GetHeadPosition();

	if(elm==m_focus) {
		m_focus = NULL;
		bChanged = TRUE;
	}
	while(pos) {
		pos0 = pos;
		pelm = GetNext(pos);
		if(pelm==elm) {
			m_child.RemoveAt(pos0);
			bChanged = TRUE;
		} else {
			if(pelm->OnDelete(elm))
				rt = TRUE;
		}
	}
	if(bChanged) {
		if(CalcExt(dirUp))
			InvalidateRect(CPoint(0,0));
		rt = TRUE;
	}
	return rt;
}

BOOL CViecFC::SendMsgToChild(int qst, CObject *el)
{
	BOOL rt = FALSE;
	POSITION pos = GetHeadPosition();
	while(pos) {
		if(GetNext(pos)->SendMsg(qst, el))
			rt = TRUE;
	}
	return rt;
}

BOOL CGElem::SendMsg(int msg, CObject* obj)
{
	switch(msg) {
	case MSG_ADD_MENU_FOR_CHILD:
	case MSG_COMMAND_FOR_CHILD:
	case MSG_CAN_THIS_DISAPPEAR:
	case MSG_INCLUDE_CHILD_IN_MATH_TABLE:
		if(m_pInst!=NULL && GetParent() && GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
			return m_pInst->SendMsg(msg, obj);
		break;
	}
	return CViecFC::SendMsg(msg, obj);
}

BOOL CPElem::SendMsg(int msg, CObject* obj)
{
	SendMsgToRePipe(msg, obj);
	return CGElem::SendMsg(msg, obj);
}

BOOL CPElem::SendMsgToRePipe(int qst, CObject *el)
{
	int cnt,i;
	cnt = GetInputCount();
	if(cnt)
		i=10;
	POSITION pos;
	CRelationPipe *pRp;
	pos = m_rpInput.GetHeadPosition();
	while(pos) {
		pRp = (CRelationPipe *) m_rpInput.GetNext(pos);
		pRp->SendMsg(qst, el);
	}
	pos = m_rpOutput.GetHeadPosition();
	while(pos) {
		pRp = (CRelationPipe *) m_rpOutput.GetNext(pos);
		pRp->SendMsg(qst, el);
	}
	return FALSE;
}

CPoint CViecFC::GetMenuPoint(CPoint *pp)
{
	CPoint p0;
	CRect r0,r;
	CElemView *panc = (CElemView *) GetView();
	panc->m_pView->GetWindowRect(&r0);
	if(pp==NULL) {
		CPoint p(r0.left, r0.top);
		p.Offset(- panc->m_pView->GetScrollPosition());
		GetRectG(r);
		r.OffsetRect(p);
		p0 = CPoint(r.right, r.bottom);
	} else {
		p0 = *pp;
		p0.Offset(r0.left, r0.top);
	}
	return p0;
}

CMenu *CViecFC::GetPopupMenu(BOOL fg)
{
	CMenu *menu;
	if(fg) {
		while(CElmResSrv::s_pElmResSrv->m_Menu.GetCount()>0) {
			menu = (CMenu*) CElmResSrv::s_pElmResSrv->m_Menu.RemoveTail();
			menu->DestroyMenu();
			delete menu;
		}
	}
	menu = new CMenu;
	CElmResSrv::s_pElmResSrv->m_Menu.AddTail(menu);
	menu->CreatePopupMenu();
	return menu;
}

BOOL CGElem::OnCreated(EnumOnCreated bSkp)
{
	CSuitCase SC;
	if(bSkp==SKIP_IF_ALLOWED)
		if(SendMsg(MSG_CAN_SKIP_ONCREATED_PROC, &SC))
			if(SC.m_int)
				return TRUE;
	m_bCreated = TRUE;
	return CViecFC::OnCreated(bSkp);
}

BOOL CViecFC::TrackPopupMenu(CMenu* pMenu, CPoint p0)
{
	CElemView *panc = (CElemView *) GetView();
	if(!panc) return FALSE;
	return pMenu->TrackPopupMenu(
		TPM_RIGHTBUTTON | TPM_LEFTBUTTON, p0.x, p0.y, panc->m_pView, NULL);
}

CArchive *CViecFC::OpenFile(const char *filename, modeFile mode)
{
	switch(mode) {
		case modeRead:
			m_pFile = new CFile;
			m_pFile->Open(filename,
			   CFile::modeRead | CFile::shareDenyWrite);
			m_pArc = new CArchive(m_pFile,
				CArchive::load | CArchive::bNoFlushOnDelete);
			return m_pArc;
		case modeWrite:
			m_pFile = new CFile;
			m_pFile->Open(filename,
				 CFile::modeCreate | CFile::modeReadWrite
   				| CFile::shareExclusive);
			m_pArc = new CArchive(m_pFile,
			    CArchive::store | CArchive::bNoFlushOnDelete);
   			return m_pArc;
		default:
			;
	}
	return NULL;
}

void CViecFC::CloseFile()
{
	if(m_pArc==NULL) return;
	m_pArc->Close();
	delete m_pArc;

	m_pFile->Close();
	delete m_pFile;

	m_pArc = NULL;
	m_pFile = NULL;
}

int CViecFC::SendCmdQ(int msg)
{
	return CElmResSrv::s_pElmResSrv->m_pView->SendMessage(MSG_VIEW_ON_COMMAND_TO_ELEM, msg, (long) this);
}

BOOL CViecFC::PostCmdQ(int msg)
{
	return CElmResSrv::s_pElmResSrv->m_pView->PostMessage(MSG_VIEW_ON_COMMAND_TO_ELEM, msg, (long) this);
}

BOOL CIElem::OnDelete(CViecFC *delm)
{
	CViecFC *pelm;
	if((pelm=GetBody())!=NULL) {
		return pelm->OnDelete(delm);
	}
	return FALSE;
}

int CMSInteger::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	switch(nChar) {
	case VK_UP:
		m_value += 1;
		CalcExt();
		InvalidateRect(CPoint(0,0));
		return TRUE;
	case VK_DOWN:
		m_value -= 1;
		CalcExt();
		InvalidateRect(CPoint(0,0));
		return TRUE;
	}
	return CMSNumber::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CMSInteger::CopyBody(CViecFC *pelm)
{
	CMSNumber::CopyBody(pelm);
	CMSInteger *pCp = (CMSInteger *) pelm;
	pCp->m_value = m_value;
}

void CMSInteger::SerializeBody(CArchive& ar)
{
	CMSNumber::SerializeBody(ar);
	if(ar.IsStoring()) {
		ar << (DWORD) m_value;
	} else {
		DWORD u;
		ar >> u;
		m_value = u;
	}
}

CViecFC * CViecFC::GetChild(int no)
{
	if(no>(GetCount()-1)) return NULL;	   //check the map elements if "no"th element can be extracted
	POSITION pos = m_child.FindIndex(no);
	if(pos==NULL) return NULL;
	return (CViecFC *) m_child.GetAt(pos);	//GetAt(pos) (pos)th element is extracted in TCHAR(character)
}

POSITION CViecFC::AddHead(CViecFC *e)
{
	if(!e) return NULL;
	e->SetParent(this);
	return m_child.AddHead(e);
}

