#ifndef __ELEM_H__
#define __ELEM_H__

#define ADD_ELEM_TO_COLLECTOR(className) { \
	CRuntimeClass *rtc = &className::class##className;\
	TheElemCollector.m_member[rtc->m_lpszClassName]= rtc;	}

#define ADD_ELEM_TO_DEFAULT_SYMBOL(c, className) { \
	CRuntimeClass *rtc = &className::class##className;\
	s_TheDefaultSymbols[c]= rtc;		}

//////////////////////////////////////////////////////////////////////////
#define DECLARE_ELEM(className) \
	DECLARE_SERIAL(className) \
	void *className::operator new(size_t nSize) \
		{ return _CHM_NewElem(RUNTIME_CLASS(className), nSize); } \
	void className::operator delete(void *p) \
		{ _CHM_DeleteElem(RUNTIME_CLASS(className), p);  } \
	void *className::operator new(size_t, void *p) \
		{  return p;  }

#define IMPLEMENT_ELEM(className, baseClass, wSchema) \
	IMPLEMENT_SERIAL(className, baseClass, _CHM_AddElemToCol(&className::class##className, wSchema))

#define DECLARE_ELEM_FREE(className) \
	DECLARE_DYNCREATE(className) \
	void *className::operator new(size_t nSize) \
		{ return CObject::operator new(nSize); } \
	void className::operator delete(void *p) \
		{ CObject::operator delete(p); } \
	void *className::operator new(size_t, void *p) \
		{  return p;  }

#define IMPLEMENT_ELEM_FREE(className, baseClass) \
	IMPLEMENT_DYNCREATE(className, baseClass)

inline void* _CHM_NewElem(CRuntimeClass *rtc, size_t nSize);
inline void _CHM_DeleteElem(CRuntimeClass *rtc, void *p);

//////////////////////////////////////////////////////////////////////////

#define MSG_TYPE_1	0x1000
#define CMD_TYPE_1	0x2000
#define CMD_UNKNOWN	0x3000
#define CMD_USERDEF	0x4000
#define CMD_VIEW	(WM_USER + 1)

#define MSG_VIEW_ON_COMMAND_TO_ELEM	(CMD_VIEW + 0x0001)

#define MSG_ADD_MENU	MSG_TYPE_1 | 0x0001
#define MSG_COMMAND		MSG_TYPE_1 | 0x0002
#define MSG_COLLECT_OBJECT	MSG_TYPE_1 | 0x0003
#define MSG_CAN_THIS_DISAPPEAR	MSG_TYPE_1 | 0x0004
#define MSG_SET_FOCUS_OFF	MSG_TYPE_1 | 0x0005
#define MSG_CAN_THIS_CHILD_DISAPPEAR	MSG_TYPE_1 | 0x0006
#define MSG_SUBSTITUTE_THE_TWO	MSG_TYPE_1 | 0x0007
#define MSG_RECALC_ALL_VIEW	MSG_TYPE_1 | 0x0008
#define MSG_ON_DELETE	MSG_TYPE_1 | 0x0009
#define MSG_DO_JOB		MSG_TYPE_1 | 0x000A
#define MSG_INCLUDE_CHILD_IN_MATH_TABLE	MSG_TYPE_1 | 0x000B
#define MSG_CAN_SKIP_ONCREATED_PROC	MSG_TYPE_1 | 0x000C
#define MSG_COLLECT_KINDOF_OBJECT	MSG_TYPE_1 | 0x0020

#define CMD_SPLIT		CMD_TYPE_1 | 0x0001
#define CMD_GO_BACK		CMD_TYPE_1 | 0x0002
#define CMD_FOCUS_TO	CMD_TYPE_1 | 0x0003
#define CMD_OPEN		CMD_TYPE_1 | 0x0004
#define CMD_CLOSE		CMD_TYPE_1 | 0x0005
#define CMD_CHANG_NAME	CMD_TYPE_1 | 0x0006
#define CMD_RECAL_SIZE	CMD_TYPE_1 | 0x0007
#define CMD_ADD_COMMENT	CMD_TYPE_1 | 0x0008
#define CMD_ADD_DELETE	CMD_TYPE_1 | 0x0009

#define CMD_ADD_TAIL_AN_UNKNOWN	CMD_TYPE_1 | 0x000A
#define CMD_INSERT_AN_UNKNOWN	CMD_TYPE_1 | 0x000B

#define CMD_AN_UNKNOWN_TO_PLUS	CMD_UNKNOWN | 0x0001
#define CMD_AN_UNKNOWN_TO_MINUS	CMD_UNKNOWN | 0x0002
#define CMD_AN_UNKNOWN_TO_MULT	CMD_UNKNOWN | 0x0003
#define CMD_AN_UNKNOWN_TO_NEG	CMD_UNKNOWN | 0x0004
#define CMD_AN_UNKNOWN_TO_DIV	CMD_UNKNOWN | 0x0005
#define CMD_AN_UNKNOWN_TO_DERIV	CMD_UNKNOWN | 0x0006

#define CMD_AN_UNKNOWN_TO_EQUAL	CMD_UNKNOWN | 0x0007
#define CMD_AN_UNKNOWN_TO_GT	CMD_UNKNOWN | 0x0008
#define CMD_AN_UNKNOWN_TO_LT	CMD_UNKNOWN | 0x0009
#define CMD_AN_UNKNOWN_TO_GE	CMD_UNKNOWN | 0x000A
#define CMD_AN_UNKNOWN_TO_LE	CMD_UNKNOWN | 0x000B

#define CMD_AN_UNKNOWN_TO_IND_X	CMD_UNKNOWN | 0x000C
#define CMD_AN_UNKNOWN_TO_IND_Y	CMD_UNKNOWN | 0x000D
#define CMD_AN_UNKNOWN_TO_IND_Z	CMD_UNKNOWN | 0x000E
#define CMD_AN_UNKNOWN_TO_IND_T	CMD_UNKNOWN | 0x000F
#define CMD_AN_UNKNOWN_TO_INT	CMD_UNKNOWN | 0x0010

#define CMD_AN_UNKNOWN_TO_IND_DX	CMD_UNKNOWN | 0x0011
#define CMD_AN_UNKNOWN_TO_IND_DY	CMD_UNKNOWN | 0x0012
#define CMD_AN_UNKNOWN_TO_IND_DZ	CMD_UNKNOWN | 0x0013
#define CMD_AN_UNKNOWN_TO_IND_DT	CMD_UNKNOWN | 0x0014

#define CMD_AN_UNKNOWN_TO_IND_I	CMD_UNKNOWN | 0x0015
#define CMD_AN_UNKNOWN_TO_IND_J	CMD_UNKNOWN | 0x0016
#define CMD_AN_UNKNOWN_TO_IND_K	CMD_UNKNOWN | 0x0017
#define CMD_AN_UNKNOWN_TO_IND_N	CMD_UNKNOWN | 0x0018

#define CMD_CHANGE_TO_UNKNOWN	CMD_UNKNOWN | 0x0019

#define CMD_AN_UNKNOWN_TO_USERDEF	CMD_USERDEF

#define CMD_LOAD_OBJECT		CMD_TYPE_1 | 0x000C
#define CMD_SAVE_OBJECT 	CMD_TYPE_1 | 0x000D
#define CMD_NOT_FIND_FST	CMD_TYPE_1 | 0x000E
#define CMD_SET_FIND_FST	CMD_TYPE_1 | 0x000F

#define CMD_COVERED_BY_NEG	CMD_TYPE_1 | 0x0010
#define CMD_COVERED_BY_PLUS	CMD_TYPE_1 | 0x0011
#define CMD_COVERED_BY_MULT	CMD_TYPE_1 | 0x0012
#define CMD_COVERED_BY_DIV	CMD_TYPE_1 | 0x0013
#define CMD_COVERED_BY_DERIV	CMD_TYPE_1 | 0x0014

#define CMD_COVERED_BY_EQUAL	CMD_TYPE_1 | 0x0015
#define CMD_COVERED_BY_LT		CMD_TYPE_1 | 0x0016
#define CMD_COVERED_BY_GT		CMD_TYPE_1 | 0x0017
#define CMD_COVERED_BY_LE		CMD_TYPE_1 | 0x0018
#define CMD_COVERED_BY_GE		CMD_TYPE_1 | 0x0019
#define CMD_COVERED_BY_ABS		CMD_TYPE_1 | 0x001A
#define CMD_CHM_TREE_REPORT		CMD_TYPE_1 | 0x001B // CHM 1999.02.02 tree report
#define CMD_LOAD_OBJECT_COM		CMD_TYPE_1 | 0x001C // CHM 1999.02.03
#define CMD_LOAD_PDE_PROB_INFO	CMD_TYPE_1 | 0x001D // CHM 1999.02.04
#define CMD_LOAD_PDE_MESH_INFO	CMD_TYPE_1 | 0x001E // CHM 1999.02.04
#define CMD_LOAD_PDE_TIME_INFO	CMD_TYPE_1 | 0x001F // CHM 1999.02.04
#define CMD_LOAD_PDE_DEP_INFO	CMD_TYPE_1 | 0x0020 // CHM 1999.02.04
#define CMD_LOAD_PDE_PARA_INFO	CMD_TYPE_1 | 0x0021 // fujita 1999.06.03 Parameter informatin set
#define CMD_LOAD_PDE_DEP_DEL    CMD_TYPE_1 | 0x0022 // fujita 1999.06.03 Dependent variable delete
#define CMD_LOAD_PDE_SLV_SET    CMD_TYPE_1 | 0x0023 // fujita 1999.06.07 PDE set

#define MSG_ADD_MENU_FOR_CHILD	MSG_TYPE_1 | 0x000D
#define MSG_COMMAND_FOR_CHILD	MSG_TYPE_1 | 0x000E
#define MSG_COLLECT_ALL_GARBAGE	MSG_TYPE_1 | 0x000F
#define MSG_CHANG_NAME			MSG_TYPE_1 | 0x0010


#pragma warning(disable: 4275)
#pragma warning(disable: 4251)

#define NODE_NUM_IN_PLEX 10

enum EnumOnCreated {
	DO_ALL,
	SKIP_IF_CREATED,
	SKIP_IF_ALLOWED
};

struct CENode
{
	CENode* pNext;
	CENode* pPrev;
	CObject* data;
};

struct CEPlexOfNode    // warning variable length structure
{
	CEPlexOfNode* pNext;
	UINT nCur;

	void* data() { return this+1; }
	static CEPlexOfNode* PASCAL Create(CEPlexOfNode*& head);
	void FreeDataChain();       // free this one and links
};

class AFX_EXT_CLASS CViecFCList : public CObject
{

	DECLARE_SERIAL(CViecFCList)

protected:
public:

	CViecFCList(int nBlockSize = 10);

	int GetCount() const;
	BOOL IsEmpty() const;
	CObject*& GetHead();
	CObject* GetHead() const;
	CObject*& GetTail();
	CObject* GetTail() const;
	CObject* RemoveHead();
	CObject* RemoveTail();
	POSITION AddHead(CObject* newElement);
	POSITION AddTail(CObject* newElement);
	void AddHead(CViecFCList* pNewList);
	void AddTail(CViecFCList* pNewList);
	void RemoveAll();

	// iteration
	POSITION GetHeadPosition() const;
	POSITION GetTailPosition() const;
	CObject*& GetNext(POSITION& rPosition); // return *Position++
	CObject* GetNext(POSITION& rPosition) const; // return *Position++
	CObject*& GetPrev(POSITION& rPosition); // return *Position--
	CObject* GetPrev(POSITION& rPosition) const; // return *Position--

	// getting/modifying an element at a given position
	CObject*& GetAt(POSITION position);
	CObject* GetAt(POSITION position) const;
	void SetAt(POSITION pos, CObject* newElement);
	void RemoveAt(POSITION position);

	// inserting before or after a given position
	POSITION InsertBefore(POSITION position, CObject* newElement);
	POSITION InsertAfter(POSITION position, CObject* newElement);

	// helper functions (note: O(n) speed)
	POSITION Find(CObject* searchValue, POSITION startAfter = NULL) const;
						// defaults to starting at the HEAD
						// return NULL if not found
	POSITION FindIndex(int nIndex) const;
						// get the 'nIndex'th element (may return NULL)

// Implementation
protected:
	CENode* m_pNodeHead;
	CENode* m_pNodeTail;
	int m_nCount;
	CENode* m_pNodeFree;
	struct CEPlexOfNode* m_pBlocks;
	int m_nBlockSize;

	CENode* NewNode(CENode*, CENode*);
	void FreeNode(CENode*);

public:
	~CViecFCList();

	void Serialize(CArchive&);
#ifdef _DEBUG
	void Dump(CDumpContext&) const;
	void AssertValid() const;
#endif
};

class AFX_EXT_CLASS CViecFC;
//class AFX_EXT_CLASS CElemCtn;
class AFX_EXT_CLASS CElemView;
class AFX_EXT_CLASS CSymbInst;
//class AFX_EXT_CLASS CViecFC;
class AFX_EXT_CLASS CElmResSrv;

class AFX_EXT_CLASS CElemCollect {
public:
	CMapStringToPtr m_member;
	CViecFC* GetNewUnknownElem(CArchive& ar, const char *);
};

///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////

typedef const TCHAR * PETCHAR;

typedef struct _CEText {
	BYTE code;
	BYTE bLen;
	char data[1];
//	WORD wLen;
//	DWORD dwLen;
	operator PETCHAR();
	size_t GetLength();
} CEText;

inline CEText::operator PETCHAR()
	{ return (PETCHAR) ((BYTE*)this + 2); }

inline size_t CEText::GetLength()
	{ return bLen; }

class AFX_EXT_CLASS CViecFC : public CObject {
protected:
	CEText *m_petName;
	CEText *m_petFont;
	BYTE m_nDot, m_nCharSet, m_nItalic;
	BYTE m_bFindFirst;

	DECLARE_ELEM(CViecFC)

	BOOL /*m_bSelected,*/ m_bFocus
	   , m_bDrag, m_bDragAllow;
	CRect m_extent;
	CPoint m_org;
	CViecFC *m_parent;
	CViecFC *m_focus;
	CViecFCList m_child;
	BOOL m_bEncap;

	CPoint t_point;
	CFile *m_pFile;
	CArchive *m_pArc;

public:
	static int s_nDot;

	enum dirMode { dirNot=0, dirUp=-1, dirDown=1 };
	enum modeFile { modeRead=1, modeWrite };

	static CMultiDocTemplate *pElemTemp;
	static int m_id;

	CViecFC(CViecFC *parent = NULL);
	virtual ~CViecFC();

	virtual int OnFocus(CPoint &p);
	virtual int OnRun();
	virtual int OnAccess(CPoint *p = NULL);
	virtual int OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	virtual int OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	virtual int OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	virtual int OnDrag(const CPoint& old, const CPoint& last);
	virtual int OnDrop(const CPoint& last);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual void OnDrawBody(CDC *pdc, const CPoint& p);
	virtual void OnDrawDrag(CDC *pdc, const CPoint& p);
	virtual void OnDrawFocus(CDC *pdc, const CPoint& p);
	virtual int OnCommand(UINT id);
	virtual BOOL IsInside(CViecFC *pel);

	virtual const CRect& GetExtent();
	virtual const CPoint& GetOrg();
	virtual CRect GetRect();
	virtual void GetRectG(CRect& rr);
	virtual CSize GetSize();
	virtual CViecFC* GetFocus();
	virtual void SetFocus(BOOL b) { m_bFocus=b; }
	virtual CViecFC* GetParent();
	virtual BOOL SubstChild(CViecFC *pFrom, CViecFC *pTo, dirMode dir=dirUp);

	virtual int CalcExt(dirMode d=dirUp);
	virtual void Serialize(CArchive& ar);
	virtual void SerializeBody(CArchive& ar);
	virtual BOOL OnDelete(CViecFC *);
	virtual BOOL SendMsg(int, CObject*);

	virtual CViecFC* GetUnknownElem(CArchive& ar, const char *);
	virtual CElemView *GetNewView(PETCHAR );
	virtual POSITION AddTail(CViecFC *);
	virtual POSITION AddHead(CViecFC *);
	virtual CViecFC *Copy();
	virtual void CopyBody(CViecFC *);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual CRect ToCalcExt(CSymbInst*, dirMode d=dirUp) { return CRect(0,0,0,0); }
	virtual void ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift) { return; };
	virtual PETCHAR GetDrawName();
	virtual void OnDrawChild(CDC *pdc, const CPoint& p);

	virtual void SetName(PETCHAR name, BYTE nDot, BYTE nCharSet);
	virtual void SetName(PETCHAR name);
	virtual PETCHAR GetName();
	virtual PETCHAR GetFont();
	size_t GetNameLen();
	size_t GetFontLen();

	CViecFC * GetChild(int no);
	CViecFC *GetElemByName(const char *, dirMode dir=dirUp, CViecFC* pfrom=NULL);
	BOOL GetFindFirst() { return m_bFindFirst; }
	void SetFindFirst(BOOL b) { m_bFindFirst = b; }

	void SetFocusChild(CViecFC *fc) { m_focus = fc; };
	void CopyChild(CViecFC *);
	int GetCount();
	POSITION GetHeadPosition();
	BOOL SendMsgToChild(int, CObject*);
	CViecFC *GetNext(POSITION&);
	POSITION FindIndex(int ind) { return m_child.FindIndex(ind); }
	CViecFC *GetAt(POSITION pos) { return (CViecFC*) m_child.GetAt(pos); }
	void SerialChild(CArchive& ar);

	CViecFC *RemoveHead() { return (CViecFC*) m_child.RemoveHead(); }
	CViecFC *RemoveTail() { return (CViecFC*) m_child.RemoveTail(); }
	void RemoveAll() { m_child.RemoveAll(); }

	int Release();
	void InvalidateRect(const CPoint&);
	void InvalidateRectBd(const CPoint& point, const CRect& rb = CRect(0,0,0,0), int wd=2);
	CDC* GetDC();
	int ReleaseDC(CDC*);
	int SetFont(CDC *pdc, int dot, PETCHAR name, BYTE nCharSet, BYTE nItalic=TRUE, int wd=0);
	int SetPen(CDC *pdc, int nPenStyle, int nWidth, COLORREF crColor);
	int SetBrush(CDC *pdc, COLORREF crColor);
	void SetOldGdiObject(CDC *pdc);
	CViecFC* GetView();
	CViecFC* GetAncestor();
	int SendCmdQ(int cmd);
	BOOL PostCmdQ(int cmd);

	CEText *GetNewTChar(PETCHAR pch, CEText *old);
	BOOL FocusToView(CViecFC *pel);
	void DrawFold3D(CDC *pdc, const CPoint& p, int mode = 0);
	int GetId() { return m_id; }
	void SetId(int id) { m_id = id; }
	int SetExtent(const CRect& r);
	int SetOrg(const CPoint& p);
	void SetParent(CViecFC *);
	void SetDragAllow(BOOL);
	BOOL GetDragAllow();

	CPoint GetMenuPoint(CPoint *);
	CMenu *GetPopupMenu(BOOL fg=TRUE);
	BOOL TrackPopupMenu(CMenu*, CPoint p0);
	CArchive *OpenFile(const char*, modeFile);
	void CloseFile();
	void DrawArrow(CDC *pdc, const CPoint& p1, const CPoint& p2);

	CRect GetTextExtent(CDC *pdc, const char *pch, size_t nSize);
	void UnionExtent(CRect& dest, CRect& src);
	void TextOut(CDC *pdc, int x, int y, const char *pch, size_t len);
	void CalcExtPost(dirMode dir, const CRect& extent);
	void SelectStockObject(CDC *pdc, int nIdx);
	void SetTextColor(CDC *pdc, DWORD col);
	void EtchingRect(CRect& rct, CRect& eth);
	CViecFC *GetBaseElem(CRuntimeClass *);
	CViecFC *GetChildElem(CRuntimeClass *);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

};

class AFX_EXT_CLASS CRelationPipe : public CViecFC {
	DECLARE_ELEM(CRelationPipe);
public:
	CEText *m_petName;
	CViecFC *m_pSymb;
	CRelationPipe(PETCHAR nm = NULL);
	virtual BOOL SendMsg(int, CObject*);
	virtual ~CRelationPipe();
	PETCHAR GetName() { return *m_petName; };
	size_t GetNameLen() { return m_petName->GetLength(); };
};

//////////////////////////////////////////////////////////////////////
// CViecFC clas
//
class AFX_EXT_CLASS CMathSymb : public CViecFC {
protected:
	DECLARE_ELEM(CMathSymb)
	BYTE m_dimension[4]; // 0,1,2,3

public:
	virtual SetDimension(BYTE dim0, BYTE dim1, BYTE dim2, BYTE dim3);
	virtual int CalcExt(dirMode d=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual CRect ToCalcExt(CSymbInst*, dirMode d=dirUp);
	virtual void ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift);
	int GetnDot(int level, int dot);
	int GetSpc(int level);
	virtual int OnCommand(UINT id);
};

class AFX_EXT_CLASS CMSUnknown : public CMathSymb {
protected:
	DECLARE_ELEM(CMSUnknown)
	virtual BOOL SendMsg(int, CObject*);
};

class AFX_EXT_CLASS CMSIndep : public CMathSymb {
protected:
	DECLARE_ELEM(CMSIndep)
};

class AFX_EXT_CLASS CMSPhys : public CMathSymb {
protected:
	DECLARE_ELEM(CMSPhys)
};

class AFX_EXT_CLASS CMSDep : public CMSPhys {
protected:
	DECLARE_ELEM(CMSDep)
};

class AFX_EXT_CLASS CMSIndex : public CMathSymb {
protected:
	DECLARE_ELEM(CMSIndex)
};

//Add class by Fujita 990614
class AFX_EXT_CLASS CMSArg : public CMSIndex {
protected:
	DECLARE_ELEM(CMSArg)
};

//char^̕ϐ錾i|C^[^**j
class AFX_EXT_CLASS CMSChar : public CMathSymb {
//protected:
	DECLARE_ELEM(CMSChar)
public:
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};

//char^̕ϐ錾i|C^[^*j
class AFX_EXT_CLASS CMSChar_One : public CMathSymb {
//protected:
	DECLARE_ELEM(CMSChar_One)
public:
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};



class AFX_EXT_CLASS CMSNumber : public CMathSymb {
public:
	virtual BOOL IsNeg() { return FALSE; };
protected:
	DECLARE_ELEM(CMSNumber)
};

class AFX_EXT_CLASS CMSReal : public CMSNumber {
protected:
	DECLARE_ELEM(CMSReal)
};

class AFX_EXT_CLASS CMSInt : public CMSNumber {
protected:
	DECLARE_ELEM(CMSInt)
public:
	virtual CRect ToCalcExt(CSymbInst*, dirMode d=dirUp);
	virtual void ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift);
};

class AFX_EXT_CLASS CMSInteger : public CMSNumber {
protected:
	DECLARE_ELEM(CMSInteger)
public:
	virtual void SerializeBody(CArchive& ar);

	virtual int CalcExt(dirMode d=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnAccess(CPoint *p = NULL);
	virtual int OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	virtual void CopyBody(CViecFC *);

	CMSInteger() { m_value = 1; }

	int m_value;
};

class AFX_EXT_CLASS CMSConst : public CMathSymb {
protected:
	DECLARE_ELEM(CMSConst)
};

class AFX_EXT_CLASS CMSOperator : public CMathSymb {
protected:
	DECLARE_ELEM(CMSOperator)

public:

	CMSOperator();
	virtual BOOL SendMsg(int, CObject*);
	virtual BOOL IsBrcRq(CSymbInst*);
	virtual CRect ToCalcExt(CSymbInst*, dirMode d=dirUp);
	virtual void ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift);
	void DrawBrck(CDC *, CSymbInst *ps, const CPoint& shift);
};

class AFX_EXT_CLASS CMSOPlus : public CMSOperator {
protected:
	DECLARE_ELEM(CMSOPlus)
public:
	virtual BOOL IsBrcRq(CSymbInst*);
	virtual CRect ToCalcExt(CSymbInst*, dirMode d=dirUp);
	virtual void ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift);
};

class AFX_EXT_CLASS CMSOMinus : public CMSOperator {
protected:
	DECLARE_ELEM(CMSOMinus)
public:
	virtual BOOL IsBrcRq(CSymbInst*);
};

class AFX_EXT_CLASS CMSONeg : public CMSOperator {
protected:
	DECLARE_ELEM(CMSONeg)
public:
	virtual BOOL IsBrcRq(CSymbInst*);
	virtual PETCHAR GetDrawName() { return "-"; };
	virtual CRect ToCalcExt(CSymbInst*, dirMode d=dirUp);
	virtual void ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift);
};

class AFX_EXT_CLASS CMSOEqual : public CMSOperator {
protected:
	DECLARE_ELEM(CMSOEqual)
public:
};

class AFX_EXT_CLASS CMSOMult : public CMSOperator {
protected:
	DECLARE_ELEM(CMSOMult)
public:
	virtual BOOL IsBrcRq(CSymbInst*);
	virtual PETCHAR GetDrawName();
};

class AFX_EXT_CLASS CMSODiv : public CMSOperator {
protected:
	DECLARE_ELEM(CMSODiv)
public:
	virtual CRect ToCalcExt(CSymbInst*, dirMode d=dirUp);
	virtual void ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift);
};

class AFX_EXT_CLASS CMSODiff : public CMSOperator {
protected:
	DECLARE_ELEM(CMSODiff)
public:
	virtual PETCHAR GetDrawName();
	virtual CRect ToCalcExt(CSymbInst*, dirMode d=dirUp);
	virtual void ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift);
};

class AFX_EXT_CLASS CMSOAbs : public CMSOperator {
protected:
	DECLARE_ELEM(CMSOAbs)
public:
	virtual BOOL IsBrcRq(CSymbInst*) { return FALSE;} ;
	virtual CRect ToCalcExt(CSymbInst*, dirMode d=dirUp);
	virtual void ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift);
};

//AhXZq̃NX
class AFX_EXT_CLASS CMSOAdrs : public CMSOperator {
protected:
	DECLARE_ELEM(CMSOAdrs)
public:
	virtual BOOL IsBrcRq(CSymbInst*);
	virtual PETCHAR GetDrawName() { return "&"; };
	virtual CRect ToCalcExt(CSymbInst*, dirMode d=dirUp);
	virtual void ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift);
};

//|C^[Zq̃NX
class AFX_EXT_CLASS CMSOPoint : public CMSOperator {
protected:
	DECLARE_ELEM(CMSOPoint)
public:
	virtual BOOL IsBrcRq(CSymbInst*);
	virtual PETCHAR GetDrawName() { return "*"; };
	virtual CRect ToCalcExt(CSymbInst*, dirMode d=dirUp);
	virtual void ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift);
};

///////////////////////////////////////////////////
// Math Equation
//

class AFX_EXT_CLASS CIElem;				   //??

class AFX_EXT_CLASS CGElem : public CViecFC {
public:
	enum mode { modeOpen=1, modeClose=2 };
protected:
	mode m_mode;
	CRect m_RName;
	UINT m_nFormat;
	BOOL m_bCreated;

friend CIElem;
	CIElem *m_pInst;
	CRect m_oldRct;

	DECLARE_ELEM(CGElem)

public:
	CGElem();
	virtual ~CGElem();

	virtual BOOL SendMsg(int, CObject*);
	virtual void SerializeBody(CArchive& ar);
	virtual void CopyBody(CViecFC *);
	virtual int OnAccess(CPoint *p = NULL);
	virtual int OnCommand(UINT id);
	virtual int CalcExt(dirMode d=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual CIElem *GetNewInst();
	virtual void SetMode(mode);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);

	UINT GetFormat() { return m_nFormat; };
	void SetFormat(UINT d) { m_nFormat = d; }
	
	BOOL IsInst() { return m_pInst!=NULL; }
	void SetInst(CIElem *pI);
	mode GetMode() { return m_mode; }
	CIElem *GetInstBody() { return m_pInst; }
	BOOL ToDblBody();
	void SetOldRct(const CRect& r) { m_oldRct = r; };

	const CRect& GetRName() { return m_RName; };
	BOOL AppendDefaultMenu(CMenu *);
};

class AFX_EXT_CLASS CPElem : public CGElem {
protected:
	CViecFCList m_rpInput, m_rpOutput;
	BOOL m_bZoneFg;

	DECLARE_ELEM(CPElem)
public:
	enum DROP_POS { InSideRect=0, LeftTop=1, RightTop=2, RightBottom=3
	, LeftBottom=4, TopSide=5, BottomSide=6, LeftSide=7, RightSide=8 };

	DROP_POS m_zone;

	CPElem();
	virtual ~CPElem();

	virtual int OnFocus(CPoint &p);
	virtual int OnDrag(const CPoint& old, const CPoint& last);
	virtual int OnDrop(const CPoint& last);
	virtual void SerializeBody(CArchive& ar);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual BOOL SubstChild(CViecFC *pFrom, CViecFC *pTo, dirMode dir=dirUp);
	virtual BOOL OnDelete(CViecFC *);
	virtual void CopyBody(CViecFC *);
	virtual BOOL SendMsg(int, CObject*);

	void AddInputPoint(CObject *);
	void AddOutputPoint(CObject *);
	void SetZoneFg(BOOL b) { m_bZoneFg = b; }
	BOOL GetZoneFg(void) { return m_bZoneFg; }
	BOOL SendMsgToRePipe(int qst, CObject *el);

	int GetInputCount() { return m_rpInput.GetCount(); }
	CViecFC *GetInputChild(int n);
//	CViecFC *RemoveInputTail() { return (CViecFC *) m_Input.RemoveTail(); }
//	CViecFC *RemoveInputHead() { return (CViecFC *) m_Input.RemoveHead(); }
//	void RemoveInputAdd() {	m_Input.RemoveAll(); }
//	void AddInputTail(CViecFC *e) { m_Input.AddTail(e); }
//	void AddInputHead(CViecFC *e) { m_Input.AddHead(e); }
	CRelationPipe *FindInputRel(CViecFC *pS);

	int GetOutputCount() { return m_rpOutput.GetCount(); }
	CViecFC *GetOutputChild(int n);
//	CViecFC *RemoveOutputTail() { return (CViecFC *) m_Output.RemoveTail(); }
//	CViecFC *RemoveOutputHead() { return (CViecFC *) m_Output.RemoveHead(); }
//	void RemoveOutputAdd() {	m_Output.RemoveAll(); }
//	void AddOutputTail(CViecFC *e) { m_Output.AddTail(e); }
//	void AddOutputHead(CViecFC *e) { m_Output.AddHead(e); }
	CRelationPipe *FindOutputRel(CViecFC *pS);
};

class AFX_EXT_CLASS CSElem : public CPElem {
public:
	CSElem();
	virtual ~CSElem();

protected:
	DECLARE_ELEM(CSElem)
};

class AFX_EXT_CLASS CIElem : public CPElem {
protected:
	CGElem *m_pBody;

public:
	virtual BOOL OnDelete(CViecFC *);
	CIElem();
	virtual ~CIElem();

	virtual BOOL DblInst(CGElem *);
	virtual BOOL PackInst();
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual int OnAccess(CPoint *p = NULL);
	virtual int OnCommand(UINT id);
	virtual void SerializeBody(CArchive& ar);
	virtual int CalcExt(dirMode d=dirUp);
	virtual BOOL SendMsg(int, CObject*);
	virtual void CopyBody(CViecFC *);

	CGElem *GetBody() { return m_pBody; }

protected:
	DECLARE_ELEM(CIElem)
};

class AFX_EXT_CLASS CSymbInst : public CPElem {
protected:
	CViecFC *m_pSymb;
	CEText *m_petSymbName;
	int m_level;
	int m_int;
	double m_double;

	DECLARE_ELEM(CSymbInst)

public:
	CSymbInst(CViecFC *mi);
	CSymbInst(PETCHAR = NULL);

	virtual ~CSymbInst();
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode d=dirUp);
	virtual void SerializeBody(CArchive& ar);
	virtual int OnFocus(CPoint &p);
	virtual int OnDrag(const CPoint& old, const CPoint& last);
	virtual int OnDrop(const CPoint& last);
	virtual BOOL OnDelete(CViecFC *);
	virtual void SetMode(mode m) { m_mode = m; };
	virtual CIElem *GetNewInst();
	virtual int OnAccess(CPoint *p = NULL);
	virtual int OnCommand(UINT id);
	virtual int OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	virtual BOOL SendMsg(int, CObject*);
	virtual void CopyBody(CViecFC *);

	void SetEncap(BOOL b) { m_bEncap = b; }
	BOOL GetEncap() { return m_bEncap; }
	int GetLevel() { return m_level; }
	void SetLevel(int lv) { m_level = lv; }
	int GetInt() { return m_int; }
	void SetInt(int d) { m_int = d; }
	double GetDouble() { return m_double; }
	void SetDouble(double d) { m_double = d; }
	CSymbInst *GetBaseSymbInst(CRuntimeClass *);
	CViecFC *GetSymbBody();

	PETCHAR GetSymbName() { return *m_petSymbName; };
	size_t GetSymbNmLen() { return m_petSymbName->GetLength(); }
	BOOL ChangeInst(const char*);
};

class AFX_EXT_CLASS COperatorFolder : public CPElem {
	DECLARE_ELEM(COperatorFolder)
public:
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode d=dirUp);
	virtual void Serialize(CArchive& ar);
};

class AFX_EXT_CLASS CEquInst : public CIElem {
public:
	CEquInst();
	virtual int CalcExt(dirMode d=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);

protected:
	DECLARE_ELEM(CEquInst)
};

class AFX_EXT_CLASS CMSMatrix : public CMathSymb {
protected:
	DECLARE_ELEM(CMSMatrix)
public:
	virtual CRect ToCalcExt(CSymbInst*, dirMode d=dirUp);
	virtual void ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift);
};

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

class AFX_EXT_CLASS GDrag {
protected:
	CWnd *m_capture;
	CPoint m_start, m_old, m_last;

public:
	GDrag();
	~GDrag();
	BOOL IsDragging() { return m_capture? TRUE: FALSE; }
	int Drag(CPoint& p);
	int Capture(CWnd *c, CPoint& p);
	CPoint OldOffset();
	CPoint LastOffset();
	int Release();
};

class AFX_EXT_CLASS CSuitCase : public CObject {
	DECLARE_DYNCREATE(CSuitCase)
public:
	int m_int;
	double m_double;

	int m_intAry[10];
	int m_doubleAry[10];

	CObject *m_case, *m_case2;
	CViecFCList *m_oblist;
	CRuntimeClass* m_runtimeClass;
	void *m_void;
};

class AFX_EXT_CLASS CJobDoer : public CObject {
	DECLARE_DYNCREATE(CJobDoer)
public:
	virtual BOOL Do(CObject *);
};

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

class AFX_EXT_CLASS CElemView : public CViecFC {
protected:
	DECLARE_DYNCREATE(CElemView)
protected:
public:
	CGdiObject *pOldPen, *pOldBrush, *pOldFont;
	CScrollView* m_pView;
	BOOL m_bResizeFrame;

public:
	CElemView();
	virtual ~CElemView();
	virtual void Initialize(CScrollView* pvw);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual void SetView(CScrollView*);
	virtual CRect GetClientRect();
	virtual void LogicToCleint(CRect&);
	virtual int CalcExt(dirMode d=dirUp);
	virtual int OnFocus(CPoint &p);
	virtual BOOL SendMsg(int, CObject*);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
};

class AFX_EXT_CLASS CElmResSrv : public CElemView {
	DECLARE_ELEM_FREE(CElmResSrv)
public:													 //s_pElmResSrv
	void * NewElem(CRuntimeClass *, size_t);
	void DeleteElem(CRuntimeClass *, void *);

	class AFX_EXT_CLASS CObjFont: public CObject {
	public:
		int nDot,nWd;
		CString sName;
		CFont *pGdiObj;
		BYTE nCharSet, nItalic;
		~CObjFont() { if(pGdiObj) delete pGdiObj; }
	};
	class AFX_EXT_CLASS CObjPen: public CObject {
	public:
		int nPenStyle;
		int nWidth;
		COLORREF crColor;
		CPen *pGdiObj;
		~CObjPen() { if(pGdiObj) delete pGdiObj; }
	};
	class AFX_EXT_CLASS CObjBrush : public CObject {
	public:
		COLORREF crColor;
		CBrush *pGdiObj;
		~CObjBrush() { if(pGdiObj) delete pGdiObj; }
	};
	/////////// EText //////////
	struct CETextBlock {
		CETextBlock *pNext;
		int nCur, nSize;
		BYTE pData[1];
	};

	CRITICAL_SECTION m_syncETextUsed;
	int m_nETextUsed, m_nETextAll;
	int m_nETextBytesUsed, m_nETextBytesAll;
	CETextBlock *m_pETextFree, *m_pETextUsed;
	BOOL m_bNowCollecting;

	////////// mapping the elem ///////////
	struct _MemChain { _MemChain *pNext; };
	CMapPtrToPtr m_mapRtcToFree;
	CMapPtrToPtr m_mapRtcToAllNo;
	CMapPtrToPtr m_mapRtcToUsedNo;

	static CElmResSrv *s_pElmResSrv; // pointer for itself.  why?

	CViecFCList m_Menu;
	CViecFCList s_Font, s_Pen, s_Brush;
	CElmResSrv();
	~CElmResSrv();

	CEText *GetNewTChar(PETCHAR pch, CEText *old);
	void GarbageEText(CEText*& pEText);
	BOOL CollectGarbage();

	virtual CDC* GetDC();
	virtual int ReleaseDC(CDC*);
	virtual int SetFont(CDC *pdc, int dot, PETCHAR , BYTE nCharSet, BYTE nItalic=TRUE, int wd=0);
	virtual int SetPen(CDC *pdc, int nPenStyle, int nWidth, COLORREF crColor);
	virtual int SetBrush(CDC *pdc, COLORREF crColor);
	virtual void SetOldGdiObject(CDC *pdc);
};

class AFX_EXT_CLASS CGDoc : public CDocument
{
protected:
	CGDoc();           // IɎgpveNg RXgN^B
	DECLARE_DYNCREATE(CGDoc)
public:
	CElemView *m_pElemView;
	virtual BOOL OnNewDocument();
	virtual void DeleteContents();
	virtual ~CGDoc();
	virtual void Serialize(CArchive& ar);   // hLg I/O ɑ΂ăI[o[Ch܂B
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
};

class AFX_EXT_CLASS CGMainDoc : public CGDoc
{
	DECLARE_DYNCREATE(CGMainDoc)
public:
	virtual BOOL OnNewDocument();
	virtual void DeleteContents();
};

class AFX_EXT_CLASS CGTemplate : public CMultiDocTemplate {
protected:
	DECLARE_DYNAMIC(CGTemplate)
public:
	virtual ~CGTemplate() {};
	virtual void CloseAllDocuments(BOOL bEndSession);
	CGTemplate(UINT nIDResource, CRuntimeClass* pDocClass,
		CRuntimeClass* pFrameClass, CRuntimeClass* pViewClass);
};

class AFX_EXT_CLASS CGView : public CScrollView
{
	DECLARE_DYNCREATE(CGView)
protected:
	CGView();           // IɎgpveNg RXgN^B
public:
	CPoint m_window;
	CPoint m_viewport;
public:
 	CGDoc *GetDocument();

	virtual void OnDraw(CDC* pDC);      // ̃r[`悷邽߂ɃI[o[Ch܂B
	virtual void OnInitialUpdate();     // \zAŏ̏B
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);

	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

	virtual BOOL IsSelected(const CObject* pDocItem) const;
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
protected:
	virtual ~CGView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg LRESULT OnCmdToElem(WPARAM, LPARAM);
	DECLARE_MESSAGE_MAP()
};

class AFX_EXT_CLASS CGFrame : public CMDIChildWnd
{
	DECLARE_DYNCREATE(CGFrame)
protected:
	CGFrame();           // IɎgpveNg RXgN^B
protected:
	virtual ~CGFrame();
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	afx_msg void OnClose();
	DECLARE_MESSAGE_MAP()
};

class AFX_EXT_CLASS CSingleFrm : public CFrameWnd
{
protected: // VACY@\݂̂쐬܂B
	CSingleFrm();
	DECLARE_DYNCREATE(CSingleFrm)
protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
public:
	virtual ~CSingleFrm();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
protected:
	DECLARE_MESSAGE_MAP()
};
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

enum SHIFT_STATE { SS_NOTHING, SS_SHIFT, SS_CTRL, SS_SHIFT_CTRL };

extern AFX_EXT_DATA CElemCollect TheElemCollector;
extern AFX_EXT_DATA GDrag TheDrag;
extern AFX_EXT_DATA int nSpace1,nDotStp;
extern AFX_EXT_DATA CMapStringToPtr s_TheDefaultSymbols;
extern AFX_EXT_DATA CMapStringToOb s_MathSymbMapTable;
extern "C" AFX_EXT_API void WINAPI InitElem();
extern "C" AFX_EXT_API enum SHIFT_STATE MyGetKeyState();

inline WORD _CHM_AddElemToCol(CRuntimeClass *rtc, WORD w)
	{  TheElemCollector.m_member[rtc->m_lpszClassName]= rtc; return w; }

inline void* ::_CHM_NewElem(CRuntimeClass *rtc, size_t nSize)
	{  if(CElmResSrv::s_pElmResSrv==NULL) return CObject::operator new(nSize);
		return CElmResSrv::s_pElmResSrv->NewElem(rtc, nSize); }

inline void ::_CHM_DeleteElem(CRuntimeClass *rtc, void *p)
	{  if(CElmResSrv::s_pElmResSrv==NULL) { CObject::operator delete(p); return; }
		CElmResSrv::s_pElmResSrv->DeleteElem(rtc, p);  }

#endif //__ELEM_H__
