#include "stdafx.h"

#include "elem.h"
#include "resource.h"
#include "chgnmdlg.h"


int CMSInteger::CalcExt(dirMode dir)
{

	CSymbInst *inst = (CSymbInst *) GetParent();
	if(inst->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		CViecFC *pSym = inst->GetSymbBody();
		if(pSym->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
			m_value = - m_value;
			CViecFC *pelm = inst->GetParent();
			pelm->SubstChild(inst, this, dirDown);
			GetView()->CalcExt(dirDown);
			inst->m_child.RemoveTail();
			delete inst;
		}
	}

	CString str;
	if(m_value<0)
		str.Format("(%d)", m_value);
	else
		str.Format("%d", m_value);
	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	CSize sz = pdc->GetTextExtent(str, lstrlen(str));
	ReleaseDC(pdc);
	CRect ext = m_extent;
	m_extent.left = 0;
	m_extent.right = sz.cx;
	m_extent.top = -sz.cy/2;
	m_extent.bottom = sz.cy + m_extent.top;
	if(dir==dirUp && m_parent)
		m_parent->CalcExt(dir);
	if(m_extent!=ext) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
		return 1;
	}
	return 0;
}

void CMSInteger::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,255) : RGB(0,0,0);
	CPoint p0=p;
	p0.Offset(m_org);

	CString str;
	if(m_value<0)
		str.Format("(%d)", m_value);
	else
		str.Format("%d", m_value);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	pdc->SetTextColor(col);
	CSize sz = pdc->GetTextExtent(str, lstrlen(str));
	pdc->TextOut(p0.x, p0.y-sz.cy/2, str);
}

int CMSInteger::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu();
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	pMenu->AppendMenu(MF_STRING, CMD_CHANGE_TO_UNKNOWN,"&unknown");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CMathSymb::OnCommand(UINT id)
{
	switch(id) {
		case CMD_CHANGE_TO_UNKNOWN:
			{
				CSymbInst *inst = new CSymbInst("?");
				GetAncestor()->SubstChild(this, inst, dirDown);
				inst->SetFocus(TRUE);
				inst->OnCreated();
				inst->GetView()->CalcExt(dirDown);
				delete this;
			}
			return TRUE;
	}
	return CViecFC::OnCommand(id);
}

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

/////CMSChar //////////////////////////////////////////////////////
/////fujita 990614///////////////////////////////////////////////
int CMSChar::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	CRect xNm = GetTextExtent(pdc, GetName(), GetNameLen());
	CRect xPm = GetTextExtent(pdc, "**", 2); //"**"̗̈vZ
	
	ReleaseDC(pdc);

	m_extent = CRect(0,xPm.top, xPm.right + xNm.right, xNm.bottom);
	CalcExtPost(dir, ext);
	return TRUE;
}

void CMSChar::OnDraw(CDC *pdc, const CPoint& p)
{
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	CRect xNm = GetTextExtent(pdc, GetName(), GetNameLen());
	CRect xPm = GetTextExtent(pdc, "**", 2); //"**"̗̈vZ
	
	CPoint p0 = GetOrg();

	p0.Offset(p);
	COLORREF col = m_bFocus? RGB(0,0,255) : RGB(0,0,0);
	pdc->SetTextColor(col);

	TextOut(pdc, p0.x, p0.y + xPm.bottom/3, "**", 2);
	TextOut(pdc, p0.x + xPm.right, p0.y, GetName(), GetNameLen());
	OnDrawChild(pdc, p);
}

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

/////CMSChar_One //////////////////////////////////////////////////////
/////fujita 990614///////////////////////////////////////////////
int CMSChar_One::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	CRect xNm = GetTextExtent(pdc, GetName(), GetNameLen());
	CRect xPm = GetTextExtent(pdc, "*", 1); //"**"̗̈vZ
	
	ReleaseDC(pdc);

	m_extent = CRect(0,xPm.top, xPm.right + xNm.right, xNm.bottom);
	CalcExtPost(dir, ext);
	return TRUE;
}

void CMSChar_One::OnDraw(CDC *pdc, const CPoint& p)
{
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	CRect xNm = GetTextExtent(pdc, GetName(), GetNameLen());
	CRect xPm = GetTextExtent(pdc, "*", 1); //"**"̗̈vZ
	
	CPoint p0 = GetOrg();

	p0.Offset(p);
	COLORREF col = m_bFocus? RGB(0,0,255) : RGB(0,0,0);
	pdc->SetTextColor(col);

	TextOut(pdc, p0.x, p0.y + xPm.bottom/3, "*", 1);
	TextOut(pdc, p0.x + xPm.right, p0.y, GetName(), GetNameLen());
	OnDrawChild(pdc, p);
}

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////


///////////////////////   JobDoer   //////////////////////////
///////////////////////   JobDoer   //////////////////////////

BOOL CJobDoer::Do(CObject *ob)
{
//	CElemCtn *pel = (CElemCtn *) ob;
//	pel->m_child.RemoveAll();
//	pel->m_bEncap = TRUE;
	return TRUE;
}


