// elem.cpp : DLL p̏̒`s܂B
//

#include "stdafx.h"
#include <afxdllx.h>

#include "elem.h"
#include "resource.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

static AFX_EXTENSION_MODULE elemDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("ELEM.DLL B\n");
		
		// g DLL  1 񂾂܂
		AfxInitExtensionModule(elemDLL, hInstance);

		//  DLL \[X `FC֑}܂
		new CDynLinkLibrary(elemDLL);
		CViecFC::pElemTemp = NULL;
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("ELEM.DLL IB\n");
		if(CViecFC::pElemTemp)
			delete CViecFC::pElemTemp;
	}
	return 1;   // ok
}

extern "C" AFX_EXT_API enum SHIFT_STATE MyGetKeyState()
{
	BOOL sL, sR, cL, cR;
	sL = GetKeyState(VK_LSHIFT) & 0x8000;
	sR = GetKeyState(VK_RSHIFT) & 0x8000;
	cL = GetKeyState(VK_LCONTROL) & 0x8000;
	cR = GetKeyState(VK_RCONTROL) & 0x8000;
	if( (sL || sR) && !cR && !cL )
		return SS_SHIFT;
	if( (cL || cR) && !sR && !sL )
		return SS_CTRL;
	if( (cL || cR) && (sL || sR) )
		return SS_CTRL;
	return SS_NOTHING;
}

extern "C" AFX_EXT_API void WINAPI InitElem()
{
	// create a new CDynLinkLibrary for this app
//	new CDynLinkLibrary(elemDLL);

	// Register the doc templates we provide to the app
	CWinApp* pApp = AfxGetApp();
	ASSERT(pApp != NULL);

	ADD_ELEM_TO_DEFAULT_SYMBOL("*", CMSOMult);
	ADD_ELEM_TO_DEFAULT_SYMBOL("+", CMSOPlus);
	ADD_ELEM_TO_DEFAULT_SYMBOL("-?", CMSONeg);
	ADD_ELEM_TO_DEFAULT_SYMBOL("/", CMSODiv);
	ADD_ELEM_TO_DEFAULT_SYMBOL("deriv", CMSODiff);
	ADD_ELEM_TO_DEFAULT_SYMBOL("=", CMSOEqual);
	ADD_ELEM_TO_DEFAULT_SYMBOL("abs", CMSOAbs);
	ADD_ELEM_TO_DEFAULT_SYMBOL(" ", CMathSymb);
	ADD_ELEM_TO_DEFAULT_SYMBOL("?", CMSUnknown);

	ADD_ELEM_TO_DEFAULT_SYMBOL("%", CMSOperator);
	ADD_ELEM_TO_DEFAULT_SYMBOL("==", CMSOperator);
	ADD_ELEM_TO_DEFAULT_SYMBOL("!=", CMSOperator);
	ADD_ELEM_TO_DEFAULT_SYMBOL("<", CMSOperator);
	ADD_ELEM_TO_DEFAULT_SYMBOL(">", CMSOperator);
	ADD_ELEM_TO_DEFAULT_SYMBOL("<=", CMSOperator);
	ADD_ELEM_TO_DEFAULT_SYMBOL(">=", CMSOperator);

	//|C^[Zq̈
	ADD_ELEM_TO_DEFAULT_SYMBOL("&?",  CMSOAdrs);
	//|C^[Zq̈
	ADD_ELEM_TO_DEFAULT_SYMBOL("*?",  CMSOPoint);
}

/////////////////////////////////////////////////////////////////////////////
// CGDoc

////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////

CGDoc::CGDoc()
{
	m_pElemView = NULL;
}

CGDoc::~CGDoc()
{
}

BOOL CGDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	if(m_pElemView) {
		delete m_pElemView;
		m_pElemView = NULL;
	}
	m_pElemView = new CElemView();
	return TRUE;
}

void CGDoc::DeleteContents()
{
	if(m_pElemView) {
		delete m_pElemView;
		m_pElemView = NULL;
	}
}

#ifdef _DEBUG
void CGDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CGDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


void CGDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring()) {
		if(m_pElemView && m_pElemView->GetCount()==1) {
			POSITION pos = m_pElemView->GetHeadPosition();
			CViecFC *obj = m_pElemView->GetNext(pos);
			obj->Serialize(ar);
		}
	} else {
		CString head;
		CViecFC type;

		m_pElemView = new CElmResSrv;
		ar >> head;
		CViecFC *pe = type.GetUnknownElem(ar, head);
		if(pe->IsKindOf(RUNTIME_CLASS(CViecFC))) {
			m_pElemView->AddTail(pe);
			m_pElemView->OnCreated();
		}
	}
}

////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////

BOOL CGMainDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	if(CElmResSrv::s_pElmResSrv)
		return FALSE;
	if(m_pElemView) {
		delete m_pElemView;
		m_pElemView = NULL;
		CElmResSrv::s_pElmResSrv = NULL;
	}
	 CElmResSrv::s_pElmResSrv = new CElmResSrv();
	 m_pElemView = CElmResSrv::s_pElmResSrv;
	return TRUE;
}

void CGMainDoc::DeleteContents()
{
	if(m_pElemView) {
		delete m_pElemView;
		m_pElemView = NULL;
		CElmResSrv::s_pElmResSrv = NULL;
	}
}

////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// CGFrame

IMPLEMENT_DYNCREATE(CGFrame, CMDIChildWnd)

CGFrame::CGFrame()
{
}

CGFrame::~CGFrame()
{
}


BEGIN_MESSAGE_MAP(CGFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CGFrame)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CGFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style &= ~WS_MAXIMIZE;
	return CMDIChildWnd::PreCreateWindow(cs);
}

void CGFrame::OnClose() 
{
	// TODO: ̈ʒuɃbZ[W nh̃R[hǉ邩A܂̓ftHǧĂяosB
	CGDoc *pdoc = (CGDoc *) GetActiveView()->GetDocument();
	if(pdoc->m_pElemView) {
		POSITION pos = pdoc->m_pElemView->GetHeadPosition();
		CPElem *ppe = (CPElem*) pdoc->m_pElemView->GetNext(pos);
		if(ppe && !ppe->IsInst())
			CMDIChildWnd::OnClose();
	}
}



CGTemplate::CGTemplate(UINT nIDResource, CRuntimeClass* pDocClass,
	CRuntimeClass* pFrameClass, CRuntimeClass* pViewClass)
		: CMultiDocTemplate(nIDResource, pDocClass, pFrameClass, pViewClass)
{
}

void CGTemplate::CloseAllDocuments(BOOL bEndSession)
{
	CDocument *pDoc;
	while( m_docList.GetCount()>0 ) {
		pDoc=(CDocument *)m_docList.GetHead();
		if(bEndSession)
			pDoc->DisconnectViews();
		pDoc->OnCloseDocument();
	}
}

////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNCREATE(CSingleFrm, CFrameWnd)

BEGIN_MESSAGE_MAP(CSingleFrm, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CSingleFrm::CSingleFrm()
{
}

CSingleFrm::~CSingleFrm()
{
}

#ifdef _DEBUG
void CSingleFrm::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CSingleFrm::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

BOOL CSingleFrm::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: ɓꉻꂽR[hǉŁA܂͒PɊ{NXĂяoĂ
	cs.hMenu = NULL;
	return CFrameWnd::PreCreateWindow(cs);
}



/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
//      CGView
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNCREATE(CGView, CScrollView)

IMPLEMENT_DYNAMIC(CGTemplate, CMultiDocTemplate)

CGView::CGView()
{
	m_window = CPoint(400,400);
	m_viewport = CPoint(1500,1500);
}

CGView::~CGView()
{
}


BEGIN_MESSAGE_MAP(CGView, CScrollView)
	//{{AFX_MSG_MAP(CGView)
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	ON_WM_CHAR()
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
	ON_MESSAGE(MSG_VIEW_ON_COMMAND_TO_ELEM, OnCmdToElem)
END_MESSAGE_MAP()


LRESULT CGView::OnCmdToElem(WPARAM wpa, LPARAM lpa)
{
	int rt;
	CViecFC *pelm = (CViecFC *) lpa;
	if(!pelm || !pelm->IsKindOf(RUNTIME_CLASS(CViecFC))) return TRUE;
	EnterCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
	rt = pelm->OnCommand(wpa);
	LeaveCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
	return rt;
}

BOOL CGView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈B
	return DoPreparePrinting(pInfo);
}

void CGView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CGView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// CGView `

void CGView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: ̃r[Ŝ̃TCYvZĂB
	CGDoc* pdoc = GetDocument();

	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);

	if(pdoc->m_pElemView) {
		pdoc->m_pElemView->Initialize(this);
		pdoc->m_pElemView->SetExtent(CRect(0,0,0,0));
		EnterCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
		pdoc->m_pElemView->CalcExt(CViecFC::dirDown);
		LeaveCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
	}
}

void CGView::OnDraw(CDC* pDC)
{
	CGDoc* pdoc = GetDocument();
	// TODO: ̏ꏊɕ`̂߂̃R[hǉĂB
	if(pdoc->m_pElemView) {
		EnterCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
		pdoc->m_pElemView->OnDraw(pDC, CPoint(0,0));
		LeaveCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
	}
}

CGDoc * CGView::GetDocument()
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGDoc)));
	return (CGDoc*)m_pDocument;
}

/////////////////////////////////////////////////////////////////////////////
// CGView ff

#ifdef _DEBUG
void CGView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CGView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGView bZ[W nh

void CGView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nh̃R[hǉ邩A܂̓ftHǧĂяosB
	CPoint point0 = point;
	point0.Offset(GetScrollPosition());
	CScrollView::OnLButtonDblClk(nFlags, point);
}

void CGView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nh̃R[hǉ邩A܂̓ftHǧĂяosB
	CPoint point0 = point;
	point0.Offset(GetScrollPosition());
	CGDoc *pdoc = GetDocument();

	if(pdoc->m_pElemView==NULL) return;
	CViecFC& pctn = *pdoc->m_pElemView;
	pctn.OnFocus(point0);
	TheDrag.Capture(this, point0);
	CScrollView::OnLButtonDown(nFlags, point);
}

void CGView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nh̃R[hǉ邩A܂̓ftHǧĂяosB
	
	CGDoc *pdoc = GetDocument();
	if(pdoc->m_pElemView) {
		CViecFC& ctn = *pdoc->m_pElemView;
		if(TheDrag.IsDragging()) {
			EnterCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
			if(ctn.OnDrop(TheDrag.LastOffset()));
			LeaveCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
			TheDrag.Release();
		}
	}
	CScrollView::OnLButtonUp(nFlags, point);
}

void CGView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: ̈ʒuɃbZ[W nh̃R[hǉ邩A܂̓ftHǧĂяosB
	
	CPoint point0 = point;
	point0.Offset(GetScrollPosition());
	if(TheDrag.IsDragging()) {
		CGDoc *pdoc = GetDocument();
		if(pdoc->m_pElemView) {
			CViecFC& ctn = *pdoc->m_pElemView;
			TheDrag.Drag(point0);
			EnterCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
			ctn.OnDrag(TheDrag.OldOffset(), TheDrag.LastOffset());
			LeaveCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
		}
	}
	CScrollView::OnMouseMove(nFlags, point);
}

void CGView::OnRButtonDown(UINT nFlags, CPoint point)
{
	// TODO: ̈ʒuɃbZ[W nh̃R[hǉ邩A܂̓ftHǧĂяosB
	CPoint point0 = point;
	point0.Offset(GetScrollPosition());
	CGDoc *pdoc = GetDocument();
	if(pdoc->m_pElemView) {
		CViecFC& ctn = *pdoc->m_pElemView;
		CScrollView::OnRButtonDown(nFlags, point);
		ctn.OnFocus(point0);
		CViecFC *pelem = ctn.GetFocus();
		if(pelem) {
			EnterCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
			pelem->OnAccess(&point);
			LeaveCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
		}
	}

}

void CGView::OnRButtonUp(UINT nFlags, CPoint point)
{
	// TODO: ̈ʒuɃbZ[W nh̃R[hǉ邩A܂̓ftHǧĂяosB
	
	CScrollView::OnRButtonUp(nFlags, point);
}


BOOL CGView::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: ɓꉻꂽR[hǉŁA܂͒PɊ{NXĂяoĂ
	int rt;
	CGDoc *pdoc = GetDocument();
	if(pdoc->m_pElemView) {
		CViecFC& ctn = *pdoc->m_pElemView;
		CViecFC *pelm = ctn.GetFocus();
/*
		switch(wParam) {
		case CMD_VIEW_ON_COMMAND_TO_ELEM:
			{
				pelm = (CViecFC *) lParam;
				if(!pelm || !pelm->IsKindOf(RUNTIME_CLASS(CViecFC))) return TRUE;
			}
			break;
		}
*/
		if(pelm) {
			EnterCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
			rt = pelm->OnCommand(wParam);
			LeaveCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
			return rt;
		}
	}
	return CScrollView::OnCommand(wParam, lParam);
}


void CGView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: ̈ʒuɃbZ[W nh̃R[hǉ邩A܂̓ftHǧĂяosB
	CGDoc *pdoc = GetDocument();
	if(pdoc->m_pElemView) {
		CViecFC& ctn = *pdoc->m_pElemView;
		CViecFC *pelem = ctn.GetFocus();
		if(pelem) {
			EnterCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
			pelem->OnKeyDown(nChar, nRepCnt, nFlags);
			LeaveCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
		}
	}
	CScrollView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CGView::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: ̈ʒuɃbZ[W nh̃R[hǉ邩A܂̓ftHǧĂяosB
	
	CScrollView::OnKeyUp(nChar, nRepCnt, nFlags);
}

void CGView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// TODO: ɓꉻꂽR[hǉŁA܂͒PɊ{NXĂяoĂ
	
	
}

BOOL CGView::IsSelected(const CObject* pDocItem) const
{
	// TODO: ɓꉻꂽR[hǉŁA܂͒PɊ{NXĂяoĂ
	
	return CScrollView::IsSelected(pDocItem);
}

void CGView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
	// TODO: ɓꉻꂽR[hǉŁA܂͒PɊ{NXĂяoĂ
	
	CScrollView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}

void CGView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: ɓꉻꂽR[hǉŁA܂͒PɊ{NXĂяoĂ
	
	CScrollView::OnPrepareDC(pDC, pInfo);
	if(pInfo) {
		pDC->SetMapMode(MM_ANISOTROPIC);
		pDC->SetWindowExt( m_window.x, m_window.y);
		pDC->SetViewportExt( m_viewport.x, m_viewport.y);
	}
}

void CGView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: ̈ʒuɃbZ[W nh̃R[hǉ邩A܂̓ftHǧĂяosB
	CGDoc *pdoc = GetDocument();
	if(pdoc->m_pElemView) {
		CViecFC& ctn = *pdoc->m_pElemView;
		CViecFC *pelem = ctn.GetFocus();
		if(pelem) {
			EnterCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
			pelem->OnChar(nChar, nRepCnt, nFlags);
			LeaveCriticalSection(&CElmResSrv::s_pElmResSrv->m_syncETextUsed);
		}
	}
	CScrollView::OnChar(nChar, nRepCnt, nFlags);
}


