////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "elem.h"

int CViecFCList::GetCount() const
	{ return m_nCount; }

BOOL CViecFCList::IsEmpty() const
	{ return m_nCount == 0; }

CObject*& CViecFCList::GetHead()
	{ ASSERT(m_pNodeHead != NULL);
		return m_pNodeHead->data; }

CObject* CViecFCList::GetHead() const
	{ ASSERT(m_pNodeHead != NULL);
		return m_pNodeHead->data; }

CObject*& CViecFCList::GetTail()
	{ ASSERT(m_pNodeTail != NULL);
		return m_pNodeTail->data; }

CObject* CViecFCList::GetTail() const
	{ ASSERT(m_pNodeTail != NULL);
		return m_pNodeTail->data; }

POSITION CViecFCList::GetHeadPosition() const
	{ return (POSITION) m_pNodeHead; }

POSITION CViecFCList::GetTailPosition() const
	{ return (POSITION) m_pNodeTail; }

CObject*& CViecFCList::GetNext(POSITION& rPosition) // return *Position++
	{ CENode* pNode = (CENode*) rPosition;
		ASSERT(AfxIsValidAddress(pNode, sizeof(CENode)));
		rPosition = (POSITION) pNode->pNext;
		return pNode->data; }

CObject* CViecFCList::GetNext(POSITION& rPosition) const // return *Position++
	{ CENode* pNode = (CENode*) rPosition;
		ASSERT(AfxIsValidAddress(pNode, sizeof(CENode)));
		rPosition = (POSITION) pNode->pNext;
		return pNode->data; }

CObject*& CViecFCList::GetPrev(POSITION& rPosition) // return *Position--
	{ CENode* pNode = (CENode*) rPosition;
		ASSERT(AfxIsValidAddress(pNode, sizeof(CENode)));
		rPosition = (POSITION) pNode->pPrev;
		return pNode->data; }

CObject* CViecFCList::GetPrev(POSITION& rPosition) const // return *Position--
	{ CENode* pNode = (CENode*) rPosition;
		ASSERT(AfxIsValidAddress(pNode, sizeof(CENode)));
		rPosition = (POSITION) pNode->pPrev;
		return pNode->data; }

CObject*& CViecFCList::GetAt(POSITION position)
	{ CENode* pNode = (CENode*) position;
		ASSERT(AfxIsValidAddress(pNode, sizeof(CENode)));
		return pNode->data; }

CObject* CViecFCList::GetAt(POSITION position) const
	{ CENode* pNode = (CENode*) position;
		ASSERT(AfxIsValidAddress(pNode, sizeof(CENode)));
		return pNode->data; }

void CViecFCList::SetAt(POSITION pos, CObject* newElement)
	{ CENode* pNode = (CENode*) pos;
		ASSERT(AfxIsValidAddress(pNode, sizeof(CENode)));
		pNode->data = newElement; }

