
#include <stdio.h>
#include <math.h>

#define ___DEBUG___

/* Definition of constants */
#define NMAX 50000
#define JMAX 40
#define IMAX 40

#define MIDgP1  (MILWP1+1 )
#define MISzP1  (MILWP1+MIRWP1+2 )
#define MIRWP1  (iMxP1*1+0 )
#define MJSzP1  (iMxP1*jMxP1 )
#define MILWP1  (iMxP1*1+0 )
#define iMxP1  ((IMAX-1)-1+1 )
#define jMxP1  ((JMAX-1)-1+1 )


/* prototypes definition of all functions in this program */
void main();
void SlvU1();
void SlvV1();
void SlvP1();
void SlvU2();
void SlvV2();
void SlvP2();
void subst();
void output();
void init();


#ifndef ___DEBUG___

/* time step variable */
int n;

/* Declaration of parameters */
double Re = 100.000000;
double U0 = 0.500000;

double dx = 1.000000;
double dy = 1.000000;
double dt = 0.050000;

double U[IMAX+1][JMAX+1];/* U n 0 */
double U1[IMAX+1][JMAX+1];/* U n 1 */
double U2[IMAX+1][JMAX+1];/* U ~ 0 */
double V[IMAX+1][JMAX+1];/* V n 0 */
double V1[IMAX+1][JMAX+1];/* V n 1 */
double V2[IMAX+1][JMAX+1];/* V ~ 0 */
double P[IMAX+1][JMAX+1];/* P n 0 */
double P1[IMAX+1][JMAX+1];/* P n 1 */
double P2[IMAX+1][JMAX+1];/* P ~ 0 */

/* Declaration of matrix and vector */
double AmP1[MISzP1+1][MJSzP1+1];

#else

#include <windows.h>

struct SYSTEM_VARS {
	short int VarNo;
	char pszStatus[22];
	struct {
		char varName[16];
		short int type;
		short int size[3];
		long pBody;
	} varList[16];

	double AmP1[MISzP1+1][MJSzP1+1];

	double U[IMAX+1][JMAX+1];/* U(n+0) */
	double U1[IMAX+1][JMAX+1];/* U(n+1) */
	double U2[IMAX+1][JMAX+1];/* U(~+0) */
	double V[IMAX+1][JMAX+1];/* V(n+0) */
	double V1[IMAX+1][JMAX+1];/* V(n+1) */
	double V2[IMAX+1][JMAX+1];/* V(~+0) */
	double P[IMAX+1][JMAX+1];/* P(n+0) */
	double P1[IMAX+1][JMAX+1];/* P(n+1) */
	double P2[IMAX+1][JMAX+1];/* P(~+0) */

	double Re;
	double U0;

	double dx;
	double dy;
	double dt;

	int n;

} *system_vars;


#define AmP1 system_vars->AmP1

#define U system_vars->U
#define U1 system_vars->U1
#define U2 system_vars->U2
#define V system_vars->V
#define V1 system_vars->V1
#define V2 system_vars->V2
#define P system_vars->P
#define P1 system_vars->P1
#define P2 system_vars->P2

#define Re system_vars->Re
#define U0 system_vars->U0

#define dx system_vars->dx
#define dy system_vars->dy
#define dt system_vars->dt

#define n system_vars->n

HANDLE hTimeStep;

HANDLE hSignal, hFM;

#define VAR_TYPE_2_DIM_REAL 1
#define VAR_TYPE_1_DIM_REAL 2
#define VAR_TYPE_REAL 3
#define VAR_TYPE_INTEGER 4

void InitDebug()
{
	hTimeStep = CreateEvent(NULL, FALSE, FALSE, "NVSMAC8_BRKTimeStep");
	hSignal = CreateEvent(NULL, FALSE, FALSE, "NVSMAC8_SIGNAL");
	hFM = CreateFileMapping((HANDLE)-1, NULL, PAGE_READWRITE, 0, sizeof(struct SYSTEM_VARS), "NVSMAC8_VARS");
	system_vars = (struct SYSTEM_VARS *) MapViewOfFile(hFM, FILE_MAP_WRITE, 0,0,0);

	lstrcpy(system_vars->varList[0].varName, "AmP1");
	system_vars->varList[0].type = VAR_TYPE_2_DIM_REAL;
	system_vars->varList[0].size[0] = MISzP1+1;
	system_vars->varList[0].size[1] = MJSzP1+1;
	system_vars->varList[0].pBody = (BYTE*)AmP1-(BYTE*)system_vars;

	lstrcpy(system_vars->varList[1].varName, "U(n)");
	system_vars->varList[1].type = VAR_TYPE_2_DIM_REAL;
	system_vars->varList[1].size[0] = IMAX+1;
	system_vars->varList[1].size[1] = JMAX+1;
	system_vars->varList[1].pBody = (BYTE*)U-(BYTE*)system_vars;

	lstrcpy(system_vars->varList[2].varName, "U(n+1)");
	system_vars->varList[2].type = VAR_TYPE_2_DIM_REAL;
	system_vars->varList[2].size[0] = IMAX+1;
	system_vars->varList[2].size[1] = JMAX+1;
	system_vars->varList[2].pBody = (BYTE*)U1-(BYTE*)system_vars;

	lstrcpy(system_vars->varList[3].varName, "U(~)");
	system_vars->varList[3].type = VAR_TYPE_2_DIM_REAL;
	system_vars->varList[3].size[0] = IMAX+1;
	system_vars->varList[3].size[1] = JMAX+1;
	system_vars->varList[3].pBody = (BYTE*)U2-(BYTE*)system_vars;

	lstrcpy(system_vars->varList[4].varName, "V(n)");
	system_vars->varList[4].type = VAR_TYPE_2_DIM_REAL;
	system_vars->varList[4].size[0] = IMAX+1;
	system_vars->varList[4].size[1] = JMAX+1;
	system_vars->varList[4].pBody = (BYTE*)V-(BYTE*)system_vars;

	lstrcpy(system_vars->varList[5].varName, "V(n+1)");
	system_vars->varList[5].type = VAR_TYPE_2_DIM_REAL;
	system_vars->varList[5].size[0] = IMAX+1;
	system_vars->varList[5].size[1] = JMAX+1;
	system_vars->varList[5].pBody = (BYTE*)V1-(BYTE*)system_vars;

	lstrcpy(system_vars->varList[6].varName, "V(~)");
	system_vars->varList[6].type = VAR_TYPE_2_DIM_REAL;
	system_vars->varList[6].size[0] = IMAX+1;
	system_vars->varList[6].size[1] = JMAX+1;
	system_vars->varList[6].pBody = (BYTE*)V2-(BYTE*)system_vars;

	lstrcpy(system_vars->varList[7].varName, "P(n)");
	system_vars->varList[7].type = VAR_TYPE_2_DIM_REAL;
	system_vars->varList[7].size[0] = IMAX+1;
	system_vars->varList[7].size[1] = JMAX+1;
	system_vars->varList[7].pBody = (BYTE*)P-(BYTE*)system_vars;

	lstrcpy(system_vars->varList[8].varName, "P(n+1)");
	system_vars->varList[8].type = VAR_TYPE_2_DIM_REAL;
	system_vars->varList[8].size[0] = IMAX+1;
	system_vars->varList[8].size[1] = JMAX+1;
	system_vars->varList[8].pBody = (BYTE*)P1-(BYTE*)system_vars;

	lstrcpy(system_vars->varList[9].varName, "P(~)");
	system_vars->varList[9].type = VAR_TYPE_2_DIM_REAL;
	system_vars->varList[9].size[0] = IMAX+1;
	system_vars->varList[9].size[1] = JMAX+1;
	system_vars->varList[9].pBody = (BYTE*)P2-(BYTE*)system_vars;


	lstrcpy(system_vars->varList[10].varName, "Re");
	system_vars->varList[10].type = VAR_TYPE_REAL;
	system_vars->varList[10].pBody = (BYTE*)&Re-(BYTE*)system_vars;
	Re = 100.000000;

	lstrcpy(system_vars->varList[11].varName, "U0");
	system_vars->varList[11].type = VAR_TYPE_REAL;
	system_vars->varList[11].pBody = (BYTE*)&U0-(BYTE*)system_vars;
	U0 = 0.500000;



	lstrcpy(system_vars->varList[12].varName, "dx");
	system_vars->varList[12].type = VAR_TYPE_REAL;
	system_vars->varList[12].pBody = (BYTE*)&dx-(BYTE*)system_vars;
	dx = 1.000000;

	lstrcpy(system_vars->varList[13].varName, "dy");
	system_vars->varList[13].type = VAR_TYPE_REAL;
	system_vars->varList[13].pBody = (BYTE*)&dy-(BYTE*)system_vars;
	dy = 1.000000;

	lstrcpy(system_vars->varList[14].varName, "dt");
	system_vars->varList[14].type = VAR_TYPE_REAL;
	system_vars->varList[14].pBody = (BYTE*)&dt-(BYTE*)system_vars;
	dt = 0.050000;


	lstrcpy(system_vars->varList[15].varName, "n");
	system_vars->varList[15].type = VAR_TYPE_INTEGER;
	system_vars->varList[15].pBody = (BYTE*)&n-(BYTE*)system_vars;

	system_vars->VarNo = 16;
	SetEvent(hSignal);
}

#endif

void main()
{
#ifdef ___DEBUG___
	InitDebug();
#endif

	init();
	for(n=1; n<=NMAX; n++) {
		/* 1 time step solver n --> n+1 */
		{
			SlvU1();
			SlvV1();
			SlvP1();
			SlvU2();
			SlvV2();
			SlvP2();
		}
#ifdef ___DEBUG___
		lstrcpy(system_vars->pszStatus, "Sym11994,TimeStep");
		SetEvent(hSignal);
		WaitForSingleObject(hTimeStep, INFINITE);
#endif
		if(n%20==0) {
			output();
		}
		subst();
	}

}


void SlvU1()
{
	int i, j;
	for(i=2; i<=IMAX-1; i++) {
		for(j=2; j<=JMAX-2; j++) {
			U2[i][j] = U[i][j]
			           +dt
			            *(-((U[i][j]+fabs(U[i][j]))/2*(U[i][j]-U[i-1][j])/dx
			                +(U[i][j]-fabs(U[i][j]))/2*(U[i+1][j]-U[i][j])/dx)
			              -((1/4*(V[i][j+1]+V[i][j]+V[i-1][j+1]+V[i-1][j])
			                 +fabs(1/4
			                       *(V[i][j+1]+V[i][j]+V[i-1][j+1]+V[i-1][j])))
			                /2*(U[i][j]-U[i][j-1])/dy
			                +(1/4*(V[i][j+1]+V[i][j]+V[i-1][j+1]+V[i-1][j])
			                  -fabs(1/4
			                        *(V[i][j+1]+V[i][j]+V[i-1][j+1]+V[i-1][j])))
			                 /2*(U[i][j+1]-U[i][j])/dy)-(P[i][j]-P[i-1][j])/dx
			              +1/Re
			               *((U[i+1][j]-2*U[i][j]+U[i-1][j])/dx*dx
			                 +(U[i][j+1]-2*U[i][j]+U[i][j-1])/dy*dy));
		}
	}
}


void SlvV1()
{
	int i, j;
	for(i=2; i<=IMAX-1; i++) {
		for(j=2; j<=JMAX-2; j++) {
			V2[i][j] = V[i][j]
			           +dt
			            *(-((1/4*(U[i+1][j]+U[i+1][j-1]+U[i][j]+U[i][j-1])
			                 +fabs(1/4
			                       *(U[i+1][j]+U[i+1][j-1]+U[i][j]+U[i][j-1])))
			                /2*(V[i][j]-V[i-1][j])/dx
			                +(1/4*(U[i+1][j]+U[i+1][j-1]+U[i][j]+U[i][j-1])
			                  -fabs(1/4
			                        *(U[i+1][j]+U[i+1][j-1]+U[i][j]+U[i][j-1])))
			                 /2*(V[i+1][j]-V[i][j])/dx)
			              -((V[i][j]+fabs(V[i][j]))/2*(V[i][j]-V[i][j-1])/dy
			                +(V[i][j]-fabs(V[i][j]))/2*(V[i][j+1]-V[i][j])/dy)
			              -(P[i][j]-P[i][j-1])/dy
			              +1/Re
			               *((V[i+1][j]-2*V[i][j]+V[i-1][j])/dx*dx
			                 +(V[i][j+1]-2*V[i][j]+V[i][j-1])/dy*dy));
		}
	}
}


void SlvP1()
{
	int mI, mJ, mK, mJK, mMax, mMin, i, j, mI10, mI00, mIY0, mI01, mI0Y;
	double cnt;
	for(mI=1; mI<=MISzP1; mI++) {
		for(mJ=1; mJ<=MJSzP1; mJ++) {
			AmP1[mI][mJ] = 0;
		}
	}
	for(i=2; i<=IMAX-2; i++) {
		for(j=2; j<=JMAX-2; j++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI10 = iMxP1*(j-1)+(i+1)-mJ+MIDgP1;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
				mIY0 = iMxP1*(j-1)+(i-1)-mJ+MIDgP1;
				mI01 = iMxP1*j+i-mJ+MIDgP1;
				mI0Y = iMxP1*(j-2)+i-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI10][mJ] = dt*1/dx*dx;
				AmP1[mI00][mJ] = -dt*1/dx*dx*2-dt*1/dy*dy*2;
				AmP1[mIY0][mJ] = dt*1/dx*dx;
				AmP1[mI01][mJ] = dt*1/dy*dy;
				AmP1[mI0Y][mJ] = dt*1/dy*dy;
				AmP1[MISzP1][mJ] = (U2[i+1][j]-U2[i][j])/dx
				                   +(V2[i][j+1]-V2[i][j])/dy;
			}
		}
	}
	/* Boundary Conditions */
	{
		/* boundary condition on LEFT */
		i = 1;
		for(j=2; j<=JMAX-2; j++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI00][mJ] = 1;
				AmP1[MISzP1][mJ] = 0;
			}
		}
		/* boundary condition on RIGHT */
		i = IMAX-1;
		for(j=2; j<=JMAX-2; j++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI00][mJ] = 1;
				AmP1[MISzP1][mJ] = 0;
			}
		}
		/* boundary condition on BTTM */
		j = 1;
		for(i=1; i<=IMAX-1; i++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI01 = iMxP1*j+i-mJ+MIDgP1;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI01][mJ] = 1/dy;
				AmP1[mI00][mJ] = (-1/dy);
				AmP1[MISzP1][mJ] = 0;
			}
		}
		/* boundary condition on TOP */
		j = JMAX-1;
		for(i=1; i<=IMAX-1; i++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
				mI0Y = iMxP1*(j-2)+i-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI00][mJ] = 1/dy;
				AmP1[mI0Y][mJ] = (-1/dy);
				AmP1[MISzP1][mJ] = 0;
			}
		}
		/* boundary condition on InLeft */
		i = 12;
		for(j=18; j<=JMAX-16; j++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
				mIY0 = iMxP1*(j-1)+(i-1)-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI00][mJ] = 1/dx;
				AmP1[mIY0][mJ] = (-1/dx);
				AmP1[MISzP1][mJ] = 0;
			}
		}
		/* boundary condition on InRight */
		i = 19;
		for(j=18; j<=JMAX-16; j++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI10 = iMxP1*(j-1)+(i+1)-mJ+MIDgP1;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI10][mJ] = 1/dx;
				AmP1[mI00][mJ] = (-1/dx);
				AmP1[MISzP1][mJ] = 0;
			}
		}
		/* boundary condition on InBttm */
		j = 17;
		for(i=12; i<=IMAX-21; i++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
				mI0Y = iMxP1*(j-2)+i-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI00][mJ] = 1/dy;
				AmP1[mI0Y][mJ] = (-1/dy);
				AmP1[MISzP1][mJ] = 0;
			}
		}
		/* boundary condition on InTop */
		j = 25;
		for(i=12; i<=IMAX-21; i++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI01 = iMxP1*j+i-mJ+MIDgP1;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI01][mJ] = 1/dy;
				AmP1[mI00][mJ] = (-1/dy);
				AmP1[MISzP1][mJ] = 0;
			}
		}
	}
	/* Gauss Elimination Band Matrix Solver */
	{
		for(mJ=1; mJ<=MJSzP1; mJ++) {
			cnt = AmP1[MIDgP1][mJ];
			for(mI=1; mI<=MISzP1; mI++) {
				AmP1[mI][mJ] = AmP1[mI][mJ]/cnt;
			}
		}
		for(mK=1; mK<=MJSzP1-1; mK++) {
			cnt = AmP1[MIDgP1][mK];
			for(mI=MIDgP1; mI<=MISzP1; mI++) {
				AmP1[mI][mK] = AmP1[mI][mK]/cnt;
			}
			mMin = mK+MILWP1;
			if(mMin>MJSzP1) {
				mMin = MJSzP1;
			}
			for(mJ=mK+1; mJ<=mMin; mJ++) {
				mJK = mJ-mK;
				for(mI=MIDgP1-mJK+1; mI<=MILWP1+MIRWP1+1-mJK; mI++) {
					AmP1[mI][mJ] = AmP1[mI][mJ]-AmP1[mI+mJK][mK]*AmP1[MIDgP1
					                                                  -mJK][mJ];
				}
				AmP1[MISzP1][mJ] = AmP1[MISzP1][mJ]
				                   -AmP1[MISzP1][mK]*AmP1[MIDgP1-mJK][mJ];
			}
		}
		AmP1[MISzP1][MJSzP1] = AmP1[MISzP1][MJSzP1]/AmP1[MIDgP1][MJSzP1];
		for(mK=MJSzP1; mK>=2; mK-= 1) {
			mMax = mK-MILWP1;
			if(mMax<1) {
				mMax = 1;
			}
			for(mJ=mK-1; mJ>=mMax; mJ-= 1) {
				AmP1[MISzP1][mJ] = AmP1[MISzP1][mJ]
				                   -AmP1[MISzP1][mK]*AmP1[MIDgP1+mK-mJ][mJ];
			}
		}
		AmP1[MISzP1][1] = AmP1[MISzP1][1]/AmP1[MIDgP1][1];
		for(i=1; i<=IMAX-1; i++) {
			for(j=1; j<=JMAX-1; j++) {
				mJ = iMxP1*(j-1)+i;
				P2[i][j] = AmP1[MISzP1][mJ];
			}
		}
	}
}


void SlvU2()
{
	int i, j;
	for(i=2; i<=IMAX; i++) {
		for(j=1; j<=JMAX-1; j++) {
			U1[i][j] = U2[i][j]-dt*(P2[i][j]-P2[i-1][j])/dx;
		}
	}
	/* Boundary Conditions */
	{
		/* boundary condition on LEFT */
		i = 1;
		for(j=2; j<=JMAX-2; j++) {
			U1[i][j] = 2*U0-U1[i+1][j];
		}
		/* boundary condition on RIGHT */
		i = IMAX-1;
		for(j=2; j<=JMAX-2; j++) {
			U1[i+1][j] = 2*U0-U1[i][j];
		}
		/* boundary condition on BTTM */
		j = 1;
		for(i=1; i<=IMAX-1; i++) {
			U1[i][j] = 0;
		}
		/* boundary condition on TOP */
		j = JMAX-1;
		for(i=1; i<=IMAX-1; i++) {
			U1[i][j] = 0;
		}
		/* boundary condition on InLeft */
		i = 12;
		for(j=18; j<=JMAX-16; j++) {
			U1[i+1][j] = (-U1[i][j]);
		}
		/* boundary condition on InRight */
		i = 19;
		for(j=18; j<=JMAX-16; j++) {
			U1[i][j] = (-U1[i+1][j]);
		}
		/* boundary condition on InTop */
		j = 25;
		for(i=12; i<=IMAX-21; i++) {
			U1[i][j] = 0;
		}
		/* boundary condition on InBttm */
		j = 17;
		for(i=12; i<=IMAX-21; i++) {
			U1[i][j] = 0;
		}
	}
}


void SlvV2()
{
	int i, j;
	for(i=1; i<=IMAX; i++) {
		for(j=2; j<=JMAX; j++) {
			V1[i][j] = V2[i][j]-dt*(P2[i][j]-P2[i][j-1])/dy;
		}
	}
	/* Boundary Conditions */
	{
		/* boundary condition on LEFT */
		i = 1;
		for(j=2; j<=JMAX-2; j++) {
			V1[i][j] = 0;
		}
		/* boundary condition on RIGHT */
		i = IMAX-1;
		for(j=2; j<=JMAX-2; j++) {
			V1[i][j] = 0;
		}
		/* boundary condition on BTTM */
		j = 1;
		for(i=1; i<=IMAX-1; i++) {
			V1[i][j] = (-V1[i][j+1]);
		}
		/* boundary condition on TOP */
		j = JMAX-1;
		for(i=1; i<=IMAX-1; i++) {
			V1[i][j+1] = (-V1[i][j]);
		}
		/* boundary condition on InLeft */
		i = 12;
		for(j=18; j<=JMAX-16; j++) {
			V1[i][j] = 0;
		}
		/* boundary condition on InRight */
		i = 19;
		for(j=18; j<=JMAX-16; j++) {
			V1[i][j] = 0;
		}
		/* boundary condition on InBttm */
		j = 17;
		for(i=12; i<=IMAX-21; i++) {
			V1[i][j+1] = (-V1[i][j]);
		}
		/* boundary condition on InTop */
		j = 25;
		for(i=12; i<=IMAX-21; i++) {
			V1[i][j] = (-V1[i][j+1]);
		}
	}
}


void SlvP2()
{
	int i, j;
	for(i=1; i<=IMAX-1; i++) {
		for(j=1; j<=JMAX-1; j++) {
			P1[i][j] = P[i][j]+P2[i][j];
		}
	}
}


void subst()
{
	int i, j;
	for(i=1; i<=IMAX; i++) {
		for(j=1; j<=JMAX; j++) {
			U[i][j] = U1[i][j];
			V[i][j] = V1[i][j];
			P[i][j] = P1[i][j];
		}
	}
}


void output()
{
	int i, j;
	for(i=1; i<=IMAX; i++) {
		for(j=1; j<=JMAX; j++) {
			printf("%e %e %e \n",U[i][j],V[i][j],P[i][j]);
		}
	}
}


void init()
{
	int i, j;
	for(i=1; i<=IMAX; i++) {
		for(j=1; j<=JMAX; j++) {
			U[i][j] = 0;
			V[i][j] = 0;
			P[i][j] = 0;
		}
	}
}


