#include "stdafx.h"

#include "pde_msg.h"

#include "pde_adv.h"
#include "jd_alg.h"


//////////////////////  CJDSimpEqt  /////////////////////////
//////////////////////  CJDSimpEqt  /////////////////////////

BOOL CJDSimpEqt::Do(CObject *g)
{
	CSymbInst *pInst;
	pInst = (CSymbInst *) g;
	if(!m_bStartFg) {
		return FindStartCond(pInst);
	} else {
		CMapStringToOb para;
		BOOL okFg;
		POSITION pos;
		CViecFC *pE;

		okFg = FALSE;
		while(!okFg && pInst->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			pos = pInst->GetHeadPosition();
			while(pos) {
				pE = pInst->GetNext(pos);
				pE->SendMsg(MSG_DO_JOB, this);
			}
			switch(AnalyseSimpForm(pInst, para)) {
			case SIMP_PLUS_ABLE_FORM2:	/* 2+a+3+.. */
				SimpPlusAbleForm2(pInst, para);
				break;
			case SIMP_MULT_ABLE_FORM1:	/* 2a3.. */
				SimpMultAbleForm1(pInst, para);
				break;
			case SIMP_DIV_ABLE_FORM1:	/* 1/2... */
				SimpDivAbleForm1(pInst, para);
				break;
			case SIMP_DIV_ABLE_FORM2:	/* a/(a*b*c*..) */
			case SIMP_DIV_ABLE_FORM3:	/* (a*b*c*..)/a */
			case SIMP_DIV_ABLE_FORM4:	/* (a*b*c*..)/(a*d*e*..) */
				SimpDivAbleForm2(pInst, para);
				break;
			case SIMP_PLUS_INT_0:	// a+0..
				SimpPlusInt0(pInst, para);
				break;
			case SIMP_MULT_INT_0:	// a*0..
				SimpMultInt0(pInst, para);
				break;
			case SIMP_MULT_INT_1:	// a*1..
				SimpMultInt1(pInst, para);
				break;
			case SIMP_DIV_BY_1:		// a/1..
				SimpDivBy1(pInst, para);
				break;
			case SIMP_NEG_INT:		// (-? 1)
				SimpNegInt(pInst, para);
				break;
			case SIMP_INV_INV:		// 1/(1/X)
				SimpInvInv(pInst, para);
				break;
			case SIMP_NEG_DIV_NEG:	// (- (- X)/Y)
				SimpNegDivNeg(pInst,para);
				break;
			default:
				okFg = TRUE;
				break;
			}
		}
		m_cManipCnt++;
		pInst->CalcExt(CViecFC::dirDown);
		pInst->CalcExt();
		return TRUE;
	}
	return FALSE;
}

//////////////////////  CJDExpEqt  /////////////////////////
//////////////////////  CJDExpEqt  /////////////////////////

BOOL CJDExpEqt::Do(CObject *g)
{
	CSymbInst *pInst;
	pInst = (CSymbInst *) g;
	if(!m_bStartFg) {
		return FindStartCond(pInst);
	} else {
		CMapStringToOb para;
		int cManipCnt;
		BOOL okFg;
		POSITION pos;
		CViecFC *pE;
		EXP_ENUM exp_enum;
		okFg = FALSE;
		while(!okFg && pInst->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			pos = pInst->GetHeadPosition();
			while(pos) {
				pE = pInst->GetNext(pos);
				pE->SendMsg(MSG_DO_JOB, this);
			}
			exp_enum = AnalyseExpForm(pInst, para);
			switch(exp_enum) {
			case EXP_PLUS_IN_PLUS:	// a+(b+c)+..	->	a+b+c
				ExpPlusInPlus(pInst, para);
				cManipCnt++;
				break;
			case EXP_PLUS_IN_MULT:	// a(b+c+..)b..	->	abb+acb
				ExpPlusInMult(pInst, para);
				cManipCnt++;
				break;
			case EXP_MULT_IN_MULT:	// a(bc..)d..	->	abc..d..
				ExpMultInMult(pInst, para);
				cManipCnt++;
				break;
			case EXP_NEG_IN_MULT:	// a(-b)c..	->	(- abc)
				ExpNegInMult(pInst, para);
				cManipCnt++;
				break;
			case EXP_PLUS_IN_NUME:	// (a+b+..)/X	->	a/X+b/X+..
				ExpPlusInNume(pInst, para);
				cManipCnt++;
				break;
			case EXP_X_DIV_BY_Y:	//	X/Y	->	1/Y * X
				{
					CViecFC *pN, *pD, *pV;
					pN = (CViecFC *) para["NUME"];
					pD = (CViecFC *) para["DENO"];
					pInst->m_child.RemoveAll();
					pInst->ChangeInst("*");
					pV = new CSymbInst("/");
					pV->AddTail(new CMSFract(1));
					pV->AddTail(pD);
					pInst->AddTail(pV);
					pInst->AddTail(pN);
					pInst->OnCreated();
				}
				cManipCnt++;
				break;
			case EXP_PLUS_IN_NEG:	// (- (a+b+..)	->	(-a-b-..)
				ExpPlusInNeg(pInst, para);
				cManipCnt++;
				break;
			case EXP_NEG_IN_NEG:	/* -(-a) */
				ExpNegInNeg(pInst, para);
				cManipCnt++;
				break;
			default:
				okFg = TRUE;
			}
			if(!okFg) {
				pInst->CalcExt(CViecFC::dirDown);
				pInst->CalcExt();
			}
		}
		return TRUE;
	}
	return FALSE;
}

//////////////////////  CJDExpEqt2  /////////////////////////
//////////////////////  CJDExpEqt2  /////////////////////////

BOOL CJDExpEqt2::Do(CObject *g)
{
	CSymbInst *pInst;
	pInst = (CSymbInst *) g;
	if(!m_bStartFg) {
		return FindStartCond(pInst);
	} else {
		CMapStringToOb para;
		int cManipCnt;
		BOOL okFg;
		POSITION pos;
		CViecFC *pE;
		EXP_ENUM exp_enum;

		if(m_target.IsIncluded(pInst)) {
			cManipCnt = m_cManipCnt;
			okFg = FALSE;
			while(!okFg && pInst->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
				m_cManipCnt = 0;
				pos = pInst->GetHeadPosition();
				while(pos) {
					pE = pInst->GetNext(pos);
					pE->SendMsg(MSG_DO_JOB, this);
				}
				exp_enum = AnalyseExpForm(pInst, para);
				switch(exp_enum) {
				case EXP_PLUS_IN_PLUS:	// a+(b+c)+..	->	a+b+c
					ExpPlusInPlus(pInst, para);
					cManipCnt++;
					break;
				case EXP_PLUS_IN_MULT:	// a(b+c+..)b..	->	abb+acb
					ExpPlusInMult(pInst, para);
					cManipCnt++;
					break;
				case EXP_MULT_IN_MULT:	// a(bc..)d..	->	abc..d..
					if(ExpMultInMult(pInst, para))
						cManipCnt++;
					else
						okFg = TRUE;
					break;
				case EXP_NEG_IN_MULT:	// a(-b)c..	->	(- abc)
					ExpNegInMult(pInst, para);
					cManipCnt++;
					break;
				case EXP_PLUS_IN_NUME:	// (a+b+..)/X	->	a/X+b/X+..
					ExpPlusInNume(pInst, para);
					cManipCnt++;
					break;
				case EXP_X_DIV_BY_Y:	//	X/Y	->	1/Y * X
					{
						CViecFC *pN, *pD, *pV;
						pN = (CViecFC *) para["NUME"];
						pD = (CViecFC *) para["DENO"];
						pInst->m_child.RemoveAll();
						pInst->ChangeInst("*");
						pV = new CSymbInst("/");
						pV->AddTail(new CMSFract(1));
						pV->AddTail(pD);
						pInst->AddTail(pV);
						pInst->AddTail(pN);
						pInst->OnCreated();
					}
					cManipCnt++;
					break;
				case EXP_PLUS_IN_NEG:	// (- (a+b+..)	->	(-a-b-..)
					ExpPlusInNeg(pInst, para);
					cManipCnt++;
					break;
				case EXP_NEG_IN_NEG:	/* -(-a) */
					ExpNegInNeg(pInst, para);
					cManipCnt++;
					break;
				default:
					okFg = TRUE;
				}
				if(!okFg) {
					pInst->CalcExt(CViecFC::dirDown);
					pInst->CalcExt();
				}
			}
			m_cManipCnt = cManipCnt;
		}
		return TRUE;
	}
	return FALSE;
}

//////////////////////  CJDBindEqt  /////////////////////////
//////////////////////  CJDBindEqt  /////////////////////////

BOOL CJDBindEqt::Do(CObject *g)
{
	CSymbInst *pInst;
	pInst = (CSymbInst *) g;
	if(!m_bStartFg) {
		return FindStartCond(pInst);
	} else {
		CMapStringToOb para;
		if(!pInst->IsKindOf(RUNTIME_CLASS(CSymbInst)))	return FALSE;
		switch(AnalyseBindForm(pInst, para)) {
		case BIND_PLUS_ABLE_FORM1:
			BindPlusAbleForm1(pInst, para);
			break;
		default:
			return FALSE;
		}
		m_cManipCnt++;
		pInst->CalcExt(CViecFC::dirDown);
		pInst->CalcExt();
		return TRUE;
	}
	return FALSE;
}

//////////////////////  CJDExpEqtNum  /////////////////////////
//////////////////////  CJDExpEqtNum  /////////////////////////

BOOL CJDExpEqtNum::Do(CObject *g)
{
	CSymbInst *pInst;
	pInst = (CSymbInst *) g;
	if(!m_bStartFg) {
		return FindStartCond(pInst);
	} else {
		CMapStringToOb para;
		BOOL okFg;
		POSITION pos;
		CViecFC *pE;
		EXP_ENUM exp_enum;
		CSymbInst *pI;

		okFg = FALSE;
		while(!okFg && pInst->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			pos = pInst->GetHeadPosition();
			while(pos) {
				pE = pInst->GetNext(pos);
				pE->SendMsg(MSG_DO_JOB, this);
			}
			okFg = TRUE;
			exp_enum = AnalyseExpForm(pInst, para);
			switch(exp_enum) {
			case EXP_PLUS_IN_PLUS:	// a+(b+c)+..	->	a+b+c
				pos = pInst->GetHeadPosition();
				while(pos) {
					pI = (CSymbInst *) pInst->GetNext(pos);
					if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
						pI=NULL; break;
					}
					if(!pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))
						&& !pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
						pI=NULL; break;
					}
				}
				if(pI==NULL) break;
				ExpPlusInPlus(pInst, para);
				okFg = FALSE;
				break;
			case EXP_PLUS_IN_MULT:	// a(b+c+..)b..	->	abb+acb
				pos = pInst->GetHeadPosition();
				pE = pInst->GetNext(pos);
				if(!pE->IsKindOf(RUNTIME_CLASS(CMSFract))) break;
				pE = pInst->GetNext(pos);
				if(pE!=para["FIRST"]) break;
				ExpPlusInMult(pInst, para);
				okFg = FALSE;
				break;
			case EXP_MULT_IN_MULT:	// a(bc..)d..	->	abc..d..
				ExpMultInMult(pInst, para);
				okFg = FALSE;
				break;
			}
			if(!okFg) {
				pInst->CalcExt(CViecFC::dirDown);
				pInst->CalcExt();
			}
		}
		return TRUE;
	}
	return FALSE;
}

//////////////////////  CJDBindEqtNum  /////////////////////////
//////////////////////  CJDBindEqtNum  /////////////////////////

BOOL CJDBindEqtNum::Do(CObject *g)
{
	CSymbInst *pInst;
	pInst = (CSymbInst *) g;
	if(!m_bStartFg) {
		return FindStartCond(pInst);
	} else {
		CMapStringToOb para;
		if(!pInst->IsKindOf(RUNTIME_CLASS(CSymbInst)))	return FALSE;
		switch(AnalyseBindForm(pInst, para)) {
		case BIND_PLUS_ABLE_FORM2:
			BindPlusAbleForm2(pInst, para);
			break;
		default:
			return FALSE;
		}
		m_cManipCnt++;
		pInst->CalcExt(CViecFC::dirDown);
		pInst->CalcExt();
		return TRUE;
	}
	return FALSE;
}

///////////////////  CJDFormEqt  /////////////////////
///////////////////  CJDFormEqt  /////////////////////

CJDFormEqt::CJDFormEqt()
{
	m_solvType = SOLV_TYPE_UNKNOWN;
}

BOOL CJDFormEqt::FindStartCond(CSymbInst* pInst)
{
	CViecFC *pelm;
	POSITION pos;
	CViecFC *psym;

	if(pInst->IsKindOf(RUNTIME_CLASS(CPDETarget))) {
		CSymbInst *pInst2;
		CViecFC *psym2;
		CPDEDepInfo *pDep;
		psym = pInst->GetSymbBody();
		if(!psym->IsKindOf(RUNTIME_CLASS(CMSDepVar))) return TRUE;
		if(pInst->GetCount()==0) return TRUE;
		pDep = (CPDEDepInfo *) psym->GetParent();
		if(!pDep->IsKindOf(RUNTIME_CLASS(CPDEDepInfo))) return TRUE;
		pos = pInst->GetHeadPosition();
		pInst2 = (CSymbInst *) pInst->GetNext(pos);
		if(!pInst2->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
		psym2 = pInst2->GetSymbBody();
		if(psym2->IsKindOf(RUNTIME_CLASS(CMSIndex))) {
			m_target.m_theDep = (CMSPhys *) psym;
			m_target.m_timeIndex = (CMSIndex *) psym2;
			m_target.m_timeShift.m_value = 0;
			m_target.m_timeShift.m_deno = 1;
		} else if(psym2->IsKindOf(RUNTIME_CLASS(CMSOPlus)) && pInst2->GetCount()==2) {
			CSymbInst *pInst3;
			CViecFC *psym3;
			CMSFract *pfrct;
			pos = pInst2->GetHeadPosition();
			pInst3 = (CSymbInst *) pInst2->GetNext(pos);
			pfrct = (CMSFract *) pInst2->GetNext(pos);
			if(!pInst3->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
			psym3 = pInst3->GetSymbBody();
			if(!pfrct->IsKindOf(RUNTIME_CLASS(CMSFract))) return TRUE;
			if(!psym3->IsKindOf(RUNTIME_CLASS(CMSIndex))) return TRUE;
			m_target.m_theDep = (CMSPhys *) psym;
			m_target.m_timeIndex = (CMSIndex *) psym3;
			m_target.m_timeShift.m_value = pfrct->m_value;
			m_target.m_timeShift.m_deno = pfrct->m_deno;
		}
		return TRUE;
	}
	if(pInst->IsKindOf(RUNTIME_CLASS(CPDEDepPDE))) {
		CSymbInst *pE, *pL;
		if(pInst->GetCount()==2) {
			pos = pInst->GetHeadPosition();
			pInst->GetNext(pos);
			pelm = pInst->GetNext(pos);
			if(pelm->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
				pE = (CSymbInst *) pelm;
				if(pE->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOEqual))) {
					pos = pE->GetHeadPosition();
					pelm = pE->GetNext(pos);
					if(pelm->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
						pL = (CSymbInst *) pelm;
						if(pL->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
							m_solvType = SOLV_TYPE_IMPLICIT;
						} else {
							m_solvType = SOLV_TYPE_EXPLICIT;
						}
					}
				}
			}
		} else if(pInst->GetCount()>2) {
			m_solvType = SOLV_TYPE_EXPLICIT;
		}
		return FALSE;
	}
	if(pInst->IsKindOf(RUNTIME_CLASS(CPDEBoundCond))) {
		CPDEBoundDef *pBD;
		pBD = (CPDEBoundDef *) pInst->GetSymbBody();
		if(pBD->IsKindOf(RUNTIME_CLASS(CPDEBoundDef))) {
			m_pBoundDef = pBD;
			pos = pInst->GetHeadPosition();
			while(pos) {
				pInst->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
			}
			m_pBoundDef = NULL;
		}
		return TRUE;
	}
	return FALSE;
}

SOLV_TYPE CJDFormEqt::SetSolvForm(CSymbInst *pEql, BOOL chk)
{
	POSITION pos, pos2;
	CViecFC *pL, *pR, *pE;
	CViecFC cL, cR;
	CSymbInst *pI, *pLI, *pRI, *pV, *pM, *pN, *pP;
	CMSFract *pF;

	pos = pEql->GetHeadPosition();
	pL = pEql->GetNext(pos);
	pR = pEql->GetNext(pos);
	pEql->m_child.RemoveAll();
	//--- checking for the left side
	if(m_target.IsThis((CSymbInst *) pL)) {
		cL.AddTail(pL);
	} else if(pL->IsKindOf(RUNTIME_CLASS(CMSFract))) {
		pF = (CMSFract *) pL;
		if(pF->m_value!=0) {
			pF->m_value = - pF->m_value;
			cR.AddTail(pL);
		}
	} else if(pL->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		pLI = (CSymbInst *) pL;
		if(pLI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
			pos2 = pLI->GetHeadPosition();
			while(pos2)
				pV = (CSymbInst *) pI->GetNext(pos2);
			if(m_target.IsThis(pV)) {
				if(pI->GetCount()==2) {
					pM = pI;
				} else {
					pI->m_child.RemoveTail();
					pM = new CSymbInst("*");
					pM->AddTail(pI);
					pM->AddTail(pV);
				}
				cL.AddTail(pM);
			} else {
				pN = new CSymbInst("-?");
				pN->AddTail(pI);
				cR.AddTail(pN);
			}
		} else if(pLI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
			pos = pLI->GetHeadPosition();
			while(pos) {
				pE = pLI->GetNext(pos);
				if(pE->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
					pI = (CSymbInst *) pE;
					if(m_target.IsThis((CSymbInst *) pE)) {
						cL.AddTail(pLI);
					} else if(pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
						pos2 = pI->GetHeadPosition();
						while(pos2)
							pV = (CSymbInst *) pI->GetNext(pos2);
						if(m_target.IsThis(pV)) {
							if(pI->GetCount()==2) {
								pM = pI;
							} else {
								pI->m_child.RemoveTail();
								pM = new CSymbInst("*");
								pM->AddTail(pI);
								pM->AddTail(pV);
							}
							cL.AddTail(pM);
						} else {
							pN = new CSymbInst("-?");
							pN->AddTail(pI);
							cR.AddTail(pN);
						}
					} else if(pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
//						pos2 = pI->GetHeadPosition();
//						pM = (CSymbInst *) pI->GetNext(pos2);
//						pI->m_child.RemoveAll();
//						delete pI;
						pM = pI;
						if(pM->IsKindOf(RUNTIME_CLASS(CSymbInst))
						&& pM->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
							pos2 = pM->GetHeadPosition();
							while(pos2)
								pV = (CSymbInst *) pM->GetNext(pos2);
							if(m_target.IsThis(pV)) {
								if(pM->GetCount()==2) {
									pos2 = pM->GetHeadPosition();
									pE = pM->GetNext(pos2);
									pM->m_child.RemoveAll();
									pN = new CSymbInst("-?");
									pN->AddTail(pE);
									pM->AddTail(pN);
									pM->AddTail(pV);
								} else {
									pM->m_child.RemoveTail();
									pE = pM;
									pM = new CSymbInst("*");
									pN = new CSymbInst("-?");
									pN->AddTail(pE);
									pM->AddTail(pN);
									pM->AddTail(pV);
								}
								cL.AddTail(pM);
							} else {
								pN = new CSymbInst("-?");
								pN->AddTail(pM);
								cR.AddTail(pN);
							}
						} else {
							pN = new CSymbInst("-?");
							pN->AddTail(pM);
							cR.AddTail(pN);
						}
					} else {
						pN = new CSymbInst("-?");
						pN->AddTail(pI);
						cR.AddTail(pN);
					}
				} else {
					pN = new CSymbInst("-?");
					pN->AddTail(pE);
					cR.AddTail(pN);
				}
			}
			pLI->m_child.RemoveAll();
			delete pLI;
		} else {
			pN = new CSymbInst("-?");
			pN->AddTail(pL);
			cR.AddTail(pN);
		}
	} else {
		pN = new CSymbInst("-?");
		pN->AddTail(pL);
		cR.AddTail(pN);
	}
	//--- check for right side
	if(pR->IsKindOf(RUNTIME_CLASS(CMSFract)) 
		&& ((CMSFract*)pR)->m_value==0) {
	} else {
		cR.AddTail(pR);
	}

	//--- create result
	if(cL.GetCount()==1) {
		pos = cL.GetHeadPosition();
		pEql->AddTail(cL.GetNext(pos));
	} else if(cL.GetCount()==0) {
		pEql->AddTail(new CMSFract(0));
	} else {
		pP = new CSymbInst("+");
		pEql->AddTail(pP);
		pos = cL.GetHeadPosition();
		while(pos) {
			pP->AddTail(cL.GetNext(pos));
		}
	}
	if(cR.GetCount()==1) {
		pos = cR.GetHeadPosition();
		pEql->AddTail(cR.GetNext(pos));
	} else if(cR.GetCount()==0) {
		pEql->AddTail(new CMSFract(0));
	} else {
		pP = new CSymbInst("+");
		pEql->AddTail(pP);
		pos = cR.GetHeadPosition();
		while(pos) {
			pP->AddTail(cR.GetNext(pos));
		}
	}
	if(chk) {
		if(cL.GetCount()>1)
			m_solvType = SOLV_TYPE_IMPLICIT;
		else if(cL.GetCount()==1)
			m_solvType = SOLV_TYPE_EXPLICIT;
		else
			m_solvType = SOLV_TYPE_UNKNOWN;
	}
	cL.m_child.RemoveAll();
	cR.m_child.RemoveAll();
	pEql->OnCreated();
	return m_solvType;
}

BOOL CJDFormEqt::FormImplicit(CSymbInst *pEql)
{
	return TRUE;
}

BOOL CJDFormEqt::FormExplicit(CSymbInst *pEql)
{
	POSITION pos;
	CViecFC *pL, *pR, *pD, *pV;
	CSymbInst *pI, *pM;
	CMSFract *pF1, *pF2;
	pos = pEql->GetHeadPosition();
	pL = pEql->GetNext(pos);
	pR = pEql->GetNext(pos);
	if(pL->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		pI = (CSymbInst *) pL;
		if(pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult)) && pI->GetCount()==2) {
			pos = pI->GetHeadPosition();
			pL = pI->GetNext(pos);
			pV = pI->GetNext(pos);
			pI->m_child.RemoveAll();
			if(pL->IsKindOf(RUNTIME_CLASS(CMSFract))) {
				pF1 = (CMSFract *) pL;
				pM = (CSymbInst *) pR;
				if(pM->IsKindOf(RUNTIME_CLASS(CSymbInst))
					&& pM->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
					pos = pM->GetHeadPosition();
					pF2 = (CMSFract *) pM->GetNext(pos);
					if(pF2->IsKindOf(RUNTIME_CLASS(CMSFract))) {
						pF2->Mult(pF1->m_deno, pF1->m_value);
						delete pF1;
					} else {
						pM->m_child.AddHead(pF1);
						pF1->SetParent(pM);
					}
					delete pI;
					pI = pM;
				} else {
					int val = pF1->m_value;
					if(val>=0) {
						pF1->m_value = pF1->m_deno;
						pF1->m_deno = val;
					} else {
						pF1->m_value = - (int) pF1->m_deno;
						pF1->m_deno = (unsigned int) - val;
					}
					pI->AddTail(pF1);
					pI->AddTail(pR);
				}
			} else {
				pD = new CSymbInst("/");
				pD->AddTail(new CMSFract(1));
				pD->AddTail(pL);
				pI->AddTail(pD);
				pI->AddTail(pR);
			}
			pEql->m_child.RemoveAll();
			pEql->AddTail(pV);
			pEql->AddTail(pI);
			pEql->OnCreated();
		}
	}
	return TRUE;
}

BOOL CJDFormEqt::FormExplicitBC(CSymbInst *pEql)
{
	// Boundary Condition ??

//			pBD->m_surf->m_pHalfDir->m_bPosDir
//			pBD->m_surf->m_pHalfDir->m_bHalf
//			pBD->m_surf->m_axisNo+1
//			pBD->m_surf->m_axisNo+1
	POSITION pos, pos2, pos3;
	CViecFC *pL, *pR;
	CSymbInst *pM, *pV, *pZ, *pI, *pX, *pP;
	int i;
	pos = pEql->GetHeadPosition();
	pL = pEql->GetNext(pos);
	pR = pEql->GetNext(pos);
	for(i=0;i<4;i++) {
		m_shift[i].m_value = 0;
		m_shift[i].m_deno = 1;
	}
	if(pL->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		pI = (CSymbInst *) pL;
		if(pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
			pZ = NULL;
			pos = pI->GetHeadPosition();
			while(pos) {
				pM = (CSymbInst *) pI->GetNext(pos);
				if(pM->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
					if(pM->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
						pos2 = pM->GetHeadPosition();
						pM->GetNext(pos2);
						pV = (CSymbInst *) pM->GetNext(pos2);
						pos3 = pV->GetHeadPosition();
						for(i=0; pos3; i++) {
							pX = (CSymbInst *) pV->GetNext(pos3);
							if(i==m_pBoundDef->m_surf->m_axisNo+1) {
								break;
							}
						}
						if(i==m_pBoundDef->m_surf->m_axisNo+1) {
							CMSFract Old, *pShf, shf;
							if(pX->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
								shf.m_value=0;
								if(pX->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
									pos3 = pX->GetHeadPosition();
									pX->GetNext(pos3);
									pShf = (CMSFract *) pX->GetNext(pos3);
									if(pShf->IsKindOf(RUNTIME_CLASS(CMSFract))) {
										shf.m_value = pShf->m_value;
										shf.m_deno = pShf->m_deno;
									}
								}
								Old.m_value = m_shift[i].m_value;
								Old.m_deno = m_shift[i].m_deno;
								if(Old.m_deno!=shf.m_deno) {
									Old.Mult(shf.m_deno, shf.m_deno);
									shf.Mult(Old.m_deno, Old.m_deno);
								}
								if(m_pBoundDef->m_surf->m_pHalfDir->m_bPosDir) {
									if(shf.m_value <= Old.m_value) {
										m_shift[i].m_value = shf.m_value;
										m_shift[i].m_deno = shf.m_deno;
										pZ = pM;
									}
								} else {
									if(shf.m_value >= Old.m_value) {
										m_shift[i].m_value = shf.m_value;
										m_shift[i].m_deno = shf.m_deno;
										pZ = pM;
									}
								}
							}
						}
					}
				}
			}
			//--- plus (pI)
			if(pZ) {
				CViecFC cR;
				BOOL okFg;
				pos = pI->GetHeadPosition();
				while(pos) {
					pM = (CSymbInst *) pI->GetNext(pos);
					if(pZ!=pM)
						cR.AddTail(pM);
				}
				pI->m_child.RemoveAll();
				delete pI;
				okFg = FALSE;
				if(pR->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
					pM = (CSymbInst *) pR;
					if(pM->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
						pos = cR.GetHeadPosition();
						while(pos) {
							pR->AddTail(cR.GetNext(pos));
						}
						okFg = TRUE;
					}
				}
				if(pR->IsKindOf(RUNTIME_CLASS(CMSFract))) {
					CMSFract *pF;
					pF = (CMSFract *) pR;
					if(pF->m_value==0) {
						delete pR;
						pR = NULL;
					}
				}
				if(!okFg) {
					CSymbInst *pN;
					if(cR.GetCount()+((pR==NULL)? 0:1)>1) {
						pP = new CSymbInst("+");
						if(pR) pP->AddTail(pR);
						pos = cR.GetHeadPosition();
						while(pos) {
							pN = new CSymbInst("-?");
							pN->AddTail(cR.GetNext(pos));
							pP->AddTail(pN);
						}
						pR = pP;
					} else if(pR==NULL) {
						pos = cR.GetHeadPosition();
						pN = new CSymbInst("-?");
						pN->AddTail(cR.GetNext(pos));
						pR = pN;
					}
				}
				cR.m_child.RemoveAll();
				pEql->m_child.RemoveAll();
				pEql->AddTail(pZ);
				pEql->AddTail(pR);
				pEql->OnCreated();
			}
		}
		//--- symbInst
		return FormExplicit(pEql);
	}
	return TRUE;
}

BOOL CJDFormEqt::Do(CObject *g)
{
	CSymbInst *pInst;
	pInst = (CSymbInst *) g;
	if(FindStartCond(pInst))
		return TRUE;
	if(pInst->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOEqual))) {
			if(!m_target.m_theDep || !m_target.m_timeIndex) return TRUE;
			if(m_pBoundDef==NULL) {
				switch(SetSolvForm(pInst, TRUE)) {
				case SOLV_TYPE_EXPLICIT:
					FormExplicit(pInst);
					break;
				case SOLV_TYPE_IMPLICIT:
					return TRUE;
				}
			} else {
				CJDExpEqt exp;
				CJDSimpEqt simp;
				switch(SetSolvForm(pInst, FALSE)) {
				case SOLV_TYPE_EXPLICIT:
					FormExplicitBC(pInst);
					exp.Copy(this);
					pInst->SendMsg(MSG_DO_JOB, &exp);
					simp.Copy(this);
					pInst->SendMsg(MSG_DO_JOB, &simp);
					break;
				case SOLV_TYPE_IMPLICIT:
					return TRUE;
				}
			}
			pInst->CalcExt(CViecFC::dirDown);
			pInst->CalcExt();

			return TRUE;
		}
	}
	return FALSE;
}

