#include "stdafx.h"

#include "pde_prg.h"
#include "jd_prc.h"


////////////// Band Matrix Solver //////////////
////////////// Band Matrix Solver //////////////

void CJDCreateProc::InitBandMatrix()
{
	CalcSkipWdBandMtx();

	sAmtx = CString("Am")+m_name;
//	sBvct = CString("Bv")+m_name;
//	sFvct = CString("Fv")+m_name;

	m_pAm = new CMSPDEMtx;
	m_pAm->SetName(sAmtx);
	m_pAm->AddTail(new CSymbInst(sMtxISz));
	m_pAm->AddTail(new CSymbInst(sMtxJSz));
	m_pMainProcGen->pMtxDefs->AddTail(m_pAm);

//	m_pBv = new CMSPDEVct;
//	m_pBv->SetName(sBvct);
//	m_pBv->AddTail(new CSymbInst(sMtxJSz));
//	m_pMainProcGen->pMtxDefs->AddTail(m_pBv);

//	m_pFv = new CMSPDEVct;
//	m_pFv->SetName(sFvct);
//	m_pFv->AddTail(new CSymbInst(sMtxJSz));
//	m_pMainProcGen->pMtxDefs->AddTail(m_pFv);

	CMSIndex *pMi, *pMj, *pMk, *pMmax, *pMmin;
	pMi = new CMSIndex;
	pMi->SetName("mI");
	m_pVars->AddTail(pMi);
	pMj = new CMSIndex;
	pMj->SetName("mJ");
	m_pVars->AddTail(pMj);
	pMk = new CMSIndex;
	pMk->SetName("mK");
	m_pVars->AddTail(pMk);

	pMk = new CMSIndex;
	pMk->SetName("mJK");
	m_pVars->AddTail(pMk);

	pMmax = new CMSIndex;
	pMmax->SetName("mMax");
	m_pVars->AddTail(pMmax);

	pMmin = new CMSIndex;
	pMmin->SetName("mMin");
	m_pVars->AddTail(pMmin);

	//--- matrix elements clear
	CPDFor *pForI, *pForJ;
	CPDForSub *pSbI, *pSbJ;
	CSymbInst *pM0, *pD1;
	CPDSubst *psbst;

	pForI = new CPDFor;
	pSbI = new CPDForSub;
	pSbI->AddTail(new CSymbInst("mI"));
	pSbI->AddTail(new CMSFract(1));
	pSbI->AddTail(new CSymbInst(sMtxISz));
	pForI->AddTail(pSbI);

	pForJ = new CPDFor;
	pSbJ = new CPDForSub;
	pSbJ->AddTail(new CSymbInst("mJ"));
	pSbJ->AddTail(new CMSFract(1));
	pSbJ->AddTail(new CSymbInst(sMtxJSz));
	pForJ->AddTail(pSbJ);
	pForI->AddTail(pForJ);

	pM0 = new CSymbInst("=");
	pD1 = new CSymbInst(sAmtx);
	pD1->AddTail(new CSymbInst("mI"));
	pD1->AddTail(new CSymbInst("mJ"));
	pM0->AddTail(pD1);
	pM0->AddTail(new CMSFract(0));
	psbst = new CPDSubst;
	psbst->AddTail(pM0);
	pForJ->AddTail(psbst);

	pSlvProc->AddTail(pForI);
}

BOOL CJDCreateProc::CreateBandMtxSlv(CViecFC *pPrnt, CSymbInst *pEqt)
{
	CSymbInst *pIL, *pIR, *pV, *pTm, *pEq1, *pMx;
	POSITION pos;
	CPDSubst *pSbst;
	CViecFC *pPrnt0;
	CViecFC *pL = pEqt->GetChild(0);
	CViecFC *pR = pEqt->GetChild(1);

	if(!pL->IsKindOf(RUNTIME_CLASS(CSymbInst))) return FALSE;
	if(!pPrnt->IsKindOf(RUNTIME_CLASS(CViecFC))) return FALSE;

	pPrnt0 = pPrnt;
	//---	variables declaration
//	pVars = new CPDVar;
//	pPrnt->AddTail(pVars);

	pPrnt = new CPDBlock();
	((CViecFC*)pPrnt)->SetName("Calculating the subscript number");
	((CPad*)pPrnt)->SetMode(CPElem::modeClose);
	pPrnt0->AddTail(pPrnt);

	pIL = (CSymbInst *) pL;	// left side
	pIR = (CSymbInst *) pR;	// right side

	//--- calculate the diagonal elements of matrix
	//--- create the I00 = wd * j + 1
	//---            I10 = wd * (j+1) + 0
	pV = NULL;
	m_nShift[0] = m_nShift[1] = 0;
	CalcMtxNoEqtFullMtx(pPrnt, "mJ");
	//---  only 1 term on left side
	if(pIL->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSDepVar))) {
		pTm = pIL;
		if(pTm->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult)) && pTm->GetCount()==2) {
			// with factor multiplied 
			pV = (CSymbInst *) pTm->GetChild(1);
		} else if(pTm->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSDepVar))) {
			// without factor multiplied 
			pV = pTm;
		}
		if(pV)
			CreateBandMtxSlvNum(pPrnt, pV);
	}
	//---	if left side is like aV+bV+..
	if(pIL->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
		pos = pIL->GetHeadPosition();
		while(pos) {
			pV = NULL;
			pTm = (CSymbInst *) pIL->GetNext(pos);
			if(!pTm->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
			if(pTm->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
				// with factor multiplied 
				if(pTm->GetCount()!=2) continue;
				pV = (CSymbInst *) pTm->GetChild(1);
			} else if(pTm->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSDepVar))) {
				// without factor multiplied 
				pV = pTm;
			}
			if(pV)
				CreateBandMtxSlvNum(pPrnt, pV);
		}
	}
	if(m_midPos<0)
		return FALSE;

	while(pLeftWg->GetCount())	delete pLeftWg->RemoveTail();
	while(pRightWg->GetCount())	delete pRightWg->RemoveTail();
	while(pMxISz->GetCount())	delete pMxISz->RemoveTail();

	CSymbInst *pMlt, *pPls;

	int nLeftWg = - m_nLeftWing;
	if(nLeftWg/10==0) {
		pLeftWg->AddTail(new CMSFract(nLeftWg));
	} else {
		pPls = new CSymbInst("+");
		pMlt = new CSymbInst("*");
		pLeftWg->AddTail(pPls);
		pPls->AddTail(pMlt);
		pMlt->AddTail(new CSymbInst(sMax[0]));
		pMlt->AddTail(new CMSFract(nLeftWg/10));
		pPls->AddTail(new CMSFract(nLeftWg%10));
	}
	if(m_nRightWing/10==0) {
		pRightWg->AddTail(new CMSFract(m_nRightWing));
	} else {
		pPls = new CSymbInst("+");
		pMlt = new CSymbInst("*");
		pRightWg->AddTail(pPls);
		pPls->AddTail(pMlt);
		pMlt->AddTail(new CSymbInst(sMax[0]));
		pMlt->AddTail(new CMSFract(m_nRightWing/10));
		pPls->AddTail(new CMSFract(m_nRightWing%10));
	}

	pPls = new CSymbInst("+");
	pMxISz->AddTail(pPls);
	pPls->AddTail(new CSymbInst(sLeftWg));
	pPls->AddTail(new CSymbInst(sRightWg));
	pPls->AddTail(new CMSFract(2));

//	pLeftWg->AddTail(new CMSFract(m_nLeftWing));
//	pRightWg->AddTail(new CMSFract(m_nRightWing));

	pPrnt = new CPDBlock();
	((CViecFC*)pPrnt)->SetName("matrix element setting");
	((CPad*)pPrnt)->SetMode(CPElem::modeClose);
	pPrnt0->AddTail(pPrnt);

	if(pIL->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
		//---	the substitution statement
		pos = pIL->GetHeadPosition();
		while(pos) {
			pTm = (CSymbInst *) pIL->GetNext(pos);
			if(!pTm->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
			CreateMtxSlvSet(pPrnt, pTm);
		}
	} else if(pIL->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		CreateMtxSlvSet(pPrnt, pIL);
	}
	//---	the right side vector
	pSbst = new CPDSubst;
	pPrnt->AddTail(pSbst);
	pEq1 = new CSymbInst("=");
	pSbst->AddTail(pEq1);
	pMx = new CSymbInst(sAmtx);
	pEq1->AddTail(pMx);
	pEq1->AddTail(pIR->Copy());
	pMx->AddTail(new CSymbInst(sMtxISz));
	pMx->AddTail(new CSymbInst("mJ"));

	return TRUE;
}

BOOL CJDCreateProc::BandMatrixGaussSlv(CViecFC *pPrnt)
{
	//--- elemination method
	CPDFor *pForI, *pForJ, *pForK;
	CPDForSub *pSbI, *pSbJ, *pSbK;
	CSymbInst *pInstK, *pEq;

	CViecFC *pP0 = pPrnt;
	CPDBlock *pBlk = new CPDBlock;
	pBlk->SetName("Gauss Elimination Band Matrix Solver");
	pPrnt->AddTail(pBlk);
	pBlk->SetMode(CPElem::modeClose);
	pPrnt = pBlk;

	//	double cnt;
	//	int mI,mJ,mK,mMax,mMin
	//	for mJ=1 to MJSz {
	//		cnt = Mtx(MIDg, mJ)
	//		for mI = 1 to MISz {
	//			Mtx(mI, mJ) = Mtx(mI, mJ) cnt
	//		}
	//	}
	//	for mK=1 to MJSz-1 {
	//		cnt = Mtx(MIDg, mK)
	//		for mI=MIDg to MISz {
	//			Mtx(mI,mK) = Mtx(mI, mK) / cnt
	//		}
	//		mMin = mK+MILW
	//		if mMin>MJSz {
	//			mMin = MJSz
	//		}
	//		for mJ=mK+1 to mMin {
	//			mJK = mJ-mK
	//			for mI = MIDg-mJK[+1] to MILW+MIRW+1-mJK {
	//				Mtx(mI,mJ) = Mtx(mI,mJ) - Mtx(mI+mJK, mK) * Mtx(MIDG-mJK, mJ)
	//			}
	//			Mtx(MISz, mJ) = Mtx(MISz, mJ) - Mtx(MISz, mK) * Mtx(MIDg-mJK, mJ)
	//		}
	//	}
	//	Mtx(MISz, MJSz) = Mtx(MISz, MJSz) / Mtx(MIDg, MJSz)
	//	for mK = mJSz to 2 step -1 {
	//		mMax = mK-MILW
	//		if mMax<1 {
	//			mMax = 1
	//		}
	//		for mJ = mK-1 to mMax step -1 {
	//			Mtx(MISz, mJ) = Mtx(MISz,mJ) - Mtx(MISz, mK) * Mtx(MIDg+mK-mJ, mJ)
	//		}
	//	}
	//	Mtx(MISz,1) = Mtx(MISz,1) / Mtx(MIDg,1)

	//	double cnt;
	//	int mI,mJ,mK,mMax,mMin
	CMSConst *pCnt;
	pCnt = new CMSConst;
	pCnt->SetName("cnt");
	m_pVars->AddTail(pCnt);

	//	for mJ=1 to MJSz {
	//		cnt = Mtx(MIDg, mJ)
	//		for mI = 1 to MISz {
	//			Mtx(mI, mJ) = Mtx(mI, mJ) cnt
	//		}
	//	}
	//--- elimination
	pForJ = new CPDFor;
	pSbJ = new CPDForSub;
	pSbJ->AddTail(new CSymbInst("mJ"));
	pSbJ->AddTail(new CMSFract(1));
	pSbJ->AddTail(new CSymbInst(sMtxJSz));
	pForJ->AddTail(pSbJ);
	pPrnt->AddTail(pForJ);

	CSymbInst *pCI = new CSymbInst("cnt");
	pEq = new CSymbInst("=");
	CSymbInst *pMx = new CSymbInst(sAmtx);
	CPDSubst *pSb = new CPDSubst;
	pForJ->AddTail(pSb);
	pSb->AddTail(pEq);
	pEq->AddTail(pCI);
	pEq->AddTail(pMx);
	pMx->AddTail(new CSymbInst(sDiagCol));
	pMx->AddTail(new CSymbInst("mJ"));

	pForI = new CPDFor;
	pSbI = new CPDForSub;
	pSbI->AddTail(new CSymbInst("mI"));
	pSbI->AddTail(new CMSFract(1));
	pSbI->AddTail(new CSymbInst(sMtxISz));
	pForI->AddTail(pSbI);
	pForJ->AddTail(pForI);

	pSb = new CPDSubst;
	pForI->AddTail(pSb);
	pEq = new CSymbInst("=");
	pSb->AddTail(pEq);
	pMx = new CSymbInst(sAmtx);
	pEq->AddTail(pMx);
	pMx->AddTail(new CSymbInst("mI"));
	pMx->AddTail(new CSymbInst("mJ"));

	CSymbInst *pDv;
	pDv = new CSymbInst("/");
	pEq->AddTail(pDv);
	pMx = new CSymbInst(sAmtx);
	pDv->AddTail(pMx);
	pDv->AddTail(new CSymbInst("cnt"));
	pMx->AddTail(new CSymbInst("mI"));
	pMx->AddTail(new CSymbInst("mJ"));

	//	for mK=1 to MJSz-1 {
	//		cnt = Mtx(MIDg, mK)
	//		for mI=MIDg to MISz {
	//			Mtx(mI,mK) = Mtx(mI, mK) / cnt
	//		}
	pForK = new CPDFor;
	pPrnt->AddTail(pForK);
	pSbK = new CPDForSub;
	pForK->AddTail(pSbK);
	pSbK->AddTail(new CSymbInst("mK"));
	pSbK->AddTail(new CMSFract(1));
	CSymbInst *pPls = new CSymbInst("+");
	pSbK->AddTail(pPls);
	pPls->AddTail(new CSymbInst(sMtxJSz));
	pPls->AddTail(new CMSFract(-1));
	
	pSb = new CPDSubst;
	pForK->AddTail(pSb);
	pEq = new CSymbInst("=");
	pSb->AddTail(pEq);
	pCI = new CSymbInst("cnt");
	pMx = new CSymbInst(sAmtx);
	pEq->AddTail(pCI);
	pEq->AddTail(pMx);
	pMx->AddTail(new CSymbInst(sDiagCol));
	pMx->AddTail(new CSymbInst("mK"));

	pForI = new CPDFor;
	pForK->AddTail(pForI);
	pSbI = new CPDForSub;
	pForI->AddTail(pSbI);
	pSbI->AddTail(new CSymbInst("mI"));
	pSbI->AddTail(new CSymbInst(sDiagCol));
	pSbI->AddTail(new CSymbInst(sMtxISz));

	pSb = new CPDSubst;
	pForI->AddTail(pSb);
	pEq = new CSymbInst("=");
	pSb->AddTail(pEq);
	pMx = new CSymbInst(sAmtx);
	pEq->AddTail(pMx);
	pMx->AddTail(new CSymbInst("mI"));
	pMx->AddTail(new CSymbInst("mK"));
	pDv = new CSymbInst("/");
	pEq->AddTail(pDv);
	pMx = new CSymbInst(sAmtx);
	pDv->AddTail(pMx);
	pMx->AddTail(new CSymbInst("mI"));
	pMx->AddTail(new CSymbInst("mK"));
	pDv->AddTail(new CSymbInst("cnt"));

	//		mMin = mK+MILW
	//		if mMin>MJSz {
	//			mMin = MJSz
	//		}
	//		for mJ=mK+1 to mMin {
	pSb = new CPDSubst;
	pForK->AddTail(pSb);
	pEq = new CSymbInst("=");
	pSb->AddTail(pEq);
	pEq->AddTail(new CSymbInst("mMin"));
	pPls = new CSymbInst("+");
	pEq->AddTail(pPls);
	pPls->AddTail(new CSymbInst("mK"));
	pPls->AddTail(new CSymbInst(sLeftWg));

	CPDIf *pIf = new CPDIf;
	pForK->AddTail(pIf);
	pEq = new CSymbInst(">");
	pIf->AddTail(pEq);
	pEq->AddTail(new CSymbInst("mMin"));
	pEq->AddTail(new CSymbInst(sMtxJSz));
	CPDBlock *pThen = new CPDBlock;
	pIf->AddTail(pThen);
	pSb = new CPDSubst;
	pThen->AddTail(pSb);
	pEq = new CSymbInst("=");
	pSb->AddTail(pEq);
	pEq->AddTail(new CSymbInst("mMin"));
	pEq->AddTail(new CSymbInst(sMtxJSz));
	pIf->AddTail(new CPDBlock);

	pForJ = new CPDFor;
	pForK->AddTail(pForJ);
	pSbJ = new CPDForSub;
	pForJ->AddTail(pSbJ);
	pSbJ->AddTail(new CSymbInst("mJ"));
	pPls = new CSymbInst("+");
	pSbJ->AddTail(pPls);
	pPls->AddTail(new CSymbInst("mK"));
	pPls->AddTail(new CMSFract(1));
	pSbJ->AddTail(new CSymbInst("mMin"));

	//			mJK = mJ-mK
	//			for mI = MIDg-mJK[+1] to MILW+MIRW+1-mJK {
	pSb = new CPDSubst;
	pForJ->AddTail(pSb);
	pEq = new CSymbInst("=");
	pSb->AddTail(pEq);
	pEq->AddTail(new CSymbInst("mJK"));
	pPls = new CSymbInst("+");
	pEq->AddTail(pPls);
	pPls->AddTail(new CSymbInst("mJ"));
	CSymbInst *pMn;
	pMn = new CSymbInst("-?");
	pPls->AddTail(pMn);
	pInstK = new CSymbInst("mK");
	pMn->AddTail(pInstK);

	pForI = new CPDFor;
	pForJ->AddTail(pForI);
	pSbI = new CPDForSub;
	pForI->AddTail(pSbI);
	pSbI->AddTail(new CSymbInst("mI"));

	pPls = new CSymbInst("+");
	pSbI->AddTail(pPls);
	pPls->AddTail(new CSymbInst(sDiagCol));
	pMn = new CSymbInst("-?");
	pPls->AddTail(pMn);
	pPls->AddTail(new CMSFract(1));
	pMn->AddTail(new CSymbInst("mJK"));

	pPls = new CSymbInst("+");
	pSbI->AddTail(pPls);
	pPls->AddTail(new CSymbInst(sLeftWg));
	pPls->AddTail(new CSymbInst(sRightWg));
	pPls->AddTail(new CMSFract(1));
	pMn = new CSymbInst("-?");
	pPls->AddTail(pMn);
	pMn->AddTail(new CSymbInst("mJK"));

	//				Mtx(mI,mJ) = Mtx(mI,mJ) - Mtx(mI+mJK, mK) * Mtx(MIDG-mJK, mJ)
	//			}
	pSb = new CPDSubst;
	pForI->AddTail(pSb);
	pEq = new CSymbInst("=");
	pSb->AddTail(pEq);
	pMx = new CSymbInst(sAmtx);
	pEq->AddTail(pMx);
	pMx->AddTail(new CSymbInst("mI"));
	pMx->AddTail(new CSymbInst("mJ"));

	pPls = new CSymbInst("+");
	pEq->AddTail(pPls);
	pMx = new CSymbInst(sAmtx);
	pPls->AddTail(pMx);
	pMx->AddTail(new CSymbInst("mI"));
	pMx->AddTail(new CSymbInst("mJ"));
	pMn = new CSymbInst("-?");
	pPls->AddTail(pMn);

	CSymbInst *pMlt;
	pMlt = new CSymbInst("*");
	pMn->AddTail(pMlt);
	pMx = new CSymbInst(sAmtx);
	pMlt->AddTail(pMx);
	pPls = new CSymbInst("+");
	pMx->AddTail(pPls);
	pPls->AddTail(new CSymbInst("mI"));
	pPls->AddTail(new CSymbInst("mJK"));
	pMx->AddTail(new CSymbInst("mK"));
	pMx = new CSymbInst(sAmtx);
	pMlt->AddTail(pMx);
	pPls = new CSymbInst("+");
	pMx->AddTail(pPls);
	pMn = new CSymbInst("-?");
	pPls->AddTail(new CSymbInst(sDiagCol));
	pPls->AddTail(pMn);
	pMn->AddTail(new CSymbInst("mJK"));
	pMx->AddTail(new CSymbInst("mJ"));

	//			Mtx(MISz, mJ) = Mtx(MISz, mJ) - Mtx(MISz, mK) * Mtx(MIDg-mJK, mJ)
	//		}
	//	}
	pSb = new CPDSubst;
	pForJ->AddTail(pSb);
	pEq = new CSymbInst("=");
	pSb->AddTail(pEq);

	pMx = new CSymbInst(sAmtx);
	pEq->AddTail(pMx);
	pMx->AddTail(new CSymbInst(sMtxISz));
	pMx->AddTail(new CSymbInst("mJ"));
	pPls = new CSymbInst("+");
	pEq->AddTail(pPls);

	pMx = new CSymbInst(sAmtx);
	pPls->AddTail(pMx);
	pMx->AddTail(new CSymbInst(sMtxISz));
	pMx->AddTail(new CSymbInst("mJ"));

	pMn = new CSymbInst("-?");
	pPls->AddTail(pMn);
	pMlt = new CSymbInst("*");
	pMn->AddTail(pMlt);

	pMx = new CSymbInst(sAmtx);
	pMlt->AddTail(pMx);
	pMx->AddTail(new CSymbInst(sMtxISz));
	pMx->AddTail(new CSymbInst("mK"));

	pMx = new CSymbInst(sAmtx);
	pMlt->AddTail(pMx);
	pPls = new CSymbInst("+");
	pMx->AddTail(pPls);
	pPls->AddTail(new CSymbInst(sDiagCol));
	pMn = new CSymbInst("-?");
	pPls->AddTail(pMn);
	pMn->AddTail(new CSymbInst("mJK"));
	pMx->AddTail(new CSymbInst("mJ"));

	//	Mtx(MISz, MJSz) = Mtx(MISz, MJSz) / Mtx(MIDg, MJSz)
	pSb = new CPDSubst;
	pPrnt->AddTail(pSb);
	pEq = new CSymbInst("=");
	pSb->AddTail(pEq);
	pMx = new CSymbInst(sAmtx);
	pEq->AddTail(pMx);
	pMx->AddTail(new CSymbInst(sMtxISz));
	pMx->AddTail(new CSymbInst(sMtxJSz));
	pDv = new CSymbInst("/");
	pEq->AddTail(pDv);
	pMx = new CSymbInst(sAmtx);
	pDv->AddTail(pMx);
	pMx->AddTail(new CSymbInst(sMtxISz));
	pMx->AddTail(new CSymbInst(sMtxJSz));
	pMx = new CSymbInst(sAmtx);
	pDv->AddTail(pMx);
	pMx->AddTail(new CSymbInst(sDiagCol));
	pMx->AddTail(new CSymbInst(sMtxJSz));

	//	for mK = mJSz to 2 step -1 {
	//		mMax = mK-MILW
	pForK = new CPDFor;
	pPrnt->AddTail(pForK);
	pSbK = new CPDForSub;
	pForK->AddTail(pSbK);
	pSbK->AddTail(new CSymbInst("mK"));
	pSbK->AddTail(new CSymbInst(sMtxJSz));
	pSbK->AddTail(new CMSFract(2));
	pSbK->AddTail(new CMSFract(-1));
	pSb = new CPDSubst;
	pForK->AddTail(pSb);
	pEq = new CSymbInst("=");
	pSb->AddTail(pEq);
	pEq->AddTail(new CSymbInst("mMax"));
	pPls  = new CSymbInst("+");
	pEq->AddTail(pPls);
	pPls->AddTail(new CSymbInst("mK"));
	pMn = new CSymbInst("-?");
	pPls->AddTail(pMn);
	pMn->AddTail(new CSymbInst(sLeftWg));

	//		if mMax<1 {
	//			mMax = 1
	//		}
	pIf = new CPDIf;
	pForK->AddTail(pIf);
	pEq = new CSymbInst("<");
	pIf->AddTail(pEq);
	pEq->AddTail(new CSymbInst("mMax"));
	pEq->AddTail(new CMSFract(1));
	pThen = new CPDBlock;
	pIf->AddTail(pThen);
	pIf->AddTail(new CPDBlock);
	pSb = new CPDSubst;
	pThen->AddTail(pSb);
	pEq = new CSymbInst("=");
	pSb->AddTail(pEq);
	pEq->AddTail(new CSymbInst("mMax"));
	pEq->AddTail(new CMSFract(1));

	//		for mJ = mK-1 to mMax step -1 {
	//			Mtx(MISz, mJ) = Mtx(MISz,mJ) - Mtx(MISz, mK) * Mtx(MIDg+mK-mJ, mJ)
	//		}
	//	}
	pForJ = new CPDFor;
	pForK->AddTail(pForJ);
	pSbJ = new CPDForSub;
	pForJ->AddTail(pSbJ);
	pSbJ->AddTail(new CSymbInst("mJ"));
	pPls = new CSymbInst("+");
	pSbJ->AddTail(pPls);
	pPls->AddTail(new CSymbInst("mK"));
	pPls->AddTail(new CMSFract(-1));
	pSbJ->AddTail(new CSymbInst("mMax"));
	pSbJ->AddTail(new CMSFract(-1));

	pSb = new CPDSubst;
	pForJ->AddTail(pSb);
	pEq = new CSymbInst("=");
	pSb->AddTail(pEq);
	pMx = new CSymbInst(sAmtx);
	pEq->AddTail(pMx);
	pMx->AddTail(new CSymbInst(pMxISz));
	pMx->AddTail(new CSymbInst("mJ"));
	pPls = new CSymbInst("+");
	pEq->AddTail(pPls);
	pMx = new CSymbInst(sAmtx);
	pPls->AddTail(pMx);
	pMx->AddTail(new CSymbInst(sMtxISz));
	pMx->AddTail(new CSymbInst("mJ"));
	pMn = new CSymbInst("-?");
	pPls->AddTail(pMn);

	pMlt = new CSymbInst("*");
	pMn->AddTail(pMlt);
	pMx = new CSymbInst(sAmtx);
	pMlt->AddTail(pMx);
	pMx->AddTail(new CSymbInst(sMtxISz));
	pMx->AddTail(new CSymbInst("mK"));
	pMx = new CSymbInst(sAmtx);
	pMlt->AddTail(pMx);

	pPls = new CSymbInst("+");
	pMx->AddTail(pPls);
	pPls->AddTail(new CSymbInst(sDiagCol));
	pPls->AddTail(new CSymbInst("mK"));
	pMn = new CSymbInst("-?");
	pPls->AddTail(pMn);
	pMn->AddTail(new CSymbInst("mJ"));
	pMx->AddTail(new CSymbInst("mJ"));

	//	Mtx(MISz,1) = Mtx(MISz,1) / Mtx(MIDg,1)
	pSb = new CPDSubst;
	pPrnt->AddTail(pSb);
	pEq = new CSymbInst("=");
	pSb->AddTail(pEq);
	pMx = new CSymbInst(sAmtx);
	pEq->AddTail(pMx);
	pMx->AddTail(new CSymbInst(sMtxISz));
	pMx->AddTail(new CMSFract(1));
	pDv = new CSymbInst("/");
	pEq->AddTail(pDv);
	pMx = new CSymbInst(sAmtx);
	pDv->AddTail(pMx);
	pMx->AddTail(new CSymbInst(sMtxISz));
	pMx->AddTail(new CMSFract(1));
	pMx = new CSymbInst(sAmtx);
	pDv->AddTail(pMx);
	pMx->AddTail(new CSymbInst(sDiagCol));
	pMx->AddTail(new CMSFract(1));

	//--- find the answer to the physic array
	POSITION pos;
	int i;
	CRangeOnAxis *pRoX;
	CPDESpaceVar *pSpc;
	CViecFC *pF, *pT, *pE;
	CMSFract *pN;

	pos = pRg->GetHeadPosition();
	for(i=0; pos; i++) {
		pRoX = (CRangeOnAxis *) pRg->GetNext(pos);
		pSpc = (CPDESpaceVar *) pRoX->GetSymbBody()->GetParent();
		if(!pSpc->IsKindOf(RUNTIME_CLASS(CPDESpaceVar))) continue;
		pF = new CMSFract(pRoX->m_pFrom->m_value - rangeBegin[i]);
		pT = new CMSFract(pRoX->m_pTo->m_value - rangeEnd[i]);
		pN = (CMSFract *) pT;
		if(pN->m_value<0) {
			pE = pT;
			pT = new CSymbInst("+");
			pT->AddTail(new CSymbInst(pSpc->m_division->GetName()));
			pT->AddTail(pE);
		} if(pN->m_value==0) {
			delete pT;
			pT = new CSymbInst(pSpc->m_division->GetName());
		}
		CPDFor *pfor = new CPDFor;
		CPad *psub = new CPDForSub;
		CSymbInst *pvar = new CSymbInst(pSpc->m_pIndex->GetName());
		pPrnt->AddTail(pfor);
		pfor->AddTail(psub);
		psub->AddTail(pvar);
		psub->AddTail(pF);
		psub->AddTail(pT);
		pPrnt = pfor;
	}
	m_nShift[0] = m_nShift[1] = 0;
	CalcMtxNoEqtFullMtx(pPrnt, "mJ");

	pSb = new CPDSubst;
	pPrnt->AddTail(pSb);
	pEq = new CSymbInst("=");
	pSb->AddTail(pEq);
//	pI1 = (CSymbInst *) m_pVarLst[m_midPos]->Copy();
	CSymbInst *pPhys = (CSymbInst *) m_pVarLst[m_midPos]->Copy();
	
	pMx = new CSymbInst(sAmtx);
	pMx->AddTail(new CSymbInst(sMtxISz));
	pMx->AddTail(new CSymbInst("mJ"));
	pEq->AddTail(pPhys);
	pEq->AddTail(pMx);
	return TRUE;
}

BOOL CJDCreateProc::CalcSkipWdBandMtx()
{
	CRangeOnAxis *pRoX;
	CPDESpaceVar *pSpc;
	CMSFract  *pN;
	CViecFC *pE, *pF, *pT;
	CSymbInst *pX, *pM;
	CViecFC M;
	POSITION pos;
	int i;
	CPDEConstDef *pcnst;

	pos = pRg->GetHeadPosition();
	for(i=0; pos; i++) {
		pRoX = (CRangeOnAxis *) pRg->GetNext(pos);
		pSpc = (CPDESpaceVar *) pRoX->GetSymbBody()->GetParent();
		if(!pSpc->IsKindOf(RUNTIME_CLASS(CPDESpaceVar))) continue;
		pF = new CMSFract(- pRoX->m_pFrom->m_value);
		pT = new CMSFract(pRoX->m_pTo->m_value);
		pN = (CMSFract *) pT;
		if(pN->m_value<0) {
			pE = pT;
			pT = new CSymbInst("+");
			pT->AddTail(new CSymbInst(pSpc->m_division->GetName()));
			pT->AddTail(pE);
		} if(pN->m_value==0) {
			delete pT;
			pT = new CSymbInst(pSpc->m_division->GetName());
		}
		sMax[i] = pSpc->m_pIndex->GetName()+CString("Mx")+m_name;
		pX = new CSymbInst("+");
		pX->AddTail(pT);
		pX->AddTail(pF);
		pX->AddTail(new CMSFract(1));
		pcnst = new CPDEConstDef;
		pcnst->SetName(sMax[i]);
		pcnst->AddTail(pX);
		m_pMainProcGen->pMtxDefs->AddTail(pcnst);

		M.AddTail(new CSymbInst(sMax[i]));
	}
	m_pMainProcGen->pMtxDefs->AddTail(new CPDELineTerm);

	sMtxISz = CString("MISz") + m_name;
	sMtxJSz = CString("MJSz") + m_name;
	sLeftWg = CString("MILW") + m_name;
	sRightWg = CString("MIRW") + m_name;
	sDiagCol = CString("MIDg") + m_name;

	pLeftWg = new CPDEConstDef;
	pLeftWg->SetName(sLeftWg);
	m_pMainProcGen->pMtxDefs->AddTail(pLeftWg);

	pRightWg = new CPDEConstDef;
	pRightWg->SetName(sRightWg);
	m_pMainProcGen->pMtxDefs->AddTail(pRightWg);

	pDiagCol = new CPDEConstDef;
	pDiagCol->SetName(sDiagCol);
	CSymbInst *pP = new CSymbInst("+");
	pP->AddTail(new CSymbInst(sLeftWg));
	pP->AddTail(new CMSFract(1));
	pDiagCol->AddTail(pP);
	m_pMainProcGen->pMtxDefs->AddTail(pDiagCol);

	m_pMainProcGen->pMtxDefs->AddTail(new CPDELineTerm);

	//--- matrix i size
	pMxISz = new CPDEConstDef;
	pMxISz->SetName(sMtxISz);
	pMxISz->AddTail(new CSymbInst(sMtxJSz));
	m_pMainProcGen->pMtxDefs->AddTail(pMxISz);

	//--- matrix j size
	pMxJSz = new CPDEConstDef;
	pMxJSz->SetName(sMtxJSz);
	m_pMainProcGen->pMtxDefs->AddTail(pMxJSz);
	if(M.GetCount()==1) {
		pMxJSz->AddTail(M.GetChild(0));
		M.m_child.RemoveAll();
	} else {
		pM = new CSymbInst("*");
		pos = M.GetHeadPosition();
		while(pos)
			pM->AddTail(M.GetNext(pos));
		M.m_child.RemoveAll();
		pMxJSz->AddTail(pM);
	}

	m_pMainProcGen->pMtxDefs->AddTail(new CPDELineTerm);
	return TRUE;
}

// equation to calculate matrix subscript
BOOL CJDCreateProc::CalcMtxNoEqtBandMtx(CViecFC *pPrnt, const char *nm)
{
	CSymbInst *pX, *pY, *pZ, *pI, *pTm, *pV;
	CPDSubst *pSbst;

	int ix = m_nShift[0];
	int iy = m_nShift[1] - 1;

	pX = new CSymbInst("i");
	if(ix!=0) {
		pI = new CSymbInst("+");
		pI->AddTail(pX);
		pI->AddTail(new CMSFract(ix));
		pX = pI;
	}
	pY = new CSymbInst("j");
	if(iy!=0) {
		pI = new CSymbInst("+");
		pI->AddTail(pY);
		pI->AddTail(new CMSFract(iy));
		pY = pI;
	}
	pI = new CSymbInst("*");
	pZ = new CSymbInst("+");
	pI->AddTail(new CSymbInst(sMax[0]));
	pI->AddTail(pY);
	pZ->AddTail(pI);
	pZ->AddTail(pX);
	pTm = new CSymbInst(nm);
	pV = new CSymbInst("=");
	pV->AddTail(pTm);
	pV->AddTail(pZ);
	pSbst = new CPDSubst;
	pSbst->AddTail(pV);
	pPrnt->AddTail(pSbst);

	pI = new CSymbInst("-?");
	pZ->AddTail(pI);
	pI->AddTail(new CSymbInst("mJ"));
	pZ->AddTail(new CSymbInst(sDiagCol));
	
	return TRUE;
}

BOOL CJDCreateProc::CreateBandMtxSlvNum(CViecFC *pPrnt, CSymbInst *pV)
{
	CJDCheckIfEqual check;
	int i;
	CSymbInst *pX, *pY;

	//---	Has this  treated before.
	check.m_bResult=FALSE;
	for(i=0;i<m_varNo;i++) {
		check.m_checked = m_pVarLst[i];
		pV->SendMsg(MSG_DO_JOB, &check);
		if(check.m_bResult) break;
	}
	//---	If it has not yet.
	m_nShift[0] = m_nShift[1] = 0;
	pX = (CSymbInst *) pV->GetChild(1);
	pY = (CSymbInst *) pV->GetChild(2);
	if(pX->GetCount()==2)
		m_nShift[0] = ((CMSFract *) pX->GetChild(1))->m_value;
	if(pY->GetCount()==2)
		m_nShift[1] = ((CMSFract *) pY->GetChild(1))->m_value;
	if(!check.m_bResult) {
		//---	add it into the variable list
		//---	carry out the variable name
		m_pVarLst[m_varNo] = pV;
		m_nameLst[m_varNo].Format("mI%c%c"
			, (char) ((m_nShift[0]<0)? 'Z'+m_nShift[0] : '0'+m_nShift[0])
			, (char) ((m_nShift[1]<0)? 'Z'+m_nShift[1] : '0'+m_nShift[1]));
		//---	If this one is on the diagonal.
		if(m_nShift[0]==0 && m_nShift[1]==0)
			m_midPos = m_varNo;
		//---	create the equation to calculate it out
		CMSIndex *pIndx;
		pIndx = new CMSIndex();
		pIndx->SetName(m_nameLst[m_varNo]);
		m_pVars->AddTail(pIndx);
		//---	increase the number of the list of variable
		m_varNo++;
	}
	int wing = m_nShift[1] * 10 + m_nShift[0];
	if(m_nLeftWing>wing) m_nLeftWing = wing;
	if(m_nRightWing<wing) m_nRightWing = wing;
	CalcMtxNoEqtBandMtx(pPrnt, m_nameLst[i]);
	return TRUE;
}

