#include "stdafx.h"

#include "pde_msg.h"

#include "pde_adv.h"
#include "jd_dsc.h"

///////////////////////////  CJDDiscretizer  ///////////////////////////
///////////////////////////  CJDDiscretizer  ///////////////////////////

CJDDescretizer::CJDDescretizer()
{
//	m_bStartFg = FALSE;
//	m_cManipCnt = 0;
//	for(int i=0;i<4;i++) {
//		m_shift[i].m_value = 0;
//		m_shift[i].m_deno = 1;
//	}
//	m_target.m_theDep = NULL;
//	m_target.m_timeIndex = NULL;
//	m_target.m_timeShift.m_value = 0;
	m_pBoundDef = NULL;
}

CJDDescretizer::MakeDepDisc(CSymbInst *pInst, CViecFC *psym)
{
	POSITION pos;
	CPDESpaceVar *pS;
	CViecFCList obLst;
	CSuitCase SC;
	CPDEMeshInfo *pPDE;
	CPDETimeVar *pT;
	CPDESpaceVars *pPs;
	int i;

	SC.m_runtimeClass = RUNTIME_CLASS(CPDEMeshInfo);
	SC.m_oblist = &obLst;
	pInst->GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
	if(!obLst.GetCount()) return FALSE;
	pPDE = (CPDEMeshInfo *) obLst.GetHead();
	if(!pPDE->IsKindOf(RUNTIME_CLASS(CPDEMeshInfo))) return TRUE;

	SC.m_runtimeClass = RUNTIME_CLASS(CPDETimeVar);
	obLst.RemoveAll();
	pInst->GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
	if(!obLst.GetCount()) return FALSE;
	pT = (CPDETimeVar *) obLst.GetHead();
	if(!pT->IsKindOf(RUNTIME_CLASS(CPDETimeVar))) return TRUE;

	pPs = pPDE->m_spaceVars;
	if(pInst->GetCount()==0)
		pInst->AddTail(new CSymbInst(pT->m_pIndex->GetName()));
	pos = pPs->GetHeadPosition();
	for(i=2;pos;i++) {
		pS = (CPDESpaceVar *) pPs->GetNext(pos);
		if(pInst->GetCount()<i)
			pInst->AddTail(new CSymbInst(pS->m_pIndex->GetName()));
	}
	return TRUE;
}

BOOL CJDDescretizer::Do(CObject *g)
{
	CSymbInst *pInst;
	CViecFC *psym;
	
	pInst = (CSymbInst *) g;
	if(!m_bStartFg) {
		CViecFC *pelm;
		POSITION pos;
		CViecFC *psym;

		if(!pInst->IsKindOf(RUNTIME_CLASS(CSymbInst)))	return FALSE;
		psym = pInst->GetSymbBody();
		if(!psym->IsKindOf(RUNTIME_CLASS(CMSOEqual)))	return FALSE;
		if(!(pos = pInst->GetHeadPosition())) return FALSE;
		m_bStartFg = TRUE;
		pelm = pInst->GetNext(pos);
		pelm->SendMsg(MSG_DO_JOB, this);
		pelm = pInst->GetNext(pos);
		pelm->SendMsg(MSG_DO_JOB, this);
		return TRUE;
	} else {
		if(!pInst->IsKindOf(RUNTIME_CLASS(CSymbInst)))	return FALSE;
		psym = pInst->GetSymbBody();
		if(psym->IsKindOf(RUNTIME_CLASS(CMSDepVar))) {
			MakeDepDisc(pInst, psym);
			pInst->OnCreated();
			pInst->CalcExt(CViecFC::dirDown);
			pInst->CalcExt();
			return TRUE;
		}
	}
	return FALSE;
}

BOOL CJDDescretizer::FindStartCond(CSymbInst* pInst) // description ??
{
	CViecFC *pelm;
	POSITION pos;
	CViecFC *psym;
	if(pInst->IsKindOf(RUNTIME_CLASS(CPDETarget))) {
		psym = pInst->GetSymbBody();
		if(!psym->IsKindOf(RUNTIME_CLASS(CMSPhys))) return TRUE;
		if(pInst->GetCount()==0) return TRUE;
		pos = pInst->GetHeadPosition();

		CSymbInst *pInst2;
		CViecFC *psym2;
		pInst2 = (CSymbInst *) pInst->GetNext(pos);
		if(!pInst2->IsKindOf(RUNTIME_CLASS(CSymbInst))) return FALSE;
		psym2 = pInst2->GetSymbBody();
		if(psym2->IsKindOf(RUNTIME_CLASS(CMSIndex))) {
			m_target.m_theDep = (CMSPhys *) psym;
			m_target.m_timeIndex = (CMSIndex *) psym2;
			m_target.m_timeShift.m_value = 0;
			m_target.m_timeShift.m_deno = 1;
		} else if(psym2->IsKindOf(RUNTIME_CLASS(CMSOPlus)) && pInst2->GetCount()==2) {
			CSymbInst *pInst3;
			CViecFC *psym3;
			CMSFract *pfrct;
			pos = pInst2->GetHeadPosition();
			pInst3 = (CSymbInst *) pInst2->GetNext(pos);
			pfrct = (CMSFract *) pInst2->GetNext(pos);
			if(!pInst3->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
			psym3 = pInst3->GetSymbBody();
			if(!pfrct->IsKindOf(RUNTIME_CLASS(CMSFract))) return TRUE;
			if(!psym3->IsKindOf(RUNTIME_CLASS(CMSIndex))) return TRUE;
			m_target.m_theDep = (CMSPhys *) psym;
			m_target.m_timeIndex = (CMSIndex *) psym3;
			m_target.m_timeShift.m_value = pfrct->m_value;
			m_target.m_timeShift.m_deno = pfrct->m_deno;
		}
		return TRUE;
	}
	if(pInst->IsKindOf(RUNTIME_CLASS(CPDEBoundCond))) {
		CPDEBoundDef *pBD;
		pBD = (CPDEBoundDef *) pInst->GetSymbBody();
		if(pBD->IsKindOf(RUNTIME_CLASS(CPDEBoundDef))) {
			m_pBoundDef = pBD;
			pos = pInst->GetHeadPosition();
			while(pos) {
				pelm = pInst->GetNext(pos);
				pelm->SendMsg(MSG_DO_JOB, this);
			}
			m_pBoundDef = NULL;
			return TRUE;
		}
	}
	if(pInst->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		psym = pInst->GetSymbBody();
		if(psym->IsKindOf(RUNTIME_CLASS(CMSOEqual))) {
			if(!m_target.m_theDep || !m_target.m_timeIndex) return TRUE;
			m_bStartFg = TRUE;
			pos = pInst->GetHeadPosition();
			while(pos) {
				pelm = pInst->GetNext(pos);
				pelm->SendMsg(MSG_DO_JOB, this);
			}
			m_bStartFg = FALSE;
			return TRUE;
		}
	}
	return FALSE;
}

AF_ENUM CJDDescretizer::AnalyseForm(CSymbInst *pInst, CMapStringToOb& pParam)
{
	CViecFC *psym;
	POSITION pos;

	psym = pInst->GetSymbBody();
	{
		CSymbInst *pM1, *pM2, *pM21, *pM22;
		CViecFC *pS1, *pS2, *pS21, *pS22;
		CPDEDepInfo *pDep;

		if(!psym->IsKindOf(RUNTIME_CLASS(CMSOMult))) goto label1;
		if(pInst->GetCount()!=2) goto label1;
		pos = pInst->GetHeadPosition();
		pM1 = (CSymbInst *) pInst->GetNext(pos);
		pM2 = (CSymbInst *) pInst->GetNext(pos);
		if(!pM1->IsKindOf(RUNTIME_CLASS(CSymbInst))) goto label1;
		if(!pM2->IsKindOf(RUNTIME_CLASS(CSymbInst))) goto label1;
		pS1 = pM1->GetSymbBody();
		pS2 = pM2->GetSymbBody();
		if(!pS1->IsKindOf(RUNTIME_CLASS(CMSDepVar))) goto label1;
		if(!pS2->IsKindOf(RUNTIME_CLASS(CMSODiff))) goto label1;
		pDep = (CPDEDepInfo *) pS1->GetParent();
		if(!pDep->IsKindOf(RUNTIME_CLASS(CPDEDepInfo))) goto label1;
		CPDESpaceVar *pSpc;

		pos = pM2->GetHeadPosition();
		pM21 = (CSymbInst *) pM2->GetNext(pos);
		pM22 = (CSymbInst *) pM2->GetNext(pos);
		if(!pM21->IsKindOf(RUNTIME_CLASS(CSymbInst))) goto label1;
		if(!pM22->IsKindOf(RUNTIME_CLASS(CSymbInst))) goto label1;
		
		pS21 = pM21->GetSymbBody();
		pS22 = pM22->GetSymbBody();
		if(!pS22->IsKindOf(RUNTIME_CLASS(CMSIndepVar))) goto label1;
		pSpc = (CPDESpaceVar *) pS22->GetParent();
		if(!pSpc->IsKindOf(RUNTIME_CLASS(CPDESpaceVar))) goto label1;

		CSuitCase SC;
		if(!pS22->SendMsg(MSG_PDE_GET_AXIS_NO, &SC)) goto label1;
		if((pDep->m_pos->m_velocity-1)!=SC.m_int) goto label1;

		pParam["DERIVED"] = pM21;
		pParam["SPACEVAR"] = pSpc;
		pParam["VELO_DEPINFO"] = pDep;
		pParam["VELO_DEPVAR"] = pM1;

		return AF_UPWIND;
	}
label1:

	while(psym->IsKindOf(RUNTIME_CLASS(CMSODiff))) {
		CSymbInst *e1, *e2;
		CMSIndepVar *pInd;
		POSITION pos;
		CPDETimeVar *pTm;

		if(pInst->GetCount()!=2) return AF_CANT_BE_RECOGNIZED;
		pos = pInst->GetHeadPosition();
		e1 = (CSymbInst *) pInst->GetNext(pos);
		e2 = (CSymbInst *) pInst->GetNext(pos);
		if(!e1->IsKindOf(RUNTIME_CLASS(CSymbInst))) break;
		if(!e2->IsKindOf(RUNTIME_CLASS(CSymbInst))) break;
		pInd = (CMSIndepVar *) e2->GetSymbBody();
		if(!pInd->IsKindOf(RUNTIME_CLASS(CMSIndepVar))) break;
		pTm = (CPDETimeVar *) pInd->GetParent();
		if(!pTm->IsKindOf(RUNTIME_CLASS(CPDETimeVar))) break;

		pParam["DERIVED"] = e1;
		pParam["TIMEVAR"] = pTm;
		if(pInst->GetInt()==1)
			return AF_PART_DIFF_TIME_1;
		if(pInst->GetInt()==2)
			return AF_PART_DIFF_TIME_2;
		break;
	}

	while(psym->IsKindOf(RUNTIME_CLASS(CMSODiff))) {
		CSymbInst *e1, *e2;
		CMSIndepVar *pInd;
		POSITION pos;
		CPDESpaceVar *pSpc;

		if(pInst->GetCount()!=2) return AF_CANT_BE_RECOGNIZED;
		pos = pInst->GetHeadPosition();
		e1 = (CSymbInst *) pInst->GetNext(pos);
		e2 = (CSymbInst *) pInst->GetNext(pos);
		if(!e1->IsKindOf(RUNTIME_CLASS(CSymbInst))) break;
		if(!e2->IsKindOf(RUNTIME_CLASS(CSymbInst))) break;
		pInd = (CMSIndepVar *) e2->GetSymbBody();
		if(!pInd->IsKindOf(RUNTIME_CLASS(CMSIndepVar))) break;
		pSpc = (CPDESpaceVar *) pInd->GetParent();
		if(!pSpc->IsKindOf(RUNTIME_CLASS(CPDESpaceVar))) break;

		pParam["DERIVED"] = e1;
		pParam["SPACEVAR"] = pSpc;
		if(pInst->GetInt()==1)
			return AF_PART_DIFF_SPACE_1;
		if(pInst->GetInt()==2)
			return AF_PART_DIFF_SPACE_2;
		break;
	}

	if(psym->IsKindOf(RUNTIME_CLASS(CMSDepVar))) {
		if(!psym->GetParent()->IsKindOf(RUNTIME_CLASS(CPDEDepInfo))) goto label2;
		return AF_DEP_VAR;
	}
label2:

	return AF_CANT_BE_RECOGNIZED;
}

BOOL CJDDescretizer::DiscDerivC1(CSymbInst* pInst, CMapStringToOb& para)
{
	CSymbInst *pNeg, *pPls, *pInd2, *pDrv;
	CPDESpaceVar *pSpc;
	CSymbInst *pCp1, *pCp2;
	CSuitCase SC;
	int shf = 0;

	pSpc = (CPDESpaceVar *) para["SPACEVAR"];
	pDrv = (CSymbInst *) para["DERIVED"];
	pCp1 = (CSymbInst *) pDrv->Copy();
	pCp2 = (CSymbInst *) pDrv->Copy();
	if(!pSpc->m_pIndepVar->SendMsg(MSG_PDE_GET_AXIS_NO, &SC)) return FALSE;
	if(SC.m_int<0 || SC.m_int>2) return FALSE;
	if(m_pBoundDef) {
		if(SC.m_int==m_pBoundDef->m_surf->m_axisNo) {
			if(pDrv->GetSymbBody()==m_target.m_theDep) {
				CPDEDepInfo *pDep;
				BOOL hlf, bps;
				hlf = m_pBoundDef->m_surf->m_pHalfDir->m_bHalf;
				pDep = (CPDEDepInfo *) m_target.m_theDep->GetParent();
				bps = pDep->m_pos->m_pos[SC.m_int];
				if(hlf==bps)
					if(m_pBoundDef->m_surf->m_pHalfDir->m_bPosDir)	shf = 1;
					else	shf = -1;
			}
		}
	}
	while(pInst->GetCount())
		delete pInst->m_child.RemoveTail();

	pInst->ChangeInst("/");
	pInst->SetInt(1);
	pPls = new CSymbInst("+");
	pInd2 = new CSymbInst(pSpc->m_pIndep->GetName());

	pInst->AddTail(pPls);
	pInst->AddTail(pInd2);
	pNeg = new CSymbInst("-?");
	pPls->AddTail(pCp1);
	pPls->AddTail(pNeg);
	pNeg->AddTail(pCp2);
	pInst->OnCreated();

	m_shift[SC.m_int+1].Plus(shf, 2);
	m_shift[SC.m_int+1].Plus(1, 2);
	pCp1->SendMsg(MSG_DO_JOB, this);
	m_shift[SC.m_int+1].Plus(-1);
	pCp2->SendMsg(MSG_DO_JOB, this);
	m_shift[SC.m_int+1].Plus(1, 2);
	m_shift[SC.m_int+1].Plus(-shf, 2);
	return TRUE;
}

BOOL CJDDescretizer::DiscDerivC2(CSymbInst* pInst, CMapStringToOb& para)
{
	CSymbInst *pNeg, *pPls, *pDrv;
	CPDESpaceVar *pSpc;
	CMSFract *pF;
	CSymbInst *pCp1, *pCp2, *pCp3, *pM;
	CSuitCase SC;

	pSpc = (CPDESpaceVar *) para["SPACEVAR"];
	pDrv = (CSymbInst *) para["DERIVED"];
	pCp1 = (CSymbInst *) pDrv->Copy();
	pCp2 = (CSymbInst *) pDrv->Copy();
	pCp3 = (CSymbInst *) pDrv->Copy();
	if(!pSpc->m_pIndepVar->SendMsg(MSG_PDE_GET_AXIS_NO, &SC)) return FALSE;
	if(SC.m_int<0 || SC.m_int>2) return FALSE;
	while(pInst->GetCount())
		delete pInst->m_child.RemoveTail();

	pInst->ChangeInst("/");
	pInst->SetInt(1);
	pPls = new CSymbInst("+");
	pInst->AddTail(pPls);
	pM = new CSymbInst("*");
	pInst->AddTail(pM);
	pM->AddTail(new CSymbInst(pSpc->m_pIndep->GetName()));
	pM->AddTail(new CSymbInst(pSpc->m_pIndep->GetName()));

	pNeg = new CSymbInst("-?");
	pPls->AddTail(pCp1);
	pPls->AddTail(pNeg);
	pPls->AddTail(pCp3);

	pM = new CSymbInst("*");
	pNeg->AddTail(pM);
	pF = new CMSFract;
	pF->m_value = 2;
	pM->AddTail(pF);
	pM->AddTail(pCp2);
	pInst->OnCreated();

	m_shift[SC.m_int+1].Plus(1);
	pCp1->SendMsg(MSG_DO_JOB, this);
	m_shift[SC.m_int+1].Plus(-2);
	pCp3->SendMsg(MSG_DO_JOB, this);
	m_shift[SC.m_int+1].Plus(1);
	return TRUE;  
}

BOOL CJDDescretizer::DiscDerivTime1(CSymbInst* pInst, CMapStringToOb& para)
{
	CSymbInst *pNeg, *pPls, *pInd2, *pDrv;
	CPDETimeVar *pTm;
	CSymbInst *pCp1, *pCp2;
	CSuitCase SC;
	int shf = 0;

	pTm = (CPDETimeVar *) para["TIMEVAR"];
	pDrv = (CSymbInst *) para["DERIVED"];
	pCp1 = (CSymbInst *) pDrv->Copy();
	pCp2 = (CSymbInst *) pDrv->Copy();
	while(pInst->GetCount())
		delete pInst->m_child.RemoveTail();

	pInst->ChangeInst("/");
	pInst->SetInt(1);
	pPls = new CSymbInst("+");
	pInd2 = new CSymbInst(pTm->m_pIndep->GetName());

	pInst->AddTail(pPls);
	pInst->AddTail(pInd2);
	pNeg = new CSymbInst("-?");
	pPls->AddTail(pCp1);
	pPls->AddTail(pNeg);
	pNeg->AddTail(pCp2);
	pInst->OnCreated();

//	m_shift[SC.m_int+1].Plus(shf, 2);
	m_shift[0].Plus(1);
	pCp1->SendMsg(MSG_DO_JOB, this);
	m_shift[0].Plus(-1);
	pCp2->SendMsg(MSG_DO_JOB, this);
//	m_shift[SC.m_int+1].Plus(-shf, 2);
	return TRUE;
}

BOOL CJDDescretizer::DiscUpwndFstOrd(CSymbInst* pInst, CMapStringToOb& para)
{
	CSymbInst *pNg1, *pNg2, *pNg0, *pInd1, *pInd2;
	CSymbInst *pP11, *pP12, *pP21, *pP22;
	CSymbInst *pWg11, *pWg12, *pWg21, *pWg22;
	CSymbInst *pV11, *pV12, *pV21, *pV22;
	CSymbInst *pWg1, *pWg2;
	CSymbInst *pVar, *pAb1, *pAb2;
	CSymbInst *pDrv, *pCp1, *pCp2, *pCp3, *pCp4;
	CMSFract *pF1, *pF2;
	CPDESpaceVar *pSpc;
	CSuitCase SC;
	CPDEDepInfo *pDep;

	pDrv = (CSymbInst *) para["DERIVED"];
	pSpc = (CPDESpaceVar *) para["SPACEVAR"];
	pDep = (CPDEDepInfo *) para["VELO_DEPINFO"];
	pVar = (CSymbInst *) para["VELO_DEPVAR"];
	if(!pSpc->m_pIndepVar->SendMsg(MSG_PDE_GET_AXIS_NO, &SC)) return FALSE;
	if(SC.m_int<0 || SC.m_int>2) return FALSE;

	pCp1 = (CSymbInst *) pDrv->Copy();
	pCp2 = (CSymbInst *) pDrv->Copy();
	pCp3 = (CSymbInst *) pDrv->Copy();
	pCp4 = (CSymbInst *) pDrv->Copy();
	pV11 = (CSymbInst *) pVar->Copy();
	pV12 = (CSymbInst *) pVar->Copy();
	pV21 = (CSymbInst *) pVar->Copy();
	pV22 = (CSymbInst *) pVar->Copy();
	while(pInst->GetCount())
		delete pInst->m_child.RemoveTail();

	pInd1 = new CSymbInst(pSpc->m_pIndep->GetName());
	pInd2 = new CSymbInst(pSpc->m_pIndep->GetName());
	pNg1 = new CSymbInst("-?");
	pNg2 = new CSymbInst("-?");
	pP12 = new CSymbInst("+");
	pP22 = new CSymbInst("+");
	pWg12 = new CSymbInst("/");
	pWg22 = new CSymbInst("/");
	pWg12->AddTail(pP12);
	pWg12->AddTail(pInd1);
	pWg22->AddTail(pP22);
	pWg22->AddTail(pInd2);
	pP12->AddTail(pCp1);
	pP12->AddTail(pNg1);
	pNg1->AddTail(pCp2);
	pP22->AddTail(pCp3);
	pP22->AddTail(pNg2);
	pNg2->AddTail(pCp4);

	pWg11 = new CSymbInst("/");
	pP11 = new CSymbInst("+");
	pAb1 = new CSymbInst("abs");
	pAb1->AddTail(pV12);
	pP11->AddTail(pV11);
	pP11->AddTail(pAb1);
	pF1 = new CMSFract();
	pF1->m_value = 2;
	pF1->m_deno = 1;
	pWg11->AddTail(pP11);
	pWg11->AddTail(pF1);
	pWg1 = new CSymbInst("*");
	pWg1->AddTail(pWg11);
	pWg1->AddTail(pWg12);

	pWg21 = new CSymbInst("/");
	pP21 = new CSymbInst("+");
	pAb2 = new CSymbInst("abs");
	pAb2->AddTail(pV22);
	pNg0 = new CSymbInst("-?");
	pNg0->AddTail(pAb2);
	pP21->AddTail(pV21);
	pP21->AddTail(pNg0);
	pF2 = new CMSFract();
	pF2->m_value = 2;
	pF2->m_deno = 1;
	pWg21->AddTail(pP21);
	pWg21->AddTail(pF2);
	pWg2 = new CSymbInst("*");
	pWg2->AddTail(pWg21);
	pWg2->AddTail(pWg22);

/*
	pAb1 = new CSymbInst("-?");
	pAb1->AddTail(pV12);

	pWg1 = new CSymbInst("*");
	pWg1->AddTail(pCp1);
	pWg1->AddTail(pCp2);
	pWg1->AddTail(pV11);
	pWg1->AddTail(pAb1);

	pWg2 = new CSymbInst("*");
	pWg2->AddTail(pCp3);
	pWg2->AddTail(pCp4);
	pWg2->AddTail(pV21);
	pWg2->AddTail(pV22);
*/

	pInst->ChangeInst("+");
	pInst->AddTail(pWg1);
	pInst->AddTail(pWg2);
	pInst->OnCreated();

	CJDDescDeriv shf;
	shf.Copy(this);
	shf.m_shift[SC.m_int+1].Plus(-1);
	pCp2->SendMsg(MSG_DO_JOB, &shf);
	shf.m_shift[SC.m_int+1].Plus(2);
	pCp3->SendMsg(MSG_DO_JOB, &shf);

	return TRUE;
}

BOOL CJDDescretizer::ShiftVar(CSymbInst* pInst)
{
	CSymbInst *pI1,*pI2;
	CViecFC *pS;
	CMSFract *pF;
	POSITION pos, pos2;
	int i;

	pos = pInst->GetHeadPosition();
	for(i=0; pos; i++) {
		pI1 = (CSymbInst *) pInst->GetNext(pos);
		if(m_shift[i].m_value==0) continue;
		if(!pI1->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
		pS = pI1->GetSymbBody();
		if(pS->IsKindOf(RUNTIME_CLASS(CMSIndex))) {
			// Vi
			CSymbInst *pSI = (CSymbInst *) pI1->GetParent();
			CSymbInst *pSI2 = new CSymbInst("+");
			pF = new CMSFract;
			pF->m_value = m_shift[i].m_value;
			pF->m_deno = m_shift[i].m_deno;
			pSI->SubstChild(pI1, pSI2);
			pSI2->AddTail(pI1);
			pSI2->AddTail(pF);
			pSI2->OnCreated();
		} else if(pS->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
			if(pI1->GetCount()!=2) continue;
			pos2 = pI1->GetHeadPosition();
			pI2 = (CSymbInst *) pI1->GetNext(pos2);
			pF = (CMSFract *) pI1->GetNext(pos2);
			if(!pI2->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
			pS = pI2->GetSymbBody();
			if(!pS->IsKindOf(RUNTIME_CLASS(CMSIndex))) continue;
			if(!pF->IsKindOf(RUNTIME_CLASS(CMSFract))) continue;
			// Vi+1
			pF->Plus(m_shift[i].m_value, m_shift[i].m_deno);
			if(pF->m_value==0) {
				pInst->SubstChild(pI1, pI2);
				while(pI1->GetCount())
					pI1->m_child.RemoveTail();
				delete pI1;
				delete pF;
			}
		}
	}
	pInst->CalcExt(CViecFC::dirDown);
	pInst->CalcExt();
	return TRUE;
}

BOOL CJDDescretizer::ShiftVarToPos(CSymbInst* pInst)
{
	CSymbInst *pI1,*pI2;
	CViecFC *pS;
	CMSFract *pF;
	POSITION pos, pos2;
	int i;
	CPDEDepInfo *pDep;
	int shft;

	pDep = (CPDEDepInfo *) pInst->GetSymbBody()->GetParent();
	pos = pInst->GetHeadPosition();
	for(i=0; pos; i++) {
		if(i>0) {
			switch(pDep->m_pos->m_pos[i-1]) {
			case 0:	shft = 1;	break;
			case 1:	shft = 0;	break;
			case 2:	shft = -1;	break;
			}
		} else {
			shft = 0;
		}
		
		pI1 = (CSymbInst *) pInst->GetNext(pos);
		if(m_shift[i].m_value==0 && shft==0) continue;
		if(!pI1->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
		pS = pI1->GetSymbBody();
		if(pS->IsKindOf(RUNTIME_CLASS(CMSIndex))) {
			// Vi
			pF = new CMSFract;
			pF->m_value = m_shift[i].m_value;
			pF->m_deno = m_shift[i].m_deno;
			pF->Plus(shft, 2);
			if(pF->m_value==0) {
				delete pF;
				continue;
			}
			CSymbInst *pSI = (CSymbInst *) pI1->GetParent();
			CSymbInst *pSI2 = new CSymbInst("+");
			pSI->SubstChild(pI1, pSI2);
			pSI2->AddTail(pI1);
			pSI2->AddTail(pF);
			pSI2->OnCreated();
		} else if(pS->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
			if(pI1->GetCount()!=2) continue;
			pos2 = pI1->GetHeadPosition();
			pI2 = (CSymbInst *) pI1->GetNext(pos2);
			pF = (CMSFract *) pI1->GetNext(pos2);
			if(!pI2->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
			pS = pI2->GetSymbBody();
			if(!pS->IsKindOf(RUNTIME_CLASS(CMSIndex))) continue;
			if(!pF->IsKindOf(RUNTIME_CLASS(CMSFract))) continue;
			// Vi+1
			pF->Plus(m_shift[i].m_value, m_shift[i].m_deno);
			pF->Plus(shft, 2);
			if(pF->m_value==0) {
				pInst->SubstChild(pI1, pI2);
				while(pI1->GetCount())
					pI1->m_child.RemoveTail();
				delete pI1;
				delete pF;
			}
		}
	}
	pInst->CalcExt(CViecFC::dirDown);
	pInst->CalcExt();
	return TRUE;
}

BOOL CJDDescretizer::Copy(CJDDescretizer* d)
{
	m_bStartFg = d->m_bStartFg;
	m_pBoundDef = d->m_pBoundDef;
	for(int i=0;i<4;i++) {
		m_shift[i].m_value = d->m_shift[i].m_value;
		m_shift[i].m_deno = d->m_shift[i].m_deno;
	}
	m_target.m_theDep = d->m_target.m_theDep;
	m_target.m_timeIndex = d->m_target.m_timeIndex;
	m_target.m_timeShift.m_value = d->m_target.m_timeShift.m_value;
	m_target.m_timeShift.m_deno = d->m_target.m_timeShift.m_deno;
	return TRUE;
}

EXP_ENUM CJDDescretizer::AnalyseExpForm(CSymbInst *pInst, CMapStringToOb& para)
{
	POSITION pos;
	CSymbInst *pI1, *pI2, *pI3;
	CViecFC *psym, *pS1, *pS2;
	CViecFC *pE;
	CMSFract *pF;

	psym = pInst->GetSymbBody();
	if(psym->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
		pos = pInst->GetHeadPosition();
		pI1 = (CSymbInst *) pInst->GetNext(pos);
		pS1 = pI1->GetSymbBody();
		if(pS1->IsKindOf(RUNTIME_CLASS(CMSONeg)))
			return EXP_NEG_IN_NEG;
	}
	if(psym->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
		pos = pInst->GetHeadPosition();
		while(pos) {
			pI1 = (CSymbInst *) pInst->GetNext(pos);
			if(!pI1->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
			pS1 = pI1->GetSymbBody();
			if(pS1->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
				para["FIRST"] = pI1;
				return EXP_PLUS_IN_PLUS;
			}
		}
	}
	if(psym->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
		pos = pInst->GetHeadPosition();
		pI1 = (CSymbInst *) pInst->GetNext(pos);
		if(pI1->IsKindOf(RUNTIME_CLASS(CSymbInst))
			&& pI1->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus)))
			return EXP_PLUS_IN_NEG;
	}
	if(psym->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
		int negCnt=0;
		pos = pInst->GetHeadPosition();
		while(pos) {
			pI1 = (CSymbInst *) pInst->GetNext(pos);
			if(!pI1->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
			pS1 = pI1->GetSymbBody();
			if(pS1->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
				para["FIRST"] = pI1;
				return EXP_PLUS_IN_MULT;
			}
			if(pS1->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
				para["FIRST"] = pI1;
				return EXP_MULT_IN_MULT;
			}
			if(pS1->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
//				if(negCnt==0) para["FIRST"] = pI1;
//				if(negCnt>0) return EXP_NEG_IN_MULT;
//				negCnt++;
				return EXP_NEG_IN_MULT;
			}
		}
	}
	if(psym->IsKindOf(RUNTIME_CLASS(CMSODiv))){
		pos = pInst->GetHeadPosition();
		pI1 = (CSymbInst *) pInst->GetNext(pos); //--- deno
		if(pI1->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			pS1 = pI1->GetSymbBody();
			if(pS1->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
				para["FIRST"] = pI1;
				return EXP_PLUS_IN_NUME;
			}
		}
	}
	// EXP_X_DIV_BY_Y	//	X/Y	{X!=1}	->	1/Y * X
	if(psym->IsKindOf(RUNTIME_CLASS(CMSODiv))) {
		CViecFC *pD;
		pos = pInst->GetHeadPosition();
		pE = pInst->GetNext(pos);
		pD = pInst->GetNext(pos);
		para["NUME"] = pE;
		para["DENO"] = pD;
		if(pE->IsKindOf(RUNTIME_CLASS(CMSFract))) {
			pF = (CMSFract *) pE;
			if(!(pF->m_value==1 && pF->m_deno==1))
				return EXP_X_DIV_BY_Y;
		} else {
			return EXP_X_DIV_BY_Y;
		}
	}
/*
	if(psym->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
		pos = pInst->GetHeadPosition();
		while(pos) pI1 = (CSymbInst *) pInst->GetNext(pos);
		if(m_target.IsThis(pI1))
			return EXP_DEP_IN_MULT;
	}
*/
	if(psym->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
		pos = pInst->GetHeadPosition();
		pI1 = (CSymbInst *) pInst->GetNext(pos);
		if(pI1->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			pS1 = pI1->GetSymbBody();
			if(pS1->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
				pos = pI1->GetHeadPosition();
				while(pos) pI2 = (CSymbInst *) pI1->GetNext(pos);
				if(m_target.IsThis(pI2))
					return EXP_DEP_IN_NEG_MULT;
			}
		}
	}
	if(psym->IsKindOf(RUNTIME_CLASS(CMSODiv))) {
		pos = pInst->GetHeadPosition();
		pI1 = (CSymbInst *) pInst->GetNext(pos);
		if(pI1->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			pS1 = pI1->GetSymbBody();
			if(pS1->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
				pos = pI1->GetHeadPosition();
				while(pos) pI2 = (CSymbInst *) pI1->GetNext(pos);
				if(m_target.IsThis(pI2))
					return EXP_DEP_IN_NUME_MULT;
			}
		}
	}
	if(psym->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
		pos = pInst->GetHeadPosition();
		pI1 = (CSymbInst *) pInst->GetNext(pos);
		if(pI1->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			pS1 = pI1->GetSymbBody();
			if(pS1->IsKindOf(RUNTIME_CLASS(CMSODiv))) {
				pos = pI1->GetHeadPosition();
				pI2 = (CSymbInst *) pI1->GetNext(pos);
				if(pI2->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
					pS2 = pI2->GetSymbBody();
					if(pS2->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
						pos = pI2->GetHeadPosition();
						while(pos) pI3 = (CSymbInst *) pI2->GetNext(pos);
						if(m_target.IsThis(pI3))
							return EXP_DEP_IN_NEG_NUME_MULT;
					}
				}
			}
		}
	}
	return EXP_NOT_RECOGNIZED;
}

BIND_ENUM CJDDescretizer::AnalyseBindForm(CSymbInst *pInst, CMapStringToOb& para)
{
	CSymbInst *pI1, *pI2;
	CViecFC *psym;

	psym = pInst->GetSymbBody();
	//--------------
	//	BIND_PLUS_ABLE_FORM1
	//	V -> (-V)+V+aV+(-aV).. 
	if(psym->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
		POSITION pos1, pos2;
		CSymbInst *pV, *pT;
		CSymbInst *pV0 = NULL;
		int cnt;

		pos1 = pInst->GetHeadPosition();
		while(pos1) {
			pI1 = (CSymbInst *) pInst->GetNext(pos1);
			if(!pI1->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
			pV = pI1;
			if(pI1->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
				pos2 = pI1->GetHeadPosition();
				pV = (CSymbInst *) pI1->GetNext(pos2);
			}
			if(pV->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
				pT = pV;
				pos2 = pT->GetHeadPosition();
				while(pos2)	pV = (CSymbInst *) pT->GetNext(pos2);
			}
			cnt = 0;
			pos2 = pos1;
			while(pos2) {
				pI2 = (CSymbInst *) pInst->GetNext(pos2);
				if(pI1==pI2) continue;
				if(!pI2->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
				CMapStringToOb para;
				switch(AnalyseFactForm(pI2, pV, para)) {
				case FF_FORM_X:
				case FF_FORM_N_X:
				case FF_FORM_F_X:
				case FF_FORM_N_F_X:
					cnt++;
					break;
				}
			}
			if(cnt>0) {
				pV0 = pV;
				break;
			}
		}
		if(pV0) {
			para["FIRST"] = pI1;
			para["KEY"] = pV0;
			return BIND_PLUS_ABLE_FORM1;
		}
	}
	//--------------
	//	BIND_PLUS_ABLE_FORM2
	// 2X+2Y+2Z	->	2(X+Y+Z)
	if(psym->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
		BOOL okFg;
		POSITION pos, pos2;
		CSymbInst *pM;
		CViecFC *pE;
		CMSFract *pF, *pF0;

		pF0 = NULL;
		okFg = TRUE;
		pos = pInst->GetHeadPosition();
		while(okFg && pos) {
			pM = (CSymbInst *) pInst->GetNext(pos);
			okFg = FALSE;
			if(pM->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
				if(pM->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
					pos2 = pM->GetHeadPosition();
					pE = pM->GetNext(pos2);
					if(pE->IsKindOf(RUNTIME_CLASS(CMSFract))) {
						if(pF0==NULL) {
							pF0 = (CMSFract *) pE;
							okFg = TRUE;
						} else {
							pF = (CMSFract *) pE;
							if(pF->m_value==pF0->m_value &&
								pF->m_deno==pF0->m_deno) {
								okFg = TRUE;
							}
						}
					}
				}
			}
		}
		if(okFg)
			return BIND_PLUS_ABLE_FORM2;
	}
	return BIND_NOT_RECOGNIZED;
}

SIMP_ENUM CJDDescretizer::AnalyseSimpForm(CSymbInst *pInst, CMapStringToOb& para)
{
	POSITION pos;
	CViecFC *psym;

	psym = pInst->GetSymbBody();
	//--------------
	//	SIMP_PLUS_ABLE_FORM2	/* 2+a+3+.. */
	//	
	if(psym->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
		POSITION pos1, pos2;
		CViecFC *pF1, *pF2;
		pos1 = pInst->GetHeadPosition();
		while(pos1) {
			pF1 = pInst->GetNext(pos1);
			if(!pF1->IsKindOf(RUNTIME_CLASS(CMSFract))) continue;
			pos2 = pos1;
			while(pos2) {
				pF2 = pInst->GetNext(pos2);
				if(pF2->IsKindOf(RUNTIME_CLASS(CMSFract))) {
					para["FIRST"] = pF1;
					return SIMP_PLUS_ABLE_FORM2;
				}
			}
		}
	}
	//	SIMP_MULT_ABLE_FORM1	/* 2a3.. */
	if(psym->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
		POSITION pos1, pos2;
		CViecFC *pF1, *pF2;
		pos1 = pInst->GetHeadPosition();
		while(pos1) {
			pF1 = pInst->GetNext(pos1);
			if(!pF1->IsKindOf(RUNTIME_CLASS(CMSFract))) continue;
			pos2 = pos1;
			while(pos2) {
				pF2 = pInst->GetNext(pos2);
				if(pF2->IsKindOf(RUNTIME_CLASS(CMSFract))) {
					para["FIRST"] = pF1;
					return SIMP_MULT_ABLE_FORM1;
				}
			}
		}
	}
	//	SIMP_DIV_ABLE_FORM1	/* 1/2 */
	if(psym->IsKindOf(RUNTIME_CLASS(CMSODiv))) {
		CViecFC *pN, *pD;
		pos = pInst->GetHeadPosition();
		pN = pInst->GetNext(pos);
		pD = pInst->GetNext(pos);
		if(pN->IsKindOf(RUNTIME_CLASS(CMSFract)) && pD->IsKindOf(RUNTIME_CLASS(CMSFract)))
			return SIMP_DIV_ABLE_FORM1;
	}
	// SIMP_PLUS_INT_0	// 0+a+.. 
	if(psym->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
		POSITION pos;
		CViecFC *pE;
		CMSFract *pF;
		pos = pInst->GetHeadPosition();
		while(pos) {
			pE = pInst->GetNext(pos);
			if(pE->IsKindOf(RUNTIME_CLASS(CMSFract))) {
				pF = (CMSFract *) pE;
				if(pF->m_value==0)
					return SIMP_PLUS_INT_0;
			}
		}
	}
	//	EXP_MULT_INV_INV	//	1/X*1/Y*a*b	->	1/(X*Y)*a*b
	if(psym->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
		POSITION pos2;
		CViecFC *p1=NULL, *pE;
		CSymbInst *pI;
		CMSFract *pF;

		pos = pInst->GetHeadPosition();
		while(pos) {
			pE = pInst->GetNext(pos);
			if(pE->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
				pI = (CSymbInst *) pE;
				if(pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSODiv))) {
					pos2 = pI->GetHeadPosition();
					pE = pI->GetNext(pos2);
					if(pE->IsKindOf(RUNTIME_CLASS(CMSFract))) {
						pF = (CMSFract *) pE;
						if(!(pF->m_value==1 && pF->m_deno==1)) {
							if(p1==NULL) {
								p1 = pI;
							} else {
								para["FIRST"] = p1;
								para["SECOND"] = pI;
								return SIMP_MULT_INV_INV;
							}
						}
					}
				}
			}
		}
	}
	// SIMP_MULT_INT_0;	// 0*a*..
	if(psym->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
		POSITION pos;
		CViecFC *pE;
		CMSFract *pF;
		pos = pInst->GetHeadPosition();
		while(pos) {
			pE = pInst->GetNext(pos);
			if(pE->IsKindOf(RUNTIME_CLASS(CMSFract))) {
				pF = (CMSFract *) pE;
				if(pF->m_value==0)
					return SIMP_MULT_INT_0;
			}
		}
	}
	// SIMP_MULT_INT_1;	// 1*a*..
	if(psym->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
		POSITION pos;
		CViecFC *pE;
		CMSFract *pF;
		pos = pInst->GetHeadPosition();
		while(pos) {
			pE = pInst->GetNext(pos);
			if(pE->IsKindOf(RUNTIME_CLASS(CMSFract))) {
				pF = (CMSFract *) pE;
				if(pF->m_value==1 && pF->m_deno==1)
					return SIMP_MULT_INT_1;
			}
		}
	}
	// SIMP_DIV_BY_1;	// a/1;
	if(psym->IsKindOf(RUNTIME_CLASS(CMSODiv))) {
		POSITION pos;
		CViecFC *pE;
		CMSFract *pF;
		pos = pInst->GetHeadPosition();
		pInst->GetNext(pos);
		pE = pInst->GetNext(pos);
		if(pE->IsKindOf(RUNTIME_CLASS(CMSFract))) {
			pF = (CMSFract *) pE;
			if(pF->m_value==1)
				return SIMP_DIV_BY_1;
		}
	}
	// SIMP_NEG_INT;		// (-? 1)
	if(psym->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
		POSITION pos;
		CViecFC *pE;
		pos = pInst->GetHeadPosition();
		if(pos) {
			pE = pInst->GetNext(pos);
			if(pE->IsKindOf(RUNTIME_CLASS(CMSFract)))
				return SIMP_NEG_INT;
		} else {
			pos = NULL;
		}
	}
	//	SIMP_DIV_ABLE_FORM2	/* a/(a*b*c*..) */
	if(psym->IsKindOf(RUNTIME_CLASS(CMSODiv))) {
		CSymbInst *pN, *pD, *pD1;
		CSymbInst *pV;
		pos = pInst->GetHeadPosition();
		pN = (CSymbInst *) pInst->GetNext(pos);
		pD = (CSymbInst *) pInst->GetNext(pos);
		pV = pN;
		if(pD->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			if(pD->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
				if(pN->IsKindOf(RUNTIME_CLASS(CSymbInst))
				&& pN->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
					pos = pN->GetHeadPosition();
					pV = (CSymbInst *) pN->GetNext(pos);
				}
				BOOL OkFg = TRUE;
				if(pN->IsKindOf(RUNTIME_CLASS(CMSFract))) {
					CMSFract *pF;
					pF = (CMSFract *) pN;
					if(pF->m_value==1 && pF->m_deno==1)
						OkFg = FALSE;
				}
				if(OkFg) {
					pos = pD->GetHeadPosition();
					while(pos) {
						pD1 = (CSymbInst *) pD->GetNext(pos);
						CMapStringToOb para2;
						switch(AnalyseFactForm(pD1, pV, para2)) {
						case FF_FORM_X:
						case FF_FORM_N_X:
//						case FF_FORM_F_X:
//						case FF_FORM_N_F_X:
							para["KEY"] = pV;
							para["NUME"] = pN;
							para["DENO"] = pD1;
							return SIMP_DIV_ABLE_FORM2;
						}
					}
				}
			}
		}
	}
	//	SIMP_DIV_ABLE_FORM3	/* (a*b*c*..)/a */
	if(psym->IsKindOf(RUNTIME_CLASS(CMSODiv))) {
		CSymbInst *pN, *pD, *pN1;
		CSymbInst *pV;
		pos = pInst->GetHeadPosition();
		pN = (CSymbInst *) pInst->GetNext(pos);
		pD = (CSymbInst *) pInst->GetNext(pos);
		if(pN->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			if(pN->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
				pV = pD;
				if(pD->IsKindOf(RUNTIME_CLASS(CSymbInst)) && pD->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
					pos = pD->GetHeadPosition();
					pV = (CSymbInst *) pD->GetNext(pos);
				}
				pos = pN->GetHeadPosition();
				while(pos) {
					pN1 = (CSymbInst *) pN->GetNext(pos);
					if(pN1->IsKindOf(RUNTIME_CLASS(CMSFract))) {
						CMSFract *pF;
						pF = (CMSFract *) pN1;
						if(pF->m_value==1 && pF->m_deno==1)
							continue;
					}
					CMapStringToOb para2;
					switch(AnalyseFactForm(pN1, pV, para2)) {
					case FF_FORM_X:
					case FF_FORM_N_X:
//					case FF_FORM_F_X:
//					case FF_FORM_N_F_X:
						para["KEY"] = pV;
						para["NUME"] = pN1;
						para["DENO"] = pD;
						return SIMP_DIV_ABLE_FORM3;
					}
				}
			}
		}
	}
	//	SIMP_DIV_ABLE_FORM4	/* (a*b*c*..)/(a*d*e*..) */
	if(psym->IsKindOf(RUNTIME_CLASS(CMSODiv))) {
		POSITION pos1, pos2;
		CSymbInst *pN, *pN1, *pD, *pD1;
		CSymbInst *pV;
		pos = pInst->GetHeadPosition();
		pN = (CSymbInst *) pInst->GetNext(pos);
		pD = (CSymbInst *) pInst->GetNext(pos);
		if(pN->IsKindOf(RUNTIME_CLASS(CSymbInst)) && pD->IsKindOf(RUNTIME_CLASS(CSymbInst))
		&& pN->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))
		&& pD->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
			pos1 = pN->GetHeadPosition();
			while(pos1) {
				pN1 = (CSymbInst *) pN->GetNext(pos1);
				pV = pN1;
				if(pN1->IsKindOf(RUNTIME_CLASS(CSymbInst))
				&& pN1->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
					pos = pN1->GetHeadPosition();
					pV = (CSymbInst *) pN1->GetNext(pos);
				}
				if(pN1->IsKindOf(RUNTIME_CLASS(CMSFract))) {
					CMSFract *pF;
					pF = (CMSFract *) pN1;
					if(pF->m_value==1 && pF->m_deno==1)
						continue;
				}

				pos2 = pD->GetHeadPosition();
				while(pos2) {
					pD1 = (CSymbInst *) pD->GetNext(pos2);

					CMapStringToOb para2;
					switch(AnalyseFactForm(pD1, pV, para2)) {
					case FF_FORM_X:
					case FF_FORM_N_X:
						para["KEY"] = pV;
						para["NUME"] = pN1;
						para["DENO"] = pD1;
						return SIMP_DIV_ABLE_FORM4;
					}
				}
			}
		}
	}
	// SIMP_INV_INV		//  1/(1/X)
	if(psym->IsKindOf(RUNTIME_CLASS(CMSODiv)) && pInst->GetCount()==2) {
		CSymbInst *pN, *pD, *pN1, *pD1;
		pN = (CSymbInst *) pInst->GetChild(0);
		pD = (CSymbInst *) pInst->GetChild(1);
		if( pN->IsKindOf(RUNTIME_CLASS(CMSFract)) &&
			((CMSFract *) pN)->IsEqual(1) &&
			pD->IsKindOf(RUNTIME_CLASS(CSymbInst)) &&
			pD->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSODiv)) && 
			pD->GetCount()==2)
		{
			pN1 = (CSymbInst*) pD->GetChild(0);
			pD1 = (CSymbInst*) pD->GetChild(1);
			if( pN1->IsKindOf(RUNTIME_CLASS(CMSFract)) &&
				((CMSFract *) pN1)->IsEqual(1))
			{
				para["NUME1"] = pInst;
				para["NUME2"] = pD;
				para["KEY"] = pD1;
				return SIMP_INV_INV;
			}
		}
	}

	//  SIMP_NEG_DIV_NEG	//  (- (- X)/Y)
	if( psym->IsKindOf(RUNTIME_CLASS(CMSONeg)) &&
		pInst->GetCount()==1)
	{
		CSymbInst *pN, *pX, *pY;
		pN = (CSymbInst *) pInst->GetChild(0);
		if( pN->IsKindOf(RUNTIME_CLASS(CSymbInst)) &&
			pN->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSODiv)) &&
			pN->GetCount()==2 )
		{
			pX = (CSymbInst *) pN->GetChild(0);
			pY = (CSymbInst *) pN->GetChild(1);
			if( pX->IsKindOf(RUNTIME_CLASS(CSymbInst)) &&
				pX->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg)) &&
				pX->GetCount()==1 )
			{
				para["NUME"] = pX;
				para["DENO"] = pY;
				para["KEY"] = pX->GetChild(0);
				para["DIV"] = pN;
				return SIMP_NEG_DIV_NEG;
			}
		}
	}

	return SIMP_NOT_RECOGNIZED;
}

FACTOR_FORM	CJDDescretizer::AnalyseFactForm(CViecFC *pS, CViecFC *pV, CMapStringToOb& para)
{
	CJDCheckIfEqual checker;
	POSITION pos;
	CSymbInst *pI3, *pI2;

	checker.m_checked = pV;
	pI2 = (CSymbInst *) pS;
	pI3 = (CSymbInst *) pV;
	if(pI3->IsKindOf(RUNTIME_CLASS(CSymbInst)))
		if(pI3->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSUnknown))) 
			return FF_NOT_RECOGNIZED;
	//----- 1st type candidate
	//	pI2==V
	pI2->SendMsg(MSG_DO_JOB, &checker);
	if(checker.m_bResult)
		return FF_FORM_X;

	if(!pI2->IsKindOf(RUNTIME_CLASS(CSymbInst)))
		return FF_NOT_RECOGNIZED;

	//----- 2nd type candicate
	//	pI2==(-pI3)==(-V)
	if(pI2->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
		pos = pI2->GetHeadPosition();
		pI3 = (CSymbInst *) pI2->GetNext(pos);
		if(pI3->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			pI3->SendMsg(MSG_DO_JOB, &checker);
			if(checker.m_bResult)
				return FF_FORM_N_X;
		}
	}
	//----- 3rd type candicate
	//	pI2==(a*pI3)==(aV)
	if(pI2->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
		pos = pI2->GetHeadPosition();
		while(pos)
			pI3 = (CSymbInst *) pI2->GetNext(pos);
		if(pI3->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			pI3->SendMsg(MSG_DO_JOB, &checker);
			if(checker.m_bResult)
				return FF_FORM_F_X;
		}
	}
	if(pI2->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
		pos = pI2->GetHeadPosition();
		pI3 = (CSymbInst *) pI2->GetNext(pos);
		if(pI3->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
			CSymbInst *pI4;
			pos = pI3->GetHeadPosition();
			while(pos)
				pI4 = (CSymbInst *) pI3->GetNext(pos);
			if(pI4->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
				pI4->SendMsg(MSG_DO_JOB, &checker);
				if(checker.m_bResult)
					return FF_FORM_N_F_X;
			}
		}
	}
	return FF_NOT_RECOGNIZED;
}

BOOL CJDDescretizer::ExpPlusInPlus(CSymbInst*& pInst, CMapStringToOb& para)
{
			{
				CSymbInst *pI;
				POSITION pos, pos1;
				CViecFC *pO;
				CViecFC lst;

				pI = (CSymbInst *) para["FIRST"];
				pos = pInst->GetHeadPosition();
				while(pos)
					lst.AddTail(pInst->GetNext(pos));
				pInst->SetFocusChild(NULL);
				pInst->m_child.RemoveAll();
				pos = lst.GetHeadPosition();
				while(pos) {
					pO = lst.GetNext(pos);
					if(pO!=pI) {
						pInst->AddTail(pO);
					} else {
						pos1 = pI->GetHeadPosition();
						while(pos1)
							pInst->AddTail(pI->GetNext(pos1));
					}
				}
				lst.m_child.RemoveAll();
				pI->m_child.RemoveAll();
				pInst->OnCreated();
				delete pI;
			}
	return TRUE;
}

BOOL CJDDescretizer::ExpPlusInMult(CSymbInst*& pInst, CMapStringToOb& para)
{
			{
				CViecFC FstP, SndP;
				CSymbInst *pI, *pM;
				POSITION pos, pos2;
				BOOL bFstPart;
				CViecFC *pO, *p2;

				pI = (CSymbInst *) para["FIRST"];
				pos = pInst->GetHeadPosition();
				bFstPart = TRUE;
				while(pos) {
					pO = pInst->GetNext(pos);
					if(pO==pI)	bFstPart = FALSE;
					else if(bFstPart)	FstP.AddTail(pO);
					else	SndP.AddTail(pO);
				}
				pInst->SetFocusChild(NULL);
				pInst->m_child.RemoveAll();

				pos = pI->GetHeadPosition();
				while(pos) {
					pM = new CSymbInst("*");
					pInst->AddTail(pM);
					pos2 = FstP.GetHeadPosition();
					while(pos2)
						pM->AddTail(FstP.GetNext(pos2)->Copy());
					p2 = pI->GetNext(pos);
					pM->AddTail(p2);
					pos2 = SndP.GetHeadPosition();
					while(pos2)
						pM->AddTail(SndP.GetNext(pos2)->Copy());
				}
				pI->m_child.RemoveAll();
				pInst->ChangeInst("+");
				pInst->OnCreated();
				delete pI;
			}
	return TRUE;
}

// a(bc..)d..	->	abc..d..
BOOL CJDDescretizer::ExpMultInMult(CSymbInst*& pInst, CMapStringToOb& para)
{
	CSymbInst *pI;
	POSITION pos, pos1;
	CViecFC *pO;
	CViecFC lst;

	pos = pInst->GetHeadPosition();
	while(pos)
		pI = (CSymbInst *) pInst->GetNext(pos);
	if(m_target.IsThis(pI))
		return FALSE;

	pI = (CSymbInst *) para["FIRST"];
	pos = pInst->GetHeadPosition();
	while(pos)
		lst.AddTail(pInst->GetNext(pos));
	pInst->SetFocusChild(NULL);
	pInst->m_child.RemoveAll();
	pos = lst.GetHeadPosition();
	while(pos) {
		pO = lst.GetNext(pos);
		if(pO!=pI) {
			pInst->AddTail(pO);
		} else {
			pos1 = pI->GetHeadPosition();
			while(pos1)
				pInst->AddTail(pI->GetNext(pos1));
		}
	}
	lst.m_child.RemoveAll();
	pI->m_child.RemoveAll();
	pInst->OnCreated();
	delete pI;

	return TRUE;
}

/*
// a(bc..)d..	->	abc..d..
BOOL CJDDescretizer::ExpMultInMult(CSymbInst*& pInst, CMapStringToOb& para)
{
	CSymbInst *pI;
	POSITION pos, pos1;
	CViecFC *pO;
	CViecFC lst;
	pI = (CSymbInst *) para["FIRST"];
	pos = pInst->GetHeadPosition();
	while(pos)
		lst.AddTail(pInst->GetNext(pos));
	pInst->SetFocusChild(NULL);
	pInst->m_child.RemoveAll();
	pos = lst.GetHeadPosition();
	while(pos) {
		pO = lst.GetNext(pos);
		if(pO!=pI) {
			pInst->AddTail(pO);
		} else {
			pos1 = pI->GetHeadPosition();
			while(pos1)
				pInst->AddTail(pI->GetNext(pos1));
		}
	}
	lst.m_child.RemoveAll();
	pI->m_child.RemoveAll();
	pInst->OnCreated();
	delete pI;

	return TRUE;
}
*/

BOOL CJDDescretizer::ExpNegInMult(CSymbInst*& pInst, CMapStringToOb& para)
{
			{
				POSITION pos, pos1;
				CSymbInst *pI, *pN;
				CViecFC *pE;
				CViecFC lst;
				int cnt = 0;
				pos = pInst->GetHeadPosition();
				while(pos) {
					pI = (CSymbInst *) pInst->GetNext(pos);
					if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
					if(!pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg))) continue;
					pos1 = pI->GetHeadPosition();
					pE = pI->GetNext(pos1);
					pInst->SubstChild(pI, pE);
					pI->m_child.RemoveAll();
					delete pI;
					cnt++;
				}
				if(cnt%2) {
					pos = pInst->GetHeadPosition();
					pN = new CSymbInst("*");
					while(pos)	pN->AddTail(pInst->GetNext(pos));
					pInst->m_child.RemoveAll();
					pInst->AddTail(pN);
					pInst->ChangeInst("-?");
					pInst->OnCreated();
				}
			}
	return TRUE;
}

BOOL CJDDescretizer::ExpPlusInNume(CSymbInst*& pInst, CMapStringToOb& para)
{
			{
				POSITION pos;
				CSymbInst *pD, *pN, *pDV;
				CViecFC *pN1;
				pos = pInst->GetHeadPosition();
				pN = (CSymbInst *) pInst->GetNext(pos);
				pD = (CSymbInst *) pInst->GetNext(pos);
				pInst->m_child.RemoveAll();
				pos = pN->GetHeadPosition();
				while(pos) {
					pN1 = pN->GetNext(pos);
					pDV = new CSymbInst("/");
					pDV->AddTail(pN1->Copy());
					pDV->AddTail(pD->Copy());
					pInst->AddTail(pDV);
				}
				delete pN;
				delete pD;
				pInst->ChangeInst("+");
				pInst->OnCreated();
			}
	return TRUE;
}

BOOL CJDDescretizer::ExpPlusInNeg(CSymbInst*& pInst, CMapStringToOb& para)
{
				POSITION pos;
				CViecFC *pE;
				CViecFC *pE1;
				CSymbInst *pN;
				pos = pInst->GetHeadPosition();
				pE = (CViecFC *) pInst->GetNext(pos);
				pInst->m_child.RemoveAll();
				pos = pE->GetHeadPosition();
				while(pos) {
					pE1 = pE->GetNext(pos);
					pN = new CSymbInst("-?");
					pN->AddTail(pE1);
					pInst->AddTail(pN);
				}
				pInst->ChangeInst("+");
				pInst->OnCreated();
	return TRUE;
}

BOOL CJDDescretizer::ExpNegInNeg(CSymbInst*& pInst, CMapStringToOb& para)
{
			{
				POSITION pos;
				CViecFC *pE, *pE1;
				pos = pInst->GetHeadPosition();
				pE = (CViecFC *) pInst->GetNext(pos);
				pos = pE->GetHeadPosition();
				pE1 = (CViecFC *) pE->GetNext(pos);
				pInst->GetParent()->SubstChild(pInst, pE1);
				pInst = (CSymbInst *) pE1;
			}
	return TRUE;
}

BOOL CJDDescretizer::ExpDepInMult(CSymbInst*& pInst, CMapStringToOb& para)
{
	if(pInst->GetCount()>2) {
		POSITION pos;
		CSymbInst *pE, *pF;
		pF = new CSymbInst("*");
		pos = pInst->GetHeadPosition();
		while(pos) {
			pE = (CSymbInst *) pInst->GetNext(pos);
			if(!pos) break;
			pF->AddTail(pE);
		}
		pInst->m_child.RemoveAll();
		pInst->ChangeInst("*");
		pInst->AddTail(pF);
		pInst->AddTail(pE);
		pInst->OnCreated();
	}
	return TRUE;
}

BOOL CJDDescretizer::ExpDepInNegMult(CSymbInst*& pInst, CMapStringToOb& para)
{
					POSITION pos;
					CViecFC *pE, *pH, *pV;
					CSymbInst *pN;
					pos = pInst->GetHeadPosition();
					pN = (CSymbInst *) pInst->GetNext(pos);
					pos = pN->GetHeadPosition();
					if(pInst->GetCount()==2) {
						pH = pN->GetNext(pos);
						pV = pN->GetNext(pos);
					} else {
						pH = new CSymbInst("*");
						while(pos) {
							pE = pN->GetNext(pos);
							if(pos)
								pH->AddTail(pE);
							else
								pV = pE;
						}
					}
					pN->m_child.RemoveAll();
					pN->ChangeInst("-?");
					pN->AddTail(pH);

					pInst->ChangeInst("*");
					pInst->m_child.RemoveAll();
					pInst->AddTail(pN);
					pInst->AddTail(pV);
					pInst->OnCreated();
/*
			{
				POSITION pos;
				CViecFC *pF;
				CSymbInst *pI, *pN, *pV;
				pos = pInst->GetHeadPosition();
				pI = (CSymbInst *) pInst->GetNext(pos);
				if(pI->GetCount()==2) {
					pos = pI->GetHeadPosition();
					pF = pI->GetNext(pos);
					pV = (CSymbInst *) pI->GetNext(pos);
					pI->m_child.RemoveAll();
					pInst->m_child.RemoveAll();
					pI->ChangeInst("-?");
					pInst->ChangeInst("*");
					pI->AddTail(pF);
					pInst->AddTail(pI);
					pInst->AddTail(pV);
				} else {
					pos = pI->GetHeadPosition();
					while(pos) {
						pF = (CSymbInst *) pI->GetNext(pos);
						if(!pos)	pV = (CSymbInst *) pF;
					}
					pI->m_child.RemoveTail();
					pInst->m_child.RemoveAll();
					pN = new CSymbInst("-?");
					pN->AddTail(pI);
					pInst->ChangeInst("*");
					pInst->AddTail(pN);
					pInst->AddTail(pV);
				}
				pInst->OnCreated();
			}
*/
			return TRUE;
}

BOOL CJDDescretizer::ExpDepInNumeMult(CSymbInst*& pInst, CMapStringToOb& para)
{
				POSITION pos;
				CSymbInst *pF, *pF2, *pV, *pI, *pD;
				pos = pInst->GetHeadPosition();
				pI = (CSymbInst *) pInst->GetNext(pos);
				pD = (CSymbInst *) pInst->GetNext(pos);
				pos = pI->GetHeadPosition();
				while(pos) {
					pF = (CSymbInst *) pI->GetNext(pos);
					if(!pos) pV = pF;
				}
				pI->m_child.RemoveTail();
				if(pI->GetCount()==1) {
					pos = pI->GetHeadPosition();
					pF2 = (CSymbInst *) pI->GetNext(pos);
					pI->m_child.RemoveAll();
					delete pI;
				} else {
					pF2 = pI;
				}
				pF = new CSymbInst("/");
				pF->AddTail(pF2);
				pF->AddTail(pD);
				pInst->m_child.RemoveAll();
				pInst->ChangeInst("*");
				pInst->AddTail(pF);
				pInst->AddTail(pV);
				pInst->OnCreated();
	return TRUE;
}

BOOL CJDDescretizer::ExpDepInNegNumeMult(CSymbInst*& pInst, CMapStringToOb& para)
{
				POSITION pos;
				CSymbInst *pF, *pF2, *pV, *pI, *pD, *pS;
				pos = pInst->GetHeadPosition();
				pS = (CSymbInst *) pInst->GetNext(pos);
				pos = pS->GetHeadPosition();
				pI = (CSymbInst *) pS->GetNext(pos);
				pD = (CSymbInst *) pS->GetNext(pos);
				pos = pI->GetHeadPosition();
				while(pos) {
					pF = (CSymbInst *) pI->GetNext(pos);
					if(!pos) pV = pF;
				}
				pI->m_child.RemoveTail();
				if(pI->GetCount()==1) {
					pos = pI->GetHeadPosition();
					pF2 = (CSymbInst *) pI->GetNext(pos);
					pI->m_child.RemoveAll();
					delete pI;
				} else {
					pF2 = pI;
				}
				pF = new CSymbInst("/");
				pF->AddTail(pF2);
				pF->AddTail(pD);
				pS->m_child.RemoveAll();
				pS->ChangeInst("-?");
				pS->AddTail(pF);
				pInst->m_child.RemoveAll();
				pInst->ChangeInst("*");
				pInst->AddTail(pS);
				pInst->AddTail(pV);
				pInst->OnCreated();
	return TRUE;
}

BOOL CJDDescretizer::BindPlusAbleForm1(CSymbInst*& pInst, CMapStringToOb& para)
{
				CSymbInst *pV, *pI, *pK, *pP, *pM;
				POSITION pos, pos2;
				CViecFC lstA,lstB,lstC;
				CViecFC *pE;
				CViecFC *pS, *pU;
				CMapStringToOb para2;
				CMSFract *pF;

				pV = (CSymbInst *) para["FIRST"];
				pK = (CSymbInst *) para["KEY"];
				pos = pInst->GetHeadPosition();
				while(pos) {
					pos2 = pos;
					pE = pInst->GetNext(pos);
					if(pE==pV) break;
					lstA.AddTail(pE);
				}
				pU = (CViecFC *) pK->Copy();
				pInst->AddTail(pU);
				pU->OnCreated();
				pInst->m_child.RemoveTail();
				pP = new CSymbInst("+");
				pos = pos2;
				while(pos) {
					pE = pInst->GetNext(pos);
					if(!pE->IsKindOf(RUNTIME_CLASS(CViecFC))) {
						lstC.AddTail(pE);
						continue;
					}
					pS = (CViecFC *) pE;
					switch(AnalyseFactForm(pS, pU, para2)) {
					case FF_FORM_X:
						pF = new CMSFract(1,1);
						pP->AddTail(pF);
						delete pS;
						break;
					case FF_FORM_N_X:
						pF = new CMSFract(-1,1);
						pP->AddTail(pF);
						delete pS;
						break;
					case FF_FORM_F_X:
						pos2 = pS->GetHeadPosition();
						while(pos2)
							pI = (CSymbInst *) pS->GetNext(pos2);
						pS->m_child.RemoveTail();
						delete pI;
						if(pS->GetCount()==1) {
							pos2 = pS->GetHeadPosition();
							pP->AddTail(pS->GetNext(pos2));
							pS->m_child.RemoveAll();
							delete pS;
						} else {
							pP->AddTail(pS);
						}
						break;
					case FF_FORM_N_F_X:
						pos2 = pS->GetHeadPosition();
						pM = (CSymbInst *) pS->GetNext(pos2);
						pos2 = pM->GetHeadPosition();
						while(pos2)
							pI = (CSymbInst *) pM->GetNext(pos2);
						pM->m_child.RemoveTail();
						delete pI;
						if(pM->GetCount()==1) {
							pos2 = pM->GetHeadPosition();
							pS->SubstChild(pM, pM->GetNext(pos2));
							pM->m_child.RemoveAll();
							delete pM;
						}
						pP->AddTail(pS);
						break;
					default:
						lstC.AddTail(pS);
					}
				};
				if(pP->GetCount()>1) {
					pInst->m_child.RemoveAll();
					pos = lstA.GetHeadPosition();
					while(pos) pInst->AddTail(lstA.GetNext(pos));

					pM = new CSymbInst("*");
					pM->AddTail(pP);
					pM->AddTail(pU);
					pInst->AddTail(pM);

					pos = lstC.GetHeadPosition();
					while(pos) pInst->AddTail(lstC.GetNext(pos));
					if(lstA.GetCount()==0 && lstC.GetCount()==0) {
						pInst->GetParent()->SubstChild(pInst, pM);
						pInst->m_child.RemoveAll();
						delete pInst;
						pInst = pM;
					}
				} else {
					delete pP;
				}
				lstA.m_child.RemoveAll();
				lstB.m_child.RemoveAll();
				lstC.m_child.RemoveAll();
				pInst->OnCreated();
	return TRUE;
}

BOOL CJDDescretizer::BindPlusAbleForm2(CSymbInst*& pInst, CMapStringToOb& para)
{
	POSITION pos;
	CViecFC pC, *pM;
	CViecFC *pP, *pE, *pF;

	pF = NULL;
	pP = new CSymbInst("+");
	pos = pInst->GetHeadPosition();
	while(pos) {
		pM = (CViecFC *) pInst->GetNext(pos);
		if(pF==NULL)
			pF = (CMSFract *) pM->m_child.RemoveHead();
		else
			delete pM->m_child.RemoveHead();
		if(pM->GetCount()==1) {
			pE = (CViecFC *) pM->m_child.RemoveHead();
			delete pM;
			pM = (CViecFC *) pE;
		}
		pP->AddTail(pM);
	}
	pInst->m_child.RemoveAll();
	pInst->ChangeInst("*");
	pInst->AddTail(pF);
	pInst->AddTail(pP);
	pInst->OnCreated();
	return TRUE;
}
		
BOOL CJDDescretizer::SimpPlusAbleForm2(CSymbInst*& pInst, CMapStringToOb& para)
{
				POSITION pos;
				CViecFC lstA;
				CViecFC *pE;
				CMSFract *pF, *pF1;
				pF = NULL;
				pos = pInst->GetHeadPosition();
				while(pos) {
					pE = pInst->GetNext(pos);
					if(pE->IsKindOf(RUNTIME_CLASS(CMSFract))) {
						pF1 = (CMSFract *) pE;
						if(pF==NULL) {
							pF = pF1;
						} else {
							pF->Plus(pF1->m_value, pF1->m_deno);
							delete pF1;
						}
					} else {
						lstA.AddTail(pE);
					}
				}
				pInst->m_child.RemoveAll();
				if(lstA.GetCount()==0) {
					pInst->GetParent()->SubstChild(pInst, pF);
					delete pInst;
					pInst = (CSymbInst *) pF;
				} else {
					pInst->AddTail(pF);
					pos = lstA.GetHeadPosition();
					while(pos)
						pInst->AddTail(lstA.GetNext(pos));
				}
				lstA.m_child.RemoveAll();
	return TRUE;
}

BOOL CJDDescretizer::SimpMultAbleForm1(CSymbInst*& pInst, CMapStringToOb& para)
{
				POSITION pos;
				CViecFC lstA;
				CViecFC *pE;
				CMSFract *pF, *pF1;
				pF = NULL;
				pos = pInst->GetHeadPosition();
				while(pos) {
					pE = pInst->GetNext(pos);
					if(pE->IsKindOf(RUNTIME_CLASS(CMSFract))) {
						pF1 = (CMSFract *) pE;
						if(pF==NULL) {
							pF = pF1;
						} else {
							pF->Mult(pF1->m_value, pF1->m_deno);
							delete pF1;
						}
					} else {
						lstA.AddTail(pE);
					}
				}
				pInst->m_child.RemoveAll();
				if(lstA.GetCount()==0) {
					pInst->GetParent()->SubstChild(pInst, pF);
					delete pInst;
					pInst = (CSymbInst *) pF;
				} else {
					pInst->AddTail(pF);
					pos = lstA.GetHeadPosition();
					while(pos)
						pInst->AddTail(lstA.GetNext(pos));
				}
				lstA.m_child.RemoveAll();
	return TRUE;
}

BOOL CJDDescretizer::SimpDivAbleForm1(CSymbInst*& pInst, CMapStringToOb& para)
{
	POSITION pos;
	CMSFract *pF1, *pF2;
	pos = pInst->GetHeadPosition();
	pF1 = (CMSFract *) pInst->GetNext(pos);
	pF2 = (CMSFract *) pInst->GetNext(pos);
	pF1->Mult(pF2->m_deno, pF2->m_value);
	pInst->GetParent()->SubstChild(pInst, pF1);
	pInst->m_child.RemoveAll();
	delete pInst;
	delete pF2;
	pInst = (CSymbInst *) pF1;
	return TRUE;
}

BOOL CJDDescretizer::SimpDivAbleForm2(CSymbInst*& pInst, CMapStringToOb& para)
{
	int i;
	CMapStringToOb para2;
	CViecFC *pN[2], *pK;
	CMSFract *pF;
	pN[0] = (CViecFC *) para["NUME"];
	pN[1] = (CViecFC *) para["DENO"];
	pK = (CViecFC *) para["KEY"];
	for(i=0;i<2;i++) {
		switch(AnalyseFactForm(pN[i], pK, para2)) {
		case FF_FORM_X:
			pF = new CMSFract(1,1);
			pN[i]->GetParent()->SubstChild(pN[i], pF);
			break;
		case FF_FORM_N_X:
			pF = new CMSFract(-1, 1);
			pN[i]->GetParent()->SubstChild(pN[i], pF);
			break;
		}
	}
	for(i=0;i<2;i++) {
		delete pN[i];
	}
	return TRUE;
}

BOOL CJDDescretizer::SimpPlusInt0(CSymbInst*& pInst, CMapStringToOb& para)
{
	// a+0
	POSITION pos;
	CViecFC *pE;
	CViecFC lst;
	CMSFract *pF;
	pos = pInst->GetHeadPosition();
	while(pos) {
		pE = pInst->GetNext(pos);
		if(pE->IsKindOf(RUNTIME_CLASS(CMSFract))) {
			pF = (CMSFract *) pE;
			if(pF->m_value==0) {
				delete pF;
				continue;
			}
		}
		lst.AddTail(pE);
	}
	pInst->m_child.RemoveAll();
	pos = lst.GetHeadPosition();
	while(pos) {
		pE = lst.GetNext(pos);
		pInst->AddTail(pE);
	}
	lst.m_child.RemoveAll();
	if(pInst->GetCount()==1) {
		pInst->GetParent()->SubstChild(pInst, pE);
		pInst->m_child.RemoveAll();
		delete pInst;
		pInst = (CSymbInst *) pE;
	} else if(pInst->GetCount()==0) {
		pF = new CMSFract(0);
		pInst->GetParent()->SubstChild(pInst, pF);
		delete pInst;
		pInst = (CSymbInst *) pF;
	}
	return TRUE;
}

BOOL CJDDescretizer::SimpMultInt0(CSymbInst*& pInst, CMapStringToOb& para)
{
	CMSFract *pF;
	pF = new CMSFract(0);
	pInst->GetParent()->SubstChild(pInst, pF);
	delete pInst;
	pInst = (CSymbInst *) pF;
	return TRUE;
}

BOOL CJDDescretizer::SimpMultInt1(CSymbInst*& pInst, CMapStringToOb& para)
{
	POSITION pos;
	CMSFract *pF;
	CViecFC *pE;
	CViecFC lst;
	pos = pInst->GetHeadPosition();
	while(pos) {
		pE = pInst->GetNext(pos);
		if(pE->IsKindOf(RUNTIME_CLASS(CMSFract))) {
			pF = (CMSFract *) pE;
			if(pF->m_value==1 && pF->m_deno==1) {
				delete pF;
				continue;
			}
		}
		lst.AddTail(pE);
	}
	pInst->m_child.RemoveAll();
	pos = lst.GetHeadPosition();
	while(pos) {
		pE = lst.GetNext(pos);
		pInst->AddTail(pE);
	}
	lst.m_child.RemoveAll();
	if(pInst->GetCount()==1) {
		pInst->GetParent()->SubstChild(pInst, pE);
		pInst->m_child.RemoveAll();
		delete pInst;
		pInst = (CSymbInst *) pE;
	} else if(pInst->GetCount()==0) {
		pF = new CMSFract(1);
		pInst->GetParent()->SubstChild(pInst, pF);
		delete pInst;
		pInst = (CSymbInst *) pF;
	}
	return TRUE;
}
				
BOOL CJDDescretizer::SimpDivBy1(CSymbInst*& pInst, CMapStringToOb& para)
{
	POSITION pos;
	CViecFC *pE;
	pos = pInst->GetHeadPosition();
	pE = pInst->GetNext(pos);
	delete pInst->GetNext(pos);
	pInst->GetParent()->SubstChild(pInst, pE);
	pInst->m_child.RemoveAll();
	delete pInst;
	pInst = (CSymbInst *) pE;
	return TRUE;
}

BOOL CJDDescretizer::SimpNegInt(CSymbInst*& pInst, CMapStringToOb& para)
{
	POSITION pos;
	CMSFract *pF;
	pos = pInst->GetHeadPosition();
	pF = (CMSFract *) pInst->GetNext(pos);
	pF->m_value = - pF->m_value;
	pInst->GetParent()->SubstChild(pInst, pF);
	pInst->m_child.RemoveAll();
	delete pInst;
	pInst = (CSymbInst *) pF;
	return TRUE;
}

BOOL CJDDescretizer::SimpInvInv(CSymbInst*& pInst, CMapStringToOb& para)
{
	CViecFC *pN1, *pN2, *pKey;
	pN1 = (CViecFC *) para["NUME1"];
	pN2 = (CViecFC *) para["NUME2"];
	pKey = (CViecFC *) para["KEY"];
	if(pInst!=pN1) return FALSE;
	pN2->RemoveTail();
	pInst->GetParent()->SubstChild(pInst, pKey);
	delete pInst;
	pInst = (CSymbInst *) pKey;
	return TRUE;
}

BOOL CJDDescretizer::SimpNegDivNeg(CSymbInst*& pInst, CMapStringToOb& para)
{
	CViecFC *pN, *pD, *pK, *pV;
	pK = (CViecFC *) para["KEY"];
	pN = (CViecFC *) para["NUME"];
	pD = (CViecFC *) para["DENO"];
	pV = (CViecFC *) para["DIV"];
	pV->RemoveAll();
	pInst->RemoveAll();
	pN->RemoveAll();
	pV->AddTail(pK);
	pV->AddTail(pD);
	pInst->GetParent()->SubstChild(pInst, pV);
	delete pInst;
	delete pN;
	pInst = (CSymbInst *) pV;
	return TRUE;
}

///////////////////////////  CJDDescDeriv  ///////////////////////////
///////////////////////////  CJDDescDeriv  ///////////////////////////

BOOL CJDDescDeriv::Do(CObject *g)
{
	CSymbInst *pInst;
	CViecFC *psym;
	
	pInst = (CSymbInst *) g;
	if(!m_bStartFg) {
		return FindStartCond(pInst);
	} else {
		if(!pInst->IsKindOf(RUNTIME_CLASS(CSymbInst)))	return FALSE;
		psym = pInst->GetSymbBody();

		CMapStringToOb para;
		switch(AnalyseForm(pInst, para)) {
		case AF_DEP_VAR:
			ShiftVar(pInst);
			break;
		case AF_PART_DIFF_SPACE_1:
			DiscDerivC1(pInst, para);
			break;
		case AF_PART_DIFF_SPACE_2:
			DiscDerivC2(pInst, para);
			break;
		default:
			return FALSE;
		}
		pInst->CalcExt(CViecFC::dirDown);
		pInst->CalcExt();
		return TRUE;
	}
	return FALSE;
}

///////////////////////////  CJDDescUpwndFstOrd  ///////////////////////////
///////////////////////////  CJDDescUpwndFstOrd  ///////////////////////////

BOOL CJDDescUpwndFstOrd::Do(CObject *g)
{
	CSymbInst *pInst;
	CViecFC *psym;
	
	pInst = (CSymbInst *) g;
	if(!m_bStartFg) {
		return FindStartCond(pInst);
	} else {
		if(!pInst->IsKindOf(RUNTIME_CLASS(CSymbInst)))	return FALSE;
		psym = pInst->GetSymbBody();

		CMapStringToOb para;
		switch(AnalyseForm(pInst, para)) {
		case AF_DEP_VAR:
			ShiftVar(pInst);
			break;
		case AF_UPWIND:
			DiscUpwndFstOrd(pInst, para);
			break;
		case AF_PART_DIFF_TIME_1:
			DiscDerivTime1(pInst, para);
			break;
		case AF_PART_DIFF_SPACE_1:
			DiscDerivC1(pInst, para);
			break;
		case AF_PART_DIFF_SPACE_2:
			DiscDerivC2(pInst, para);
			break;
		default:
			return FALSE;
		}
		pInst->CalcExt(CViecFC::dirDown);
		pInst->CalcExt();
		return TRUE;
	}
	return FALSE;
}

///////////////////////////  CJDShiftToPos  ///////////////////////////
///////////////////////////  CJDShiftToPos  ///////////////////////////
BOOL CJDShiftToPos::FindStartCond(CSymbInst* pInst)
{
	CViecFC *pelm;
	POSITION pos;
	CViecFC *psym;

	if(pInst->IsKindOf(RUNTIME_CLASS(CPDETarget))) {
		CSymbInst *pInst2;
		CViecFC *psym2;
		CPDEDepInfo *pDep;
		psym = pInst->GetSymbBody();
		if(!psym->IsKindOf(RUNTIME_CLASS(CMSDepVar))) return TRUE;
		if(pInst->GetCount()==0) return TRUE;
		pDep = (CPDEDepInfo *) psym->GetParent();
		if(!pDep->IsKindOf(RUNTIME_CLASS(CPDEDepInfo))) return TRUE;
		pos = pInst->GetHeadPosition();
		pInst2 = (CSymbInst *) pInst->GetNext(pos);
		if(!pInst2->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
		psym2 = pInst2->GetSymbBody();
		if(psym2->IsKindOf(RUNTIME_CLASS(CMSIndex))) {
			m_target.m_theDep = (CMSPhys *) psym;
			m_target.m_timeIndex = (CMSIndex *) psym2;
			m_target.m_timeShift.m_value = 0;
			m_target.m_timeShift.m_deno = 1;
		} else if(psym2->IsKindOf(RUNTIME_CLASS(CMSOPlus)) && pInst2->GetCount()==2) {
			CSymbInst *pInst3;
			CViecFC *psym3;
			CMSFract *pfrct;
			pos = pInst2->GetHeadPosition();
			pInst3 = (CSymbInst *) pInst2->GetNext(pos);
			pfrct = (CMSFract *) pInst2->GetNext(pos);
			if(!pInst3->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
			psym3 = pInst3->GetSymbBody();
			if(!pfrct->IsKindOf(RUNTIME_CLASS(CMSFract))) return TRUE;
			if(!psym3->IsKindOf(RUNTIME_CLASS(CMSIndex))) return TRUE;
			m_target.m_theDep = (CMSPhys *) psym;
			m_target.m_timeIndex = (CMSIndex *) psym3;
			m_target.m_timeShift.m_value = pfrct->m_value;
			m_target.m_timeShift.m_deno = pfrct->m_deno;
		}
		int i;
		for(i=0;i<3;i++) {
			switch(pDep->m_pos->m_pos[i]) {
			case 0:
				m_shift[i+1].m_value = -1;
				m_shift[i+1].m_deno = 2;
				break;
			case 1:
				m_shift[i+1].m_value = 0;
				m_shift[i+1].m_deno = 2;
				break;
			case 2:
				m_shift[i+1].m_value = 1;
				m_shift[i+1].m_deno = 2;
				break;
			}
		}
		return TRUE;
	}
	int shft;
	if(pInst->IsKindOf(RUNTIME_CLASS(CPDEBoundCond))) {
		CPDEBoundDef *pBD;
		pBD = (CPDEBoundDef *) pInst->GetSymbBody();
		if(pBD->IsKindOf(RUNTIME_CLASS(CPDEBoundDef))) {
			switch(pBD->m_surf->m_pHalfDir->m_bHalf) {
			case 0:	shft = -1;	break;
			case 1:	shft = 0;	break;
			case 2:	shft = 1;	break;
			}
			if(shft!=m_shift[pBD->m_surf->m_axisNo+1].m_value) {
				shft = shft - m_shift[pBD->m_surf->m_axisNo+1].m_value;
				m_shift[pBD->m_surf->m_axisNo+1].Plus(shft, 2);
				POSITION pos;
				pos = pInst->GetHeadPosition();
				while(pos) {
					pelm = pInst->GetNext(pos);
					pelm->SendMsg(MSG_DO_JOB, this);
				}
				m_shift[pBD->m_surf->m_axisNo+1].Plus(-shft, 2);
				return TRUE;
			}
		}
	}
	if(pInst->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		psym = pInst->GetSymbBody();
		if(psym->IsKindOf(RUNTIME_CLASS(CMSOEqual))) {
			if(!m_target.m_theDep || !m_target.m_timeIndex) return TRUE;
			m_bStartFg = TRUE;
			pos = pInst->GetHeadPosition();
			while(pos) {
				pelm = pInst->GetNext(pos);
				pelm->SendMsg(MSG_DO_JOB, this);
			}
			m_bStartFg = FALSE;
			return TRUE;
		}
	}
	return FALSE;
}

BOOL CJDShiftToPos::Do(CObject *g)
{
	CSymbInst *pInst;
	CViecFC *psym;
	
	pInst = (CSymbInst *) g;
	if(!m_bStartFg) {
		return FindStartCond(pInst);
	} else {
		if(!pInst->IsKindOf(RUNTIME_CLASS(CSymbInst)))	return FALSE;
		psym = pInst->GetSymbBody();

		CMapStringToOb para;
		switch(AnalyseForm(pInst, para)) {
		case AF_DEP_VAR:
			ShiftVarToPos(pInst);
			break;
		default:
			return FALSE;
		}
		pInst->CalcExt(CViecFC::dirDown);
		pInst->CalcExt();
		return TRUE;
	}
	return FALSE;
}

//////////////////////  CJDMapToFit  /////////////////////////
//////////////////////  CJDMapToFit  /////////////////////////

BOOL CJDMapToFit::Do(CObject *g)
{
	CSymbInst *pInst;
	CViecFC *psym;
	
	pInst = (CSymbInst *) g;
	if(!m_bStartFg) {
		return FindStartCond(pInst);
	} else {
		if(!pInst->IsKindOf(RUNTIME_CLASS(CSymbInst)))	return FALSE;
		psym = pInst->GetSymbBody();

		CMapStringToOb para;
		switch(AnalyseForm(pInst, para)) {
		case AF_DEP_VAR:
			{
				POSITION pos, pos2;
				CViecFC *pelm;
				int i;
				CSymbInst *pI1, *pI2;
				CViecFC *pS1;
				CMSFract *pF;
				int m,n=0;

				if(pInst->GetCount()<2) return TRUE;
				pos = pInst->GetHeadPosition();
				for(i=0; pos; i++) {
					pelm = pInst->GetNext(pos);
					if(!pelm->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
					pI1 = (CSymbInst *) pelm;
					pS1 = pI1->GetSymbBody();
					if(!pS1->IsKindOf(RUNTIME_CLASS(CMSOPlus))) continue;
					if(pI1->GetCount()!=2) continue;
					pos2 = pI1->GetHeadPosition();
					pI1->GetNext(pos2);
					pF = (CMSFract *) pI1->GetNext(pos2);
					if(!pF->IsKindOf(RUNTIME_CLASS(CMSFract))) continue;
					if(pF->m_value==0 || pF->m_deno!=2) continue;
					m = i;
					n++;
					break;
				}
				if(n) {
					pI2 = new CSymbInst("*");
					pI1 = new CSymbInst("+");
					pF = new CMSFract();
					pF->m_value = 1;
					pF->m_deno = 2;
					pI2->AddTail(pF);
					pI2->AddTail(pI1);
					pInst->GetParent()->SubstChild(pInst, pI2);
					CSymbInst *pD1, *pD2;
					pD1 = (CSymbInst *) pInst->Copy();
					pD2 = (CSymbInst *) pInst->Copy();
					pI1->AddTail(pD1);
					pI1->AddTail(pD2);
					pI2->OnCreated();
					for(i=0; i<4; i++) {
						m_shift[i].m_value = 0;
						m_shift[i].m_deno = 2;
					}
					m_shift[m].m_value = 1;
					ShiftVar(pD1);
					m_shift[m].m_value = -1;
					ShiftVar(pD2);
					pI2->SendMsg(MSG_DO_JOB, this);

					pI2->CalcExt(CViecFC::dirDown);
					pI2->CalcExt();
					delete pInst;
				}
			}
			return TRUE;
		}
		return FALSE;
	}
	return FALSE;
}

////////////////////// CJDCheckDepend /////////////////////
////////////////////// CJDCheckDepend /////////////////////
////////////////////// CJDCheckDepend /////////////////////

BOOL CJDCheckDepend::Do(CObject *g)
{
	CSymbInst *pI;
	if(g->IsKindOf(RUNTIME_CLASS(CPDETarget))) {
		m_bStartFg = TRUE;
		return FindStartCond((CSymbInst *) g);
	}
	if(g->IsKindOf(RUNTIME_CLASS(CPDEBoundCond)))
		return TRUE;
	pI = (CSymbInst *) g;
	if(pI->IsKindOf(RUNTIME_CLASS(CSymbInst))
		&& pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOEqual))) {
		if(!CanThisCalc((CSymbInst*) pI->GetChild(1)))
			m_bStartFg = FALSE;
		return TRUE;
	}
	return FALSE;
}

BOOL CJDCheckDepend::CanThisCalc(CSymbInst *pI)
{
	POSITION pos;
	int i;
	if(pI->IsKindOf(RUNTIME_CLASS(CSymbInst))
		&& pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSDepVar))) {
		for(i=0;i<checkNo;i++)
			if(targetVar[i].IsThis(pI))
				break;
		if(i<checkNo)
			return TRUE;
		return FALSE;
	}
	if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst)))
		return TRUE;
	pos = pI->GetHeadPosition();
	while(pos)
		if(!CanThisCalc((CSymbInst *) pI->GetNext(pos)))
			return FALSE;
	return TRUE;
}

//////////////////////  CJDCheckIfIncluded  /////////////////////////
//////////////////////  CJDCheckIfIncluded  /////////////////////////
//////////////////////  CJDCheckIfIncluded  /////////////////////////

CJDCheckIfIncluded::CJDCheckIfIncluded(CJDDescretizer& o)
{
	m_target.m_theDep = o.m_target.m_theDep;
	m_target.m_timeIndex = o.m_target.m_timeIndex;
	m_target.m_timeShift.m_value = o.m_target.m_timeShift.m_value;
	m_target.m_timeShift.m_deno = o.m_target.m_timeShift.m_deno;
}

BOOL CJDCheckIfIncluded::Do(CObject *g)
{
	CSymbInst *pInst, *pIp, *pIx;
	POSITION pos;
	CMSFract *pF;

	pInst = (CSymbInst *) g;
	if(m_bResult) return TRUE;
	if(pInst->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		if(pInst->GetSymbBody()==m_target.m_theDep && pInst->GetCount()>1) {
			pos = pInst->GetHeadPosition();
			pIx = (CSymbInst *) pInst->GetNext(pos);
			if(m_target.m_timeShift.m_value==0) {
				if(!pIx->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
				if(pIx->GetSymbBody()!=m_target.m_timeIndex) return TRUE;
				m_bResult = TRUE;
			} else {
				pIp = pIx;
				if(!pIp->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) return TRUE;
				if(pIp->GetCount()!=2) return TRUE;
				pos = pIp->GetHeadPosition();
				pIx = (CSymbInst *) pIp->GetNext(pos);
				pF = (CMSFract *) pIp->GetNext(pos);
				if(!pIx->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
				if(pIx->GetSymbBody()!=m_target.m_timeIndex) return TRUE;
				if(!pF->IsKindOf(RUNTIME_CLASS(CMSFract))) return TRUE;
				if(pF->m_value!=m_target.m_timeShift.m_value) return TRUE;
				if(pF->m_value==0 || pF->m_deno==m_target.m_timeShift.m_deno)
					m_bResult = TRUE;
			}
			return TRUE;
		}
	}
	return FALSE;
}

