#ifndef __JD_DSC_H__
#define __JD_DSC_H__

#ifndef __JD_UTL_H__
#	include "jd_utl.h"
#endif

class AFX_EXT_CLASS CJDDescretizer : public CJDAlgManip {
public:

	CPDEBoundDef *m_pBoundDef;
public:
	CJDDescretizer();

	virtual BOOL Do(CObject *);

	BOOL FindStartCond(CSymbInst* pInst);
	BOOL Copy(CJDDescretizer *);

	AF_ENUM AnalyseForm(CSymbInst *pInst, CMapStringToOb &pParam);
	EXP_ENUM AnalyseExpForm(CSymbInst *pInst, CMapStringToOb& );
	SIMP_ENUM AnalyseSimpForm(CSymbInst *pInst, CMapStringToOb& );
	BIND_ENUM AnalyseBindForm(CSymbInst *pInst, CMapStringToOb& );
	FACTOR_FORM AnalyseFactForm(CViecFC *pInst, CViecFC*, CMapStringToOb&);

	BOOL MakeDepDisc(CSymbInst *, CViecFC *);
	BOOL DiscDerivC1(CSymbInst* pInst, CMapStringToOb& para);
	BOOL DiscDerivC2(CSymbInst* pInst, CMapStringToOb& para);
	BOOL DiscDerivTime1(CSymbInst* pInst, CMapStringToOb& para);
	BOOL ShiftVar(CSymbInst* pInst);
	BOOL DiscUpwndFstOrd(CSymbInst* pInst, CMapStringToOb& para);
	BOOL ShiftVarToPos(CSymbInst* pInst);

	BOOL ExpPlusInPlus(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL ExpPlusInMult(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL ExpMultInMult(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL ExpNegInMult(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL ExpPlusInNume(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL ExpPlusInNeg(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL ExpNegInNeg(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL ExpDepInMult(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL ExpDepInNegMult(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL ExpDepInNumeMult(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL ExpDepInNegNumeMult(CSymbInst*& pInst, CMapStringToOb& para);

	BOOL BindPlusAbleForm1(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL BindPlusAbleForm2(CSymbInst*& pInst, CMapStringToOb& para);
	
	BOOL SimpPlusAbleForm2(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL SimpMultAbleForm1(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL SimpDivAbleForm1(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL SimpDivAbleForm2(CSymbInst*& pInst, CMapStringToOb& para);

	BOOL SimpPlusInt0(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL SimpMultInt0(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL SimpMultInt1(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL SimpDivBy1(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL SimpNegInt(CSymbInst*& pInst, CMapStringToOb& para);

	BOOL SimpInvInv(CSymbInst*& pInst, CMapStringToOb& para);
	BOOL SimpNegDivNeg(CSymbInst*& pInst, CMapStringToOb& para);
};

class AFX_EXT_CLASS CJDDescDeriv : public CJDDescretizer {
public:
	virtual BOOL Do(CObject *);
};

class AFX_EXT_CLASS CJDDescUpwndFstOrd : public CJDDescretizer {
public:
	virtual BOOL Do(CObject *);
};

class AFX_EXT_CLASS CJDShiftToPos : public CJDDescretizer {
public:
	BOOL FindStartCond(CSymbInst* pInst);
	virtual BOOL Do(CObject *);
};

class AFX_EXT_CLASS CJDMapToFit : public CJDDescretizer {
public:
	virtual BOOL Do(CObject *);
};

class AFX_EXT_CLASS CJDCheckDepend : public CJDDescretizer {
public:
	CTargetDep targetVar[40];
	int targetNo, checkNo;
	BOOL CanThisCalc(CSymbInst *pI);
	virtual BOOL Do(CObject *);
};

class AFX_EXT_CLASS CJDCheckIfIncluded : public CJDAlgManip {
public:
	CViecFC *m_checked;
	BOOL m_bResult;
	CJDCheckIfIncluded() {};
	CJDCheckIfIncluded(CJDDescretizer&);
	virtual BOOL Do(CObject *);
};

#endif //__JD_DSC_H__
