
#include "stdafx.h"

#include "pde_prg.h"
#include "jd_prc.h"
#include "pde_msg.h"


//////////////////// CJDCreateMainProc ////////////////////
//////////////////// CJDCreateMainProc ////////////////////
//////////////////// CJDCreateMainProc ////////////////////

BOOL CJDCreateMainProc::Do(CObject *g)
{
	if(!g->IsKindOf(RUNTIME_CLASS(CPDERunSpread))) return FALSE; // FALSE -> propagate downward the tree
																// TRUE -> stop at this node
	pRun = (CPDERunSpread *) g;

	pVPrc = NULL;

	//--- find program
	if(pRun->GetOutputCount()==0) return TRUE;
	pPrg = (CPDEObject *) pRun->GetOutputChild(0);
	if(pPrg->IsKindOf(RUNTIME_CLASS(CIElem)))  //check if splitted.  
		pPrg = (CPDEObject *) ((CIElem*) pPrg)->GetBody();
	if(!pPrg->IsKindOf(RUNTIME_CLASS(CPDEObjPrg))) return TRUE;
	while(pPrg->GetCount())
		delete pPrg->m_child.RemoveTail();	//make it empty.

	//--- find top problem
	pPrb = (CPDEProblem *) pRun->GetParent();
	if(pPrb->IsKindOf(RUNTIME_CLASS(CElemView))) //check if its parent is frame not pPrb
		pPrb = (CPDEProblem *) pRun->GetInstBody()->GetParent(); //get the real body in the pprb.  
	if(!pPrb->IsKindOf(RUNTIME_CLASS(CPDEProblem))) return TRUE;

	//--- chcek pri - post file  990608 fujita
	// v[|XgvZbT̎gp𔻒fBTRUEȂgpAFALSEȂsgp
	char buf[30];
	CPDEFileFold *pFold;
	CEFile *pFile;
	CEFileFrom *pFrom;
	pInfo = (CPDEInfo*) pPrb->GetChild(0);
	if(!pInfo->IsKindOf(RUNTIME_CLASS(CPDEInfo))) throw; //擾|C^[CPDEInfołȂȂ

	fp = fopen("..\\temp\\Pre_Pos.inf","r");
	if (fp == NULL){
		printf("can't open Pre_Pos.inf file \n");
	}
	m_GRID = FALSE;
	m_AVS = FALSE;
	m_POST = FALSE;
	
	while(fgets(buf,sizeof(buf),fp) != NULL){
		if(!strncmp(buf,"MICRO_GRID",10)){
			m_GRID = TRUE;

			//file pointer ̐ݒ
			pFold = new CPDEFileFold;
			pFold->SetName("Input Micro_Grid file");
			pFold->SetMode(CPElem::modeClose);
			pInfo->AddTail(pFold);
			pInfo->OnCreated(DO_ALL);
			pFold->CalcExt(CPElem::dirDown);
			pFold->CalcExt();
			pFold->SendMsg(MSG_RECALC_ALL_VIEW, NULL);

			pFrom = new CEFileFrom;
			pFrom->SetName("M_GRID.msh");
			pFold->AddTail(pFrom);
			pFrom->CalcExt(CPElem::dirDown);
			pFrom->CalcExt();
			//pFold->InvalidateRect(CPoint(0,0));				
			continue;
		}else if(!strncmp(buf,"MICRO_AVS",9)){
			m_AVS = TRUE;

			//file pointer ̐ݒ
			pFold = new CPDEFileFold;
			pFold->SetName("Output Micro_AVS file");
			pFold->SetMode(CPElem::modeClose);
			pInfo->AddTail(pFold);
			pInfo->OnCreated(DO_ALL);
			pFold->CalcExt(CPElem::dirDown);
			pFold->CalcExt();
			pFold->SendMsg(MSG_RECALC_ALL_VIEW, NULL);

			pFile = new CEFile;
			pFile->SetName("M_AVS.dat"); //AVS̃f[^t@C
			pFold->AddTail(pFile);
			pFile->CalcExt(CPElem::dirDown);
			pFile->CalcExt();

			pFile = new CEFile;
			pFile->SetName("M_AVS.fld"); //AVS̃tB[ht@C
			pFold->AddTail(pFile);
			pFile->CalcExt(CPElem::dirDown);
			pFile->CalcExt();
			//pFold->InvalidateRect(CPoint(0,0));
			continue;
		}else if(!strncmp(buf,"MICRO_POST",10)){
			m_POST = TRUE;

			//file pointer ̐ݒ
			pFold = new CPDEFileFold;
			pFold->SetName("Output Micro_Post file");
			pFold->SetMode(CPElem::modeClose);
			pInfo->AddTail(pFold);
			pInfo->OnCreated(DO_ALL);
			pFold->CalcExt(CPElem::dirDown);
			pFold->CalcExt();
			pFold->SendMsg(MSG_RECALC_ALL_VIEW, NULL);

			pFile = new CEFile;
			pFile->SetName("M_POST.dat");
			pFold->AddTail(pFile);
			pFile->CalcExt(CPElem::dirDown);
			pFile->CalcExt();
			//pFold->InvalidateRect(CPoint(0,0));
			continue;
		}
	}
	fclose(fp);
	//


	CPDETimeVar *pTmV = (CPDETimeVar *) pPrb->GetChildElem(RUNTIME_CLASS(CPDETimeVar));
	if(pTmV==NULL) return TRUE;				 // get it from the all nodes beneath .

	pTimeIndex = pTmV->m_pIndex;// means "n"
	pITx = pTmV->m_division;	// "nmax"
//	pTimeIndex = pPrb->m_pdeInfo->m_meshInfo->m_timeVar->m_pIndex;
//	pITx = pPrb->m_pdeInfo->m_meshInfo->m_timeVar->m_division;

	pMtxDefs = new CPDEMtxDefs;	// prepare a box for matrix
	pMtxDefs->SetMode(CPElem::modeOpen);
	pMtxDefs->SetName("Matrix Definition");	// name when closed
	pPrg->AddTail(pMtxDefs);
	pPrg->AddTail(new CPDELineTerm);  //RETURN mark for display on window

	pMain = new CPDProc;// PAD procedure 
	pPrg->AddTail(pMain);
	pMain->SetName("main"); //main()
	CPDVar *parg = new CPDArgs;	// argument for main function main(args,..,..
	pMain->AddTail(parg);
	pMain->SetMode(CPElem::modeClose);
	pPrg->AddTail(new CPDELineTerm);

	CPDCall *pInitC = new CPDCall;
	pInitC->SetName("init");
	pInitC->AddTail(new CPDArgs2);	//Argument
	CPDCall *pSlv;	 //call it in Main
	CPDFor *pfor = new CPDFor;	//for
	CPad *psub = new CPDForSub;	//for "FOR" variable (ex. "n"), initial condition, end condition
	CPDBlock *pSolvBlk = new CPDBlock; // block { and }
	pSolvBlk->SetName("1 time step solver n --> n+1");

	pMain->AddTail(pInitC);
	if(m_GRID){
		CPDCall *pReadC = new CPDCall;
		pReadC->SetName("read");
		pReadC->AddTail(new CPDArgs2);	//Argument
		pMain->AddTail(pReadC);
	}

	//fujita  990609
	if(m_AVS){
		CPDCall *pM_out = new CPDCall;
		pM_out->SetName("M_AVS_FLD_out");
		pM_out->AddTail(new CPDArgs2);
		pMain->AddTail(pM_out);
	}

	
	pMain->AddTail(pfor);
	pfor->AddTail(psub);
	psub->AddTail(new CSymbInst(pTimeIndex->GetName()));	 //for "FOR" "n"
	psub->AddTail(new CMSFract(1));							  //for "FOR" "1"
	psub->AddTail(new CSymbInst(pITx->GetName()));			  //for "FOR" "nmax"
	pfor->AddTail(pSolvBlk);   // solverblock in main { ...;...;..;..}

	//--- add Abstract Visual Box //visualization 
	pVsBox = new CPDEAbstProcVis;
	pVsBox->SetMode(CPElem::modeOpen);
	pVsBox->SetName("1 time step solver n --> n+1");
	pPrg->AddTail(pVsBox);
	pPrg->AddTail(new CPDELineTerm);

	//--- create main program and time step for statement.
	pSubst = new CPDProc;
	pPrg->AddTail(pSubst);
	pSubst->SetName("subst"); //substitute F(n+1)-> F(n)
	CPDVar *parg2 = new CPDArgs;   //subst()
	pSubst->AddTail(parg2);
	pSubst->SetMode(CPElem::modeClose);

	pOutput = new CPDProc;				  //Output()
	pPrg->AddTail(pOutput);
	pOutput->SetName("output");
	parg2 = new CPDArgs;
	pOutput->AddTail(parg2);
	pOutput->SetMode(CPElem::modeClose);


	pInit = new CPDProc;	//Init()
	pPrg->AddTail(pInit);
	pInit->SetName("init");
	parg2 = new CPDArgs;
	pInit->AddTail(parg2);
	pInit->SetMode(CPElem::modeClose);

	pPrg->AddTail(new CPDELineTerm); //Return mark

	//ǉ fujita 990609
	//read() ͍Wt@Cǂݍފ֐

	if(m_GRID){
		pRead = new CPDProc;
		pPrg->AddTail(pRead);
		pRead->SetName("read"); 
		CPDVar *parg2 = new CPDArgs;   //read()
		pRead->AddTail(parg2);
		pRead->SetMode(CPElem::modeClose);

	}

	if(m_AVS){
		//AVSf[^o͊֐
		pM_AVS = new CPDProc;
		pPrg->AddTail(pM_AVS);
		pM_AVS->SetName("M_AVS_out"); 
		CPDVar *parg2 = new CPDArgs; 
		pM_AVS->AddTail(parg2);
		pM_AVS->SetMode(CPElem::modeClose);

		
		//AVS Fldt@Co͊֐
		pM_AVS_FLD = new CPDProc;
		pPrg->AddTail(pM_AVS_FLD);
		pM_AVS_FLD->SetName("M_AVS_Fld_out"); 
		parg2 = new CPDArgs; 
		pM_AVS_FLD->AddTail(parg2);
		pM_AVS_FLD->SetMode(CPElem::modeClose);

	}

	if(m_POST){
		//Micro Post o͊֐
		pM_POST = new CPDProc;
		pPrg->AddTail(pM_POST);
		pM_POST->SetName("M_POST_out"); 
		CPDVar *parg2 = new CPDArgs; 
		pM_POST->AddTail(parg2);
		pM_POST->SetMode(CPElem::modeClose);

	}

	pPrg->AddTail(new CPDELineTerm); //Return mark

	//--- find all the n time step dependent variable
	//  find dependency between solversets
	pos = pPrb->m_pdeInfo->GetHeadPosition();
	check.targetNo = 0;	 //total solverset number = total dependent variable number
	while(pos) {
		pDep = (CPDEDepInfo *) pPrb->m_pdeInfo->GetNext(pos);
		if(pDep->IsKindOf(RUNTIME_CLASS(CIElem)))
		pDep = (CPDEDepInfo *) ((CIElem*)pDep)->GetBody();
		if(!pDep->IsKindOf(RUNTIME_CLASS(CPDEDepInfo)))	continue;
		if(!pDep->m_var) continue;
		if(!pDep->m_var->IsKindOf(RUNTIME_CLASS(CMSDepVar))) continue;
		check.targetVar[check.targetNo].m_theDep = pDep->m_var;	//get dependent var name (ex."T")
		check.targetVar[check.targetNo].m_timeIndex = pTimeIndex; //"n"
		check.targetVar[check.targetNo].m_timeShift.m_value = 0;  // "+1"
		check.targetNo++;
	}
	oldDepNo = check.targetNo;

	//--- show the first set of dependent variable
	check.checkNo = 0;
	pVars = new CPDEObtainedVars;  //gather dependent variables in old step "n"
	pVsBox->AddTail(pVars);
	for(i=check.checkNo;i<check.targetNo;i++) {
		pV = new CSymbInst(check.targetVar[i].m_theDep->GetName());
		if(check.targetVar[i].m_timeShift.m_value==0) {
			pN = new CSymbInst(check.targetVar[i].m_timeIndex->GetName());
		} else {
			pN = new CSymbInst("+");
			pN2 = new CSymbInst(check.targetVar[i].m_timeIndex->GetName());
			pF = new CMSFract(check.targetVar[i].m_timeShift.m_value
				, check.targetVar[i].m_timeShift.m_deno);
			pN->AddTail(pN2);
			pN->AddTail(pF);
		}
		pV->AddTail(pN);
		pVars->AddTail(pV);
	}
	pVars->OnCreated();
	pVars->CalcExt(CViecFC::dirDown);
	pVars->CalcExt();
	check.checkNo = check.targetNo;

	CPDEBrkPntDefs *pBrkPnts = new CPDEBrkPntDefs;
	pBrkPnts->SetMode(CPElem::modeOpen);
	pBrkPnts->SetName("Break Points Definition");
	pPrg->AddTail(pBrkPnts);
	pPrg->AddTail(new CPDELineTerm);

	CPDEBrkObj *pBrk = new CPDEBrkObj;
	pBrkPnts->AddTail(pBrk);
	pBrk->SetName("TimeStep");

	pPrg->OnCreated();

	//--- analyse difference equation and create solvers
	CViecFC *pHd;
	check.m_bStartFg = TRUE;
	while(check.m_bStartFg) {
		//--- find the first difference equation which can solve
		//    by the default set (ex. "n", "~") of dependent variable
		pos = pRun->GetHeadPosition();
		while(pos) {
			check.m_bStartFg = FALSE;
			pPrc = (CPDEProcess *) pRun->GetNext(pos);
			if(pPrc->IsKindOf(RUNTIME_CLASS(CIElem)))
				pPrc = (CPDEProcess*) ((CIElem*) pPrc)->GetBody();
			if(checkedAlready.Lookup(pPrc, plvd)) continue;
			if((CObject*) pPrc==(CObject*) pVsBox) continue;
			if(!pPrc->IsKindOf(RUNTIME_CLASS(CPDEProcess))) continue;
			if(pPrc->GetCount()!=3) continue;
			pHd = (CViecFC *) pPrc->GetChild(0);
			pObj = (CPDEObject *) pPrc->GetChild(2);
			if(pObj->IsKindOf(RUNTIME_CLASS(CIElem)))
				pObj = (CPDEObject *) ((CIElem*)pObj)->GetBody();
			if(pObj->GetCount()==0) continue;
			pSet = (CPDESolvSet *) pObj->GetChild(0);
			if(!pSet->IsKindOf(RUNTIME_CLASS(CPDESolvSet))) continue;
			if(pSet->GetCount()==0) continue;
			check.m_bStartFg = TRUE;
			pSet->SendMsg(MSG_DO_JOB, &check);
			if(check.m_bStartFg) break;
		}

		if(check.m_bStartFg) {
			// If there is a difference equation available
			// add to the list of visual box
			if(pVPrc==NULL) {
				// If the list is not yet created, do it now.
				pVPrc = new CPDEInvokedProcs;
				pVsBox->AddTail(pVPrc);
				pVsBox->OnCreated();
				pVsBox->CalcExt(CViecFC::dirDown);
				pVsBox->CalcExt();
			}

			DoCreateSolver(pHd->GetName());
			
			/**********************************************
			// Kawa  April 22
			CJDCreateProc prc;	//for making solver content
			prc.m_pMainProcGen = this;	//	CJDCreatmainProc
			prc.m_name = pHd->GetName();
			prc.m_output = pVPrc;
			pSet->SendMsg(MSG_DO_JOB, &prc);
			// Kawa  April 22
			***********************************************/

			//--- create call statement to call that solver
			pSlv = new CPDCall();
			pSlv->SetName(CString("Slv")+pHd->GetName());
			pSlv->AddTail(new CPDArgs2);
			pSolvBlk->AddTail(pSlv);
			
			//--- add to the list
			check.targetVar[check.targetNo].m_theDep = check.m_target.m_theDep;
			check.targetVar[check.targetNo].m_timeIndex
				= check.m_target.m_timeIndex;
			check.targetVar[check.targetNo].m_timeShift.m_value
				= check.m_target.m_timeShift.m_value;
			check.targetVar[check.targetNo].m_timeShift.m_deno
				= check.m_target.m_timeShift.m_deno;
			check.targetNo++;
			checkedAlready[pPrc] = NULL;
		} else if(!check.m_bStartFg && check.checkNo<check.targetNo) {
			//--- if no difference equation found, 
			//--- add the next set of dependent variable
			//--- append them to the default set
			pVars = new CPDEObtainedVars;
			pVsBox->AddTail(pVars);
			for(i=check.checkNo;i<check.targetNo;i++) {
				pV = new CSymbInst(check.targetVar[i].m_theDep->GetName());
				if(check.targetVar[i].m_timeShift.m_value==0) {
					pN = new CSymbInst(check.targetVar[i].m_timeIndex->GetName());
				} else {
					pN = new CSymbInst("+");
					pN2 = new CSymbInst(check.targetVar[i].m_timeIndex->GetName());
					pF = new CMSFract(check.targetVar[i].m_timeShift.m_value
						, check.targetVar[i].m_timeShift.m_deno);
					pN->AddTail(pN2);
					pN->AddTail(pF);
				}
				pVars->AddTail(pV);
				pV->AddTail(pN);
			}
			pVars->OnCreated();
			pVars->CalcExt(CViecFC::dirDown);
			pVars->CalcExt();

			pVPrc = NULL;
			check.checkNo = check.targetNo;
			check.m_bStartFg = TRUE;
		}
	}
	//--- the default break point for each time step
	CPad *pBrkPnt = new CPDBrkPnt;
	pfor->AddTail(pBrkPnt);
	pBrkPnt->AddTail(new CSymbInst("TimeStep"));

	//--- output routine all for each 20 time step
	//outputIf̍\
	CPad *pif = new CPDIf;
	CSymbInst *pcond = new CSymbInst("==");
	CSymbInst *pmod = new CSymbInst("%");
	pmod->AddTail(new CSymbInst(pTimeIndex->GetName()));
	pmod->AddTail(new CMSFract(20));
	pcond->AddTail(pmod);
	pcond->AddTail(new CMSFract(0));

	CPDBlock *pthen = new CPDBlock();
	CPDBlock *pelse = new CPDBlock();
	CPDCall *pOut = new CPDCall();
	CPDCall *pM_out;

	pOut->AddTail(new CPDArgs2);
	pOut->SetName("output");
	pthen->AddTail(pOut);

	pif->AddTail(pcond);
	pif->AddTail(pthen);
	pif->AddTail(pelse);
	
	pfor->AddTail(pif);

	//fujita  990609
	if(m_AVS){
		pM_out = new CPDCall;
		pM_out->SetName("M_AVS_out");
		pM_out->AddTail(new CPDArgs2);
		pthen->AddTail(pM_out);

		/*
		pM_out = new CPDCall;
		pM_out->SetName("M_AVS_FLD_out");
		pM_out->AddTail(new CPDArgs2);
		pthen->AddTail(pM_out);
		*/
	}

	if(m_POST){
		pM_out = new CPDCall;
		pM_out->SetName("M_POST_out");
		pM_out->AddTail(new CPDArgs2);
		pthen->AddTail(pM_out);
	}
	////////////////////////////////////////////////


	//main()̒g̍\
	CPDCall *pSub;
	pSub = new CPDCall;
	pSub->SetName("subst");
	pSub->AddTail(new CPDArgs2);
	pfor->AddTail(pSub);
	////////////////////////////

	//evZX֐Ă
	MakeSubstProc(pSubst);
	MakeOutputProc(pOutput);
	MakeInitProc(pInit);
/*
	MakeReadProc(pRead);
	MakeM_AVS_out_Proc(pM_AVS);
	MakeM_AVS_FLD_out_Proc(pM_AVS_FLD);
	MakeM_POST_out_Proc(pM_POST);
*/
	if(m_GRID){ 
		MakeReadProc(pRead);
	}
	if(m_AVS){
		MakeM_AVS_out_Proc(pM_AVS);
		MakeM_AVS_FLD_out_Proc(pM_AVS_FLD);
	}
	if(m_POST){
		MakeM_POST_out_Proc(pM_POST);
	}

	pPrg->OnCreated();
	pPrg->CalcExt(CViecFC::dirDown);
	pPrg->CalcExt();
	return TRUE;
}

BOOL CJDCreateMainProc::DoCreateSolver(const char *name)
{
	CJDCreateProc prc;	//for making solver content
	prc.m_pMainProcGen = this;	//	CJDCreatmainProc
	prc.m_name = name;
	prc.m_output = pVPrc;
	pSet->SendMsg(MSG_DO_JOB, &prc);
	return TRUE;
}

// Subst()̃[`H
void CJDCreateMainProc::MakeSubstProc(CViecFC *pPrnt)
{
	CPDESpaceVars *pSpcs;
	CPDESpaceVar *pSpc;
	CPDFor *pFor;
	CPDForSub *pSbF;
	CMSIndex *pIndx;
	CPDVar *pVars;

	pSpcs = pPrb->m_pdeInfo->m_meshInfo->m_spaceVars;
	int dim = pSpcs->GetCount();

	pVars = new CPDVar;
	pPrnt->AddTail(pVars);

	for(i=0;i<dim;i++) {
		pSpc = (CPDESpaceVar *) pSpcs->GetChild(i);
		pIndx = new CMSIndex;
		pIndx->SetName(pSpc->m_pIndex->GetName());
		pVars->AddTail(pIndx);

		pFor = new CPDFor;
		pSbF = new CPDForSub;
		pSbF->AddTail(new CSymbInst(pSpc->m_pIndex->GetName()));
		pSbF->AddTail(new CMSFract(1));
		pSbF->AddTail(new CSymbInst(pSpc->m_division->GetName()));
		pFor->AddTail(pSbF);
		pPrnt->AddTail(pFor);
		pPrnt = pFor;
	}

	for(i=0;i<oldDepNo;i++) {
		CPDSubst *sss;
		CSymbInst *pEq, *pLs, *pLs1, *pRs, *pRs1, *pRs11;
		int j,k;
		k = 0;
		for(j=oldDepNo;j<check.targetNo;j++) {
			if(check.targetVar[j].m_theDep==check.targetVar[i].m_theDep)
				k = j;
		}
		if(k==0) continue;

		sss = new CPDSubst;
		pEq = new CSymbInst("=");
		pLs = new CSymbInst(check.targetVar[i].m_theDep->GetName());
		pLs1 = new CSymbInst(check.targetVar[i].m_timeIndex->GetName());
		pRs = new CSymbInst(check.targetVar[i].m_theDep->GetName());
		if(check.targetVar[k].m_timeShift.m_value==0) {
			pRs1 = new CSymbInst(check.targetVar[k].m_timeIndex->GetName());
		} else {
			pRs1 = new CSymbInst("+");
			pRs11 = new CSymbInst(check.targetVar[k].m_timeIndex->GetName());
			pRs1->AddTail(pRs11);
			pRs1->AddTail(new CMSFract(check.targetVar[k].m_timeShift.m_value
						, check.targetVar[k].m_timeShift.m_deno));
		}
		sss->AddTail(pEq);
		pEq->AddTail(pLs);
		pEq->AddTail(pRs);
		pLs->AddTail(pLs1);
		pRs->AddTail(pRs1);

		for(j=0;j<dim;j++) {
			pSpc = (CPDESpaceVar *) pSpcs->GetChild(j);
			pLs->AddTail(new CSymbInst(pSpc->m_pIndex->GetName()));
			pRs->AddTail(new CSymbInst(pSpc->m_pIndex->GetName()));
		}

		pPrnt->AddTail(sss);
	}
}

// Output()̃[`HH
void CJDCreateMainProc::MakeOutputProc(CViecFC *pPrnt)
{
	CPDESpaceVars *pSpcs;
	CPDESpaceVar *pSpc;
	CPDFor *pFor;
	CPDForSub *pSbF;
	CMSIndex *pIndx;
	CPDVar *pVars;

	pSpcs = pPrb->m_pdeInfo->m_meshInfo->m_spaceVars;
	int dim = pSpcs->GetCount();

	pVars = new CPDVar;
	pPrnt->AddTail(pVars);

	for(i=0;i<dim;i++) {
		pSpc = (CPDESpaceVar *) pSpcs->GetChild(i);
		pIndx = new CMSIndex;
		pIndx->SetName(pSpc->m_pIndex->GetName());
		pVars->AddTail(pIndx);

		pFor = new CPDFor;
		pSbF = new CPDForSub;
		pSbF->AddTail(new CSymbInst(pSpc->m_pIndex->GetName()));
		pSbF->AddTail(new CMSFract(1));
		pSbF->AddTail(new CSymbInst(pSpc->m_division->GetName()));
		pFor->AddTail(pSbF);
		pPrnt->AddTail(pFor);
		pPrnt = pFor;
	}

	CPDOutput *pOut;
	CPDArgs2 *pArg;

	pOut = new CPDOutput;
	pArg = new CPDArgs2;
	pPrnt->AddTail(pOut);
	pOut->AddTail(pArg);
	for(i=0;i<oldDepNo;i++) {
		CSymbInst *pLs, *pLs1;
		int j,k;

		k = 0;
		for(j=oldDepNo;j<check.targetNo;j++) {
			if(check.targetVar[j].m_theDep==check.targetVar[i].m_theDep)
				k = j;
		}
		if(k==0) continue;
		pLs = new CSymbInst(check.targetVar[i].m_theDep->GetName());
		pLs1 = new CSymbInst(check.targetVar[i].m_timeIndex->GetName());
		pLs->AddTail(pLs1);
		pArg->AddTail(pLs);
		for(j=0;j<dim;j++) {
			pSpc = (CPDESpaceVar *) pSpcs->GetChild(j);
			pLs->AddTail(new CSymbInst(pSpc->m_pIndex->GetName()));
		}
	}
}

// Init()̃[`HH
void CJDCreateMainProc::MakeInitProc(CViecFC *pPrnt)
{
	CPDESpaceVars *pSpcs;
	CPDESpaceVar *pSpc;
	CPDETimeVar *pTmV;
	CPDVar *pVars;
	CPDSubst *sss;
	CSymbInst *pEq, *pLs, *pLs1;
	CMSIndex *pIndx;
	CPDFor *pFor;
	CPDForSub *pSbF;
	int i,j,k;


	pVars = new CPDVar;
	pPrnt->AddTail(pVars);

	pTmV = (CPDETimeVar *) pPrb->GetChildElem(RUNTIME_CLASS(CPDETimeVar));
	if(pTmV==NULL) return;

//	sss = new CPDSubst;
//	pEq = new CSymbInst("=");
//	pLs = new CSymbInst(pTmV->m_pIndep->GetName());
//	pPrnt->AddTail(sss);
//	sss->AddTail(pEq);
//	pEq->AddTail(pLs);
//	pEq->AddTail(new CMSRealEx(0.1));

	pSpcs = pPrb->m_pdeInfo->m_meshInfo->m_spaceVars;
	int dim = pSpcs->GetCount();

//	for(i=0;i<dim;i++) {
//		pSpc = (CPDESpaceVar *) pSpcs->GetChild(i);
//		sss = new CPDSubst;
//		pEq = new CSymbInst("=");
//		pLs = new CSymbInst(pSpc->m_pIndep->GetName());
//		pPrnt->AddTail(sss);
//		sss->AddTail(pEq);
//		pEq->AddTail(pLs);
//		pEq->AddTail(new CMSRealEx(1.0));
//	}

	for(i=0;i<dim;i++) {
		pSpc = (CPDESpaceVar *) pSpcs->GetChild(i);
		pIndx = new CMSIndex;
		pIndx->SetName(pSpc->m_pIndex->GetName());
		pVars->AddTail(pIndx);

		pFor = new CPDFor;
		pSbF = new CPDForSub;
		pSbF->AddTail(new CSymbInst(pSpc->m_pIndex->GetName()));
		pSbF->AddTail(new CMSFract(1));
		pSbF->AddTail(new CSymbInst(pSpc->m_division->GetName()));
		pFor->AddTail(pSbF);
		pPrnt->AddTail(pFor);
		pPrnt = pFor;
	}

	for(i=0;i<oldDepNo;i++) {
		k = 0;
		for(j=oldDepNo;j<check.targetNo;j++) {
			if(check.targetVar[j].m_theDep==check.targetVar[i].m_theDep)
				k = j;
		}
		if(k==0) continue;

		sss = new CPDSubst;
		pEq = new CSymbInst("=");
		pLs = new CSymbInst(check.targetVar[i].m_theDep->GetName());
		pLs1 = new CSymbInst(check.targetVar[i].m_timeIndex->GetName());
		sss->AddTail(pEq);
		pEq->AddTail(pLs);
		/****************************************************************/
		// Modify by fujita 98.11.29.
		//pEq->AddTail(new CMSFract(0));
		pEq->AddTail(new CMSRealEx(0.0)); //Right side of equation value.
		/****************************************************************/
		pLs->AddTail(pLs1);

		for(j=0;j<dim;j++) {
			pSpc = (CPDESpaceVar *) pSpcs->GetChild(j);
			pLs->AddTail(new CSymbInst(pSpc->m_pIndex->GetName()));
		}

		pPrnt->AddTail(sss);
	}
}

void CJDCreateMainProc::MakeReadProc(CViecFC *pPrnt)
{
	CPDESpaceVars *pSpcs;
	
	pSpcs = pPrb->m_pdeInfo->m_meshInfo->m_spaceVars;
	int dim = pSpcs->GetCount();

	//[Jϐ̐錾
	CPDVar *pVars; //ϐ錾̔
	pVars = new CPDVar;
	pPrnt->AddTail(pVars);
	CMSChar_One *pChar = new CMSChar_One; //̐錾
	pChar->SetName("line");
	pVars->AddTail(pChar);

	CMSIndex *pIndex;
	CMSMatrix *pMat;
	switch(dim){
	case 1:
		pVars = new CPDVar;
		pPrnt->AddTail(pVars);

		pIndex = new CMSIndex;
		pIndex->SetName("cnt"); //local variable "cnt"
		pVars->AddTail(pIndex); //ϐ錾ɒ`B

		pIndex = new CMSIndex;
		pIndex->SetName("i_no"); //local variable "i_no"
		pVars->AddTail(pIndex); //ϐ錾ɒ`B

		pVars = new CPDVar;
		pPrnt->AddTail(pVars);

		pMat = new CMSMatrix;
		pMat->SetName("f_x");
		pVars->AddTail(pMat);


		break;
	case 2:
		pVars = new CPDVar;
		pPrnt->AddTail(pVars);

		pIndex = new CMSIndex;
		pIndex->SetName("cnt"); //local variable "cnt"
		pVars->AddTail(pIndex); //ϐ錾ɒ`B

		pIndex = new CMSIndex;
		pIndex->SetName("i_no"); //local variable "i_no"
		pVars->AddTail(pIndex); //ϐ錾ɒ`B

		pIndex = new CMSIndex;
		pIndex->SetName("j_no"); //local variable "j_no"
		pVars->AddTail(pIndex); //ϐ錾ɒ`B

		pVars = new CPDVar;
		pPrnt->AddTail(pVars);

		pMat = new CMSMatrix;
		pMat->SetName("f_x"); //double type̕ϐ
		pVars->AddTail(pMat);

		pMat = new CMSMatrix;
		pMat->SetName("f_y"); //double type̕ϐ
		pVars->AddTail(pMat);

		break;
	case 3:
		pVars = new CPDVar;
		pPrnt->AddTail(pVars);

		pIndex = new CMSIndex;
		pIndex->SetName("cnt"); //local variable "cnt"
		pVars->AddTail(pIndex); //ϐ錾ɒ`B

		pIndex = new CMSIndex;
		pIndex->SetName("i_no"); //local variable "i_no"
		pVars->AddTail(pIndex); //ϐ錾ɒ`B

		pIndex = new CMSIndex;
		pIndex->SetName("j_no"); //local variable "j_no"
		pVars->AddTail(pIndex); //ϐ錾ɒ`B

		pIndex = new CMSIndex;
		pIndex->SetName("k_no"); //local variable "k_no"
		pVars->AddTail(pIndex); //ϐ錾ɒ`B

		pVars = new CPDVar;
		pPrnt->AddTail(pVars);

		pMat = new CMSMatrix;
		pMat->SetName("f_x");
		pVars->AddTail(pMat);

		pMat = new CMSMatrix;
		pMat->SetName("f_y");
		pVars->AddTail(pMat);

		pMat = new CMSMatrix;
		pMat->SetName("f_z");
		pVars->AddTail(pMat);
		break;
	}
	///[Jϐ̐錾 end/////////////////////////////

	///for [v̍쐬if[^ǂݍݕj
	///FOR [v iPj////////////////////////////////////////////////////
	CPDFor *pFor = new CPDFor;
	CPDForSub *pFor_Sub = new CPDForSub;
	
	
	pPrnt->AddTail(pFor); //̐e|C^[FORNXo^BŏpPrntɓo^B
	pFor->AddTail(pFor_Sub); //FoȑNXo^B
			
	pFor_Sub->AddTail(new CSymbInst("cnt")); //ϐ cnt
	pFor_Sub->AddTail(new CMSFract(1)); //l(1)

	CSymbInst *pM = new CSymbInst("*");
	CPDFileFrom *pFrom;
	CPDArgs2 *pArg;

	CPDCallBy *pCall;
	CMSArg *pTxt = new CMSArg;
	CSymbInst *pAdr;
	CSymbInst *pEqu;
	CPDSubst *pSub;
	int P_DepNo;
	//////////////////////////
	switch(dim){
	case 1:
		pFor_Sub->AddTail(pM); //I 
		pM->AddTail(new CSymbInst("IMAX"));

		pArg = new CPDArgs2;
		pFrom = new CPDFileFrom;
		pFrom->AddTail(new CSymbInst("M_GRID.msh")); //ǂݍ݃t@C
		pFrom->AddTail(pArg);

		pFor->AddTail(pFrom);
		pArg->AddTail(new CSymbInst("line")); //ǂݍ݃obt@
		////////////////////////
		pCall = new CPDCallBy;
		pArg = new CPDArgs2;
		pCall->SetName("sscanf");
		pCall->AddTail(pArg);
		pFor->AddTail(pCall);

		//sscanf̈
		pArg->AddTail(new CSymbInst("line"));
		pTxt = new CMSArg;
		// modify fujita 99/10/30 
		// pTxt->SetName("\"%%d %%f \"");
		pTxt->SetName("\"%d %f \"");
		pArg->AddTail(pTxt);
		pAdr = new CSymbInst("&?");
		pAdr->AddTail(new CSymbInst("i_no"));
		pArg->AddTail(pAdr);

		pAdr = new CSymbInst("&?");
		pAdr->AddTail(new CSymbInst("f_x"));
		pArg->AddTail(pAdr);

		//Wf[^ϐɊi[B
		//i[ϐ͂͂߂ɒ`ꂽ͕ϐƂB
		//QȂ͂߂̂QARȂŏ̂RƂB

		//oldDepNo ͉͕ϐ̐iԂj
		//錾ׂẲ͕ϐo͂B
		P_DepNo = dim;
		for(i=0;i<P_DepNo;i++) {
			CSymbInst *pLs, *pLs1,*pRs;
			int j;

			//͕ϐ
			pLs = new CSymbInst(check.targetVar[i].m_theDep->GetName());
			pLs1 = new CSymbInst(check.targetVar[i].m_timeIndex->GetName());
			pLs->AddTail(pLs1); //E̓Y

			//sscanfœǂݍ񂾂͕̂ϐ֑B
			//xx[i_no][j_no] = f_x
			//yy[i_no][j_no] = f_y
	
			pSub = new CPDSubst;
			pFor->AddTail(pSub);
			pEqu = new CSymbInst("=");
			pSub->AddTail(pEqu);
			for(j=0;j<dim;j++) {
				if(j==0) pLs->AddTail(new CSymbInst("i_no"));
				if(j==1) pLs->AddTail(new CSymbInst("j_no"));
				if(j==2) pLs->AddTail(new CSymbInst("k_no"));
			}

			if(i==0) pRs = new CSymbInst("f_x");
			if(i==1) pRs = new CSymbInst("f_y");
			if(i==2) pRs = new CSymbInst("f_z");

			//̍E̍o^
			pEqu->AddTail(pLs);
			pEqu->AddTail(pRs);
		}
		break;
	case 2:
		pFor_Sub->AddTail(pM); //I 
		pM->AddTail(new CSymbInst("IMAX"));
		pM->AddTail(new CSymbInst("JMAX"));

		pArg = new CPDArgs2;
		pFrom = new CPDFileFrom;
		pFrom->AddTail(new CSymbInst("M_GRID.msh")); //ǂݍ݃t@C
		pFrom->AddTail(pArg);

		pFor->AddTail(pFrom);
		pArg->AddTail(new CSymbInst("line")); //ǂݍ݃obt@
		////////////////////////
		pCall = new CPDCallBy;
		pArg = new CPDArgs2;
		pCall->SetName("sscanf");
		pCall->AddTail(pArg);
		pFor->AddTail(pCall);

		//sscanf̈
		pArg->AddTail(new CSymbInst("line"));
		pTxt = new CMSArg;

		// modify fujita 99/10/30 
		//pTxt->SetName("%%d %%d %%f %%f ");
		pTxt->SetName("\"%d %d %f %f \"");
		pArg->AddTail(pTxt);
		pAdr = new CSymbInst("&?");
		pAdr->AddTail(new CSymbInst("i_no"));
		pArg->AddTail(pAdr);

		pAdr = new CSymbInst("&?");
		pAdr->AddTail(new CSymbInst("j_no"));
		pArg->AddTail(pAdr);

		pAdr = new CSymbInst("&?");
		pAdr->AddTail(new CSymbInst("f_x"));
		pArg->AddTail(pAdr);

		pAdr = new CSymbInst("&?");
		pAdr->AddTail(new CSymbInst("f_y"));
		pArg->AddTail(pAdr);

		//Wf[^ϐɊi[B
		//i[ϐ͂͂߂ɒ`ꂽ͕ϐƂB
		//QȂ͂߂̂QARȂŏ̂RƂB

		//oldDepNo ͉͕ϐ̐iԂj
		//錾ׂẲ͕ϐo͂B
		P_DepNo = dim;
		for(i=0;i<P_DepNo;i++) {
			CSymbInst *pLs, *pLs1,*pRs;
			int j;

			//͕ϐ
			pLs = new CSymbInst(check.targetVar[i].m_theDep->GetName());
			pLs1 = new CSymbInst(check.targetVar[i].m_timeIndex->GetName());
			pLs->AddTail(pLs1); //E̓Y

			//sscanfœǂݍ񂾂͕̂ϐ֑B
			//xx[i_no][j_no] = f_x
			//yy[i_no][j_no] = f_y
	
			pSub = new CPDSubst;
			pFor->AddTail(pSub);
			pEqu = new CSymbInst("=");
			pSub->AddTail(pEqu);
			for(j=0;j<dim;j++) {
				if(j==0) pLs->AddTail(new CSymbInst("i_no"));
				if(j==1) pLs->AddTail(new CSymbInst("j_no"));
				if(j==2) pLs->AddTail(new CSymbInst("k_no"));
			}

			if(i==0) pRs = new CSymbInst("f_x");
			if(i==1) pRs = new CSymbInst("f_y");
			if(i==2) pRs = new CSymbInst("f_z");

			//̍E̍o^
			pEqu->AddTail(pLs);
			pEqu->AddTail(pRs);
		}
		break;
	case 3:
		pFor_Sub->AddTail(pM); //I 
		pM->AddTail(new CSymbInst("IMAX"));
		pM->AddTail(new CSymbInst("JMAX"));
		pM->AddTail(new CSymbInst("KMAX"));

		pArg = new CPDArgs2;
		pFrom = new CPDFileFrom;
		pFrom->AddTail(new CSymbInst("M_GRID.msh")); //ǂݍ݃t@C
		pFrom->AddTail(pArg);

		pFor->AddTail(pFrom);
		pArg->AddTail(new CSymbInst("line")); //ǂݍ݃obt@
		////////////////////////
		pCall = new CPDCallBy;
		pArg = new CPDArgs2;
		pCall->SetName("sscanf");
		pCall->AddTail(pArg);
		pFor->AddTail(pCall);

		//sscanf̈
		pArg->AddTail(new CSymbInst("line"));
		pTxt = new CMSArg;
		// modify fujita 99/10/30 
		//pTxt->SetName("\"%%d %%d %%d %%f %%f %%f \"");
		pTxt->SetName("\"%d %d %d %f %f %f\"");
		pArg->AddTail(pTxt);
		pAdr = new CSymbInst("&?");
		pAdr->AddTail(new CSymbInst("i_no"));
		pArg->AddTail(pAdr);

		pAdr = new CSymbInst("&?");
		pAdr->AddTail(new CSymbInst("j_no"));
		pArg->AddTail(pAdr);

		pAdr = new CSymbInst("&?");
		pAdr->AddTail(new CSymbInst("k_no"));
		pArg->AddTail(pAdr);

		pAdr = new CSymbInst("&?");
		pAdr->AddTail(new CSymbInst("f_x"));
		pArg->AddTail(pAdr);

		pAdr = new CSymbInst("&?");
		pAdr->AddTail(new CSymbInst("f_y"));
		pArg->AddTail(pAdr);

		pAdr = new CSymbInst("&?");
		pAdr->AddTail(new CSymbInst("f_z"));
		pArg->AddTail(pAdr);

		//Wf[^ϐɊi[B
		//i[ϐ͂͂߂ɒ`ꂽ͕ϐƂB
		//QȂ͂߂̂QARȂŏ̂RƂB

		//oldDepNo ͉͕ϐ̐iԂj
		//錾ׂẲ͕ϐo͂B
		//P_DepNo = dim;
		P_DepNo = oldDepNo;
		for(i=0;i<P_DepNo;i++) {
			CSymbInst *pLs, *pLs1,*pRs;
			int j;

			//͕ϐ
			pLs = new CSymbInst(check.targetVar[i].m_theDep->GetName());
			pLs1 = new CSymbInst(check.targetVar[i].m_timeIndex->GetName());
			pLs->AddTail(pLs1); //E̓Y

			//sscanfœǂݍ񂾂͕̂ϐ֑B
			//xx[i_no][j_no] = f_x
			//yy[i_no][j_no] = f_y
	
			pSub = new CPDSubst;
			pFor->AddTail(pSub);
			pEqu = new CSymbInst("=");
			pSub->AddTail(pEqu);
			for(j=0;j<dim;j++) {
				if(j==0) pLs->AddTail(new CSymbInst("i_no"));
				if(j==1) pLs->AddTail(new CSymbInst("j_no"));
				if(j==2) pLs->AddTail(new CSymbInst("k_no"));
			}

			if(i==0) pRs = new CSymbInst("f_x");
			if(i==1) pRs = new CSymbInst("f_y");
			if(i==2) pRs = new CSymbInst("f_z");

			//̍E̍o^
			pEqu->AddTail(pLs);
			pEqu->AddTail(pRs);
		}
		break;
	}
		
	
	///FOR [v iPj̎ ///////////////////////////////////////////////////
	/*
	pSub = new CPDSubst; //for loop̒̑
	pStore->AddTail(pSub);

	pEqual = new CSymbInst("="); //̓L
	pSub->AddTail(pEqual);

	CSymbInst *pLeft = new CSymbInst("table"); //̍
	pEqual->AddTail(pLeft);
	pEqual->AddTail(new CSymbInst("MPI_PROC_NULL")); //̉E

	CSymbInst *pPlus;
	for(i=1;i <= dim;i++) {
		pPlus = new CSymbInst("+");
		pLeft->AddTail(pPlus); //indexo^B
		pSpc = (CPDESpaceVar *) pSpcs->GetChild(i-1);
		pPlus->AddTail(new CSymbInst(pSpc->m_pIndex->GetName())); //Windex i,j,k擾
		pPlus->AddTail(new CSymbInst("c")); 
		//i+c,j+c,k+c
	}
	CPDFor *pFor;
	CPDForSub *pFSub;
	*/

	/*
	CPDWhile *pWhi = new CPDWhile;
	CSymbInst *pCond = new CSymbInst("!=");
	CPDCall *pCall = new CPDCall;
	CPDArgs2 *pArg2 = new CPDArgs2;
	pCall->SetName("fgets");
	pCall->AddTail(pArg2);
	
	pCond->AddTail(pCall);
	//pCond->AddTail(new CSymbInst("line"));
	pCond->AddTail(new CMSFract(0));

	CPDBlock *pThen = new CPDBlock();
	CPDSubst *pSub = new CPDSubst;
	CSymbInst *pEqu = new CSymbInst("=");
	pPrnt->AddTail(pWhi);
	pWhi->AddTail(pCond);
	pWhi->AddTail(pThen);

	pThen->AddTail(pSub);
	pSub->AddTail(pEqu);
	pEqu->AddTail(new CSymbInst("i"));
	pEqu->AddTail(new CMSFract(1));
	*/
	
}

void CJDCreateMainProc::MakeM_AVS_out_Proc(CViecFC *pPrnt)
{
	CPDESpaceVars *pSpcs;
	CPDESpaceVar *pSpc;
	CPDFor *pFor;
	CPDForSub *pSbF;
	CMSIndex *pIndx;
	CPDVar *pVars;

	pSpcs = pPrb->m_pdeInfo->m_meshInfo->m_spaceVars;
	int dim = pSpcs->GetCount();

	pVars = new CPDVar;
	pPrnt->AddTail(pVars);

	for(i=(dim-1);i>=0;i--) {
		pSpc = (CPDESpaceVar *) pSpcs->GetChild(i);
		pIndx = new CMSIndex;
		pIndx->SetName(pSpc->m_pIndex->GetName());
		pVars->AddTail(pIndx);

		pFor = new CPDFor;
		pSbF = new CPDForSub;
		pSbF->AddTail(new CSymbInst(pSpc->m_pIndex->GetName()));
		pSbF->AddTail(new CMSFract(1));
		pSbF->AddTail(new CSymbInst(pSpc->m_division->GetName()));
		pFor->AddTail(pSbF);
		pPrnt->AddTail(pFor);
		pPrnt = pFor;
	}

	CPDFile *pS;
	CPDArgs2 *pArg;

	pArg = new CPDArgs2;
	pS = new CPDFile;
	pS->AddTail(new CSymbInst("M_AVS.dat"));
	pS->AddTail(pArg);
	
	pPrnt->AddTail(pS);

	//i,j,kȂǂo͂
	CSymbInst *pInd;
	for(i=0;i<dim;i++) {
		pSpc = (CPDESpaceVar *) pSpcs->GetChild(i);
		pInd = new CSymbInst(pSpc->m_pIndex->GetName());
		pArg->AddTail(pInd);
	}

	//oldDepNo ͉͕ϐ̐iԂj
	//錾ׂẲ͕ϐo͂B
	for(i=0;i<oldDepNo;i++) {
		CSymbInst *pLs, *pLs1;
		int j,k;

		/*
		k = 0;
		for(j=oldDepNo;j<check.targetNo;j++) {
			if(check.targetVar[j].m_theDep==check.targetVar[i].m_theDep)
				k = j;
		}
		if(k==0) continue;
		*/
		pLs = new CSymbInst(check.targetVar[i].m_theDep->GetName());
		pLs1 = new CSymbInst(check.targetVar[i].m_timeIndex->GetName());
		pLs->AddTail(pLs1);
		pArg->AddTail(pLs);
		for(j=0;j<dim;j++) {
			pSpc = (CPDESpaceVar *) pSpcs->GetChild(j);
			pLs->AddTail(new CSymbInst(pSpc->m_pIndex->GetName()));
		}
	}
	
}

void CJDCreateMainProc::MakeM_AVS_FLD_out_Proc(CViecFC *pPrnt)
{
	///[Jϐ̐錾/////////////////////////////////////////////////////
	CPDVar *pVars = new CPDVar; //ϐ錾̔
	pPrnt->AddTail(pVars); //B

	CMSIndex *pIndex = new CMSIndex;
	pIndex->SetName("dim"); //local variable "dim"
	pVars->AddTail(pIndex); //ϐ錾ɒ`B

	pIndex = new CMSIndex;
	pIndex->SetName("var_no"); //local variable "var_no"
	pVars->AddTail(pIndex); //ϐ錾ɒ`B

	pIndex = new CMSIndex;
	pIndex->SetName("skip"); //local variable "skip"
	pVars->AddTail(pIndex); //ϐ錾ɒ`B

	pIndex = new CMSIndex;
	pIndex->SetName("offset"); //local variable "offset"
	pVars->AddTail(pIndex); //ϐ錾ɒ`B

	pIndex = new CMSIndex;
	pIndex->SetName("stride"); //local variable "stride"
	pVars->AddTail(pIndex); //ϐ錾ɒ`B

	pIndex = new CMSIndex;
	pIndex->SetName("cnt"); //local variable "cnt"
	pVars->AddTail(pIndex); //ϐ錾ɒ`B

	pVars = new CPDVar;
	pPrnt->AddTail(pVars);

	CMSChar_One *pChar = new CMSChar_One;
	pChar->SetName("filetype"); //local variable "filetype"
	pVars->AddTail(pChar); //ϐ錾ɒ`B

	//eϐ̒l͂B
	///ϐ̏lݒ dim = ?/////////////////////////////////////////////////////
	CPDESpaceVars *pSpcs;

	pSpcs = pPrb->m_pdeInfo->m_meshInfo->m_spaceVars;
	int dim = pSpcs->GetCount();

	CPDSubst *pSub;	
	CSymbInst *pEqual;
	pSub = new CPDSubst;
	pPrnt->AddTail(pSub);
	pEqual = new CSymbInst("=");
	pSub->AddTail(pEqual);
	pEqual->AddTail(new CSymbInst("dim"));
	pEqual->AddTail(new CMSFract(dim));
	////////////////////////////////////////////

	///ϐ̏lݒ var_no = ?/////////////////////////////////////////////////////
	pSub = new CPDSubst;
	pPrnt->AddTail(pSub);
	pEqual = new CSymbInst("=");
	pSub->AddTail(pEqual);
	pEqual->AddTail(new CSymbInst("var_no"));
	pEqual->AddTail(new CMSFract(oldDepNo));
	////////////////////////////////////////////

	///ϐ̏lݒ skip = 0/////////////////////////////////////////////////////
	pSub = new CPDSubst;
	pPrnt->AddTail(pSub);
	pEqual = new CSymbInst("=");
	pSub->AddTail(pEqual);
	pEqual->AddTail(new CSymbInst("skip"));
	pEqual->AddTail(new CMSFract(0));
	////////////////////////////////////////////

	///ϐ̏lݒ stride = var_no * dim/////////////////////////////////////////////////////
	pSub = new CPDSubst;
	pPrnt->AddTail(pSub);
	pEqual = new CSymbInst("=");
	pSub->AddTail(pEqual);
	pEqual->AddTail(new CSymbInst("stride"));
	CSymbInst *pMult = new CSymbInst("+");
	pEqual->AddTail(pMult);
	pMult->AddTail(new CSymbInst("var_no"));
	pMult->AddTail(new CSymbInst("dim"));
	////////////////////////////////////////////

	///ϐ̏lݒ filetype = "ascii"/////////////////////////////////////////////////////
	//CPDStrcpy *pStr = new CPDStrcpy;
	CPDCallBy *pCall = new CPDCallBy;
	pCall->SetName("strcpy");
	CPDArgs2 *pA = new CPDArgs2;
	//pPrnt->AddTail(pStr);
	pPrnt->AddTail(pCall);
	//pStr->AddTail(pA);
	pCall->AddTail(pA);

	pA->AddTail(new CSymbInst("filetype"));

	CMSArg *pM = new CMSArg;
	pM->SetName("\"ascii\"");
	pA->AddTail(pM);
	////////////////////////////////////////////



	//fileo
	//fpritf("M_AVS.fld","# AVS field file");
	CPDFile *pS;
	CPDArgs2 *pArg;

	pArg = new CPDArgs2;
	pS = new CPDFile;
	pS->AddTail(new CSymbInst("M_AVS.fld"));
	pS->AddTail(pArg);
	
	pPrnt->AddTail(pS);

	CMSArg *pTxt = new CMSArg;
	pTxt->SetName("\"# AVS field file\""); 
	pArg->AddTail(pTxt);
	//////////////////////////

	//fpritf("M_AVS.fld","ndim = %d",dim);
	pArg = new CPDArgs2;
	pS = new CPDFile;
	pS->AddTail(new CSymbInst("M_AVS.fld"));
	pS->AddTail(pArg);
	
	pPrnt->AddTail(pS);

	pTxt = new CMSArg;
	pTxt->SetName("\"ndim = %d \""); 
	pArg->AddTail(pTxt);
	pArg->AddTail(new CSymbInst("dim"));
	/////////////////////////////////////

	//fpritf("M_AVS.fld","dim1 = %d",IMAX);
	//fpritf("M_AVS.fld","dim2 = %d",JMAX);
	int i;
	for (i=1; i <= dim; i++){
		pArg = new CPDArgs2;
		pS = new CPDFile;
		pS->AddTail(new CSymbInst("M_AVS.fld"));
		pS->AddTail(pArg);
		
		pPrnt->AddTail(pS);

		pTxt = new CMSArg;
		char dim_name[30];
		sprintf(dim_name,"\" dim%d",i);
		strcat(dim_name," = %d \"");
		pTxt->SetName(dim_name);
		pArg->AddTail(pTxt);
		switch(i){
		case 1: 
			pArg->AddTail(new CSymbInst("IMAX"));
			break;
		case 2: 
			pArg->AddTail(new CSymbInst("JMAX"));
			break;
		case 3: 
			pArg->AddTail(new CSymbInst("KMAX"));
			break;

		}
	}
	/////////////////////////////////////

	//fpritf("M_AVS.fld","nspce = %d",dim);
	pArg = new CPDArgs2;
	pS = new CPDFile;
	pS->AddTail(new CSymbInst("M_AVS.fld"));
	pS->AddTail(pArg);
	
	pPrnt->AddTail(pS);

	pTxt = new CMSArg;
	pTxt->SetName("\"nspace = %d \""); 
	pArg->AddTail(pTxt);
	pArg->AddTail(new CSymbInst("dim"));
	/////////////////////////////////////

	//fpritf("M_AVS.fld","nspce = %d",var_no);
	pArg = new CPDArgs2;
	pS = new CPDFile;
	pS->AddTail(new CSymbInst("M_AVS.fld"));
	pS->AddTail(pArg);
	
	pPrnt->AddTail(pS);

	pTxt = new CMSArg;
	pTxt->SetName("\"veclen = %d \""); 
	pArg->AddTail(pTxt);
	pArg->AddTail(new CSymbInst("var_no"));
	/////////////////////////////////////

	//fpritf("M_AVS.fld","data = float");
	pArg = new CPDArgs2;
	pS = new CPDFile;
	pS->AddTail(new CSymbInst("M_AVS.fld"));
	pS->AddTail(pArg);
	
	pPrnt->AddTail(pS);

	pTxt = new CMSArg;
	pTxt->SetName("\"data = float \""); 
	pArg->AddTail(pTxt);
	/////////////////////////////////////

	//fpritf("M_AVS.fld","field = irregular");
	pArg = new CPDArgs2;
	pS = new CPDFile;
	pS->AddTail(new CSymbInst("M_AVS.fld"));
	pS->AddTail(pArg);
	
	pPrnt->AddTail(pS);

	pTxt = new CMSArg;
	pTxt->SetName("\"field = irregular \""); 
	pArg->AddTail(pTxt);
	/////////////////////////////////////

	
	///FOR [v iPj////////////////////////////////////////////////////
	CPDFor *pFor = new CPDFor;
	CPDForSub *pFor_Sub = new CPDForSub;
	pPrnt->AddTail(pFor); //̐e|C^[FORNXo^BŏpPrntɓo^B
	pFor->AddTail(pFor_Sub); //FoȑNXo^B
		
	pFor_Sub->AddTail(new CSymbInst("cnt")); //ϐ cnt
	pFor_Sub->AddTail(new CMSFract(1)); //l(1)
	pFor_Sub->AddTail(new CSymbInst("var_no")); //I cnt <= var_no
	
	///FOR [v iPj̎ ///////////////////////////////////////////////////
	pSub = new CPDSubst; //for loop̒̑
	pFor->AddTail(pSub);

	pEqual = new CSymbInst("="); //̓L
	pSub->AddTail(pEqual);

	CSymbInst *pLeft = new CSymbInst("offset"); //̍
	pEqual->AddTail(pLeft);
	CSymbInst *pPlus = new CSymbInst("+");
	pEqual->AddTail(pPlus);
	pPlus->AddTail(new CSymbInst("cnt")); //̉Eӑ1
	pPlus->AddTail(new CSymbInst("dim")); //̉Eӑ2
	pPlus->AddTail(new CMSFract(-1)); //̉Eӑ3

	//make fprintf("M_AVS.fld","variable %d file =.\\M_AVS.dat filetype = %s skip = %d offset = %d stride = %d
	//",cnt,filetype,skip,skip,offset,stride);
	pArg = new CPDArgs2;
	pS = new CPDFile;
	pS->AddTail(new CSymbInst("M_AVS.fld"));
	pS->AddTail(pArg);
	
	pFor->AddTail(pS);

	pTxt = new CMSArg;
	pTxt->SetName("\"variable %d file = .\\M_AVS.dat filetype = %s skip = %d offset = %d stride = %d \""); 
	pArg->AddTail(pTxt);
	pArg->AddTail(new CSymbInst("cnt"));
	pArg->AddTail(new CSymbInst("filetype"));
	pArg->AddTail(new CSymbInst("skip"));
	pArg->AddTail(new CSymbInst("offset"));
	pArg->AddTail(new CSymbInst("stride"));
	////////////////////////////////////////////////////

	///FOR [v i2j////////////////////////////////////////////////////
	pFor = new CPDFor;
	pFor_Sub = new CPDForSub;
	pPrnt->AddTail(pFor); //̐e|C^[FORNXo^BŏpPrntɓo^B
	pFor->AddTail(pFor_Sub); //FoȑNXo^B
		
	pFor_Sub->AddTail(new CSymbInst("cnt")); //ϐ cnt
	pFor_Sub->AddTail(new CMSFract(1)); //l(1)
	pFor_Sub->AddTail(new CSymbInst("dim")); //I cnt <= dim
	
	///FOR [v i2j̎ ///////////////////////////////////////////////////
	pSub = new CPDSubst; //for loop̒̑
	pFor->AddTail(pSub);

	pEqual = new CSymbInst("="); //̓L
	pSub->AddTail(pEqual);

	pLeft = new CSymbInst("offset"); //̍
	pEqual->AddTail(pLeft);
	pPlus = new CSymbInst("+");
	pEqual->AddTail(pPlus);
	pPlus->AddTail(new CSymbInst("cnt")); //̉Eӑ1
	pPlus->AddTail(new CSymbInst("dim")); //̉Eӑ2
	pPlus->AddTail(new CMSFract(-1)); //̉Eӑ3

	//make fprintf("M_AVS.fld","coord %d file = .\\M_AVS.dat filetype = %s skip = %d offset = %d stride = %d
	//",cnt,filetype,skip,skip,offset,stride);
	pArg = new CPDArgs2;
	pS = new CPDFile;
	pS->AddTail(new CSymbInst("M_AVS.fld"));
	pS->AddTail(pArg);
	
	pFor->AddTail(pS);

	pTxt = new CMSArg;
	pTxt->SetName("\"coord %d file = .\\M_AVS.dat filetype = %s skip = %d offset = %d stride = %d \""); 
	pArg->AddTail(pTxt);
	pArg->AddTail(new CSymbInst("cnt"));
	pArg->AddTail(new CSymbInst("filetype"));
	pArg->AddTail(new CSymbInst("skip"));
	pArg->AddTail(new CSymbInst("offset"));
	pArg->AddTail(new CSymbInst("stride"));
	////////////////////////////////////////////////////
}

void CJDCreateMainProc::MakeM_POST_out_Proc(CViecFC *pPrnt)
{
	CPDESpaceVars *pSpcs;
	CPDESpaceVar *pSpc;
	CPDFor *pFor;
	CPDForSub *pSbF;
	CMSIndex *pIndx;
	CPDVar *pVars;

	pSpcs = pPrb->m_pdeInfo->m_meshInfo->m_spaceVars;
	int dim = pSpcs->GetCount();

	pVars = new CPDVar;
	pPrnt->AddTail(pVars);

	for(i=0; i<dim; i++) {
		pSpc = (CPDESpaceVar *) pSpcs->GetChild(i);
		pIndx = new CMSIndex;
		pIndx->SetName(pSpc->m_pIndex->GetName());
		pVars->AddTail(pIndx);

		pFor = new CPDFor;
		pSbF = new CPDForSub;
		pSbF->AddTail(new CSymbInst(pSpc->m_pIndex->GetName()));
		pSbF->AddTail(new CMSFract(1));
		pSbF->AddTail(new CSymbInst(pSpc->m_division->GetName()));
		pFor->AddTail(pSbF);
		pPrnt->AddTail(pFor);
		pPrnt = pFor;
	}

	CPDFile *pS;
	CPDArgs2 *pArg;

	pArg = new CPDArgs2;
	pS = new CPDFile;
	pS->AddTail(new CSymbInst("M_POST.dat"));
	pS->AddTail(pArg);
	
	pPrnt->AddTail(pS);

	//i,j,kȂǂo͂
	CSymbInst *pInd;
	for(i=0;i<dim;i++) {
		pSpc = (CPDESpaceVar *) pSpcs->GetChild(i);
		pInd = new CSymbInst(pSpc->m_pIndex->GetName());
		pArg->AddTail(pInd);
	}

	//oldDepNo ͉͕ϐ̐iԂj
	//錾ׂẲ͕ϐo͂B
	for(i=0;i<oldDepNo;i++) {
		CSymbInst *pLs, *pLs1;
		int j,k;

		/*
		k = 0;
		for(j=oldDepNo;j<check.targetNo;j++) {
			if(check.targetVar[j].m_theDep==check.targetVar[i].m_theDep)
				k = j;
		}
		if(k==0) continue;
		*/
		pLs = new CSymbInst(check.targetVar[i].m_theDep->GetName());
		pLs1 = new CSymbInst(check.targetVar[i].m_timeIndex->GetName());
		pLs->AddTail(pLs1);
		pArg->AddTail(pLs);
		for(j=0;j<dim;j++) {
			pSpc = (CPDESpaceVar *) pSpcs->GetChild(j);
			pLs->AddTail(new CSymbInst(pSpc->m_pIndex->GetName()));
		}
	}

}

//////////////////// CJDCreateProc ////////////////////
//////////////////// CJDCreateProc ////////////////////
//////////////////// CJDCreateProc ////////////////////

BOOL CJDCreateProc::FindStartCond(CSymbInst* pInst)
{
	POSITION pos;
	CViecFC *psym;
	CSymbInst *pInst2;
	CViecFC *psym2;
	CPDEDepInfo *pDep;
	psym = pInst->GetSymbBody();
	if(!psym->IsKindOf(RUNTIME_CLASS(CMSDepVar))) return TRUE;
	if(pInst->GetCount()==0) return TRUE;
	pDep = (CPDEDepInfo *) psym->GetParent();
	if(!pDep->IsKindOf(RUNTIME_CLASS(CPDEDepInfo))) return TRUE;
	pos = pInst->GetHeadPosition();
	pInst2 = (CSymbInst *) pInst->GetNext(pos);
	if(!pInst2->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
	psym2 = pInst2->GetSymbBody();
	if(psym2->IsKindOf(RUNTIME_CLASS(CMSIndex))) {
		m_target.m_theDep = (CMSPhys *) psym;
		m_target.m_timeIndex = (CMSIndex *) psym2;
		m_target.m_timeShift.m_value = 0;
		m_target.m_timeShift.m_deno = 1;
	} else if(psym2->IsKindOf(RUNTIME_CLASS(CMSOPlus)) && pInst2->GetCount()==2) {
		CSymbInst *pInst3;
		CViecFC *psym3;
		CMSFract *pfrct;
		pos = pInst2->GetHeadPosition();
		pInst3 = (CSymbInst *) pInst2->GetNext(pos);
		pfrct = (CMSFract *) pInst2->GetNext(pos);
		if(!pInst3->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
		psym3 = pInst3->GetSymbBody();
		if(!pfrct->IsKindOf(RUNTIME_CLASS(CMSFract))) return TRUE;
		if(!psym3->IsKindOf(RUNTIME_CLASS(CMSIndex))) return TRUE;
		m_target.m_theDep = (CMSPhys *) psym;
		m_target.m_timeIndex = (CMSIndex *) psym3;
		m_target.m_timeShift.m_value = pfrct->m_value;
		m_target.m_timeShift.m_deno = pfrct->m_deno;
	}
	return TRUE;
}

BOOL CJDCreateProc::Do(CObject *g)
{
	if(m_bStartFg) {
		CSymbInst *pDep, *pI;
		CMSFract *pShf;
		int i;
		if(g->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			pDep = (CSymbInst *) g;
			if(pDep->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSDepVar))) {
				if(pDep->GetCount()!=dim+1) return TRUE;
				for(i=0;i<dim;i++) {
					pI = (CSymbInst *) pDep->GetChild(i+1);
					if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
					if(pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
						pShf = (CMSFract *) pI->GetChild(1);
						if(pShf->IsKindOf(RUNTIME_CLASS(CMSFract))) {
							if(pShf->m_value < rangeBegin[i])
								rangeBegin[i] = pShf->m_value;
							if(pShf->m_value > rangeEnd[i])
								rangeEnd[i] = pShf->m_value;
						}
					}
				}
				return TRUE;
			}
		}
		return FALSE;
	} else {
		int i,cnt;
		if(g->IsKindOf(RUNTIME_CLASS(CIElem)))
			g = ((CIElem*)g)->GetBody();
		if(!g->IsKindOf(RUNTIME_CLASS(CPDESolvSet))) return TRUE;
		pSlv = (CPDESolvSet *) g;
		cnt = pSlv->GetCount();  // cnt = tne number of CPDESolvSet's child
		if(cnt<2) return TRUE;
		pTg = (CPDETarget *) pSlv->GetChild(0);
		pPde = (CPDEDepPDE *) pSlv->GetChild(1);
		if(!pTg->IsKindOf(RUNTIME_CLASS(CPDETarget))) return TRUE;
		if(!pPde->IsKindOf(RUNTIME_CLASS(CPDEDepPDE))) return TRUE;
		for(i=0;i<cnt-2;i++) {
			pBcs[i] = (CPDEBoundCond *) pSlv->GetChild(i+2);
			// Boundary condition pointer get.
			// pBcs[0] = pointer of First boundary class .
			// pBcs[1] = pointer of Second boundary class .
			// pBcs[2] = pointer of Third boundary class .
			// pBcs[3] = pointer of fourth boundary class .
			// ...................


			if(!pBcs[i]->IsKindOf(RUNTIME_CLASS(CPDEBoundCond))) return TRUE;
			// Check pBcs. If pBcs is not CPDEBoudCond pointer,return TRUE(finish).

			if(!pBcs[i]->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CPDEBoundDef))) return TRUE;
			// Check pBcs->Symbol. 
			// If pBcs->Symbol is not CPDEBoudDef pointer,return TRUE(finish).
			// Two times check!!

		}

		if(!FindStartCond(pTg)) return TRUE;
		if(pPde->GetCount()<2) return TRUE;
		pRg = (CPDERange *) pPde->GetChild(0);
		pEqt = (CSymbInst *) pPde->GetChild(1);
		if(!pRg->IsKindOf(RUNTIME_CLASS(CPDERange))) return TRUE;
		if(!pEqt->IsKindOf(RUNTIME_CLASS(CSymbInst))) return TRUE;
		if(!pEqt->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOEqual))) return TRUE;
		dim = pRg->GetCount();

		m_eSolverType = SOLVER_EXPLICIT;
		if(pEqt->GetChild(0)->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			CSymbInst *pP = (CSymbInst *) pEqt->GetChild(0);
			if(pP->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus)))
				m_eSolverType = SOLVER_BAND_MATRIX_GAUSS;
//				m_eSolverType = SOLVER_FULL_MATRIX_GAUSS;
		}

		m_bStartFg=TRUE;
		//--------- find skip
		for(i=0;i<dim;i++) rangeBegin[i] = rangeEnd[i] = 0;
		pEqt->GetChild(0)->SendMsg(MSG_DO_JOB, this);
		pEqt->GetChild(1)->SendMsg(MSG_DO_JOB, this);

		//--- create solver proc

		pSlvProc = new CPDProc;
		pSlvProc->AddTail(new CPDArgs);
		pSlvProc->SetName(CString("Slv")+m_name);
		pSlvProc->SetMode(CPElem::modeClose);

		m_pVars = new CPDVar;
		pSlvProc->AddTail(m_pVars);

		//--- solver initialize
		m_nLeftWing = 0;
		m_nRightWing = 0;
		switch(m_eSolverType) {
		case SOLVER_FULL_MATRIX_GAUSS:
			InitFullMatrix();
		case SOLVER_BAND_MATRIX_GAUSS:
			InitBandMatrix();
		};
			
		POSITION pos;
		CPad *pPrnt;
		CRangeOnAxis *pRoX;
		CPDESpaceVar *pSpc;
		CViecFC *pF, *pT, *pE;
		CMSFract *pN;
		CPDBlock *pBlk;

		//--- bulk solver
		pPrnt = pSlvProc;
		m_varNo = 0;
		m_midPos = -1;

		pos = pRg->GetHeadPosition();
		for(i=0; pos; i++) {
			pRoX = (CRangeOnAxis *) pRg->GetNext(pos);

			pSpc = (CPDESpaceVar *) pRoX->GetSymbBody()->GetParent();
			if(!pSpc->IsKindOf(RUNTIME_CLASS(CPDESpaceVar))) continue;
			pF = new CMSFract(pRoX->m_pFrom->m_value - rangeBegin[i]);
			pT = new CMSFract(pRoX->m_pTo->m_value - rangeEnd[i]);
			pN = (CMSFract *) pT;
			if(pN->m_value<0) {
				pE = pT;
				pT = new CSymbInst("+");
				pT->AddTail(new CSymbInst(pSpc->m_division->GetName()));
				pT->AddTail(pE);
			} if(pN->m_value==0) {
				delete pT;
				pT = new CSymbInst(pSpc->m_division->GetName());
			}
			CPDFor *pfor = new CPDFor;
			CPad *psub = new CPDForSub;
			CSymbInst *pvar = new CSymbInst(pSpc->m_pIndex->GetName());
			pPrnt->AddTail(pfor);

			CMSIndex *ndx = new CMSIndex;
			ndx->SetName(pSpc->m_pIndex->GetName());
			m_pVars->AddTail(ndx);

			pfor->AddTail(psub);
			psub->AddTail(pvar);
			psub->AddTail(pF);
			psub->AddTail(pT);

//			psub->AddTail(new CSymbInst("j")); //Kawa
#if 0 									 //Kawa from here
			pMade = new CSymbInst("+");
			pNew = new CSymbInst("J");
			pMade->AddTail(pT);
			pMade->AddTail(pNew);

			psub->AddTail(pMade);
#endif									 //Kawa to here
			pPrnt = pfor;
		}

		CPDSubst *pSbst;
		//--- solver in bulk
		switch(m_eSolverType) {
		case SOLVER_BAND_MATRIX_GAUSS:
			CreateBandMtxSlv(pPrnt, pEqt);
			break;
		case SOLVER_FULL_MATRIX_GAUSS:
			CreateMtxSlv(pPrnt, pEqt->GetChild(0), pEqt->GetChild(1));
			break;
		case SOLVER_EXPLICIT:
			pSbst = new CPDSubst;
			pPrnt->AddTail(pSbst);
			pSbst->AddTail(pEqt->Copy());
			break;
		}

		//--- boundary solver
		CPDEBoundDef *pBD;
		pBlk = NULL;
		if(cnt>2) {
			pBlk = new CPDBlock;
			pSlvProc->AddTail(pBlk);
			pBlk->SetName("Boundary Conditions");
			// Block in PAD figure is naming "XXXXXX".

			pBlk->SetMode(CPElem::modeClose);
			// InitBlock conditoin set Close.
		}
		for(i=0;i<cnt-2;i++) {
			pBD = (CPDEBoundDef *) pBcs[i]->GetSymbBody();
			// store Boundary Condition symbol pointer pBD.

			if(pBlk)
				pPrnt = pBlk;
			//--- surface index 
			pSpc = (CPDESpaceVar *) pBD->m_surf->GetSymbBody()->GetParent();
			if(!pSpc->IsKindOf(RUNTIME_CLASS(CPDESpaceVar))) continue;
			// Check pSpc.

			//--------- find skip
			CSymbInst *pCond = (CSymbInst *) pBcs[i]->GetChild(0);
			for(int j=0;j<dim;j++) rangeBegin[j] = rangeEnd[j] = 0;
			pCond->GetChild(0)->SendMsg(MSG_DO_JOB, this);
			pCond->GetChild(1)->SendMsg(MSG_DO_JOB, this);

			CPDComm *pCm;
			pCm = new CPDComm();
			pCm->SetName(CString("boundary condition on ")+pBD->GetName());
			pPrnt->AddTail(pCm);  // CPad *pPrnt 
								  // pCm (bondary condition) add tail to CPad

			pT = new CMSFract(pBD->m_surf->m_pAt->m_value);
									// CViecFC *pT
								    // CPDEBoundDef *pBD 

			pN = (CMSFract *) pT;
			if(pN->m_value<0) {
				pE = pT;
				pT = new CSymbInst("+");
				pT->AddTail(new CSymbInst(pSpc->m_division->GetName()));
				pT->AddTail(pE);
			} if(pN->m_value==0) {
				delete pT;
				pT = new CSymbInst(pSpc->m_division->GetName());
			}
			pSbst = new CPDSubst;
			pPrnt->AddTail(pSbst);
			pE = new CSymbInst("=");
			pE->AddTail(new CSymbInst(pSpc->m_pIndex->GetName()));
			pE->AddTail(pT);
			pSbst->AddTail(pE);

			if(pBD->m_range!=NULL) {
				//--- range index
				pSpc = (CPDESpaceVar *) pBD->m_range->GetSymbBody()->GetParent();
				if(!pSpc->IsKindOf(RUNTIME_CLASS(CPDESpaceVar))) continue;
				pF = new CMSFract(pBD->m_range->m_pFrom->m_value - rangeBegin[pBD->m_range->m_axisNo]);
				pT = new CMSFract(pBD->m_range->m_pTo->m_value - rangeEnd[pBD->m_range->m_axisNo]);
				pN = (CMSFract *) pT;
				if(pN->m_value<0) {
					pE = pT;
					pT = new CSymbInst("+");
					pT->AddTail(new CSymbInst(pSpc->m_division->GetName()));
					pT->AddTail(pE);
				} if(pN->m_value==0) {
					delete pT;
					pT = new CSymbInst(pSpc->m_division->GetName());
				}
				CPDFor *pfor = new CPDFor;
				CPad *psub = new CPDForSub;
				CSymbInst *pvar = new CSymbInst(pSpc->m_pIndex->GetName());
				pPrnt->AddTail(pfor);

				pfor->AddTail(psub);
				psub->AddTail(pvar);
				psub->AddTail(pF);
				psub->AddTail(pT);
				
				pPrnt = pfor;
			}

			//--- solver for boundary condition
			switch(m_eSolverType) {
			case SOLVER_BAND_MATRIX_GAUSS:
				CreateBandMtxSlv(pPrnt, pCond);
				break;
			case SOLVER_FULL_MATRIX_GAUSS:
				CreateMtxSlv(pPrnt, pCond->GetChild(0), pCond->GetChild(1));
				break;
			case SOLVER_EXPLICIT:
				// display boundary condition on PAD Fig.
				// 
				/******** original *****************
				pSbst = new CPDSubst;
				pSbst->AddTail(pCond->Copy());
				// What is pCond->Copy() ?


						// CPDSubst *pSbst
						// CPad *pPrnt 
						// CSymbInst *pCond

				//pSbst->AddTail(pCond);
				//pPrnt->AddTail(pCond);
				pPrnt->AddTail(pSbst);
				**************************************/
				pSbst = new CPDSubst;
				// CPDSubst is PAD BOX
				//pSbst->AddTail(pCond->Copy());
				// What is pCond->Copy() ?


						// CPDSubst *pSbst
						// CPad *pPrnt 
						// CSymbInst *pCond

				pSbst->AddTail(pCond);
				// pPrnt->AddTail(pCond); // this lien is not necessary.
				pPrnt->AddTail(pSbst);
				break;
			}
		}

		pPrnt = pSlvProc;
		//--- solver post process
		switch(m_eSolverType) {
		case SOLVER_BAND_MATRIX_GAUSS:
			BandMatrixGaussSlv(pPrnt);
			break;
		case SOLVER_EXPLICIT:
			break;
		case SOLVER_FULL_MATRIX_GAUSS:
			FullMatrixGaussSlv(pPrnt);
			break;
		}
		m_output->AddTail(pSlvProc);
		m_output->OnCreated();
		m_output->CalcExt(CViecFC::dirDown);
		m_output->CalcExt();
		return TRUE;


	}
	return FALSE;
}

void CJDCreateProc::InitFullMatrix()
{
	CalcSkipWdFullMtx();

	sAmtx = CString("Am")+m_name;
	sBvct = CString("Bv")+m_name;
	sFvct = CString("Fv")+m_name;

	m_pAm = new CMSPDEMtx;
	m_pAm->SetName(sAmtx);
	m_pAm->AddTail(new CSymbInst(sMtxISz));
	m_pAm->AddTail(new CSymbInst(sMtxJSz));
	m_pMainProcGen->pMtxDefs->AddTail(m_pAm);

	m_pBv = new CMSPDEVct;
	m_pBv->SetName(sBvct);
	m_pBv->AddTail(new CSymbInst(sMtxJSz));
	m_pMainProcGen->pMtxDefs->AddTail(m_pBv);

	m_pFv = new CMSPDEVct;
	m_pFv->SetName(sFvct);
	m_pFv->AddTail(new CSymbInst(sMtxJSz));
	m_pMainProcGen->pMtxDefs->AddTail(m_pFv);

	CMSIndex *pMi, *pMj, *pMk;
	pMi = new CMSIndex;
	pMi->SetName("mI");
	m_pVars->AddTail(pMi);
	pMj = new CMSIndex;
	pMj->SetName("mJ");
	m_pVars->AddTail(pMj);
	pMk = new CMSIndex;
	pMk->SetName("mK");
	m_pVars->AddTail(pMk);

	//--- matrix elements clear
	CPDFor *pForI, *pForJ;
	CPDForSub *pSbI, *pSbJ;
	CSymbInst *pM0, *pD1;
	CPDSubst *psbst;

	pForI = new CPDFor;
	pSbI = new CPDForSub;
	pSbI->AddTail(new CSymbInst("mI"));
	pSbI->AddTail(new CMSFract(1));
	pSbI->AddTail(new CSymbInst(sMtxJSz));
	pForI->AddTail(pSbI);

	pForJ = new CPDFor;
	pSbJ = new CPDForSub;
	pSbJ->AddTail(new CSymbInst("mJ"));
	pSbJ->AddTail(new CMSFract(1));
	pSbJ->AddTail(new CSymbInst(sMtxJSz));
	pForJ->AddTail(pSbJ);
	pForI->AddTail(pForJ);

	pM0 = new CSymbInst("=");
	pD1 = new CSymbInst(sAmtx);
	pD1->AddTail(new CSymbInst("mI"));
	pD1->AddTail(new CSymbInst("mJ"));
	pM0->AddTail(pD1);
	pM0->AddTail(new CMSFract(0));
	psbst = new CPDSubst;
	psbst->AddTail(pM0);
	pForJ->AddTail(psbst);

	pSlvProc->AddTail(pForI);
}

BOOL CJDCreateProc::CalcSkipWdFullMtx()
{
	CRangeOnAxis *pRoX;
	CPDESpaceVar *pSpc;
	CMSFract  *pN;
	CViecFC *pE, *pF, *pT;
	CSymbInst *pX, *pM;
	CViecFC M;
	POSITION pos;
	int i;
	CPDEConstDef *pcnst;

	pos = pRg->GetHeadPosition();
	for(i=0; pos; i++) {
		pRoX = (CRangeOnAxis *) pRg->GetNext(pos);
		pSpc = (CPDESpaceVar *) pRoX->GetSymbBody()->GetParent();
		if(!pSpc->IsKindOf(RUNTIME_CLASS(CPDESpaceVar))) continue;
		pF = new CMSFract(- pRoX->m_pFrom->m_value);
		pT = new CMSFract(pRoX->m_pTo->m_value);
		pN = (CMSFract *) pT;
		if(pN->m_value<0) {
			pE = pT;
			pT = new CSymbInst("+");
			pT->AddTail(new CSymbInst(pSpc->m_division->GetName()));
			pT->AddTail(pE);
		} if(pN->m_value==0) {
			delete pT;
			pT = new CSymbInst(pSpc->m_division->GetName());
		}
		sMax[i] = pSpc->m_pIndex->GetName()+CString("Mx")+m_name;
		pX = new CSymbInst("+");
		pX->AddTail(pT);
		pX->AddTail(pF);
		pX->AddTail(new CMSFract(1));
		pcnst = new CPDEConstDef;
		pcnst->SetName(sMax[i]);
		pcnst->AddTail(pX);
		m_pMainProcGen->pMtxDefs->AddTail(pcnst);

		M.AddTail(new CSymbInst(sMax[i]));
	}
	m_pMainProcGen->pMtxDefs->AddTail(new CPDELineTerm);
	sMtxISz = CString("MISz") + m_name;
	sMtxJSz = CString("MJSz")+m_name;

	pMxISz = new CPDEConstDef;
	pMxISz->SetName(sMtxISz);
	pMxISz->AddTail(new CSymbInst(sMtxJSz));
	m_pMainProcGen->pMtxDefs->AddTail(pMxISz);

	pMxJSz = new CPDEConstDef;
	pMxJSz->SetName(sMtxJSz);
	m_pMainProcGen->pMtxDefs->AddTail(pMxJSz);
	if(M.GetCount()==1) {
		pMxJSz->AddTail(M.GetChild(0));
		M.m_child.RemoveAll();
	} else {
		pM = new CSymbInst("*");
		pos = M.GetHeadPosition();
		while(pos)
			pM->AddTail(M.GetNext(pos));
		M.m_child.RemoveAll();
		pMxJSz->AddTail(pM);
	}

	m_pMainProcGen->pMtxDefs->AddTail(new CPDELineTerm);
	return TRUE;
}

BOOL CJDCreateProc::FullMatrixGaussSlv(CViecFC *pPrnt)
{
	//--- elemination method
	CMSConst *pM;
	CPDFor *pForI, *pForJ, *pForK;
	CPDForSub *pSbI, *pSbJ, *pSbK;
	CSymbInst *pInstJ, *pInstK, *pP1;
	CSymbInst *pM0, *pD, *pD1, *pD2, *pEq;
	CPDSubst *psbst;

	CViecFC *pP0 = pPrnt;
	CPDBlock *pBlk = new CPDBlock;
	pBlk->SetName("Gauss Elimination Matrix Solver");
	pPrnt->AddTail(pBlk);
	pBlk->SetMode(CPElem::modeClose);
	pPrnt = pBlk;

	pM = new CMSConst;
	pM->SetName("m");
	m_pVars->AddTail(pM);

	//--- elimination
	pForI = new CPDFor;
	pSbI = new CPDForSub;
	pSbI->AddTail(new CSymbInst("mI"));
	pSbI->AddTail(new CMSFract(1));
	pSbI->AddTail(new CSymbInst(sMtxJSz));
	pForI->AddTail(pSbI);
	pPrnt->AddTail(pForI);

	pForJ = new CPDFor;
	pSbJ = new CPDForSub;
	pSbJ->AddTail(new CSymbInst("mJ"));
	pInstJ = new CSymbInst("mI");
	pP1 = new CSymbInst("+");
	pP1->AddTail(pInstJ);
	pP1->AddTail(new CMSFract);
	pSbJ->AddTail(pP1);
	pSbJ->AddTail(new CSymbInst(sMtxJSz));
	pForJ->AddTail(pSbJ);
	pForI->AddTail(pForJ);

	//	M = MXoT[K][I] / MXoT[I][I];
	pEq = new CSymbInst("=");
	pM0 = new CSymbInst("m");
	pD = new CSymbInst("/");
	pD1 = new CSymbInst(sAmtx);
	pD2 = new CSymbInst(sAmtx);
	pD->AddTail(pD1);
	pD->AddTail(pD2);
	pD1->AddTail(new CSymbInst("mI"));
	pD1->AddTail(new CSymbInst("mJ"));
	pD2->AddTail(new CSymbInst("mI"));
	pD2->AddTail(new CSymbInst("mI"));
	pEq->AddTail(pM0);
	pEq->AddTail(pD);
	psbst = new CPDSubst;
	psbst->AddTail(pEq);

	pForK = new CPDFor;
	pSbK = new CPDForSub;
	pSbK->AddTail(new CSymbInst("mK"));
	pInstK = new CSymbInst("mI");
	pSbK->AddTail(pInstK);
	pSbK->AddTail(new CSymbInst(sMtxJSz));
	pForK->AddTail(pSbK);

	pForJ->AddTail(psbst);
	pForJ->AddTail(pForK);

	//	MXoT[K][J] = MXoT[K][J] - M * MXoT[I][J];
	CSymbInst *pI0, *pI1, *pI2, *pI3, *pI4, *pI5, *pI6, *pI7;
	CPDSubst *pSbst;
	pI0 = new CSymbInst("=");
	pI1 = new CSymbInst(sAmtx);
	pI2 = new CSymbInst("+");
	pI3 = new CSymbInst(sAmtx);
	pI4 = new CSymbInst("-?");
	pI5 = new CSymbInst("*");
	pI6 = new CSymbInst("m");	//----???
	pI7 = new CSymbInst(sAmtx);
	pI0->AddTail(pI1);
	pI0->AddTail(pI2);
	pI1->AddTail(new CSymbInst("mK"));
	pI1->AddTail(new CSymbInst("mJ"));
	pI2->AddTail(pI3);
	pI2->AddTail(pI4);
	pI3->AddTail(new CSymbInst("mK"));
	pI3->AddTail(new CSymbInst("mJ"));
	pI4->AddTail(pI5);
	pI5->AddTail(pI6);
	pI5->AddTail(pI7);
	pI7->AddTail(new CSymbInst("mK"));
	pI7->AddTail(new CSymbInst("mI"));
	pSbst = new CPDSubst;
	pSbst->AddTail(pI0);
	pForK->AddTail(pSbst);

	pI0 = new CSymbInst("=");
	pI1 = new CSymbInst(sBvct);
	pI2 = new CSymbInst("+");
	pI3 = new CSymbInst(sBvct);
	pI4 = new CSymbInst("-?");
	pI5 = new CSymbInst("*");
	pI6 = new CSymbInst("m");	//----???
	pI7 = new CSymbInst(sBvct);
	pI0->AddTail(pI1);
	pI0->AddTail(pI2);
	pI1->AddTail(new CSymbInst("mJ"));
	pI2->AddTail(pI3);
	pI2->AddTail(pI4);
	pI3->AddTail(new CSymbInst("mJ"));
	pI4->AddTail(pI5);
	pI5->AddTail(pI6);
	pI5->AddTail(pI7);
	pI7->AddTail(new CSymbInst("mI"));
	pSbst = new CPDSubst;
	pSbst->AddTail(pI0);
	pForJ->AddTail(pSbst);

	//--- find the answers
//			for(IJ=MTXSZ ; IJ>=1; IJ--) {
//				RT = BXoT[IJ];
//				for( K=IJ+1 ; K<= MTXSZ ; K++) {
//					RT = RT - MXoT[IJ][K] * FXoT[K];
//				}
//				FXoT[IJ] = RT / MXoT[IJ][IJ];
//			}
//			CPDFor *pFor, *pForJ;
//			CPDForSub *pSb;
			CMSConst *pRt;
//			CSymbInst *pEq, *pI1, *pI2, *pI3, *pI4, *pI5, *pI6;

	CPDFor *pFor;
	CPDForSub *pSb;

	pFor = new CPDFor;
	pSb = new CPDForSub;
	pSb->AddTail(new CSymbInst("mJ"));
	pSb->AddTail(new CSymbInst(sMtxJSz));
	pSb->AddTail(new CMSFract(1));
	pSb->AddTail(new CMSFract(-1));	// ???
	pFor->AddTail(pSb);
	pPrnt->AddTail(pFor);
		
	pRt = new CMSConst();
	pRt->SetName("RT");
	m_pVars->AddTail(pRt);

//				RT = BXoT[IJ];
	pSbst = new CPDSubst;
	pFor->AddTail(pSbst);
	pEq = new CSymbInst("=");
	pSbst->AddTail(pEq);
	pI1 = new CSymbInst("RT");
	pEq->AddTail(pI1);
	pI2 = new CSymbInst(sBvct);
	pEq->AddTail(pI2);
	pI2->AddTail(new CSymbInst("mJ"));
			
//				for( K=IJ+1 ; K<= MTXSZ ; K++) {
//					RT = RT - MXoT[IJ][K] * FXoT[K];
	pForJ = new CPDFor;
	pSb = new CPDForSub;
	pSb->AddTail(new CSymbInst("mI"));
	CSymbInst *pPls;
	pPls = new CSymbInst("+");
	pPls->AddTail(new CSymbInst("mJ"));
	pPls->AddTail(new CMSFract(1));
	pSb->AddTail(pPls);
	pSb->AddTail(new CSymbInst(sMtxJSz));
	pForJ->AddTail(pSb);
	pFor->AddTail(pForJ);

	pSbst = new CPDSubst;
	pForJ->AddTail(pSbst);
	pEq = new CSymbInst("=");
	pSbst->AddTail(pEq);
	pI1 = new CSymbInst("RT");
	pI2 = new CSymbInst("+");
	pEq->AddTail(pI1);
	pEq->AddTail(pI2);
	pI3 = new CSymbInst("-?");
	pI4 = new CSymbInst("*");
	pI2->AddTail(new CSymbInst("RT"));
	pI2->AddTail(pI3);
	pI3->AddTail(pI4);
	pI5 = new CSymbInst(sAmtx);
	pI6 = new CSymbInst(sFvct);
	pI4->AddTail(pI5);
	pI4->AddTail(pI6);
	pI5->AddTail(new CSymbInst("mI"));
	pI5->AddTail(new CSymbInst("mJ"));

	pI6->AddTail(new CSymbInst("mI"));
		
	pSbst = new CPDSubst;
	pFor->AddTail(pSbst);
	pEq = new CSymbInst("=");
	pSbst->AddTail(pEq);
	pI1 = new CSymbInst(sFvct);
	pI2 = new CSymbInst("/");
	pEq->AddTail(pI1);
	pEq->AddTail(pI2);
	pI3 = new CSymbInst("RT");
	pI4 = new CSymbInst(sAmtx);
	pI2->AddTail(pI3);
	pI2->AddTail(pI4);
	pI1->AddTail(new CSymbInst("mJ"));

	pI4->AddTail(new CSymbInst("mJ"));
	pI4->AddTail(new CSymbInst("mJ"));

	POSITION pos;
	int i;
	CRangeOnAxis *pRoX;
	CPDESpaceVar *pSpc;
	CViecFC *pF, *pT, *pE;
	CMSFract *pN;

	pos = pRg->GetHeadPosition();
	for(i=0; pos; i++) {
		pRoX = (CRangeOnAxis *) pRg->GetNext(pos);
		pSpc = (CPDESpaceVar *) pRoX->GetSymbBody()->GetParent();
		if(!pSpc->IsKindOf(RUNTIME_CLASS(CPDESpaceVar))) continue;
		pF = new CMSFract(pRoX->m_pFrom->m_value - rangeBegin[i]);
		pT = new CMSFract(pRoX->m_pTo->m_value - rangeEnd[i]);
		pN = (CMSFract *) pT;
		if(pN->m_value<0) {
			pE = pT;
			pT = new CSymbInst("+");
			pT->AddTail(new CSymbInst(pSpc->m_division->GetName()));
			pT->AddTail(pE);
		} if(pN->m_value==0) {
			delete pT;
			pT = new CSymbInst(pSpc->m_division->GetName());
		}
		CPDFor *pfor = new CPDFor;
		CPad *psub = new CPDForSub;
		CSymbInst *pvar = new CSymbInst(pSpc->m_pIndex->GetName());
		pPrnt->AddTail(pfor);
		pfor->AddTail(psub);
		psub->AddTail(pvar);
		psub->AddTail(pF);
		psub->AddTail(pT);
		pPrnt = pfor;
	}
	m_nShift[0] = m_nShift[1] = 0;
	CalcMtxNoEqtFullMtx(pPrnt, "mJ");
	pSbst = new CPDSubst;
	pPrnt->AddTail(pSbst);
	pEq = new CSymbInst("=");
	pSbst->AddTail(pEq);
//	pI1 = (CSymbInst *) m_pVarLst[m_midPos]->Copy();
	pI1 = (CSymbInst *) m_pVarLst[m_midPos]->Copy();
	pI2 = new CSymbInst(sFvct);
	pI2->AddTail(new CSymbInst("mJ"));
	pEq->AddTail(pI1);
	pEq->AddTail(pI2);
	return TRUE;
}

BOOL CJDCreateProc::CreateFullMtxSlvNum(CViecFC *pPrnt, CSymbInst *pV)
{
	CJDCheckIfEqual check;
	int i;
	CSymbInst *pX, *pY;

	//---	Has this  treated before.
	check.m_bResult=FALSE;
	for(i=0;i<m_varNo;i++) {
		check.m_checked = m_pVarLst[i];
		pV->SendMsg(MSG_DO_JOB, &check);
		if(check.m_bResult) break;
	}
	//---	If it has not yet.
	m_nShift[0] = m_nShift[1] = 0;
	pX = (CSymbInst *) pV->GetChild(1);
	pY = (CSymbInst *) pV->GetChild(2);
	if(pX->GetCount()==2)
		m_nShift[0] = ((CMSFract *) pX->GetChild(1))->m_value;
	if(pY->GetCount()==2)
		m_nShift[1] = ((CMSFract *) pY->GetChild(1))->m_value;
	if(!check.m_bResult) {
		//---	add it into the variable list
		//---	carry out the variable name
		m_pVarLst[m_varNo] = pV;
		m_nameLst[m_varNo].Format("mI%c%c"
			, (char) ((m_nShift[0]<0)? 'Z'+m_nShift[0] : '0'+m_nShift[0])
			, (char) ((m_nShift[1]<0)? 'Z'+m_nShift[1] : '0'+m_nShift[1]));
		//---	If this one is on the diagonal.
		if(m_nShift[0]==0 && m_nShift[1]==0)
			m_midPos = m_varNo;
		//---	create the equation to calculate it out
		CMSIndex *pIndx;
		pIndx = new CMSIndex();
		pIndx->SetName(m_nameLst[m_varNo]);
		m_pVars->AddTail(pIndx);
		//---	increase the number of the list of variable
		m_varNo++;
	}
	int wing = m_nShift[1] * 10 + m_nShift[0];
	if(m_nLeftWing>wing) m_nLeftWing = wing;
	if(m_nRightWing<wing) m_nRightWing = wing;
	CalcMtxNoEqtFullMtx(pPrnt, m_nameLst[i]);
	return TRUE;
}

// equation to calculate matrix subscript
BOOL CJDCreateProc::CalcMtxNoEqtFullMtx(CViecFC *pPrnt, const char *nm)
{
	CSymbInst *pX, *pY, *pZ, *pI, *pTm, *pV;
	CPDSubst *pSbst;

	int ix = m_nShift[0];
	int iy = m_nShift[1] - 1;

	pX = new CSymbInst("i");
	if(ix!=0) {
		pI = new CSymbInst("+");
		pI->AddTail(pX);
		pI->AddTail(new CMSFract(ix));
		pX = pI;
	}
	pY = new CSymbInst("j");
	if(iy!=0) {
		pI = new CSymbInst("+");
		pI->AddTail(pY);
		pI->AddTail(new CMSFract(iy));
		pY = pI;
	}
	pI = new CSymbInst("*");
	pZ = new CSymbInst("+");
	pI->AddTail(new CSymbInst(sMax[0]));
	pI->AddTail(pY);
	pZ->AddTail(pI);
	pZ->AddTail(pX);
	pTm = new CSymbInst(nm);
	pV = new CSymbInst("=");
	pV->AddTail(pTm);
	pV->AddTail(pZ);
	pSbst = new CPDSubst;
	pSbst->AddTail(pV);
	pPrnt->AddTail(pSbst);
	return TRUE;
}

// matrix elements setting.
BOOL CJDCreateProc::CreateMtxSlvSet(CViecFC *pPrnt, CSymbInst *pTm)
{
	CSymbInst *pV, *pEq, *pMx, *pFct;
	int i;
	CJDCheckIfEqual check;

	pEq = pV = NULL;
	if(pTm->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
		if(pTm->GetCount()!=2) return FALSE;
		//---	with a factor
		pFct = (CSymbInst *) pTm->GetChild(0);
		pV = (CSymbInst *) pTm->GetChild(1);
		pEq = new CSymbInst("=");
		pMx = new CSymbInst(sAmtx);
		pEq->AddTail(pMx);
		pEq->AddTail(pFct->Copy());
		//---	Mi,j { What is i? }
	} else if(pTm->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSDepVar))) {
		pV = pTm;
		//---	without a factor
		pEq = new CSymbInst("=");
		pMx = new CSymbInst(sAmtx);
		pEq->AddTail(pMx);
		pEq->AddTail(new CMSFract(1));
		//---	Mi,j { What is i? }
	}
	if(pV) {
		//---	find the variable name
		//---	Mi,j = Factor
		//---	what is j?
		for(i=0;i<m_varNo;i++) {
			check.m_checked = m_pVarLst[i];
			pV->SendMsg(MSG_DO_JOB, &check);
			if(check.m_bResult) {
				break;
			}
		}
	}
	if(pEq) {
		//---	complete the substitution
		CPDSubst *pSbst;
		pSbst = new CPDSubst;
		pSbst->AddTail(pEq);
		pPrnt->AddTail(pSbst);

		pMx->AddTail(new CSymbInst(m_nameLst[i]));
		pMx->AddTail(new CSymbInst("mJ"));
//		pMx->AddTail(new CSymbInst(m_nameLst[m_midPos]));
	}
	return TRUE;
}

BOOL CJDCreateProc::CreateMtxSlv(CViecFC *pPrnt, CViecFC *pL, CViecFC *pR)
{
	CSymbInst *pIL, *pIR, *pV, *pTm, *pEq1, *pMx;
	POSITION pos;
	CPDSubst *pSbst;
	CViecFC *pPrnt0;

	if(!pL->IsKindOf(RUNTIME_CLASS(CSymbInst))) return FALSE;
	if(!pPrnt->IsKindOf(RUNTIME_CLASS(CViecFC))) return FALSE;

	pPrnt0 = pPrnt;
//---	variables declaration
//	pVars = new CPDVar;
//	pPrnt->AddTail(pVars);

	pPrnt = new CPDBlock();
	((CViecFC*)pPrnt)->SetName("Calculating the subscript number");
	((CPad*)pPrnt)->SetMode(CPElem::modeClose);
	pPrnt0->AddTail(pPrnt);

	pIL = (CSymbInst *) pL;	// left side
	pIR = (CSymbInst *) pR;	// right side

	//--- calculate the diagonal elements of matrix
	//--- create the I00 = wd * j + 1
	//---            I10 = wd * (j+1) + 0
	pV = NULL;
	m_nShift[0] = m_nShift[1] = 0;
	CalcMtxNoEqtFullMtx(pPrnt, "mJ");
	//---  only 1 term on left side
	if(pIL->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSDepVar))) {
		pTm = pIL;
		if(pTm->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult)) && pTm->GetCount()==2) {
			// with factor multiplied 
			pV = (CSymbInst *) pTm->GetChild(1);
		} else if(pTm->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSDepVar))) {
			// without factor multiplied 
			pV = pTm;
		}
		if(pV)
			CreateFullMtxSlvNum(pPrnt, pV);
	}
	//---	if left side is like aV+bV+..
	if(pIL->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
		pos = pIL->GetHeadPosition();
		while(pos) {
			pV = NULL;
			pTm = (CSymbInst *) pIL->GetNext(pos);
			if(!pTm->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
			if(pTm->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOMult))) {
				// with factor multiplied 
				if(pTm->GetCount()!=2) continue;
				pV = (CSymbInst *) pTm->GetChild(1);
			} else if(pTm->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSDepVar))) {
				// without factor multiplied 
				pV = pTm;
			}
			if(pV)
				CreateFullMtxSlvNum(pPrnt, pV);
		}
	}
	if(m_midPos<0)
		return FALSE;

	pPrnt = new CPDBlock();
	((CViecFC*)pPrnt)->SetName("matrix element setting");
	((CPad*)pPrnt)->SetMode(CPElem::modeClose);
	pPrnt0->AddTail(pPrnt);

	if(pIL->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
		//---	the substitution statement
		pos = pIL->GetHeadPosition();
		while(pos) {
			pTm = (CSymbInst *) pIL->GetNext(pos);
			if(!pTm->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
			CreateMtxSlvSet(pPrnt, pTm);
		}
	} else if(pIL->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		CreateMtxSlvSet(pPrnt, pIL);
	}
	//---	the right side vector
	pEq1 = new CSymbInst("=");
	pMx = new CSymbInst(sBvct);
	pEq1->AddTail(pMx);
	pEq1->AddTail(pIR->Copy());
	pSbst = new CPDSubst;
	pSbst->AddTail(pEq1);
	pPrnt->AddTail(pSbst);
//	pMx->AddTail(new CSymbInst(m_nameLst[m_midPos]));
	pMx->AddTail(new CSymbInst("mJ"));

	return TRUE;
}

