
#ifndef __JD_PRC_H__
#define __JD_PRC_H__

#ifndef __JD_ALG_H__
#	include "jd_alg.h"
#endif

class AFX_EXT_CLASS CJDCreateMainProc : public CJDAlgManip {
public:
	CPDEMtxDefs *pMtxDefs;
	CPDEAbstProcVis *pVsBox;
	POSITION pos;
	CPDEProcess *pPrc;
	CPDEObject *pObj;
	CPDEInfo *pInfo;
	CPDEDepInfo *pDep;
	CMSIndex *pTimeIndex;
	CPDEProblem *pPrb;
	CPDESolvSet *pSet;
	CJDCheckDepend check;
	CSymbInst *pV, *pN, *pN2;
	CMSFract *pF;
	CMapPtrToPtr checkedAlready;
	void *plvd;
	CPDEObtainedVars *pVars;
	CPDEInvokedProcs *pVPrc;
	int i, oldDepNo;
	CViecFC *pITx;
	CPDEObject *pPrg;
//	CPDProg *pPrg;
	CPDERunSpread *pRun;
	CPDProc *pMain, *pSubst, *pOutput, *pInit;
	CPDProc *pRead, *pM_AVS, *pM_AVS_FLD, *pM_POST;

	FILE *fp;
	BOOL m_GRID,m_AVS,m_POST;

	virtual void MakeSubstProc(CViecFC *);
	virtual void MakeOutputProc(CViecFC *);
	virtual void MakeInitProc(CViecFC *);
	virtual void MakeReadProc(CViecFC *);
	virtual void MakeM_AVS_out_Proc(CViecFC *);
	virtual void MakeM_AVS_FLD_out_Proc(CViecFC *);
	virtual void MakeM_POST_out_Proc(CViecFC *);
	virtual BOOL Do(CObject *);
	virtual BOOL DoCreateSolver(const char *);
};

enum SOLVER_TYPE {
	SOLVER_EXPLICIT,
	SOLVER_FULL_MATRIX_GAUSS,
	SOLVER_BAND_MATRIX_GAUSS,
	SOLVER_BAND_MATRIX_ADI,
	SOLVER_FULL_MATRIX_LU,
	SOLVER_SOR,
};
// AFX_EXT_CLASS:  when this class is used in other projects(module), this should be put.   
class AFX_EXT_CLASS CJDCreateProc : public CJDAlgManip {
public:
	CPDESolvSet *pSlv;
	CPDETarget *pTg;
	CPDEBoundCond *pBcs[20];
	CPDEDepPDE *pPde;
	CPDERange *pRg;
	CSymbInst *pEqt;
	int dim;
	int m_nLeftWing, m_nRightWing, m_nShift[3];
	int rangeBegin[3], rangeEnd[3];
	CPDProc *pSlvProc;
	CViecFC *m_output;
	CString m_name;
	int m_varNo, m_midPos;
	CSymbInst *m_pVarLst[20];
	CString m_nameLst[20];
	CPDVar *m_pVars;
	CJDCreateMainProc *m_pMainProcGen;
	CMSPDEMtx *m_pAm, *m_pBv, *m_pFv;
	CString sAmtx, sBvct, sFvct;
	SOLVER_TYPE m_eSolverType;

	CString sMax[3], sMtxISz, sMtxJSz, sLeftWg, sRightWg, sDiagCol;
	CPDEConstDef *pMxISz, *pMxJSz, *pLeftWg, *pRightWg, *pDiagCol;

	virtual BOOL Do(CObject *);

	BOOL FindStartCond(CSymbInst* pInst);

	BOOL CreateMtxSlvSet(CViecFC *pPrnt, CSymbInst *pEqt);

	BOOL CreateFullMtxSlvNum(CViecFC *pPrnt, CSymbInst *pEqt);
	BOOL CalcMtxNoEqtFullMtx(CViecFC *pPrnt, const char *nm);
	BOOL CalcSkipWdFullMtx();
	void InitFullMatrix();
	BOOL CreateMtxSlv(CViecFC *pPrnt, CViecFC *pL, CViecFC *pR);
	BOOL FullMatrixGaussSlv(CViecFC *);

	BOOL CreateBandMtxSlvNum(CViecFC *pPrnt, CSymbInst *pEqt);
	BOOL CalcMtxNoEqtBandMtx(CViecFC *pPrnt, const char *nm);
	BOOL CalcSkipWdBandMtx();
	void InitBandMatrix();
	BOOL CreateBandMtxSlv(CViecFC *pPrnt, CSymbInst *pL);
	BOOL BandMatrixGaussSlv(CViecFC *);
};

#endif //__JD_PRC_H__
