
#ifndef __JD_UTL_H__
#define __JD_UTL_H__

typedef enum {
	EXP_NOT_RECOGNIZED
	, EXP_PLUS_IN_PLUS	// a+(b+c)+..	->	a+b+c
	, EXP_PLUS_IN_MULT	// a(b+c+..)b..	->	abb+acb
	, EXP_MULT_IN_MULT	// a(bc..)d..	->	abc..d..
	, EXP_NEG_IN_MULT	// a(-b)c..	->	(- abc)
	, EXP_PLUS_IN_NUME	// (a+b+..)/X	->	a/X+b/X+..
	, EXP_PLUS_IN_NEG	// (- (a+b+..)	->	(-a-b-..)
	, EXP_NEG_IN_NEG	/* -(-a) */

	, EXP_DEP_IN_MULT	/* a*b*..*V */
	, EXP_DEP_IN_NEG_MULT	// - a*b*..*V	->	(a*b*..)*V
	, EXP_DEP_IN_NUME_MULT	// (a*b*..*V)/X	->	(a*b*../X)*V
	, EXP_DEP_IN_NEG_NUME_MULT	// (- a*b*..*V)/X	->	(- a*b*../X)*V
	, EXP_X_DIV_BY_Y	//	X/Y	->	1/Y * X
//	, EXP_MULT_DIV_BY_X	//	(a*b*c)/X	->	1/X *a*b*c
//	, EXP_O_NEG_MULT_C_DIV_BY_X	//	(- a*b*c)/X	->	(- 1/X*a*b*c)
//	, EXP_O_NEG_MULT_DIV_BY_X_C	//	(- a*b*c/X)	->	(- 1/X*a*b*c)
} EXP_ENUM;

typedef enum {
	SIMP_NOT_RECOGNIZED
	, SIMP_PLUS_ABLE_FORM2	// 2+a+3+..	->	5+a+..
	, SIMP_MULT_ABLE_FORM1	// 2a3..	->	6*a..

	, SIMP_DIV_ABLE_FORM1	// 1/2	->	(1/2)
	, SIMP_DIV_ABLE_FORM2	// a/(a*b*c*..)	->	1/(a*b*c..)
	, SIMP_DIV_ABLE_FORM3	// (a*b*c*..)/a	->	(a*b*c../1)
	, SIMP_DIV_ABLE_FORM4	// (a*b*c*..)/(a*d*e*..)	(1*b*c*..)/(1*d*e*..)

	, SIMP_PLUS_INT_0	// 0+a+..	->	a+..
	, SIMP_MULT_INT_0	// 0*a*..	->	0
	, SIMP_MULT_INT_1	// 1*a*..	->	a*..
	, SIMP_DIV_BY_1	// a/1	->	a
	, SIMP_NEG_INT		// (-? 1)	->	-1

	, SIMP_MULT_INV_INV	//	1/X*1/Y*a*b	->	1/(X*Y)*a*b
	, SIMP_INV_INV		//  1/(1/X)
	, SIMP_NEG_DIV_NEG	//  (- (- X)/Y)
} SIMP_ENUM;

typedef enum {
	BIND_NOT_RECOGNIZED
	, BIND_PLUS_ABLE_FORM1	// V,(-V),ab..V,(-ab..V) -> V+(-V)+V+aV+(-aV)..
	, BIND_PLUS_ABLE_FORM2	// 2X+2Y+2Z	->	2(X+Y+Z)
} BIND_ENUM;

typedef enum {
	FF_NOT_RECOGNIZED
	, FF_FORM_X	// X {X}
	, FF_FORM_N_X	// -X {X}
	, FF_FORM_F_X	// ab..X {X}
	, FF_FORM_N_F_X	// -ab..X {X}
} FACTOR_FORM;

typedef enum {
	SOLV_TYPE_UNKNOWN
	, SOLV_TYPE_EXPLICIT
	, SOLV_TYPE_IMPLICIT
} SOLV_TYPE;

typedef enum { 
	AF_CANT_BE_RECOGNIZED
	, AF_PART_DIFF_TIME_1
	, AF_PART_DIFF_TIME_2
	, AF_PART_DIFF_SPACE_1
	, AF_PART_DIFF_SPACE_2
	, AF_UPWIND
	, AF_DEP_VAR
} AF_ENUM;

class AFX_EXT_CLASS CTargetDep {
public:
	CMSPhys *m_theDep;
	CMSIndex *m_timeIndex;
	CMSFract m_timeShift;
	int m_number;

	BOOL Copy(CTargetDep *);
	BOOL IsThis(CSymbInst *);
	BOOL IsIncluded(CSymbInst *);
};
	
class AFX_EXT_CLASS CJDAlgManip : public CJobDoer{
	DECLARE_ELEM(CJDAlgManip)
public:
	CJDAlgManip();
	BOOL m_bStartFg;
	int m_cManipCnt;
	CMSFract m_shift[4];
	CTargetDep m_target;
};

class AFX_EXT_CLASS CJDCheckIfEqual : public CJDAlgManip {
public:
	CViecFC *m_checked;
	BOOL m_bResult;
	virtual BOOL Do(CObject *);
};

#endif //__JD_UTL_H__
