// pad.cpp : DLL p̏̒`s܂B
//
#include "stdafx.h"
#include <afxdllx.h>

#include "resource.h"
#include "pad.h"
#include "pad_msg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

//---------------------------------------------------
//
//             PAD DIAGRAM
//
//---------------------------------------------------


int CPad::s_merginX = 5;
int CPad::s_merginY = 2;
int CPad::s_space = 20;

IMPLEMENT_ELEM(CPad, CPElem, 103)
IMPLEMENT_ELEM(CPDSubst, CPad, 104)
IMPLEMENT_ELEM(CPDBlock, CPad, 105)
IMPLEMENT_ELEM(CPadInst, CIElem, 106)
IMPLEMENT_ELEM(CPDProg, CPad, 107)
IMPLEMENT_ELEM(CPDProc, CPDProg, 108)
IMPLEMENT_ELEM(CPDIf, CPad, 109)
IMPLEMENT_ELEM(CPDFor, CPad, 110)
IMPLEMENT_ELEM(CPDComm, CPad, 111)
IMPLEMENT_ELEM(CPDBreak, CPad, 112)
IMPLEMENT_ELEM(CPDCall, CPad, 113)
IMPLEMENT_ELEM(CPDSdLay, CPad, 114)
IMPLEMENT_ELEM(CPDVar, CPad, 115)
IMPLEMENT_ELEM(CPDArgs, CPDVar, 116)
IMPLEMENT_ELEM(CPDArgs2, CPDArgs, 117)
IMPLEMENT_ELEM(CPDForSub, CPad, 118)
IMPLEMENT_ELEM(CPDOutput, CPad, 119)
IMPLEMENT_ELEM(CPDStrcpy, CPad, 120)
IMPLEMENT_ELEM(CPDWhile, CPad, 121)
IMPLEMENT_ELEM(CPDCallBy, CPad, 122)

CIElem *CPad::GetNewInst()
{
	return (CIElem*) new CPadInst;
}

CPad::CPad()
{
	m_bEncap = FALSE;
	m_bZoneFg = FALSE;
	m_bFixed = TRUE;
	SetMode(modeOpen);
}

void CPad::OnDrawDoubleLine(CDC *pdc, const CPoint& p)
{
	////////////////////////////////////
	//--------- Double Line
	CPoint p1( m_RName.right, 0);
	CPoint p2( m_RName.right+s_space, 0);
	p1.Offset(p); p1.Offset(GetOrg());
	p2.Offset(p); p2.Offset(GetOrg());
	SetPen(pdc, PS_SOLID, 2, RGB(0,0,0));
	p1.y -= 3; p2.y -= 3;
	pdc->MoveTo(p1); pdc->LineTo(p2);
	p1.y += 6; p2.y += 6;
	pdc->MoveTo(p1); pdc->LineTo(p2);
	/////////////////////////////////////
}

int CPad::CalcExt(dirMode dir)
{
	POSITION pos;
	CRect extent = m_extent;

	if(GetCount()==0) {
		m_extent = m_RName = CRect(0,-5,10,5);
	} else if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView))) {
		if(dir==dirDown)
			for(pos=GetHeadPosition();pos; ) GetNext(pos)->CalcExt(dir);
		CalcExtClose();
		m_extent = m_RName;
		CalcExtOpen(CPoint(m_extent.right + s_space, 0));
	} else if(!m_bEncap) {
		if(dir==dirDown)
			for(pos=GetHeadPosition();pos; ) GetNext(pos)->CalcExt(dir);
		m_extent = CRect(0,0,0,0);
		CalcExtOpen();
	} else {
		if(dir==dirDown)
			for(pos=GetHeadPosition();pos; ) GetNext(pos)->CalcExt(dir);
		CalcExtClose();
		m_extent = m_RName;
	}
	if(m_extent!=extent) {
		CRect ext = m_extent;
		InvalidateRect(CPoint(0,0));
		m_extent = extent;
		InvalidateRect(CPoint(0,0));
		m_extent = ext;
	}
	if(dir==dirUp && GetParent()) GetParent()->CalcExt(dir);
	
	return 1;
}

int CPad::CalcExtClose()
{
	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent(GetName(), GetNameLen());
	ReleaseDC(pdc);
	m_RName.left = 0;
	m_RName.right = sz.cx;
	m_RName.top = -(sz.cy-1)/2;
	m_RName.bottom = sz.cy/2;
	m_RName.right += s_merginX*2 + 16;
	m_RName.top -= s_merginY + 2;
	m_RName.bottom += s_merginY + 2;
	return 1;
}

int CPad::CalcExtOpen(CPoint &p, int st)
{
	POSITION pos;
	BOOL fstFg = TRUE;
	int i;

	pos = GetHeadPosition();
	for(i=0;i<st;i++)
		GetNext(pos);
	while(pos) {
		CPad *pel = (CPad *) GetNext(pos);
		if(!pel->IsKindOf(RUNTIME_CLASS(CPad)) &&
			!pel->IsKindOf(RUNTIME_CLASS(CPadInst)))
			continue;
		if(!pel->IsKindOf(RUNTIME_CLASS(CPadInst)) && !pel->IsFixed())
			continue;
		CRect ext = pel->GetExtent();
		if(!fstFg) p.y -= ext.top;
		else fstFg = FALSE;
		pel->SetOrg(p);
		p.y += ext.bottom;
		p.y += s_merginY;
		ext = pel->GetRect();
		if(ext.right > m_extent.right) m_extent.right = ext.right;
		if(ext.top < m_extent.top) m_extent.top = ext.top;
		if(ext.bottom > m_extent.bottom) m_extent.bottom = ext.bottom;
	}
	m_extent.left -= s_merginX;
	m_extent.top -= s_merginY;
	m_extent.right += s_merginX;
	m_extent.bottom += s_merginY;
	return 1;
}

void CPad::OnDraw(CDC *pdc, const CPoint& p)
{
	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView))) {
//		DrawFold3D(pdc, p);
		OnDrawDoubleLine(pdc, p);
		OnDrawClose(pdc, p);
		OnDrawOpen(pdc, p);
	} else if(!m_bEncap) {
//		DrawFold3D(pdc, p);
		OnDrawOpen(pdc, p);
	} else {
		OnDrawClose(pdc, p);
	}
}

void CPad::OnDrawClose(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	CRect rct = m_RName;
	rct.left += 1; rct.right -=1;
	rct.bottom -= 1;
	rct.OffsetRect(GetOrg());
	rct.OffsetRect(p);
	SetPen(pdc, PS_SOLID, 2, col);
	pdc->SelectStockObject(NULL_BRUSH);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	pdc->Rectangle(&rct);
	CRect r2 = rct;
	r2.left += 3;
	r2.right -= 3;
	r2.top += 3;
	r2.bottom -= 3;
	SetPen(pdc, PS_SOLID, 1, col);
	pdc->Rectangle(&r2);
	pdc->DrawText(GetName(), GetNameLen(), &rct, DT_CENTER | DT_VCENTER | DT_SINGLELINE);

	pdc->SetTextColor(col);
}

void CPad::OnDrawOpen(CDC *pdc, const CPoint& p, int st)
{
	CPoint p0 = p;
	p0.Offset(GetOrg());
	CPoint p1;
	int i;

	BOOL fstFg = TRUE;
	POSITION pos = GetHeadPosition();
	for(i=0;i<st;i++)
		GetNext(pos)->OnDraw(pdc, p0);
	while(pos) {
		CPad * pel = (CPad *) GetNext(pos);
		if(!pel->IsKindOf(RUNTIME_CLASS(CPad))
			&& !pel->IsKindOf(RUNTIME_CLASS(CPadInst)))
			continue;
		if(!pel->IsKindOf(RUNTIME_CLASS(CPadInst)) && !pel->IsFixed())
//		if(!pel->IsFixed())
			continue;
		if(fstFg) {
			fstFg = FALSE;
			p1 = pel->GetOrg();
			p1.Offset(p0);
			p1.x += 1;
			p1.y += pel->GetRName().bottom;
		} else {
			SetPen(pdc, PS_SOLID, 2, RGB(0,0,0));
			pdc->MoveTo(p1.x, p1.y-3);
			p1 = pel->GetOrg();
			p1.Offset(p0);
			p1.x += 1;
			p1.y += pel->GetRName().top;
			pdc->LineTo(p1.x, p1.y+3);
			p1.y += pel->GetRName().Height();
			pdc->MoveTo(p1);
		}
		pel->OnDraw(pdc, p0);
	}
}


int CPad::OnAccess(CPoint *p)
{
	CMenu *pMenu = GetPopupMenu();
	pMenu->AppendMenu(MF_STRING, 0, GetRuntimeClass()->m_lpszClassName +CString(": ")+ GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT)psub->m_hMenu, "&Default menu");
	AppendDefaultMenu(psub);
	CSuitCase SC;
	SC.m_case = this;
	SC.m_case2 = pMenu;
	SendMsg(MSG_ADD_MENU_FOR_CHILD, &SC);
	TrackPopupMenu(pMenu, GetMenuPoint(p));
	return 0;
}

int CPad::OnCommand(UINT id)
{
	static CStringArray strAry;
	switch(id) {
		case CMD_PAD_NEW_ARG2:
			{
				CSymbInst *pI = new CSymbInst("?");
				AddTail(pI);
				OnCreated();
				GetView()->CalcExt(dirDown);
			}
			return TRUE;
		case CMD_PAD_NEW_ARG:
			{
				CMSIndex *pphys = new CMSIndex;
				AddTail(pphys);
				OnCreated();
				GetView()->CalcExt(dirDown);
			}
			return TRUE;
		case CMD_PAD_NEW_SUBST:
			{
				CPDSubst *psym = new CPDSubst;
				psym->SetName(psym->GetName(), s_nDot, m_nCharSet);
				SetMode(modeOpen);
				AddTail(psym);

				CSymbInst *psi = new CSymbInst("=");
				psym->AddTail(psi);
				CSymbInst *psi1 = new CSymbInst("?");
				CSymbInst *psi2 = new CSymbInst("?");
				psi->AddTail(psi1);
				psi->AddTail(psi2);

				psym->OnCreated();
				psym->SetOrg(t_point);
				psym->SetDragAllow(TRUE);
				CalcExt(dirDown);
				CalcExt();
			}
			return TRUE;
		case CMD_PAD_NEW_PROC:
			{
				CPDProc *psym = new CPDProc;
				SetMode(modeOpen);
				AddTail(psym);
				CPDVar *parg = new CPDArgs;
				psym->AddTail(parg);
				psym->OnCreated();
				psym->SetOrg(t_point);
				psym->SetDragAllow(TRUE);
				GetView()->CalcExt(dirDown);
			}
			return TRUE;
		case CMD_PAD_NEW_IF:
			{
				CPad *pif = new CPDIf;
				CSymbInst *pcond = new CSymbInst("?");
				CPDBlock *pthen = new CPDBlock();
				CPDBlock *pelse = new CPDBlock();
				SetMode(modeOpen);
				AddTail(pif);

				pif->AddTail(pcond);
				pif->AddTail(pthen);
				pif->AddTail(pelse);
				
				pif->OnCreated();
				pif->SetOrg(t_point);
				GetView()->CalcExt(dirDown);
			}
			return TRUE;
		case CMD_PAD_NEW_BLOCK:
			{
				CPDBlock *pblk = new CPDBlock;
				SetMode(modeOpen);
				AddTail(pblk);
				OnCreated();
				GetView()->CalcExt(dirDown);
			}
			return TRUE;
		case CMD_PAD_NEW_FOR:
			{
				CPDFor *pfor = new CPDFor;
				CPad *psub = new CPDForSub;
				CSymbInst *pvar = new CSymbInst("?");
				CSymbInst *pfrom = new CSymbInst("?");
				CSymbInst *pto = new CSymbInst("?");
				SetMode(modeOpen);
				AddTail(pfor);

				pfor->AddTail(psub);
				psub->AddTail(pvar);
				psub->AddTail(pfrom);
				psub->AddTail(pto);
				OnCreated();
				GetView()->CalcExt(dirDown);
			}
			return TRUE;
		case CMD_PAD_NEW_CALL:
			{
				CPDCall *pcall = new CPDCall;
				pcall->AddTail(new CPDArgs2);
				SetMode(modeOpen);
				AddTail(pcall);
				OnCreated();
				GetView()->CalcExt(dirDown);
			}
			return TRUE;
		case CMD_PAD_NEW_VAR:
			{
				CPDVar *pvar = new CPDVar;
				SetMode(modeOpen);
				AddTail(pvar);
				CMSIndex *v1 = new CMSIndex;
				pvar->AddTail(v1);
				OnCreated();
				GetView()->CalcExt(dirDown);
			}
			return TRUE;
/*
		case CMD_PAD_NEW_BRK:
			{
				CEList obLst;
				CSuitCase SC;
				CPElem *pelm;
				POSITION pos;
				CPDEBrkObj *pBrk;
				int i;

				SC.m_runtimeClass = NULL;
				SC.m_oblist = &obLst;
				SC.m_runtimeClass = RUNTIME_CLASS(CPDEBrkObj);
				pelm = this;
				while(pelm && !pelm->IsKindOf(RUNTIME_CLASS(CPDEObjPrg))) {
					if(pelm->GetParent()->IsKindOf(RUNTIME_CLASS(CElemView))) {
						if(pelm->GetInstBody()!=NULL)
							pelm = (CPElem*) pelm->GetInstBody()->GetParent();
						else
							return TRUE;
					} else {
						pelm = (CPElem*) pelm->GetParent();
						if(!pelm->IsKindOf(RUNTIME_CLASS(CPElem))) return TRUE;
					}
				}
				if(!pelm || !pelm->IsKindOf(RUNTIME_CLASS(CPDEObjPrg)))
					return TRUE;
				obLst.RemoveAll();
				pelm->SendMsg(MSG_COLLECT_OBJECT, &SC);
				if(!obLst.GetCount()) return TRUE;
				CMenu *pSmn = GetPopupMenu(TRUE);
				pSmn->AppendMenu(MF_STRING, 0, "Break Object List");
				pSmn->AppendMenu(MF_SEPARATOR);
				pos = obLst.GetHeadPosition();
				strAry.RemoveAll();
				for(i=0; pos; i++) {
					pBrk = (CPDEBrkObj *) obLst.GetNext(pos);
					strAry.Add(pBrk->GetName());
					pSmn->AppendMenu(MF_STRING, CMD_FIND_DEP_RESULT+ i, strAry[i]);
				}
				TrackPopupMenu(pSmn, GetMenuPoint(NULL));
			}
			return TRUE;
			*/
	}
	/*
	int sig2 = id & 0xff00;
	int no = id & 0x00ff;
	switch(sig2) {
	case CMD_FIND_DEP_RESULT:
		{
			if(no>strAry.GetUpperBound()) return TRUE;
			CPDBrkPnt *pBrk = new CPDBrkPnt;
			CSIBrkPnt *pBrk2 = new CSIBrkPnt(strAry[no]);
			AddTail(pBrk);
			pBrk->AddTail(pBrk2);
			OnCreated();
			CalcExt(dirDown);
			CalcExt();
		}
		return TRUE;
	}
	*/

	return CPElem::OnCommand(id);
}

BOOL CPad::AppendDefaultMenu(CMenu *pMenu)
{
	if(!GetParent()->IsKindOf(RUNTIME_CLASS(CElemView))) {
		pMenu->AppendMenu(MF_STRING, CMD_SPLIT, "&split");
		if(m_bEncap)
			pMenu->AppendMenu(MF_STRING, CMD_OPEN, "&open");
		else
			pMenu->AppendMenu(MF_STRING, CMD_CLOSE, "&close");
	} else {
		pMenu->AppendMenu(MF_STRING, CMD_GO_BACK, "&turn back");
	}
	return CGElem::AppendDefaultMenu(pMenu);
}

BOOL CPad::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_CAN_SKIP_ONCREATED_PROC:
//		if(GetMode()==modeClose && !GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
//			((CSuitCase *) el)->m_int = TRUE;
		((CSuitCase *) el)->m_int = FALSE;
		return TRUE;
	}
	return CPElem::SendMsg(msg, el);
}


//-------------------------------------------
/////////////////////////////////////////////
//                                          
//            CPDBlock
//
/////////////////////////////////////////////

int CPDBlock::OnAccess(CPoint *pp)
{
	return CPad::OnAccess(pp);
/*
	CMenu *pMenu = GetPopupMenu();
	pMenu->AppendMenu(MF_STRING, 0, GetRuntimeClass()->m_lpszClassName +CString(": ")+ GetName());
	pMenu->AppendMenu(MF_SEPARATOR);

	CMenu *psub = GetPopupMenu(FALSE);
	if(psub) {
		pMenu->AppendMenu(MF_POPUP, (UINT)psub->m_hMenu, "&Default Menu");
		AppendDefaultMenu(psub);
	}
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_SUBST, "add new &subst");
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_IF, "add new &if");
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_BLOCK, "add new &block");
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_FOR, "add new &for");
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_CALL, "add new &call");
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_VAR, "add new &var");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 0;
*/
}

int CPDBlock::OnCommand(UINT id)
{
	switch(id) {
		case 0:
			return 1;
		default:
			return CPad::OnCommand(id);
	}
	return TRUE;
}

int CPDBlock::CalcExtClose()
{
	CDC *pdc = GetDC();
	if(!pdc) {
		m_extent = CRect(0, -15, s_space, 15);
		return 0;
	}
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent(GetName(), GetNameLen());
	ReleaseDC(pdc);
	m_RName.left = 0;
	m_RName.right = sz.cx;
	m_RName.top = -(sz.cy-1)/2;
	m_RName.bottom = sz.cy/2;
	m_RName.right += s_merginX*2;
	m_RName.top -= s_merginY;
	m_RName.bottom += s_merginY;
	return 1;
}

int CPDBlock::CalcExt(dirMode dir)
{
	POSITION pos;
	CRect extent = m_extent;

	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)) && GetCount()) {
		if(dir==dirDown)
			for(pos=GetHeadPosition();pos; ) GetNext(pos)->CalcExt(dir);
//		CalcExtClose();
//		m_extent = m_RName;
		CalcExtOpen(CPoint(5, 0));
	} else if(!m_bEncap && GetCount()) {
		if(dir==dirDown)
			for(pos=GetHeadPosition();pos; ) GetNext(pos)->CalcExt(dir);
		m_extent = CRect(0,0,0,0);
		CalcExtOpen();
		m_extent.left -= s_merginX;
		m_extent.right += s_merginX;
		m_extent.top -= s_merginY;
		m_extent.bottom += s_merginY;
	} else if(GetCount()) {
		if(dir==dirDown)
			for(pos=GetHeadPosition();pos; ) GetNext(pos)->CalcExt(dir);
		CalcExtClose();
		m_extent = m_RName;
	} else {
		m_extent = m_RName = CRect(0,-6, 16, 6);
	}
	if(m_extent!=extent) {
		CRect ext = m_extent;
		InvalidateRect(CPoint(0,0));
		m_extent = extent;
		InvalidateRect(CPoint(0,0));
		m_extent = ext;
	}
	if(dir==dirUp && GetParent()) GetParent()->CalcExt(dir);
	
	return TRUE;
}

void CPDBlock::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	if(!m_bEncap && GetCount()) {
		CRect rct = GetRect();
		rct.OffsetRect(p);
		pdc->SelectStockObject(NULL_BRUSH);
		SetPen(pdc, PS_DOT, 1, col);
		pdc->Rectangle(&rct);
		OnDrawOpen(pdc, p);
	} else if(GetCount()) {
		CRect rct = m_RName;
		rct.left += 1; rct.right -=1;
		rct.bottom -= 1;
		rct.OffsetRect(GetOrg());
		rct.OffsetRect(p);
		pdc->SetTextColor(col);
		SetPen(pdc, PS_SOLID, 2, col);
		pdc->SelectStockObject(NULL_BRUSH);
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
		pdc->Rectangle(&rct);
		pdc->DrawText(GetName(), lstrlen(GetName()), &rct, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		pdc->SetTextColor(RGB(0,0,0));
		SetPen(pdc, PS_SOLID, 1, RGB(0,0,0));
	} else {
		pdc->SelectStockObject(NULL_BRUSH);
		SetPen(pdc, PS_SOLID, 1, col);
		CRect rct = m_RName;
		rct.OffsetRect(GetOrg());
		rct.OffsetRect(p);
		pdc->Rectangle(&rct);
	}
}

//-------------------------------------------
/////////////////////////////////////////////
//                                          
//            CPDSubst
//
/////////////////////////////////////////////


CPDSubst::CPDSubst()
{
	m_bEncap = FALSE;
}

int CPDSubst::CalcExt(dirMode dir)   // Calculation extent.
{
	InvalidateRect(CPoint(0,0));
	POSITION pos = GetHeadPosition();
	int y = 0;
	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView))
	   || !m_bEncap) {
		while(pos) {
			CViecFC *pel = GetNext(pos);
			if(pel==NULL) return 0;
			if(dir==dirDown)
				pel->CalcExt(dir);
			pel->GetExtent();
			if(y==0) {
				pel->SetOrg(CPoint(s_merginX, y));
				y = pel->GetExtent().top;
			} else {
				y -= pel->GetExtent().top;
				pel->SetOrg(CPoint(s_merginX, y));
			}
			y += pel->GetExtent().Height();
		}
		CViecFC::CalcExt(dirNot);
		m_extent.right += s_merginX * 2;
		m_extent.top -= s_merginY;
		m_extent.bottom += s_merginY;
		m_RName = m_extent;
	} else {
		CalcExtClose();
		m_extent = m_RName;
	}
	if(dir==dirUp && GetParent())
		GetParent()->CalcExt(dir);
	InvalidateRect(CPoint(0,0));
	return 1;
}

void CPDSubst::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	//---------  Box around ---
	CRect r = GetRect();
	r.OffsetRect(p);
	r.left += 1; r.right -=1;
	SetPen(pdc, PS_SOLID, 2, col);
	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView))
	   || !m_bEncap) {
		pdc->SelectStockObject(NULL_BRUSH);
		pdc->Rectangle(&r);
		CViecFC::OnDrawChild(pdc, p);
	} else {
		OnDrawClose(pdc, p);
	}
}

BOOL CPDSubst::SendMsg(int msg, CObject* el)
{
	switch(msg) {
		case MSG_CAN_THIS_DISAPPEAR:
			if(GetCount())
				return TRUE;
			return FALSE;
	}
	return CPad::SendMsg(msg, el);
}

/////////////////////////////////////////////////////////////////////////
//
// CPadInst
//
/////////////////////////////////////////////////////////////////////////


CPadInst::CPadInst()
{
	m_bEncap = TRUE;
	SetDragAllow(TRUE);
}

int CPadInst::CalcExt(dirMode dir)
{
	CSize sz;
	CDC *pdc = GetDC();
	if(!pdc) {
		m_extent = CRect(0, -15, CPad::s_space, 15);
		return 0;
	}
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	sz = pdc->GetTextExtent(GetName(), lstrlen(GetName()));
	ReleaseDC(pdc);
	m_extent.left = 0;
	m_extent.right = sz.cx;
	m_extent.top = -(sz.cy-1)/2;
	m_extent.bottom = sz.cy/2;

	m_extent.right += CPad::s_merginX*2 + 16;
	m_extent.top -= CPad::s_merginY + 3;
	m_extent.bottom += CPad::s_merginY + 3;
	if(dir==dirUp && GetParent())
		GetParent()->CalcExt(dir);
	return 1;
}

void CPadInst::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	CRect rct = GetExtent();
	rct.left += 1; rct.right -=1;
	rct.bottom -= 1;
	rct.OffsetRect(p);
	rct.OffsetRect(GetOrg());
	pdc->SetTextColor(col);
	SetPen(pdc, PS_SOLID, 2, col);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	pdc->SelectStockObject(NULL_BRUSH);
	pdc->Rectangle(&rct);
	CRect r2 = rct;
	rct.left += 3;
	rct.right -= 3;
	rct.top += 3;
	rct.bottom -= 3;
	SetPen(pdc, PS_SOLID, 1, col);
	pdc->Rectangle(&rct);
	pdc->DrawText(GetName(), lstrlen(GetName()), &r2, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
}

//////////////////////////////////////////////////////////////////////////
//
//         CPDProg
//
//////////////////////////////////////////////////////////////////////////


void CPDProg::OnDrawClose(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	CRect rct = m_RName;
	rct.left += 1; rct.right -=1;
	rct.bottom -= 1;
	rct.OffsetRect(GetOrg());
	rct.OffsetRect(p);
	pdc->SetTextColor(col);
	SetPen(pdc, PS_SOLID, 2, col);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	pdc->SelectStockObject(NULL_BRUSH);
	pdc->Rectangle(&rct);
	CRect r2 = rct;
	rct.left += 4;
	rct.right -= 4;
	pdc->Rectangle(&rct);
	pdc->DrawText(GetName(), lstrlen(GetName()), &r2, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
}

int CPDProg::CalcExt(dirMode dir)
{
	POSITION pos;
	CRect extent = m_extent;

	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)) || !m_bEncap) {
		if(dir==dirDown)
			for(pos=GetHeadPosition();pos; ) GetNext(pos)->CalcExt(dir);
		CalcExtClose();
		m_extent = m_RName;
		CalcExtOpen(CPoint(0 /*m_extent.right + s_space*/, m_extent.bottom + s_merginY + 10));
	} else {
		if(dir==dirDown)
			for(pos=GetHeadPosition();pos; ) GetNext(pos)->CalcExt(dir);
		CalcExtClose();
		m_extent = m_RName;
	}
	if(m_extent!=extent) {
		CRect ext = m_extent;
		InvalidateRect(CPoint(0,0));
		m_extent = extent;
		InvalidateRect(CPoint(0,0));
		m_extent = ext;
	}
	if(dir==dirUp && GetParent()) GetParent()->CalcExt(dir);
	
	return 1;
}

int CPDProg::OnAccess(CPoint *p)
{
	CMenu *pMenu = GetPopupMenu();
	pMenu->AppendMenu(MF_STRING, 0, GetRuntimeClass()->m_lpszClassName +CString(": ")+ GetName());
	pMenu->AppendMenu(MF_SEPARATOR);

	CMenu *psub = GetPopupMenu(FALSE);
	if(psub) {
		pMenu->AppendMenu(MF_POPUP, (UINT)psub->m_hMenu, "&Default Menu");
		AppendDefaultMenu(psub);
	}

	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_PROC, "&add new procedure");
	TrackPopupMenu(pMenu, GetMenuPoint(p));
	return 1;
}

int CPDProg::OnCommand(UINT id)
{
	switch(id) {
		case 0:
			return 0;
		default:
			return CPad::OnCommand(id);
	}
	return 0;
}

void CPDProg::OnDraw(CDC *pdc, const CPoint& p)
{
	if( (GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)) || !m_bEncap) && GetCount()) {
		COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
		CRect rct = GetRect();
		rct.OffsetRect(p);
		pdc->SelectStockObject(NULL_BRUSH);
		SetPen(pdc, PS_SOLID, 1, col);
		pdc->SetTextColor(col);
		pdc->TextOut(rct.left+2, rct.top+2, GetName());
		pdc->Rectangle(&rct);
		OnDrawChild(pdc, p);
	} else {
		OnDrawClose(pdc, p);
	}
}

//////////////////////////////////////////////////////////////////////////
//
//         CPDProc
//
//////////////////////////////////////////////////////////////////////////

BOOL CPDProc::SendMsg(int msg, CObject* el)
{
	switch(msg) {
		case MSG_CAN_THIS_DISAPPEAR:
			{
				if(GetCount()<=1)
					return FALSE;
				POSITION pos = GetHeadPosition();
				CViecFC *pe = GetNext(pos);
				if(pe==el)
					return FALSE;
			}
			return TRUE;
	}
	return CPad::SendMsg(msg, el);
}

int CPDProc::OnAccess(CPoint *p)
{
	return CPad::OnAccess(p);
/*
	CMenu *pMenu = GetPopupMenu();
	pMenu->AppendMenu(MF_STRING, 0, GetRuntimeClass()->m_lpszClassName +CString(": ")+ GetName());
	pMenu->AppendMenu(MF_SEPARATOR);

	CMenu *psub = GetPopupMenu(FALSE);
	if(psub) {
		pMenu->AppendMenu(MF_POPUP, (UINT)psub->m_hMenu, "&Default Menu");
		AppendDefaultMenu(psub);
	}
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_SUBST, "add new &subst");
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_IF, "add new &if");
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_BLOCK, "add new &block");
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_FOR, "add new &for");
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_CALL, "add new &call");
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_VAR, "add new &var");

	TrackPopupMenu(pMenu, GetMenuPoint(p));
	return 1;
*/}

int CPDProc::OnCommand(UINT id)
{
	switch(id) {
		case 0:
			return TRUE;
		default:
			return CPad::OnCommand(id);
	}
	return 0;
}

void CPDProc::OnDrawClose(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	CRect rct = m_RName;

	rct.left += 1; rct.right -=1;
	rct.bottom -= 1;
	rct.OffsetRect(GetOrg());
	rct.OffsetRect(p);
	SetPen(pdc, PS_SOLID, 2, col);
	pdc->SelectStockObject(NULL_BRUSH);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	pdc->SetTextColor(col);
	pdc->Rectangle(&rct);

	SetPen(pdc, PS_SOLID, 1, col);
	pdc->MoveTo(rct.left+3, rct.top);
	pdc->LineTo(rct.left+3, rct.bottom);
	pdc->MoveTo(rct.right-5, rct.top);
	pdc->LineTo(rct.right-5, rct.bottom);

	CPoint p0 = p;
	p0.Offset(GetOrg());
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent(GetName(), lstrlen(GetName()));
	p0.x += 8 + s_merginX;
	pdc->TextOut(p0.x, p0.y-sz.cy/2, GetName());

	POSITION pos;
	pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	CPoint pp = p;
	pp.Offset(GetOrg());
	parg->OnDraw(pdc, pp);

	pdc->SetTextColor(col);
}

int CPDProc::CalcExtClose()
{
	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent(GetName(), lstrlen(GetName()));
	ReleaseDC(pdc);

	POSITION pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	parg->SetOrg(CPoint(8 + s_merginX + sz.cx, 0));
	m_RName.left = 0;
	m_RName.right = sz.cx;
	m_RName.top = -(sz.cy-1)/2;
	m_RName.bottom = sz.cy/2;
	m_RName.right += s_merginX*2 + 16 + parg->GetExtent().Width();
	m_RName.top -= s_merginY + 2;
	m_RName.bottom += s_merginY + 2;

	return 1;
}

int CPDProc::CalcExt(dirMode dir)
{
	POSITION pos;
	CRect extent = m_extent;

	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)) || !m_bEncap) {
		if(dir==dirDown)
			for(pos=GetHeadPosition();pos; ) GetNext(pos)->CalcExt(dir);
		CalcExtClose();
		pos = GetHeadPosition();
		CPDArgs *parg = (CPDArgs *) GetNext(pos);
//		parg->SetOrg(CPoint(m_RName.));
		m_extent = m_RName;
		CalcExtOpen(CPoint(m_extent.right + s_space, 0));
	} else {
		if(dir==dirDown)
			for(pos=GetHeadPosition();pos; ) GetNext(pos)->CalcExt(dir);
		CalcExtClose();
		m_extent = m_RName;
	}
	if(m_extent!=extent) {
		CRect ext = m_extent;
		InvalidateRect(CPoint(0,0));
		m_extent = extent;
		InvalidateRect(CPoint(0,0));
		m_extent = ext;
	}
	if(dir==dirUp && GetParent()) GetParent()->CalcExt(dir);
	
	return 1;
}

void CPDProc::OnDraw(CDC *pdc, const CPoint& p)
{
	CPoint p0 = p;
	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)) || !m_bEncap) {
//		DrawFold3D(pdc, p);
		if(GetCount()>1)
			OnDrawDoubleLine(pdc, p0);
		OnDrawClose(pdc, p0);
		OnDrawOpen(pdc, p0);
	} else {
		OnDrawClose(pdc, p0);
	}
}



///////////////////////////////////////////
//
//         CPDProc
//
///////////////////////////////////////////

int CPDIf::CalcExt(dirMode dir)
{
	POSITION pos;
	CRect extent = m_extent;

	m_bEncap = FALSE;
	if(dir==dirDown)
		for(pos=GetHeadPosition();pos; ) GetNext(pos)->CalcExt(dir);
	if(GetCount()==3) {
		pos = GetHeadPosition();
		CViecFC *pCond = GetNext(pos);
		CViecFC *pThen = GetNext(pos);
		CViecFC *pElse = GetNext(pos);
		m_RName = pCond->GetExtent();
		m_RName.top += - s_merginY;
		m_RName.bottom += s_merginY;
		int hg = m_RName.Height();
//		if(hg > m_RName.right)
//			hg = m_RName.right;
		m_inedge = hg * 30 /100;

		m_RName.right += s_merginX * 2 + m_inedge;
		pCond->SetOrg(CPoint(s_merginX, 0));
		pThen->SetOrg(CPoint(m_RName.right + s_space, m_RName.top));

		int hh = pThen->GetExtent().bottom;
		hh += m_inedge - pElse->GetExtent().top;
		if(hh > m_RName.Height())
			pElse->SetOrg(CPoint(m_RName.right + s_space, hh + m_RName.top));
		else
			pElse->SetOrg(CPoint(m_RName.right + s_space, m_RName.bottom));

		CViecFC::CalcExt(dirNot);
		if(m_RName.left<m_extent.left)	m_extent.left = m_RName.left;
		if(m_RName.right>m_extent.right)	m_extent.right = m_RName.right;
		if(m_RName.top<m_extent.top)	m_extent.top = m_RName.top;
		if(m_RName.bottom>m_extent.bottom)	m_extent.bottom = m_RName.bottom;

	} else {
		m_RName = m_extent = CRect(0,-10, 10, 10);
	}

	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView))) {
		m_extent.left -= 6;
		m_extent.top -= 6;
		m_extent.right += 6;
		m_extent.bottom += 6;
	}
	if(dir==dirUp && GetParent())
		GetParent()->CalcExt(dir);
	return 1;
}

void CPDIf::OnDraw(CDC *pdc, const CPoint& p)
{
//	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
//		DrawFold3D(pdc, p);
	CPoint p0 = p;
	p0.Offset(GetOrg());
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	if(GetCount()==3) {
		POSITION pos = GetHeadPosition();
		CViecFC *pCond = GetNext(pos);
		CViecFC *pThen = GetNext(pos);
		CViecFC *pElse = GetNext(pos);
		CPoint p1( m_RName.right, m_RName.top+1);
		CPoint p2( m_RName.right, m_RName.bottom-1);
		p1.Offset(p0);
		p2.Offset(p0);

		CPoint p3 = pThen->GetOrg();
		p3.y += 1;
		p3.Offset(p0);
		
		SetPen(pdc, PS_SOLID, 2, RGB(0,0,0));
		pdc->MoveTo(p1);
		pdc->LineTo(p3);

		CPoint p4 = pElse->GetOrg();
		p4.y -= 1;
		p4.Offset(p0);

		if(p2.y==p4.y) {
			pdc->MoveTo(p2);
			pdc->LineTo(p4);
		} else {
			CPoint p0;
			pdc->MoveTo(p2);
			p0 = CPoint((p2.x+p4.x)/2, p2.y);
			pdc->LineTo(p0);
			p0.y = p4.y;
			pdc->LineTo(p0);
			pdc->LineTo(p4);
		}
	}

	CRect rct = m_RName;
	rct.OffsetRect(p0);
	rct.left += 1; rct.right -= 1;
	rct.bottom -= 1;

	SetPen(pdc, PS_SOLID, 2, col);
	pdc->MoveTo(rct.left, rct.top);
	pdc->LineTo(rct.right, rct.top);
	pdc->LineTo(rct.right-m_inedge+1, p0.y);
	pdc->LineTo(rct.right, rct.bottom);
	pdc->LineTo(rct.left, rct.bottom);
	pdc->LineTo(rct.left, rct.top);

	OnDrawChild(pdc, p);
}

BOOL CPDIf::SendMsg(int msg, CObject* el)
{
	switch(msg) {
		case MSG_CAN_THIS_DISAPPEAR:
			return FALSE;
	}
	return CPad::SendMsg(msg, el);
}

////////////// CPDWhile /////////////////////
////////////// CPDWhile ////////////////////
int CPDWhile::CalcExt(dirMode dir)
{
	POSITION pos;
	CRect extent = m_extent;

	m_bEncap = FALSE;
	if(dir==dirDown)
		for(pos=GetHeadPosition();pos; ) GetNext(pos)->CalcExt(dir);
	if(GetCount()==2) {
		pos = GetHeadPosition();
		CViecFC *pCond = GetNext(pos);
		CViecFC *pThen = GetNext(pos);
		//CViecFC *pElse = GetNext(pos);
		m_RName = pCond->GetExtent();
		m_RName.top += - s_merginY;
		m_RName.bottom += s_merginY;
		int hg = m_RName.Height();
//		if(hg > m_RName.right)
//			hg = m_RName.right;
		m_inedge = hg * 30 /100;

		m_RName.right += s_merginX * 2 + m_inedge;
		pCond->SetOrg(CPoint(s_merginX, 0));
		pThen->SetOrg(CPoint(m_RName.right + s_space, m_RName.top));

		int hh = pThen->GetExtent().bottom;
		//hh += m_inedge - pElse->GetExtent().top;
		/*
		if(hh > m_RName.Height())
			pElse->SetOrg(CPoint(m_RName.right + s_space, hh + m_RName.top));
		else
			pElse->SetOrg(CPoint(m_RName.right + s_space, m_RName.bottom));
		*/

		CViecFC::CalcExt(dirNot);
		if(m_RName.left<m_extent.left)	m_extent.left = m_RName.left;
		if(m_RName.right>m_extent.right)	m_extent.right = m_RName.right;
		if(m_RName.top<m_extent.top)	m_extent.top = m_RName.top;
		if(m_RName.bottom>m_extent.bottom)	m_extent.bottom = m_RName.bottom;

	} else {
		m_RName = m_extent = CRect(0,-10, 10, 10);
	}

	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView))) {
		m_extent.left -= 6;
		m_extent.top -= 6;
		m_extent.right += 6;
		m_extent.bottom += 6;
	}
	if(dir==dirUp && GetParent())
		GetParent()->CalcExt(dir);
	return 1;
}

void CPDWhile::OnDraw(CDC *pdc, const CPoint& p)
{
//	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
//		DrawFold3D(pdc, p);
	CPoint p0 = p;
	p0.Offset(GetOrg());
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	if(GetCount()==2) {
		POSITION pos = GetHeadPosition();
		CViecFC *pCond = GetNext(pos);
		CViecFC *pThen = GetNext(pos);
		//CViecFC *pElse = GetNext(pos);
		CPoint p1( m_RName.right, m_RName.top+1);
		CPoint p2( m_RName.right, m_RName.bottom-1);
		p1.Offset(p0);
		p2.Offset(p0);

		CPoint p3 = pThen->GetOrg();
		p3.y += 1;
		p3.Offset(p0);
		
		SetPen(pdc, PS_SOLID, 2, RGB(0,0,0));
		pdc->MoveTo(p1);
		pdc->LineTo(p3);

		/*
		CPoint p4 = pElse->GetOrg();
		p4.y -= 1;
		p4.Offset(p0);

		if(p2.y==p4.y) {
			pdc->MoveTo(p2);
			pdc->LineTo(p4);
		} else {
			CPoint p0;
			pdc->MoveTo(p2);
			p0 = CPoint((p2.x+p4.x)/2, p2.y);
			pdc->LineTo(p0);
			p0.y = p4.y;
			pdc->LineTo(p0);
			pdc->LineTo(p4);
		}
		*/
	}

	CRect rct = m_RName;
	rct.OffsetRect(p0);
	rct.left += 1; rct.right -= 1;
	rct.bottom -= 1;

	SetPen(pdc, PS_SOLID, 2, col);
	pdc->MoveTo(rct.left, rct.top);
	pdc->LineTo(rct.right, rct.top);
	pdc->LineTo(rct.right-m_inedge+1, p0.y);
	pdc->LineTo(rct.right, rct.bottom);
	pdc->LineTo(rct.left, rct.bottom);
	pdc->LineTo(rct.left, rct.top);

	OnDrawChild(pdc, p);
}

BOOL CPDWhile::SendMsg(int msg, CObject* el)
{
	switch(msg) {
		case MSG_CAN_THIS_DISAPPEAR:
			return FALSE;
	}
	return CPad::SendMsg(msg, el);
}
////////////////////////////////////////////
/////////////////////////////////////////////
//                                          
//            CPDSdLay
//
/////////////////////////////////////////////


int CPDSdLay::CalcExt(dirMode dir)
{
	CPoint co(0,0);
	POSITION pos;
	CViecFC * pel;
	CSize sz1,sz2;
	CDC *pdc;

	pdc = GetDC();
	if(!pdc) return 0;
	sz1 = pdc->GetTextExtent("=",1);
	sz2 = pdc->GetTextExtent("=",1);
	ReleaseDC(pdc);

	pos = GetHeadPosition();
	while(pos) {
		pel = GetNext(pos);
		if(dir==dirDown)
			pel->CalcExt(dir);
		pel->SetOrg(co);
		co.x += pel->GetExtent().Width();
		co.x += sz1.cx;
	}
	CViecFC::CalcExt(dirNot);
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	return 1;
}

void CPDSdLay::OnDraw(CDC *pdc, const CPoint& p)
{
	OnDrawChild(pdc, p);
}


/////////////////////////////////////////////
//                                          
//            CPDVar
//
/////////////////////////////////////////////


CPDVar::CPDVar()
{
	m_bFindFirst = TRUE;
//	m_bFixed = FALSE;
}

int CPDVar::CalcExt(dirMode dir)
{
	CPoint co(0, 0);
	POSITION pos;
	CViecFC *pel;
	CRect ext = m_extent;

	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), FALSE);
	CSize szComma = pdc->GetTextExtent(",", 1);
//	CSize szBrack = pdc->GetTextExtent("(", 1);
	ReleaseDC(pdc);

	co.x += s_merginX; //szBrack.cx;
	pos = GetHeadPosition();
	while(pos) {
		pel = GetNext(pos);
		if(dir==dirDown)
			pel->CalcExt(dir);
		pel->SetOrg(co);
		co.x += pel->GetExtent().Width();
		co.x += szComma.cx;
	}
	CViecFC::CalcExt(dirNot);
	m_extent.left = 0;
	m_extent.right += s_merginX;
	m_extent.top -= s_merginY-2;
	m_extent.bottom += s_merginY-2;
	m_RName = m_extent;
	
	if(GetCount()==0)
		m_extent = m_RName = CRect(0,-6, 16, 6);
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return 1;
/*
	CPoint co(s_merginX, 0);
	POSITION pos;
	CViecFC *pel;

	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView))
	   || !m_bEncap) {
		pos = GetHeadPosition();
		while(pos) {
			pel = GetNext(pos);
			if(dir==dirDown)
				pel->CalcExt(dir);
			pel->SetOrg(co);
			co.x += pel->GetExtent().Width();
			co.x += s_merginX;
		}
		CViecFC::CalcExt(dirNot);
		m_extent.right += s_merginX;
		m_extent.top -= s_merginY;
		m_extent.bottom += s_merginY;
		m_RName = m_extent;
	} else {
		CalcExtClose();
		m_extent = m_RName;
	}
	if(!IsFixed())
		m_extent = CRect(0,0,0,0);
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	return 1;
*/
}

void CPDVar::OnDraw(CDC *pdc, const CPoint& p)
{
	CPoint p0 = p;
	p0.Offset(GetOrg());
	CRect r = GetExtent();
	r.OffsetRect(p0);

	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, FALSE);
	CSize szComma = pdc->GetTextExtent(",", 1);

	r.left++;
	pdc->SelectStockObject(NULL_BRUSH);
	SetPen(pdc, PS_SOLID, 2, col);
	pdc->SetTextColor(col);
	pdc->Rectangle(&r);

	POSITION pos = GetHeadPosition();
	if(pos) GetNext(pos);
	while(pos) {
		CViecFC *pelm = GetNext(pos);
		CPoint ppnt = pelm->GetOrg();
		pdc->TextOut(p0.x+ppnt.x-szComma.cx, p0.y-szComma.cy/2, ",");
	}
	CViecFC::OnDrawChild(pdc, p);
/*
	CRect r = GetRect();
	r.OffsetRect(p);
	r.left += 1; r.right -=1;
	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView))
	   || !m_bEncap) {
		COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
		CRect rct = r;
		pdc->SelectStockObject(NULL_BRUSH);
		SetPen(pdc, PS_SOLID, 2, col);
		pdc->SetTextColor(col);
		pdc->Rectangle(&r);
		CViecFC::OnDrawChild(pdc, p);
	} else {
		OnDrawClose(pdc, p);
	}
*/
}

int CPDVar::OnAccess(CPoint *pp)
{
	return CPad::OnAccess(pp);
/*
	CMenu *pMenu = GetPopupMenu();
	pMenu->AppendMenu(MF_STRING, 0, GetRuntimeClass()->m_lpszClassName +CString(": ")+ GetName());
	pMenu->AppendMenu(MF_SEPARATOR);

	CMenu *psub = GetPopupMenu(FALSE);
	if(psub) {
		pMenu->AppendMenu(MF_POPUP, (UINT)psub->m_hMenu, "&Default Menu");
		AppendDefaultMenu(psub);
	}
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_ARG, "add new &arg");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 0;
*/
}


/////////////////////////////////////////////
//                                          
//            CPDForSub
//
/////////////////////////////////////////////

int CPDForSub::CalcExt(dirMode dir)
{
	CPoint co(0,0);
	POSITION pos;
	CSize sz1,sz2,sz3;
	CDC *pdc;
	CViecFC *psb[4];
	int i;

	pdc = GetDC();
	if(!pdc) return 0;
	SetFont(pdc, 20, "Times New Roman", ANSI_CHARSET);
	sz1 = pdc->GetTextExtent("=",1);
	sz2 = pdc->GetTextExtent(" to ",4);
	sz3 = pdc->GetTextExtent(" step ",6);
	ReleaseDC(pdc);

	pos=GetHeadPosition();
	for(i=0;pos && i<4;i++) {
		psb[i] = GetNext(pos);
		if(dir==dirDown)
			psb[i]->CalcExt(dir);
	}
	psb[0]->SetOrg(co);
	co.x += psb[0]->GetExtent().Width();
	co.x += sz1.cx;
	psb[1]->SetOrg(co);
	co.x += psb[1]->GetExtent().Width();
	co.x += sz2.cx;
	psb[2]->SetOrg(co);
	if(i>=4) {
		co.x += psb[2]->GetExtent().Width();
		co.x += sz3.cx;
		psb[3]->SetOrg(co);
	}

	CViecFC::CalcExt(dirNot);
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	return 1;
}

void CPDForSub::OnDraw(CDC *pdc, const CPoint& p)
{
	CViecFC *psb[4];
	CSize sz1,sz2,sz3;
	POSITION pos;
	CPoint p0,p1;
	int i;

	p0 = GetOrg();
	p0.Offset(p);

	pos=GetHeadPosition();
	for(i=0;pos && i<4;i++)
		psb[i] = GetNext(pos);
//	SetFont(pdc, 20, "Times New Roman", ANSI_CHARSET);
	sz1 = pdc->GetTextExtent("=",1);
	sz2 = pdc->GetTextExtent(" to ",4);
	sz3 = pdc->GetTextExtent(" step ",6);

	if(m_bFocus) {
		CRect rct = GetRect();
		rct.OffsetRect(p);
		pdc->SelectStockObject(NULL_BRUSH);
		pdc->SelectStockObject(BLACK_PEN);
		pdc->Rectangle(&rct);
	}

	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	pdc->SetTextColor(col);

	p1=p0;
	p1.Offset(psb[1]->GetOrg());
	p1.Offset(-sz1.cx, -sz1.cy/2);
	pdc->TextOut(p1.x, p1.y, "=");

	p1=p0;
	p1.Offset(psb[2]->GetOrg());
	p1.Offset(-sz2.cx, -sz2.cy/2);
	pdc->TextOut(p1.x, p1.y, " to ");

	if(i>=4) {
		p1=p0;
		p1.Offset(psb[3]->GetOrg());
		p1.Offset(-sz3.cx, -sz3.cy/2);
		pdc->TextOut(p1.x, p1.y, " step ");
	}

	OnDrawChild(pdc, p);
}

BOOL CPDForSub::SendMsg(int msg, CObject* el)
{
	switch(msg) {
		case MSG_CAN_THIS_DISAPPEAR:
			return FALSE;
	}
	return CPad::SendMsg(msg, el);
}

BOOL CPDFor::SendMsg(int msg, CObject* el)
{
	switch(msg) {
		case MSG_CAN_THIS_DISAPPEAR:
			{
				if(GetCount()<=1)
					return FALSE;
				POSITION pos = GetHeadPosition();
				CViecFC *pe = GetNext(pos);
				if(pe==el)
					return FALSE;
			}
			return TRUE;
	}
	return CPad::SendMsg(msg, el);
}

int CPDFor::CalcExt(dirMode dir)
{
	POSITION pos;
	CRect extent = m_extent;

	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)) || !m_bEncap) {
		if(dir==dirDown)
			for(pos=GetHeadPosition();pos; ) GetNext(pos)->CalcExt(dir);
		CalcExtClose();
		m_extent = m_RName;
		CalcExtOpen(CPoint(m_extent.right + s_space, 0), 1);
	} else {
		if(dir==dirDown)
			for(pos=GetHeadPosition();pos; ) GetNext(pos)->CalcExt(dir);
		CalcExtClose();
		m_extent = m_RName;
	}
	if(m_extent!=extent) {
		CRect ext = m_extent;
		InvalidateRect(CPoint(0,0));
		m_extent = extent;
		InvalidateRect(CPoint(0,0));
		m_extent = ext;
	}
	if(dir==dirUp && GetParent()) GetParent()->CalcExt(dir);
	
	return 1;
}

void CPDFor::OnDraw(CDC *pdc, const CPoint& p)
{
	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)) || !m_bEncap) {
//		if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
//			DrawFold3D(pdc, p);
		CPoint p1( m_RName.right, 0);
		CPoint p2( m_RName.right+s_space, 0);
		p1.Offset(p); p1.Offset(GetOrg());
		p2.Offset(p); p2.Offset(GetOrg());

		SetPen(pdc, PS_SOLID, 2, RGB(0,0,0));
		if(GetCount()>=2) {
			pdc->MoveTo(p1);
			pdc->LineTo(p2);
		}
		/////////////////////////////////////
		OnDrawClose(pdc, p);
		OnDrawOpen(pdc, p, 1);
//	} else {
//		OnDrawClose(pdc, p);
	}
}

int CPDFor::CalcExtClose()
{
	CRect rct;
	CViecFC *pel;

	pel = (CViecFC*) m_child.GetHead();
	pel->SetOrg(CPoint(10 , 0));
	rct = pel->GetRect();
	m_RName.left = 0;
	m_RName.right = rct.right + s_merginX * 2 + 6; //rct.right *2/3;
	m_RName.top = rct.top - s_merginY; //+ rct.top/3;
	m_RName.bottom = rct.bottom + s_merginY; //rct.bottom/3;

	return 1;
}

int CPDFor::CalcExtOpen(CPoint &p, int st)
{
	POSITION pos;
	BOOL fstFg = TRUE;
	int i;

	pos = GetHeadPosition();
	for(i=0;i<st;i++)
		GetNext(pos);
	while(pos) {
		CViecFC *pel = GetNext(pos);
		if(pel->IsKindOf(RUNTIME_CLASS(CPad)) &&
		   !((CPad*)pel)->IsFixed())
			continue;
		CRect ext = pel->GetExtent();
		if(!fstFg) p.y -= ext.top;
		else fstFg = FALSE;
		pel->SetOrg(p);
		p.y += ext.bottom;
		p.y += s_merginY;
		ext = pel->GetRect();
		if(ext.right > m_extent.right) m_extent.right = ext.right;
		if(ext.top < m_extent.top) m_extent.top = ext.top;
		if(ext.bottom > m_extent.bottom) m_extent.bottom = ext.bottom;
	}
	return 1;
}

void CPDFor::OnDrawClose(CDC *pdc, const CPoint& p)
{

	POSITION pos = GetHeadPosition();
	CRect r0 = GetNext(pos)->GetRect();

	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	CRect rct = m_RName;
	rct.left += 1; rct.right -=1;
//	rct.bottom -= 1;
	rct.OffsetRect(GetOrg());
	rct.OffsetRect(p);

	SetPen(pdc, PS_SOLID, 2, col);
	pdc->SelectStockObject(NULL_BRUSH);
	pdc->Rectangle(&rct);
	pdc->MoveTo(rct.right-5, rct.top);
	pdc->LineTo(rct.right-5, rct.bottom-1);
}

int CPDFor::OnAccess(CPoint *pp)
{
	return CPad::OnAccess(pp);
/*
	CMenu *pMenu = GetPopupMenu();
	pMenu->AppendMenu(MF_STRING, 0, GetRuntimeClass()->m_lpszClassName +CString(": ")+ GetName());
	pMenu->AppendMenu(MF_SEPARATOR);

	CMenu *psub = GetPopupMenu(FALSE);
	if(psub) {
		pMenu->AppendMenu(MF_POPUP, (UINT)psub->m_hMenu, "&Default Menu");
		AppendDefaultMenu(psub);
	}
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_SUBST, "add new &subst");
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_IF, "add new &if");
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_BLOCK, "add new &block");
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_FOR, "add new &for");
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_CALL, "add new &call");
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_VAR, "add new &var");
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_BRK, "&break point");
	CSuitCase SC;
	SC.m_case = this;
	SC.m_case2 = pMenu;
	SendMsg(MSG_ADD_MENU_FOR_CHILD, &SC);

	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 0;
*/
}

int CPDCall::CalcExt(dirMode dir)
{
	CRect ext = GetExtent();

	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent(GetName(), lstrlen(GetName()));
	ReleaseDC(pdc);

	POSITION pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	if(dir==dirDown)
		parg->CalcExt(dir);
	parg->SetOrg(CPoint(8 + s_merginX + sz.cx, 0));
	m_RName.left = 0;
	m_RName.right = sz.cx;
	m_RName.top = -(sz.cy-1)/2;
	m_RName.bottom = sz.cy/2;
	m_RName.right += s_merginX*2 + 16 + parg->GetExtent().Width();
	if(parg->GetExtent().top<m_RName.top)
		m_RName.top = parg->GetExtent().top;
	if(parg->GetExtent().bottom>m_RName.bottom)
		m_RName.bottom = parg->GetExtent().bottom;
	m_RName.top -= s_merginY + 2;
	m_RName.bottom += s_merginY + 2;
	m_extent = m_RName;
	if(dir==dirUp) GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return 1;
}
/*
	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent(m_name, lstrlen(m_name));
	ReleaseDC(pdc);

//	POSITION pos = GetHeadPosition();
//	CPDArgs *parg = (CPDArgs *) GetNext(pos);
//	parg->SetOrg(CPoint(8 + s_merginX + sz.cx, 0));
//	int wd = parg->GetExtent().Width();
	int wd = 0;
	m_RName.left = 0;
	m_RName.right = sz.cx;
	m_RName.top = -(sz.cy-1)/2;
	m_RName.bottom = sz.cy/2;
	m_RName.right += s_merginX*2 + 16 + wd;
	m_RName.top -= s_merginY + 2;
	m_RName.bottom += s_merginY + 2;

	m_extent = m_RName;
	return 1;
}
*/

void CPDCall::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	CRect rct = m_RName;

	rct.left += 1; rct.right -=1;
	rct.bottom -= 1;
	rct.OffsetRect(GetOrg());
	rct.OffsetRect(p);
	SetPen(pdc, PS_SOLID, 2, col);
	pdc->SelectStockObject(NULL_BRUSH);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	pdc->SetTextColor(col);
	pdc->Rectangle(&rct);

	SetPen(pdc, PS_SOLID, 1, col);
	pdc->MoveTo(rct.left+3, rct.top);
	pdc->LineTo(rct.left+3, rct.bottom);
	pdc->MoveTo(rct.right-5, rct.top);
	pdc->LineTo(rct.right-5, rct.bottom);

	CPoint p0 = p;
	p0.Offset(GetOrg());
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent(GetName(), lstrlen(GetName()));
	p0.x += 8 + s_merginX;
	pdc->TextOut(p0.x, p0.y-sz.cy/2, GetName());

	POSITION pos;
	pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	CPoint pp = p;
	pp.Offset(GetOrg());
	parg->OnDraw(pdc, pp);

	pdc->SetTextColor(col);
}
/*
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	CRect rct = m_RName;

	rct.left += 1; rct.right -=1;
	rct.bottom -= 1;
	rct.OffsetRect(GetOrg());
	rct.OffsetRect(p);
	SetPen(pdc, PS_SOLID, 2, col);
	pdc->SelectStockObject(NULL_BRUSH);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	pdc->SetTextColor(col);
	pdc->Rectangle(&rct);

	SetPen(pdc, PS_SOLID, 1, col);
	pdc->MoveTo(rct.left+3, rct.top);
	pdc->LineTo(rct.left+3, rct.bottom);
	pdc->MoveTo(rct.right-5, rct.top);
	pdc->LineTo(rct.right-5, rct.bottom);

	CPoint p0 = p;
	p0.Offset(GetOrg());
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent(m_name, lstrlen(m_name));
	p0.x += 8 + s_merginX;
	pdc->TextOut(p0.x, p0.y-sz.cy/2, m_name);

	POSITION pos;
	pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	CPoint pp = p;
	pp.Offset(GetOrg());
	parg->OnDraw(pdc, pp);
*/


////////////////////////////////////////////////////
// CPDCallBy ////////////////////////////////////////
int CPDCallBy::CalcExt(dirMode dir)
{
	CRect ext = GetExtent();

	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent(GetName(), lstrlen(GetName()));
	ReleaseDC(pdc);

	POSITION pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	if(dir==dirDown)
		parg->CalcExt(dir);
	parg->SetOrg(CPoint(8 + s_merginX + sz.cx, 0));
	m_RName.left = 0;
	m_RName.right = sz.cx;
	m_RName.top = -(sz.cy-1)/2;
	m_RName.bottom = sz.cy/2;
	m_RName.right += s_merginX*2 + 16 + parg->GetExtent().Width();
	if(parg->GetExtent().top<m_RName.top)
		m_RName.top = parg->GetExtent().top;
	if(parg->GetExtent().bottom>m_RName.bottom)
		m_RName.bottom = parg->GetExtent().bottom;
	m_RName.top -= s_merginY + 2;
	m_RName.bottom += s_merginY + 2;
	m_extent = m_RName;
	if(dir==dirUp) GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return 1;
}

void CPDCallBy::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	CRect rct = m_RName;

	rct.left += 1; rct.right -=1;
	rct.bottom -= 1;
	rct.OffsetRect(GetOrg());
	rct.OffsetRect(p);
	SetPen(pdc, PS_SOLID, 2, col);
	pdc->SelectStockObject(NULL_BRUSH);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	pdc->SetTextColor(col);
	pdc->Rectangle(&rct);

	SetPen(pdc, PS_SOLID, 1, col);
	pdc->MoveTo(rct.left+3, rct.top);
	pdc->LineTo(rct.left+3, rct.bottom);
	pdc->MoveTo(rct.right-5, rct.top);
	pdc->LineTo(rct.right-5, rct.bottom);

	CPoint p0 = p;
	p0.Offset(GetOrg());
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent(GetName(), lstrlen(GetName()));
	p0.x += 8 + s_merginX;
	pdc->TextOut(p0.x, p0.y-sz.cy/2, GetName());

	POSITION pos;
	pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	CPoint pp = p;
	pp.Offset(GetOrg());
	parg->OnDraw(pdc, pp);

	pdc->SetTextColor(col);
}

/////////////////////// CPDComm //////////////////////////////
/////////////////////// CPDComm //////////////////////////////

int CPDComm::CalcExt(dirMode dir)
{
//	POSITION pos;
	CRect extent = m_extent;

	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent(GetName(), lstrlen(GetName()));
	ReleaseDC(pdc);
	m_RName.left = 0;
	m_RName.right = sz.cx;
	m_RName.top = -(sz.cy-1)/2;
	m_RName.bottom = sz.cy/2;
	m_RName.right += s_merginX*2;
	m_RName.top -= s_merginY + 2;
	m_RName.bottom += s_merginY + 2;

	m_extent = m_RName;
	if(dir==dirUp && GetParent()) GetParent()->CalcExt(dir);
	
	return 1;
}

void CPDComm::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	CRect rct = m_RName;
	rct.left += 1; rct.right -=1;
	rct.bottom -= 1;
	rct.OffsetRect(GetOrg());
	rct.OffsetRect(p);
	pdc->SetTextColor(col);
	SetPen(pdc, PS_SOLID, 2, col);
	pdc->MoveTo(rct.left, rct.top);
	pdc->LineTo(rct.left, rct.bottom);
	pdc->SelectStockObject(NULL_BRUSH);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
//	pdc->Rectangle(&rct);
	pdc->DrawText(GetName(), lstrlen(GetName()), &rct, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
}

/////////////////////////////////////////////
//                                          
//            CPDOutput
//
/////////////////////////////////////////////


void CPDOutput::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	CRect rct = m_RName;

	rct.left += 1; rct.right -=1;
	rct.bottom -= 1;
	rct.OffsetRect(GetOrg());
	rct.OffsetRect(p);
	SetPen(pdc, PS_SOLID, 2, col);
	pdc->SelectStockObject(NULL_BRUSH);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	pdc->SetTextColor(col);
	pdc->Rectangle(&rct);

	SetPen(pdc, PS_SOLID, 1, col);
	pdc->MoveTo(rct.left+3, rct.top);
	pdc->LineTo(rct.left+3, rct.bottom);
	pdc->MoveTo(rct.right-5, rct.top);
	pdc->LineTo(rct.right-5, rct.bottom);

	CPoint p0 = p;
	p0.Offset(GetOrg());
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent("print", 6);
	p0.x += 8 + s_merginX;
	pdc->TextOut(p0.x, p0.y-sz.cy/2, "print");

	POSITION pos;
	pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	CPoint pp = p;
	pp.Offset(GetOrg());
	parg->OnDraw(pdc, pp);

	pdc->SetTextColor(col);
}

int CPDOutput::CalcExt(dirMode dir)
{
	CRect ext = GetExtent();

	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent("print", 6);
	ReleaseDC(pdc);

	POSITION pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	if(dir==dirDown)
		parg->CalcExt(dir);
	parg->SetOrg(CPoint(8 + s_merginX + sz.cx, 0));
	m_RName.left = 0;
	m_RName.right = sz.cx;
	m_RName.top = -(sz.cy-1)/2;
	m_RName.bottom = sz.cy/2;
	m_RName.right += s_merginX*2 + 16 + parg->GetExtent().Width();
	if(parg->GetExtent().top<m_RName.top)
		m_RName.top = parg->GetExtent().top;
	if(parg->GetExtent().bottom>m_RName.bottom)
		m_RName.bottom = parg->GetExtent().bottom;
	m_RName.top -= s_merginY + 2;
	m_RName.bottom += s_merginY + 2;
	m_extent = m_RName;
	if(dir==dirUp) GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return 1;
}
/*
	CPoint co(20,0);
	POSITION pos;
	CViecFC * pel;
	CSize sz1,sz2;
	CDC *pdc;

	pdc = GetDC();
	if(!pdc) return 0;
	sz1 = pdc->GetTextExtent("=",1);
	sz2 = pdc->GetTextExtent("=",1);
	ReleaseDC(pdc);

	pos = GetHeadPosition();
	while(pos) {
		pel = GetNext(pos);
		if(dir==dirDown)
			pel->CalcExt(dir);
		pel->SetOrg(co);
		co.x += pel->GetExtent().Width();
		co.x += sz1.cx;
	}
	CViecFC::CalcExt(dirNot);
	m_extent.right += 25;
	m_extent.top -= 10;
	m_extent.bottom +=10;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	return 1;
}

void CPDOutput::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	int wd;
	CRect rct = GetRect();
	rct.OffsetRect(p);
	wd = rct.Height()/2;
	SetPen(pdc, PS_SOLID, 2, col);
	pdc->MoveTo(rct.left+1, rct.top);
	pdc->LineTo(rct.right, rct.top);
	pdc->LineTo(rct.right, rct.bottom-wd);
	pdc->LineTo(rct.right-wd, rct.bottom);
	pdc->LineTo(rct.left+1, rct.bottom);
	pdc->LineTo(rct.left+1, rct.top);
	OnDrawChild(pdc, p);
}
*/

///CPDStrcpy//////////////////////////////////////////
///
void CPDStrcpy::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	CRect rct = m_RName;

	rct.left += 1; rct.right -=1;
	rct.bottom -= 1;
	rct.OffsetRect(GetOrg());
	rct.OffsetRect(p);
	SetPen(pdc, PS_SOLID, 2, col);
	pdc->SelectStockObject(NULL_BRUSH);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	pdc->SetTextColor(col);
	pdc->Rectangle(&rct);

	SetPen(pdc, PS_SOLID, 1, col);
	pdc->MoveTo(rct.left+3, rct.top);
	pdc->LineTo(rct.left+3, rct.bottom);
	pdc->MoveTo(rct.right-5, rct.top);
	pdc->LineTo(rct.right-5, rct.bottom);

	CPoint p0 = p;
	p0.Offset(GetOrg());
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent("strcpy", 6);
	p0.x += 8 + s_merginX;
	pdc->TextOut(p0.x, p0.y-sz.cy/2, "strcpy");

	POSITION pos;
	pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	CPoint pp = p;
	pp.Offset(GetOrg());
	parg->OnDraw(pdc, pp);

	pdc->SetTextColor(col);
}

int CPDStrcpy::CalcExt(dirMode dir)
{
	CRect ext = GetExtent();

	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet);
	CSize sz = pdc->GetTextExtent("strcpy", 6);
	ReleaseDC(pdc);

	POSITION pos = GetHeadPosition();
	CPDArgs *parg = (CPDArgs *) GetNext(pos);
	if(dir==dirDown)
		parg->CalcExt(dir);
	parg->SetOrg(CPoint(8 + s_merginX + sz.cx, 0));
	m_RName.left = 0;
	m_RName.right = sz.cx;
	m_RName.top = -(sz.cy-1)/2;
	m_RName.bottom = sz.cy/2;
	m_RName.right += s_merginX*2 + 16 + parg->GetExtent().Width();
	if(parg->GetExtent().top<m_RName.top)
		m_RName.top = parg->GetExtent().top;
	if(parg->GetExtent().bottom>m_RName.bottom)
		m_RName.bottom = parg->GetExtent().bottom;
	m_RName.top -= s_merginY + 2;
	m_RName.bottom += s_merginY + 2;
	m_extent = m_RName;
	if(dir==dirUp) GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return 1;
}
//////////////////////////////////////////////////////////////////////

int CPDArgs::CalcExt(dirMode dir)
{
	CPoint co(0, 0);
	POSITION pos;
	CViecFC *pel;
	CRect ext = m_extent;
	CRect rct;

	m_extent = CRect(0,0,0,0);
	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), FALSE);
	CSize szComma = pdc->GetTextExtent(",", 1);
	CSize szBrack = pdc->GetTextExtent("(", 1);
	m_extent = GetTextExtent(pdc, "(", 1);
	ReleaseDC(pdc);

	co.x = szBrack.cx;
	pos = GetHeadPosition();
	while(pos) {
		pel = GetNext(pos);
		if(dir==dirDown)
			pel->CalcExt(dir);
		pel->SetOrg(co);
		rct = pel->GetRect();
		UnionExtent(m_extent, rct);
		co.x += pel->GetExtent().Width();
		co.x += szComma.cx;
	}
	m_extent.right += szBrack.cx;
	m_RName = m_extent;
	CalcExtPost(dir, ext);
	return 1;
}

void CPDArgs::OnDraw(CDC *pdc, const CPoint& p)
{
	CPoint p0 = p;
	p0.Offset(GetOrg());
	CRect r = GetExtent();
	r.OffsetRect(p0);

	COLORREF col = m_bFocus? RGB(0,0,225) : RGB(0,0,0);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, FALSE);
	CSize szComma = pdc->GetTextExtent(",", 1);
	CSize szBrack = pdc->GetTextExtent("(", 1);
	pdc->SetTextColor(col);
	pdc->TextOut(p0.x, p0.y-szBrack.cy/2-1, "(");
	pdc->TextOut(p0.x+r.Width()-szBrack.cx, p0.y-szBrack.cy/2-1, ")");

	POSITION pos = GetHeadPosition();
	if(pos) GetNext(pos);
	while(pos) {
		CViecFC *pelm = GetNext(pos);
		CPoint ppnt = pelm->GetOrg();
		pdc->TextOut(p0.x+ppnt.x-szComma.cx, p0.y-szComma.cy/2, ",");
	}
	CViecFC::OnDrawChild(pdc, p);
}

int CPDArgs::OnAccess(CPoint *pp)
{
	return CPad::OnAccess(pp);
/*
	CMenu *pMenu = GetPopupMenu();
	pMenu->AppendMenu(MF_STRING, 0, GetRuntimeClass()->m_lpszClassName +CString(": ")+ GetName());
	pMenu->AppendMenu(MF_SEPARATOR);

	CMenu *psub = GetPopupMenu(FALSE);
	if(psub) {
		pMenu->AppendMenu(MF_POPUP, (UINT)psub->m_hMenu, "&Default Menu");
		AppendDefaultMenu(psub);
	}
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_ARG, "add new &arg");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 0;
*/
}

int CPDArgs2::OnAccess(CPoint *pp)
{
	return CPad::OnAccess(pp);
/*
	CMenu *pMenu = GetPopupMenu();
	pMenu->AppendMenu(MF_STRING, 0, GetRuntimeClass()->m_lpszClassName +CString(": ")+ GetName());
	pMenu->AppendMenu(MF_SEPARATOR);

	CMenu *psub = GetPopupMenu(FALSE);
	if(psub) {
		pMenu->AppendMenu(MF_POPUP, (UINT)psub->m_hMenu, "&Default Menu");
		AppendDefaultMenu(psub);
	}
	pMenu->AppendMenu(MF_STRING, CMD_PAD_NEW_ARG2, "add new &arg");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 0;
*/
}


