#include "stdafx.h"
#include <math.h>

#include "pde_adv.h"
#include "jd_prc.h"

#include "pde_msg.h"
#include "msg_adv.h"

CPrgrsDlg dlgPrg;

IMPLEMENT_ELEM(CPDERange, CPDEBase, 219)
IMPLEMENT_ELEM(CPDEDepPDE, CPDEBase, 220)
IMPLEMENT_ELEM(CPDEBoundConds, CPDEBase, 221)
IMPLEMENT_ELEM(CPDERunSpread, CPDEBase, 227)

IMPLEMENT_ELEM(CPDEInfo, CPDEBase, 215)
IMPLEMENT_ELEM(CPDESet, CPDEBase, 222)
IMPLEMENT_ELEM(CPDESolvSet, CPDESet, 226)
IMPLEMENT_ELEM(CPDESpaceVar, CPDEBase, 203)
IMPLEMENT_ELEM(CPDETimeVar, CPDESpaceVar, 205)
IMPLEMENT_ELEM(CPDESpaceVars, CPDEBase, 204)
IMPLEMENT_ELEM(CPDEPrcManip, CPDEProcess, 233)
IMPLEMENT_ELEM(CPDEPrcDisc, CPDEProcess, 234)
IMPLEMENT_ELEM(CMSDepVar, CMSDep, 260)

////////////////////    CPDERange   /////////////////////
////////////////////    CPDERange   /////////////////////

CPDERange::CPDERange()
{
}

BOOL CPDERange::OnCreated(EnumOnCreated bSkp)
{
	POSITION pos;
	//int iranai = GetCount(); //just for check
	if(GetCount()==0) {
		CViecFCList obLst;
		CSuitCase SC;
		SC.m_runtimeClass = RUNTIME_CLASS(CPDEInfo);  /////	 
		SC.m_oblist = &obLst;
		GetAncestor()->SendMsg(MSG_COLLECT_KINDOF_OBJECT, &SC);
		if(!obLst.GetCount()) return TRUE;		
		CPDEInfo *pPDE = (CPDEInfo *) obLst.GetHead();
		if(!pPDE->IsKindOf(RUNTIME_CLASS(CPDEInfo)))
			return FALSE;
//		CRangeOnAxis *pRng;
		CViecFC *pRng;
		CPDESpaceVar *pVar;
		COnePointOnAxis *pPnt;
		int i;
		for(i=0;i<3;i++) {
			pVar = pPDE->m_meshInfo->m_spaceVars->m_spaceVar[i]; 
			if(!pVar) break;
			pRng = new CRangeOnAxis(pVar->m_pIndepVar->GetName());
			AddTail(pRng);

			pPnt = new COnePointOnAxis;
			pPnt->m_value = 1;
			pRng->AddTail(pPnt);

			pPnt = new COnePointOnAxis;
			pPnt->m_value = 0;
			pRng->AddTail(pPnt);
		}
	}
	pos = GetHeadPosition();
	for(m_rangeNo=0; pos; m_rangeNo++)
		m_range[m_rangeNo] = (CRangeOnAxis *) GetNext(pos);
	return CPDEBase::OnCreated(bSkp);
}

int CPDERange::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	CalcExtVert(dir);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDERange::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	OnDrawChild(pdc, p);
}


/////////////////  CPDESet  //////////////////
/////////////////  CPDESet  //////////////////

BOOL CPDESet::OnCreated(EnumOnCreated bSkp)
{
	if(GetCount()==0) {
		CPDEDepPDE *pDep = new CPDEDepPDE;
		AddTail(pDep);
		pDep->CreateDepPDE();
		pDep->SetMode(modeOpen);
		pDep->SetDragAllow(TRUE);
	}
	return CPDEBase::OnCreated(bSkp);
}

BOOL CPDESet::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_CAN_SKIP_ONCREATED_PROC:
		if(GetMode()==modeClose && !GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
			((CSuitCase *) el)->m_int = TRUE;
		else
			((CSuitCase *) el)->m_int = FALSE;
		return TRUE;
	case MSG_CAN_THIS_DISAPPEAR:
		if(el==m_child.GetHead())
			return FALSE;
		return TRUE;
	}
	return CPDEBase::SendMsg(msg, el);
}

int CPDESet::CalcExt(dirMode dir)
{
	CRect ext = m_extent;

	CalcExtVert(dir, 4);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDESet::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	OnDrawChild(pdc, p);
}


int CPDESet::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);
	pMenu->AppendMenu(MF_STRING, CMD_DEP_ADD_BC, "add &boundary condition");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}


int CPDESet::OnCommand(UINT id)
{
	static CStringArray strObj;

	switch(id) {
	case CMD_DEP_ADD_BC:
		{
			POSITION pos;
			CViecFCList obLst;
			CSuitCase SC;
			int i;
			CPDEBoundDef *pBD;
			SC.m_runtimeClass = RUNTIME_CLASS(CPDEBoundDef);
			SC.m_oblist = &obLst;
			GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
			if(!obLst.GetCount()) return TRUE;

			CMenu *pMenu = GetPopupMenu(TRUE);
			strObj.RemoveAll();
			pMenu->AppendMenu(MF_STRING, 0, "select boundary");
			pMenu->AppendMenu(MF_SEPARATOR);
			pos = obLst.GetHeadPosition();
			for(i=0; pos; i++) {
				pBD = (CPDEBoundDef *) obLst.GetNext(pos);
				strObj.Add(pBD->GetName());
				pMenu->AppendMenu(MF_STRING, CMD_FIND_DEP_RESULT+i, pBD->GetName());
			}
			TrackPopupMenu(pMenu, GetMenuPoint(NULL));
		}
		return TRUE;
	}
			/////   The result from selection  ///////
	int sig2 = id & 0xff00;
	int no = id & 0x00ff;
	switch(sig2) {
	case CMD_FIND_DEP_RESULT:
		{
			CPDEBoundCond *pbc;
			if(no>strObj.GetUpperBound()) return TRUE;
			pbc = new CPDEBoundCond(strObj[no]);
			AddTail(pbc);
			OnCreated();
			CalcExt(dirDown);
			CalcExt();
		}
		return TRUE;
	}
	return CPDEBase::OnCommand(id);
}

/////////////////  CPDESolvSet  //////////////////
/////////////////  CPDESolvSet  //////////////////

BOOL CPDESolvSet::OnCreated(EnumOnCreated bSkp)
{
	int iranai = GetCount(); // Just for check of value of GetCount(). 
	if(GetCount()<2) {
		while(GetCount())
			delete m_child.RemoveTail();
		const char *var = "?";
		CPDEDepInfo *pD = (CPDEDepInfo *) GetParent();
		if(pD->IsKindOf(RUNTIME_CLASS(CPDEDepInfo))) {
			var = pD->m_var->GetName();
		}
		CPDETarget *pTg = new CPDETarget(var);
		CPDEDepPDE *pDep = new CPDEDepPDE;
		AddTail(pTg);
		AddTail(pDep);
		pDep->CreateDepPDE();
	}
	return CPDEBase::OnCreated(bSkp);
}

BOOL CPDESolvSet::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_CAN_THIS_DISAPPEAR:
		{
			POSITION pos;
			if(GetCount()<2) return FALSE;
			pos = GetHeadPosition();
			if(el==GetNext(pos)) return FALSE;
			if(el==GetNext(pos)) return FALSE;
		}
		return TRUE;
	}
	return CPDEBase::SendMsg(msg, el);
}

///////////////////// CPDESpaceVar /////////////////////////
///////////////////// CPDESpaceVar /////////////////////////
///////////////////// CPDESpaceVar /////////////////////////

int CPDESpaceVar::OnCommand(UINT id)
{
	return CPDEBase::OnCommand(id);
}

BOOL CPDESpaceVar::OnCreated(EnumOnCreated bSkp)
{
	if(GetCount()<4)
		return FALSE;
	POSITION pos;
	pos = GetHeadPosition();
	m_pIndepVar = (CMSIndepVar *) GetNext(pos);
	m_pIndep = (CMSIndep *) GetNext(pos);
	m_pIndex = (CMSIndex *) GetNext(pos);
	m_division = (CMSCInteger *) GetNext(pos);
	return CPDEBase::OnCreated(bSkp);
}

int CPDESpaceVar::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	CalcExtHMerg(dir, GetName(), 20);
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDESpaceVar::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,255) : RGB(0,0,0);
	CRect rct = GetRect();
	rct.OffsetRect(p);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	pdc->SetTextColor(col);
	pdc->TextOut(rct.left, rct.top, GetName());
//	OnDrawName(pdc, p);
	OnDrawChild(pdc, p);
}

BOOL CPDESpaceVar::CreateSpace(const char* ind, const char* dx, const char* i, const char *IMAX, int no)
{
	while(GetCount())
		delete m_child.RemoveTail();
	CViecFC *ps1, *ps2, *ps3;
	CMSCInteger *ps4;
	ps1 = new CMSIndepVar;
	ps2 = new CMSIndep;
	ps3 = new CMSIndex;
	ps4 = new CMSMeshSize;
	ps4->m_value = no;
	ps1->SetName(ind, m_nDot+1, m_nCharSet);
	ps2->SetName(dx, m_nDot+1, m_nCharSet);
	ps3->SetName(i, m_nDot+1, m_nCharSet);
	ps4->SetName(IMAX, m_nDot+1, m_nCharSet);
	AddTail(ps1);
	AddTail(ps2);
	AddTail(ps3);
	AddTail(ps4);

	return TRUE;
}

BOOL CPDESpaceVar::CreateSpaceConst(const char* ind, const char* dx, const char* i, const char *IMAX, int no)
{
	while(GetCount())
		delete m_child.RemoveTail();
	CViecFC *ps1, *ps2, *ps3;
	CMSCInteger *ps4;
	ps1 = new CMSIndepVar;
	ps2 = new CMSIndepConst;
	ps3 = new CMSIndex;
	ps4 = new CMSMeshSize;
	ps4->m_value = no;
	ps1->SetName(ind, m_nDot+1, m_nCharSet);
	ps2->SetName(dx, m_nDot+1, m_nCharSet);
	ps3->SetName(i, m_nDot+1, m_nCharSet);
	ps4->SetName(IMAX, m_nDot+1, m_nCharSet);
	AddTail(ps1);
	AddTail(ps2);
	AddTail(ps3);
	AddTail(ps4);

	return TRUE;
}

CPDESpaceVar::CPDESpaceVar()
{
	m_bFindFirst = TRUE;
}

BOOL CPDESpaceVar::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_CAN_THIS_DISAPPEAR:
		return FALSE;
	case MSG_PDE_GET_MESH_NO:
		{
			CSuitCase *pSC;

			pSC = (CSuitCase *) el;
			POSITION pos;
			pos = m_child.FindIndex(3);
			if(!pos) {
				pSC->m_int = -1;
				return FALSE;
			}

			CMSCInteger *pInt = (CMSCInteger *) m_child.GetNext(pos);
			if(!pInt->IsKindOf(RUNTIME_CLASS(CMSCInteger))) {
				pSC->m_int = -1;
				return FALSE;
			}

			pSC->m_int = pInt->m_value;
			return TRUE;
		}
	case MSG_INCLUDE_CHILD_IN_MATH_TABLE:
		{
			CSuitCase *pSC = (CSuitCase *) el;
			pSC->m_int = FALSE;
			if(pSC->m_case==m_pIndepVar || pSC->m_case==m_pIndep || pSC->m_case==m_pIndex || pSC->m_case==m_division)
				pSC->m_int = TRUE;
			return TRUE;
		}
	}
	return CPDEBase::SendMsg(msg, el);
}

int CPDESpaceVars::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	CalcExtVert(dir);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return 1;
}

BOOL CPDESpaceVars::OnCreated(EnumOnCreated bSkp)
{
	POSITION pos;
	pos = GetHeadPosition();
	int i=0;
	while(pos) {
		CPDESpaceVar *pVar = (CPDESpaceVar *) GetNext(pos);
		if(pVar->IsKindOf(RUNTIME_CLASS(CPDESpaceVar)))
			m_spaceVar[i++] = pVar;
	}
	for(;i<3;i++)
		m_spaceVar[i] = NULL;
	return CPDEBase::OnCreated(bSkp);
}

void CPDESpaceVars::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	OnDrawChild(pdc, p);
}

BOOL CPDESpaceVars::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_CAN_THIS_DISAPPEAR:
		return FALSE;
	case MSG_PDE_GET_MESH_NO:
		{
			CPDESpaceVar *pVar;
			CSuitCase *pSC;
			CSuitCase SC2;
			int i;

			pSC = (CSuitCase *) el;
			POSITION pos = GetHeadPosition();
			for(i=0;pos; i++) {
				pVar = (CPDESpaceVar *) GetNext(pos);
				pVar->SendMsg(MSG_PDE_GET_MESH_NO, &SC2);
				pSC->m_intAry[i] = SC2.m_int;
			}
			pSC->m_int = i;
			return TRUE;
		}
	}
	return CPDEBase::SendMsg(msg, el);
}

///////////////////// CPDETimeVar /////////////////////////
///////////////////// CPDETimeVar /////////////////////////
///////////////////// CPDETimeVar /////////////////////////

BOOL CPDETimeVar::OnCreated(EnumOnCreated bSkp)
{
	if(GetCount()<4)
		return FALSE;
	POSITION pos;
	pos = GetHeadPosition();
	m_pIndepVar = (CMSIndepVar *) GetNext(pos);
	m_pIndep = (CMSIndep *) GetNext(pos);
	m_indexFold = (CPDEIndexFold *) GetNext(pos);
	m_division = (CMSCInteger *) GetNext(pos);
	pos = m_indexFold->GetHeadPosition();
	if(pos==NULL) return FALSE;
	m_pIndex = (CMSIndex *) m_indexFold->GetNext(pos);
	return CPDEBase::OnCreated(bSkp);
}

int CPDETimeVar::CalcExt(dirMode dir)
{
	if(GetMode()!=modeOpen)
		return CPDEBase::CalcExt(dir);
	CRect ext = m_extent;
	CalcExtHMerg(dir, GetName(), 20);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	CalcExtPost(dir, ext);
	return TRUE;
}

void CPDETimeVar::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	if(m_mode==modeClose) {
		OnDrawClose(pdc, p);
	} else {
		COLORREF col = m_bFocus ? RGB(0,0,255) : RGB(0,0,0);
		CPoint p0 = p;
		p0.Offset(GetOrg());
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		CSize sz = pdc->GetTextExtent(GetName(), lstrlen(GetName()));
		pdc->SetTextColor(col);
		pdc->TextOut(p0.x, p0.y, GetName());
		OnDrawChild(pdc, p);
	}
}

BOOL CPDETimeVar::CreateTimeVar(const char* ind, const char* dx, const char* i, const char *IMAX, int no)
{
	while(GetCount())
		delete m_child.RemoveTail();
	CViecFC *ps1, *ps2, *ps31;
	CPDEIndexFold *ps3;
	CMSCInteger *ps4;
	ps1 = new CMSIndepVar;
	ps2 = new CMSIndepConst(0.1);
	ps4 = new CMSMeshSize;
	ps3 = new CPDEIndexFold;
	ps31 = new CMSIndex;
	ps4->m_value = no;
	ps1->SetName(ind, m_nDot+1, m_nCharSet);
	ps2->SetName(dx, m_nDot+1, m_nCharSet);
	ps31->SetName(i, m_nDot+1, m_nCharSet);
	ps4->SetName(IMAX, m_nDot+1, m_nCharSet);
	AddTail(ps1);
	AddTail(ps2);
	AddTail(ps3);
	AddTail(ps4);
	ps3->AddTail(ps31);

	CViecFC *ps32;
	ps32 = new CMSIndex;
	ps32->SetName("~", m_nDot+1, m_nCharSet);
	ps3->AddTail(ps32);

	CViecFC *ps33;
	ps33 = new CMSIndex;
	ps33->SetName("'", m_nDot+1, m_nCharSet);
	ps3->AddTail(ps33);

	return TRUE;
}

///////////////////// CPDESpaceVars /////////////////////////
///////////////////// CPDESpaceVars /////////////////////////
///////////////////// CPDESpaceVars /////////////////////////

CPDESpaceVars::CPDESpaceVars()
{
	m_bFindFirst = TRUE;
}

/////////////////  CPDEPrcManip  //////////////////
/////////////////  CPDEPrcManip  //////////////////

int CPDEPrcManip::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);

	pMenu->AppendMenu(MF_STRING, CMD_PROC_MANIP_1, "#&1 (copy)");
	pMenu->AppendMenu(MF_STRING, CMD_PROC_MANIP_3, "#&3 (desc up wind 1st)");
	pMenu->AppendMenu(MF_STRING, CMD_PROC_MANIP_5, "#&5 (map to fit pos)");
	pMenu->AppendMenu(MF_STRING, CMD_PROC_MANIP_6, "#&6 (simplify)");
//	pMenu->AppendMenu(MF_STRING, CMD_PROC_MANIP_7, "#&7 (bind)");
	pMenu->AppendMenu(MF_STRING, CMD_PROC_MANIP_8, "#&8 (form eqt)");

	psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_SEPARATOR);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&sub menu");
	psub->AppendMenu(MF_STRING, CMD_PROC_MANIP_10, "CJDExpEqt2");
	psub->AppendMenu(MF_STRING, CMD_PROC_MANIP_11, "CJDBindEqt");
	psub->AppendMenu(MF_STRING, CMD_PROC_MANIP_12, "CJDSimpEqt");
	psub->AppendMenu(MF_STRING, CMD_PROC_MANIP_13, "CJDFormEqt");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDEPrcManip::OnCommand(UINT id)
{
	CViecFC *pelm;

	switch(id) {
	case CMD_PROC_MANIP_1:
		CopyProc();	   //from ? to ?
		return TRUE;
	case CMD_PROC_MANIP_3:
		pelm = CopyProc();
		if(pelm) {
			CJDDescUpwndFstOrd uw;
//			CJDDescDeriv uw;
			CJDShiftToPos dr;
			pelm->SendMsg(MSG_DO_JOB, &uw);
			pelm->SendMsg(MSG_DO_JOB, &dr);
		}
		return TRUE;
	case CMD_PROC_MANIP_5:
		pelm = CopyProc();
		if(pelm) {
			CJDMapToFit dr;
			CJDExpEqtNum exp;
			CJDBindEqtNum bd;
			CJDSimpEqt simp;
			pelm->SendMsg(MSG_DO_JOB, &dr);
			pelm->SendMsg(MSG_DO_JOB, &exp);
			pelm->SendMsg(MSG_DO_JOB, &simp);
			pelm->SendMsg(MSG_DO_JOB, &bd);
		}
		return TRUE;
	case CMD_PROC_MANIP_6:
		pelm = CopyProc();
		if(pelm) {
			CJDSimpEqt dr;
			pelm->SendMsg(MSG_DO_JOB, &dr);
		}
		return TRUE;
	case CMD_PROC_MANIP_7:
		pelm = CopyProc();
		if(pelm) {
			CJDBindEqt dr;
			pelm->SendMsg(MSG_DO_JOB, &dr);
		}
		return TRUE;
	case CMD_PROC_MANIP_8:
		pelm = CopyProc();
		if(pelm) {
			CJDExpEqt2 exp;
			CJDBindEqt bind;
			CJDSimpEqt simp;
			CJDFormEqt form;
			pelm->SendMsg(MSG_DO_JOB, &exp);
			pelm->SendMsg(MSG_DO_JOB, &bind);
			pelm->SendMsg(MSG_DO_JOB, &simp);
			pelm->SendMsg(MSG_DO_JOB, &form);
		}
		return TRUE;
	case CMD_PROC_MANIP_10:
		pelm = CopyProc();
		if(pelm) {
			CJDExpEqt2 exp;
			pelm->SendMsg(MSG_DO_JOB, &exp);
		}
		return TRUE;
	case CMD_PROC_MANIP_11:
		pelm = CopyProc();
		if(pelm) {
			CJDBindEqt bind;
			pelm->SendMsg(MSG_DO_JOB, &bind);
		}
		return TRUE;
	case CMD_PROC_MANIP_12:
		pelm = CopyProc();
		if(pelm) {
			CJDSimpEqt simp;
			pelm->SendMsg(MSG_DO_JOB, &simp);
		}
		return TRUE;
	case CMD_PROC_MANIP_13:
		pelm = CopyProc();
		if(pelm) {
			CJDFormEqt form;
			pelm->SendMsg(MSG_DO_JOB, &form);
		}
		return TRUE;
	}
	return CPDEProcess::OnCommand(id);
}

/////////////////  CPDEPrcDisc  //////////////////
/////////////////  CPDEPrcDisc  //////////////////

int CPDEPrcDisc::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);

	pMenu->AppendMenu(MF_STRING, CMD_PROC_DEL_ALL, "e&rase all details");
	pMenu->AppendMenu(MF_STRING, CMD_PROC_FORM_STRCT, "&form new process");
	pMenu->AppendMenu(MF_STRING, CMD_PROC_ADD_MANIP, "&add process");
	pMenu->AppendMenu(MF_STRING, CMD_PROC_PASS_EQT, "&pass the result");

	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDEPrcDisc::OnCommand(UINT id)
{
	switch(id) {
	case CMD_PROC_FORM_STRCT:
		{
			CViecFC * pin;
			CViecFC * pout;
			CString nm;
			if(!GetInputOutput(pin, pout))
				return TRUE;
			POSITION pos;
			CViecFC *pelm;
			pos = pin->GetHeadPosition();
			pelm = pin->GetNext(pos);
			pelm = MakeCopy(pelm);

			while(GetCount())
				delete m_child.RemoveTail();

			CPDEObject *pob1 = new CPDEObject;			   //1
			nm = CString(GetName()) + ".Eq.1";
			pob1->SetName(nm, m_nDot, m_nCharSet);
			AddTail(pob1);

			//--- process #1
			CPDEProcess *pprc = new CPDEPrcManip;		//2
			nm = CString(GetName()) + ".1";
			pprc->SetName(nm, m_nDot, m_nCharSet);
			AddTail(pprc);

			CPDEObject *pob2 = new CPDEObject;		 //3
			nm = CString(GetName()) + ".Eq.2";
			pob2->SetName(nm, m_nDot, m_nCharSet);
			AddTail(pob2);

			pprc->AddInputPoint(pob1);
			pprc->AddOutputPoint(pob2);

			//--- process #2
			CPDEProcess *pprc2 = new CPDEPrcManip;		   //4
			nm = CString(GetName()) + ".2";
			pprc2->SetName(nm, m_nDot, m_nCharSet);
			AddTail(pprc2);

			CPDEObject *pob3 = new CPDEObject;			//5
			nm = CString(GetName()) + ".Eq.3";
			pob3->SetName(nm, m_nDot, m_nCharSet);
			AddTail(pob3);

			pprc2->AddInputPoint(pob2);
			pprc2->AddOutputPoint(pob3);

			//--- process #3
			CPDEProcess *pprc3 = new CPDEPrcManip;	 //6
			nm = CString(GetName()) + ".3";
			pprc3->SetName(nm, m_nDot, m_nCharSet);
			AddTail(pprc3);

			CPDEObject *pob4 = new CPDEObject;	  //7
			nm = CString(GetName()) + ".4";
			pob4->SetName(nm, m_nDot, m_nCharSet);
			AddTail(pob4);

			pprc3->AddInputPoint(pob3);
			pprc3->AddOutputPoint(pob4);

			//--- set input object
			pob1->AddTail(pelm);

			OnCreated();
			CalcExt(dirDown);
			if(!GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
				ToDblBody();
			CalcExt();
			
			CJDDescretizer wk;
			pelm->SendMsg(MSG_DO_JOB, &wk);
		}
		return TRUE;
	case CMD_PROC_DEL_ALL:
		while(GetCount())
			delete RemoveTail();
		return TRUE;
	case CMD_PROC_PASS_EQT:
		{
			POSITION pos;
			CViecFC *pB, *pR, *pO;
			if(GetOutputCount()==0) return TRUE;
			pO = (CViecFC *) GetOutputChild(0);
			if(GetCount()<3) return TRUE;
			pos = GetHeadPosition();
			while(pos)
				pB = (CViecFC *) GetNext(pos);
			if(pB->GetCount()==0) return TRUE;
			pos = pB->GetHeadPosition();
			pR = (CViecFC *) pB->GetNext(pos)->Copy();
			pO->AddTail(pR);
			pR->OnCreated();
			pO->CalcExt(dirDown);
			pO->CalcExt();
		}
		return TRUE;
	case CMD_PROC_ADD_MANIP:
		{
			if(GetCount()<3) return TRUE;
			CViecFC *last = (CViecFC *) m_child.GetTail();
			CPDEProcess *pprc = new CPDEPrcManip;
			CPDEObject *pobj = new CPDEObject;
			AddTail(pprc);
			AddTail(pobj);

			CString nm, fm;
			nm = CString(GetName());
			pprc->SetName(nm, m_nDot, m_nCharSet);
			pprc->AddInputPoint(last);
			pprc->AddOutputPoint(pobj);
			nm = CString(GetName()) + CString("Eq");
			pobj->SetName(nm, m_nDot, m_nCharSet);

			OnCreated();
			CalcExt(dirDown);
			CalcExt();
		}
		return TRUE;
	}
	return CPDEProcess::OnCommand(id);
}

/////////////////  CPDEDepPDE  //////////////////
/////////////////  CPDEDepPDE  //////////////////

int CPDEDepPDE::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
//	CalcExtHMerg(dir, NULL, 10);
	CalcExtVert(dir, 4);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDEDepPDE::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	OnDrawChild(pdc, p);
}

int CPDEDepPDE::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);
	pMenu->AppendMenu(MF_STRING, CMD_DEP_ADD_EQUATION, "add an &eqaution");
	pMenu->AppendMenu(MF_STRING, CMD_WAIT_FOR_CONNECTION, "wait for connection");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

BOOL CPDEDepPDE::CreateDepPDE()
{
	CSymbInst *pSI, *pSI2;
	SetMode(modeOpen);
	AddTail(new CPDERange);
	pSI = new CSymbInst("=");
	AddTail(pSI);
	pSI2 = new CSymbInst("?");
	pSI->AddTail(pSI2);
	pSI2 = new CSymbInst("?");
	pSI->AddTail(pSI2);
	return TRUE;
}

BOOL CPDEDepPDE::OnCreated(EnumOnCreated bSkp)
{
	return CPDEBase::OnCreated(bSkp);
}

int CPDEBoundConds::CalcExt(dirMode dir)
{
	CRect ext = m_extent;

	CalcExtVert(dir, 4);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDEBoundConds::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	OnDrawChild(pdc, p);
}

/////////////////  CPDERunSpread  //////////////////
/////////////////  CPDERunSpread  //////////////////

int CPDERunSpread::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	CalcExtHMerg(dir, NULL, 10);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDERunSpread::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	OnDrawChild(pdc, p);
	OnDrawRel(pdc, p);
}

int CPDERunSpread::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);

	pMenu->AppendMenu(MF_STRING, CMD_RUN_CREATE_PROG, "create &main procedure");
	pMenu->AppendMenu(MF_STRING, CMD_RUN_AUTOMATIC, "automatic &run");

	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

DWORD WINAPI SpreadAutoRun(LPVOID pv)	  //for automatic program design and generation
{										  // pv = this = CPDERunSpread
	                                      // maybe pv:CPDERunSpread just generated 
	                                      // is input. (?) from where
	static BOOL bRunning = FALSE;		  // for check, "static" is used.
										  // to prevent the generation of the second thread
	if(!pv) return 0;
	CPDERunSpread *pRsp = (CPDERunSpread *) pv;	   //pv??
	CPDEObject *pPrg;							   //create ObjC (Object Container)
	if(!pRsp->IsKindOf(RUNTIME_CLASS(CPDERunSpread))) return 0;	// why required? Because pointer only check.
	//if(!pRsp->IsKindOf(RUNTIME_CLASS(CPDERunSpread))) return 0; //test (fail!)
	if(bRunning) return 0;						   //remove this function, if one thread is running

	pPrg = (CPDEObject *) pRsp->GetOutputChild(0); // (0) means the first output. But has only one output normally 
												   //This pointer(pPrg) indicates CPDERunSpreadPara class.
	if(!pPrg || !pPrg->IsKindOf(RUNTIME_CLASS(CPDEObject))) return 0;
	bRunning = TRUE;					//ready for this thread running		   // flag for already-used

	POSITION pos;
	CPDEProcess *pPrc;
	CPDEPrcDisc *pDsc;
																					  
	dlgPrg.m_sLabel = "starting";		  //dlgPrg : global 
	pRsp->SendCmdQ(CMD_SHOW_PROGRESS_DLG); //to send GUI thread(main) one, save the event in the Queue
	pos = pRsp->GetHeadPosition();	  //find the head of the immediate child(This class is CPDEProcess).

	while(pos) {					   //if plural processes for each solverset are there, they are listed in a list structure.
		pPrc = (CPDEProcess *) pRsp->GetNext(pos);
		if(!pPrc->IsKindOf(RUNTIME_CLASS(CPDEProcess))) continue;  // find CPDEProcess
		if(pPrc->GetCount()<3) continue;  // check if it has 3 objects on CPDEProcess sheet
		                                  // see the excuting GUI (CPDEObject,CPDEPrcDisc and CPDEObject).
		pDsc = (CPDEPrcDisc *) pPrc->GetChild(1);	 // get the (2)nd element
		// This pDsc point at CPDEPrcDisc class;

		if(pDsc->IsKindOf(RUNTIME_CLASS(CIElem)))
			pDsc = (CPDEPrcDisc *) ((CIElem *)pDsc)->GetInstBody();	 //if splitted, get its body
		//When CPDEPrcDisc splitted,Do This class change ClElem ??

		if(!pDsc->IsKindOf(RUNTIME_CLASS(CPDEPrcDisc))) continue;
		if(pDsc->GetInputCount()<1) continue;					   //check if CPDEProcDisc (OBjC) with 
		if(pDsc->GetOutputCount()<1) continue;					   //arrows for input and output

		dlgPrg.m_sLabel = pDsc->GetName();	// get its name and present it on GUI thread.
		// Name = symXXX.disc
		dlgPrg.m_sLabel += " is running";

		if(pRsp->SendCmdQ(CMD_IS_CANCELED_DLG))		 //SendCmdQ ??
			goto endLabel;
		pDsc->SendCmdQ(CMD_PROC_FORM_STRCT);	   //OK Later I come here
								  //send this command to the main GUI thread, and wait
		                          //if PostCmdQ, not wait.
		                          //in the main thread 7 boxes are prepared.
		if(pDsc->GetCount()!=7) goto endLabel;	   // why 7?

		CPDEPrcManip *pManp;	//Manipulate what? //eqation is manipulated.. 
								//CPDEPrcManip base from CPDEProcess.
								//The both of difference are OnComaand and OnAccess.
								//from here some dirty methods are used by CHM.
		CPDEObject *pInp;		//what kind of object?
		int cmdLst[] = { CMD_PROC_MANIP_3, CMD_PROC_MANIP_5, CMD_PROC_MANIP_8 };
		int i;			  // for automatic run.  3 proccesses are now prepared.
		for(i=0;i<3;i++) {
			pManp = (CPDEPrcManip *) pDsc->GetChild(i*2 + 1);//Do pDsc have child class??
			if(!pManp->IsKindOf(RUNTIME_CLASS(CPDEPrcManip))) {
				goto endLabel;
			}
			if(pManp->GetInputCount()!=1 || pManp->GetOutputCount()!=1) {
				goto endLabel;
			}
			pInp = (CPDEObject *) pManp->GetInputChild(0);	//get the input information; solverset
			if(!pInp || !pInp->IsKindOf(RUNTIME_CLASS(CPDEObject)) || pInp->GetCount()!=1) {
				goto endLabel;
			}
			dlgPrg.m_sLabel.Format("%s run %d/3 step", (const char *) pDsc->GetName(), i+1);
			if(pRsp->SendCmdQ(CMD_IS_CANCELED_DLG))	goto endLabel;

			pInp->SendCmdQ(CMD_SPLIT); //split its process to show
			pManp->SendCmdQ(cmdLst[i]);	//send the first CMD_PROC....._3.
			Sleep(200);					//wait 0.2sec 
			pInp->SendCmdQ(CMD_GO_BACK);//Go back. save the splitted window
		}
		pDsc->SendCmdQ(CMD_GO_BACK);
		pDsc->SendCmdQ(CMD_PROC_PASS_EQT);	//pass the final result to the end box
	}
	dlgPrg.m_sLabel = "creating program";
	if(pRsp->SendCmdQ(CMD_IS_CANCELED_DLG)) goto endLabel;
	pRsp->SendCmdQ(CMD_RUN_CREATE_PROG);   //create the program	 <<<<-----
										   //98.11.25 This break point!!
	pPrg->SendCmdQ(CMD_SPLIT);

endLabel:
	bRunning = FALSE;
	pRsp->SendCmdQ(CMD_DESTROY_PROGRESS_DLG); // erase the dialog
	return 1;
}

int CPDERunSpread::OnCommand(UINT id)
{
	switch(id) {
	case CMD_SHOW_PROGRESS_DLG:
		dlgPrg.m_bCancel = FALSE;
		dlgPrg.Create(CPrgrsDlg::IDD);
		dlgPrg.ShowWindow(SW_SHOW);
		return TRUE;
	case CMD_IS_CANCELED_DLG:
		if(dlgPrg.m_bCancel) return TRUE;
		dlgPrg.UpdateData(FALSE);
		return FALSE;
	case CMD_DESTROY_PROGRESS_DLG:
		dlgPrg.DestroyWindow();
		return TRUE;
	/*****************************************************/
	/*****************************************************/
	case CMD_RUN_CREATE_PROG:
		{
			CJDCreateMainProc proc;
			OnCreated();
			SendMsg(MSG_DO_JOB, &proc);
		}
		return TRUE;
	/*****************************************************/
	/*****************************************************/
	case CMD_RUN_AUTOMATIC:
		{
			DWORD tid;
			::CreateThread(NULL, 0, SpreadAutoRun, this, 0, &tid);
		}										 // | This pointer is passed to the 
		                                         //SPreadAuto..... now CPDERunSpread 
		return TRUE;
	case CMD_RUN_CREATE_FORT:
		return TRUE;
	}
	return CPDEBase::OnCommand(id);
}

BOOL CPDERunSpread::CreateNewTemplate(CViecFC *pelm)
{
	CPDEProcess * ptmp = new CPDEProcess;  //the following 3 components
	CPDEObject *pob1 = new CPDEObject;     //input; container
	CPDEProcess *pprc1 = new CPDEPrcDisc;  // process
	CPDEObject *pob2 = new CPDEObject;	   //output;
	SetMode(modeOpen);

	AddTail(ptmp);
	ptmp->SetMode(modeOpen);

	pob1->AddTail(pelm);
	pob1->SetName(pelm->GetName(), m_nDot, m_nCharSet);
	pob2->SetName(pelm->GetName()+CString(".Solv"), m_nDot, m_nCharSet);
	pprc1->SetName(pelm->GetName()+CString(".Disc"), m_nDot, m_nCharSet);

	ptmp->AddTail(pob1);
	ptmp->AddTail(pprc1);
	ptmp->AddTail(pob2);

	pprc1->AddInputPoint(pob1);
	pprc1->AddOutputPoint(pob2);
	pprc1->SetMode(modeClose);

	return TRUE;
}

/////////////////  CPDEAbstProcVis  //////////////////
/////////////////  CPDEAbstProcVis  //////////////////

int CPDEAbstProcVis::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	CalcExtHMerg(dir, NULL, 20);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDEAbstProcVis::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	OnDrawChild(pdc, p);
	CPoint p1,p2, p0;
	p0 = p;
	p0.Offset(GetOrg());

	pdc->SelectStockObject(BLACK_PEN);
	POSITION pos;
	CRect rct;
	pos = GetHeadPosition();
	rct = GetNext(pos)->GetRect();
	p1 = CPoint(p0.x+rct.right, p0.y+rct.top+20);
	while(pos) {
		rct = GetNext(pos)->GetRect();
		p2 = CPoint(p0.x+rct.left, p0.y+rct.top+20);
		DrawArrow(pdc, p1, p2);
		p1 = CPoint(p0.x+rct.right, p0.y+rct.top+20);
	}
}

int CPDEAbstProcVis::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);

	pMenu->AppendMenu(MF_STRING, CMD_NEW_OBTAINED_VARS, "add &vars");
	pMenu->AppendMenu(MF_STRING, CMD_NEW_INVOKED_PROCS, "add &procs");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDEAbstProcVis::OnCommand(UINT id)
{
	switch(id) {
	case CMD_NEW_OBTAINED_VARS:
		{
			CPDEObtainedVars *pVars;
			pVars = new CPDEObtainedVars;
			AddTail(pVars);
			OnCreated();
			CalcExt(dirDown);
			CalcExt();
		}
		return TRUE;
	case CMD_NEW_INVOKED_PROCS:
		{
			CPDEInvokedProcs *pPrc;
			pPrc = new CPDEInvokedProcs;
			AddTail(pPrc);
			OnCreated();
			CalcExt(dirDown);
			CalcExt();
		}
		return TRUE;
	}
	return CPDEBase::OnCommand(id);
}

/////////////////  CPDEObtainedVars  //////////////////
/////////////////  CPDEObtainedVars  //////////////////

int CPDEObtainedVars::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	CalcExtVert(dir, 10);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDEObtainedVars::OnDraw(CDC *pdc, const CPoint& p)
{
//	DrawFold3D(pdc, p, m_bFocus? 0:1);
	COLORREF col = RGB(0,0,0);

	CRect rct = GetRect();
	rct.OffsetRect(p);
	pdc->SelectStockObject(NULL_BRUSH);
	SetPen(pdc, PS_SOLID, 1, col);
	pdc->Rectangle(&rct);

	OnDrawChild(pdc, p);
}

int CPDEObtainedVars::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);
	pMenu->AppendMenu(MF_STRING, CMD_NEW_TARGET_VAR, "new &var");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDEObtainedVars::OnCommand(UINT id)
{
	switch(id) {
	case CMD_NEW_TARGET_VAR:
		{
			CSymbInst *pInst;
			pInst = new CSymbInst("?");
			AddTail(pInst);
			OnCreated();
			CalcExt(dirDown);
			CalcExt();
		}
		return TRUE;
	}
	return CPDEBase::OnCommand(id);
}

/////////////////  CPDEInvokedProcs  //////////////////
/////////////////  CPDEInvokedProcs  //////////////////

int CPDEInvokedProcs::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	CalcExtVert(dir, 10);
//	CalcExtHMerg(dir, NULL, 20);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDEInvokedProcs::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	OnDrawChild(pdc, p);
}

int CPDEInvokedProcs::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDEInvokedProcs::OnCommand(UINT id)
{
	return CPDEBase::OnCommand(id);
}

////////////////    CPDEInfo   /////////////////
////////////////    CPDEInfo   /////////////////

CPDEInfo::CPDEInfo()
{
	m_meshInfo = NULL;
}

BOOL CPDEInfo::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_CAN_THIS_DISAPPEAR:
		if(el==m_meshInfo)
			return FALSE;
		break;
	}
	return CPDEBase::SendMsg(msg, el);
}

int CPDEInfo::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);
	pMenu->AppendMenu(MF_STRING, CMD_NEW_DEP_VAR, "new dependent &variable");
	pMenu->AppendMenu(MF_STRING, CMD_NEW_PARAM_FOLD, "new &para folder");
	pMenu->AppendMenu(MF_STRING, CMD_NEW_PROCEDURE, "new &procedure");
	pMenu->AppendMenu(MF_STRING, CMD_NEW_FILE_FOLD, "new &file folder");

	pMenu->AppendMenu(MF_STRING, CMD_CHM_TREE_REPORT, "tree report");

	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDEInfo::CalcExt(dirMode dir)
{
	if(GetMode()!=modeOpen)
		return CPDEBase::CalcExt(dir);
	CRect ext = m_extent;
	CalcExtHMerg(dir, "", 10);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	CalcExtPost(dir, ext);
	return TRUE;
}

void CPDEInfo::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	if(m_mode==modeClose) {
		OnDrawClose(pdc, p);
	} else {
		OnDrawChild(pdc, p);
	}
//	CPDEBase::OnDraw(pdc, p);
}

BOOL CPDEInfo::CreatePDEsInfo()
{
	CPDEMeshInfo *pMsh;
	CPDEDepInfo *pDep;

	pMsh = new CPDEMeshInfo;
	pMsh->CreateMeshInfo1();
	AddTail(pMsh);

	pDep = new CPDEDepInfo;
	pDep->CreateDep2D("Velocity on x direction", "U", 0, 1);
	AddTail(pDep);

	pDep = new CPDEDepInfo;
	pDep->CreateDep2D("Velocity on y direction", "V", 1, 0);
	AddTail(pDep);

	pDep = new CPDEDepInfo;
	pDep->CreateDep2D("Pressure", "P", 1, 1);
	AddTail(pDep);

	return TRUE;
}

BOOL CPDEInfo::OnCreated(EnumOnCreated bSkp)
{
	if(GetCount()==0)
		return FALSE;
	POSITION pos;
	pos = GetHeadPosition();
	m_meshInfo = (CPDEMeshInfo *) GetNext(pos);
	if(m_meshInfo->IsKindOf(RUNTIME_CLASS(CIElem)))
		m_meshInfo = (CPDEMeshInfo *) ((CIElem*)m_meshInfo)->GetBody();
	if(!m_meshInfo || !m_meshInfo->IsKindOf(RUNTIME_CLASS(CPDEMeshInfo)))
		return FALSE;
	return CPDEBase::OnCreated(bSkp);
}

//////////////////   CMSDepVar   ////////////////////
//////////////////   CMSDepVar   ////////////////////

BOOL CMSDepVar::SendMsg(int sig, CObject* obj)
{
	switch(sig) {
	case MSG_ADD_MENU:
		{
			CMenu *pmn = (CMenu*) obj;
			CMenu *pSmn = GetPopupMenu(FALSE);
			pmn->AppendMenu(MF_POPUP, (UINT)pSmn->m_hMenu, "di&screte");
				pSmn->AppendMenu(MF_STRING, CMD_DEP_DISCRETE, "&discrete");
				pSmn->AppendMenu(MF_STRING, CMD_DEP_DISCRETE2, "discrete&2");
				pSmn->AppendMenu(MF_STRING, CMD_DEP_UNDISCRETE, "&undiscrete");
		}
		return TRUE;
	case MSG_COMMAND:
		{
			CSuitCase *pSC = (CSuitCase *) obj;
			CSymbInst *pSI = (CSymbInst*) pSC->m_case;
			BOOL fg = FALSE;
			switch(pSC->m_int) {
			case CMD_DEP_DISCRETE: fg = TRUE;
			case CMD_DEP_DISCRETE2:
				{
					POSITION pos;
					CPDESpaceVar *pS;
					CViecFCList obLst;
					CSuitCase SC;

					SC.m_runtimeClass = RUNTIME_CLASS(CPDEMeshInfo);
					SC.m_oblist = &obLst;
					GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
					if(!obLst.GetCount()) return TRUE;
					CPDEMeshInfo *pPDE = (CPDEMeshInfo *) obLst.GetHead();
					if(!pPDE->IsKindOf(RUNTIME_CLASS(CPDEMeshInfo))) return TRUE;

					CPDETimeVar *pT = (CPDETimeVar *) GetAncestor()->GetChildElem(RUNTIME_CLASS(CPDETimeVar));
					if(pT==NULL) return TRUE;

					CPDESpaceVars *pPs = pPDE->m_spaceVars;
					//--- bug 2
					pSI->m_child.RemoveAll();
					pSI->AddTail(new CSymbInst(pT->m_pIndex->GetName()));
					if(fg) {
						pos = pPs->GetHeadPosition();
						while(pos) {
							pS = (CPDESpaceVar *) pPs->GetNext(pos);
							pSI->AddTail(new CSymbInst(pS->m_pIndex->GetName()));
						}
					}
					pSI->OnCreated();
					pSI->CalcExt(dirDown);
					pSI->CalcExt();
				}
				return TRUE;
			case CMD_DEP_UNDISCRETE:
				{
					//--- bug 3
					pSI->m_child.RemoveAll();
					pSI->OnCreated();
					pSI->CalcExt(dirDown);
					pSI->CalcExt();
				}
				return TRUE;
			}
		}
	}
	return CMSDep::SendMsg(sig, obj);
}


