
#ifndef __PDE_ADV_H__
#define __PDE_ADV_H__

#ifndef __PDE_MSH_H__
#	include "pde_msh.h"
#endif

#ifndef __PAD_H__
#	include "pad.h"
#endif

class AFX_EXT_CLASS CPDEInfo : public CPDEBase {
	DECLARE_ELEM(CPDEInfo)
public:
	CPDEMeshInfo *m_meshInfo;

	CPDEInfo();
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	BOOL CreatePDEsInfo();
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual BOOL SendMsg(int msg, CObject* el);
	virtual int OnAccess(CPoint *p = NULL);
};

class AFX_EXT_CLASS CPDERange : public CPDEBase {
	DECLARE_ELEM(CPDERange)
public:
	int m_rangeNo;
	CRangeOnAxis *m_range[3];

	CPDERange();

	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};

class AFX_EXT_CLASS CPDEProblem : public CPDEBase {
	DECLARE_ELEM(CPDEProblem)
public:
	CPDEInfo *m_pdeInfo;	   // pointer for the PDEInfo

	CPDEProblem();
	virtual int OnAccess(CPoint *p = NULL);
	virtual int OnCommand(UINT);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual BOOL SendMsg(int msg, CObject* el);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);

};

#ifndef __PRGRSDLG_H__
#	include "prgrsdlg.h"
#endif

extern CPrgrsDlg dlgPrg;

#endif //__PDE_ADV_H__
