
#ifndef	__PDE_MSH_H__
#define __PDE_MSH_H__

#ifndef __PDE_BAS_H__
#	include "pde_bas.h"
#endif

class AFX_EXT_CLASS CPDEMeshInfo;
class AFX_EXT_CLASS CMSCInteger;

class AFX_EXT_CLASS CMSMeshSize : public CMSCInteger {
	DECLARE_ELEM(CMSMeshSize)
public:
	virtual int OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	virtual int OnAccess(CPoint *pp);
	virtual int OnCommand(UINT);
};

class AFX_EXT_CLASS CPDEBoundDefs : public CPDEBase {
	DECLARE_ELEM(CPDEBoundDefs)
public:
	CPDEBoundDefs();
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual int OnAccess(CPoint *pp);
	virtual int OnCommand(UINT);
	virtual BOOL SendMsg(int, CObject*);
};

class AFX_EXT_CLASS CPointOnAxis : public CSymbInst {
	DECLARE_ELEM(CPointOnAxis)
public:
	int m_axisNo; // 0:x 1:y 2:z

	CPointOnAxis() : CSymbInst() {};
	CPointOnAxis(const char* nm);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
};

class AFX_EXT_CLASS CPointOnAxisOfMesh : public CPointOnAxis {
	DECLARE_ELEM(CPointOnAxisOfMesh)
public:
	CPointOnAxisOfMesh() : CPointOnAxis() {};
	CPointOnAxisOfMesh(const char* nm) : CPointOnAxis(nm) {};
//	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
};

class AFX_EXT_CLASS CHalfAndDir : public CViecFC {
	DECLARE_ELEM(CHalfAndDir)
public:
	BOOL m_bHalf, m_bPosDir;

	CHalfAndDir();
	virtual void CopyBody(CViecFC *);
	virtual void SerializeBody(CArchive& ar);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual int OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	virtual int OnAccess(CPoint *pp);
	virtual int OnCommand(UINT);
};

class AFX_EXT_CLASS  COnePointOnAxis : public CMSInteger {
	DECLARE_ELEM(COnePointOnAxis)
public:
	virtual int OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};

class AFX_EXT_CLASS  COnePointOnAxisOfMesh : public COnePointOnAxis {
	DECLARE_ELEM(COnePointOnAxisOfMesh)
public:
	virtual int OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
};

class AFX_EXT_CLASS  CSurfOnAxisOfMesh : public CPointOnAxisOfMesh {
	DECLARE_ELEM(CSurfOnAxisOfMesh)
public:
	CHalfAndDir *m_pHalfDir;
	COnePointOnAxis *m_pAt;

	CSurfOnAxisOfMesh() : CPointOnAxisOfMesh() {};
	CSurfOnAxisOfMesh(const char* nm) : CPointOnAxisOfMesh(nm) {};
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
};

class AFX_EXT_CLASS  CRangeOnAxisOfMesh : public CPointOnAxisOfMesh {
	DECLARE_ELEM(CRangeOnAxisOfMesh)
public:
	COnePointOnAxis *m_pFrom;
	COnePointOnAxis *m_pTo;

	CRangeOnAxisOfMesh() : CPointOnAxisOfMesh() {};
	CRangeOnAxisOfMesh(const char* nm) : CPointOnAxisOfMesh(nm) {};
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
};

class AFX_EXT_CLASS  CRangeOnAxis : public CPointOnAxis {
	DECLARE_ELEM(CRangeOnAxis)
public:
	COnePointOnAxis *m_pFrom;
	COnePointOnAxis *m_pTo;

	CRangeOnAxis() : CPointOnAxis() {};
	CRangeOnAxis(const char* nm) : CPointOnAxis(nm) {};
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
};

class AFX_EXT_CLASS CPDEBoundDef : public CPDEBase {
	DECLARE_ELEM(CPDEBoundDef)
public:
	CSurfOnAxisOfMesh *m_surf;
	CRangeOnAxisOfMesh *m_range;
	CRangeOnAxisOfMesh *m_range2;

/////Kawa for 1Dimension
	BOOL CreateBoundDef1D(const char*, int, BOOL, BOOL);
	BOOL CreateBoundDef(const char*, int, BOOL, BOOL, const char*, int, int);
/////Kawa for 3Dimension
	BOOL CreateBoundDef3D(const char*, int, BOOL, BOOL, const char*, int, int, const char*, int, int);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual BOOL SendMsg(int, CObject*);
};

class AFX_EXT_CLASS CPDEMeshMap : public CPDEBase {
	DECLARE_ELEM(CPDEMeshMap)
public:
	CPDEMeshInfo *m_meshInfo;

	CRect m_extIn;
	int m_meshNo[3];

	CPDEMeshMap();
	virtual BOOL SendMsg(int msg, CObject* el);
	virtual int OnDrop(const CPoint& last);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
};

class AFX_EXT_CLASS CPDEMeshInfo : public CPDEBase {
	DECLARE_ELEM(CPDEMeshInfo)
public:
//	CPDETimeVar *m_timeVar;
	CPDESpaceVars *m_spaceVars;
	CPDEMeshMap *m_meshMap;
	CPDEBoundDefs *m_boundDefs;

	CPDEMeshInfo();
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual BOOL SendMsg(int msg, CObject* el);

	BOOL CreateMeshInfo1();
	BOOL CreateMeshInfo2();
	BOOL CreateMeshInfo1D();/////Kawa
	BOOL CreateMeshInfo3D();/////Kawa
};

class AFX_EXT_CLASS CBoundLine : public CSymbInst {
	DECLARE_ELEM(CBoundLine)
public:
	int m_verOrHor;
	CBoundLine(CPDEBoundDef *pi=NULL) : CSymbInst(pi) {};
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
};

#endif // __PDE_MSH_H__
