#ifndef __PDE_PRG_H__
#define __PDE_PRG_H__

#ifndef __PDE_ADV_H__
#	include "pde_adv.h"
#endif

typedef struct {
	short int VarNo;
	char pszStatus[22];
	struct {
		char varName[16];
		short int type;
		short int size[3];
		unsigned long pBody;
	} varList[1];
} VAR_STRUCT;

class AFX_EXT_CLASS CPDBrkPnt;
class AFX_EXT_CLASS CPDEBrkObj;

class AFX_EXT_CLASS CPDEObjPrg : public CPDEObject {
	DECLARE_ELEM(CPDEObjPrg)
public:
	BOOL m_bGen, m_bBreaking;
	CString sPathName, sFileName, sFileExt, sFileTitle, sPath;
	STARTUPINFO startupInfo;
	PROCESS_INFORMATION  procInfo;
	HANDLE hVar, hSig, hThr;
	VAR_STRUCT *pVar;
	CString sSig, sVar, sBrk;
	CStringArray strAry;
	int m_cmd;
	CRITICAL_SECTION memSync;
	CPDBrkPnt *m_pBrkPnt;
	CPDEBrkObj *m_pBrkObj;

	CPDEObjPrg();
	virtual ~CPDEObjPrg();
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual void SerializeBody(CArchive& ar);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnAccess(CPoint *pp);
	virtual int OnCommand(UINT);
	virtual BOOL SendMsg(int, CObject*);
	BOOL SetMenuForPDFor(CMenu *pMenu);
	BOOL OnCommandForPad(int msg, CPad *pPad);
	BOOL OnCommandForSymbInst(int msg, CSymbInst *pPad);

	void ToFindCandAndSelect(CViecFC *, CRuntimeClass *);
	BOOL AddFileToElem(CViecFC *, int no);
};

class AFX_EXT_CLASS CPDEBrkObj : public CPDEBase {
	DECLARE_ELEM(CPDEBrkObj)
	CPDEBttn *m_resetBtn, *m_onOffBtn, *m_trigBtn;
	HANDLE hBrk;
public:
	BOOL m_bBreak;

	CPDEBrkObj();
	virtual ~CPDEBrkObj();
	virtual BOOL SendMsg(int msg, CObject* el);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual CRect ToCalcExt(CSymbInst*, dirMode d=dirUp);
	virtual void ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift);
};

class AFX_EXT_CLASS CPDBrkPnt : public CPDSubst {
	DECLARE_ELEM(CPDBrkPnt)
public:
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual BOOL SendMsg(int msg, CObject* el);
};

class AFX_EXT_CLASS CPDFile : public CPad {
	DECLARE_ELEM(CPDFile)
public:
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};

//add new class
class AFX_EXT_CLASS CPDFileFrom : public CPad {
	DECLARE_ELEM(CPDFileFrom)
public:
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};


class AFX_EXT_CLASS CPDESngVarBox : public CPDEBase {
	DECLARE_ELEM(CPDESngVarBox)
public:
	virtual BOOL SendMsg(int msg, CObject* el);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual int OnAccess(CPoint *pp);
	virtual int OnCommand(UINT);
};

class AFX_EXT_CLASS CPDESngVar : public CViecFC {
	DECLARE_ELEM(CPDESngVar)
public:
	CStringArray strAry;
	char m_pszVarName[21];
	int m_nVarNo;

	CPDESngVar();
	virtual BOOL SendMsg(int msg, CObject* el);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual int OnAccess(CPoint *pp);
	virtual int OnCommand(UINT);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};


#endif //__PDE_PRG_H__
