#ifndef __PDE_UTL_H__
#define __PDE_UTL_H__

class AFX_EXT_CLASS CMSCInteger : public CMSConst {
	DECLARE_ELEM(CMSCInteger)
public:
	virtual void CopyBody(CViecFC *);
	virtual void SerializeBody(CArchive& ar);
	virtual int OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	int m_value;
	CMSCInteger() { m_value = 100; }
};

class AFX_EXT_CLASS CMSCReal : public CMSConst {
	DECLARE_ELEM(CMSCReal)
public:
	double m_value;

	virtual void CopyBody(CViecFC *);
	virtual void SerializeBody(CArchive& ar);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnCommand(UINT);
	virtual int OnAccess(CPoint *pp);

	CMSCReal() { m_value = 1.0; }
};

class AFX_EXT_CLASS CMSCRealSub : public CMSCReal {
	DECLARE_ELEM(CMSCRealSub)
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};

class AFX_EXT_CLASS CMSUnknown2 : public CMSUnknown {
	DECLARE_ELEM(CMSUnknown2)
public:
	virtual BOOL SendMsg(int msg, CObject* el);
};

class AFX_EXT_CLASS CMSFract : public CMSNumber {
protected:
	DECLARE_ELEM(CMSFract)
public:
	int m_value;
	unsigned int m_deno;

	CMSFract(int num = 1, unsigned int den = 1) { m_value = num; m_deno = den? den:1; }
	void gdc();
	virtual BOOL IsNeg() { return m_value < 0; }
	virtual void CopyBody(CViecFC *);
	virtual void SerializeBody(CArchive& ar);
	virtual int CalcExt(dirMode d=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	virtual int OnAccess(CPoint *p = NULL);
	BOOL IsEqual(int n, unsigned int d = 1);
	BOOL Plus(int, unsigned int);
	BOOL Plus(int);
	BOOL Mult(int, unsigned int = 1);
};

class AFX_EXT_CLASS CMSRealEx : public CMSNumber {
protected:
	DECLARE_ELEM(CMSRealEx)
public:
	double m_value;

	CMSRealEx(double d = 0) { m_value = d; }
	virtual BOOL IsNeg() { return m_value < 0; }
	virtual void CopyBody(CViecFC *);
	virtual void SerializeBody(CArchive& ar);
	virtual int CalcExt(dirMode d=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnAccess(CPoint *p = NULL);
	virtual int OnCommand(UINT);
	void Plus(double d) { m_value += d; };
	void Mult(double d) { m_value *= d; };
};

class AFX_EXT_CLASS CMSPDEMtx : public CMSMatrix {
protected:
	DECLARE_ELEM(CMSPDEMtx)
public:
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};

class AFX_EXT_CLASS CMSPDEVct : public CMSPDEMtx {
protected:
	DECLARE_ELEM(CMSPDEVct)
public:
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};

class AFX_EXT_CLASS CPDEBttn : public CViecFC {
	DECLARE_ELEM(CPDEBttn)
public:
	COLORREF m_color;
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnFocus(CPoint &p);
	virtual int OnDrop(const CPoint& last);
};

class AFX_EXT_CLASS CEFile : public CViecFC {
	DECLARE_ELEM(CEFile)
public:
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual CRect ToCalcExt(CSymbInst*, dirMode d=dirUp);
	virtual void ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift);
};

class AFX_EXT_CLASS CEFileFrom : public CViecFC {
	DECLARE_ELEM(CEFileFrom)
public:
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual CRect ToCalcExt(CSymbInst*, dirMode d=dirUp);
	virtual void ToDraw(CSymbInst *pInst, CDC *pdc, const CPoint& shift);
};

#endif //__PDE_UTL_H__
