#ifndef __PAD_H__
#define __PAD_H__

class CPad;
class CPadInst;

class AFX_EXT_CLASS CPad : public CPElem {
	DECLARE_ELEM(CPad)
	int m_bFixed;
public:
	static int s_merginX;
	static int s_merginY;
	static int s_space;

	CPad();
	virtual CIElem *GetNewInst(); /* { return (CIElem*) new CPadInst; };*/
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode d=dirUp);
	virtual int OnAccess(CPoint *p = NULL);
	virtual int OnCommand(UINT id);
	virtual BOOL SendMsg(int, CObject*);

	int CalcExtClose();
	int CalcExtOpen(CPoint &p = CPoint(0,0), int st=0);
	void OnDrawClose(CDC *, const CPoint&);
	void OnDrawOpen(CDC *, const CPoint&, int st=0);
	void OnDrawDoubleLine(CDC *pdc, const CPoint& p);
	BOOL IsFixed() { return m_bFixed; }
	void SetFixedFg(BOOL b) { m_bFixed = b; }
	BOOL AppendDefaultMenu(CMenu *);
};

class AFX_EXT_CLASS CPadInst : public CIElem {
public:
	CPadInst();
	virtual int CalcExt(dirMode d=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
//	virtual CViecFC* GetUnknowElem(CArchive& ar, const CString& hd);
protected:
	DECLARE_ELEM(CPadInst)
};

class AFX_EXT_CLASS CPDSubst : public CPad {
	DECLARE_ELEM(CPDSubst)
public:
	CPDSubst();
	virtual CIElem *GetNewInst() { return (CIElem*) new CPadInst; };
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode d=dirUp);
	virtual BOOL SendMsg(int, CObject*);
};

class AFX_EXT_CLASS CPDBlock : public CPad {
	DECLARE_ELEM(CPDBlock)
public:
	virtual int OnAccess(CPoint *p = NULL);
	virtual int OnCommand(UINT id);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode d=dirUp);

	int CalcExtClose();
};

class AFX_EXT_CLASS CPDProg : public CPad {
	DECLARE_ELEM(CPDProg)
public:
	void OnDrawClose(CDC *, const CPoint&);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode d=dirUp);
	virtual int OnAccess(CPoint *p = NULL);
	virtual int OnCommand(UINT id);
};

class AFX_EXT_CLASS CPDProc : public CPDProg {
	DECLARE_ELEM(CPDProc)
public:
	int CalcExtClose();
	void OnDrawClose(CDC *, const CPoint&);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode d=dirUp);
	virtual int OnAccess(CPoint *p = NULL);
	virtual int OnCommand(UINT id);
	virtual BOOL SendMsg(int, CObject*);
};

class AFX_EXT_CLASS CPDIf : public CPad {
	DECLARE_ELEM(CPDIf)
protected:
	int m_inedge;
public:
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode d=dirUp);
	virtual BOOL SendMsg(int, CObject*);
};

class AFX_EXT_CLASS CPDFor : public CPDProg {
	DECLARE_ELEM(CPDFor)
public:
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode d=dirUp);
	virtual int OnAccess(CPoint *p = NULL);
	virtual BOOL SendMsg(int, CObject*);

	int CalcExtOpen(CPoint &p = CPoint(0,0), int st=0);
	int CalcExtClose();
	void OnDrawClose(CDC *, const CPoint&);
};

class AFX_EXT_CLASS CPDSdLay : public CPad {
	DECLARE_ELEM(CPDSdLay)
public:
	virtual int CalcExt(dirMode d=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};

class AFX_EXT_CLASS CPDVar : public CPad {
	DECLARE_ELEM(CPDVar)
public:
	CPDVar();
	virtual int CalcExt(dirMode d=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnAccess(CPoint *p = NULL);
};

class AFX_EXT_CLASS CPDArgs : public CPDVar {
	DECLARE_ELEM(CPDArgs)
public:
	CPDArgs() { m_bFixed = FALSE; }
	virtual int CalcExt(dirMode d=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnAccess(CPoint *p = NULL);
};

class AFX_EXT_CLASS CPDArgs2 : public CPDArgs {
	DECLARE_ELEM(CPDArgs2)
public:
	virtual int OnAccess(CPoint *p = NULL);
};

class AFX_EXT_CLASS CPDOutput : public CPad {
	DECLARE_ELEM(CPDOutput)
public:
	virtual int CalcExt(dirMode d=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};

///new class//
//fujita 990614
//strcpy֐gpB
//example strcpy(filetype,"ascii")
class AFX_EXT_CLASS CPDStrcpy : public CPad {
	DECLARE_ELEM(CPDStrcpy)
public:
	virtual int CalcExt(dirMode d=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};
////////////////////////////////////

class AFX_EXT_CLASS CPDForSub : public CPad {
	DECLARE_ELEM(CPDForSub)
public:
	virtual int CalcExt(dirMode d=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual BOOL SendMsg(int, CObject*);
};

class AFX_EXT_CLASS CPDComm : public CPad {
	DECLARE_ELEM(CPDComm)
public:
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode d=dirUp);
};

class AFX_EXT_CLASS CPDBreak : public CPad {
	DECLARE_ELEM(CPDBreak)
public:
};

class AFX_EXT_CLASS CPDCall : public CPad {
	DECLARE_ELEM(CPDCall)
public:
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode d=dirUp);
};
  // moved here April 1998
class AFX_EXT_CLASS CPadDoc : public CGMainDoc
{
	DECLARE_DYNCREATE(CPadDoc)
	virtual BOOL OnNewDocument();
};

//New class fujita 990616
//̃NXWhilePAD\B
class AFX_EXT_CLASS CPDWhile : public CPad {
	DECLARE_ELEM(CPDWhile)
protected:
	int m_inedge;
public:
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode d=dirUp);
	virtual BOOL SendMsg(int, CObject*);
};

//ftHgŕ܂͈̈֐\NXłBMPI_init(&argc,&argv)
class AFX_EXT_CLASS CPDCallBy : public CPad {
	DECLARE_ELEM(CPDCallBy)
public:
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int CalcExt(dirMode d=dirUp);
};
///////////////////////////////////////////////////////
#endif //__PAD_H__
