
#include "stdafx.h"

#include <math.h>
#include <winsock2.h>

#include "pde_bas.h"
#include "pde_msg.h"
#include "realdlg.h"

IMPLEMENT_ELEM(CPDEIElem, CIElem, 202)
IMPLEMENT_ELEM(CPDEBase, CPElem, 201)
IMPLEMENT_ELEM(CPDEIndexFold, CPDEBase, 224)
IMPLEMENT_ELEM(CPDEProcess, CPDEBase, 231)
IMPLEMENT_ELEM(CPDEObject, CPDEBase, 232)
IMPLEMENT_ELEM(CPDEPosDef, CPDEBase, 218)
IMPLEMENT_ELEM(CPDEDepInfo, CPDEBase, 216)
IMPLEMENT_ELEM(CPDEParaInfo, CPDEBase, 217)
IMPLEMENT_ELEM(CPDEFileFold, CPDEParaInfo, 274)
IMPLEMENT_ELEM(CPDEAbstProcVis, CPDEBase, 228)
IMPLEMENT_ELEM(CPDEObtainedVars, CPDEBase, 229)
IMPLEMENT_ELEM(CPDEInvokedProcs, CPDEBase, 230)
IMPLEMENT_ELEM(CPDELineTerm, CPDEBase, 263)
IMPLEMENT_ELEM(CPDETarget, CSymbInst, 225)
IMPLEMENT_ELEM(CMSUnknown2, CMSUnknown, 250)
IMPLEMENT_ELEM(CMSIndepVar, CMSIndep, 210)
IMPLEMENT_ELEM(CPDEBoundCond, CSymbInst, 244)

IMPLEMENT_ELEM(CMSIndepConst, CMSIndep, 300);

//////////////////  CPDEBase ///////////////////
//////////////////  CPDEBase ///////////////////
//////////////////  CPDEBase ///////////////////

int CPDEBase::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

BOOL CPDEBase::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_SUBSTITUTE_THE_TWO:
		return TRUE;
	case MSG_RECALC_ALL_VIEW:
		if(!GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
			break;	 //	If it is not the most base window in Windows Program,
		             //   re-CalcExt & invalidateRect. 
		GetParent()->CalcExt(dirDown);
		GetParent()->InvalidateRect(CPoint(0,0));
		break;
	}
	return CPElem::SendMsg(msg, el);
}

DWORD WINAPI WaitForConnect(LPVOID pv)
{
	SOCKET m_waitSocket = NULL;
	SOCKET m_connectedSocket = NULL;
	struct sockaddr_in inAddr;
	int sz = sizeof(sockaddr_in);
	static char buf[5000];
	static int beinside = FALSE;

	if(beinside) return NULL;
	beinside = TRUE;
	CViecFC *pObj = (CViecFC *) pv;
	if(pObj==NULL) return NULL;

	try {
		struct sockaddr_in m_sockAddr;
		int m_err;

		m_waitSocket = socket(AF_INET, SOCK_STREAM, 0);
		if(m_waitSocket==NULL) throw;
		memset(&m_sockAddr, 0, sizeof(m_sockAddr));
		m_sockAddr.sin_port = htons(1000);
		m_sockAddr.sin_family = AF_INET;

		m_err = bind(m_waitSocket, (PSOCKADDR) &m_sockAddr, sizeof(m_sockAddr));
		if(m_err ==  SOCKET_ERROR) throw;
		m_err = listen(m_waitSocket, 10);
		if(m_err == SOCKET_ERROR) throw;
		m_connectedSocket = accept(m_waitSocket, (PSOCKADDR) &inAddr, &sz);

		sz = recv(m_connectedSocket, buf, 5000, 0);
		buf[sz] = 0;
		FILE *fp;
		fp = fopen("_com.tmp", "wb");
		if(!fp) throw;
		fwrite(buf, 1, sz, fp);
		fclose(fp);

		closesocket(m_connectedSocket);
		closesocket(m_waitSocket);

		pObj->PostCmdQ(CMD_LOAD_OBJECT_COM);

	} catch(void) {
	}
	beinside = FALSE;
	return NULL;
}

int CPDEBase::OnCommand(UINT id)
{
	switch(id) {
	case CMD_WAIT_FOR_CONNECTION:
		{
			DWORD tid;
			::CreateThread(NULL, 0, WaitForConnect, this, 0, &tid);
		}
		return TRUE;
/*
	case CMD_NEW_PROCEDURE:
		{
			CPDProc *psym = new CPDProc;
			SetMode(modeOpen);
			AddTail(psym);
			CPDVar *parg = new CPDArgs;
			psym->AddTail(parg);
			psym->OnCreated();
			CalcExt(dirDown);
			CalcExt();
		}
		return TRUE;
*/
	case CMD_NEW_PARAM_FOLD:
		{
			CPDEParaInfo *pinf = new CPDEParaInfo; 
			AddTail(pinf);
			pinf->OnCreated();
			CalcExt(dirDown);
			CalcExt();
		}
		return TRUE;
	case CMD_NEW_FILE_FOLD:
		{
			CPDEFileFold *pfld = new CPDEFileFold; 
			AddTail(pfld);
			pfld->OnCreated();
			CalcExt(dirDown);
			CalcExt();
		}
		return TRUE;
	case CMD_NEW_PARAM:
		{
			CMSCReal *pPar = new CMSCReal;
			AddTail(pPar);
			pPar->OnCreated();
			CalcExt(dirDown);
			CalcExt();
		}
		return TRUE;
	case CMD_NEW_DEP_VAR:
		{
			CPDEDepInfo *pDep = new CPDEDepInfo;
			pDep->AddTail(new CMSDepVar);
			pDep->AddTail(new CMathSymb);
			pDep->AddTail(new CPDEPosDef);
			AddTail(pDep);
			pDep->OnCreated();
			CalcExt(dirDown);
			CalcExt();
		}
		return TRUE;
	case CMD_DEP_ADD_EQUATION:
		{
			CSymbInst *pEq = new CSymbInst("=");
			CSymbInst *pEq1 = new CSymbInst("?");
			CSymbInst *pEq2 = new CSymbInst("?");
			pEq->AddTail(pEq1);
			pEq->AddTail(pEq2);
			AddTail(pEq);
			pEq->OnCreated();
			CalcExt(dirDown);
			CalcExt();
		}
		return TRUE;
	}
	return CPElem::OnCommand(id);
}

int CPDEBase::CalcExtHMerg(dirMode dir, const char *nm, int mg)
{
	POSITION pos;
	CViecFC *pelm;
	CSize sz(0,0);

	if(nm) {
		CDC *pdc = GetDC();
		if(pdc==NULL) return FALSE;
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		sz = pdc->GetTextExtent(nm, lstrlen(nm));
		ReleaseDC(pdc);
	}

	int x = sz.cx;
	x = (sz.cx)? sz.cx : -mg;
	CPoint pp;
	pos = GetHeadPosition();
	for(; pos; ) {
		pelm = GetNext(pos);
		if(dir==dirDown && GetMode()==modeOpen)
			pelm->CalcExt(dir);
		x += mg;
		CRect rct = pelm->GetExtent();
		pp = CPoint(x,0);
		pp.Offset(-rct.left, -rct.top);
		pelm->SetOrg(pp);
		x += pelm->GetExtent().Width();
	}
	CViecFC::CalcExt(dirNot);
	return TRUE;
}

int CPDEBase::CalcExtMidVert(dirMode dir, int mg)
{
	POSITION pos;
	int y0=0;
	CViecFC *pelm;
	int wd,wd0;
	CRect ext0;
	CPoint pt;

	pos = GetHeadPosition();
	while(pos) {
		pelm = GetNext(pos);
		if(dir==dirDown && GetMode()==modeOpen)
			pelm->CalcExt(dir);
		ext0 = pelm->GetExtent();
		y0 -= ext0.top;
		pt.x = -ext0.left;
		pt.y = y0;
		y0 += ext0.bottom + mg;
		pelm->SetOrg(pt);
	}
	CViecFC::CalcExt(dirNot);

	y0 = 0;
	wd0 = GetExtent().Width();
	pos = GetHeadPosition();
	while(pos) {
		pelm = GetNext(pos);
		ext0 = pelm->GetExtent();
		wd = ext0.Width();
		y0 -= ext0.top;
		pt.x = -ext0.left + wd0/2-wd/2;
		pt.y = y0;
		y0 += ext0.bottom + mg;
		pelm->SetOrg(pt);
	}
	CViecFC::CalcExt(dirNot);
	return TRUE;
}

int CPDEBase::CalcExtVert(dirMode dir, int mg)
{
	POSITION pos;
	CViecFC *pelm;
	if(dir==dirDown && GetMode()==modeOpen) {
		pos = GetHeadPosition();
		while(pos)
			GetNext(pos)->CalcExt(dir);
	}
	int y0=0, x0;
	pos = GetHeadPosition();
	while(pos) {
		pelm = GetNext(pos);
		y0 -= pelm->GetExtent().top;
		x0 = -pelm->GetExtent().left;
		pelm->SetOrg(CPoint(x0,y0));
		y0 += pelm->GetExtent().bottom + mg;
	}
	CViecFC::CalcExt(dirNot);
	return TRUE;
}

void CPDEBase::OnDrawTest(CDC *pdc, const CPoint& p)
{
	CPoint p0 = p;
	p0.Offset(GetOrg());

	CRect rct = GetRect();
	rct.OffsetRect(p);
	pdc->SelectStockObject(NULL_BRUSH);
	pdc->SelectStockObject(BLACK_PEN);

	pdc->Rectangle(&rct);
	pdc->SelectStockObject(WHITE_PEN);
	pdc->MoveTo(p0);
	pdc->LineTo(p0.x + 40, p0.y);
}

void CPDEBase::OnDrawName(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus ? RGB(0,0,255) : RGB(0,0,0);
	CPoint p0 = p;
	p0.Offset(GetOrg());
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	CSize sz = pdc->GetTextExtent(GetName(), lstrlen(GetName()));
	pdc->SetTextColor(col);
	pdc->TextOut(p0.x, p0.y-sz.cy/2, GetName());
}

void CPDEBase::OnDrawClose(CDC *pdc, const CPoint& p)
{
	COLORREF rgb;
	CRect r0=m_extent;
	r0.OffsetRect(m_org);
	r0.OffsetRect(p);
	CRect rD(r0.left+4, r0.top+4, r0.right-4, r0.bottom-4);
	if(m_bFocus) rgb = pdc->SetTextColor(RGB(0,0,255));
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	pdc->DrawText(GetName(), GetNameLen(), &rD, DT_CENTER || DT_VCENTER || DT_SINGLELINE);
}

void CPDEBase::OnDrawRel(CDC *pdc, const CPoint& p)
{
//		CObList inPnt, outPnt;
//		POSITION pos, pos0;
		CViecFC *pel;
		CRect r0,r;

		CViecFC *anc = GetView();

//		GetConPnts(inPnt, outPnt);
/*
		pos = inPnt.GetHeadPosition();
		while(pos) {
			pos0 = pos;
			pel = (CViecFC *) inPnt.GetNext(pos);
			if(pel->IsKindOf(RUNTIME_CLASS(CPElem))) {
				CPElem *ppe = (CPElem*) pel;
				if(ppe->GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)) && GetInst()) {
					pel = ppe->GetInst();
				}
			}
			if(IsInside(pel)) {
				inPnt.RemoveAt(pos0);
			} else if(!anc->IsInside(pel)) {
				inPnt.RemoveAt(pos0);
			}
		}

		pos = outPnt.GetHeadPosition();
		while(pos) {
			pos0 = pos;
			pel = (CViecFC *) outPnt.GetNext(pos);
			if(pel->IsKindOf(RUNTIME_CLASS(CPElem))) {
				CPElem *ppe = (CPElem*) pel;
				if(ppe->GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)) && GetInst()) {
					pel = ppe->GetInst();
				}
			}
			if(IsInside(pel)) {
				outPnt.RemoveAt(pos0);
			} else if(!anc->IsInside(pel)) {
				outPnt.RemoveAt(pos0);
			}
		}
*/
		int cnt, i;
		r0 = GetRect();
		r0.OffsetRect(p);
		SetPen(pdc, PS_SOLID, 1, RGB(0,0,0));
		cnt = GetInputCount();
		for(i=0; i<cnt; i++) {
			pel = GetInputChild(i);
			if(pel->IsKindOf(RUNTIME_CLASS(CPElem))) {
				CPElem *ppe = (CPElem*) pel;
				if(ppe->GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)) && GetInstBody()) {
					pel = ppe->GetInstBody();
				}
			}
			r = CRect(0,0,0,0);
			pel->GetRectG(r);
			CPoint p2((r0.left+r0.right)/2, r0.top);
			CPoint p1((r.left+r.right)/2, r.bottom);
			DrawArrow(pdc, p1, p2);
		}

		cnt = GetOutputCount();
		for(i=0; i<cnt; i++) {
			pel = GetOutputChild(i);
			if(pel->IsKindOf(RUNTIME_CLASS(CPElem))) {
				CPElem *ppe = (CPElem*) pel;
				if(ppe->GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)) && GetInstBody()) {
					pel = ppe->GetInstBody();
				}
			}
			r = CRect(0,0,0,0);
			pel->GetRectG(r);
			CPoint p1((r0.left+r0.right)/2, r0.bottom);
			CPoint p2((r.left+r.right)/2, r.top);
			DrawArrow(pdc, p1, p2);
		}

}

int CPDEBase::CalcExtHTab(dirMode dir, int tabWd)
{
	POSITION pos;
	CViecFC *pelm;
	if(dir==dirDown && GetMode()==modeOpen) {
		pos = GetHeadPosition();
		while(pos)
			GetNext(pos)->CalcExt(dir);
	}
	CDC *pdc = GetDC();
	if(pdc==NULL) return FALSE;
	CSize sz = pdc->GetTextExtent(GetName(), lstrlen(GetName()));
	ReleaseDC(pdc);

	int tabNo = 0;
	int x0 = 0;
	int xL = sz.cx;
	pos = GetHeadPosition();
	while(pos) {
		for(;x0<=(xL+tabWd/8);tabNo++)
			x0 += tabWd;
		pelm = GetNext(pos);
		pelm->SetOrg(CPoint(x0, 0));
		xL = x0 + pelm->GetExtent().right;
	}

	CViecFC::CalcExt(dirNot);
	m_extent.left = 0;
	if(m_extent.top>(-sz.cy/2)) m_extent.top = -sz.cy/2;
	if(m_extent.bottom<(sz.cy-sz.cy/2)) m_extent.bottom = sz.cy-sz.cy/2;
	if(m_extent.right<sz.cx) m_extent.right = sz.cx;
	return TRUE;
}

int CPDEBase::CalcExtLines(dirMode dir, int mg, int hg)
{
	POSITION pos;
	CViecFC *pelm;
	CSize sz(0,0);

	if(dir==dirDown && GetMode()==modeOpen) {
		pos = GetHeadPosition();
		while(pos) GetNext(pos)->CalcExt(dir);
	}

	int x = -mg;
	int hg0 = 0;
	int y = 0;
	CPoint pp;
	pos = GetHeadPosition();
	for(; pos; ) {
		pelm = GetNext(pos);
		x += mg;
		CRect rct = pelm->GetExtent();
		pp = CPoint(x,0);
		pp.Offset(-rct.left, -rct.top + y);
		pelm->SetOrg(pp);
		x += pelm->GetExtent().Width();
		if(rct.Height()>hg0) hg0 = rct.Height();
		if(pelm->IsKindOf(RUNTIME_CLASS(CPDELineTerm))) {
			y += hg0 + hg;
			x = -mg;
			hg0 = 0;
		}
	}
	CViecFC::CalcExt(dirNot);
	return TRUE;
}

CIElem * CPDEBase::GetNewInst()
{
	CIElem *newInst = new CPDEIElem;
	newInst->SetDragAllow(TRUE);
	return newInst;
}

CPDEBase::CPDEBase()
{
	m_mode = modeOpen;
	m_bEncap = FALSE;
	m_bZoneFg = FALSE;
	m_bFindFirst = FALSE;
}

CPDEBase *CPDEBase::GetBaseObj()
{
	CViecFC *pE = this;
	CRuntimeClass *pRtc = GetRuntimeClass();
	while(pE && !pE->IsKindOf(RUNTIME_CLASS(CPDEObject))) {
		if(pE->GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
			if(pE->IsKindOf(RUNTIME_CLASS(CPElem)))
				pE = ((CPElem*) pE)->GetInstBody();
			else
				pE = NULL;
		else
			pE = pE->GetParent();
	}
	return (CPDEBase *) pE;
}


//////////////////  CPDEIElem  ///////////////////
//////////////////  CPDEIElem  ///////////////////
//////////////////  CPDEIElem  ///////////////////

BOOL CPDEIElem::PackInst()
{
	CGElem *inst = m_pBody;
	BOOL rt = CIElem::PackInst();
	return rt;
}

//////////////////  CPDEIndexFold  ///////////////////
//////////////////  CPDEIndexFold  ///////////////////

CPDEIndexFold::CPDEIndexFold()
{
	m_bFindFirst = TRUE;
}

BOOL CPDEIndexFold::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_CAN_THIS_DISAPPEAR:
		if(el==m_child.GetHead())
			return FALSE;
		return TRUE;
	case MSG_INCLUDE_CHILD_IN_MATH_TABLE:
		((CSuitCase *) el)->m_int = TRUE;
		return TRUE;
	}
	return CPDEBase::SendMsg(msg, el);
}

int CPDEIndexFold::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	CalcExtVert(dir);

	m_extent.left -= 8;
	m_extent.right += 8;
//	m_extent.top -= 6;
//	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDEIndexFold::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	OnDrawChild(pdc, p);
}

BOOL CPDEIndexFold::OnCreated(EnumOnCreated bSkp)
{
	return CPDEBase::OnCreated(bSkp);
}

int CPDEIndexFold::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDEIndexFold::OnCommand(UINT id)
{
	return CPDEBase::OnCommand(id);
}

/////////////////  CPDEProcess  //////////////////
/////////////////  CPDEProcess  //////////////////

CPDEProcess::CPDEProcess()
{
	SetMode(modeClose);
}

int CPDEProcess::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	if(GetMode()!=modeOpen)
		return CPDEBase::CalcExt(dir);
	CalcExtMidVert(dir, 20);

	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDEProcess::OnDraw(CDC *pdc, const CPoint& p)
{
	if(GetParent()->IsKindOf(RUNTIME_CLASS(CElemView))) {
		DrawFold3D(pdc, p);
		OnDrawChild(pdc, p);
	} else if(m_mode==modeOpen) {
		COLORREF rgb = m_bFocus? RGB(0,0,255) : RGB(0,0,0);
		CRect r0=GetRect();
		r0.OffsetRect(p);
		SetPen(pdc, PS_SOLID, 1, rgb);
		pdc->SelectStockObject(NULL_BRUSH);
		pdc->Rectangle(&r0);
		OnDrawChild(pdc, p);
//		if(GetInputCount())
		OnDrawRel(pdc, p);
	} else {
		COLORREF rgb = m_bFocus? RGB(0,0,255) : RGB(0,0,0);
		CRect r0=GetRect();
		r0.OffsetRect(p);
		CRect rD(r0.left+4, r0.top+4, r0.right-4, r0.bottom-4);
		pdc->SetTextColor(rgb);
		pdc->SelectStockObject(NULL_BRUSH);
		SetPen(pdc, PS_SOLID, 1, rgb);
		pdc->Rectangle(&r0);
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		pdc->DrawText(GetName(), lstrlen(GetName()), &rD, GetFormat());
		OnDrawRel(pdc, p);
	}
}

CViecFC *CPDEProcess::CopyProc()
{
	CViecFC * pin;
	CViecFC * pout;
	POSITION pos;
	CViecFC *pelm;
	if(!GetInputOutput(pin, pout))	return NULL;
	pos = pin->GetHeadPosition();
	pelm = pin->GetNext(pos);
	pelm = MakeCopy(pelm);		 //?
	if(!pelm) return NULL;
	while(pout->GetCount())
		delete pout->m_child.RemoveTail(); //? cleaning up.  Why needed?
	pout->AddTail(pelm);
	pout->OnCreated();
	pout->CalcExt(dirDown);
	pout->CalcExt();
	return pelm;
}

int CPDEProcess::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);

	pMenu->AppendMenu(MF_STRING, CMD_PROC_ELEM_COPY, "&copy");

	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

CViecFC *CPDEProcess::MakeCopy(CViecFC *pelm)
{
	if(!pelm) return NULL;
	if(!pelm->IsKindOf(RUNTIME_CLASS(CViecFC)))
		return NULL;
	return pelm->Copy();
}

BOOL CPDEProcess::GetInputOutput(CViecFC*& pin, CViecFC*& pout)
{
	if(GetInputCount()!=1) {
		MessageBox(NULL, "no input elem", "ERR", MB_OK);
		return FALSE;
	}
	if(GetOutputCount()!=1) {
		MessageBox(NULL, "no input elem", "ERR", MB_OK);
		return FALSE;
	}
	pin = (CViecFC *) GetInputChild(0);
	pout = (CViecFC *) GetOutputChild(0);
	if(pin->IsKindOf(RUNTIME_CLASS(CIElem))) {
		pin = ((CIElem*) pin)->GetBody();
	}
	if(pout->IsKindOf(RUNTIME_CLASS(CIElem))) {
		pout = ((CIElem*) pout)->GetBody();
	}
	if(!pin->IsKindOf(RUNTIME_CLASS(CViecFC))) {
		MessageBox(NULL, "input elem error", "ERR", MB_OK);
		return FALSE;
	}
	if(!pout->IsKindOf(RUNTIME_CLASS(CViecFC))) {
		MessageBox(NULL, "input elem error", "ERR", MB_OK);
		return FALSE;
	}
	if(pin->GetCount()!=1) {
		MessageBox(NULL, "input or output number ", "ERR", MB_OK);
		return FALSE;
	}
	return TRUE;
}

int CPDEProcess::OnCommand(UINT id)
{
	return CPDEBase::OnCommand(id);
}

BOOL CPDEProcess::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_CAN_SKIP_ONCREATED_PROC:
		if(GetMode()==modeClose && !GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
			((CSuitCase *) el)->m_int = TRUE;
		else
			((CSuitCase *) el)->m_int = FALSE;
		return TRUE;
	}
	return CPDEBase::SendMsg(msg, el);
}

/////////////////  CPDEObject  //////////////////
/////////////////  CPDEObject  //////////////////

CPDEObject::CPDEObject()
{
	SetMode(modeClose);
}

int CPDEObject::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	if(GetMode()!=modeOpen)
		return CPDEBase::CalcExt(dir);
	CalcExtMidVert(dir, 20);

	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
//	return CPDEBase::CalcExt(dir);
}

void CPDEObject::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	if(m_mode!=modeClose) {
		OnDrawChild(pdc, p);
	} else {
		COLORREF rgb;
		CRect r0=m_extent;
		r0.OffsetRect(m_org);
		r0.OffsetRect(p);
		CRect rD(r0.left+4, r0.top+4, r0.right-4, r0.bottom-4);
		if(m_bFocus) rgb = pdc->SetTextColor(RGB(0,0,255));
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		pdc->DrawText(GetName(), lstrlen(GetName()), &rD, GetFormat());
		SetOldGdiObject(pdc);
//		OnDrawRel(pdc, p);
	}
}

int CPDEObject::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);

//	pMenu->AppendMenu(MF_STRING, CMD_PROC_ELEM_COPY, "&copy");
//	pMenu->AppendMenu(MF_STRING, CMD_PROC_FORM_STRCT, "&form new process");

	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDEObject::OnCommand(UINT id)
{
	return CPDEBase::OnCommand(id);
}

BOOL CPDEObject::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_CAN_SKIP_ONCREATED_PROC:
		if(GetMode()==modeClose && !GetParent()->IsKindOf(RUNTIME_CLASS(CElemView)))
			((CSuitCase *) el)->m_int = TRUE;
		else
			((CSuitCase *) el)->m_int = FALSE;
		return TRUE;
	case MSG_INCLUDE_CHILD_IN_MATH_TABLE:
		if(el && ((CSuitCase *) el)->m_case->IsKindOf(RUNTIME_CLASS(CMSMatrix)))
			((CSuitCase *) el)->m_int = TRUE;
		return TRUE;
	}
	return CPDEBase::SendMsg(msg, el);
}

//////////////////   CPDEPosDef   /////////////////////
//////////////////   CPDEPosDef   /////////////////////

CPDEPosDef::CPDEPosDef()
{
	m_bZoneFg = TRUE;
	m_extent = CRect(0,0,100,100);
	for(int i=0;i<3;i++)
		m_pos[i] = 1;
	m_velocity = 0;
}

int CPDEPosDef::CalcExt(dirMode dir)
{
	if(dir==dirUp && GetParent())
		return GetParent()->CalcExt(dir);
	return FALSE;
}

void CPDEPosDef::CopyBody(CViecFC *pelm)
{
	CPDEPosDef *pCp = (CPDEPosDef *) pelm;
	CPDEBase::CopyBody(pelm);
	for(int i=0; i<3; i++)
		pCp->m_pos[i] = m_pos[i];
	pCp->m_velocity = m_velocity;
}

void CPDEPosDef::SerializeBody(CArchive& ar)
{
	int i;
	CPDEBase::SerializeBody(ar);
	if(ar.IsStoring()) {
		for(i=0;i<3;i++) {
			ar << m_pos[i];
		}
		ar << m_velocity;
	} else {
		for(i=0;i<3;i++) {
			ar >> m_pos[i];
		}
		ar >> m_velocity;
	}
}

int CPDEPosDef::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	switch(nChar) {
	case (UINT)'V':
		switch(MyGetKeyState()) {
		case SS_NOTHING:
			m_velocity++;
			if(m_velocity>3)
				m_velocity=0;
			InvalidateRect(CPoint(0,0));
			return TRUE;
		}
		break;
	case VK_LEFT:
		switch(MyGetKeyState()) {
		case SS_SHIFT:
			m_pos[0] = 0;
			InvalidateRect(CPoint(0,0));
			return TRUE;
		}
		break;
	case VK_RIGHT:
		switch(MyGetKeyState()) {
		case SS_SHIFT:
			m_pos[0] = 1;
			InvalidateRect(CPoint(0,0));
			return TRUE;
		}
		break;
	case VK_UP:
		switch(MyGetKeyState()) {
		case SS_SHIFT:
			m_pos[1] = 1;
			InvalidateRect(CPoint(0,0));
			return TRUE;
		}
		break;
	case VK_DOWN:
		switch(MyGetKeyState()) {
		case SS_SHIFT:
			m_pos[1] = 0;
			InvalidateRect(CPoint(0,0));
			return TRUE;
		}
		break;
	}
	return CPDEBase::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CPDEPosDef::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,255) : RGB(0,0,0);

	int wd, hg;
	CRect rct = GetRect();
	rct.OffsetRect(p);
	wd = rct.Width() / 6;
	hg = rct.Height() / 6;
	SetPen(pdc, PS_SOLID, 1, col);
	SetBrush(pdc, RGB(255,255,255));

	pdc->Rectangle(rct);
	pdc->MoveTo(rct.left + wd, rct.bottom - hg);
	pdc->LineTo(rct.right - wd, rct.bottom - hg);
	pdc->LineTo(rct.right - wd, rct.bottom - 5*hg);
	pdc->LineTo(rct.left + wd, rct.bottom - 5*hg);
	pdc->LineTo(rct.left + wd, rct.bottom - hg);

	SetPen(pdc, PS_DOT, 1, RGB(0,0,0));
	pdc->MoveTo(rct.left + wd, rct.bottom - 3*hg);
	pdc->LineTo(rct.right - wd, rct.bottom - 3*hg);
	pdc->MoveTo(rct.left + 3*wd, rct.bottom - 5*hg);
	pdc->LineTo(rct.left + 3*wd, rct.bottom - hg);

	SetPen(pdc, PS_SOLID, 1, RGB(0,0,0));
	CPoint p1(rct.left + 2*wd, rct.bottom - hg/2);
	CPoint p2(rct.right - 2*wd, rct.bottom -hg/2);
	DrawArrow(pdc, p1, p2);
	p1 = CPoint(rct.left + wd/2, rct.bottom - 2*hg);
	p2 = CPoint(rct.left + wd/2, rct.top + hg*2);
	DrawArrow(pdc, p1, p2);

	p1 = CPoint(rct.left + wd, rct.bottom - hg);
	p1.x += m_pos[0] * wd * 2;
	p1.y -= m_pos[1] * hg * 2;
	int wd3,hg3;
	wd3 = wd>4? wd/4 : 1;
	hg3 = hg>4? hg/4 : 1;
	pdc->Ellipse(p1.x-wd3, p1.y-hg3, p1.x+wd3, p1.y+hg3);

	int vvx = 0, vvy = 0;
	switch(m_velocity) {
	case 1:
		vvx = wd3*3;
		break;
	case 2:
		vvy = hg3*3;
		break;
	}
	if(vvx!=0 || vvy!=0) {
		SetPen(pdc, PS_SOLID, 1, RGB(0,130,0));
		CPoint p01(p1.x-vvx, p1.y+vvy);
		CPoint p02(p1.x+vvx, p1.y-vvy);
		DrawArrow(pdc, p01, p02);
	}

	SetFont(pdc, hg, GetFont(), m_nCharSet);
	pdc->TextOut(rct.left +wd, rct.bottom -hg, "i");
	SetFont(pdc, hg, GetFont(), m_nCharSet);
	pdc->TextOut(rct.left+wd/3, rct.bottom - 3*hg/2, "j");
}

//////////////  CPDEDepInfo  //////////////
//////////////  CPDEDepInfo  //////////////

CPDEDepInfo::CPDEDepInfo()
{
	m_bFindFirst = TRUE;
}

BOOL CPDEDepInfo::CreateDep1D(const char *nm, const char *var, int s1, int s2)
{
	while(GetCount())
		delete m_child.RemoveTail();
	CMSDep *pvar;
	CViecFC *desc;
	CPDEPosDef *pos;

	pvar = new CMSDepVar;
	pvar->SetName(var, m_nDot+1, m_nCharSet);
	AddTail(pvar);

	desc = new CViecFC;
	desc->SetName(nm, m_nDot, m_nCharSet);
	AddTail(desc);
	
	pos = new CPDEPosDef;
	pos->m_pos[0] = s1;
	pos->m_pos[1] = s2;
	AddTail(pos);

//	CPDESet *pSet = new CPDESet;
	CPDESolvSet *pSet = new CPDESolvSet;
	AddTail(pSet);

	return TRUE;
}

BOOL CPDEDepInfo::CreateDep2D(const char *nm, const char *var, int s1, int s2)
{
	while(GetCount())
		delete m_child.RemoveTail();
	CMSDep *pvar;
	CViecFC *desc;
	CPDEPosDef *pos;

	pvar = new CMSDepVar;
	pvar->SetName(var, m_nDot+1, m_nCharSet);
	AddTail(pvar);

	desc = new CViecFC;
	desc->SetName(nm, m_nDot, m_nCharSet);
	AddTail(desc);
	
	pos = new CPDEPosDef;
	pos->m_pos[0] = s1;
	pos->m_pos[1] = s2;
	AddTail(pos);

//	CPDESet *pSet = new CPDESet;
	CPDESolvSet *pSet = new CPDESolvSet;
	AddTail(pSet);

	return TRUE;
}

BOOL CPDEDepInfo::CreateDep3D(const char *nm, const char *var, int s1, int s2)
{
	while(GetCount())
		delete m_child.RemoveTail();
	CMSDep *pvar;
	CViecFC *desc;
	CPDEPosDef *pos;

	pvar = new CMSDepVar;
	pvar->SetName(var, m_nDot+1, m_nCharSet);
	AddTail(pvar);

	desc = new CViecFC;
	desc->SetName(nm, m_nDot, m_nCharSet);
	AddTail(desc);
	
	pos = new CPDEPosDef;
	pos->m_pos[0] = s1;
	pos->m_pos[1] = s2;
	AddTail(pos);

//	CPDESet *pSet = new CPDESet;
	CPDESolvSet *pSet = new CPDESolvSet;
	AddTail(pSet);

	return TRUE;
}

int CPDEDepInfo::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	if(GetMode()!=modeOpen)
		return CPDEBase::CalcExt(dir);
	CalcExtVert(dir, 5);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDEDepInfo::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	if(m_mode!=modeClose) {
		OnDrawChild(pdc, p);
	} else {
		COLORREF rgb;
		CRect r0=m_extent;
		r0.OffsetRect(m_org);
		r0.OffsetRect(p);
		CRect rD(r0.left+4, r0.top+4, r0.right-4, r0.bottom-4);
		if(m_bFocus) rgb = pdc->SetTextColor(RGB(0,0,255));
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		pdc->DrawText(GetName(), lstrlen(GetName()), &rD, GetFormat());
		SetOldGdiObject(pdc);
//		OnDrawRel(pdc, p);
	}
}

BOOL CPDEDepInfo::OnCreated(EnumOnCreated bSkp)
{
	if(GetCount()<3)
		return FALSE;
	POSITION pos;
	pos = GetHeadPosition();
	m_var = (CMSDepVar *) GetNext(pos);
	m_descript = (CViecFC *) GetNext(pos);
	m_pos = (CPDEPosDef *) GetNext(pos);

	return CPDEBase::OnCreated(bSkp);
}

int CPDEDepInfo::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);

	pMenu->AppendMenu(MF_STRING, CMD_NEW_PDE_SET, "a new PDE &set");

	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDEDepInfo::OnCommand(UINT id)
{
	switch(id) {
	case CMD_NEW_PDE_SET:
		{
//			CPDESet *pSet = new CPDESet;
			CPDESolvSet *pSet = new CPDESolvSet;
			AddTail(pSet);
			OnCreated();
			CalcExt(dirDown);
			CalcExt(dirUp);
		}
		return TRUE;
	case CMD_LOAD_PDE_SLV_SET:
		{
		CArchive *ar;
		CString head;
		CViecFC *pInf;
		
		pInf = (CViecFC*) GetParent(); //ẽ|C^[	(CPDEInfo)	
		if(pInf->GetCount()<2) return TRUE;

		ar = OpenFile("..\\temp\\_com.tmp", modeRead); //testpobj
		if(ar==NULL) break;
		*ar >> head;
		CViecFC *pelm, *pOld2;
		pelm = GetUnknownElem(*ar, head);
		CloseFile();
		if(pelm==NULL) return FALSE;

		POSITION pos2;
		BOOL SlvFlg;
		SlvFlg = FALSE; //CPDESolvset݂邩AȂ
		
		pos2 = this->GetHeadPosition();
		while(pos2){ //CPDEDepInfo̎q𒲂ׂ
			pOld2 = (CViecFC*) this->GetNext(pos2);
			if(pOld2->IsKindOf(RUNTIME_CLASS(CPDESolvSet))){ //CPDEDepInfo̒CPDESolvSetłɑ݂Ă
				SlvFlg = TRUE;
				this->RemoveTail(); //Ō̎q폜
				//this->SubstChild(pOld2, pelm);
				this->AddTail(pelm); //VSolverTailB
				break;
			}
		}
		if(!SlvFlg) this->AddTail(pelm); //CPDESolvSetB

		s_MathSymbMapTable.RemoveAll();
		OnCreated(DO_ALL);
		pelm->CalcExt(dirDown);
		pelm->SendMsg(MSG_RECALC_ALL_VIEW, NULL);
		CalcExt();
		pelm->InvalidateRect(CPoint(0,0));

		return TRUE;
		}
	}
	return CPDEBase::OnCommand(id);
}

BOOL CPDEDepInfo::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_CAN_THIS_DISAPPEAR:
		if(el==m_var || el==m_pos || el==m_descript)
			return FALSE;
		return TRUE;
	case MSG_INCLUDE_CHILD_IN_MATH_TABLE:
		{
			CSuitCase *pSC = (CSuitCase *) el;
			pSC->m_int = FALSE;
			if(pSC->m_case==m_var)
				pSC->m_int = TRUE;
			return TRUE;
		}
	}
	return CPDEBase::SendMsg(msg, el);
}

//////////////   CPDEParaInfo   //////////////
//////////////   CPDEParaInfo   //////////////

int CPDEParaInfo::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);
	pMenu->AppendMenu(MF_STRING, CMD_NEW_PARAM, "new &parameter");

	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDEParaInfo::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	if(GetMode()!=modeOpen)
		return CPDEBase::CalcExt(dir);
	CalcExtVert(dir, 4);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDEParaInfo::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	if(m_mode!=modeClose) {
		OnDrawChild(pdc, p);
	} else {
		COLORREF rgb;
		CRect r0=m_extent;
		r0.OffsetRect(m_org);
		r0.OffsetRect(p);
		CRect rD(r0.left+4, r0.top+4, r0.right-4, r0.bottom-4);
		if(m_bFocus) rgb = pdc->SetTextColor(RGB(0,0,255));
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		pdc->DrawText(GetName(), lstrlen(GetName()), &rD, GetFormat());
		SetOldGdiObject(pdc);
//		OnDrawRel(pdc, p);
	}
}

BOOL CPDEParaInfo::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_INCLUDE_CHILD_IN_MATH_TABLE:
		((CSuitCase *) el)->m_int = TRUE;
		return TRUE;
	}
	return CPDEBase::SendMsg(msg, el);
}

//////////////////////// CPDEFileFold ////////////////////////////
//////////////////////// CPDEFileFold ////////////////////////////

int CPDEFileFold::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);
	pMenu->AppendMenu(MF_STRING, CMD_NEW_FILE, "new &file");
	pMenu->AppendMenu(MF_STRING, CMD_NEW_FILE_FROM, "new file f&rom");

	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDEFileFold::OnCommand(UINT id)
{
	switch(id) {
	case CMD_NEW_FILE:
		{
			AddTail(new CEFile);
			OnCreated();
			CalcExt(dirDown);
			CalcExt();
			return TRUE;
		}
	case CMD_NEW_FILE_FROM:
		{
			AddTail(new CEFileFrom);
			OnCreated();
			CalcExt(dirDown);
			CalcExt();
			return TRUE;
		}
	}
	return CPDEParaInfo::OnCommand(id);
}

int CPDELineTerm::CalcExt(dirMode dir)
{
	m_extent = CRect(0,0,0,0);
	return 1;
}

void CPDELineTerm::OnDraw(CDC *pdc, const CPoint& p)
{
//	pdc->SelectStockObject(BLACK_PEN);
//	pdc->SelectStockObject(NULL_BRUSH);
//	CRect rct = GetRect();
//	rct.OffsetRect(p);
//	pdc->Rectangle(&rct);
}

BOOL CMSUnknown2::SendMsg(int sig, CObject* obj)
{
	CString str;
	int i;
	CObject *dm;

	switch(sig) {
	case MSG_ADD_MENU:
		if(obj->IsKindOf(RUNTIME_CLASS(CMenu))) {
			CMenu *pmn = (CMenu*) obj;
			CMenu *pSmn = GetPopupMenu(FALSE);
			CMenu *pmn2 = GetPopupMenu(FALSE);
			pmn->AppendMenu(MF_POPUP, (UINT)pSmn->m_hMenu, "&operator");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_PLUS, "plus \'&+\'");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_NEG, "negative \'&-\'");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_MULT, "multiply \'&*\'");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_DIV, "divide \'&/\'");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_DERIV, "&deriv");

				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_EQUAL, "&=");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_GT, "&>");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_LT, "&<");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_GE, "&>=");
				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_LE, "&<=");

				pSmn->AppendMenu(MF_STRING, CMD_AN_UNKNOWN_TO_INT, "&integer");
			pmn->AppendMenu(MF_STRING, CMD_FIND_THE_DEP_VAR, "dependant &var");
			pmn->AppendMenu(MF_STRING, CMD_FIND_TIME_INDEX, "&time indep var");
			pmn->AppendMenu(MF_POPUP, (UINT)pmn2->m_hMenu, "&space indep var");
				pmn2->AppendMenu(MF_STRING, CMD_FIND_THE_IND_VAR, "var &x,y,z");
				pmn2->AppendMenu(MF_STRING, CMD_FIND_THE_IND_VAR2, "var &dx,dy,dz");
				pmn2->AppendMenu(MF_STRING, CMD_FIND_THE_IND_VAR3, "index &i,j,k");
				pmn2->AppendMenu(MF_STRING, CMD_FIND_THE_IND_VAR4, "&max IMAX,JMAX,KMAX");
			pmn->AppendMenu(MF_STRING, CMD_FIND_THE_PARAM, "&param");
			pmn->AppendMenu(MF_STRING, CMD_FIND_THE_MATRIX, "&matrix");
		}
		return TRUE;
	case MSG_COMMAND:
		{
			static CMapStringToOb strObj;
			static CStringArray strAry;
			CSuitCase *pSC = (CSuitCase *) obj;
			CSymbInst *pSI = (CSymbInst*) pSC->m_case;

			CViecFCList obLst;
			CSuitCase SC;
			SC.m_runtimeClass = NULL;
			char * tt = NULL;
			switch(pSC->m_int) {
			case CMD_AN_UNKNOWN_TO_INT:
				{
					CMSFract *pint = new CMSFract;
					GetAncestor()->SubstChild(pSI, pint, dirDown);
					pint->SetFocus(TRUE);
					delete pSI;
					pint->CalcExt();
					pint->InvalidateRect(CPoint(0,0));
				}
				return 1;
			case CMD_FIND_TIME_INDEX:
				{
					tt = "Time Independant var";
					obLst.RemoveAll();
					strAry.RemoveAll();
					strObj.RemoveAll();
					SC.m_oblist = &obLst;
					SC.m_runtimeClass = RUNTIME_CLASS(CPDETimeVar);
					GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
					if(!obLst.GetCount()) return FALSE;
					POSITION pos;
					CMenu *pSmn = GetPopupMenu(TRUE);
					pSmn->AppendMenu(MF_STRING, 0, tt);
					pSmn->AppendMenu(MF_SEPARATOR);
					CPDETimeVar *pInd;
					pos = obLst.GetHeadPosition();
					strAry.RemoveAll();
					int i;
					for(i=0; pos;) {
						pInd = (CPDETimeVar *) obLst.GetNext(pos);
						strAry.Add(pInd->m_pIndepVar->GetName());
						strAry.Add(pInd->m_pIndep->GetName());
						strAry.Add(pInd->m_division->GetName());
						pSmn->AppendMenu(MF_STRING, CMD_FIND_DEP_RESULT+ 0, strAry[0]);
						pSmn->AppendMenu(MF_STRING, CMD_FIND_DEP_RESULT+ 1, strAry[1]);
						pSmn->AppendMenu(MF_STRING, CMD_FIND_DEP_RESULT+ 2, strAry[2]);

						pSmn->AppendMenu(MF_SEPARATOR);
						pSmn->AppendMenu(MF_STRING, 0, "time index");
						pSmn->AppendMenu(MF_SEPARATOR);

						i = 3;
						CViecFC *sym;
						POSITION pos2 = pInd->m_indexFold->GetHeadPosition();
						while(pos2) {
							sym = (CViecFC *) pInd->m_indexFold->GetNext(pos2);
							strAry.Add(sym->GetName());
							pSmn->AppendMenu(MF_STRING, CMD_FIND_DEP_RESULT+ i, strAry[i]);
							i++;
						}
					}
					CViecFC *pel = (CViecFC *) pSC->m_case;
					pel->TrackPopupMenu(pSmn, pel->GetMenuPoint(NULL));
					return TRUE;
				}
				return TRUE;
			case CMD_FIND_THE_MATRIX:
				{
					tt = "Matrix Available";
					SC.m_runtimeClass = RUNTIME_CLASS(CMSMatrix);
					obLst.RemoveAll();
					strObj.RemoveAll();
					SC.m_oblist = &obLst;
					GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
					if(!obLst.GetCount()) return FALSE;
					POSITION pos;
					CMenu *pSmn = GetPopupMenu(TRUE);
					pSmn->AppendMenu(MF_STRING, 0, tt);
					pSmn->AppendMenu(MF_SEPARATOR);
					CMSMatrix *pMtx;
					pos = obLst.GetHeadPosition();
					for(; pos; ) {
						pMtx = (CMSMatrix *) obLst.GetNext(pos);
						strObj[pMtx->GetName()] = pMtx;
					}
					pos = strObj.GetStartPosition();
					strAry.RemoveAll();
					for(i=0; pos; i++) {
						strObj.GetNextAssoc(pos, str, dm);
						strAry.Add(str);
						pSmn->AppendMenu(MF_STRING, CMD_FIND_RESULT_WITH2+ i, str);
					}
					CViecFC *pel = (CViecFC *) pSC->m_case;
					pel->TrackPopupMenu(pSmn, pel->GetMenuPoint(NULL));
					return TRUE;
				}
			case CMD_FIND_THE_DEP_VAR:
				{
					tt = " Dependant Variable";
					SC.m_runtimeClass = RUNTIME_CLASS(CPDEDepInfo);
					obLst.RemoveAll();
					strObj.RemoveAll();
					SC.m_oblist = &obLst;
					GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
					if(!obLst.GetCount()) return FALSE;
					POSITION pos;
					CMenu *pSmn = GetPopupMenu(TRUE);
					pSmn->AppendMenu(MF_STRING, 0, tt);
					pSmn->AppendMenu(MF_SEPARATOR);
					CPDEDepInfo *pDep;
					pos = obLst.GetHeadPosition();
					for(; pos; ) {
						pDep = (CPDEDepInfo *) obLst.GetNext(pos);
						strObj[pDep->m_var->GetName()] = pDep->m_var;
					}
					pos = strObj.GetStartPosition();
					strAry.RemoveAll();
					for(i=0; pos; i++) {
						strObj.GetNextAssoc(pos, str, dm);
						strAry.Add(str);
						pSmn->AppendMenu(MF_STRING, CMD_FIND_DEP_RESULT+ i, str);
					}
					CViecFC *pel = (CViecFC *) pSC->m_case;
					pel->TrackPopupMenu(pSmn, pel->GetMenuPoint(NULL));
					return TRUE;
				}
			case CMD_FIND_THE_IND_VAR:
				{
					tt = " Independant Variable";
					obLst.RemoveAll();
					strObj.RemoveAll();
					SC.m_oblist = &obLst;
					SC.m_runtimeClass = RUNTIME_CLASS(CPDESpaceVar);
					GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
//					SC.m_runtimeClass = RUNTIME_CLASS(CPDETimeVar);
//					GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
					if(!obLst.GetCount()) return FALSE;
					POSITION pos;
					CMenu *pSmn = GetPopupMenu(TRUE);
					pSmn->AppendMenu(MF_STRING, 0, tt);
					pSmn->AppendMenu(MF_SEPARATOR);
					CPDESpaceVar *pInd;
					pos = obLst.GetHeadPosition();
					for(; pos; ) {
						pInd = (CPDESpaceVar *) obLst.GetNext(pos);
						strObj[pInd->m_pIndepVar->GetName()] = pInd->m_pIndepVar;
					}
					CString str;
					int i;
					CObject *dm;
					pos = strObj.GetStartPosition();
					strAry.RemoveAll();
					for(i=0; pos; i++) {
						strObj.GetNextAssoc(pos, str, dm);
						strAry.Add(str);
						pSmn->AppendMenu(MF_STRING, CMD_FIND_DEP_RESULT+ i, str);
					}

					CViecFC *pel = (CViecFC *) pSC->m_case;
					pel->TrackPopupMenu(pSmn, pel->GetMenuPoint(NULL));
					return TRUE;
				}
			case CMD_FIND_THE_IND_VAR2:
				{
					tt = " Independant Variable &2";
					obLst.RemoveAll();
					strObj.RemoveAll();
					SC.m_oblist = &obLst;
					SC.m_runtimeClass = RUNTIME_CLASS(CPDESpaceVar);
					GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
//					SC.m_runtimeClass = RUNTIME_CLASS(CPDETimeVar);
//					GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
					if(!obLst.GetCount()) return FALSE;
					POSITION pos;
					CMenu *pSmn = GetPopupMenu(TRUE);
					pSmn->AppendMenu(MF_STRING, 0, tt);
					pSmn->AppendMenu(MF_SEPARATOR);
					CPDESpaceVar *pInd;
					pos = obLst.GetHeadPosition();
					for(; pos; ) {
						pInd = (CPDESpaceVar *) obLst.GetNext(pos);
						strObj[pInd->m_pIndep->GetName()] = pInd->m_pIndep;
					}
					CString str;
					int i;
					CObject *dm;
					pos = strObj.GetStartPosition();
					strAry.RemoveAll();
					for(i=0; pos; i++) {
						strObj.GetNextAssoc(pos, str, dm);
						strAry.Add(str);
						pSmn->AppendMenu(MF_STRING, CMD_FIND_DEP_RESULT+ i, str);
					}

					CViecFC *pel = (CViecFC *) pSC->m_case;
					pel->TrackPopupMenu(pSmn, pel->GetMenuPoint(NULL));
					return TRUE;
				}
			case CMD_FIND_THE_IND_VAR3:
				{
					tt = " Independant Variable &2";
					obLst.RemoveAll();
					strObj.RemoveAll();
					SC.m_oblist = &obLst;
					SC.m_runtimeClass = RUNTIME_CLASS(CPDESpaceVar);
					GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
//					SC.m_runtimeClass = RUNTIME_CLASS(CPDETimeVar);
//					GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
					if(!obLst.GetCount()) return FALSE;
					POSITION pos;
					CMenu *pSmn = GetPopupMenu(TRUE);
					pSmn->AppendMenu(MF_STRING, 0, tt);
					pSmn->AppendMenu(MF_SEPARATOR);
					CPDESpaceVar *pInd;
					pos = obLst.GetHeadPosition();
					for(; pos; ) {
						pInd = (CPDESpaceVar *) obLst.GetNext(pos);
						strObj[pInd->m_pIndex->GetName()] = pInd->m_pIndex;
					}
					CString str;
					int i;
					CObject *dm;
					pos = strObj.GetStartPosition();
					strAry.RemoveAll();
					for(i=0; pos; i++) {
						strObj.GetNextAssoc(pos, str, dm);
						strAry.Add(str);
						pSmn->AppendMenu(MF_STRING, CMD_FIND_DEP_RESULT+ i, str);
					}

					CViecFC *pel = (CViecFC *) pSC->m_case;
					pel->TrackPopupMenu(pSmn, pel->GetMenuPoint(NULL));
					return TRUE;
				}
			case CMD_FIND_THE_IND_VAR4:
				{
					tt = " Independant Variable &2";
					obLst.RemoveAll();
					strObj.RemoveAll();
					SC.m_oblist = &obLst;
					SC.m_runtimeClass = RUNTIME_CLASS(CPDESpaceVar);
					GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
//					SC.m_runtimeClass = RUNTIME_CLASS(CPDETimeVar);
//					GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
					if(!obLst.GetCount()) return FALSE;
					POSITION pos;
					CMenu *pSmn = GetPopupMenu(TRUE);
					pSmn->AppendMenu(MF_STRING, 0, tt);
					pSmn->AppendMenu(MF_SEPARATOR);
					CPDESpaceVar *pInd;
					pos = obLst.GetHeadPosition();
					for(; pos; ) {
						pInd = (CPDESpaceVar *) obLst.GetNext(pos);
						strObj[pInd->m_division->GetName()] = pInd->m_division;
					}
					CString str;
					int i;
					CObject *dm;
					pos = strObj.GetStartPosition();
					strAry.RemoveAll();
					for(i=0; pos; i++) {
						strObj.GetNextAssoc(pos, str, dm);
						strAry.Add(str);
						pSmn->AppendMenu(MF_STRING, CMD_FIND_DEP_RESULT+ i, str);
					}

					CViecFC *pel = (CViecFC *) pSC->m_case;
					pel->TrackPopupMenu(pSmn, pel->GetMenuPoint(NULL));
					return TRUE;
				}
			case CMD_FIND_THE_PARAM:
				{
					tt = "&parameter";
					obLst.RemoveAll();
					strObj.RemoveAll();
					SC.m_oblist = &obLst;
					SC.m_runtimeClass = RUNTIME_CLASS(CPDEParaInfo);
					GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
					if(!obLst.GetCount()) return FALSE;
					POSITION pos;
					CMenu *pSmn = GetPopupMenu(TRUE);
					pSmn->AppendMenu(MF_STRING, 0, tt);
					pSmn->AppendMenu(MF_SEPARATOR);

					CViecFC *pSymb;
					POSITION pos2;

					CPDEParaInfo *pPara;
					pos = obLst.GetHeadPosition();
					for(; pos; ) {
						pPara = (CPDEParaInfo *) obLst.GetNext(pos);
						pos2 = pPara->GetHeadPosition();
						while(pos2) {
							pSymb = (CViecFC *) pPara->GetNext(pos2);
							strObj[pSymb->GetName()] = pSymb;
						}
					}
					CString str;
					int i;
					CObject *dm;
					pos = strObj.GetStartPosition();
					strAry.RemoveAll();
					for(i=0; pos; i++) {
						strObj.GetNextAssoc(pos, str, dm);
						strAry.Add(str);
						pSmn->AppendMenu(MF_STRING, CMD_FIND_DEP_RESULT+ i, str);
					}

					CViecFC *pel = (CViecFC *) pSC->m_case;
					pel->TrackPopupMenu(pSmn, pel->GetMenuPoint(NULL));
					return TRUE;
				}
			}
			/////   The result from selection  ///////
			int sig2 = pSC->m_int & 0xff00;
			int no = pSC->m_int & 0x00ff;
			switch(sig2) {
			case CMD_FIND_DEP_RESULT:
				{
					if(no>strAry.GetUpperBound())
						return TRUE;
					str = strAry[no];
					pSI->ChangeInst(str);
					pSI->OnCreated();
					pSI->CalcExt();
					pSI->InvalidateRect(CPoint(0,0));
				}
				return TRUE;
			case CMD_FIND_RESULT_WITH2:
				{
					CString str;
					int i;
					CObject *dm;
					POSITION pos;

					pos = strObj.GetStartPosition();
					for(i=0; pos; i++) {
						strObj.GetNextAssoc(pos, str, dm);
						if(no==i) {
							break;
						}
					}
					if(i==no) {
						pSI->ChangeInst(str);
						//--- bug 1
						pSI->m_child.RemoveAll();
						pSI->AddTail(new CSymbInst("?"));
						pSI->AddTail(new CSymbInst("?"));
						pSI->OnCreated();
						pSI->CalcExt(dirDown);
						pSI->InvalidateRect(CPoint(0,0));
					}
				}
				return TRUE;
			}
		}
		break;
	}
	return CMSUnknown::SendMsg(sig, obj);
}

/////////////////// CMSIndepVar ////////////////////
/////////////////// CMSIndepVar ////////////////////
/////////////////// CMSIndepVar ////////////////////

BOOL CMSIndepVar::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_PDE_GET_AXIS_NO:
		{
			CSuitCase *pSC;
			pSC = (CSuitCase *) el;
			CPDESpaceVar *pVar = (CPDESpaceVar *) GetParent();
			CPDESpaceVars *pVars = (CPDESpaceVars *) pVar->GetParent();
			if(!pVar->IsKindOf(RUNTIME_CLASS(CPDESpaceVar)) ||
			   !pVars->IsKindOf(RUNTIME_CLASS(CPDESpaceVars)))
				return FALSE;
			for(int i=0; i<3; i++)
				if(pVars->m_spaceVar[i]==pVar) {
					pSC->m_int = i;
					return TRUE;
				}
			return FALSE;
		}
	}
	return CMSIndep::SendMsg(msg, el);
}

/////////////////// CMSIndepConst ////////////////////
/////////////////// CMSIndepConst ////////////////////
/////////////////// CMSIndepConst ////////////////////

void CMSIndepConst::SerializeBody(CArchive& ar)
{
	CMSIndep::SerializeBody(ar);
	if(ar.IsStoring()) {
		ar << m_value;
	} else {
		ar >> m_value;
	}
}

BOOL CMSIndepConst::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_PDE_GET_AXIS_NO:
		{
			CSuitCase *pSC;
			pSC = (CSuitCase *) el;
			CPDESpaceVar *pVar = (CPDESpaceVar *) GetParent();
			CPDESpaceVars *pVars = (CPDESpaceVars *) pVar->GetParent();
			if(!pVar->IsKindOf(RUNTIME_CLASS(CPDESpaceVar)) ||
			   !pVars->IsKindOf(RUNTIME_CLASS(CPDESpaceVars)))
				return FALSE;
			for(int i=0; i<3; i++)
				if(pVars->m_spaceVar[i]==pVar) {
					pSC->m_int = i;
					return TRUE;
				}
			return FALSE;
		}
	}
	return CMSIndep::SendMsg(msg, el);
}

int CMSIndepConst::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	psub->AppendMenu(MF_STRING, CMD_CHANG_NAME, "Change &Name");
	psub->AppendMenu(MF_STRING, CMD_RECAL_SIZE, "&Recalc Size");
	if(GetParent()->SendMsg(MSG_CAN_THIS_DISAPPEAR, this))
		psub->AppendMenu(MF_STRING, CMD_ADD_DELETE, "&Delete");
	pMenu->AppendMenu(MF_STRING, CMD_INPUT_VALUE, "&input value");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CMSIndepConst::OnCommand(UINT id)
{
	switch(id) {
	case CMD_INPUT_VALUE:
		{
			CRealValueDlg dlg;
			dlg.m_value = m_value;
			dlg.m_label = "Real Number";
			if(dlg.DoModal()==IDOK) {
				m_value = dlg.m_value;
				m_extent.right++;
				GetParent()->SendMsg(MSG_CONST_CHANGED, this);
				CalcExt();
			}
		}
		return TRUE;
	}
	return CMSIndep::OnCommand(id);
}

int CMSIndepConst::CalcExt(dirMode dir)
{
	char buf[31];
	sprintf(buf, "%s = %.3lf", GetName(), m_value);
	CRect ext = GetExtent();
	CDC *pdc = GetDC();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	m_extent = GetTextExtent(pdc, buf, lstrlen(buf));
	ReleaseDC(pdc);
	CalcExtPost(dir, ext);
	return TRUE;
}

void CMSIndepConst::OnDraw(CDC *pdc, const CPoint& p)
{
	char buf[31];
	sprintf(buf, "%s = %.3lf", GetName(), m_value);
	CPoint pO = GetOrg();
	pO.Offset(p);
	COLORREF col = m_bFocus ? RGB(0,0,255) : RGB(0,0,0);
	pdc->SetTextColor(col);
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	TextOut(pdc, pO.x, pO.y, buf, lstrlen(buf));
}

CMSIndepConst::CMSIndepConst(double val)
{
	m_value = val;
}
////////////////////   CPDEDepPDE   ////////////////////
////////////////////   CPDEDepPDE   ////////////////////

BOOL CPDEBoundCond::OnCreated(EnumOnCreated bSkp)
{
	CSymbInst *pSI, *pSI2;
	if(GetCount()==0) {
		pSI = new CSymbInst("=");
		AddTail(pSI);
		pSI2 = new CSymbInst("?");
		pSI->AddTail(pSI2);
		pSI2 = new CSymbInst("?");
		pSI->AddTail(pSI2);
	}
	return CSymbInst::OnCreated(bSkp);
}

int CPDEBoundCond::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);
	pMenu->AppendMenu(MF_STRING, CMD_DEP_ADD_EQUATION, "add an &eqaution");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDEBoundCond::CalcExt(dirMode dir)
{
	POSITION pos;
	CViecFC *pelm;
	CSize sz(0,0);
	CRect ext = m_extent;
	CViecFC *psym = GetSymbBody();

	CString nm = CString("... ") + psym->GetName();
	CDC *pdc = GetDC();
	if(pdc==NULL) return FALSE;
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	sz = pdc->GetTextExtent(nm, lstrlen(nm));
	ReleaseDC(pdc);

	if(dir==dirDown && GetMode()==modeOpen) {
		pos = GetHeadPosition();
		while(pos)
			GetNext(pos)->CalcExt(dir);
	}
	int y0=0, x0;
	pos = GetHeadPosition();
	while(pos) {
		pelm = GetNext(pos);
		y0 -= pelm->GetExtent().top;
		x0 = -pelm->GetExtent().left;
		pelm->SetOrg(CPoint(x0,y0));
		y0 += pelm->GetExtent().bottom + 5;
	}
	CViecFC::CalcExt(dirNot);
	m_extent.right += 10+sz.cx;
	if(m_extent.bottom<sz.cy) m_extent.bottom = sz.cy;

	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

int CPDEBoundCond::OnCommand(UINT id)
{
	switch(id) {
	case CMD_DEP_ADD_EQUATION:
		{
			CSymbInst *pEq = new CSymbInst("=");
			CSymbInst *pEq1 = new CSymbInst("?");
			CSymbInst *pEq2 = new CSymbInst("?");
			pEq->AddTail(pEq1);
			pEq->AddTail(pEq2);
			AddTail(pEq);
			OnCreated();
			CalcExt(dirDown);
			CalcExt();
		}
		return TRUE;
	}
	return CSymbInst::OnCommand(id);
}

void CPDEBoundCond::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);

	CViecFC *psym = GetSymbBody();
	COLORREF col = m_bFocus ? RGB(0,0,255) : RGB(0,0,0);
	CRect rct = GetRect();
	rct.OffsetRect(p);
	CString nm = CString("... ") + psym->GetName();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	CSize sz = pdc->GetTextExtent(nm, lstrlen(nm));
	pdc->SetTextColor(col);
	pdc->TextOut(rct.right - sz.cx - 8, rct.bottom - sz.cy - 6, nm);

	OnDrawChild(pdc, p);
//	CSymbInst::OnDraw(pdc, p);
}

