#include "stdafx.h"
#include <math.h>

#include "pde_adv.h"
#include "jd_prc.h"

#include "pde_msg.h"

IMPLEMENT_ELEM(CPDEBoundDefs, CPDEBase, 208)
IMPLEMENT_ELEM(CPDEBoundDef, CPDEBase, 209)
IMPLEMENT_ELEM(CPDEMeshMap, CPDEBase, 206)
IMPLEMENT_ELEM(CPDEMeshInfo, CPDEBase, 207)
IMPLEMENT_ELEM(CBoundLine, CSymbInst, 243)
IMPLEMENT_ELEM(COnePointOnAxis, CMSInteger, 248)
IMPLEMENT_ELEM(COnePointOnAxisOfMesh, COnePointOnAxis, 249)
IMPLEMENT_ELEM(CSurfOnAxisOfMesh, CPointOnAxisOfMesh, 247)
IMPLEMENT_ELEM(CRangeOnAxisOfMesh, CPointOnAxisOfMesh, 246)
IMPLEMENT_ELEM(CMSMeshSize, CMSCInteger, 214)
IMPLEMENT_ELEM(CPointOnAxis, CSymbInst, 241)
IMPLEMENT_ELEM(CHalfAndDir, CViecFC, 211)
IMPLEMENT_ELEM(CPointOnAxisOfMesh, CPointOnAxis, 242)
IMPLEMENT_ELEM(CRangeOnAxis, CPointOnAxis, 245)

/////////////// CPDEBoundDef ////////////////////
/////////////// CPDEBoundDef ////////////////////

BOOL CPDEBoundDef::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_PDE_GET_BOUND_INFO:
		{
			CPDESpaceVar *pVar1, *pVar2, *pVar3;
			CSuitCase *pSC = (CSuitCase *) el;
//			pVar3 = (CPDESpaceVar *) m_range2->GetInst()->GetParent();

			//---
			pVar1 = (CPDESpaceVar *) m_surf->GetSymbBody()->GetParent();
			pSC->m_intAry[0] = m_surf->m_axisNo; // surface axis
			pSC->m_intAry[1] = m_surf->m_pAt->m_value;
			if(pSC->m_intAry[1]<=0)
				pSC->m_intAry[1] = pVar1->m_division->m_value + pSC->m_intAry[1];
			pSC->m_intAry[2] = m_surf->m_pHalfDir->m_bPosDir;
			pSC->m_intAry[3] = m_surf->m_pHalfDir->m_bHalf;

			if(m_range) {
				pVar2 = (CPDESpaceVar *) m_range->GetSymbBody()->GetParent();
				pSC->m_intAry[4] = m_range->m_axisNo;
				pSC->m_intAry[5] = m_range->m_pFrom->m_value;
				if(pSC->m_intAry[5]<=0)
					pSC->m_intAry[5] = pVar2->m_division->m_value + pSC->m_intAry[5];
				pSC->m_intAry[6] = m_range->m_pTo->m_value;
				if(pSC->m_intAry[6]<=0)
					pSC->m_intAry[6] = pVar2->m_division->m_value + pSC->m_intAry[6];
			}
			if(m_range2) {
				pVar3 = (CPDESpaceVar *) m_range2->GetSymbBody()->GetParent();
				pSC->m_intAry[7] = m_range2->m_axisNo;
				pSC->m_intAry[8] = m_range2->m_pFrom->m_value;
				if(pSC->m_intAry[8]<=0)
					pSC->m_intAry[8] = pVar2->m_division->m_value + pSC->m_intAry[8];
				pSC->m_intAry[9] = m_range->m_pTo->m_value;
				if(pSC->m_intAry[9]<=0)
					pSC->m_intAry[9] = pVar2->m_division->m_value + pSC->m_intAry[9];
			}
//			pSC->m_intAry[1] = m_surf->m_pHalfDir->
//			m_intAry[1] = pBD->m_surf->m_halfDir
//			pBD->m_range1;
		}
		return TRUE;
	}
	return CPDEBase::SendMsg(msg, el);
}

BOOL CPDEBoundDef::CreateBoundDef1D(const char* mainInd, int at, BOOL posiDir, BOOL half)
{
	COnePointOnAxis *pNat;
	CViecFC *pS;
	CHalfAndDir *pH;

	pS = new CSurfOnAxisOfMesh(mainInd);
	AddTail(pS);

	pH = new CHalfAndDir;
	pNat = new COnePointOnAxisOfMesh;

	pH->m_bHalf = half;
	pH->m_bPosDir = posiDir;
	pNat->m_value = at;

	pS->AddTail(pH);
	pS->AddTail(pNat);


	return TRUE;
}

/////for 2D
BOOL CPDEBoundDef::CreateBoundDef(const char* mainInd, int at, BOOL posiDir, BOOL half
   , const char* rangeInd, int from, int to)
{
	COnePointOnAxis *pNat, *pNfrom, *pNto;
	CViecFC *pS, *pR;
	CHalfAndDir *pH;

	pS = new CSurfOnAxisOfMesh(mainInd);
	pR = new CRangeOnAxisOfMesh(rangeInd);
	AddTail(pS);
	AddTail(pR);

	pH = new CHalfAndDir;
	pNat = new COnePointOnAxisOfMesh;
	pNfrom = new COnePointOnAxisOfMesh;
	pNto = new COnePointOnAxisOfMesh;

	pH->m_bHalf = half;
	pH->m_bPosDir = posiDir;
	pNat->m_value = at;
	pNfrom->m_value = from;
	pNto->m_value = to;

	pS->AddTail(pH);
	pS->AddTail(pNat);

	pR->AddTail(pNfrom);
	pR->AddTail(pNto);


	return TRUE;
}
/////Kawa for 3D
BOOL CPDEBoundDef::CreateBoundDef3D(const char* mainInd, int at, BOOL posiDir, BOOL half
   , const char* rangeInd, int from, int to, const char* rangeInd2, int from2, int to2)
{
	COnePointOnAxis *pNat, *pNfrom, *pNto, *pNfrom2, *pNto2;
	CViecFC *pS, *pR, *pR2;
	CHalfAndDir *pH;

	pS = new CSurfOnAxisOfMesh(mainInd);
	pR = new CRangeOnAxisOfMesh(rangeInd);
	pR2 = new CRangeOnAxisOfMesh(rangeInd2);
	AddTail(pS);
	AddTail(pR);
	AddTail(pR2);

	pH = new CHalfAndDir;
	pNat = new COnePointOnAxisOfMesh;
	pNfrom = new COnePointOnAxisOfMesh;
	pNto = new COnePointOnAxisOfMesh;
	pNfrom2 = new COnePointOnAxisOfMesh;
	pNto2 = new COnePointOnAxisOfMesh;

	pH->m_bHalf = half;
	pH->m_bPosDir = posiDir;
	pNat->m_value = at;
	pNfrom->m_value = from;
	pNto->m_value = to;
	pNfrom2->m_value = from;
	pNto2->m_value = to;

	pS->AddTail(pH);
	pS->AddTail(pNat);

	pR->AddTail(pNfrom);
	pR->AddTail(pNto);
	pR2->AddTail(pNfrom2);
	pR2->AddTail(pNto2);


	return TRUE;
}

int CPDEBoundDef::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	CalcExtHMerg(dir, GetName(), 20);
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDEBoundDef::OnDraw(CDC *pdc, const CPoint& p)
{
	COLORREF col = m_bFocus? RGB(0,0,255) : RGB(0,0,0);
	CRect rct = GetRect();
	rct.OffsetRect(p);
	pdc->SetTextColor(col);
	pdc->TextOut(rct.left, rct.top, GetName());

//	OnDrawName(pdc, p);
	OnDrawChild(pdc, p);
}

BOOL CPDEBoundDef::OnCreated(EnumOnCreated bSkp)
{
	POSITION pos;
	if(!CPDEBase::OnCreated(bSkp))
		return FALSE;
	m_surf = NULL;
	m_range = NULL;
	m_range2 = NULL;
	pos = GetHeadPosition();
	if(pos)	{
		m_surf = (CSurfOnAxisOfMesh *) GetNext(pos);
		if(m_surf->IsKindOf(RUNTIME_CLASS(CIElem)))
			m_surf = (CSurfOnAxisOfMesh *) ((CIElem *)m_surf)->GetBody();
	}
	if(pos)	{
		m_range = (CRangeOnAxisOfMesh *) GetNext(pos); //1߂CrangeOnAxisOfMesh
		if(m_range->IsKindOf(RUNTIME_CLASS(CIElem)))
			m_range = (CRangeOnAxisOfMesh *) ((CIElem *)m_range)->GetBody();
	}
	if(pos)	{
		m_range2 = (CRangeOnAxisOfMesh *) GetNext(pos); //2߂CrangeOnAxisOfMeshi3̂ƂgpȂj
		if(m_range2->IsKindOf(RUNTIME_CLASS(CIElem)))
			m_range2 = (CRangeOnAxisOfMesh *) ((CIElem *)m_range2)->GetBody();
	}
	return TRUE;
}

/////////////////  CPDEMeshMap ////////////////
/////////////////  CPDEMeshMap ////////////////

int CPDEMeshMap::OnDrop(const CPoint& last)
{
	int rt;
	if(m_bDrag) {
		rt = CPDEBase::OnDrop(last);
		m_extent.right++;
		CalcExt();
//		GetView()->CalcExt(dirDown);
	} else {
		rt = CPDEBase::OnDrop(last);
	}
	return rt;
}

CPDEMeshMap::CPDEMeshMap()
{
	SetDragAllow(TRUE);
	m_bZoneFg = TRUE;
	m_extent = CRect(-8, -6, 158, 156);
	m_meshInfo = NULL;
}

void CPDEMeshMap::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);

	CPoint p0 = p;
	p0.Offset(GetOrg());

	CRect rct = m_extIn;
	rct.OffsetRect(p0);

	CPoint pOrg(rct.left, rct.bottom);
	CSize sFrm(rct.Width(), rct.Height());

	pdc->SelectStockObject(BLACK_PEN);
	int i,j;
	int xx, yy;
	for(i=0; i<=m_meshNo[0]; i++) {
		xx = i * sFrm.cx / m_meshNo[0];
		pdc->MoveTo(rct.left + xx, rct.top);
		pdc->LineTo(rct.left + xx, rct.bottom);
	}
	for(j=0; j<=m_meshNo[1]; j++) {
		yy = - j * sFrm.cy / m_meshNo[1];
		pdc->MoveTo(rct.left, rct.bottom + yy);
		pdc->LineTo(rct.right, rct.bottom + yy);
	}

	OnDrawChild(pdc, p);
}

int CPDEMeshMap::CalcExt(dirMode dir)
{
	POSITION pos;
	
	int dw1 = m_meshInfo->m_spaceVars->GetExtent().Width();
	int dw2 = m_meshInfo->m_boundDefs->GetExtent().Width();

	int dw = m_extent.Width();
	int dh = m_extent.Height();
	if(dw<dw1) dh = dw = dw1;
	if(dw<dw2) dh = dw = dw2;
	CRect ext = m_extent;

	m_extent.left = -8;
	m_extent.right = -8 + dw;
	m_extent.top = -6;
	m_extent.bottom = -6 + dh;

	m_extIn.left = m_extent.left + 20;
	m_extIn.right = m_extent.right - 20;
	m_extIn.top = m_extent.top + 20;
	m_extIn.bottom = m_extent.bottom - 20;

	if(dir==dirDown && GetMode()==modeOpen) {
		pos = GetHeadPosition();
		while(pos) {
			GetNext(pos)->CalcExt(dir);
		}
	}
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	return TRUE;
}

BOOL CPDEMeshMap::OnCreated(EnumOnCreated bSkp)
{
	SetMode(modeOpen);
	m_meshInfo = (CPDEMeshInfo *) GetParent();
	if(m_meshInfo->IsKindOf(RUNTIME_CLASS(CElemView)))
		m_meshInfo = (CPDEMeshInfo *) GetInstBody()->GetParent();
	if(!m_meshInfo->IsKindOf(RUNTIME_CLASS(CPDEMeshInfo)))
		return FALSE;
	BOOL rt = CPDEBase::OnCreated(bSkp);
	CSuitCase SC;
	SendMsg(MSG_PDE_MESH_CHANGED, &SC);
	return rt;
}

BOOL CPDEMeshMap::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_PDE_MESH_CHANGED:
		{
			int i;
			CSuitCase SC;
			POSITION pos;
			m_meshInfo->m_spaceVars->SendMsg(MSG_PDE_GET_MESH_NO, &SC);
			for(i=0; i<SC.m_int; i++)
				m_meshNo[i] = SC.m_intAry[i];
			for(;i<3;i++)
				m_meshNo[i] = 0;
	
//			pos = GetHeadPosition();
//			while(pos) {
//				CSymbInst *pInst;
//				pInst = (CSymbInst *) GetNext(pos);
//				if(pInst->GetInst()->IsKindOf(RUNTIME_CLASS(CObString)))
//					delete pInst->GetInst();
//			}
			
			while(GetCount())
				delete m_child.RemoveTail();

			CPDEBoundDef *pBdDef;
			CBoundLine *bdLine;
			CPDEBoundDefs *pBs = m_meshInfo->m_boundDefs;
			if(!pBs->IsKindOf(RUNTIME_CLASS(CPDEBoundDefs))) {
				bdLine = NULL;
				pBdDef = NULL;
			}

			pos = pBs->GetHeadPosition();
			while(pos) {
				pBdDef = (CPDEBoundDef *) pBs->GetNext(pos);
				bdLine = new CBoundLine(pBdDef);
				AddTail(bdLine);
				bdLine->CalcExt(dirNot);
			}
			InvalidateRect(CPoint(0,0));
		}
	}
	return CPDEBase::SendMsg(msg, el);
}

/////////////////  CPDEMeshInfo ////////////////
/////////////////  CPDEMeshInfo ////////////////

int CPDEMeshInfo::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	if(GetMode()!=modeOpen)
		return CPDEBase::CalcExt(dir);
	CalcExtVert(dir);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	CalcExtPost(dir, ext);
	return TRUE;
}

void CPDEMeshInfo::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	if(m_mode==modeClose) {
		OnDrawClose(pdc, p);
	} else {
		OnDrawChild(pdc, p);
	}
}

BOOL CPDEMeshInfo::CreateMeshInfo1()
{
//	CPDETimeVar *timeVar = new CPDETimeVar;
	CPDESpaceVars* spaceVars = new CPDESpaceVars;
	CPDEBoundDefs* boundDefs = new CPDEBoundDefs;
	CPDEMeshMap* meshMap = new CPDEMeshMap;
//	AddTail(timeVar);
	AddTail(spaceVars);
	AddTail(boundDefs);
	AddTail(meshMap);

//	timeVar->SetName("time_ind", m_nDot, m_nCharSet);
//	timeVar->CreateTimeVar("t", "dt", "n", "NMAX", 1000);

	spaceVars->SetMode(modeOpen);
	CPDESpaceVar *pvar1 = new CPDESpaceVar;
	pvar1->SetName("space_ind1", m_nDot, m_nCharSet);
	pvar1->CreateSpace("x", "dx", "i", "IMAX", 20);
	CPDESpaceVar *pvar2 = new CPDESpaceVar;
	pvar2->SetName("space_ind2", m_nDot, m_nCharSet);
	pvar2->CreateSpace("y", "dy", "j", "JMAX", 20);
	spaceVars->AddTail(pvar1);
	spaceVars->AddTail(pvar2);

	CPDEBoundDef *pbd;
	//--- LEFT
	pbd = new CPDEBoundDef;
	pbd->SetName("LEFT", m_nDot, m_nCharSet);

	pbd->CreateBoundDef("x", 1, TRUE, TRUE, "y", 1, -1);
	boundDefs->AddTail(pbd);
	//--- RIGHT
	pbd = new CPDEBoundDef;
	pbd->SetName("RIGHT", m_nDot, m_nCharSet);
	pbd->CreateBoundDef("x", -1, FALSE, TRUE, "y", 1, -1);
	boundDefs->AddTail(pbd);
	//--- BOTTOM
	pbd = new CPDEBoundDef;
	pbd->SetName("BTTM", m_nDot, m_nCharSet);
	pbd->CreateBoundDef("y", 1, FALSE, TRUE, "x", 1, -1);
	boundDefs->AddTail(pbd);
	//--- TOP
	pbd = new CPDEBoundDef;
	pbd->SetName("TOP", m_nDot, m_nCharSet);
	pbd->CreateBoundDef("y", -1, TRUE, TRUE, "x", 1, -1);
	boundDefs->AddTail(pbd);

	CPDEParaInfo *pPara = new CPDEParaInfo;
	AddTail(pPara);

	CMSCReal *pInt;
	pInt = new CMSCReal;
	pInt->SetName("Re", m_nDot, m_nCharSet);
	pPara->AddTail(pInt);
	pInt = new CMSCReal;
	pInt->SetName("U0", m_nDot, m_nCharSet);
	pPara->AddTail(pInt);

	CMSMatrix *pmtx;
	pmtx = new CMSMatrix;
	pmtx->SetName("MxP", m_nDot, m_nCharSet);
	AddTail(pmtx);

	return TRUE;
}

BOOL CPDEMeshInfo::CreateMeshInfo1D()
{
//	CPDETimeVar *timeVar = new CPDETimeVar;
	CPDESpaceVars* spaceVars = new CPDESpaceVars;
	CPDEBoundDefs* boundDefs = new CPDEBoundDefs;
/////Kawa	CPDEMeshMap* meshMap = new CPDEMeshMap;
//	AddTail(timeVar);
	AddTail(spaceVars);
	AddTail(boundDefs);
/////Kawa	AddTail(meshMap);

//	timeVar->SetName("time_ind", m_nDot, m_nCharSet);
//	timeVar->CreateTimeVar("t", "dt", "n", "NMAX", 1000);

	spaceVars->SetMode(modeOpen);
	CPDESpaceVar *pvar1 = new CPDESpaceVar;
	pvar1->SetName("space var #1", m_nDot, m_nCharSet);
	pvar1->CreateSpaceConst("x", "dx", "i", "IMAX", 20);
	spaceVars->AddTail(pvar1);

	CPDEBoundDef *pbd;
	//--- LEFT
	pbd = new CPDEBoundDef;
	pbd->SetName("LEFT", m_nDot, m_nCharSet);

	pbd->CreateBoundDef1D("x", 1, TRUE, TRUE);
	boundDefs->AddTail(pbd);
	//--- RIGHT
	pbd = new CPDEBoundDef;
	pbd->SetName("RIGHT", m_nDot, m_nCharSet);
	pbd->CreateBoundDef1D("x", -1, FALSE, TRUE);
	boundDefs->AddTail(pbd);

	return TRUE;
}

BOOL CPDEMeshInfo::CreateMeshInfo2()
{
//	CPDETimeVar *timeVar = new CPDETimeVar;
	CPDESpaceVars* spaceVars = new CPDESpaceVars;
	CPDEBoundDefs* boundDefs = new CPDEBoundDefs;
/////Kawa	CPDEMeshMap* meshMap = new CPDEMeshMap;
//	AddTail(timeVar);
	AddTail(spaceVars);
	AddTail(boundDefs);
/////Kawa	AddTail(meshMap);

//	timeVar->SetName("time_ind", m_nDot, m_nCharSet);
//	timeVar->CreateTimeVar("t", "dt", "n", "NMAX", 1000);

	spaceVars->SetMode(modeOpen);
	CPDESpaceVar *pvar1 = new CPDESpaceVar;
	pvar1->SetName("space var #1", m_nDot, m_nCharSet);
	pvar1->CreateSpaceConst("x", "dx", "i", "IMAX", 20);
	CPDESpaceVar *pvar2 = new CPDESpaceVar;
	pvar2->SetName("space var #2", m_nDot, m_nCharSet);
	pvar2->CreateSpaceConst("y", "dy", "j", "JMAX", 20);
	spaceVars->AddTail(pvar1);
	spaceVars->AddTail(pvar2);

	CPDEBoundDef *pbd;
	//--- LEFT
	pbd = new CPDEBoundDef;
	pbd->SetName("LEFT", m_nDot, m_nCharSet);

	pbd->CreateBoundDef("x", 1, TRUE, TRUE, "y", 1, -1);
	boundDefs->AddTail(pbd);
	//--- RIGHT
	pbd = new CPDEBoundDef;
	pbd->SetName("RIGHT", m_nDot, m_nCharSet);
	pbd->CreateBoundDef("x", -1, FALSE, TRUE, "y", 1, -1);
	boundDefs->AddTail(pbd);
	//--- BOTTOM
	pbd = new CPDEBoundDef;
	pbd->SetName("BTTM", m_nDot, m_nCharSet);
	pbd->CreateBoundDef("y", 1, TRUE, TRUE, "x", 1, -1);
	boundDefs->AddTail(pbd);
	//--- TOP
	pbd = new CPDEBoundDef;
	pbd->SetName("TOP", m_nDot, m_nCharSet);
	pbd->CreateBoundDef("y", -1, FALSE, TRUE, "x", 1, -1);
	boundDefs->AddTail(pbd);

	return TRUE;
}

BOOL CPDEMeshInfo::CreateMeshInfo3D()
{
//	CPDETimeVar *timeVar = new CPDETimeVar;
	CPDESpaceVars* spaceVars = new CPDESpaceVars;
	CPDEBoundDefs* boundDefs = new CPDEBoundDefs;
/////Kawa	CPDEMeshMap* meshMap = new CPDEMeshMap;
//	AddTail(timeVar);
	AddTail(spaceVars);
	AddTail(boundDefs);
/////Kawa	AddTail(meshMap);

//	timeVar->SetName("time_ind", m_nDot, m_nCharSet);
//	timeVar->CreateTimeVar("t", "dt", "n", "NMAX", 1000);

	spaceVars->SetMode(modeOpen);
	CPDESpaceVar *pvar1 = new CPDESpaceVar;
	pvar1->SetName("space var #1", m_nDot, m_nCharSet);
	pvar1->CreateSpaceConst("x", "dx", "i", "IMAX", 20);
	CPDESpaceVar *pvar2 = new CPDESpaceVar;
	pvar2->SetName("space var #2", m_nDot, m_nCharSet);
	pvar2->CreateSpaceConst("y", "dy", "j", "JMAX", 20);
	CPDESpaceVar *pvar3 = new CPDESpaceVar;
	pvar3->SetName("space var #3", m_nDot, m_nCharSet);
	pvar3->CreateSpaceConst("z", "dz", "k", "KMAX", 20);

	spaceVars->AddTail(pvar1);
	spaceVars->AddTail(pvar2);
	spaceVars->AddTail(pvar3);

	CPDEBoundDef *pbd;
	//--- LEFT
	pbd = new CPDEBoundDef;
	pbd->SetName("LEFT", m_nDot, m_nCharSet);

	pbd->CreateBoundDef3D("x", 1, TRUE, TRUE, "y", 1, -1, "z", 1, -1);
	boundDefs->AddTail(pbd);
	//--- RIGHT
	pbd = new CPDEBoundDef;
	pbd->SetName("RIGHT", m_nDot, m_nCharSet);
	pbd->CreateBoundDef3D("x", -1, FALSE, TRUE, "y", 1, -1, "z", 1, -1);
	boundDefs->AddTail(pbd);
	//--- BOTTOM
	pbd = new CPDEBoundDef;
	pbd->SetName("BTTM", m_nDot, m_nCharSet);
	pbd->CreateBoundDef3D("y", 1, TRUE, TRUE, "z", 1, -1, "x", 1, -1);
	boundDefs->AddTail(pbd);
	//--- TOP
	pbd = new CPDEBoundDef;
	pbd->SetName("TOP", m_nDot, m_nCharSet);
	pbd->CreateBoundDef3D("y", -1, FALSE, TRUE, "z", 1, -1, "x", 1, -1);
	boundDefs->AddTail(pbd);
	//--- FRONT
	pbd = new CPDEBoundDef;
	pbd->SetName("FRNT", m_nDot, m_nCharSet);
	pbd->CreateBoundDef3D("z", 1, TRUE, TRUE, "x", 1, -1, "y", 1, -1);
	boundDefs->AddTail(pbd);
	//--- REAR
	pbd = new CPDEBoundDef;
	pbd->SetName("REAR", m_nDot, m_nCharSet);
	pbd->CreateBoundDef3D("z", -1, FALSE, TRUE, "x", 1, -1, "y", 1, -1);
	boundDefs->AddTail(pbd);

	return TRUE;
}

BOOL CPDEMeshInfo::OnCreated(EnumOnCreated bSkp)
{
	if(GetCount()<2) {
		while(GetCount())
			delete m_child.RemoveTail();
//		m_timeVar = new CPDETimeVar;
		m_spaceVars = new CPDESpaceVars;
		m_boundDefs = new CPDEBoundDefs;
		m_meshMap = new CPDEMeshMap;
		AddTail(m_spaceVars);
		AddTail(m_boundDefs);
		AddTail(m_meshMap);
	}
	POSITION pos;
	pos = GetHeadPosition();
//	m_timeVar = (CPDETimeVar *) GetNext(pos);
//	if(m_timeVar->IsKindOf(RUNTIME_CLASS(CIElem)))
//		m_timeVar = (CPDETimeVar *) ((CIElem*)m_timeVar)->GetBody();
	m_spaceVars = (CPDESpaceVars *) GetNext(pos);
	if(m_spaceVars->IsKindOf(RUNTIME_CLASS(CIElem)))
		m_spaceVars = (CPDESpaceVars *) ((CIElem*)m_spaceVars)->GetBody();
	m_boundDefs = (CPDEBoundDefs *) GetNext(pos);
	if(m_boundDefs->IsKindOf(RUNTIME_CLASS(CIElem)))
		m_boundDefs = (CPDEBoundDefs *) ((CIElem*)m_boundDefs)->GetBody();
/////Kawa	m_meshMap = (CPDEMeshMap *) GetNext(pos);
/////Kawa	if(m_meshMap->IsKindOf(RUNTIME_CLASS(CIElem)))
/////Kawa		m_meshMap = (CPDEMeshMap *) ((CIElem*)m_meshMap)->GetBody();

	return CPDEBase::OnCreated(bSkp);
}

CPDEMeshInfo::CPDEMeshInfo()
{
	m_bFindFirst = TRUE;
}

BOOL CPDEMeshInfo::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_CAN_THIS_DISAPPEAR:
		return FALSE;
	}
	return CPDEBase::SendMsg(msg, el);
}

//////////////      CBoundLine     ////////////////
//////////////      CBoundLine     ////////////////

BOOL CBoundLine::OnCreated(EnumOnCreated bSkp)
{
	return CSymbInst::OnCreated(bSkp);
}

int CBoundLine::CalcExt(dirMode)
{
	CRect ext = m_extent;
	CPDEBoundDef *pBdDef = (CPDEBoundDef *) GetSymbBody();
	if(!pBdDef->IsKindOf(RUNTIME_CLASS(CPDEBoundDef)))
		return FALSE;
	CPDEMeshMap *pMap = (CPDEMeshMap *) GetParent();
	if(!pMap->IsKindOf(RUNTIME_CLASS(CPDEMeshMap)))
		return FALSE;

	CPoint LB(pMap->m_extIn.left, pMap->m_extIn.bottom);
	CSize sFrm(pMap->m_extIn.Width(), pMap->m_extIn.Height());
	int at, hlf, dir, f1, t1;

	CSuitCase SC;
	pBdDef->SendMsg(MSG_PDE_GET_BOUND_INFO, &SC);
	at = SC.m_intAry[1] - 1;
	dir = SC.m_intAry[2];
	hlf = SC.m_intAry[3];
	f1 = SC.m_intAry[5] - 1;
	t1 = SC.m_intAry[6] - 1;
	if(SC.m_intAry[0]==0) {
		//--- vertical line
		int wd = hlf? sFrm.cx/2 : 0;
//		int dd = sFrm.cy*2/4;
		int ww = sFrm.cx/pMap->m_meshNo[0]*2/5;
		int lf = dir? -ww : 0;
		int rt = dir? 0 : ww;
		m_verOrHor = 1;
		at = (at * sFrm.cx + wd)/ pMap->m_meshNo[0];
//		f1 = - (f1 * sFrm.cy-dd) / pMap->m_meshNo[1];
//		t1 = - (t1 * sFrm.cy+dd) / pMap->m_meshNo[1];
		f1 = - (f1 * sFrm.cy) / pMap->m_meshNo[1];
		t1 = - (t1 * sFrm.cy+sFrm.cy) / pMap->m_meshNo[1];
		m_org = CPoint(LB.x + at, LB.y + f1);
		m_extent = CRect(lf, t1 - f1, rt, 0);
		if(!dir)
			m_extent.OffsetRect(CPoint(1,0));
	} else if(SC.m_intAry[0]==1) {
		//--- horizontal line
		int wd = hlf? sFrm.cy/2 : 0;
//		int dd = sFrm.cx*2/4;
		int ww = sFrm.cy/pMap->m_meshNo[1]*2/5;
		int lf = !dir? -ww : 0;
		int rt = !dir? 0 : ww;
		m_verOrHor = 2;
		at = - (at * sFrm.cy + wd) / pMap->m_meshNo[1];
//		f1 = (f1 * sFrm.cx-dd) / pMap->m_meshNo[0];
//		t1 = (t1 * sFrm.cx+dd) / pMap->m_meshNo[0];
		f1 = (f1 * sFrm.cx) / pMap->m_meshNo[0];
		t1 = (t1 * sFrm.cx+sFrm.cx) / pMap->m_meshNo[0];
		m_org = CPoint(LB.x + f1, LB.y + at);
		m_extent = CRect(0, lf, t1 - f1, rt);
		if(!dir)
			m_extent.OffsetRect(CPoint(0,1));
	}
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CBoundLine::OnDraw(CDC *pdc, const CPoint& p)
{
	CPoint p0 = p;
	p0.Offset(GetOrg());

	CPDEBoundDef *bd = (CPDEBoundDef *) GetSymbBody();
	COLORREF col = m_bFocus ? RGB(0,200,0) : RGB(0,0,255);
	col = bd->GetFocus()? RGB(255,0,0) : col;
	int wd;

	CRect rct = GetExtent();
	rct.OffsetRect(p0);
	wd = rct.Width();
	pdc->SelectStockObject(WHITE_BRUSH);
	pdc->SelectStockObject(WHITE_PEN);
	pdc->Rectangle(&rct);
	SetPen(pdc, PS_SOLID, 1, col);
	if(m_verOrHor==1) {
		if(-m_extent.left<m_extent.right) p0.x++;
		else	p0.x--;
		pdc->MoveTo(p0.x, rct.top);
		pdc->LineTo(p0.x, rct.bottom);
	} else if(m_verOrHor==2) {
		pdc->MoveTo(rct.left, p0.y);
		pdc->LineTo(rct.right, p0.y);
	}
}

//////////////     COnePointOnAxis     //////////////////
//////////////     COnePointOnAxis     //////////////////

int COnePointOnAxis::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	CPointOnAxis *pP = (CPointOnAxis *) GetParent();
	CPDESpaceVar *pV = (CPDESpaceVar *) pP->GetSymbBody()->GetParent();
	switch(nChar) {
	case VK_UP:
		if(!pV->IsKindOf(RUNTIME_CLASS(CPDESpaceVar)))	return FALSE;
		if(m_value>=pV->m_division->m_value)	return FALSE;
		m_value += 1;
		m_extent.right++;
		CalcExt();
		return TRUE;
	case VK_DOWN:
		if(!pV->IsKindOf(RUNTIME_CLASS(CPDESpaceVar))) return FALSE;
		if(m_value<=(-pV->m_division->m_value+1)) return FALSE;
		m_value -= 1;
		m_extent.right++;
		CalcExt();
		return TRUE;
	}
	return CMSInteger::OnKeyDown(nChar, nRepCnt, nFlags);
}

void COnePointOnAxis::OnDraw(CDC *pdc, const CPoint& p)
{
	CPointOnAxis *pP = (CPointOnAxis *) GetParent();
	CPDESpaceVar *pV = (CPDESpaceVar *) pP->GetSymbBody()->GetParent();
	if(!pV->IsKindOf(RUNTIME_CLASS(CPDESpaceVar)))	return;
	if(m_value>=pV->m_division->m_value)	return;

	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	CString str;
	if(m_value==0) {
		str.Format("%s", (const char*) pV->m_division->GetName());
	} else if(m_value<0) {
		str.Format("%s%d", (const char*) pV->m_division->GetName(), m_value);
	} else {
		str.Format("%d", m_value);
	}
	CSize sz = pdc->GetTextExtent(str, lstrlen(str));
	COLORREF col = m_bFocus? RGB(0,0,255) : RGB(0,0,0);
	pdc->SetTextColor(col);
	CPoint p0 = p;
	p0.Offset(GetOrg());
	pdc->TextOut(p0.x, p0.y-sz.cy/2, str);
}

int COnePointOnAxis::CalcExt(dirMode dir)
{
	CPointOnAxis *pP = (CPointOnAxis *) GetParent();
	CPDESpaceVar *pV = (CPDESpaceVar *) pP->GetSymbBody()->GetParent();
	if(!pV->IsKindOf(RUNTIME_CLASS(CPDESpaceVar)))	return FALSE;
	if(m_value>=pV->m_division->m_value)	return FALSE;

	CRect ext = m_extent;
	CDC *pdc = GetDC();
	if(pdc==NULL) return FALSE;
	CString str;
	if(m_value==0) {
		str.Format("%s", (const char*) pV->m_division->GetName());
	} else if(m_value<0) {
		str.Format("%s%d", (const char*) pV->m_division->GetName(), m_value);
	} else {
		str.Format("%d", m_value);
	}
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	CSize sz = pdc->GetTextExtent(str, lstrlen(str));
	ReleaseDC(pdc);
	m_extent.left = 0;
	m_extent.right = sz.cx;
	m_extent.top = - sz.cy/2;
	m_extent.bottom = sz.cy + m_extent.top;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

////////////////////////// COnePointOnAxisOfMesh //////////////////////////
////////////////////////// COnePointOnAxisOfMesh //////////////////////////
////////////////////////// COnePointOnAxisOfMesh //////////////////////////

int COnePointOnAxisOfMesh::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	CPointOnAxis *pP = (CPointOnAxis *) GetParent();
	CPDESpaceVar *pV = (CPDESpaceVar *) pP->GetSymbBody()->GetParent();
	switch(nChar) {
	case VK_UP:
		if(!pV->IsKindOf(RUNTIME_CLASS(CPDESpaceVar)))	return FALSE;
		if(m_value>=pV->m_division->m_value)	return FALSE;
		m_value += 1;
		GetAncestor()->SendMsg(MSG_PDE_MESH_CHANGED, NULL);
		m_extent.right++;
		CalcExt();
		return TRUE;
	case VK_DOWN:
		if(!pV->IsKindOf(RUNTIME_CLASS(CPDESpaceVar))) return FALSE;
		if(m_value<=(-pV->m_division->m_value+1)) return FALSE;
		m_value -= 1;
		GetAncestor()->SendMsg(MSG_PDE_MESH_CHANGED, NULL);
		m_extent.right++;
		CalcExt();
		return TRUE;
	}
	return CMSInteger::OnKeyDown(nChar, nRepCnt, nFlags);
}

///////////////    CSurfOnAxisOfMesh    ///////////////
///////////////    CSurfOnAxisOfMesh    ///////////////

BOOL CSurfOnAxisOfMesh::OnCreated(EnumOnCreated bSkp)
{
	POSITION pos;
	if(GetCount()!=2)
		return FALSE;
	pos = GetHeadPosition();
	m_pHalfDir = (CHalfAndDir *) GetNext(pos);
	m_pAt = (COnePointOnAxis *) GetNext(pos);
	if(!m_pHalfDir->IsKindOf(RUNTIME_CLASS(CHalfAndDir)) ||
	   !m_pAt->IsKindOf(RUNTIME_CLASS(COnePointOnAxis)))
		return FALSE;
	return CPointOnAxis::OnCreated(bSkp);
}

/////////////// CRangeOnAxisOfMesh ///////////////
/////////////// CRangeOnAxisOfMesh ///////////////

BOOL CRangeOnAxisOfMesh::OnCreated(EnumOnCreated bSkp)
{
	POSITION pos;
	if(GetCount()!=2)
		return FALSE;
	pos = GetHeadPosition();
	m_pFrom = (COnePointOnAxis *) GetNext(pos);
	m_pTo = (COnePointOnAxis *) GetNext(pos);
	if(!m_pFrom->IsKindOf(RUNTIME_CLASS(COnePointOnAxis)) ||
	   !m_pTo->IsKindOf(RUNTIME_CLASS(COnePointOnAxis)))
		return FALSE;
	return CPointOnAxis::OnCreated(bSkp);
}

////////////////  CMSMeshSize  //////////////////
////////////////  CMSMeshSize  //////////////////

int CMSMeshSize::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	switch(nChar) {
	case VK_UP:
		m_value += 1;
		GetAncestor()->SendMsg(MSG_PDE_MESH_CHANGED, NULL);
		m_extent.right++;
		CalcExt();
		return TRUE;
	case VK_DOWN:
		m_value -= 1;
		GetAncestor()->SendMsg(MSG_PDE_MESH_CHANGED, NULL);
		m_extent.right++;
		CalcExt();
		return TRUE;
	}
	return CMSConst::OnKeyDown(nChar, nRepCnt, nFlags);
}

int CMSMeshSize::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);

	pMenu->AppendMenu(MF_STRING, CMD_INT_SET_VALUE, "&set integer value");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

#include "intvalue.h"

int CMSMeshSize::OnCommand(UINT id)
{
	switch(id) {
	case CMD_INT_SET_VALUE:
		{
			CIntValue intDlg;
			intDlg.m_nValue = m_value;
			intDlg.m_sName = GetName();
			if(intDlg.DoModal()==IDOK) {
				m_value = intDlg.m_nValue;
				GetAncestor()->SendMsg(MSG_PDE_MESH_CHANGED, NULL);
				m_extent.right++;
				CalcExt();
			}
		}
		return TRUE;
	}
	return CMSCInteger::OnCommand(id);
}

/////////////// CPointOnAxis ////////////////////
/////////////// CPointOnAxis ////////////////////

CPointOnAxis::CPointOnAxis(const char *nm)
: CSymbInst(nm)
{
}

int CPointOnAxis::CalcExt(dirMode dir)
{
	POSITION pos;
	CViecFC *pelm;
	CRect ext = m_extent;

	CViecFC *psym = GetSymbBody();
	if(!psym->IsKindOf(RUNTIME_CLASS(CViecFC))) {
		return FALSE;
	}

	CDC *pdc = GetDC();
	if(pdc==NULL) return FALSE;
	CString nm = psym->GetName();
	SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
	CSize sz = pdc->GetTextExtent(nm, lstrlen(nm));
	ReleaseDC(pdc);

	int x = sz.cx;
	pos = GetHeadPosition();
	for(; pos; ) {
		pelm = GetNext(pos);
		if(dir==dirDown && GetMode()==modeOpen)
			pelm->CalcExt(dir);
		x += 20;
		pelm->SetOrg(CPoint(x,0));
		x += pelm->GetExtent().Width();
	}

	CViecFC::CalcExt(dirNot);

	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPointOnAxis::OnDraw(CDC *pdc, const CPoint& p)
{
	CPoint p0 = p;
	p0.Offset(GetOrg());

	COLORREF col = m_bFocus? RGB(0,0,255) : RGB(0,0,0);
	CRect rct = GetExtent();
	rct.OffsetRect(p0);
	SetPen(pdc, PS_SOLID, 1, col);
	pdc->MoveTo(rct.left, rct.bottom-1);
	pdc->LineTo(rct.right, rct.bottom-1);

	col = RGB(0,0,0);
	CViecFC *psym = GetSymbBody();
	if(psym->IsKindOf(RUNTIME_CLASS(CViecFC))) {
		CString nm = psym->GetName();
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		CSize sz = pdc->GetTextExtent(nm, lstrlen(nm));
		pdc->SetTextColor(col);
		pdc->TextOut(p0.x, p0.y-sz.cy/2, nm);
	}
	OnDrawChild(pdc, p);
}

BOOL CPointOnAxis::OnCreated(EnumOnCreated bSkp)
{
	if(!CSymbInst::OnCreated(bSkp))
		return FALSE;
	if(!GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSIndepVar)))
		return FALSE;
	CMSIndepVar *pindVar;
	pindVar = (CMSIndepVar *) GetSymbBody();
	CSuitCase SC;
	if(!pindVar->SendMsg(MSG_PDE_GET_AXIS_NO, &SC) || SC.m_int<0)
		return FALSE;
	m_axisNo = SC.m_int;
	return TRUE;
}

/////////////// CCHalfAndDir ////////////////////
/////////////// CCHalfAndDir ////////////////////

CHalfAndDir::CHalfAndDir()
{
	m_bHalf = FALSE;
	m_bPosDir = TRUE;
}

int CHalfAndDir::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	m_extent = CRect(0,-8,30,7);
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CHalfAndDir::OnDraw(CDC *pdc, const CPoint& p)
{
	int x[9] = { 0, 4, 9, 9, 13, 18, 23, 26, 30 };
	int y[3] = { -7, 0, 6 };
	CPoint p0 = p;
	p0.Offset(GetOrg());

	COLORREF col = m_bFocus? RGB(0,0,255) : RGB(0,0,0);
	SetPen(pdc, PS_SOLID, 1, col);

	pdc->MoveTo(p0.x + x[0], p0.y + y[1]);
	pdc->LineTo(p0.x + x[8], p0.y + y[1]);

	pdc->MoveTo(p0.x + x[1], p0.y + y[1]);
	pdc->LineTo(p0.x + x[1], p0.y + y[2]);

	pdc->MoveTo(p0.x + x[6], p0.y + y[1]);
	pdc->LineTo(p0.x + x[6], p0.y + y[2]);

	pdc->MoveTo(p0.x + x[7], p0.y + y[2]);
	pdc->LineTo(p0.x + x[8], p0.y + y[1]);
	pdc->LineTo(p0.x + x[7], p0.y + y[0]);

//		pdc->LineTo(p0.x + x[5], p0.y + y[0]);
//		pdc->LineTo(p0.x + x[4], p0.y + y[1]);
//		pdc->LineTo(p0.x + x[3], p0.y + y[0]);
//		pdc->MoveTo(p0.x + x[0], p0.y + y[0]);
//		pdc->LineTo(p0.x + x[2], p0.y + y[0]);
//		pdc->LineTo(p0.x + x[1], p0.y + y[1]);
//		pdc->LineTo(p0.x + x[0], p0.y + y[0]);

	int dirNo = m_bPosDir? -1 : 1;
	int hlfNo = m_bHalf? 4 : 1;

	pdc->SelectStockObject(GRAY_BRUSH);
	pdc->SelectStockObject(NULL_PEN);
	CRect rct(p0.x + x[hlfNo], p0.y + y[0], p0.x + x[hlfNo+dirNo], p0.y + y[2]);
	pdc->Rectangle(&rct);

	pdc->SelectStockObject(BLACK_PEN);
	pdc->MoveTo(p0.x + x[hlfNo], p0.y + y[0]);
	pdc->LineTo(p0.x + x[hlfNo], p0.y + y[2]);

}

int CHalfAndDir::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	switch(nChar) {
	case VK_LEFT:
		switch(MyGetKeyState()) {
		case SS_NOTHING:
			break;
		case SS_SHIFT:
			m_bHalf = FALSE;
			GetAncestor()->SendMsg(MSG_PDE_MESH_CHANGED, NULL);
			m_extent.right++;
			CalcExt();
			return TRUE;
		case SS_CTRL:
			m_bPosDir = FALSE;
			GetAncestor()->SendMsg(MSG_PDE_MESH_CHANGED, NULL);
			m_extent.right++;
			CalcExt();
			return TRUE;
		}
		break;
	case VK_RIGHT:
		switch(MyGetKeyState()) {
		case SS_NOTHING:
			break;
		case SS_SHIFT:
			m_bHalf = TRUE;
			GetAncestor()->SendMsg(MSG_PDE_MESH_CHANGED, NULL);
			m_extent.right++;
			CalcExt();
			return TRUE;
		case SS_CTRL:
			m_bPosDir = TRUE;
			GetAncestor()->SendMsg(MSG_PDE_MESH_CHANGED, NULL);
			m_extent.right++;
			CalcExt();
			return TRUE;
		}
		break;
	}
	return CViecFC::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CHalfAndDir::CopyBody(CViecFC *pelm)
{
	CHalfAndDir *pCp = (CHalfAndDir *) pelm;
	CViecFC::CopyBody(pelm);
	pCp->m_bHalf = m_bHalf;
	pCp->m_bPosDir = m_bPosDir;
}

void CHalfAndDir::SerializeBody(CArchive& ar)
{
	CViecFC::SerializeBody(ar);
	if(ar.IsStoring()) {
		ar << (BYTE) m_bHalf;
		ar << (BYTE) m_bPosDir;
	} else {
		BYTE b;
		ar >> b;
		m_bHalf = b;
		ar >> b;
		m_bPosDir = b;
	}
}

#define CMD_BOUND_DIR_PLUS 6000
#define CMD_BOUND_DIR_MINUS 6001

int CHalfAndDir::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
//	CMenu *psub = GetPopupMenu(FALSE);
//	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
//	AppendDefaultMenu(psub);

	pMenu->AppendMenu(MF_STRING, CMD_BOUND_DIR_PLUS, "face to +");
	pMenu->AppendMenu(MF_STRING, CMD_BOUND_DIR_MINUS, "face to -");

	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CHalfAndDir::OnCommand(UINT id)
{
	switch(id) {
	case CMD_BOUND_DIR_PLUS:
		m_bPosDir = TRUE;
		CalcExt();
		InvalidateRect(NULL);
		return 1;
	case CMD_BOUND_DIR_MINUS:
		m_bPosDir = FALSE;
		CalcExt();
		InvalidateRect(NULL);
		return 1;
	}
	return 0;
}
///////////////    CRangeOnAxis    ///////////////
///////////////    CRangeOnAxis    ///////////////

BOOL CRangeOnAxis::OnCreated(EnumOnCreated bSkp)
{
//	if(m_pMathInst->IsKindOf(RUNTIME_CLASS(CObString))) {
//		CString ss;
//		CObString *str = (CObString *) m_pMathInst;
//		if(str->GetString()==CString("x"))
//			ss = "x";
//	}
	POSITION pos;
	if(GetCount()!=2)
		return FALSE;
	pos = GetHeadPosition();
	m_pFrom = (COnePointOnAxis *) GetNext(pos);
	m_pTo = (COnePointOnAxis *) GetNext(pos);
	if(!m_pFrom->IsKindOf(RUNTIME_CLASS(COnePointOnAxis)) ||
	   !m_pTo->IsKindOf(RUNTIME_CLASS(COnePointOnAxis)))
		return FALSE;
	BOOL rt = CPointOnAxis::OnCreated(bSkp);
//	if(m_pMathInst==NULL)
//		return rt;
//	if(!m_pMathInst->IsKindOf(RUNTIME_CLASS(CViecFC)))
//		return rt;
	return rt;
}

/////////// CPDEBoundDefs /////////////////////
/////////// CPDEBoundDefs /////////////////////

int CPDEBoundDefs::OnCommand(UINT id)
{
	static CStringArray strAry;

	switch(id) {
	case CMD_BND_ADD_BOUND:
		{
			CViecFCList obLst;
			CSuitCase SC;
			strAry.RemoveAll();

			SC.m_oblist = &obLst;
			SC.m_runtimeClass = RUNTIME_CLASS(CPDESpaceVar);
			GetAncestor()->SendMsg(MSG_COLLECT_OBJECT, &SC);
			if(!obLst.GetCount()) return FALSE;

			CMenu *pSmn = GetPopupMenu(TRUE);
			pSmn->AppendMenu(MF_STRING, 0, "Select Surface Direction");
			pSmn->AppendMenu(MF_SEPARATOR);

			CPDESpaceVar *pInd;
			POSITION pos;
			int i;
			pos = obLst.GetHeadPosition();
			for(i=0; pos; i++) {
				pInd = (CPDESpaceVar *) obLst.GetNext(pos);
				strAry.Add(pInd->m_pIndepVar->GetName());
				pSmn->AppendMenu(MF_STRING, CMD_FIND_DEP_RESULT+ i, strAry[i]);
			}
			TrackPopupMenu(pSmn, GetMenuPoint(NULL));
		}
		return TRUE;
	}

	int sig2 = id & 0xff00;
	int no = id & 0x00ff;
	//printf("no = %d \n",no); 
	
	switch(sig2) {
	case CMD_FIND_DEP_RESULT:
		{
			if(no>strAry.GetUpperBound())
				return TRUE;
		/////Kawa	if(no>2) return TRUE;
			CPDEBoundDef *pbd = new CPDEBoundDef;
			if(no>3) return TRUE;
			int i,j;
			i = no==0? 1 : 0;
			switch(strAry.GetSize()) {
			case 1:
				break;
			case 2:
				pbd->SetName(pbd->GetName(), m_nDot, m_nCharSet);
				pbd->CreateBoundDef(strAry[no], 1, TRUE, TRUE, strAry[i], 1, -1);
				break;
			case 3:
				if(no==0 && i==1)j=2;
				if(no==1 && i==2)j=1;
				if(no==2 && i==0)j=0;
				pbd->SetName(pbd->GetName(), m_nDot, m_nCharSet);
				pbd->CreateBoundDef3D(strAry[no], 1, TRUE, TRUE, strAry[i], 1, -1, strAry[j], 1, -1);
				break;
			};

#if 0
	switch(sig2) {
	case CMD_SET_1D_INFO:
		{
			pbd->CreateBoundDef1D(strAry[no], 1, TRUE, TRUE);
		}
	case CMD_SET_2D_INFO:
		{
			pbd->CreateBoundDef(strAry[no], 1, TRUE, TRUE, strAry[i], 1, -1);
		}
	case CMD_SET_3D_INFO:
		{
			pbd->CreateBoundDef3D(strAry[no], 1, TRUE, TRUE, strAry[i], 1, -1, strAry[j], 1, -1);
		}
	};
#endif
			AddTail(pbd);
			OnCreated();
			CalcExt(dirDown);
			CalcExt();
		}
		return TRUE;
	}
	return CPDEBase::OnCommand(id);
}

int CPDEBoundDefs::OnAccess(CPoint *pp)
{
	CMenu *pMenu = GetPopupMenu(TRUE);
	CString str = GetRuntimeClass()->m_lpszClassName;
	pMenu->AppendMenu(MF_STRING, 0, str+": "+GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT) psub->m_hMenu, "&default menu");
	pMenu->AppendMenu(MF_SEPARATOR);
	AppendDefaultMenu(psub);

	pMenu->AppendMenu(MF_STRING, CMD_BND_ADD_BOUND, "&add new boundary");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDEBoundDefs::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	CalcExtVert(dir);

	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDEBoundDefs::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	OnDrawChild(pdc, p);
}

BOOL CPDEBoundDefs::OnCreated(EnumOnCreated bSkp)
{
	return CPDEBase::OnCreated(bSkp);
}

CPDEBoundDefs::CPDEBoundDefs()
{
	m_bFindFirst = TRUE;
}

BOOL CPDEBoundDefs::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_INCLUDE_CHILD_IN_MATH_TABLE:
		((CSuitCase *) el)->m_int = TRUE;
		return TRUE;
	}
	return CPDEBase::SendMsg(msg, el);
}

