
#include "stdafx.h"
#include <math.h>

#include "pde_msg.h"
#include "var_wtc.h"

//#include "msg_adv.h"
#include "msg_prg.h"

IMPLEMENT_ELEM(CPDE3DimVarCP, CPDEBase, 268)
IMPLEMENT_ELEM(CPDE3DimVarSP, CPDEBase, 269)
IMPLEMENT_ELEM(CPDE3DimVar, CPDEBase, 270)
IMPLEMENT_ELEM(CPDE2DimVarCP, CPDEBase, 268)
IMPLEMENT_ELEM(CPDE2DimVarSP, CPDEBase, 269)
IMPLEMENT_ELEM(CPDE2DimVar, CPDEBase, 270)
IMPLEMENT_ELEM(CPDE1DimVarCP, CPDEBase, 268)
IMPLEMENT_ELEM(CPDE1DimVarSP, CPDEBase, 269)
IMPLEMENT_ELEM(CPDE1DimVar, CPDEBase, 270)


/////Kawa kokokara

/////////////////  CPDE3DimVar //////////////////
/////////////////  CPDE3DimVar //////////////////

int CPDE3DimVar::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	if(GetCount()==0 || GetMode()!=modeOpen)
		return CPDEBase::CalcExt(dir);
	CalcExtVert(dir, 2);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	CalcExtPost(dir, ext);
	return TRUE;
}

void CPDE3DimVar::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	if(m_mode!=modeClose && GetCount()>0) {
		OnDrawChild(pdc, p);
	} else {
		CRect r0=m_extent;
		r0.OffsetRect(m_org);
		r0.OffsetRect(p);
		CRect rD(r0.left+4, r0.top+4, r0.right-4, r0.bottom-4);
		if(m_bFocus) pdc->SetTextColor(RGB(0,0,255));
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		pdc->DrawText(GetName(), lstrlen(GetName()), &rD, GetFormat());
	}
}

void CPDE3DimVar::Create()
{
	AddTail(new CPDE3DimVarCP);
	AddTail(new CPDE3DimVarSP);
	m_pCP = (CPDE3DimVarCP *) GetChild(0);
	m_pSP = (CPDE3DimVarSP *) GetChild(1);
	m_pCP->Create();
}

BOOL CPDE3DimVar::OnCreated(EnumOnCreated bSkp)
{
	if(GetCount()<2) return FALSE;
	m_pCP = (CPDE3DimVarCP *) GetChild(0);
	m_pSP = (CPDE3DimVarSP *) GetChild(1);
	return CPDEBase::OnCreated(bSkp);
}

BOOL CPDE3DimVar::CheckValue(CPDEObjPrg *pPrg)
{
	EnterCriticalSection(&pPrg->memSync);
	if(pPrg->pVar && pPrg->pVar->VarNo>0 && pPrg->pVar->VarNo<100) {
		int no = m_pCP->m_nVarNo;
		if(no >= 0 && no < pPrg->pVar->VarNo) {
			if(m_pCP->m_pI->m_value >= pPrg->pVar->varList[no].size[0])
				m_pCP->m_pI->m_value = 1;
			if(m_pCP->m_pI->m_value < 1)
				m_pCP->m_pI->m_value = 1;

			if(m_pCP->m_pJ->m_value >= pPrg->pVar->varList[no].size[1])
				m_pCP->m_pJ->m_value = 1;
			if(m_pCP->m_pJ->m_value < 1)
				m_pCP->m_pJ->m_value = 1;

			if(m_pCP->m_pImax->m_value + m_pCP->m_pI->m_value
				>= pPrg->pVar->varList[no].size[0])
				m_pCP->m_pImax->m_value = pPrg->pVar->varList[no].size[0]
					- m_pCP->m_pI->m_value;
			if(m_pCP->m_pJmax->m_value + m_pCP->m_pJ->m_value
				>= pPrg->pVar->varList[no].size[1])
				m_pCP->m_pJmax->m_value = pPrg->pVar->varList[no].size[1]
					- m_pCP->m_pJ->m_value;
		}
	}
	LeaveCriticalSection(&pPrg->memSync);
	return TRUE;
}

BOOL CPDE3DimVar::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_PROG_START_RUNNIG:
		{
			CPDEObjPrg *pPrg = (CPDEObjPrg *) GetBaseElem(RUNTIME_CLASS(CPDEObjPrg));
			char buf[40] = "";
			if(!pPrg) return TRUE;
			CheckValue(pPrg);
		}
	case MSG_PROG_STOP_RUNNIG:
	case MSG_SIGNAL_HAS_COME:
		InvalidateRect(CPoint(0,0));
		return TRUE;
	}
	return CPDEBase::SendMsg(msg, el);
}

int CPDE3DimVar::OnAccess(CPoint *pp)
{
	CString str;
	CMenu *pMenu = GetPopupMenu(TRUE);
	pMenu->AppendMenu(MF_STRING, 0, GetRuntimeClass()->m_lpszClassName +CString(": ")+ GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT)psub->m_hMenu, "&Default menu");
	AppendDefaultMenu(psub);
	pMenu->AppendMenu(MF_STRING, CMD_PROC_SHOW_VARS, "show memory now");
	pMenu->AppendMenu(MF_STRING, CMD_1DIM_VAR_QUERY, "show var detail");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDE3DimVar::OnCommand(UINT id)
{
	static CStringArray strAry;
	switch(id) {
	case CMD_PROC_SHOW_VARS:
		{
			CPDEObjPrg *pPrg = (CPDEObjPrg *) GetBaseElem(RUNTIME_CLASS(CPDEObjPrg));
			if(!pPrg) return TRUE;
			if(!pPrg->pVar || pPrg->pVar->VarNo<0 && pPrg->pVar->VarNo>100) return TRUE;
			int i;
			strAry.RemoveAll();
			CMenu *pMenu = GetPopupMenu(TRUE);
			pMenu->AppendMenu(MF_STRING, 0, "select 2D array");
			pMenu->AppendMenu(MF_SEPARATOR);
			for(i=0; i<pPrg->pVar->VarNo; i++) {
				strAry.Add(pPrg->pVar->varList[i].varName);
				if(pPrg->pVar->varList[i].type==1) {
					pMenu->AppendMenu(MF_STRING, CMD_FIND_DEP_RESULT+i, strAry[i]);
				}
			}
			TrackPopupMenu(pMenu, GetMenuPoint(NULL));
		}
		return TRUE;
	case CMD_1DIM_VAR_QUERY:
		{
			CPDEObjPrg *pPrg = (CPDEObjPrg *) GetBaseElem(RUNTIME_CLASS(CPDEObjPrg));
			char buf[40] = "";
			if(!pPrg) return TRUE;
			EnterCriticalSection(&pPrg->memSync);
			if(pPrg->pVar && pPrg->pVar->VarNo>0 && pPrg->pVar->VarNo<100) {
				if(m_pCP->m_nVarNo >= 0 || m_pCP->m_nVarNo < pPrg->pVar->VarNo) {
					int no = m_pCP->m_nVarNo;
					sprintf(buf, "%s(%d %d)", pPrg->pVar->varList[no].varName
					, pPrg->pVar->varList[no].size[0], pPrg->pVar->varList[no].size[1]);
				}
			}
			LeaveCriticalSection(&pPrg->memSync);
			if(lstrlen(buf))
				MessageBox(NULL, buf, "MSG", MB_OK);
		}
		return TRUE;
	}

	int sig2 = id & 0xff00;
	int no = id & 0x00ff;
	switch(sig2) {
	case CMD_FIND_DEP_RESULT:
		{
			CPDEObjPrg *pPrg = (CPDEObjPrg*) GetBaseElem(RUNTIME_CLASS(CPDEObjPrg));
			if(!pPrg) return TRUE;
			m_pCP->m_pVarName->SetName(strAry[no]);
			m_pCP->m_nVarNo = no;
			CheckValue(pPrg);
			InvalidateRect(CPoint(0,0));
		}
		return TRUE;
	}
	return CPDEBase::OnCommand(id);
}

/////////////////  CPDE3DimVarCP //////////////////
/////////////////  CPDE3DimVarCP //////////////////

int CPDE3DimVarCP::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	if(GetCount()==0 || GetMode()!=modeOpen)
		return CPDEBase::CalcExt(dir);
	CalcExtLines(dir, 8, 0);

	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDE3DimVarCP::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	if(m_mode!=modeClose && GetCount()>0) {
		OnDrawChild(pdc, p);
	} else {
		CRect r0=m_extent;
		r0.OffsetRect(m_org);
		r0.OffsetRect(p);
		CRect rD(r0.left+4, r0.top+4, r0.right-4, r0.bottom-4);
		if(m_bFocus) pdc->SetTextColor(RGB(0,0,255));
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		pdc->DrawText(GetName(), lstrlen(GetName()), &rD, GetFormat());
	}
}

void CPDE3DimVarCP::Create()
{
	SetMode(modeOpen);

	AddTail(new CMSCInteger);
	AddTail(new CMSCInteger);
	AddTail(new CMSCInteger);
	AddTail(new CPDELineTerm);

	AddTail(new CMSCInteger);
	AddTail(new CMSCInteger);
	AddTail(new CMSCInteger);
	AddTail(new CPDELineTerm);

	AddTail(new CMSCReal);
	AddTail(new CMSCReal);
	AddTail(new CPDELineTerm);

	AddTail(new CPDEBttn);
	AddTail(new CPDEBttn);
	AddTail(new CPDEBttn);
	AddTail(new CViecFC);
	AddTail(new CPDELineTerm);

	InitVal();
}

BOOL CPDE3DimVarCP::OnCreated(EnumOnCreated bSkp)
{
	if(GetCount()<15) return FALSE;

	m_pI = (CMSCInteger *) GetChild(0);
	m_pImax = (CMSCInteger *) GetChild(1);
	m_pDI = (CMSCInteger *) GetChild(2);

	m_pJ = (CMSCInteger *) GetChild(4);
	m_pJmax = (CMSCInteger *) GetChild(5);
	m_pDJ = (CMSCInteger *) GetChild(6);

	m_pmaxVal = (CMSCReal *) GetChild(8);
	m_pzeroVal = (CMSCReal *) GetChild(9);

	m_pmaxCol = (CPDEBttn *) GetChild(11);
	m_pzeroCol = (CPDEBttn *) GetChild(12);
	m_pvalCol = (CPDEBttn *) GetChild(13);

	m_pmaxCol->m_color = RGB(255,0,0);
	m_pvalCol->m_color = RGB(0,200,0);
	m_pzeroCol->m_color = RGB(0,0,255);

	m_pVarName = (CViecFC *) GetChild(14);

	return CPDEBase::OnCreated(bSkp);
}

void CPDE3DimVarCP::InitVal()
{
	m_pI = (CMSCInteger *) GetChild(0);
	m_pImax = (CMSCInteger *) GetChild(1);
	m_pDI = (CMSCInteger *) GetChild(2);

	m_pJ = (CMSCInteger *) GetChild(4);
	m_pJmax = (CMSCInteger *) GetChild(5);
	m_pDJ = (CMSCInteger *) GetChild(6);

	m_pmaxVal = (CMSCReal *) GetChild(8);
	m_pzeroVal = (CMSCReal *) GetChild(9);

	m_pmaxCol = (CPDEBttn *) GetChild(11);
	m_pzeroCol = (CPDEBttn *) GetChild(12);
	m_pvalCol = (CPDEBttn *) GetChild(13);

	m_pVarName = (CViecFC *) GetChild(14);

	m_pI->SetName("i");
	m_pI->m_value = 1;
	m_pImax->SetName("imax");
	m_pImax->m_value = 10;
	m_pDI->SetName("di");
	m_pDI->m_value = 10;

	m_pJ->SetName("j");
	m_pJ->m_value = 1;
	m_pJmax->SetName("jmax");
	m_pJmax->m_value = 10;
	m_pDJ->SetName("dj");
	m_pDJ->m_value = 10;

	m_pmaxVal->SetName("max");
	m_pmaxVal->m_value = 10.0;
	m_pzeroVal->SetName("zero");
	m_pzeroVal->m_value = 0.0001;

	m_pmaxCol->m_color = RGB(255,0,0);
	m_pmaxCol->SetExtent(CRect(0,-5, 10,5));
	m_pzeroCol->m_color = RGB(0,0,255);
	m_pzeroCol->SetExtent(CRect(0,-5, 10,5));
	m_pvalCol->m_color = RGB(0,255,0);
	m_pvalCol->SetExtent(CRect(0,-5, 10,5));

	m_pVarName->SetName("NULL");
	m_nVarNo = -1;
}	

BOOL CPDE3DimVarCP::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_CONST_CHANGED:
		{
			GetParent()->CalcExt(dirDown);
		}
		return TRUE;
	}
	return CPDEBase::SendMsg(msg, el);
}

/////////////////  CPDE3DimVarSP //////////////////
/////////////////  CPDE3DimVarSP //////////////////

CPDE3DimVarSP::CPDE3DimVarSP()
{
	m_bAbsoluteValue = FALSE;
}

BOOL CPDE3DimVarSP::OnCreated(EnumOnCreated bSkp)
{
	m_pV = (CPDE3DimVar *) GetBaseElem(RUNTIME_CLASS(CPDE3DimVar));
	if(m_pV==NULL) return FALSE;
	return TRUE;
}

int CPDE3DimVarSP::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	int wd = (m_pV->m_pCP->m_pDI->m_value + 1) * m_pV->m_pCP->m_pImax->m_value + 1;
	int hg = (m_pV->m_pCP->m_pDJ->m_value + 1) * m_pV->m_pCP->m_pJmax->m_value + 1;
	m_extent = CRect(0,0, wd, hg);
	CalcExtPost(dir, ext);
	return 1;
}

void CPDE3DimVarSP::OnDraw(CDC *pdc, const CPoint& p)
{
	CPoint p0 = p;
	p0.Offset(GetOrg());
	CRect rct = GetExtent();
	rct.OffsetRect(p0);
	pdc->SelectStockObject(BLACK_PEN);
	pdc->SelectStockObject(NULL_BRUSH);
	pdc->Rectangle(&rct);
	int i,j,imax,jmax, di, dj, i0,j0;
	i0 = m_pV->m_pCP->m_pI->m_value;
	j0 = m_pV->m_pCP->m_pJ->m_value;
	imax = m_pV->m_pCP->m_pImax->m_value;
	jmax = m_pV->m_pCP->m_pJmax->m_value;
	di = m_pV->m_pCP->m_pDI->m_value + 1;
	dj = m_pV->m_pCP->m_pDJ->m_value + 1;
	CRect sq2;
	CRect sq(0,0, m_pV->m_pCP->m_pDI->m_value+2, m_pV->m_pCP->m_pDJ->m_value+2);
	SetPen(pdc, PS_SOLID, 1, RGB(0,0,0));
	
	CPDEObjPrg *pPrg = (CPDEObjPrg *) GetBaseElem(RUNTIME_CLASS(CPDEObjPrg));

	EnterCriticalSection(&pPrg->memSync);
	CPDE3DimVar *p3DV = (CPDE3DimVar *) GetBaseElem(RUNTIME_CLASS(CPDE2DimVar));
	if(!pPrg || !p3DV || !pPrg->pVar || p3DV->m_pCP->m_nVarNo >= pPrg->pVar->VarNo
	|| p3DV->m_pCP->m_nVarNo < 0) {
		SetBrush(pdc, RGB(255,255,255));
		for(i=0; i<imax; i++) {
			for(j=0; j<jmax; j++) {
				sq2 = sq;
				sq2.OffsetRect(CPoint(p0.x+i*di, p0.y+j*dj));
				pdc->Rectangle(&sq2);
			}
		}
	} else {
		p3DV->CheckValue(pPrg);
		int no,d;
		double *pd, data;
		double dMax = p3DV->m_pCP->m_pmaxVal->m_value;
		double dMin = p3DV->m_pCP->m_pzeroVal->m_value;
		COLORREF cMax = p3DV->m_pCP->m_pmaxCol->m_color;
		COLORREF cMin = p3DV->m_pCP->m_pzeroCol->m_color;
		COLORREF cVal = p3DV->m_pCP->m_pvalCol->m_color;
		no = p3DV->m_pCP->m_nVarNo;
		for(i=0; i<imax; i++) {
			for(j=0; j<jmax; j++) {
				sq2 = sq;
				sq2.OffsetRect(CPoint(p0.x+i*di, p0.y+j*dj));
				d = pPrg->pVar->varList[no].size[1] * (i+i0) + (j+j0);
				pd = (double*) ((BYTE*)pPrg->pVar + pPrg->pVar->varList[no].pBody);
				data = pd[d];
				if(m_bAbsoluteValue)
					data = fabs(data);
				if(data>=dMax)
					SetBrush(pdc, cMax);
				else if(data<=dMin)
					SetBrush(pdc, cMin);
				else
					SetBrush(pdc, cVal);
				pdc->Rectangle(&sq2);
			}
		}
	}
	LeaveCriticalSection(&pPrg->memSync);
}

int CPDE3DimVarSP::OnAccess(CPoint *pp)
{
	CString str;
	CRect rct;
	if(pp==NULL) return 0;
	CMenu *pMenu = GetPopupMenu(TRUE);
	CElemView *pV = (CElemView *) GetView();
	GetRectG(rct);
	CPoint p0(rct.left, rct.top);
	p0.Offset(-pV->m_pView->GetScrollPosition());
	CPoint p2 = *pp;
	p2.Offset(-p0);
	int i,j,imax,jmax, di, dj;
	imax = m_pV->m_pCP->m_pImax->m_value;
	jmax = m_pV->m_pCP->m_pJmax->m_value;
	di = m_pV->m_pCP->m_pDI->m_value + 1;
	dj = m_pV->m_pCP->m_pDJ->m_value + 1;
	i = p2.x / di + m_pV->m_pCP->m_pI->m_value;
	j = p2.y / dj + m_pV->m_pCP->m_pJ->m_value;

	str.Format("%d,%d", i, j);
	pMenu->AppendMenu(MF_STRING, 0, str);

	CPDEObjPrg *pPrg = (CPDEObjPrg *) GetBaseElem(RUNTIME_CLASS(CPDEObjPrg));
	EnterCriticalSection(&pPrg->memSync);
	CPDE3DimVar *p3DV = (CPDE3DimVar *) GetBaseElem(RUNTIME_CLASS(CPDE3DimVar));
	if(pPrg && pPrg->pVar!=NULL && p3DV) {
		int no = p3DV->m_pCP->m_nVarNo;
		if(no>=0 && no <= pPrg->pVar->VarNo) {
			int d = pPrg->pVar->varList[no].size[1] * i + j;
			double *pd = (double*) ((BYTE*)pPrg->pVar + pPrg->pVar->varList[no].pBody);
			str.Format("%e", pd[d]);
			pMenu->AppendMenu(MF_STRING, 0, str);
			if(!m_bAbsoluteValue)
				pMenu->AppendMenu(MF_STRING, MSG_SHOW_ABSOLUTE_VALUE, "&abs");
			else
				pMenu->AppendMenu(MF_STRING, MSG_SHOW_NO_ABSOL_VALUE,"&real data");
		}
	}
	LeaveCriticalSection(&pPrg->memSync);

	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDE3DimVarSP::OnCommand(UINT id)
{
	switch(id) {
	case MSG_SHOW_ABSOLUTE_VALUE:
		m_bAbsoluteValue = TRUE;
		InvalidateRect(CPoint(0,0));
		return TRUE;
	case MSG_SHOW_NO_ABSOL_VALUE:
		m_bAbsoluteValue = FALSE;
		InvalidateRect(CPoint(0,0));
		return TRUE;
	}
	return CPDEBase::OnCommand(id);
}

/////////KAWA kokomade



/////////////////  CPDE2DimVar //////////////////
/////////////////  CPDE2DimVar //////////////////

int CPDE2DimVar::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	if(GetCount()==0 || GetMode()!=modeOpen)
		return CPDEBase::CalcExt(dir);
	CalcExtVert(dir, 2);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	CalcExtPost(dir, ext);
	return TRUE;
}

void CPDE2DimVar::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	if(m_mode!=modeClose && GetCount()>0) {
		OnDrawChild(pdc, p);
	} else {
		CRect r0=m_extent;
		r0.OffsetRect(m_org);
		r0.OffsetRect(p);
		CRect rD(r0.left+4, r0.top+4, r0.right-4, r0.bottom-4);
		if(m_bFocus) pdc->SetTextColor(RGB(0,0,255));
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		pdc->DrawText(GetName(), lstrlen(GetName()), &rD, GetFormat());
	}
}

void CPDE2DimVar::Create()
{
	AddTail(new CPDE2DimVarCP);
	AddTail(new CPDE2DimVarSP);
	m_pCP = (CPDE2DimVarCP *) GetChild(0);
	m_pSP = (CPDE2DimVarSP *) GetChild(1);
	m_pCP->Create();
}

BOOL CPDE2DimVar::OnCreated(EnumOnCreated bSkp)
{
	if(GetCount()<2) return FALSE;
	m_pCP = (CPDE2DimVarCP *) GetChild(0);
	m_pSP = (CPDE2DimVarSP *) GetChild(1);
	return CPDEBase::OnCreated(bSkp);
}

BOOL CPDE2DimVar::CheckValue(CPDEObjPrg *pPrg)
{
	EnterCriticalSection(&pPrg->memSync);
	if(pPrg->pVar && pPrg->pVar->VarNo>0 && pPrg->pVar->VarNo<100) {
		int no = m_pCP->m_nVarNo;
		if(no >= 0 && no < pPrg->pVar->VarNo) {
			if(m_pCP->m_pI->m_value >= pPrg->pVar->varList[no].size[0])
				m_pCP->m_pI->m_value = 1;
			if(m_pCP->m_pI->m_value < 1)
				m_pCP->m_pI->m_value = 1;

			if(m_pCP->m_pJ->m_value >= pPrg->pVar->varList[no].size[1])
				m_pCP->m_pJ->m_value = 1;
			if(m_pCP->m_pJ->m_value < 1)
				m_pCP->m_pJ->m_value = 1;

			if(m_pCP->m_pImax->m_value + m_pCP->m_pI->m_value
				>= pPrg->pVar->varList[no].size[0])
				m_pCP->m_pImax->m_value = pPrg->pVar->varList[no].size[0]
					- m_pCP->m_pI->m_value;
			if(m_pCP->m_pJmax->m_value + m_pCP->m_pJ->m_value
				>= pPrg->pVar->varList[no].size[1])
				m_pCP->m_pJmax->m_value = pPrg->pVar->varList[no].size[1]
					- m_pCP->m_pJ->m_value;
		}
	}
	LeaveCriticalSection(&pPrg->memSync);
	return TRUE;
}

BOOL CPDE2DimVar::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_PROG_START_RUNNIG:
		{
			CPDEObjPrg *pPrg = (CPDEObjPrg *) GetBaseElem(RUNTIME_CLASS(CPDEObjPrg));
			char buf[40] = "";
			if(!pPrg) return TRUE;
			CheckValue(pPrg);
		}
	case MSG_PROG_STOP_RUNNIG:
	case MSG_SIGNAL_HAS_COME:
		InvalidateRect(CPoint(0,0));
		return TRUE;
	}
	return CPDEBase::SendMsg(msg, el);
}

int CPDE2DimVar::OnAccess(CPoint *pp)
{
	CString str;
	CMenu *pMenu = GetPopupMenu(TRUE);
	pMenu->AppendMenu(MF_STRING, 0, GetRuntimeClass()->m_lpszClassName +CString(": ")+ GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT)psub->m_hMenu, "&Default menu");
	AppendDefaultMenu(psub);
	pMenu->AppendMenu(MF_STRING, CMD_PROC_SHOW_VARS, "show memory now");
	pMenu->AppendMenu(MF_STRING, CMD_1DIM_VAR_QUERY, "show var detail");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDE2DimVar::OnCommand(UINT id)
{
	static CStringArray strAry;
	switch(id) {
	case CMD_PROC_SHOW_VARS:
		{
			CPDEObjPrg *pPrg = (CPDEObjPrg *) GetBaseElem(RUNTIME_CLASS(CPDEObjPrg));
			if(!pPrg) return TRUE;
			if(!pPrg->pVar || pPrg->pVar->VarNo<0 && pPrg->pVar->VarNo>100) return TRUE;
			int i;
			strAry.RemoveAll();
			CMenu *pMenu = GetPopupMenu(TRUE);
			pMenu->AppendMenu(MF_STRING, 0, "select 2D array");
			pMenu->AppendMenu(MF_SEPARATOR);
			for(i=0; i<pPrg->pVar->VarNo; i++) {
				strAry.Add(pPrg->pVar->varList[i].varName);
				if(pPrg->pVar->varList[i].type==1) {
					pMenu->AppendMenu(MF_STRING, CMD_FIND_DEP_RESULT+i, strAry[i]);
				}
			}
			TrackPopupMenu(pMenu, GetMenuPoint(NULL));
		}
		return TRUE;
	case CMD_1DIM_VAR_QUERY:
		{
			CPDEObjPrg *pPrg = (CPDEObjPrg *) GetBaseElem(RUNTIME_CLASS(CPDEObjPrg));
			char buf[40] = "";
			if(!pPrg) return TRUE;
			EnterCriticalSection(&pPrg->memSync);
			if(pPrg->pVar && pPrg->pVar->VarNo>0 && pPrg->pVar->VarNo<100) {
				if(m_pCP->m_nVarNo >= 0 || m_pCP->m_nVarNo < pPrg->pVar->VarNo) {
					int no = m_pCP->m_nVarNo;
					sprintf(buf, "%s(%d %d)", pPrg->pVar->varList[no].varName
					, pPrg->pVar->varList[no].size[0], pPrg->pVar->varList[no].size[1]);
				}
			}
			LeaveCriticalSection(&pPrg->memSync);
			if(lstrlen(buf))
				MessageBox(NULL, buf, "MSG", MB_OK);
		}
		return TRUE;
	}

	int sig2 = id & 0xff00;
	int no = id & 0x00ff;
	switch(sig2) {
	case CMD_FIND_DEP_RESULT:
		{
			CPDEObjPrg *pPrg = (CPDEObjPrg*) GetBaseElem(RUNTIME_CLASS(CPDEObjPrg));
			if(!pPrg) return TRUE;
			m_pCP->m_pVarName->SetName(strAry[no]);
			m_pCP->m_nVarNo = no;
			CheckValue(pPrg);
			InvalidateRect(CPoint(0,0));
		}
		return TRUE;
	}
	return CPDEBase::OnCommand(id);
}

/////////////////  CPDE2DimVarCP //////////////////
/////////////////  CPDE2DimVarCP //////////////////

int CPDE2DimVarCP::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	if(GetCount()==0 || GetMode()!=modeOpen)
		return CPDEBase::CalcExt(dir);
	CalcExtLines(dir, 8, 0);

	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	if(dir==dirUp)
		GetParent()->CalcExt(dir);
	if(ext!=m_extent) {
		CRect ext0 = m_extent;
		m_extent = ext;
		InvalidateRect(CPoint(0,0));
		m_extent = ext0;
		InvalidateRect(CPoint(0,0));
	}
	return TRUE;
}

void CPDE2DimVarCP::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	if(m_mode!=modeClose && GetCount()>0) {
		OnDrawChild(pdc, p);
	} else {
		CRect r0=m_extent;
		r0.OffsetRect(m_org);
		r0.OffsetRect(p);
		CRect rD(r0.left+4, r0.top+4, r0.right-4, r0.bottom-4);
		if(m_bFocus) pdc->SetTextColor(RGB(0,0,255));
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		pdc->DrawText(GetName(), lstrlen(GetName()), &rD, GetFormat());
	}
}

void CPDE2DimVarCP::Create()
{
	SetMode(modeOpen);

	AddTail(new CMSCInteger);
	AddTail(new CMSCInteger);
	AddTail(new CMSCInteger);
	AddTail(new CPDELineTerm);

	AddTail(new CMSCInteger);
	AddTail(new CMSCInteger);
	AddTail(new CMSCInteger);
	AddTail(new CPDELineTerm);

	AddTail(new CMSCReal);
	AddTail(new CMSCReal);
	AddTail(new CPDELineTerm);

	AddTail(new CPDEBttn);
	AddTail(new CPDEBttn);
	AddTail(new CPDEBttn);
	AddTail(new CViecFC);
	AddTail(new CPDELineTerm);

	InitVal();
}

BOOL CPDE2DimVarCP::OnCreated(EnumOnCreated bSkp)
{
	if(GetCount()<15) return FALSE;

	m_pI = (CMSCInteger *) GetChild(0);
	m_pImax = (CMSCInteger *) GetChild(1);
	m_pDI = (CMSCInteger *) GetChild(2);

	m_pJ = (CMSCInteger *) GetChild(4);
	m_pJmax = (CMSCInteger *) GetChild(5);
	m_pDJ = (CMSCInteger *) GetChild(6);

	m_pmaxVal = (CMSCReal *) GetChild(8);
	m_pzeroVal = (CMSCReal *) GetChild(9);

	m_pmaxCol = (CPDEBttn *) GetChild(11);
	m_pzeroCol = (CPDEBttn *) GetChild(12);
	m_pvalCol = (CPDEBttn *) GetChild(13);

	m_pmaxCol->m_color = RGB(255,0,0);
	m_pvalCol->m_color = RGB(0,200,0);
	m_pzeroCol->m_color = RGB(0,0,255);

	m_pVarName = (CViecFC *) GetChild(14);

	return CPDEBase::OnCreated(bSkp);
}

void CPDE2DimVarCP::InitVal()
{
	m_pI = (CMSCInteger *) GetChild(0);
	m_pImax = (CMSCInteger *) GetChild(1);
	m_pDI = (CMSCInteger *) GetChild(2);

	m_pJ = (CMSCInteger *) GetChild(4);
	m_pJmax = (CMSCInteger *) GetChild(5);
	m_pDJ = (CMSCInteger *) GetChild(6);

	m_pmaxVal = (CMSCReal *) GetChild(8);
	m_pzeroVal = (CMSCReal *) GetChild(9);

	m_pmaxCol = (CPDEBttn *) GetChild(11);
	m_pzeroCol = (CPDEBttn *) GetChild(12);
	m_pvalCol = (CPDEBttn *) GetChild(13);

	m_pVarName = (CViecFC *) GetChild(14);

	m_pI->SetName("i");
	m_pI->m_value = 1;
	m_pImax->SetName("imax");
	m_pImax->m_value = 10;
	m_pDI->SetName("di");
	m_pDI->m_value = 10;

	m_pJ->SetName("j");
	m_pJ->m_value = 1;
	m_pJmax->SetName("jmax");
	m_pJmax->m_value = 10;
	m_pDJ->SetName("dj");
	m_pDJ->m_value = 10;

	m_pmaxVal->SetName("max");
	m_pmaxVal->m_value = 10.0;
	m_pzeroVal->SetName("zero");
	m_pzeroVal->m_value = 0.0001;

	m_pmaxCol->m_color = RGB(255,0,0);
	m_pmaxCol->SetExtent(CRect(0,-5, 10,5));
	m_pzeroCol->m_color = RGB(0,0,255);
	m_pzeroCol->SetExtent(CRect(0,-5, 10,5));
	m_pvalCol->m_color = RGB(0,255,0);
	m_pvalCol->SetExtent(CRect(0,-5, 10,5));

	m_pVarName->SetName("NULL");
	m_nVarNo = -1;
}	

BOOL CPDE2DimVarCP::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_CONST_CHANGED:
		{
			GetParent()->CalcExt(dirDown);
		}
		return TRUE;
	}
	return CPDEBase::SendMsg(msg, el);
}

/////////////////  CPDE2DimVarSP //////////////////
/////////////////  CPDE2DimVarSP //////////////////

CPDE2DimVarSP::CPDE2DimVarSP()
{
	m_bAbsoluteValue = FALSE;
}

BOOL CPDE2DimVarSP::OnCreated(EnumOnCreated bSkp)
{
	m_pV = (CPDE2DimVar *) GetBaseElem(RUNTIME_CLASS(CPDE2DimVar));
	if(m_pV==NULL) return FALSE;
	return TRUE;
}

int CPDE2DimVarSP::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	int wd = (m_pV->m_pCP->m_pDI->m_value + 1) * m_pV->m_pCP->m_pImax->m_value + 1;
	int hg = (m_pV->m_pCP->m_pDJ->m_value + 1) * m_pV->m_pCP->m_pJmax->m_value + 1;
	m_extent = CRect(0,0, wd, hg);
	CalcExtPost(dir, ext);
	return 1;
}

void CPDE2DimVarSP::OnDraw(CDC *pdc, const CPoint& p)
{
	CPoint p0 = p;
	p0.Offset(GetOrg());
	CRect rct = GetExtent();
	rct.OffsetRect(p0);
	pdc->SelectStockObject(BLACK_PEN);
	pdc->SelectStockObject(NULL_BRUSH);
	pdc->Rectangle(&rct);
	int i,j,imax,jmax, di, dj, i0,j0;
	i0 = m_pV->m_pCP->m_pI->m_value;
	j0 = m_pV->m_pCP->m_pJ->m_value;
	imax = m_pV->m_pCP->m_pImax->m_value;
	jmax = m_pV->m_pCP->m_pJmax->m_value;
	di = m_pV->m_pCP->m_pDI->m_value + 1;
	dj = m_pV->m_pCP->m_pDJ->m_value + 1;
	CRect sq2;
	CRect sq(0,0, m_pV->m_pCP->m_pDI->m_value+2, m_pV->m_pCP->m_pDJ->m_value+2);
	SetPen(pdc, PS_SOLID, 1, RGB(0,0,0));
	
	CPDEObjPrg *pPrg = (CPDEObjPrg *) GetBaseElem(RUNTIME_CLASS(CPDEObjPrg));

	EnterCriticalSection(&pPrg->memSync);
	CPDE2DimVar *p2DV = (CPDE2DimVar *) GetBaseElem(RUNTIME_CLASS(CPDE2DimVar));
	if(!pPrg || !p2DV || !pPrg->pVar || p2DV->m_pCP->m_nVarNo >= pPrg->pVar->VarNo
	|| p2DV->m_pCP->m_nVarNo < 0) {
		SetBrush(pdc, RGB(255,255,255));
		for(i=0; i<imax; i++) {
			for(j=0; j<jmax; j++) {
				sq2 = sq;
				sq2.OffsetRect(CPoint(p0.x+i*di, p0.y+j*dj));
				pdc->Rectangle(&sq2);
			}
		}
	} else {
		p2DV->CheckValue(pPrg);
		int no,d;
		double *pd, data;
		double dMax = p2DV->m_pCP->m_pmaxVal->m_value;
		double dMin = p2DV->m_pCP->m_pzeroVal->m_value;
		COLORREF cMax = p2DV->m_pCP->m_pmaxCol->m_color;
		COLORREF cMin = p2DV->m_pCP->m_pzeroCol->m_color;
		COLORREF cVal = p2DV->m_pCP->m_pvalCol->m_color;
		no = p2DV->m_pCP->m_nVarNo;
		for(i=0; i<imax; i++) {
			for(j=0; j<jmax; j++) {
				sq2 = sq;
				sq2.OffsetRect(CPoint(p0.x+i*di, p0.y+j*dj));
				d = pPrg->pVar->varList[no].size[1] * (i+i0) + (j+j0);
				pd = (double*) ((BYTE*)pPrg->pVar + pPrg->pVar->varList[no].pBody);
				data = pd[d];
				if(m_bAbsoluteValue)
					data = fabs(data);
				if(data>=dMax)
					SetBrush(pdc, cMax);
				else if(data<=dMin)
					SetBrush(pdc, cMin);
				else
					SetBrush(pdc, cVal);
				pdc->Rectangle(&sq2);
			}
		}
	}
	LeaveCriticalSection(&pPrg->memSync);
}

int CPDE2DimVarSP::OnAccess(CPoint *pp)
{
	CString str;
	CRect rct;
	if(pp==NULL) return 0;
	CMenu *pMenu = GetPopupMenu(TRUE);
	CElemView *pV = (CElemView *) GetView();
	GetRectG(rct);
	CPoint p0(rct.left, rct.top);
	p0.Offset(-pV->m_pView->GetScrollPosition());
	CPoint p2 = *pp;
	p2.Offset(-p0);
	int i,j,imax,jmax, di, dj;
	imax = m_pV->m_pCP->m_pImax->m_value;
	jmax = m_pV->m_pCP->m_pJmax->m_value;
	di = m_pV->m_pCP->m_pDI->m_value + 1;
	dj = m_pV->m_pCP->m_pDJ->m_value + 1;
	i = p2.x / di + m_pV->m_pCP->m_pI->m_value;
	j = p2.y / dj + m_pV->m_pCP->m_pJ->m_value;

	str.Format("%d,%d", i, j);
	pMenu->AppendMenu(MF_STRING, 0, str);

	CPDEObjPrg *pPrg = (CPDEObjPrg *) GetBaseElem(RUNTIME_CLASS(CPDEObjPrg));
	EnterCriticalSection(&pPrg->memSync);
	CPDE2DimVar *p2DV = (CPDE2DimVar *) GetBaseElem(RUNTIME_CLASS(CPDE2DimVar));
	if(pPrg && pPrg->pVar!=NULL && p2DV) {
		int no = p2DV->m_pCP->m_nVarNo;
		if(no>=0 && no <= pPrg->pVar->VarNo) {
			int d = pPrg->pVar->varList[no].size[1] * i + j;
			double *pd = (double*) ((BYTE*)pPrg->pVar + pPrg->pVar->varList[no].pBody);
			str.Format("%e", pd[d]);
			pMenu->AppendMenu(MF_STRING, 0, str);
			if(!m_bAbsoluteValue)
				pMenu->AppendMenu(MF_STRING, MSG_SHOW_ABSOLUTE_VALUE, "&abs");
			else
				pMenu->AppendMenu(MF_STRING, MSG_SHOW_NO_ABSOL_VALUE,"&real data");
		}
	}
	LeaveCriticalSection(&pPrg->memSync);

	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDE2DimVarSP::OnCommand(UINT id)
{
	switch(id) {
	case MSG_SHOW_ABSOLUTE_VALUE:
		m_bAbsoluteValue = TRUE;
		InvalidateRect(CPoint(0,0));
		return TRUE;
	case MSG_SHOW_NO_ABSOL_VALUE:
		m_bAbsoluteValue = FALSE;
		InvalidateRect(CPoint(0,0));
		return TRUE;
	}
	return CPDEBase::OnCommand(id);
}


/////////////////  CPDE1DimVar //////////////////
/////////////////  CPDE1DimVar //////////////////

int CPDE1DimVar::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	if(GetCount()==0 || GetMode()!=modeOpen)
		return CPDEBase::CalcExt(dir);
	CalcExtVert(dir, 2);
	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	CalcExtPost(dir, ext);
	return TRUE;
}

void CPDE1DimVar::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	if(m_mode!=modeClose && GetCount()>0) {
		OnDrawChild(pdc, p);
	} else {
		CRect r0=m_extent;
		r0.OffsetRect(m_org);
		r0.OffsetRect(p);
		CRect rD(r0.left+4, r0.top+4, r0.right-4, r0.bottom-4);
		if(m_bFocus) pdc->SetTextColor(RGB(0,0,255));
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		pdc->DrawText(GetName(), lstrlen(GetName()), &rD, GetFormat());
	}
}

void CPDE1DimVar::Create()
{
	AddTail(new CPDE1DimVarCP);
	AddTail(new CPDE1DimVarSP);
	m_pCP = (CPDE1DimVarCP *) GetChild(0);
	m_pSP = (CPDE1DimVarSP *) GetChild(1);
	m_pCP->Create();
}

BOOL CPDE1DimVar::OnCreated(EnumOnCreated bSkp)
{
	if(GetCount()<2) return FALSE;
	m_pCP = (CPDE1DimVarCP *) GetChild(0);
	m_pSP = (CPDE1DimVarSP *) GetChild(1);
	return CPDEBase::OnCreated(bSkp);
}

BOOL CPDE1DimVar::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_PROG_START_RUNNIG:
	case MSG_SIGNAL_HAS_COME:
	case MSG_PROG_STOP_RUNNIG:
		InvalidateRect(CPoint(0,0));
		return TRUE;
	}
	return CPDEBase::SendMsg(msg, el);
}

int CPDE1DimVar::OnAccess(CPoint *pp)
{
	CString str;
	CMenu *pMenu = GetPopupMenu(TRUE);
	pMenu->AppendMenu(MF_STRING, 0, GetRuntimeClass()->m_lpszClassName +CString(": ")+ GetName());
	pMenu->AppendMenu(MF_SEPARATOR);
	CMenu *psub = GetPopupMenu(FALSE);
	pMenu->AppendMenu(MF_POPUP, (UINT)psub->m_hMenu, "&Default menu");
	AppendDefaultMenu(psub);
	pMenu->AppendMenu(MF_STRING, CMD_PROC_SHOW_VARS, "show memory now");
	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDE1DimVar::OnCommand(UINT id)
{
	static CStringArray strAry;
	switch(id) {
	case CMD_PROC_SHOW_VARS:
		{
			CPDEObjPrg *pPrg = (CPDEObjPrg *) GetBaseElem(RUNTIME_CLASS(CPDEObjPrg));
			if(!pPrg || !pPrg->pVar || pPrg->pVar->VarNo<0 && pPrg->pVar->VarNo>100) return TRUE;
			int i;
			strAry.RemoveAll();
			CMenu *pMenu = GetPopupMenu(TRUE);
			pMenu->AppendMenu(MF_STRING, 0, "select 1D array");
			pMenu->AppendMenu(MF_SEPARATOR);
			for(i=0; i<pPrg->pVar->VarNo; i++) {
				strAry.Add(pPrg->pVar->varList[i].varName);
				if(pPrg->pVar->varList[i].type==2) {
					pMenu->AppendMenu(MF_STRING, CMD_FIND_DEP_RESULT+i, strAry[i]);
				}
			}
			TrackPopupMenu(pMenu, GetMenuPoint(NULL));
		}
		return TRUE;
	}

	int sig2 = id & 0xff00;
	int no = id & 0x00ff;
	switch(sig2) {
	case CMD_FIND_DEP_RESULT:
		m_pCP->m_pVarName->SetName(strAry[no]);
		m_pCP->m_nVarNo = no;
		InvalidateRect(CPoint(0,0));
		return TRUE;
	}
	return CPDEBase::OnCommand(id);
}

/////////////////  CPDE1DimVarCP //////////////////
/////////////////  CPDE1DimVarCP //////////////////

int CPDE1DimVarCP::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	if(GetCount()==0 || GetMode()!=modeOpen)
		return CPDEBase::CalcExt(dir);
	CalcExtLines(dir, 8, 0);

	m_extent.left -= 8;
	m_extent.right += 8;
	m_extent.top -= 6;
	m_extent.bottom += 6;
	CalcExtPost(dir, ext);
	return TRUE;
}

void CPDE1DimVarCP::OnDraw(CDC *pdc, const CPoint& p)
{
	DrawFold3D(pdc, p, m_bFocus? 0:1);
	if(m_mode!=modeClose && GetCount()>0) {
		OnDrawChild(pdc, p);
	} else {
		CRect r0=m_extent;
		r0.OffsetRect(m_org);
		r0.OffsetRect(p);
		CRect rD(r0.left+4, r0.top+4, r0.right-4, r0.bottom-4);
		if(m_bFocus) pdc->SetTextColor(RGB(0,0,255));
		SetFont(pdc, m_nDot, GetFont(), m_nCharSet, m_nItalic);
		pdc->DrawText(GetName(), lstrlen(GetName()), &rD, GetFormat());
	}
}

void CPDE1DimVarCP::Create()
{
	SetMode(modeOpen);

	AddTail(new CMSCInteger);
	AddTail(new CMSCInteger);
	AddTail(new CMSCInteger);
	AddTail(new CPDELineTerm);

	AddTail(new CMSCReal);
	AddTail(new CMSCReal);
	AddTail(new CPDELineTerm);

	AddTail(new CPDEBttn);
	AddTail(new CPDEBttn);
	AddTail(new CPDEBttn);
	AddTail(new CViecFC);
	AddTail(new CPDELineTerm);

	InitVal();
}

BOOL CPDE1DimVarCP::OnCreated(EnumOnCreated bSkp)
{
	if(GetCount()<11) return FALSE;

	m_pJ = (CMSCInteger *) GetChild(0);
	m_pJmax = (CMSCInteger *) GetChild(1);
	m_pDJ = (CMSCInteger *) GetChild(2);

	m_pmaxVal = (CMSCReal *) GetChild(4);
	m_pzeroVal = (CMSCReal *) GetChild(5);

	m_pmaxCol = (CPDEBttn *) GetChild(7);
	m_pzeroCol = (CPDEBttn *) GetChild(8);
	m_pvalCol = (CPDEBttn *) GetChild(9);

	m_pmaxCol->m_color = RGB(255,0,0);
	m_pvalCol->m_color = RGB(0,200,0);
	m_pzeroCol->m_color = RGB(0,0,255);

	m_pVarName = (CViecFC *) GetChild(10);

	return CPDEBase::OnCreated(bSkp);
}

void CPDE1DimVarCP::InitVal()
{
	m_pJ = (CMSCInteger *) GetChild(0);
	m_pJmax = (CMSCInteger *) GetChild(1);
	m_pDJ = (CMSCInteger *) GetChild(2);

	m_pmaxVal = (CMSCReal *) GetChild(4);
	m_pzeroVal = (CMSCReal *) GetChild(5);

	m_pmaxCol = (CPDEBttn *) GetChild(7);
	m_pzeroCol = (CPDEBttn *) GetChild(8);
	m_pvalCol = (CPDEBttn *) GetChild(9);

	m_pVarName = (CViecFC *) GetChild(10);

	m_pJ->SetName("j");
	m_pJ->m_value = 1;
	m_pJmax->SetName("jmax");
	m_pJmax->m_value = 10;
	m_pDJ->SetName("dj");
	m_pDJ->m_value = 10;

	m_pmaxVal->SetName("max");
	m_pmaxVal->m_value = 10.0;
	m_pzeroVal->SetName("zero");
	m_pzeroVal->m_value = 0.0001;

	m_pmaxCol->m_color = RGB(255,0,0);
	m_pmaxCol->SetExtent(CRect(0,-5, 10,5));
	m_pzeroCol->m_color = RGB(0,0,200);
	m_pzeroCol->SetExtent(CRect(0,-5, 10,5));
	m_pvalCol->m_color = RGB(0,255,0);
	m_pvalCol->SetExtent(CRect(0,-5, 10,5));

	m_pVarName->SetName("NULL");
	m_nVarNo = -1;
}	

BOOL CPDE1DimVarCP::SendMsg(int msg, CObject* el)
{
	switch(msg) {
	case MSG_CONST_CHANGED:
		{
			GetParent()->CalcExt(dirDown);
		}
		return TRUE;
	}
	return CPDEBase::SendMsg(msg, el);
}

/////////////////  CPDE1DimVarSP //////////////////
/////////////////  CPDE1DimVarSP //////////////////

CPDE1DimVarSP::CPDE1DimVarSP()
{
	m_bAbsoluteValue = FALSE;
}

BOOL CPDE1DimVarSP::OnCreated(EnumOnCreated bSkp)
{
	m_pV = (CPDE1DimVar *) GetBaseElem(RUNTIME_CLASS(CPDE1DimVar));
	if(m_pV==NULL) return FALSE;
	return TRUE;
}

int CPDE1DimVarSP::CalcExt(dirMode dir)
{
	CRect ext = m_extent;
	int wd = (m_pV->m_pCP->m_pDJ->m_value + 1);
	int hg = (m_pV->m_pCP->m_pDJ->m_value + 1) * m_pV->m_pCP->m_pJmax->m_value + 1;
	m_extent = CRect(0,0, wd, hg);
	CalcExtPost(dir, ext);
	return 1;
}

void CPDE1DimVarSP::OnDraw(CDC *pdc, const CPoint& p)
{
	CPoint p0 = p;
	p0.Offset(GetOrg());
	CRect rct = GetExtent();
	rct.OffsetRect(p0);
	pdc->SelectStockObject(BLACK_PEN);
	pdc->SelectStockObject(NULL_BRUSH);
	pdc->Rectangle(&rct);
	int j,jmax, dj, j0;
	j0 = m_pV->m_pCP->m_pJ->m_value;
	jmax = m_pV->m_pCP->m_pJmax->m_value;
	dj = m_pV->m_pCP->m_pDJ->m_value + 1;
	CRect sq2;
	CRect sq(0,0, m_pV->m_pCP->m_pDJ->m_value+2, m_pV->m_pCP->m_pDJ->m_value+2);
	SetPen(pdc, PS_SOLID, 1, RGB(0,0,0));
	
	CPDEObjPrg *pPrg = (CPDEObjPrg *) GetBaseElem(RUNTIME_CLASS(CPDEObjPrg));

	EnterCriticalSection(&pPrg->memSync);
	CPDE1DimVar *p1DV = (CPDE1DimVar *) GetBaseElem(RUNTIME_CLASS(CPDE1DimVar));
	if(!pPrg || !p1DV || !pPrg->pVar || p1DV->m_pCP->m_nVarNo >= pPrg->pVar->VarNo
	|| p1DV->m_pCP->m_nVarNo < 0) {
		SetBrush(pdc, RGB(255,255,255));
		for(j=0; j<jmax; j++) {
			sq2 = sq;
			sq2.OffsetRect(CPoint(p0.x, p0.y+j*dj));
			pdc->Rectangle(&sq2);
		}
	} else {
		int no;
		double *pd, data;
		double dMax = p1DV->m_pCP->m_pmaxVal->m_value;
		double dMin = p1DV->m_pCP->m_pzeroVal->m_value;
		COLORREF cMax = p1DV->m_pCP->m_pmaxCol->m_color;
		COLORREF cMin = p1DV->m_pCP->m_pzeroCol->m_color;
		COLORREF cVal = p1DV->m_pCP->m_pvalCol->m_color;
		no = p1DV->m_pCP->m_nVarNo;
		for(j=0; j<jmax; j++) {
			sq2 = sq;
			sq2.OffsetRect(CPoint(p0.x, p0.y+j*dj));
			pd = (double*) ((BYTE*)pPrg->pVar + pPrg->pVar->varList[no].pBody);
			data = pd[j+j0];
			if(m_bAbsoluteValue)
				data = fabs(data);
			if(data>=dMax)
				SetBrush(pdc, cMax);
			else if(data<=dMin)
				SetBrush(pdc, cMin);
			else
				SetBrush(pdc, cVal);
			pdc->Rectangle(&sq2);
		}
	}
	LeaveCriticalSection(&pPrg->memSync);
}

int CPDE1DimVarSP::OnAccess(CPoint *pp)
{
	CString str;
	CRect rct;
	if(pp==NULL) return 0;
	CMenu *pMenu = GetPopupMenu(TRUE);
	CElemView *pV = (CElemView *) GetView();
	GetRectG(rct);
	CPoint p0(rct.left, rct.top);
	p0.Offset(-pV->m_pView->GetScrollPosition());
	CPoint p2 = *pp;
	p2.Offset(-p0);
	int j,jmax, dj;
//	imax = m_pV->m_pCP->m_pImax->m_value;
	jmax = m_pV->m_pCP->m_pJmax->m_value;
//	di = m_pV->m_pCP->m_pDI->m_value + 1;
	dj = m_pV->m_pCP->m_pDJ->m_value + 1;
//	i = p2.x / di + m_pV->m_pCP->m_pI->m_value;
	j = p2.y / dj + m_pV->m_pCP->m_pJ->m_value;

	str.Format("%d", j);
	pMenu->AppendMenu(MF_STRING, 0, str);

	CPDEObjPrg *pPrg = (CPDEObjPrg *) GetBaseElem(RUNTIME_CLASS(CPDEObjPrg));
	EnterCriticalSection(&pPrg->memSync);
	CPDE1DimVar *p2DV = (CPDE1DimVar *) GetBaseElem(RUNTIME_CLASS(CPDE1DimVar));
	if(pPrg && pPrg->pVar!=NULL && p2DV) {
		int no = p2DV->m_pCP->m_nVarNo;
		if(no>=0 && no <= pPrg->pVar->VarNo) {
			double *pd = (double*) ((BYTE*)pPrg->pVar + pPrg->pVar->varList[no].pBody);
			str.Format("%e", pd[j]);
			pMenu->AppendMenu(MF_STRING, 0, str);
			if(!m_bAbsoluteValue)
				pMenu->AppendMenu(MF_STRING, MSG_SHOW_ABSOLUTE_VALUE, "&abs");
			else
				pMenu->AppendMenu(MF_STRING, MSG_SHOW_NO_ABSOL_VALUE,"&real data");
		}
	}
	LeaveCriticalSection(&pPrg->memSync);

	TrackPopupMenu(pMenu, GetMenuPoint(pp));
	return 1;
}

int CPDE1DimVarSP::OnCommand(UINT id)
{
	switch(id) {
	case MSG_SHOW_ABSOLUTE_VALUE:
		m_bAbsoluteValue = TRUE;
		InvalidateRect(CPoint(0,0));
		return TRUE;
	case MSG_SHOW_NO_ABSOL_VALUE:
		m_bAbsoluteValue = FALSE;
		InvalidateRect(CPoint(0,0));
		return TRUE;
	}
	return CPDEBase::OnCommand(id);
}

