
#ifndef __VAR_WTC_H__
#define __VAR_WTC_H__

#ifndef __PDE_PRG_H__
#	include "pde_prg.h"
#endif


class AFX_EXT_CLASS CPDE3DimVarSP;
class AFX_EXT_CLASS CPDE3DimVarCP;

class AFX_EXT_CLASS CPDE3DimVar : public CPDEBase {
	DECLARE_ELEM(CPDE3DimVar)
public:
	CPDE3DimVarSP *m_pSP;
	CPDE3DimVarCP *m_pCP;

	void Create();
	virtual BOOL SendMsg(int msg, CObject* el);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnAccess(CPoint *pp);
	virtual int OnCommand(UINT);
	BOOL CheckValue(CPDEObjPrg *);
};

class AFX_EXT_CLASS CPDE3DimVarSP : public CPDEBase {
	DECLARE_ELEM(CPDE3DimVarSP)
public:
	CPDE3DimVar *m_pV;
	BOOL m_bAbsoluteValue;

	CPDE3DimVarSP();
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnAccess(CPoint *pp);
	virtual int OnCommand(UINT);
};

class AFX_EXT_CLASS CPDE3DimVarCP : public CPDEBase {
	DECLARE_ELEM(CPDE3DimVarCP)
public:
	CMSCInteger *m_pI, *m_pImax, *m_pDI;
	CMSCInteger *m_pJ, *m_pJmax, *m_pDJ;
	CMSCReal *m_pmaxVal, *m_pzeroVal;
	CPDEBttn *m_pmaxCol, *m_pzeroCol, *m_pvalCol;
	CViecFC *m_pVarName;
	int m_nVarNo;

	void Create();
	void InitVal();

	virtual BOOL SendMsg(int msg, CObject* el);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};




class AFX_EXT_CLASS CPDE2DimVarSP;
class AFX_EXT_CLASS CPDE2DimVarCP;

class AFX_EXT_CLASS CPDE2DimVar : public CPDEBase {
	DECLARE_ELEM(CPDE2DimVar)
public:
	CPDE2DimVarSP *m_pSP;
	CPDE2DimVarCP *m_pCP;

	void Create();
	virtual BOOL SendMsg(int msg, CObject* el);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnAccess(CPoint *pp);
	virtual int OnCommand(UINT);
	BOOL CheckValue(CPDEObjPrg *);
};

class AFX_EXT_CLASS CPDE2DimVarSP : public CPDEBase {
	DECLARE_ELEM(CPDE2DimVarSP)
public:
	CPDE2DimVar *m_pV;
	BOOL m_bAbsoluteValue;

	CPDE2DimVarSP();
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnAccess(CPoint *pp);
	virtual int OnCommand(UINT);
};

class AFX_EXT_CLASS CPDE2DimVarCP : public CPDEBase {
	DECLARE_ELEM(CPDE2DimVarCP)
public:
	CMSCInteger *m_pI, *m_pImax, *m_pDI;
	CMSCInteger *m_pJ, *m_pJmax, *m_pDJ;
	CMSCReal *m_pmaxVal, *m_pzeroVal;
	CPDEBttn *m_pmaxCol, *m_pzeroCol, *m_pvalCol;
	CViecFC *m_pVarName;
	int m_nVarNo;

	void Create();
	void InitVal();

	virtual BOOL SendMsg(int msg, CObject* el);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};


class AFX_EXT_CLASS CPDE1DimVarSP;
class AFX_EXT_CLASS CPDE1DimVarCP;

class AFX_EXT_CLASS CPDE1DimVar : public CPDEBase {
	DECLARE_ELEM(CPDE1DimVar)
public:
	CPDE1DimVarSP *m_pSP;
	CPDE1DimVarCP *m_pCP;

	void Create();
	virtual BOOL SendMsg(int msg, CObject* el);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnAccess(CPoint *pp);
	virtual int OnCommand(UINT);
};

class AFX_EXT_CLASS CPDE1DimVarSP : public CPDEBase {
	DECLARE_ELEM(CPDE1DimVarSP)
public:
	CPDE1DimVar *m_pV;
	BOOL m_bAbsoluteValue;

	CPDE1DimVarSP();
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
	virtual int OnAccess(CPoint *pp);
	virtual int OnCommand(UINT);
};

class AFX_EXT_CLASS CPDE1DimVarCP : public CPDEBase {
	DECLARE_ELEM(CPDE1DimVarCP)
public:
	CMSCInteger *m_pJ, *m_pJmax, *m_pDJ;
	CMSCReal *m_pmaxVal, *m_pzeroVal;
	CPDEBttn *m_pmaxCol, *m_pzeroCol, *m_pvalCol;
	CViecFC *m_pVarName;
	int m_nVarNo;

	void Create();
	void InitVal();

	virtual BOOL SendMsg(int msg, CObject* el);
	virtual BOOL OnCreated(EnumOnCreated = SKIP_IF_CREATED);
	virtual int CalcExt(dirMode dir=dirUp);
	virtual void OnDraw(CDC *pdc, const CPoint& p);
};

#endif // __VAR_WTC_H__
