
#include "stdafx.h"
#include "parapde.h"
#include "parajd_prg.h"
#include "parapde_ADV.h"
//#include "parapad.h"

#undef AFX_EXT_CLASS
#define AFX_EXT_CLASS AFX_CLASS_IMPORT
#include "../pad/msg_adv.h"
#include "../pad/msg_prg.h"
#include "../pad/pde_prg.h"
#undef AFX_EXT_CLASS
#define AFX_EXT_CLASS AFX_CLASS_EXPORT


IMPLEMENT_ELEM(CPDEObjPrgPara, CPDEObjPrg, 5601)
IMPLEMENT_ELEM(CJDCreateParaProgInC, CJDCreateProgInC, 5602)

/*******************************************************/
////////// CJDCreateParaProgInC::Para_ProgGen() //////////////
//This function is called by CJDCreateParaProgInC::Do.
//This function write out a part of header on generated code.
// The generated code was for Parallel code.
CJDCreateParaProgInC::CJDCreateParaProgInC()
{
	m_bEqual = FALSE;
	m_bFract = FALSE;
}

void CJDCreateParaProgInC::Para_ProgGen()
{
//#if 1
	int i;
	POSITION pos;
	CString key;
	char buf[100];
	CMSCReal *pPm;     //Parameter Box
	CMSIndep *pIndep;  //Independent variable Box
	CMSPDEMtx *pMatrix;// Matrix Box

	//--- program generation
	//output include sentences to code.
	LineFeed(); //Line feed equvalence Addtailfail('\n').
	AddTailFile("#include <stdio.h>");
	LineFeed();
	AddTailFile("#include <math.h>");
	LineFeed();
	AddTailFile("#include <mpi.h>"); //add header file.
	LineFeed();
	LineFeed();

	CMSMeshSize *pMs;
	AddTailFile("/* Definition of constants */");
	LineFeed();
	pos = findVar.m_const.GetStartPosition();
	while(pos) {
		findVar.m_const.GetNextAssoc(pos, key, (CObject*&) pMs);
		//Above function(GetNextAssoc probably get finding variable pointer and 
		//retunrn the pointer value to pMS.
		sprintf(buf, "#define %s %d", (const char*) pMs->GetName(), (int) pMs->m_value);
		//pMs->GetName() ='NMAX' 'IMAX','JMAX' etc.pMs->m_value = The max number of Mesh size.
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	//Max_CPU ,x_div,y_div,z_div擾ׂCDomainDivParaB̃|C^[pDomɊmۂB
	CJDFindClass findClass; // This Object(Class Cobject) is to find RUNTIME_CLASS.
	findClass.m_pTarget = RUNTIME_CLASS(CDomainDivPara);  //set findClass.m_pTarget = CPDESpaceVars name.
	findClass.m_pResult = NULL; // m_pResult is CView class.
	m_pdeInfo->SendMsg(MSG_DO_JOB, &findClass); //Check findclass(Object) job.
	CDomainDivPara *pDom = (CDomainDivPara*) findClass.m_pResult;

	//pDom̎qB͕ɂep[^̓Ă锠łB
	//̔pParameterƂB
	findClass.m_pTarget = RUNTIME_CLASS(CPDEParaDefs);  //set findClass.m_pTarget = CPDESpaceVars name.
	findClass.m_pResult = NULL; // m_pResult is CView class.
	pDom->SendMsg(MSG_DO_JOB, &findClass); //Check findclass(Object) job.
	CPDEParaDefs *pParameter = (CPDEParaDefs*) findClass.m_pResult;

	//MPI_Variableo͂B
	int dim = m_pdeInfo->m_meshInfo->m_spaceVars->GetCount(); //f
	int cnt = 0;
	AddTailFile("/* Definition of Parallel constants */");
	LineFeed();
	pos = pParameter->GetHeadPosition(); //̒̈ԍŏ̎q̃|WV
	CMSCInteger *pPara_var;
	while(pos){	
		pPara_var = (CMSCInteger*) pParameter->GetNext(pos); //pos̃|C^[ԂApos͎̎q̒l͂B
		if(pPara_var->IsKindOf(RUNTIME_CLASS(CMSCInteger)) == TRUE){
			sprintf(buf, "#define %s %d", (const char*) pPara_var->GetName(),(int) pPara_var->m_value);
			AddTailFile(buf);
			LineFeed();
			cnt++;
		}
		if(cnt == (dim + 1)) break;
	}
	LineFeed();


	p_Max_Cpu = (CMSCInteger*) pParameter->GetChild(0); //Max_CPU̎擾
	p_x_div = (CMSCInteger*) pParameter->GetChild(2); //x_div̎擾
	p_y_div = (CMSCInteger*) pParameter->GetChild(3); //y_div̎擾
	p_z_div = (CMSCInteger*) pParameter->GetChild(4); //z_div̎擾


	//--- definition of constant
	//What to do as fellow ?
	CPDEConstDef *pCst;
	pos = findVar.m_const2.GetStartPosition();
	while(pos) {
		findVar.m_const2.GetNextAssoc(pos, key, (CObject*&) pCst);
		if(pCst->GetCount()==0) continue; //lȂobject
		AddTailFile("#define ");
		AddTailFile(pCst->GetName());
		AddTailFile(" (");
		pCst->GetChild(0)->SendMsg(MSG_DO_JOB, this);
		//Above code describes the each parts of sentences.
		AddTailFile(")");
		LineFeed();
	}
	LineFeed();

	//--- prototype of all functions in the program
	const char *cmmt1 = "/* prototypes definition of all functions in this program */";
	AddTailFile(cmmt1);//commento sentences.
	LineFeed();
	//Pointer findProc probably have pointer on CPDProcs class(PAD fig.).
	for(i=0; i<findProc.m_procNo; i++) {
		if(findProc.m_procLst[i]->GetName() != CString("main"))
			sprintf(buf, "void %s();", findProc.m_procLst[i]->GetName());
			//SivT(),subst() etc.
		else sprintf(buf, "int %s();", findProc.m_procLst[i]->GetName());
			//main()
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	//CPDEObjPrgParãNXCPDEParaDefs{Bɂ̓O[oϐ`ĂB
	//̃|C^[pBoxłB
	findClass.m_pTarget = RUNTIME_CLASS(CPDEParaDefs);  //set findClass.m_pTarget = CPDESpaceVars name.
	findClass.m_pResult = NULL; // m_pResult is CView class.
	m_mainProg->SendMsg(MSG_DO_JOB, &findClass); //Check findclass(Object) job.
	CPDEParaDefs *pBox = (CPDEParaDefs*) findClass.m_pResult;

	//MPI_Variableo͂B
	CPDEParaDefs *pMpi,*pInt/*,*pDob*/;
	pMpi = (CPDEParaDefs*) pBox->GetChild(1); //MPI variable BOX
	AddTailFile("/*  Declare the global variables used in Domain Divided Parallel computation  */");
	LineFeed();
	AddTailFile("/* MPI type Variables */");//commento sentences.
	LineFeed();
	pos = pMpi->GetHeadPosition(); //̒̈ԍŏ̎q̃|WV
	CViecFC *pMpi_var;
	while(pos){	
		pMpi_var = (CViecFC*) pMpi->GetNext(pos); //pos̃|C^[ԂApos͎̎q̒l͂B
		if(pMpi_var->IsKindOf(RUNTIME_CLASS(CMSMpi_Status)) == TRUE){
			//MPI_Status type
			sprintf(buf, "MPI_Status %s;", (const char*) pMpi_var->GetName());
			AddTailFile(buf);
			LineFeed();
		}
		if(pMpi_var->IsKindOf(RUNTIME_CLASS(CMSMpi_Request)) == TRUE){
			//MPI_Request type
			sprintf(buf, "MPI_Request %s;", (const char*) pMpi_var->GetName());
			AddTailFile(buf);
			LineFeed();
		}
		if(pMpi_var->IsKindOf(RUNTIME_CLASS(CMSMpi_Request_Mtx)) == TRUE){
			//MPI_Request array 1d type
			sprintf(buf, "MPI_Request %s[", (const char*) pMpi_var->GetName());
			AddTailFile(buf);
			AddTailFile(p_Max_Cpu->GetName());
			AddTailFile("];");
			LineFeed();
		}
		if(pMpi_var->IsKindOf(RUNTIME_CLASS(CMSMpi_Datatype)) == TRUE){
			//MPI_Request type
			sprintf(buf, "MPI_Datatype %s;", (const char*) pMpi_var->GetName());
			AddTailFile(buf);
			LineFeed();
		}
		if(pMpi_var->IsKindOf(RUNTIME_CLASS(CMSMpi_Datatype_Mtx)) == TRUE){
			//MPI_Request array 1d type
			sprintf(buf, "MPI_Datatype %s[", (const char*) pMpi_var->GetName());
			AddTailFile(buf);
			AddTailFile(p_Max_Cpu->GetName());
			AddTailFile("];");
			LineFeed();
		}
	}
	LineFeed();

	///int type variables ̋Lq///////////////////////////////////////////////////////////////
	pInt = (CPDEParaDefs*) pBox->GetChild(2); //int variable BOX
	AddTailFile("/* Int type Variables */");//commento sentences.
	LineFeed();
	pos = pInt->GetHeadPosition(); //̒̈ԍŏ̎q̃|WV
	CViecFC *pInt_var;
	while(pos){	
		pInt_var = (CViecFC*) pMpi->GetNext(pos); //pos̃|C^[ԂApos͎̎q̒l͂B
		if(pInt_var->IsKindOf(RUNTIME_CLASS(CMSIndex)) == TRUE){
			//Int type
			sprintf(buf, "int %s;", (const char*) pInt_var->GetName());
			AddTailFile(buf);
			LineFeed();
		}
		if(pInt_var->IsKindOf(RUNTIME_CLASS(CMSIndex_Mtx)) == TRUE){
			//int 1d array type
			sprintf(buf, "int %s[", (const char*) pInt_var->GetName());
			AddTailFile(buf);
			AddTailFile(p_x_div->GetName());
			sprintf(buf, "+2];");
			AddTailFile(buf);
			LineFeed();
		}
		if(pInt_var->IsKindOf(RUNTIME_CLASS(CMSInd_Mtx_2d)) == TRUE){
			//Int array 2d type
			sprintf(buf, "int %s[", (const char*) pInt_var->GetName());
			AddTailFile(buf);
			AddTailFile(p_x_div->GetName());
			sprintf(buf, "+2][");
			AddTailFile(buf);
			AddTailFile(p_y_div->GetName());
			sprintf(buf, "+2];");
			AddTailFile(buf);
			LineFeed();
		}
		if(pInt_var->IsKindOf(RUNTIME_CLASS(CMSInd_Mtx_3d)) == TRUE){
			//Int array 2d type
			sprintf(buf, "int %s[", (const char*) pInt_var->GetName());
			AddTailFile(buf);
			AddTailFile(p_x_div->GetName());
			sprintf(buf, "+2][");
			AddTailFile(buf);
			AddTailFile(p_y_div->GetName());
			sprintf(buf, "+2][");
			AddTailFile(buf);
			AddTailFile(p_z_div->GetName());
			sprintf(buf, "+2];");
			AddTailFile(buf);
			LineFeed();
		}
	}
	LineFeed();

	///Double type variables ̋Lq///////////////////////////////////////////////////////////////
	
	//pDob = (CPDEParaDefs*) pBox->GetChild(2); //double variable BOX
	//AddTailFile("/* Double type Variables */"); //commento sentences.
	/*
	LineFeed();
	pos = pDob->GetHeadPosition(); //̒̈ԍŏ̎q̃|WV
	CViecFC *pDob_var;
	while(pos){	
		pDob_var = (CViecFC*) pMpi->GetNext(pos); //pos̃|C^[ԂApos͎̎q̒l͂B
		if(pDob_var->IsKindOf(RUNTIME_CLASS(CMSPDEMtx_1d)) == TRUE){
			//Dob type
			sprintf(buf, "double %s[", (const char*) pDob_var->GetName());
			AddTailFile(buf);
			if( (pDob_var->GetName() == CString("Send_Top")) || (pDob_var->GetName() == CString("Send_Bttm")) 
				|| (pDob_var->GetName() == CString("Recv_Top")) || (pDob_var->GetName() == CString("Recv_Bttm"))){
					pSpaceVar = (CPDESpaceVar *) pSpaceVars->GetChild(0); //IMAX
				//Top,BttmȂΈIMAXłB
			}else pSpaceVar = (CPDESpaceVar *) pSpaceVars->GetChild(1); //JMAX
			AddTailFile(pSpaceVar->m_division->GetName());
			if(m_bUseAry0 == FALSE) AddTailFile("+1];");
			else AddTailFile("];");
			LineFeed();
		}
		
	}
	LineFeed();
	*/
	

	/////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////
	//--- parameter variables declaration
	//--- time step variable
	AddTailFile("/* time step variable */");//comment sentence.
	LineFeed();
	sprintf(buf, "int %s;", (const char *) pTimeVar->m_pIndex->GetName());
	//GetName() = 'n '.
	AddTailFile(buf);
	LineFeed();

	/////////////////////////////////////////////////////////////////////////
	//--- Parameter used code.
	//--- arbitrary parameters.
	AddTailFile("/* Declaration of parameters */");//comment sentence
	LineFeed();
	pos = findVar.m_para.GetStartPosition();
	while(pos) {
		findVar.m_para.GetNextAssoc(pos, key, (CObject*&) pPm);
		sprintf(buf, "double %s = %lf;", (const char*) pPm->GetName(), pPm->m_value);
		//GetName() = 'Ax','Ay' etc.
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	/////////////////////////////////////////////////////////////////////////
	//--- Declaration of independent variables
	AddTailFile("/* Declaration of independent variables */");
	LineFeed();
	pos = findVar.m_indepVar.GetStartPosition();
	while(pos) {
		findVar.m_indepVar.GetNextAssoc(pos, key, (CObject*&) pIndep);
		if(pIndep->IsKindOf(RUNTIME_CLASS(CMSIndepConst))) {
			sprintf(buf, "double %s = %lf;", pIndep->GetName(), ((CMSIndepConst*)pIndep)->GetValue());
		} else {
			sprintf(buf, "double %s;", (const char*) pIndep->GetName());
		}
		//GetName() = 'dx','dy','dt' etc.
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	/////////////////////////////////////////////////////////////////////////
	//--- Declaration of dependent variables
	AddTailFile("/* Declaration of dependent variables */");
	LineFeed();
	//findDep.targetNo denote the total number of dependent variables.
	//Of course include next time step vaiables.
	for(i=0;i<findDep.targetNo;i++) {
		if(!findDep.targetVar[i].m_theDep->IsKindOf(RUNTIME_CLASS(CMSDepVar)))
			continue;
		if(!findDep.targetVar[i].m_timeIndex->IsKindOf(RUNTIME_CLASS(CMSIndex)))
			continue;
		if(findDep.targetVar[i].m_number==0)
			sprintf(buf, "double %s[", (const char*) findDep.targetVar[i].m_theDep->GetName());
		else
			sprintf(buf, "double %s%d[", (const char*) findDep.targetVar[i].m_theDep->GetName()
			, findDep.targetVar[i].m_number);
		AddTailFile(buf);
		pos = pSpaceVars->GetHeadPosition();
		while(pos) { //while Solved model dimention continue.
			pSpaceVar = (CPDESpaceVar *) pSpaceVars->GetNext(pos);
			AddTailFile(pSpaceVar->m_division->GetName());
			if(pos) AddTailFile(m_bUseAry0? "][" : "+1][");
			//Above code 'm_bUseAry0? "][" : "+1][" denote 
			// if (m_bUserAry0 == TRUE) AddTailFile("][");
			// else (return FALSE) AddTailFile("+1][");
		}
		AddTailFile(m_bUseAry0? "];" : "+1];");
		//Add final brackets.
		//Above code 'm_bUseAry0? "]" : "+1]" denote 
		// if (m_bUserAry0 == TRUE) AddTailFile("]");
		// else (return FALSE) AddTailFile("+1]");
		sprintf(buf, "/* %s %s %d */", (const char*) findDep.targetVar[i].m_theDep->GetName()
		, (const char*) findDep.targetVar[i].m_timeIndex->GetName()
		, findDep.targetVar[i].m_timeShift.m_value
		, findDep.targetVar[i].m_number);
		//buf = /* T n 1 */,/*T n 0 */ etc.
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	/////////////////////////////////////////////////////////////////////////
	//--- Declaration of matrix and vector ---
	CSymbInst *pSb;
	//AddTailFile("/* Declaration of matrix and vector */");
	//LineFeed();
	pos = findVar.m_matrix.GetStartPosition();
	while(pos) {
		findVar.m_matrix.GetNextAssoc(pos, key, (CObject*&) pMatrix);
//		if(pMatrix->GetCount()!=1) continue;
		pSb = (CSymbInst*) pMatrix->GetChild(0);
		if(!pSb->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
		int ddd = 2;
		if(!pMatrix->GetParent()->IsKindOf(RUNTIME_CLASS(CPDELocalDefs))) sprintf(buf, "double %s", pMatrix->GetName());
		else continue; //pMatrix̐eCPDELocalDefsȂi܂胍[JϐȂjł͋LqȂB
		/*
		if(pMatrix->GetName() != CString("Send_Var")) sprintf(buf, "double %s", pMatrix->GetName());
		else continue; //MatrixSend_VarLqȂB
		*/

		AddTailFile(buf);
		if(pMatrix->IsKindOf(RUNTIME_CLASS(CMSPDEVct)))	ddd = 1;
		for(i=0;i<ddd;i++) {
			AddTailFile("[");
			AddTailFile(pSb->GetSymbBody()->GetName());
			AddTailFile("+1]");
		}
		AddTailFile(";");
		LineFeed();
	}
	LineFeed();

	/////////////////////////////////////////////////////////////////////////
	//--- Declaration of FILE pointer
	CEFile* pCE;
	AddTailFile("/* Declaration of FILE Pointer */");
	LineFeed();
	pos = findVar.m_file.GetStartPosition();
	for(i=1; pos; i++) {
		findVar.m_file.GetNextAssoc(pos, key, (CObject*&) pCE);
		if(pCE->IsKindOf(RUNTIME_CLASS(CEFile))) {
			sprintf(buf, "FILE *filePnt%d;",i);
			AddTailFile(buf);
			LineFeed();
		}
	}
	LineFeed();

//#endif
}

////////////// CJDCreateParaProgInC /////////////////////
////////////// CJDCreateParaProgInC /////////////////////
////////////// CJDCreateParaProgInC /////////////////////

/*******************************************************/
////////// CJDCreateParaProgInC::ProgGen() //////////////
//This function is called by CJDCreateParaProgInC::Do.
//This function write out a part of header on generated code.
// The generated code was for Parallel code.

void CJDCreateParaProgInC::ProgGen()
{
//#if 1
	int i;
	POSITION pos;
	CString key;
	char buf[100];
	CMSCReal *pPm;     //Parameter Box
	CMSIndep *pIndep;  //Independent variable Box
	CMSPDEMtx *pMatrix;// Matrix Box

	//--- program generation
	//output include sentences to code.
	LineFeed(); //Line feed.equvalence Addtailfail('\n').
	AddTailFile("#include <stdio.h>");
	LineFeed();
	AddTailFile("#include <math.h>");
	LineFeed();
	LineFeed();

	CMSMeshSize *pMs;
	AddTailFile("/* Definition of constants */");
	LineFeed();
	pos = findVar.m_const.GetStartPosition();
	while(pos) {
		findVar.m_const.GetNextAssoc(pos, key, (CObject*&) pMs);
		//Above function(GetNextAssoc probably get finding variable pointer and 
		//retunrn the pointer value to pMS.
		sprintf(buf, "#define %s %d", (const char*) pMs->GetName(), (int) pMs->m_value);
		//pMs->GetName() = 'IMAX','JMAX' etc.pMs->m_value = The max number of Mesh size.
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	//--- definition of constant
	//What to do as fellow ?
	CPDEConstDef *pCst;
	pos = findVar.m_const2.GetStartPosition();
	while(pos) {
		findVar.m_const2.GetNextAssoc(pos, key, (CObject*&) pCst);
		if(pCst->GetCount()==0) continue;
		AddTailFile("#define ");
		AddTailFile(pCst->GetName());
		AddTailFile(" (");
		pCst->GetChild(0)->SendMsg(MSG_DO_JOB, this);
		//Above code describes the each parts of sentences.
		AddTailFile(" )");
		LineFeed();
	}
	LineFeed();

	//--- prototype of all functions in the program
	const char *cmmt1 = "/* prototypes definition of all functions in this program */";
	AddTailFile(cmmt1);//commento sentences.
	LineFeed();
	//Pointer findProc probably have pointer on CPDProcs class(PAD fig.).
	for(i=0; i<findProc.m_procNo; i++) {
		sprintf(buf, "void %s();", findProc.m_procLst[i]->GetName());
		// main(),SivT(),subst() etc.
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();
	LineFeed();

	/////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////
	//--- parameter variables declaration
	//--- time step variable
	AddTailFile("/* time step variable */");//comment sentence.
	LineFeed();
	sprintf(buf, "int %s;", (const char *) pTimeVar->m_pIndex->GetName());
	//GetName() = 'n '.
	AddTailFile(buf);
	LineFeed();	LineFeed();

	/////////////////////////////////////////////////////////////////////////
	//--- Parameter used code.
	//--- arbitrary parameters.
	AddTailFile("/* Declaration of parameters */");//comment sentence
	LineFeed();
	pos = findVar.m_para.GetStartPosition();
	while(pos) {
		findVar.m_para.GetNextAssoc(pos, key, (CObject*&) pPm);
		sprintf(buf, "double %s = %lf;", (const char*) pPm->GetName(), pPm->m_value);
		//GetName() = 'Ax','Ay' etc.
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	/////////////////////////////////////////////////////////////////////////
	//--- Declaration of independent variables
	AddTailFile("/* Declaration of independent variables */");
	LineFeed();
	pos = findVar.m_indepVar.GetStartPosition();
	while(pos) {
		findVar.m_indepVar.GetNextAssoc(pos, key, (CObject*&) pIndep);
		if(pIndep->IsKindOf(RUNTIME_CLASS(CMSIndepConst))) {
			sprintf(buf, "double %s = %lf;", pIndep->GetName(), ((CMSIndepConst*)pIndep)->GetValue());
		} else {
			sprintf(buf, "double %s;", (const char*) pIndep->GetName());
		}
		//GetName() = 'dx','dy','dt' etc.
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	/////////////////////////////////////////////////////////////////////////
	//--- Declaration of dependent variables
	AddTailFile("/* Declaration of dependent variables */");
	LineFeed();
	//findDep.targetNo denote the total number of dependent variables.
	//Of course include next time step vaiables.
	for(i=0;i<findDep.targetNo;i++) {
		if(!findDep.targetVar[i].m_theDep->IsKindOf(RUNTIME_CLASS(CMSDepVar)))
			continue;
		if(!findDep.targetVar[i].m_timeIndex->IsKindOf(RUNTIME_CLASS(CMSIndex)))
			continue;
		if(findDep.targetVar[i].m_number==0)
			sprintf(buf, "double %s[", (const char*) findDep.targetVar[i].m_theDep->GetName());
		else
			sprintf(buf, "double %s%d[", (const char*) findDep.targetVar[i].m_theDep->GetName()
			, findDep.targetVar[i].m_number);
		AddTailFile(buf);
		pos = pSpaceVars->GetHeadPosition();
		while(pos) { //while Solved model dimention continue.
			pSpaceVar = (CPDESpaceVar *) pSpaceVars->GetNext(pos);
			AddTailFile(pSpaceVar->m_division->GetName());
			if(pos) AddTailFile(m_bUseAry0? "][" : "+1][");
			//Above code 'm_bUseAry0? "][" : "+1][" denote 
			// if (m_bUserAry0 == TRUE) AddTailFile("][");
			// else (return FALSE) AddTailFile("+1][");
		}
		AddTailFile(m_bUseAry0? "];" : "+1];");
		//Add final brackets.
		//Above code 'm_bUseAry0? "]" : "+1]" denote 
		// if (m_bUserAry0 == TRUE) AddTailFile("]");
		// else (return FALSE) AddTailFile("+1]");
		sprintf(buf, "/* %s %s %d */", (const char*) findDep.targetVar[i].m_theDep->GetName()
		, (const char*) findDep.targetVar[i].m_timeIndex->GetName()
		, findDep.targetVar[i].m_timeShift.m_value
		, findDep.targetVar[i].m_number);
		//buf = /* T n 1 */,/*T n 0 */ etc.
		AddTailFile(buf);
		LineFeed();
	}
	LineFeed();

	/////////////////////////////////////////////////////////////////////////
	//--- Declaration of matrix and vector
	CSymbInst *pSb;
//	AddTailFile("/* Declaration of matrix and vector */"); //Kawa <- original
	AddTailFile("/*  --- ---  */");
	LineFeed();
	pos = findVar.m_matrix.GetStartPosition();
	while(pos) {
		findVar.m_matrix.GetNextAssoc(pos, key, (CObject*&) pMatrix);
//		if(pMatrix->GetCount()!=1) continue;
		pSb = (CSymbInst*) pMatrix->GetChild(0);
		if(!pSb->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
			int ddd = 2;
		sprintf(buf, "double %s", pMatrix->GetName());
		AddTailFile(buf);
		if(pMatrix->IsKindOf(RUNTIME_CLASS(CMSPDEVct)))	ddd = 1;
		for(i=0;i<ddd;i++) {
			AddTailFile("[");
			AddTailFile(pSb->GetSymbBody()->GetName());
			AddTailFile("+1]");
		}
		AddTailFile(";");
		LineFeed();
	}
	LineFeed();

}

/****************************************************************/
////// CJDCreateParaProgInC::DetailGen(CObject *g) //////////////////////////
// This function have faculity that output all generated codes except header to file.
/////////////////////////////////////////////////////////////////////////////
void CJDCreateParaProgInC::DetailGen(CObject *g)
{
//#if 1 //used developing debug
		char buf[100];
		POSITION pos;
		int i;

		m_lineNo = 0;
		//this is to create program
		//First step,Find CPDProc class from CPDEObjPrgPara PAD.
		//First found class was 'main()'.Output main() structure to file.
		//Second step,Research main() BOX and find called function or for structure.
		//Output these structure to file.
		//After Research main() BOX,fellow code find each function contents.
		//And in sequence output each function structure to file.
		if(g->IsKindOf(RUNTIME_CLASS(CPDProc))) {//vZXȂ
			CPDProc *pPrc = (CPDProc *) g;
			/******************************************/
			if(CString("main")==pPrc->GetName()) { //main̏o
				if(pPrc->GetCount() == 0) return; //no Argument
				sprintf(buf, "int %s(", pPrc->GetName()); //main()int^ʂɂoB
				AddTailFile(buf);

			}
			else {//if CString is not "main" 
				sprintf(buf, "void %s(", pPrc->GetName());
				AddTailFile(buf);
			}

			//evZXꍇ́Ä̊i[BOXłCPDELocalDefs݂B̃NX邩ǂ`FbNB
			POSITION Prg_pos,Local_pos;
			Prg_pos = m_mainProg->GetHeadPosition(); //Prg_posCPDEObjPrgPara̐擪ꏊ\
			CViecFC *pLocal; //[Jϐ{bNX̃NX
			while(Prg_pos){ //CPDEObjPrgPara̓B
				pLocal = (CViecFC*) m_mainProg->GetNext(Prg_pos);
				if(pLocal->IsKindOf(RUNTIME_CLASS(CPDELocalDefs))){ //NXCPDELocalDefsȉ̏
					/////////////////////////////////////////////////////////////////////////////////////////
					if(strcmp(pPrc->GetName(),pLocal->GetName()) == FALSE){//vĂFALSEAsvȂTURE
						//ړI̊֐ƕϐBOX̖Ov邩`FbNBȂΈႤBOX{B
						Local_pos = pLocal->GetHeadPosition(); //Local Box̍Wl
						CPElem *pMsArg;
						while(Local_pos){ //{bNX̌
							pMsArg = (CPElem *) pLocal->GetNext(Local_pos); //̃|C^[ƂB
							if(pMsArg->IsKindOf(RUNTIME_CLASS(CMSIndex))){ //^
								sprintf(buf, "int %s",(const char*) pMsArg->GetName());
								AddTailFile(buf);
							}
							if(pMsArg->IsKindOf(RUNTIME_CLASS(CMSChar))){ //^
								sprintf(buf, "char **%s",(const char*) pMsArg->GetName());
								AddTailFile(buf);
							}
							if(pMsArg->IsKindOf(RUNTIME_CLASS(CMSPDEMtx_1d))){ //1z^
								sprintf(buf, "double %s[", (const char*) pMsArg->GetName());
								AddTailFile(buf);
								POSITION Space_pos;
								if(pMsArg->GetCount() != 1) return; 
								Space_pos = pSpaceVars->GetHeadPosition(); //Index̍W
								pSpaceVar = (CPDESpaceVar *) pSpaceVars->GetNext(Space_pos);
								AddTailFile(pSpaceVar->m_division->GetName()); //IMAX,JMAX and KMAX
								AddTailFile(m_bUseAry0? "]" : "+1]");
								//Add final brackets.
								//Above code 'm_bUseAry0? "]" : "+1]" denote 
								// if (m_bUserAry0 == TRUE) AddTailFile("]");
								// else (return FALSE) AddTailFile("+1]");
							}
							if(pMsArg->IsKindOf(RUNTIME_CLASS(CMSPDEMtx))){ //2z^
								sprintf(buf, "double %s[", (const char*) pMsArg->GetName());
								AddTailFile(buf);
								POSITION Space_pos;
								Space_pos = pSpaceVars->GetHeadPosition(); //Index̍W
								while(Space_pos) { //while Solved model dimention continue.
									pSpaceVar = (CPDESpaceVar *) pSpaceVars->GetNext(Space_pos);
									AddTailFile(pSpaceVar->m_division->GetName()); //IMAX,JMAX and KMAX
									if(Space_pos) AddTailFile(m_bUseAry0? "][" : "+1]["); //z0gp邩ȂH
									//Above code 'm_bUseAry0? "][" : "+1][" denote 
									// if (m_bUserAry0 == TRUE) AddTailFile("][");
									// else (return FALSE) AddTailFile("+1][");
								}
								AddTailFile(m_bUseAry0? "]" : "+1]");
								//Add final brackets.
								//Above code 'm_bUseAry0? "]" : "+1]" denote 
								// if (m_bUserAry0 == TRUE) AddTailFile("]");
								// else (return FALSE) AddTailFile("+1]");
							}
							if(pMsArg->IsKindOf(RUNTIME_CLASS(CMSPDE_Mtx_3d))){ //3z^
								sprintf(buf, "double %s[", (const char*) pMsArg->GetName());
								AddTailFile(buf);
								POSITION Space_pos;
								Space_pos = pSpaceVars->GetHeadPosition(); //Index̍W
								while(Space_pos) { //while Solved model dimention continue.
									pSpaceVar = (CPDESpaceVar *) pSpaceVars->GetNext(Space_pos);
									AddTailFile(pSpaceVar->m_division->GetName()); //IMAX,JMAX and KMAX
									if(Space_pos) AddTailFile(m_bUseAry0? "][" : "+1]["); //z0gp邩ȂH
									//Above code 'm_bUseAry0? "][" : "+1][" denote 
									// if (m_bUserAry0 == TRUE) AddTailFile("][");
									// else (return FALSE) AddTailFile("+1][");
								}
								AddTailFile(m_bUseAry0? "]" : "+1]");
								//Add final brackets.
								//Above code 'm_bUseAry0? "]" : "+1]" denote 
								// if (m_bUserAry0 == TRUE) AddTailFile("]");
								// else (return FALSE) AddTailFile("+1]");
							}
							if(pMsArg->IsKindOf(RUNTIME_CLASS(CSymbInst))){ //ZL͎QƕϐiCPDELocalDefsł͗p邱Ƃ͂Ȃj
								POSITION Point_pos;
								Point_pos = pMsArg->GetHeadPosition(); //PointerZq̍Wl
								CPElem *pPoint;
								while(Point_pos) { //|C^[NX̎q̌
									pPoint = (CPElem *) pMsArg->GetNext(Point_pos);
									if(pPoint->IsKindOf(RUNTIME_CLASS(CMSIndex))){ //^|C^[ int*
										sprintf(buf, "int *%s",(const char*) pPoint->GetName());
										AddTailFile(buf);
									}
									if(pPoint->IsKindOf(RUNTIME_CLASS(CMSMpi_Datatype))){ //MPI_Datatype^|C^[ MPI_Datatype*
										sprintf(buf, "MPI_Datatype *%s",(const char*) pPoint->GetName());
										AddTailFile(buf);
									}
									if(Point_pos) AddTailFile(","); //ɎqȂEE
									//Above code 'm_bUseAry0? "][" : "+1][" denote 
									// if (m_bUserAry0 == TRUE) AddTailFile("][");
									// else (return FALSE) AddTailFile("+1][");
								}

							}
							if(pMsArg->IsKindOf(RUNTIME_CLASS(CMSMpi_Datatype))){ //MPI_Datatype^
								sprintf(buf, "MPI_Datatype %s",(const char*) pMsArg->GetName());
								AddTailFile(buf);
							}
							if(Local_pos) AddTailFile(","); //܂݂Ȃ΁EEE
						}
						break;
					}
				}
				/////////////////////////////////////////////////////////////////////////////////////////
			}

			AddTailFile(")"); LineFeed();//vZX

			AddTailFile("{");	LineFeed(); //vZX̊J
			m_indentNo++; //indent plus

			if(CString("main")==pPrc->GetName()) {
				/*
				if(m_bDebug) {
					AddTailFile("#ifdef ___DEBUG___"); LineFeed();
					FillIndent(); AddTailFile("InitDebug();"); LineFeed();
					AddTailFile("#endif"); LineFeed();
				}
				*/
				CEFile *pF;
				CString key;
				pos = findVar.m_file.GetStartPosition();
				for(i=1; pos; i++) {
					findVar.m_file.GetNextAssoc(pos, key, (CObject*&) pF);
					sprintf(buf, "filePnt%d = fopen(\"%s\", \"w\");", i, pF->GetName());
					//fileopen sturucture.
					FillIndent(); AddTailFile(buf); LineFeed();
				}
				//LineFeed();
			}

			pos = pPrc->GetHeadPosition(); //process̎̍Wl
			CPElem *pelm;
			while(pos) { //vZX̎qo
				pelm = (CPElem*) pPrc->GetNext(pos);
				if(pelm->IsKindOf(RUNTIME_CLASS(CPDArgs)) ||
					pelm->IsKindOf(RUNTIME_CLASS(CPDArgs2))) 
						continue; //vZX̊(CPDArgs,CPDArgs2)͂ŋLqƂ܂̂Ŕ΂
				pelm->SendMsg(MSG_DO_JOB, this);
			}

			if(CString("main")==pPrc->GetName()) {
				CEFile *pF;
				CString key;
				pos = findVar.m_file.GetStartPosition();
				for(i=1; pos; i++) {
					findVar.m_file.GetNextAssoc(pos, key, (CObject*&) pF);
					sprintf(buf, "fclose(filePnt%d);", i, pF->GetName());
					//fileopen sturucture.
					FillIndent(); AddTailFile(buf); LineFeed();
				}
				//LineFeed();
			}
			m_indentNo--;
			AddTailFile("}");	LineFeed();

		/*************************************************/
		// if g-pointer indicate CPDBBrkPnt class,
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDBrkPnt))) {
			CPDBrkPnt *pBrkPnt = (CPDBrkPnt *) g;
			if(pBrkPnt->GetCount()!=1) return;
			CSymbInst *pObjI = (CSymbInst *) pBrkPnt->GetChild(0);
			if(!pObjI->IsKindOf(RUNTIME_CLASS(CSymbInst))) return;
			if(!pObjI->GetSymbBody()) return;
			CPDEBrkObj *pObj = (CPDEBrkObj *) pObjI->GetSymbBody();
			if(!pObj->IsKindOf(RUNTIME_CLASS(CPDEBrkObj))) return;
			if(!m_bDebug) return;
			AddTailFile("#ifdef ___DEBUG___"); LineFeed();
			sprintf(buf, "lstrcpy(system_vars->pszStatus, \"%s,%s\");"
				, (const char *) pBrkPnt->GetName(), (const char *) pObj->GetName());
			FillIndent();	AddTailFile(buf);	LineFeed();
			FillIndent();	AddTailFile("SetEvent(hSignal);"); LineFeed();
//			FillIndent();	AddTailFile("PulseEvent(hSignal);"); LineFeed();
			sprintf(buf, "WaitForSingleObject(h%s, INFINITE);"
				, (const char *) pObj->GetName());
			FillIndent();	AddTailFile(buf);	LineFeed();
//			FillIndent();	AddTailFile("system_vars->pszStatus[0]=0;"); LineFeed();
			AddTailFile("#endif"); LineFeed();
		/*************************************************/
		// if g-pointer indicate CPDOutput class,
		// CPDOutput class denote 'printf()' structure.Date output.
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDOutput))) {
			CSymbInst *pI;
			CPDOutput *pPrt = (CPDOutput *) g;
			if(pPrt->GetCount()!=1) return;
			CPDArgs *pArg = (CPDArgs *) pPrt->GetChild(0);
			if(!pArg->IsKindOf(RUNTIME_CLASS(CPDArgs))) return;
			FillIndent();	AddTailFile("printf(\"");
			pos = pArg->GetHeadPosition();
			while(pos) {
				pI = (CSymbInst *) pArg->GetNext(pos);
				if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
				if(pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSIndex))
				|| pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSCInteger))) {
					AddTailFile("%d ");
				} else {
					AddTailFile("%e ");
				}
			}
			AddTailFile("\\n\"");
			pos = pArg->GetHeadPosition();
			while(pos) {
				pI = (CSymbInst *) pArg->GetNext(pos);
				if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
				AddTailFile(",");
				pI->SendMsg(MSG_DO_JOB, this);
			}
			AddTailFile(");"); LineFeed();

		/*************************************************/
		// if g-pointer indicate CPDOutput_txt class,
		// CPDOutput_txt class denote 'printf()' structure.Date output.
		//txt̏o͂SNX
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDOutput_txt))) {
			CMSArg *pTxt;
			CPDOutput_txt *pPrt = (CPDOutput_txt *) g;
			if(pPrt->GetCount()!=1) return;
			CPDArgs *pArg = (CPDArgs *) pPrt->GetChild(0);
			if(!pArg->IsKindOf(RUNTIME_CLASS(CPDArgs))) return;
			FillIndent();	AddTailFile("printf(\"");
			pos = pArg->GetHeadPosition();
			while(pos) {
				pTxt = (CMSArg *) pArg->GetNext(pos);
				sprintf(buf,pTxt->GetName());
				AddTailFile(buf);
			}
			AddTailFile("\\n\"");
			AddTailFile(");"); LineFeed();
		/*************************************************/
		// if g-pointer indicate CPDFile class,
		// CPDOutput class denote 'Decralation of file pointer' 
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDFile))) {
			CSymbInst *pI;
			CEFile *pF;
			CString key;
			int i,j;
			j = -1;
			CPDOutput *pPrt = (CPDOutput *) g;
			if(pPrt->GetCount()!=2) return;
			pI = (CSymbInst *) pPrt->GetChild(0);
			pos = findVar.m_file.GetStartPosition();
			for(i=1; pos; i++) {
				findVar.m_file.GetNextAssoc(pos, key, (CObject*&) pF);
				if(key==CString(pI->GetSymbBody()->GetName())) {
					sprintf(buf, "FILE *filePnt%d;", i);
					j = i;
					break;
				}
			}
			if(j<1) return;
			CPDArgs *pArg = (CPDArgs *) pPrt->GetChild(1);
			if(!pArg->IsKindOf(RUNTIME_CLASS(CPDArgs))) return;
			sprintf(buf, "fprintf(filePnt%d, \"", j);
			FillIndent();	AddTailFile(buf);
			pos = pArg->GetHeadPosition();
			while(pos) {
				pI = (CSymbInst *) pArg->GetNext(pos);
				if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
				if(pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSIndex))
				|| pI->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSCInteger))) {
					AddTailFile("%d ");
				} else {
					AddTailFile("%e ");
				}
			}
			AddTailFile("\\n\"");
			pos = pArg->GetHeadPosition();
			while(pos) {
				pI = (CSymbInst *) pArg->GetNext(pos);
				if(!pI->IsKindOf(RUNTIME_CLASS(CSymbInst))) continue;
				AddTailFile(",");
				pI->SendMsg(MSG_DO_JOB, this);
			}
			AddTailFile(");"); LineFeed();

		/*************************************************/
		// if g-pointer indicate CPDVar class,
		// CPDVar class denote 'Variable Type' structure.
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDVar))) {
			CPDVar *pVar = (CPDVar *) g;
			BOOL fstFg ;
			if(pVar->GetCount()==0) return;

			//CPDArgs,CPDArgs2CPDVar̔hNXłBʂ̒̎qNXLq郋[vłB
			if(pVar->IsKindOf(RUNTIME_CLASS(CPDArgs2)) ||
				pVar->IsKindOf(RUNTIME_CLASS(CPDArgs))) {
				sprintf(buf,"("); //J
				AddTailFile(buf);
				pos = pVar->GetHeadPosition(); //()̐擪W
				while(pos){
					pVar->GetNext(pos)->SendMsg(MSG_DO_JOB,this); //q̋Lq
				}
				sprintf(buf,")"); //
				AddTailFile(buf);
			}

			//--- int variable
			fstFg = TRUE;
			pos = pVar->GetHeadPosition();
			while(pos) {
				CMSIndex *pIdx;
				pIdx = (CMSIndex*) pVar->GetNext(pos);
				if(pIdx->IsKindOf(RUNTIME_CLASS(CMSIndex))) {
					if(fstFg) {
						FillIndent();
						AddTailFile("int ");
					} else {
						AddTailFile(", ");
					}
					sprintf(buf, "%s", pIdx->GetName());
					AddTailFile(buf);
					fstFg = FALSE;
				}
			}
			if(!fstFg) {
				AddTailFile(";");
				LineFeed();
			}

			//--- Int 1d-array variable
			fstFg = TRUE;
			pos = pVar->GetHeadPosition();
			while(pos) { //1zo[vłB
				CMSIndex_Mtx *pIndMt; //1z
				pIndMt = (CMSIndex_Mtx *) pVar->GetNext(pos);
				if(pIndMt->IsKindOf(RUNTIME_CLASS(CMSIndex_Mtx))) {
					if(fstFg) {
						FillIndent();
						AddTailFile("int ");
					} else {
						AddTailFile(", ");
					}
					sprintf(buf, "%s[", pIndMt->GetName()); //z
					AddTailFile(buf);
					pIndMt->GetChild(0)->SendMsg(MSG_DO_JOB,this); //q̋Lqiz̈j
					AddTailFile("]");
					fstFg = FALSE;
				}
			}
			if(!fstFg) {
				AddTailFile(";");
				LineFeed();
			}

			//--- double variable
			fstFg = TRUE;
			pos = pVar->GetHeadPosition();
			while(pos) {
				CMSConst *pCnst;
				pCnst = (CMSConst *) pVar->GetNext(pos);
				if(pCnst->IsKindOf(RUNTIME_CLASS(CMSConst))) {
					if(fstFg) {
						FillIndent();
						AddTailFile("double ");
					} else {
						AddTailFile(", ");
					}
					sprintf(buf, "%s", pCnst->GetName());
					AddTailFile(buf);
					fstFg = FALSE;
				}
			}
			if(!fstFg) {
				AddTailFile(";");
				LineFeed();
			}

			//--- double array variable
			fstFg = TRUE;
			pos = pVar->GetHeadPosition();
			while(pos) {
				CMSPDEMtx_1d *pCns1d;
				pCns1d = (CMSPDEMtx_1d *) pVar->GetNext(pos);
				if(pCns1d->IsKindOf(RUNTIME_CLASS(CMSPDEMtx_1d))) {
					if(fstFg) {
						FillIndent();
						AddTailFile("double ");
					} else {
						AddTailFile(", ");
					}
					sprintf(buf, "%s[", pCns1d->GetName());
					AddTailFile(buf);
					pCns1d->GetChild(0)->SendMsg(MSG_DO_JOB,this); //q̋Lqiz̈j
					AddTailFile("]");
					fstFg = FALSE;
				}
			}
			if(!fstFg) {
				AddTailFile(";");
				LineFeed();
			}

			//--- MPI_Datatype variable
			fstFg = TRUE;
			pos = pVar->GetHeadPosition();
			while(pos) { //MPI_Datatype^̕ϐo
				CMSMpi_Datatype *pMpiDat;
				pMpiDat = (CMSMpi_Datatype *) pVar->GetNext(pos);
				if(pMpiDat->IsKindOf(RUNTIME_CLASS(CMSMpi_Datatype))) {
					if(fstFg) { //fstFgTRUEȂŏi̍sj̕ϐłBFALSEȂ擪ł͂ȂB
						FillIndent();
						AddTailFile("MPI_Datatype ");
					} else {
						AddTailFile(", ");
					}
					sprintf(buf, "%s", pMpiDat->GetName()); //ϐ
					AddTailFile(buf);
					fstFg = FALSE;
				}
			}
			if(!fstFg) { //FALSEȂ΍słB
				AddTailFile(";");
				LineFeed();
			}


			
		/*************************************************/
		// if g-pointer indicate CPDComm class,
		// CPDComm class denote 'CPDComm???' 
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDComm))) {
			CPDComm *pCmm = (CPDComm *) g;
			sprintf(buf, "/* %s */", pCmm->GetName());
			FillIndent();
			AddTailFile(buf);
			LineFeed();

		/*************************************************/
		// if g-pointer indicate CPDOBlock class,
		// CPDBlock class denote 'PAD BOX' structure.
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDBlock))) {
			CPDBlock *pBlk = (CPDBlock *) g;
			sprintf(buf, "/* %s */", pBlk->GetName());
			FillIndent();
			AddTailFile(buf);
			LineFeed();

			FillIndent();
			AddTailFile("{");	LineFeed();
			m_indentNo++;
			pos = pBlk->GetHeadPosition();
			while(pos)
				pBlk->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
			m_indentNo--;
			FillIndent();
			AddTailFile("}");	
			LineFeed();

		/*************************************************/
		// if g-pointer indicate CPDOFor class,
		// CPDOFor class denote 'for loop' structure.
		}else if(g->IsKindOf(RUNTIME_CLASS(CPDFor))){
			CPDFor *pFor = (CPDFor *) g;
			if(pFor->GetCount()<1) return;
			pos = pFor->GetHeadPosition();
			CPDForSub *pForSub = (CPDForSub *) pFor->GetNext(pos);
			if(pForSub->GetCount()<3) return;
			int skip = 0;
			CMSFract *pF;
			if(pForSub->GetCount()==4) {
				pF = (CMSFract *) pForSub->GetChild(3);
				if(pF->IsKindOf(RUNTIME_CLASS(CMSFract)))
					if(pF->m_value!=0 && pF->m_value!=1)
						skip = pF->m_value;
			}
			FillIndent();
			AddTailFile("for(");
			pForSub->GetChild(0)->SendMsg(MSG_DO_JOB, this);
			AddTailFile("=");
			pForSub->GetChild(1)->SendMsg(MSG_DO_JOB, this);
			AddTailFile("; ");
			pForSub->GetChild(0)->SendMsg(MSG_DO_JOB, this);
			if(skip>=0) {
				AddTailFile("<=");
			} else if(skip<0) {
				AddTailFile(">=");
			}
			pForSub->GetChild(2)->SendMsg(MSG_DO_JOB, this);
			AddTailFile("; ");
			pForSub->GetChild(0)->SendMsg(MSG_DO_JOB, this);
			if(skip==0) {
				AddTailFile("++) {");
			}else if(skip>1) {
				sprintf(buf, "+= %d) {", skip);
				AddTailFile(buf);
			} else if(skip<0) {
				sprintf(buf, "-= %d) {", -skip);
				AddTailFile(buf);
			}
			LineFeed();

			m_indentNo++;
			while(pos)
				pFor->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
			m_indentNo--;
			FillIndent();
			AddTailFile("}");	LineFeed();

		/*************************************************/
		// if g-pointer indicate CPDIf class,
		// CPDIf class denote 'if ' structure.
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDIf))) {
			CPDIf *pIf = (CPDIf *) g;
			if(pIf->GetCount()==3) {
				CPad *pCond = (CPad *) pIf->GetChild(0);
				CPad *pThen = (CPad *) pIf->GetChild(1);
				CPad *pElse = (CPad *) pIf->GetChild(2);

				FillIndent();
				AddTailFile("if(");
				pCond->SendMsg(MSG_DO_JOB, this);
				AddTailFile(") {");
				LineFeed();

				m_indentNo++;
				pos = pThen->GetHeadPosition();
				while(pos)
					pThen->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
				m_indentNo--;
				if(pElse->GetCount()>0) {
					FillIndent();
					AddTailFile("} else {");
					LineFeed();
					m_indentNo++;
					pos = pElse->GetHeadPosition();
					while(pos)
						pElse->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
					m_indentNo--;
				}
				FillIndent();
				AddTailFile("}");
				LineFeed();
			}

		/*************************************************/
		// if g-pointer indicate CPDCall class,
		// CPDCall class denote 'called function ' structure.
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDCall))) {
			CPDCall *pCall = (CPDCall *) g;
			FillIndent();
			sprintf(buf, "%s();", pCall->GetName());
			AddTailFile(buf);
			LineFeed();

		/*************************************************/
		// if g-pointer indicate CPDSubst class,
		// CPDSubst class denote 'substitution equation 'structure.
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDSubst))) {
			CPad *pad = (CPad *) g;
			pos = pad->GetHeadPosition();
			while(pos)
				pad->GetNext(pos)->SendMsg(MSG_DO_JOB, this);

		/*************************************************/
		// if g-pointer indicate CPDSymbInst class,
		// CPDSymbInst class denote 'Symbolles 'structure.
		} else if(g->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
			CSymbInst *pInst = (CSymbInst *) g;

			if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOEqual))) {
				if(pInst->GetCount()==2) {
					m_bEqual = TRUE; //CR[ʉ߂Ȃ΁i킷j
					FillIndent();
					pInst->GetChild(0)->SendMsg(MSG_DO_JOB, this);
					AddTailFile(" = ");
					pInst->GetChild(1)->SendMsg(MSG_DO_JOB, this);
					AddTailFile(";");
					LineFeed();
					m_bEqual = FALSE; //I
					m_bFract = FALSE; //͕ϐ܂ސI
				}

			/*************************************************/
			// if g-pointer indicate CMSOAbs class,
			// CMSOAbs class denote 'Absolute symbol 'structure.
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOAbs))) {
				AddTailFile("fabs(");
				pInst->GetChild(0)->SendMsg(MSG_DO_JOB, this);
				AddTailFile(")");
				if(m_lineNo>0) {
					BOOL b = pInst->IsKindOf(RUNTIME_CLASS(CSymbInst));
				}

			/*************************************************/
			// if g-pointer indicate CMSONeg class,
			// CMSONeg class denote 'symbol - 'structure.
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
				CMSONeg *pNeg = (CMSONeg *) pInst->GetSymbBody();
				if(pInst->GetCount()==0) return;
				if(pInst->GetParent()->IsKindOf(RUNTIME_CLASS(CSymbInst))
				&& ((CSymbInst*)pInst->GetParent())->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
					pInst->GetChild(0)->SendMsg(MSG_DO_JOB, this);
				} else {
					if(pNeg->IsBrcRq(pInst))	AddTailFile("(");
					AddTailFile("-");
					pInst->GetChild(0)->SendMsg(MSG_DO_JOB, this);
					if(pNeg->IsBrcRq(pInst))	AddTailFile(")");
				}

			/*************************************************/
			// if g-pointer indicate CMSOAdrs,
			// CMSOAdrs denote 'symbol &? structure. 
			// codeing by fujita. 99/02/15.
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOAdrs))) {
				CMSOAdrs *pAdrs = (CMSOAdrs *) pInst->GetSymbBody();
				if(pInst->GetCount()==0) return; //Ȃ炸qB
				AddTailFile("&"); //AhXL
				pInst->GetChild(0)->SendMsg(MSG_DO_JOB, this); //q̋Lq AhXϐ

			/*************************************************/
			// if g-pointer indicate CMSOPoint,
			// CMSOPoint denote 'symbol *? structure. 
			// codeing by fujita. 99/02/15.
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPoint))) {
				CMSOPoint *pPoint = (CMSOPoint *) pInst->GetSymbBody();
				if(pInst->GetCount()==0) return; //Ȃ炸qB
				AddTailFile("*"); //|C^[L
				pInst->GetChild(0)->SendMsg(MSG_DO_JOB, this); 
			/*************************************************/
			// if g-pointer indicate CMSOPlus class,
			// CMSOPlus class denote 'symbol + 'structure.
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
				CMSOPlus *pPls = (CMSOPlus*) pInst->GetSymbBody();
				CViecFC *pelm;
				BOOL bArraySubs = m_bArraySubsc;
				BOOL bBrc = pPls->IsBrcRq(pInst);

				if(pInst->GetParent()->IsKindOf(RUNTIME_CLASS(CSymbInst))
					&& ((CSymbInst*)pInst->GetParent())->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSODiv)))
					bBrc = TRUE;

				m_bArraySubsc = FALSE;
				if(bBrc)	AddTailFile("(");
				int lineNo = 0;
				int startCol = m_startCol;
				m_startCol = m_curCol;
				pos = pInst->GetHeadPosition();
				pelm = pInst->GetNext(pos);
				if(pelm->IsKindOf(RUNTIME_CLASS(CSymbInst))
				&& ((CSymbInst*)pelm)->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg)))
					AddTailFile("-");
//				pelm->SendMsg(MSG_DO_JOB, this);
				m_lineNo = 0;
				pelm->SendMsg(MSG_DO_JOB, this);
				lineNo += m_lineNo;
				while(pos) {
					pelm = pInst->GetNext(pos);
					char *pmk = "+";
					char *nextPnt = m_nextPnt;
					int curCol = m_curCol;
					if(pelm->IsKindOf(RUNTIME_CLASS(CSymbInst))
					&& ((CSymbInst*)pelm)->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSONeg))) {
						pmk = "-";
					} else if(pelm->IsKindOf(RUNTIME_CLASS(CMSNumber))
					&& ((CMSNumber*)pelm)->IsNeg()) {
						pmk = "-";
					}
					m_lineNo = 0;
					AddTailFile(pmk);
					pelm->SendMsg(MSG_DO_JOB, this);
					lineNo += m_lineNo;
					if(m_lineNo>0 || m_curCol>=m_maxWd) {
						lineNo -= m_lineNo;
						m_nextPnt = nextPnt;
						m_curCol = curCol;
						LineFeed();
						FillIndent();  //insert TAB 
						AddTailFile(pmk);
						pelm->SendMsg(MSG_DO_JOB, this);
						lineNo += m_lineNo;
						lineNo++;
					}
				}
				if(bArraySubs && m_bUseAry0)	AddTailFile("-1");
				if(bBrc)	AddTailFile(")");
				m_lineNo = lineNo;
				m_startCol = startCol;

			/*************************************************/
			// if g-pointer indicate CMSODiv class,
			// CMSODiv class denote 'symbol / 'structure.
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSODiv))) {
				if(pInst->GetCount()==2) {
					pInst->GetChild(0)->SendMsg(MSG_DO_JOB, this);	//q̋Lq
					AddTailFile("/");
					AddTailFile("(");
					pInst->GetChild(1)->SendMsg(MSG_DO_JOB, this); //̋Lq
					AddTailFile(")");
				}

			/*************************************************/
			// if g-pointer indicate CMSOperator class,
			// CMSOperator class denote '??? 'structure.
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOperator))) {
				CViecFC *pelm;					  // for *, mod???
				CMSOperator *pOp = (CMSOperator *) pInst->GetSymbBody();
				if(pOp->IsBrcRq(pInst))	AddTailFile("(");
				int lineNo = 0;
				int startCol = m_startCol;
				m_startCol = m_curCol;
				pos = pInst->GetHeadPosition();
				pelm = pInst->GetNext(pos);
				m_lineNo = 0;
				pelm->SendMsg(MSG_DO_JOB, this);
				lineNo += m_lineNo;
				while(pos) {
					pelm = pInst->GetNext(pos);
					char *nextPnt = m_nextPnt;
					int curCol = m_curCol;
					AddTailFile(pOp->GetName());
					m_lineNo = 0;
					pelm->SendMsg(MSG_DO_JOB, this);
					lineNo += m_lineNo;
					if(m_lineNo>0 || m_curCol>=m_maxWd) {
						lineNo -= m_lineNo;
						m_nextPnt = nextPnt;
						m_curCol = curCol;
						LineFeed();
						FillIndent();
						AddTailFile(pOp->GetName());
						pelm->SendMsg(MSG_DO_JOB, this);
						lineNo += m_lineNo;
						lineNo++;
					}
				}
				if(pOp->IsBrcRq(pInst))	AddTailFile(")");
				m_lineNo = lineNo;
				m_startCol = startCol;

			/*************************************************/
			// if g-pointer indicate CMSDepVar class,
			// CMSDepVar class denote 'Dependent variable 'structure.
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSDepVar))) {
				int i;						 // put indexes for n, i,j,k
				//if(pInst->GetCount()<2) return; //q2ȏ゠B͕łł͈ႤB֐̈ɎĝŁB

				//ύX
				pos = pInst->GetHeadPosition();
				pInst->GetNext(pos);
				for(i=0;i<findDep.targetNo;i++)
					if(findDep.targetVar[i].IsThis(pInst))
						break;
				if(i>=findDep.targetNo) return;
				if(findDep.targetVar[i].m_number==0)
					sprintf(buf, "%s", (const char*) pInst->GetSymbBody()->GetName());
				else
					sprintf(buf, "%s%d", (const char*) pInst->GetSymbBody()->GetName()
					, findDep.targetVar[i].m_number);
				AddTailFile(buf);
				while(pos) {
					AddTailFile("[");
					m_bArraySubsc = TRUE;
					m_bFract = FALSE; //͕K^
					pInst->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
					m_bArraySubsc = FALSE;
					AddTailFile("]");
				}
				if(m_bEqual) m_bFract = TRUE; //͕ϐ܂ސȂCMSFract͎^ɂB

			/*************************************************/
			// if g-pointer indicate CMathSymb class,
			// CMathsymb class denote 'Mathmatical symbol TT 'structure.
			} else if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMathSymb))) {
				BOOL bArraySubsc = m_bArraySubsc;
				m_bArraySubsc = FALSE;
				AddTailFile(pInst->GetSymbBody()->GetName());
				pos = pInst->GetHeadPosition();
				while(pos) {
					AddTailFile("[");
					m_bArraySubsc = TRUE;
					pInst->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
					m_bArraySubsc = FALSE;
					AddTailFile("]");
				}
				if(bArraySubsc && m_bUseAry0) AddTailFile("-1");
			}

		/*************************************************/
		// if g-pointer indicate CMSRealEx class,
		// CMSRealEx class denote 'real number type 'structure.
		} else if(g->IsKindOf(RUNTIME_CLASS(CMSRealEx))) {
			CMSRealEx *pR = (CMSRealEx *) g;
			double val = pR->m_value;
			BOOL kakko = FALSE;

			if(pR->GetParent()->IsKindOf(RUNTIME_CLASS(CSymbInst))
			&& ((CSymbInst*)pR->GetParent())->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
				if(val<0)
					val = -val;
			} else if(pR->GetParent()->IsKindOf(RUNTIME_CLASS(CSymbInst))
			&& ((CSymbInst*)pR->GetParent())->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOperator))) {
				kakko = TRUE;
			}
			if(kakko && val<0)
				sprintf(buf, "(%lf)", val);
			else
				sprintf(buf, "%lf", val);
			AddTailFile(buf);

		/*************************************************/
		// if g-pointer indicate CMSFract class,
		// CMSFract class denote ' type 'structure.
		} else if(g->IsKindOf(RUNTIME_CLASS(CMSFract))) {
			CMSFract *pF = (CMSFract *) g;
			int val = pF->m_value; //qvalue
			BOOL kakko = FALSE;

			if(pF->GetParent()->IsKindOf(RUNTIME_CLASS(CSymbInst))
			&& ((CSymbInst*)pF->GetParent())->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOPlus))) {
				//̐̕ẻZq+Ȃ
				if(val<0)
					val = -val; //}CiX̒l̂Ƃ̏
			} else if(pF->GetParent()->IsKindOf(RUNTIME_CLASS(CSymbInst))
			&& ((CSymbInst*)pF->GetParent())->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSOperator))) {
				//̐̕ẻZq̉ZȂ
				kakko = TRUE; //ʂ
			}
			if(pF->m_deno==1) // ftHgł1
				if(kakko && val<0){
					if(m_bFract) sprintf(buf, "(%6.3f)", (double)val); //}CiX
					else sprintf(buf, "(%d)", val); //}CiX
				}else{
					if(m_bFract) sprintf(buf, "%6.3f", (double)val); //vX
					else sprintf(buf, "%d", val); //vX
				}
			else
				if(kakko && val<0){
					if(m_bFract) sprintf(buf, "(%6.3f/%6.3f)", (double)val, (double)pF->m_deno); //
					else sprintf(buf, "(%d/%u)", val, pF->m_deno);
				}else{
					if(m_bFract) sprintf(buf, "%6.3f/%6.3f", (double)val, (double)pF->m_deno); //
					else sprintf(buf, "%d/%u", val, pF->m_deno);
				}
			AddTailFile(buf);
			
		/**************************************************/
		/*************************************************/
		// if g-pointer indicate CPDCallBy class,
		// CPDCallBy class denote 'Funciton with arguments ' structure.
		} else if(g->IsKindOf(RUNTIME_CLASS(CPDCallBy))) {
			CPDCallBy *pCall = (CPDCallBy *) g;
			/******************************************/
			FillIndent();
			sprintf(buf, "%s(", pCall->GetName());
			AddTailFile(buf);
			pos = pCall->GetHeadPosition(); //̐擪W擾
			CPDArgs *pArg = (CPDArgs *) pCall->GetNext(pos); //̃NXɂ͕Kʂ̎qNXB
			if(pArg->IsKindOf(RUNTIME_CLASS(CPDArgs))) {
				POSITION pos2;
				CPElem *pMsArg; 
				pos2 = pArg->GetHeadPosition();  //ʂ̎qNX̐擪Wl
				while(pos2) { //qȂȂ܂ł̃[vJԂB
					pMsArg = (CPElem *) pArg->GetNext(pos2);
					pMsArg->SendMsg(MSG_DO_JOB, this);
					if(pos2) AddTailFile(","); //ɎqȂEE
				}
			}
			AddTailFile(");"); LineFeed(); //ʂ̒̎qȂȂEE

			//̎qɈڂB
			while(pos) {
				pCall->GetNext(pos)->SendMsg(MSG_DO_JOB, this);
			}

		}
		/*************************************************/

//#endif
}


/***************************************************/
//****BOOL CJDCreateParaProgInC::Do(CObject *g)****//
BOOL CJDCreateParaProgInC::Do(CObject *g)
{

	if(!m_bStartFg) {
		// the lowest level
		CPDEObjPrg *pObjPrg;
		CString key;
		CMSFract num;
		int i;

		//--- checks and preparations
		if(!g->IsKindOf(RUNTIME_CLASS(CPDEObjPrg))) return TRUE;
		pObjPrg = (CPDEObjPrg *) g;
		//m_PrbPara = (CPDEPrbPara*) pObjPrg->GetParanet(); //Problem̃|C^[mہB
		m_mainProg->SendMsg(MSG_DO_JOB, &findProc);
		m_pdeInfo->SendMsg(MSG_DO_JOB, &findProc);
		if(findProc.m_procNo==0) return TRUE;
		m_bStartFg = TRUE;
		m_mainProg->SendMsg(MSG_DO_JOB, &findVar);
		for(i=0;i<findProc.m_procNo; i++)
			findProc.m_procLst[i]->SendMsg(MSG_DO_JOB, &findDep);

		pTimeVar = (CPDETimeVar *) m_pdeInfo->GetChildElem(RUNTIME_CLASS(CPDETimeVar));
		if(pTimeVar==NULL) return TRUE;

		pSpaceVars = m_pdeInfo->m_meshInfo->m_spaceVars;
		if(!pSpaceVars || !pSpaceVars->IsKindOf(RUNTIME_CLASS(CPDESpaceVars))) return TRUE;
		if(pSpaceVars->GetCount()==0) return TRUE;

		pIndexFold = (CPDEIndexFold *) pTimeVar->m_indexFold;
		if(!pIndexFold || !pIndexFold->IsKindOf(RUNTIME_CLASS(CPDEIndexFold))) return TRUE;

		//--- open a program file to write into
		m_hFile = ::CreateFile(m_fileName, GENERIC_WRITE | GENERIC_READ,
			0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if(m_hFile==INVALID_HANDLE_VALUE) return TRUE;
		m_hFileMap = ::CreateFileMapping(m_hFile, NULL, PAGE_READWRITE,
			0, 1024*1024, NULL);
		if(m_hFileMap==NULL) {
			::CloseHandle(m_hFile);
			return TRUE;
		}
		m_lpvFile = ::MapViewOfFile(m_hFileMap, FILE_MAP_WRITE, 0,0,0);
		if(m_lpvFile==NULL) {
			::CloseHandle(m_hFileMap);
			::CloseHandle(m_hFile);
			return TRUE;
		}
		m_nextPnt = m_firstPnt = (char *) m_lpvFile;

		//--- sorting the dep var and generate the program
		SortDep();

		// generate the header
		if(!m_bDebug)
			//ProgGen();
			Para_ProgGen();
		else
			ProgGenDebug();
			//͕łɂ͓KpĂȂB

		//--- program generation
		for(i=0;i<findProc.m_procNo; i++) {
			findProc.m_procLst[i]->SendMsg(MSG_DO_JOB, this);
			LineFeed();
			LineFeed();
		}

		//--- close the program file
		::UnmapViewOfFile(m_lpvFile);
		::CloseHandle(m_hFileMap);
		::SetFilePointer(m_hFile, m_nextPnt-m_firstPnt, NULL, FILE_BEGIN);
		::SetEndOfFile(m_hFile);
		::CloseHandle(m_hFile);
		return TRUE;
	} else {
		DetailGen(g);  // after the first stop	 //in para
		return TRUE;
	}
	return FALSE;
}
////////////// CJDCreateParaProgInC /////////////////////
////////////// CJDCreateParaProgInC /////////////////////
//////////////        end		    /////////////////////




//////////////// CPDEObjPrgPara /////////////////////
//////////////// CPDEObjPrgPara /////////////////////
//////////////// CPDEObjPrgPara /////////////////////
int CPDEObjPrgPara::OnCommand(UINT id)
{
	DWORD tid;
	switch(id) {
	case CMD_RUN_CREATE_C:
		{
			CPDEProblem *pPrb;
			pPrb = (CPDEProblem *) GetParent();
			if(pPrb->IsKindOf(RUNTIME_CLASS(CElemView)))
				pPrb = (CPDEProblem *) GetInstBody()->GetParent();
			if(!pPrb->IsKindOf(RUNTIME_CLASS(CPDEProblem))) return TRUE;
			CFileDialog dlgFile(FALSE, NULL, "*.c", OFN_OVERWRITEPROMPT);
			if(dlgFile.DoModal()!=IDOK) break;

			/*			
			//\o[̐ɕϊ镔ł邪łׂdł͂ȂB
			//ƑȌ̒iKōsׂƍlB

			POSITION pos;
			pos = this->GetHeadPosition();
			CViecFC* pViec;
			CJDFract2Real real;//ׂẴIuWFNg̃NX𒲂ׂBCMSFract̃NXɕϊB
			while(pos){
				pViec = (CViecFC*) GetNext(pos);
				if(pViec->IsKindOf(RUNTIME_CLASS(CPDEInvokedProcs)))
					pViec->SendMsg(MSG_DO_JOB, &real); //ȂKvȂ́H
			}
			*/
			

			CJDCreateParaProgInC progMaker;
			progMaker.m_bDebug = FALSE;
			progMaker.m_fileName = dlgFile.GetPathName();
			progMaker.m_mainProg = this;
			progMaker.m_pdeInfo = pPrb->m_pdeInfo;
			SendMsg(MSG_DO_JOB, &progMaker);
		}
		return TRUE;
	case CMD_RUN_CREATE_C_DEBUG:
		{
			CPDEProblem *pPrb;
			pPrb = (CPDEProblem *) GetParent();
			if(pPrb->IsKindOf(RUNTIME_CLASS(CElemView)))
				pPrb = (CPDEProblem *) GetInstBody()->GetParent();
			if(!pPrb->IsKindOf(RUNTIME_CLASS(CPDEProblem))) return TRUE;
			CFileDialog dlgFile(FALSE, NULL, "*.c", OFN_OVERWRITEPROMPT);
			if(dlgFile.DoModal()!=IDOK) break;
			sPathName = dlgFile.GetPathName();
			sFileName = dlgFile.GetFileName();
			if(sFileName.Right(2)==".c")
				sFileName = sFileName.Left(sFileName.GetLength()-2);
			sFileExt = dlgFile.GetFileExt();
			sFileTitle = dlgFile.GetFileTitle();
			sPath = sPathName.Left(sPathName.GetLength() - sFileName.GetLength() - 3);
			m_bGen = TRUE;

			CJDCreateParaProgInC progMaker;
			progMaker.m_bDebug = TRUE;
			progMaker.m_fileName = dlgFile.GetPathName();
			progMaker.m_mainProg = this;
			progMaker.m_pdeInfo = pPrb->m_pdeInfo;
			SendMsg(MSG_DO_JOB, &progMaker);
		}
		return TRUE;
	}
	return CPDEObjPrg::OnCommand(id);
}

//////////////////////  CJDGatherParaVar  //////////////////////
//////////////////////  CJDGatherParaVar  //////////////////////

CJDGatherParaVar::CJDGatherParaVar()
{
	//͉̂킩ȂB
}

BOOL CJDGatherParaVar::Do(CObject *g)
{
	if(g->IsKindOf(RUNTIME_CLASS(CSymbInst))) {
		CSymbInst *pInst = (CSymbInst*) g;
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CPDEBrkObj))) {
			m_brkObj[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody(); //u[N|CgOBJ
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSDepVar))) {
			m_depVar[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody(); //͕ϐWB
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSIndep))) {
			m_indepVar[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody(); //ƗϐWB
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSPDEMtx))) {
			m_matrix[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody(); //2dimsWB
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSMeshSize))) {
			m_const[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody(); //bVϐWB
			//NMAXCMSMeshSize class łBIMAX,JMAX,KMAX,Max_CPU,X_div,Y_div,Z_div
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSCReal))) {
			m_para[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody(); //ϐWB
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CPDEConstDef))) {
			m_const2[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody(); //͕ϐWB
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CEFile))) {
			m_file[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody(); //t@C|C^WB
			return TRUE;
		}
		/*
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSMpi_Status))) {
			m_mpi_status[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody(); //MPI_StatusWB
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSMpi_Request))) {
			m_mpi_req[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody(); //MPI_RequestWB
			return TRUE;
		}
		if(pInst->GetSymbBody()->IsKindOf(RUNTIME_CLASS(CMSMpi_Request_Mtx))) {
			m_mpi_req_mtx[pInst->GetSymbBody()->GetName()] = pInst->GetSymbBody(); //MPI_Request[]WB
			return TRUE;
		}
		*/
	}
	return FALSE;
}
////////////////////////////////////////////////////////////////////////////