
#include <stdio.h>
#include <math.h>

/* Definition of constants */
#define NMAX 50000
#define JMAX 40
#define IMAX 40

#define MIDgP1 (MILWP1+1 )
#define MISzP1 (MILWP1+MIRWP1+2 )
#define MIRWP1 (iMxP1*1+0 )
#define MJSzP1 (iMxP1*jMxP1 )
#define MILWP1 (iMxP1*1+0 )
#define iMxP1 ((IMAX-1)-1+1 )
#define jMxP1 ((JMAX-1)-1+1 )

/* prototypes definition of all functions in this program */
void main();
void SlvU1();
void SlvV1();
void SlvP1();
void SlvU2();
void SlvV2();
void SlvP2();
void subst();
void output();
void init();


/* time step variable */
int n;

/* Declaration of parameters */
double Re = 100.000000;
double U0 = 0.500000;

/* Declaration of independent variables */
double dx = 1.000000;
double dy = 1.000000;
double dt = 0.050000;

/* Declaration of dependent variables */
double U[IMAX+1][JMAX+1];/* U n 0 */
double U1[IMAX+1][JMAX+1];/* U n 1 */
double U2[IMAX+1][JMAX+1];/* U ~ 0 */
double V[IMAX+1][JMAX+1];/* V n 0 */
double V1[IMAX+1][JMAX+1];/* V n 1 */
double V2[IMAX+1][JMAX+1];/* V ~ 0 */
double P[IMAX+1][JMAX+1];/* P n 0 */
double P1[IMAX+1][JMAX+1];/* P n 1 */
double P2[IMAX+1][JMAX+1];/* P ~ 0 */

/*  --- ---  */
double AmP1[MISzP1+1][MISzP1+1];

void main()
{

	init();
	for(n=1; n<=NMAX; n++) {
		/* 1 time step solver n --> n+1 */
		{
			SlvU1();
			SlvV1();
			SlvP1();
			SlvU2();
			SlvV2();
			SlvP2();
			printf("%d \n",n);
		}
		if(n%20==0) {
			output();
		}
		subst();
	}

}


void SlvU1()
{
	int i, j;
	for(i=2; i<=IMAX-1; i++) {
		for(j=2; j<=JMAX-2; j++) {
			U2[i][j] = U[i][j]
			           +dt
			            *(-((U[i][j]+fabs(U[i][j]))/( 2.000)
			                *(U[i][j]-U[i-1][j])/(dx)
			                +(U[i][j]-fabs(U[i][j]))/( 2.000)*(U[i+1][j]
			                                                   -U[i][j])/(dx))
			              -(( 0.250*(V[i][j+1]+V[i][j]+V[i-1][j+1]+V[i-1][j])
			                 +fabs( 0.250
			                       *(V[i][j+1]+V[i][j]+V[i-1][j+1]+V[i-1][j])))/( 2.000)
			                *(U[i][j]-U[i][j-1])/(dy)
			                +( 0.250*(V[i][j+1]+V[i][j]+V[i-1][j+1]+V[i-1][j])
			                  -fabs( 0.250
			                        *(V[i][j+1]+V[i][j]+V[i-1][j+1]+V[i-1][j])))/( 2.000)
			                 *(U[i][j+1]-U[i][j])/(dy))
			              -(P[i][j]-P[i-1][j])/(dx)
			              + 1.000/(Re)
			               *((U[i+1][j]- 2.000*U[i][j]+U[i-1][j])/(dx*dx)
			                 +(U[i][j+1]- 2.000*U[i][j]+U[i][j-1])/(dy*dy)));
		}
	}
}


void SlvV1()
{
	int i, j;
	for(i=2; i<=IMAX-1; i++) {
		for(j=2; j<=JMAX-2; j++) {
			V2[i][j] = V[i][j]
			           +dt
			            *(-(( 0.250*(U[i+1][j]+U[i+1][j-1]+U[i][j]+U[i][j-1])
			                 +fabs( 0.250
			                       *(U[i+1][j]+U[i+1][j-1]+U[i][j]+U[i][j-1])))/( 2.000)
			                *(V[i][j]-V[i-1][j])/(dx)
			                +( 0.250*(U[i+1][j]+U[i+1][j-1]+U[i][j]+U[i][j-1])
			                  -fabs( 0.250
			                        *(U[i+1][j]+U[i+1][j-1]+U[i][j]+U[i][j-1])))/( 2.000)
			                 *(V[i+1][j]-V[i][j])/(dx))
			              -((V[i][j]+fabs(V[i][j]))/( 2.000)
			                *(V[i][j]-V[i][j-1])/(dy)
			                +(V[i][j]-fabs(V[i][j]))/( 2.000)*(V[i][j+1]
			                                                   -V[i][j])/(dy))
			              -(P[i][j]-P[i][j-1])/(dy)
			              + 1.000/(Re)
			               *((V[i+1][j]- 2.000*V[i][j]+V[i-1][j])/(dx*dx)
			                 +(V[i][j+1]- 2.000*V[i][j]+V[i][j-1])/(dy*dy)));
		}
	}
}


void SlvP1()
{
	int mI, mJ, mK, mJK, mMax, mMin, i, j, mI10, mI00, mIY0, mI01, mI0Y;
	double cnt;
	for(mI=1; mI<=MISzP1; mI++) {
		for(mJ=1; mJ<=MJSzP1; mJ++) {
			AmP1[mI][mJ] =  0.000;
		}
	}
	for(i=2; i<=IMAX-2; i++) {
		for(j=2; j<=JMAX-2; j++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI10 = iMxP1*(j-1)+(i+1)-mJ+MIDgP1;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
				mIY0 = iMxP1*(j-1)+(i-1)-mJ+MIDgP1;
				mI01 = iMxP1*j+i-mJ+MIDgP1;
				mI0Y = iMxP1*(j-2)+i-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI10][mJ] = dt*1/(dx*dx);
				AmP1[mI00][mJ] = -dt*1/(dx*dx)*2-dt*1/(dy*dy)*2;
				AmP1[mIY0][mJ] = dt*1/(dx*dx);
				AmP1[mI01][mJ] = dt*1/(dy*dy);
				AmP1[mI0Y][mJ] = dt*1/(dy*dy);
				AmP1[MISzP1][mJ] = (U2[i+1][j]-U2[i][j])/(dx)+(V2[i][j+1]
				                                               -V2[i][j])/(dy);
			}
		}
	}
	/* Boundary Conditions */
	{
		/* boundary condition on LEFT */
		i = 1;
		for(j=2; j<=JMAX-2; j++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI00][mJ] = 1;
				AmP1[MISzP1][mJ] = 0;
			}
		}
		/* boundary condition on RIGHT */
		i = IMAX-1;
		for(j=2; j<=JMAX-2; j++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI00][mJ] = 1;
				AmP1[MISzP1][mJ] = 0;
			}
		}
		/* boundary condition on BTTM */
		j = 1;
		for(i=1; i<=IMAX-1; i++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI01 = iMxP1*j+i-mJ+MIDgP1;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI01][mJ] = 1/(dy);
				AmP1[mI00][mJ] = (-1/(dy));
				AmP1[MISzP1][mJ] = 0;
			}
		}
		/* boundary condition on TOP */
		j = JMAX-1;
		for(i=1; i<=IMAX-1; i++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
				mI0Y = iMxP1*(j-2)+i-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI00][mJ] = 1/(dy);
				AmP1[mI0Y][mJ] = (-1/(dy));
				AmP1[MISzP1][mJ] = 0;
			}
		}
		/* boundary condition on InLeft */
		i = 12;
		for(j=18; j<=JMAX-16; j++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
				mIY0 = iMxP1*(j-1)+(i-1)-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI00][mJ] = 1/(dx);
				AmP1[mIY0][mJ] = (-1/(dx));
				AmP1[MISzP1][mJ] = 0;
			}
		}
		/* boundary condition on InRight */
		i = 19;
		for(j=18; j<=JMAX-16; j++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI10 = iMxP1*(j-1)+(i+1)-mJ+MIDgP1;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI10][mJ] = 1/(dx);
				AmP1[mI00][mJ] = (-1/(dx));
				AmP1[MISzP1][mJ] = 0;
			}
		}
		/* boundary condition on InBttm */
		j = 17;
		for(i=12; i<=IMAX-21; i++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
				mI0Y = iMxP1*(j-2)+i-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI00][mJ] = 1/(dy);
				AmP1[mI0Y][mJ] = (-1/(dy));
				AmP1[MISzP1][mJ] = 0;
			}
		}
		/* boundary condition on InTop */
		j = 25;
		for(i=12; i<=IMAX-21; i++) {
			/* Calculating the subscript number */
			{
				mJ = iMxP1*(j-1)+i;
				mI01 = iMxP1*j+i-mJ+MIDgP1;
				mI00 = iMxP1*(j-1)+i-mJ+MIDgP1;
			}
			/* matrix element setting */
			{
				AmP1[mI01][mJ] = 1/(dy);
				AmP1[mI00][mJ] = (-1/(dy));
				AmP1[MISzP1][mJ] = 0;
			}
		}
	}
	/* Gauss Elimination Band Matrix Solver */
	{
		for(mJ=1; mJ<=MJSzP1; mJ++) {
			cnt = AmP1[MIDgP1][mJ];
			for(mI=1; mI<=MISzP1; mI++) {
				AmP1[mI][mJ] = AmP1[mI][mJ]/(cnt);
			}
		}
		for(mK=1; mK<=MJSzP1-1; mK++) {
			cnt = AmP1[MIDgP1][mK];
			for(mI=MIDgP1; mI<=MISzP1; mI++) {
				AmP1[mI][mK] = AmP1[mI][mK]/(cnt);
			}
			mMin = mK+MILWP1;
			if(mMin>MJSzP1) {
				mMin = MJSzP1;
			}
			for(mJ=mK+1; mJ<=mMin; mJ++) {
				mJK = mJ-mK;
				for(mI=MIDgP1-mJK+1; mI<=MILWP1+MIRWP1+1-mJK; mI++) {
					AmP1[mI][mJ] = AmP1[mI][mJ]-AmP1[mI+mJK][mK]*AmP1[MIDgP1
					                                                  -mJK][mJ];
				}
				AmP1[MISzP1][mJ] = AmP1[MISzP1][mJ]
				                   -AmP1[MISzP1][mK]*AmP1[MIDgP1-mJK][mJ];
			}
		}
		AmP1[MISzP1][MJSzP1] = AmP1[MISzP1][MJSzP1]/(AmP1[MIDgP1][MJSzP1]);
		for(mK=MJSzP1; mK>=2; mK-= 1) {
			mMax = mK-MILWP1;
			if(mMax<1) {
				mMax = 1;
			}
			for(mJ=mK-1; mJ>=mMax; mJ-= 1) {
				AmP1[MISzP1][mJ] = AmP1[MISzP1][mJ]
				                   -AmP1[MISzP1][mK]*AmP1[MIDgP1+mK-mJ][mJ];
			}
		}
		AmP1[MISzP1][1] = AmP1[MISzP1][1]/(AmP1[MIDgP1][1]);
		for(i=1; i<=IMAX-1; i++) {
			for(j=1; j<=JMAX-2; j++) {
				mJ = iMxP1*(j-1)+i;
				P2[i][j] = AmP1[MISzP1][mJ];
			}
		}
	}
}


void SlvU2()
{
	int i, j;
	for(i=2; i<=IMAX; i++) {
		for(j=1; j<=JMAX-1; j++) {
			U1[i][j] = U2[i][j]-dt*(P2[i][j]-P2[i-1][j])/(dx);
		}
	}
	/* Boundary Conditions */
	{
		/* boundary condition on LEFT */
		i = 1;
		for(j=2; j<=JMAX-2; j++) {
			U1[i][j] = 2*U0-U1[i+1][j];
		}
		/* boundary condition on RIGHT */
		i = IMAX-1;
		for(j=2; j<=JMAX-2; j++) {
			U1[i+1][j] = 2*U0-U1[i][j];
		}
		/* boundary condition on BTTM */
		j = 1;
		for(i=1; i<=IMAX-1; i++) {
			U1[i][j] = 0;
		}
		/* boundary condition on TOP */
		j = JMAX-1;
		for(i=1; i<=IMAX-1; i++) {
			U1[i][j] = 0;
		}
		/* boundary condition on InLeft */
		i = 12;
		for(j=18; j<=JMAX-16; j++) {
			U1[i+1][j] = (-U1[i][j]);
		}
		/* boundary condition on InRight */
		i = 19;
		for(j=18; j<=JMAX-16; j++) {
			U1[i][j] = (-U1[i+1][j]);
		}
		/* boundary condition on InTop */
		j = 25;
		for(i=12; i<=IMAX-21; i++) {
			U1[i][j] = 0;
		}
		/* boundary condition on InBttm */
		j = 17;
		for(i=12; i<=IMAX-21; i++) {
			U1[i][j] = 0;
		}
	}
}


void SlvV2()
{
	int i, j;
	for(i=1; i<=IMAX; i++) {
		for(j=2; j<=JMAX; j++) {
			V1[i][j] = V2[i][j]-dt*(P2[i][j]-P2[i][j-1])/(dy);
		}
	}
	/* Boundary Conditions */
	{
		/* boundary condition on LEFT */
		i = 1;
		for(j=2; j<=JMAX-2; j++) {
			V1[i][j] = 0;
		}
		/* boundary condition on RIGHT */
		i = IMAX-1;
		for(j=2; j<=JMAX-2; j++) {
			V1[i][j] = 0;
		}
		/* boundary condition on BTTM */
		j = 1;
		for(i=1; i<=IMAX-1; i++) {
			V1[i][j] = (-V1[i][j+1]);
		}
		/* boundary condition on TOP */
		j = JMAX-1;
		for(i=1; i<=IMAX-1; i++) {
			V1[i][j+1] = (-V1[i][j]);
		}
		/* boundary condition on InLeft */
		i = 12;
		for(j=18; j<=JMAX-16; j++) {
			V1[i][j] = 0;
		}
		/* boundary condition on InRight */
		i = 19;
		for(j=18; j<=JMAX-16; j++) {
			V1[i][j] = 0;
		}
		/* boundary condition on InBttm */
		j = 17;
		for(i=12; i<=IMAX-21; i++) {
			V1[i][j+1] = (-V1[i][j]);
		}
		/* boundary condition on InTop */
		j = 25;
		for(i=12; i<=IMAX-21; i++) {
			V1[i][j] = (-V1[i][j+1]);
		}
	}
}


void SlvP2()
{
	int i, j;
	for(i=1; i<=IMAX-1; i++) {
		for(j=1; j<=JMAX-1; j++) {
			P1[i][j] = P[i][j]+P2[i][j];
		}
	}
}


void subst()
{
	int i, j;
	for(i=1; i<=IMAX; i++) {
		for(j=1; j<=JMAX; j++) {
			U[i][j] = U1[i][j];
			V[i][j] = V1[i][j];
			P[i][j] = P1[i][j];
		}
	}
}


void output()
{
	int i, j;
	for(i=1; i<=IMAX; i++) {
		for(j=1; j<=JMAX; j++) {
			printf("%e %e %e \n",U[i][j],V[i][j],P[i][j]);
		}
	}
}


void init()
{
	int i, j;
	for(i=1; i<=IMAX; i++) {
		for(j=1; j<=JMAX; j++) {
			U[i][j] =  0.000;
			V[i][j] =  0.000;
			P[i][j] =  0.000;
		}
	}
}


