
#include <stdio.h>
#include <math.h>

/* Definition of constants */
#define NMAX 1000
#define JMAX 5
#define IMAX 6


/* prototypes definition of all functions in this program */
void main();
void SlvU_X();
void SlvU_Y();
void SlvV_X();
void SlvV_Y();
void SlvU_X_X();
void SlvU_Y_Y();
void SlvU_X_Y();
void SlvV_X_X();
void SlvV_Y_Y();
void SlvV_X_Y();
void SlvALPHA();
void SlvBETHA();
void SlvJACOB();
void SlvGAMMA();
void SlvT();
void subst();
void output();
void init();
void M_AVS_out();
void M_AVS_Fld_out();


/* time step variable */
int n;

/* Declaration of parameters */

/* Declaration of independent variables */
double dx = 1.000000;
double dy = 1.000000;
double dt = 0.100000;

/* Declaration of dependent variables */
double U[IMAX+1][JMAX+1];/* U n 0 */
double V[IMAX+1][JMAX+1];/* V n 0 */
double GAMMA[IMAX+1][JMAX+1];/* GAMMA n 0 */
double U_X_X[IMAX+1][JMAX+1];/* U_X_X n 0 */
double V_X_X[IMAX+1][JMAX+1];/* V_X_X n 0 */
double U_X_Y[IMAX+1][JMAX+1];/* U_X_Y n 0 */
double V_X_Y[IMAX+1][JMAX+1];/* V_X_Y n 0 */
double U_Y_Y[IMAX+1][JMAX+1];/* U_Y_Y n 0 */
double V_Y_Y[IMAX+1][JMAX+1];/* V_Y_Y n 0 */
double U_X[IMAX+1][JMAX+1];/* U_X n 0 */
double ALPHA[IMAX+1][JMAX+1];/* ALPHA n 0 */
double V_X[IMAX+1][JMAX+1];/* V_X n 0 */
double U_Y[IMAX+1][JMAX+1];/* U_Y n 0 */
double JACOB[IMAX+1][JMAX+1];/* JACOB n 0 */
double V_Y[IMAX+1][JMAX+1];/* V_Y n 0 */
double T[IMAX+1][JMAX+1];/* T n 1 */
double T1[IMAX+1][JMAX+1];/* T n 0 */
double BEHTA[IMAX+1][JMAX+1];/* BEHTA n 0 */

/*  --- ---  */

void main()
{
	filePnt1 = fopen("M_AVS.dat", "w");
	filePnt2 = fopen("M_AVS.fld", "w");

	init();
	M_AVS_FLD_out();
	for(n=1; n<=NMAX; n++) {
		/* 1 time step solver n --> n+1 */
		{
			SlvU_X();
			SlvU_Y();
			SlvV_X();
			SlvV_Y();
			SlvU_X_X();
			SlvU_Y_Y();
			SlvU_X_Y();
			SlvV_X_X();
			SlvV_Y_Y();
			SlvV_X_Y();
			SlvALPHA();
			SlvBETHA();
			SlvJACOB();
			SlvGAMMA();
			SlvT();
		}
		if(n%20==0) {
			output();
			M_AVS_out();
		}
		subst();
	}
	fclose(filePnt1);
	fclose(filePnt2);

}


void SlvU_X()
{
	int i, j;
	for(i=1; i<=IMAX-1; i++) {
		for(j=1; j<=JMAX-1; j++) {
			U_X[i][j] = (1/2*(U[i+1][j+1]+U[i+1][j])-1/2*(U[i][j+1]+U[i][j]))/(dx);
		}
	}
}


void SlvU_Y()
{
	int i, j;
	for(i=1; i<=IMAX-1; i++) {
		for(j=1; j<=JMAX-1; j++) {
			U_Y[i][j] = (1/2*(U[i+1][j+1]+U[i][j+1])-1/2*(U[i+1][j]+U[i][j]))/(dy);
		}
	}
}


void SlvV_X()
{
	int i, j;
	for(i=1; i<=IMAX-1; i++) {
		for(j=1; j<=JMAX-1; j++) {
			V_X[i][j] = (1/2*(V[i+1][j+1]+V[i+1][j])-1/2*(V[i][j+1]+V[i][j]))/(dx);
		}
	}
}


void SlvV_Y()
{
	int i, j;
	for(i=1; i<=IMAX-1; i++) {
		for(j=1; j<=JMAX-1; j++) {
			V_Y[i][j] = (1/2*(V[i+1][j+1]+V[i][j+1])-1/2*(V[i+1][j]+V[i][j]))/(dy);
		}
	}
}


void SlvU_X_X()
{
	int i, j;
	for(i=2; i<=IMAX-2; i++) {
		for(j=1; j<=JMAX-1; j++) {
			U_X_X[i][j] = (1/4*(U[i+2][j+1]+U[i+2][j]+U[i+1][j+1]+U[i+1][j])
			               -1/2*(U[i+1][j+1]+U[i+1][j]+U[i][j+1]+U[i][j])
			               +1/4*(U[i][j+1]+U[i][j]+U[i-1][j+1]+U[i-1][j]))/(dx
			                                                                *dx);
		}
	}
}


void SlvU_Y_Y()
{
	int i, j;
	for(i=1; i<=IMAX-1; i++) {
		for(j=2; j<=JMAX-2; j++) {
			U_Y_Y[i][j] = (1/4*(U[i+1][j+2]+U[i+1][j+1]+U[i][j+2]+U[i][j+1])
			               -1/2*(U[i+1][j+1]+U[i+1][j]+U[i][j+1]+U[i][j])
			               +1/4*(U[i+1][j]+U[i+1][j-1]+U[i][j]+U[i][j-1]))/(dy
			                                                                *dy);
		}
	}
}


void SlvU_X_Y()
{
	int i, j;
	for(i=1; i<=IMAX-1; i++) {
		for(j=1; j<=JMAX-1; j++) {
			U_X_Y[i][j] = ((U[i+1][j+1]-U[i+1][j])/(dy)
			               -(U[i][j+1]-U[i][j])/(dy))/(dx);
		}
	}
}


void SlvV_X_X()
{
	int i, j;
	for(i=2; i<=IMAX-2; i++) {
		for(j=1; j<=JMAX-1; j++) {
			V_X_X[i][j] = (1/4*(V[i+2][j+1]+V[i+2][j]+V[i+1][j+1]+V[i+1][j])
			               -1/2*(V[i+1][j+1]+V[i+1][j]+V[i][j+1]+V[i][j])
			               +1/4*(V[i][j+1]+V[i][j]+V[i-1][j+1]+V[i-1][j]))/(dx
			                                                                *dx);
		}
	}
}


void SlvV_Y_Y()
{
	int i, j;
	for(i=1; i<=IMAX-1; i++) {
		for(j=2; j<=JMAX-2; j++) {
			V_Y_Y[i][j] = (1/4*(V[i+1][j+2]+V[i+1][j+1]+V[i][j+2]+V[i][j+1])
			               -1/2*(V[i+1][j+1]+V[i+1][j]+V[i][j+1]+V[i][j])
			               +1/4*(V[i+1][j]+V[i+1][j-1]+V[i][j]+V[i][j-1]))/(dy
			                                                                *dy);
		}
	}
}


void SlvV_X_Y()
{
	int i, j;
	for(i=1; i<=IMAX-1; i++) {
		for(j=1; j<=JMAX-1; j++) {
			V_X_Y[i][j] = ((V[i+1][j+1]-V[i+1][j])/(dy)
			               -(V[i][j+1]-V[i][j])/(dy))/(dx);
		}
	}
}


void SlvALPHA()
{
	int i, j;
	for(i=1; i<=IMAX; i++) {
		for(j=1; j<=JMAX; j++) {
			ALPHA[i][j] = U_Y[i][j]*U_Y[i][j]+V_Y[i][j]*V_Y[i][j];
		}
	}
}


void SlvBETHA()
{
	int i, j;
	for(i=1; i<=IMAX; i++) {
		for(j=1; j<=JMAX; j++) {
			BEHTA[i][j] = U_X[i][j]*U_Y[i][j]+V_X[i][j]*V_Y[i][j];
		}
	}
}


void SlvJACOB()
{
	int i, j;
	for(i=1; i<=IMAX; i++) {
		for(j=1; j<=JMAX; j++) {
			JACOB[i][j] = U_X[i][j]*V_Y[i][j]-U_Y[i][j]*V_X[i][j];
		}
	}
}


void SlvGAMMA()
{
	int i, j;
	for(i=1; i<=IMAX; i++) {
		for(j=1; j<=JMAX; j++) {
			GAMMA[i][j] = U_X_X[i][j]*U_X_X[i][j]+V_X_X[i][j]*V_X_X[i][j];
		}
	}
}


void SlvT()
{
	int i, j;
	for(i=2; i<=IMAX-1; i++) {
		for(j=2; j<=JMAX-1; j++) {
			T[i][j] = 1/(1/(dt))
			          *(-(-T1[i][j])/(dt)
			            +(1/(JACOB[i][j]*JACOB[i][j])
			              *(ALPHA[i][j]
			                *(T1[i+1][j]-2*T1[i][j]+T1[i-1][j])/(dx*dx)
			                -2*BEHTA[i][j]*((1/4
			                                 *(T1[i+1][j+1]+T1[i+1][j]
			                                   +T1[i][j+1]+T1[i][j])
			                                 -1/4
			                                  *(T1[i+1][j]+T1[i+1][j-1]
			                                    +T1[i][j]+T1[i][j-1]))/(dy)
			                                -(1/4
			                                  *(T1[i][j+1]+T1[i][j]
			                                    +T1[i-1][j+1]+T1[i-1][j])
			                                  -1/4
			                                   *(T1[i][j]+T1[i][j-1]+T1[i-1][j]
			                                     +T1[i-1][j-1]))/(dy))/(dx)
			                +GAMMA[i][j]
			                 *(T1[i][j+1]-2*T1[i][j]+T1[i][j-1])/(dy*dy))
			              +1/(JACOB[i][j]*JACOB[i][j]*JACOB[i][j])
			               *((ALPHA[i][j]*U_X_X[i][j]-2*BEHTA[i][j]*U_X_Y[i][j]
			                  +GAMMA[i][j]*U_Y_Y[i][j])
			                 *(V_X[i][j]*(1/2*(T1[i][j+1]+T1[i][j])
			                              -1/2*(T1[i][j]+T1[i][j-1]))/(dy)
			                   -V_Y[i][j]*(1/2*(T1[i+1][j]+T1[i][j])
			                               -1/2*(T1[i][j]+T1[i-1][j]))/(dx))
			                 +(ALPHA[i][j]*V_X_X[i][j]
			                   -2*BEHTA[i][j]*V_X_Y[i][j]
			                   +GAMMA[i][j]*V_Y_Y[i][j])
			                  *(U_Y[i][j]*(1/2*(T1[i+1][j]+T1[i][j])
			                               -1/2*(T1[i][j]+T1[i-1][j]))/(dx)
			                    -U_X[i][j]*(1/2*(T1[i][j+1]+T1[i][j])
			                                -1/2*(T1[i][j]+T1[i][j-1]))/(dy)))));
		}
	}
	/* Boundary Conditions */
	{
		/* boundary condition on LEFT */
		i = 1;
		for(j=1; j<=JMAX-1; j++) {
			T[i][j] = 10;
		}
		/* boundary condition on RIGHT */
		i = IMAX-1;
		for(j=1; j<=JMAX-1; j++) {
			T[i][j] = dx*1/(dx)*T[i-1][j];
		}
		/* boundary condition on BTTM */
		j = 1;
		for(i=1; i<=IMAX-1; i++) {
			T[i][j+1] = dy*1/(dy)*T[i][j];
		}
		/* boundary condition on TOP */
		j = JMAX-1;
		for(i=1; i<=IMAX-1; i++) {
			T[i][j] = dy*1/(dy)*T[i][j-1];
		}
	}
}


void subst()
{
	int i, j;
	for(i=1; i<=IMAX; i++) {
		for(j=1; j<=JMAX; j++) {
			U_X[i][j] = U_X[i][j];
			U_Y[i][j] = U_Y[i][j];
			V_X[i][j] = V_X[i][j];
			V_Y[i][j] = V_Y[i][j];
			U_X_X[i][j] = U_X_X[i][j];
			U_Y_Y[i][j] = U_Y_Y[i][j];
			U_X_Y[i][j] = U_X_Y[i][j];
			V_X_X[i][j] = V_X_X[i][j];
			V_Y_Y[i][j] = V_Y_Y[i][j];
			V_X_Y[i][j] = V_X_Y[i][j];
			ALPHA[i][j] = ALPHA[i][j];
			BEHTA[i][j] = BEHTA[i][j];
			JACOB[i][j] = JACOB[i][j];
			GAMMA[i][j] = GAMMA[i][j];
			T1[i][j] = T[i][j];
		}
	}
}


void output()
{
	int i, j;
	for(i=1; i<=IMAX; i++) {
		for(j=1; j<=JMAX; j++) {
			printf("%e %e %e %e %e %e %e %e %e %e %e %e %e %e %e \n",U_X[i][j],U_Y[i][j],V_X[i][j],V_Y[i][j],U_X_X[i][j],U_Y_Y[i][j],U_X_Y[i][j],V_X_X[i][j],V_Y_Y[i][j],V_X_Y[i][j],ALPHA[i][j],BEHTA[i][j],JACOB[i][j],GAMMA[i][j],T1[i][j]);
		}
	}
}


void init()
{
	int i, j;
	for(i=1; i<=IMAX; i++) {
		for(j=1; j<=JMAX; j++) {
			U_X[i][j] = 0.000000;
			U_Y[i][j] = 0.000000;
			V_X[i][j] = 0.000000;
			V_Y[i][j] = 0.000000;
			U_X_X[i][j] = 0.000000;
			U_Y_Y[i][j] = 0.000000;
			U_X_Y[i][j] = 0.000000;
			V_X_X[i][j] = 0.000000;
			V_Y_Y[i][j] = 0.000000;
			V_X_Y[i][j] = 0.000000;
			ALPHA[i][j] = 0.000000;
			BEHTA[i][j] = 0.000000;
			JACOB[i][j] = 0.000000;
			GAMMA[i][j] = 0.000000;
			T1[i][j] = 0.000000;
		}
	}
}


void M_AVS_out()
{
	int j, i;
	for(j=1; j<=JMAX; j++) {
		for(i=1; i<=IMAX; i++) {
			fprintf(filePnt1, "%d %d %e %e %e %e %e %e %e %e %e %e %e %e %e %e %e %e %e \n",i,j,U[i][j],V[i][j],U_X[i][j],U_Y[i][j],V_X[i][j],V_Y[i][j],U_X_X[i][j],U_Y_Y[i][j],U_X_Y[i][j],V_X_X[i][j],V_Y_Y[i][j],V_X_Y[i][j],ALPHA[i][j],BEHTA[i][j],JACOB[i][j],GAMMA[i][j],T1[i][j]);
		}
	}
}


void M_AVS_Fld_out()
{
	int dim, var_no, skip, offset, stride, cnt;
	dim = 2;
	var_no = 17;
	skip = 0;
	stride = var_no+dim;
	strcpy(filetype,"ascii");
	fprintf(filePnt2, "\n");
	fprintf(filePnt2, "%d \n",dim);
	fprintf(filePnt2, "%d \n",IMAX);
	fprintf(filePnt2, "%d \n",JMAX);
	fprintf(filePnt2, "%d \n",dim);
	fprintf(filePnt2, "%d \n",var_no);
	fprintf(filePnt2, "\n");
	fprintf(filePnt2, "\n");
	for(cnt=1; cnt<=var_no; cnt++) {
		offset = cnt+dim-1;
		fprintf(filePnt2, "%d %e %d %d %d \n",cnt,filetype,skip,offset,stride);
	}
	for(cnt=1; cnt<=dim; cnt++) {
		offset = cnt+dim-1;
		fprintf(filePnt2, "%d %e %d %d %d \n",cnt,filetype,skip,offset,stride);
	}
}


